/*
 Copyright 2009-2015 Luc Saffre
 License: BSD (see file COPYING for details)
*/

// lino.js --- generated Wed Apr  5 02:42:18 2017 by Lino Voga 2016.12.0 for Secretary.
Ext.BLANK_IMAGE_URL = '/static/ext-3.3.1/resources/images/default/s.gif';
LANGUAGE_CHOICES = [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ];
MEDIA_URL = "/media/";

// hack to add a toCamel function, inspired by
// http://jamesroberts.name/blog/2010/02/22/string-functions-for-javascript-trim-to-camel-case-to-dashed-and-to-underscore/
String.prototype.toCamel = function(){
  //~ return this.replace(/(\-[a-z])/g, function($1){return $1.toUpperCase().replace('-','');});
  //~ return this;
  return this.replace(/([A-Z])([A-Z]+)/g, function(match,p1,p2,offset,string){
      //~ console.log("20131005 got ",arguments);
      return p1 + p2.toLowerCase();});
};


// 20151126 hack to modify Ext.EventObjectImpl.isSpecialKey() which
// returned false for Ctrl-S when called from a keyup handler (namely
// ComboBox.onLoad)

Ext.EventObjectImpl.prototype.isSpecialKey = function(){
    // same as original except for one line
    var k = this.normalizeKey(this.keyCode);
    // return (this.type == 'keypress' && this.ctrlKey) ||
    return (this.ctrlKey) ||
        this.isNavKeyPress() ||
        (k == this.BACKSPACE) || 
        (k >= 16 && k <= 20) || 
        (k >= 44 && k <= 46);   
};





/* MonthPickerPlugin: thanks to keypoint @ sencha forum
   http://www.sencha.com/forum/showthread.php?74002-3.x-Ext.ux.MonthMenu&p=356860#post356860
*/
Ext.namespace('Ext.ux'); 

Ext.ux.MonthPickerPlugin = function() { 
    var picker; 
    var oldDateDefaults; 

    this.init = function(pk) { 
        picker = pk; 
        picker.onTriggerClick = picker.onTriggerClick.createSequence(onClick); 
        picker.getValue = picker.getValue.createInterceptor(setDefaultMonthDay).createSequence(restoreDefaultMonthDay); 
        picker.beforeBlur = picker.beforeBlur.createInterceptor(setDefaultMonthDay).createSequence(restoreDefaultMonthDay); 
    }; 

    function setDefaultMonthDay() { 
        oldDateDefaults = Date.defaults.d; 
        Date.defaults.d = 1; 
        return true; 
    } 

    function restoreDefaultMonthDay(ret) { 
        Date.defaults.d = oldDateDefaults; 
        return ret; 
    } 

    function onClick(e, el, opt) { 
        var p = picker.menu.picker; 
        p.activeDate = p.activeDate.getFirstDateOfMonth(); 
        if (p.value) { 
            p.value = p.value.getFirstDateOfMonth(); 
        } 

        p.showMonthPicker(); 
         
        if (!p.disabled) { 
            p.monthPicker.stopFx(); 
            p.monthPicker.show(); 

            p.mun(p.monthPicker, 'click', p.onMonthClick, p); 
            p.mun(p.monthPicker, 'dblclick', p.onMonthDblClick, p); 
            p.onMonthClick = p.onMonthClick.createSequence(pickerClick); 
            p.onMonthDblClick = p.onMonthDblClick.createSequence(pickerDblclick); 
            p.mon(p.monthPicker, 'click', p.onMonthClick, p); 
            p.mon(p.monthPicker, 'dblclick', p.onMonthDblClick, p); 
        } 
    } 

    function pickerClick(e, t) { 
        var el = new Ext.Element(t); 
        if (el.is('button.x-date-mp-cancel')) { 
            picker.menu.hide(); 
        } else if(el.is('button.x-date-mp-ok')) { 
            var p = picker.menu.picker; 
            p.setValue(p.activeDate); 
            p.fireEvent('select', p, p.value); 
        } 
    } 

    function pickerDblclick(e, t) { 
        var el = new Ext.Element(t); 
        if (el.parent() 
            && (el.parent().is('td.x-date-mp-month') 
            || el.parent().is('td.x-date-mp-year'))) { 

            var p = picker.menu.picker; 
            p.setValue(p.activeDate); 
            p.fireEvent('select', p, p.value); 
        } 
    } 
}; 

Ext.preg('monthPickerPlugin', Ext.ux.MonthPickerPlugin);  


/**
JC Watsons solution (adapted to ExtJS 3.3.1 by LS) is elegant and simple:
`A "fix" for unchecked checkbox submission  behaviour
<http://www.sencha.com/forum/showthread.php?28449>`_

Added special handling for checkbox inputs. 
ExtJS defines disabled checkboxes `readonly`, not `disabled` as for other inputs.

*/
Ext.lib.Ajax.serializeForm = function(form) {
    //~ console.log('20120203 linolib.js serializeForm',form);
    var fElements = form.elements || (document.forms[form] || Ext.getDom(form)).elements, 
        hasSubmit = false, 
        encoder = encodeURIComponent, 
        name, 
        data = '', 
        type, 
        hasValue;

    Ext.each(fElements, function(element){
        name = element.name;
        type = element.type;

        if (!element.disabled && name && !(type == 'checkbox' && element.readonly)) {
            if (/select-(one|multiple)/i.test(type)) {
                Ext.each(element.options, function(opt){
                    if (opt.selected) {
                        hasValue = opt.hasAttribute ? opt.hasAttribute('value') : opt.getAttributeNode('value').specified;
                        data += String.format("{0}={1}&", encoder(name), encoder(hasValue ? opt.value : opt.text));
                    }
                });
            } else if (!(/file|undefined|reset|button/i.test(type))) {
                //~ if (!(/radio|checkbox/i.test(type) && !element.checked) && !(type == 'submit' && hasSubmit)) {
                if (!(type == 'submit' && hasSubmit)) {
                    if (type == 'checkbox') {
                        //~ console.log('20111001',element,'data += ',encoder(name) + '=' + (element.checked ? 'on' : 'off') + '&');
                        data += encoder(name) + '=' + (element.checked ? 'on' : 'off') + '&';
                    } else {
                        //~ console.log('20111001',element,'data += ',encoder(name) + '=' + encoder(element.value) + '&');
                        data += encoder(name) + '=' + encoder(element.value) + '&';
                    }
                    hasSubmit = /submit/i.test(type);
                }
            }
        //~ } else {
            //~ console.log(name,type,element.readonly);
        }
    });
    return data.substr(0, data.length - 1);
};



/*
Set a long timeout of fifteen minutes. 
See /blog/2012/0307
*/
Ext.Ajax.timeout = 15 * 60 * 1000; 

/*
 * Thanks to 
 * `huuze <http://stackoverflow.com/users/10040/huuuze>`_ for the question
 * and to 
 * `chrisv <http://stackoverflow.com/users/683808/chrisv>`_
 * for the answer on
 * http://stackoverflow.com/questions/3764589/how-do-i-include-django-1-2s-csrf-token-in-a-javascript-generated-html-form/5485616#5485616
 * 
 * */
 
Ext.Ajax.on('beforerequest', function (conn, options) {
   if (!(/^http:.*/.test(options.url) || /^https:.*/.test(options.url))) {
     if (typeof(options.headers) == "undefined") {
       options.headers = {'X-CSRFToken': Ext.util.Cookies.get('csrftoken')};
     } else {
       options.headers.extend({'X-CSRFToken': Ext.util.Cookies.get('csrftoken')});
     }                        
   }
}, this);


/*
My fix for the "Cannot set QuickTips dismissDelay to 0" bug,
see http://www.sencha.com/forum/showthread.php?183515 
*/
Ext.override(Ext.QuickTip,{
  showAt : function(xy){
        var t = this.activeTarget;
        //~ console.log("20120224 QuickTip.showAt",this.title,this.dismissDelay,t.dismissDelay);
        if(t){
            if(!this.rendered){
                this.render(Ext.getBody());
                this.activeTarget = t;
            }
            if(t.width){
                this.setWidth(t.width);
                this.body.setWidth(this.adjustBodyWidth(t.width - this.getFrameWidth()));
                this.measureWidth = false;
            } else{
                this.measureWidth = true;
            }
            this.setTitle(t.title || '');
            this.body.update(t.text);
            this.autoHide = t.autoHide;
            // bugfix by Luc 20120226
            if (t.dismissDelay != undefined) this.dismissDelay = t.dismissDelay;
            //~ this.dismissDelay = t.dismissDelay || this.dismissDelay;
            if(this.lastCls){
                this.el.removeClass(this.lastCls);
                delete this.lastCls;
            }
            if(t.cls){
                this.el.addClass(t.cls);
                this.lastCls = t.cls;
            }
            if(this.anchor){
                this.constrainPosition = false;
            }else if(t.align){ 
                xy = this.el.getAlignToXY(t.el, t.align);
                this.constrainPosition = false;
            }else{
                this.constrainPosition = true;
            }
        }
        Ext.QuickTip.superclass.showAt.call(this, xy);
    }
});

/*
Another hack. See /docs/blog/2012/0228
*/
Ext.Element.addMethods(
    function() {
        var VISIBILITY      = "visibility",
            DISPLAY         = "display",
            HIDDEN          = "hidden",
            NONE            = "none",
            XMASKED         = "x-masked",
            XMASKEDRELATIVE = "x-masked-relative",
            data            = Ext.Element.data;

        return {
            
            mask : function(msg, msgCls) {
                var me  = this,
                    dom = me.dom,
                    dh  = Ext.DomHelper,
                    EXTELMASKMSG = "ext-el-mask-msg",
                    el,
                    mask;
                // removed the following lines. See /docs/blog/2012/0228
                //~ if (!(/^body/i.test(dom.tagName) && me.getStyle('position') == 'static')) {
                    //~ console.log(20120228,dom.tagName,me);
                    //~ me.addClass(XMASKEDRELATIVE); 
                //~ }
                if (el = data(dom, 'maskMsg')) {
                    el.remove();
                }
                if (el = data(dom, 'mask')) {
                    el.remove();
                }

                mask = dh.append(dom, {cls : "ext-el-mask"}, true);
                data(dom, 'mask', mask);

                me.addClass(XMASKED);
                mask.setDisplayed(true);
                
                if (typeof msg == 'string') {
                    var mm = dh.append(dom, {cls : EXTELMASKMSG, cn:{tag:'div'}}, true);
                    data(dom, 'maskMsg', mm);
                    mm.dom.className = msgCls ? EXTELMASKMSG + " " + msgCls : EXTELMASKMSG;
                    mm.dom.firstChild.innerHTML = msg;
                    mm.setDisplayed(true);
                    mm.center(me);
                }
                
                
                if (Ext.isIE && !(Ext.isIE7 && Ext.isStrict) && me.getStyle('height') == 'auto') {
                    mask.setSize(undefined, me.getHeight());
                }
                
                return mask;
            }

            
        };
    }()
);



Ext.namespace('Lino');
    
    

//~ Lino.subst_user_field = new Ext.form.ComboBox({});
//~ Lino.subst_user = null;
Lino.insert_subst_user = function(p){
    //~ console.log('20120714 insert_subst_user',Lino.subst_user,p);
    //~ if (Lino.subst_user_field.getValue()) {
    if (p.su) return;
    if (Lino.subst_user) {
        //~ p.su = Lino.subst_user_field.getValue();
        p.su = Lino.subst_user;
    //~ } else {
        //~ delete p.su;
    }
    //~ console.log('20120714 insert_subst_user -->',Lino.subst_user,p);
}

Lino.login_window = null;

Lino.autorefresh = function() {
  if (Lino.current_window == null) {
      Lino.viewport.refresh();
      Lino.autorefresh.defer(60000);
  }
}

Lino.show_login_window = function(on_login, username, password) {
  // console.log('20121103 show_login_window',arguments);
  //~ var current_window = Lino.current_window;
  if (typeof username != 'string') username = '';
  if (typeof password != 'string') password = '';
  if (Lino.login_window == null) {
    
      function do_login() { 
            Lino.viewport.loadMask.show()
            login_panel.getForm().submit({ 
                method:'POST', 
                waitTitle:'Connecting', 
                waitMsg:'Sending data...',
                success:function(){ 
                  Lino.login_window.hide();
                  Lino.handle_home_button();
                  Lino.viewport.loadMask.hide();
                  if (typeof on_login == 'string') {
                      Lino.load_url(on_login);
                  } 
                },
                failure: function(form,action) { 
                  Lino.on_submit_failure(form, action);
                  Lino.viewport.loadMask.hide()
                }
            }); 
      };
    
      var login_button = new Ext.Button({ 
        text:"Log in",
        formBind: true,	 
        // Function that fires when user clicks the button 
        handler: do_login});
    
      var login_panel = new Ext.FormPanel({ 
        //~ inspired by http://www.sencha.com/learn/a-basic-login/
        autoHeight:true,
        labelWidth:90,
        url:'/auth', 
        frame:true, 
        defaultType:'textfield',
        monitorValid:true,
        items:[{ 
            fieldLabel:"Username", 
            id: 'username',
            name:'username', 
            value: username, 
            autoHeight:true,
            allowBlank:false 
        },{ 
            fieldLabel:"Password", 
            id:'password', 
            name:'password', 
            value: password, 
            inputType:'password', 
            autoHeight:true,
            allowBlank:false 
        }],        
        buttons:[ login_button ]});
        
      Lino.login_window = new Ext.Window({
          layout:'fit',
          defaultButton: 'username',
          width:300,
          title:"Log in", 
          autoHeight:true,
          modal: true,
          closeAction: "hide",
          keys: {
            key: Ext.EventObject.ENTER,
            fn: function() { do_login()}
          },
          items: [login_panel] });
  } else {
      var fld = Lino.login_window.items.first().form.findField('username');
      fld.setValue(username);
      var fld = Lino.login_window.items.first().form.findField('password');
      fld.setValue(password);
  };
  Lino.login_window.show();
};

Lino.logout = function(id,name) {
    Lino.call_ajax_action(
        Lino.viewport, 'GET', 
        '/auth',
        {}, 'logout', undefined, undefined,
        function(){Lino.reload();})
}

Lino.set_subst_user = function(id, name) {
    //~ console.log(20130723,'Lino.set_subst_user',id,name,Lino.current_window,Lino.viewport);
    Lino.subst_user = id;
    if (Lino.current_window) 
        Lino.current_window.main_item.set_base_param("su",id);
    if (Lino.viewport) 
        Lino.permalink_handler(Lino.current_window)();
}



//~ Lino.select_subst_user = function(cmp,rec,value){
    //~ Lino.subst_user=value;
    //~ console.log(20120713,rec);
//~ }
    
Lino.current_window = null;
Lino.window_history = Array();
    
Lino.chars2width = function(cols) {  return cols * 9; }
Lino.rows2height = function(cols) {  return cols * 20; }
Lino.perc2width = function(perc) {  
    // var w = Math.max(document.documentElement.clientWidth, window.innerWidth);
    // console.log("20151226", document, window, w);
    var w = Lino.viewport.getWidth();
    return w * perc / 100; 
}



Lino.MainPanel = {
  is_home_page: false,
  setting_param_values : false,
  config_containing_window : function(wincfg) { }
  ,init_containing_window : function(win) { }
  ,is_loading : function() { 
      if (!this.rendered) return true;
      //~ return (Ext.select('.x-loading-msg').elements.length > 0);
      return true; 
    } 
  ,do_when_clean : function(auto_save,todo) { todo() }
  ,get_master_params : function() {
    var p = {}
    p['mt'] = this.content_type; 
    rec = this.get_current_record()
    if (rec) {
      if (rec.phantom) {
          p['mk'] = undefined; 
      }else{
          p['mk'] = rec.id; 
      }
    } else {
      p['mk'] = undefined;
    }
    //~ console.log('get_master_params returns',p,'using record',rec);
    return p;
  }
  ,get_permalink : function() {
    var p = Ext.apply({}, this.get_base_params());
    delete p.fmt;
    Ext.apply(p, this.get_permalink_params());
    
    if (this.toggle_params_panel_btn) {
        p.sp = this.toggle_params_panel_btn.pressed;
        //~ if (this.toggle_params_panel_btn.pressed == this.params_panel_hidden) {
          //~ p.sp = true;
        //~ }
    }
    
    //~ Lino.insert_subst_user(p);
     //~ p.fmt = 'html';
    //~ console.log('get_permalink',p,this.get_permalink_params());
    if (this.is_home_page)
        //~ var url = '';
        var url = '/';
    else 
        var url = this.get_permalink_url();
    if (p.su == null) 
        delete p.su;
    if (Ext.urlEncode(p)) url = url + "?" + Ext.urlEncode(p);
    return url;
  }
  ,get_record_url : function(record_id) {
      var url = '/api' + this.ls_url
      //~ var url = this.containing_window.config.url_data; // ls_url;
      url += '/' + (record_id === undefined ? this.default_record_id : String(record_id));
      //~ if (record_id !== undefined) url += '/' + String(record_id);
      //~ url += '/' + String(record_id);
      return url;
  }
  ,get_permalink_url : function() {
      return '/api' + this.ls_url;
  }
  ,get_permalink_params : function() {
      //~ return {an:'grid'};
      var p = {};
      if (this.action_name)
          p.an = this.action_name;
      this.add_param_values(p,false)
      return p;
  }
  /*

  Lino.MainPanel.set_status() : the status can have the following keys:

  - param_values : values of parameter fields
  - field_values : values of action parameter fields
  - base_params
  - record_id
  - active_tab
  - data_record
  - show_params_panel
  - current_page

   */
  ,set_status : function(status, requesting_panel) {}
  ,get_status : function() { return {}}
  ,refresh : function() {}
  ,get_base_params : function() {  // Lino.MainPanel
    var p = {};
    Lino.insert_subst_user(p);
    return p;
  }
  ,add_params_panel : function (tbar) {
      if (this.params_panel) {
        //~  20130923b
        //~ this.params_panel.autoHeight = true; // 20130924
        var t = this;
        var update = function() {
            var p = t.params_panel;
            //~ console.log("update", p.getSize().height,p.forceLayout,p.autoHeight);
            var w = t.get_containing_window();
            Lino.do_when_visible(w, function() {
                //~ p.doLayout(true); // doLayout(shallow, force)
                w.doLayout(true); // doLayout(shallow, force)
                //~ t.params_panel.on('afterlayout',update,t,{single:true});
            });
        };
        Lino.do_when_visible(this.params_panel, update);
        this.params_panel.on('show',update);
        this.params_panel.on('hide',update);
        //~ this.params_panel.on('bodyresize',update);
        this.params_panel.on('afterlayout',update);
        //~ this.params_panel.on('afterlayout',update,this,{single:true});
        //~ this.params_panel.on('bodyresize',update,this,{single:true});
        //~ this.params_panel.on('resize',update,this,{single:true});
        //~ this.params_panel.on('render',update,this,{single:true});
        
        // this.params_panel.on('render',
        //~ this.params_panel.on('afterlayout',update,this,{single:true,delay:200});
        //~ this.params_panel.on('bodyresize',update,this,{single:true,delay:200});
        this.toggle_params_panel_btn = new Ext.Button({ scope:this, 
          //~ text: "$_("[parameters]")", // gear
          iconCls: 'x-tbar-database_gear',
          tooltip:"Show or hide the table parameters panel",
          enableToggle: true,
          //~ pressed: ! this.params_panel.hidden,
          pressed: ! this.params_panel_hidden,
          toggleHandler: function(btn,state) { 
            //~ console.log("20120210 add_params_panel",state,this.params_panel);
            if (state) {
                this.params_panel.show();
            } else {
                this.params_panel.hide();
            }
            //~ this.params_panel.on('afterlayout',update,this,{single:true});
            //~ t.get_containing_window().doLayout();
            //~ this.params_panel.on('afterlayout',function() {
                //~ console.log("20130918 afterlayout");
                //~ t.get_containing_window().doLayout(); // doLayout(shallow, force)
            //~ },this,{single:true});
          }
        }); 
        tbar = tbar.concat([this.toggle_params_panel_btn]);
        var refresh = function() {
            if (!t.setting_param_values) {
                t._force_dirty = true; 
                t.refresh();
            }
        }
        Ext.each(this.params_panel.fields,function(f) {
          //~ f.on('valid',function() {t.refresh()});
          if (f instanceof Ext.form.Checkbox) {
              f.on('check',refresh);
          } else if (f instanceof Ext.DatePicker) {
              f.on('select',refresh);
          } else if (f instanceof Ext.form.TriggerField) {
              f.on('select',refresh);
              //~ f.on('change',refresh);
              //~ f.on('valid',refresh);
          } else {
              if (! f.on) 
                  console.log("20121010 no method 'on'",f);
              else
                  f.on('change',refresh);
            }
          });
      }
      return tbar;
  }
  ,add_param_values : function (p,force_dirty) {
    if (this.params_panel) {
      /* 
      * 20120918 add param_values to the request string 
      * *only if the params_form is dirty*.
      * Otherwise Actor.default_params() would never be used.
      *
      * 20121023 But IntegClients.params_default has non-empty default values. 
      * Users must have the possibility to make them empty.
      * 
      * 20130605 : added `force_dirty` parameter because Checkbox fields don't 
      * mark their form as dirty when check is fired.
      * 
      * 20130721 : `force_dirty` not as a parameter but as 
      * `this._force_dirty` because
      * 
      * 20130915 : both _force_dirty and force_dirty parameter are needed.
      * 
      */
      if (force_dirty || this._force_dirty || this.params_panel.form.isDirty()) {
      //~ if (this._force_dirty || this.params_panel.form.isDirty()) {
        p.pv = this.get_param_values();
        //~ console.log("20130923 form is dirty (",force_dirty,this._force_dirty,this.params_panel.form.isDirty(),")");
        //~ console.log("20130923 form is dirty",p);
      }else{
        //~ console.log("20130923 form not dirty:",this.params_panel.form);
        if (this.status_param_values) 
          p.pv = Lino.fields2array(
            this.params_panel.fields,this.status_param_values);
      }
      //~ if (!this.params_panel.form.isDirty()) return;
      //~ p.pv = this.get_param_values();
      //~ console.log("20120203 add_param_values added pv",p.pv,"to",p);
    }
  },
  get_param_values : function() { // similar to get_field_values()
      return Lino.fields2array(this.params_panel.fields);
  },
  set_param_values : function(pv) {
    if (this.params_panel) {
      //~ console.log('20120203 MainPanel.set_param_values', pv);
      this.status_param_values = pv;
      //~ this.params_panel.form.suspendEvents(false);
      this.setting_param_values = true;
      if (pv) { 
          this.params_panel.form.my_loadRecord(pv);
      } else { 
        this.params_panel.form.reset(); 
      }
      this.setting_param_values = false;
      this._force_dirty = false; 
      //~ this.params_panel.form.resumeEvents();
    }
  }
};




Lino.Viewport = Ext.extend(Ext.Viewport, Lino.MainPanel);
Lino.Viewport = Ext.extend(Lino.Viewport, {
  layout : "fit"
  ,is_home_page : true
  ,initComponent : function(){
    Lino.Viewport.superclass.initComponent.call(this);
    this.on('render',function(){
      this.loadMask = new Ext.LoadMask(this.el,{msg:"Please wait..."});
      //~ console.log("20121118 Lino.viewport.loadMask",this.loadMask);
    },this);
  }
  ,refresh : function() {
      var caller = this;
      // console.log("20140829 Lino.Viewport.refresh()");
      if (caller.loadMask) caller.loadMask.show();
      var success = function(response) {
        if (caller.loadMask) caller.loadMask.hide();
        if (response.responseText) {
          var result = Ext.decode(response.responseText);
          //~ console.log('Lino.do_action()',action.name,'result is',result);
          if (result.html) {
              var cmp = Ext.getCmp('dashboard');
              // cmp.removeAll(true);  // 20140829
              cmp.update(result.html, true);
          }
          if (result.message) {
              if (result.alert) {
                  //~ Ext.MessageBox.alert('Alert',result.alert_msg);
                  Ext.MessageBox.alert('Alert',result.message);
              } else {
                  Lino.notify(result.message);
              }
          }
          
          if (result.notify_msg) Lino.notify(result.notify_msg);
          if (result.js_code) { 
            var jsr = result.js_code(caller);
            //~ console.log('Lino.do_action()',action,'returned from js_code in',result);
          };
        }
      };
      var action = {
        url : '/api/main_html',
        waitMsg: "Please wait...",
        failure: Lino.ajax_error_handler(caller),
        success: success,
        method: 'GET',
        params: {}
      };
      Lino.insert_subst_user(action.params);
      Ext.Ajax.request(action);
    
  }
});




Lino.open_window = function(win, st, requesting_panel) {
  // console.log("20140831 Lino.open_window()", win, win.el.getBox());
  var cw = Lino.current_window;
  if (cw) {
    // console.log("20140829 Lino.open_window() save current status",
    //             cw.main_item.get_status());
    Lino.window_history.push({
      window:cw,
      status:cw.main_item.get_status()
    });
  }
  Lino.current_window = win;
  //~ if (st.su) 
      //~ Lino.subst_user_field.setValue(st.su);
  win.main_item.set_status(st, requesting_panel);
  // win.toFront();
  win.show();
};

Lino.load_url = function(url) {
    //~ foo.bar.baz = 2; 
    //~ console.log("20121120 Lino.load_url()");
    //~ Lino.body_loadMask.show();
    Lino.viewport.loadMask.show();
    //~ location.replace(url);
    document.location = url;
}

Lino.close_window = function(status_update, norestore) {
  // norestore is used when called by handle_action_result() who 
  // will call set_status itself later
  var cw = Lino.current_window;
  var ww = Lino.window_history.pop();
  var retval = cw.main_item.requesting_panel;
  // console.log(
  //     "20150514 Lino.close_window() going to close", cw.title,
  //     "previous is", ww, 
  //     "norestore is", norestore,
  //     "retval is", retval);
  if (ww) {
    //~ if (status_update) Ext.apply(ww.status,status_update);
    if(!norestore) {
        if (status_update) status_update(ww);
        ww.window.main_item.set_status(ww.status , cw.id);
    }
    Lino.current_window = ww.window;
  } else {
      Lino.current_window = null;
      // new since 20140829:
      if(!norestore) { Lino.viewport.refresh(); }
  }
  if (cw) cw.hide_really();
  return retval;
};

Lino.kill_current_window = function() {
  // console.log("20140418 Lino.kill_current_window()");
  var cw = Lino.current_window;
  Lino.current_window = null;
  if (cw) cw.hide_really();
};

Lino.reload = function() {
    // First close all windows to ensure all changes are saved
    Lino.close_all_windows();

    // Then reload current view
    var url =  "/"

    var p = {};
    Lino.insert_subst_user(p)
    if (Ext.urlEncode(p))
        url = url + "?" + Ext.urlEncode(p);

    Lino.load_url(url);
}

Lino.handle_home_button = function() {
  if (Lino.window_history.length == 0)
      Lino.reload();
  else
      Lino.close_all_windows();
}

Lino.close_all_windows = function() {
    while (Lino.window_history.length > 0) {
        Lino.close_window();
    }
}

Lino.calling_window = function() {
    if (Lino.window_history.length) 
        return Lino.window_history[Lino.window_history.length-1];
}

//~ Lino.WindowAction = function(mainItemClass,windowConfig,mainConfig,ppf) {
Lino.WindowAction = function(windowConfig,main_item_fn) {
    //~ if(!mainConfig) mainConfig = {};
    //~ mainConfig.is_main_window = true;
    this.windowConfig = windowConfig;
    this.main_item_fn = main_item_fn;
    //~ if (ppf) mainConfig.params_panel.fields = ppf;
    //~ this.mainConfig = mainConfig;
    //~ this.mainItemClass = mainItemClass;
};

Lino.WindowAction = Ext.extend(Lino.WindowAction,{
    window : null,
    //~ mainItemClass: null,
    get_window : function() {
      //~ if(mainConfig) Ext.apply(this.mainConfig,mainConfig);
      // if (this.window == null || this.window.isDestroyed)  { // 20140829
      // if (this.window == null || this.window.getBox().width == 0)  { // 20140829
      if (this.window == null)  {
      // if (true)  {
          //~ this.windowConfig.main_item = new this.mainItemClass(this.mainConfig);
          this.windowConfig.main_item = this.main_item_fn();
          this.window = new Lino.Window(this.windowConfig);
      }
      return this.window;
    },
    run : function(requesting_panel, status) {
      // console.log('20140829 window_action.run()', this)
      Lino.open_window(this.get_window(), status, requesting_panel);
    }
  
});


Lino.PanelMixin = {
  get_containing_window : function (){
      if (this.containing_window) return this.containing_window;
      return this.containing_panel.get_containing_window();
  }
  ,set_window_title : function(title) {
    //~ this.setTitle(title);
    var cw = this.get_containing_window();

    //~ if (cw) {
    //~ if (cw && cw.closable) {
    if (cw && !cw.main_item.hide_window_title) {
      //~ console.log('20111202 set_window_title(',title,') for',this.containing_window);
      //~ if (! this.containing_window.rendered) console.log("WARNING: not rendered!");
      cw.setTitle(title);
    //~ } else {
      //~ document.title = title;
    }
    //~ else console.log('20111202 not set_window_title(',title,') for',this);
  }
  
};


// Lino.status_bar = new Ext.ux.StatusBar({defaultText:'Lino version 2016.12.0.'});






/* 
  Originally copied from Ext JS Library 3.3.1
  Modifications by Luc Saffre : 
  - rendering of phantom records
  - fire afteredit event
  - react on dblclcik, not on single click

 */
Lino.CheckColumn = Ext.extend(Ext.grid.Column, {

    processEvent : function(name, e, grid, rowIndex, colIndex){
        //~ console.log('20110713 Lino.CheckColumn.processEvent',name)
        if (name == 'click') {
        //~ if (name == 'mousedown') {
        //~ if (name == 'dblclick') {
            return this.toggleValue(grid, rowIndex, colIndex);
        } else {
            return Ext.grid.ActionColumn.superclass.processEvent.apply(this, arguments);
        }
    },
    
    toggleValue : function (grid,rowIndex,colIndex) {
        var record = grid.store.getAt(rowIndex);
        var dataIndex = grid.colModel.getDataIndex(colIndex);
        // 20120514
        //~ if(record.data.disabled_fields && record.data.disabled_fields[dataIndex]) {
          //~ Lino.notify("This field is disabled");
          //~ return false;
        //~ }
      
        //~ if (dataIndex in record.data['disabled_fields']) {
            //~ Lino.notify("This field is disabled.");
            //~ return false;
        //~ }
        var startValue = record.data[dataIndex];
        var value = !startValue;
        //~ record.set(this.dataIndex, value);
        var e = {
            grid: grid,
            record: record,
            field: dataIndex,
            originalValue: startValue,
            value: value,
            row: rowIndex,
            column: colIndex,
            cancel: false
        };
        if(grid.fireEvent("beforeedit", e) !== false && !e.cancel){
        //~ if(grid.fireEvent("validateedit", e) !== false && !e.cancel){
            record.set(dataIndex, value);
            delete e.cancel;
            grid.fireEvent("afteredit", e);
        }
        return false; // Cancel event propagation
    },

    renderer : function(v, p, record){
        if (record.phantom) return '';
        p.css += ' x-grid3-check-col-td'; 
        return String.format('<div class="x-grid3-check-col{0}">&#160;</div>', v ? '-on' : '');
    }

    // Deprecate use as a plugin. Remove in 4.0
    // init: Ext.emptyFn
});

// register ptype. Deprecate. Remove in 4.0
// Ext.preg('checkcolumn', Lino.CheckColumn);

// backwards compat. Remove in 4.0
// Ext.grid.CheckColumn = Lino.CheckColumn;

// register Column xtype
Ext.grid.Column.types.checkcolumn = Lino.CheckColumn;


/* 20110725 : 
Lino.on_tab_activate is necessary 
in contacts.Person.2.dtl 
(but don't ask me why...)
*/
Lino.on_tab_activate = function(item) {
  //~ console.log('activate',item); 
  if (item.rendered && item.doLayout) item.doLayout();
  //~ if (item.rendered) item.doLayout();
}

Lino.TimeField = Ext.extend(Ext.form.TimeField,{
  format: 'H:i',
  increment: 15
  });
Lino.DateField = Ext.extend(Ext.form.DateField,{
  //~ boxMinWidth: Lino.chars2width(15), // 20131005 changed from 11 to 15
  format: 'd.m.Y',
  altFormats: 'd/m/Y|Y-m-d'
  });
Lino.DatePickerField = Ext.extend(Ext.DatePicker,{
  //~ boxMinWidth: Lino.chars2width(11),
  format: 'd.m.Y',
  //~ altFormats: 'd/m/Y|Y-m-d'
  formatDate : function(date){
      //~ console.log("20121203 formatDate",this.name,date);
      return Ext.isDate(date) ? date.dateFormat(this.format) : date;
  }
  });
Lino.DateTimeField = Ext.extend(Ext.ux.form.DateTime,{
  dateFormat: 'd.m.Y',
  timeFormat: 'H:i'
  //~ ,hiddenFormat: 'd.m.Y H:i'
  });
Lino.URLField = Ext.extend(Ext.form.TriggerField,{
  triggerClass : 'x-form-search-trigger',
  //~ triggerClass : 'x-form-world-trigger',
  vtype: 'url',
  onTriggerClick : function() {
    //~ console.log('Lino.URLField.onTriggerClick',this.value)
    //~ document.location = this.value;
    window.open(this.getValue(),'_blank');
  }
});
Lino.IncompleteDateField = Ext.extend(Ext.form.TextField,{
  //~ regex: /^-?\d+-[01]\d-[0123]\d$/,
  //~ regex: /^[0123]\d\.[01]\d\.-?\d+$/,
  maxLength: 10,
  boxMinWidth: Lino.chars2width(10),
  regex: /^[0123]?\d\.[01]?\d\.-?\d+$/,
  regexText: 'Enter a date in format YYYY-MM-DD (use zeroes for unknown parts).'
  });


//~ Lino.make_dropzone = function(cmp) {
    //~ cmp.on('render', function(ct, position){
      //~ ct.el.on({
        //~ dragenter:function(event){
          //~ event.browserEvent.dataTransfer.dropEffect = 'move';
          //~ return true;
        //~ }
        //~ ,dragover:function(event){
          //~ event.browserEvent.dataTransfer.dropEffect = 'move';
          //~ event.stopEvent();
          //~ return true;
        //~ }
        //~ ,drop:{
          //~ scope:this
          //~ ,fn:function(event){
            //~ event.stopEvent();
            //~ console.log(20110516);
            //~ var files = event.browserEvent.dataTransfer.files;
            //~ if(files === undefined){
              //~ return true;
            //~ }
            //~ var len = files.length;
            //~ while(--len >= 0){
              //~ console.log(files[len]);
              //~ // this.processDragAndDropFileUpload(files[len]);
            //~ }
          //~ }
        //~ }
      //~ });
    //~ });
//~ };

//~ Lino.FileUploadField = Ext.ux.form.FileUploadField;

Lino.FileUploadField = Ext.extend(Ext.ux.form.FileUploadField,{
    unused_onRender : function(ct, position){
      Lino.FileUploadField.superclass.onRender.call(this, ct, position);
      this.el.on({
        dragenter:function(event){
          event.browserEvent.dataTransfer.dropEffect = 'move';
          return true;
        }
        ,dragover:function(event){
          event.browserEvent.dataTransfer.dropEffect = 'move';
          event.stopEvent();
          return true;
        }
        ,drop:{
          scope:this
          ,fn:function(event){
            event.stopEvent();
            //~ console.log(20110516);
            var files = event.browserEvent.dataTransfer.files;
            if(files === undefined){
              return true;
            }
            var len = files.length;
            while(--len >= 0){
              console.log(files[len]);
              //~ this.processDragAndDropFileUpload(files[len]);
            }
          }
        }
      });
    }
});

Lino.FileField = Ext.extend(Ext.form.TriggerField,{
  triggerClass : 'x-form-search-trigger',
  editable: false,
  onTriggerClick : function() {
    //~ console.log('Lino.URLField.onTriggerClick',this.value)
    //~ document.location = this.value;
    if (this.getValue()) window.open(MEDIA_URL + '/'+this.getValue(),'_blank');
  }
});

Lino.file_field_handler = function(panel,config) {
  if (panel.action_name == 'insert') {
      panel.has_file_upload = true;


      // config.value = '<br/><br/>';

      var f = new Lino.FileUploadField(config);
      //~ Lino.make_dropzone(f);
      return f;
      //~ return new Ext.ux.form.FileUploadField(config);
      //~ return new Lino.FileField(config);
      
  } else {
      //~ return new Lino.URLField(config);
      return new Lino.FileField(config);
  }
}

Lino.VBorderPanel = Ext.extend(Ext.Panel,{
    constructor : function(config) {
      config.layout = 'border';
      delete config.layoutConfig;
      Lino.VBorderPanel.superclass.constructor.call(this,config);
      for(var i=0; i < this.items.length;i++) {
        var item = this.items.get(i);
        if (this.isVertical(item) && item.collapsible) {
          item.on('collapse',this.onBodyResize,this);
          item.on('expand',this.onBodyResize,this);
        }
      }
    },
    isVertical : function(item) {
       return (item.region == 'north' || item.region == 'south' || item.region == 'center');
    },
    onBodyResize: function(w, h){
        //~ console.log('VBorderPanel.onBodyResize',this.title)
      if (this.isVisible()) { // to avoid "Uncaught TypeError: Cannot call method 'getHeight' of undefined."
        var sumflex = 0;
        var availableHeight = this.getInnerHeight();
        var me = this;
        this.items.each(function(item){
          if (me.isVertical(item)) {
              if (item.collapsed || item.flex == 0 || item.flex === undefined) {
                  if (item.rendered) availableHeight -= item.getHeight();
              } else {
                  sumflex += item.flex;
              }
          } 
          
        });
        //~ for(var i=0; i < this.items.length;i++) {
          //~ var item = this.items.get(i);
          //~ // if (this.isVertical(item) && item.getResizeEl()) {
          //~ if (this.isVertical(item)) {
              //~ if (item.collapsed || item.flex == 0 || item.flex === undefined) {
                  //~ // item.syncSize()
                  //~ // item.doLayout()
                  //~ // if (item.region == "north") console.log('region north',item.getHeight(),item.id, item);
                  //~ // if (item.getHeight() == 0) console.log(20100921,'both flex and getHeight() are 0!');
                  //~ availableHeight -= item.getHeight();
              //~ } else {
                  //~ sumflex += item.flex;
                  //~ // console.log(item.flex);
              //~ }
          //~ } 
          //~ // else console.log('non-vertical item in VBoderPanel:',item)
        //~ }
        var hunit = availableHeight / sumflex;
        //~ console.log('sumflex=',sumflex,'hunit=',hunit, 'availableHeight=',availableHeight);
        for(var i=0; i < this.items.length;i++) {
          var item = this.items.get(i);
          if (this.isVertical(item)) {
              if (item.flex != 0 && ! item.collapsed) {
                  item.setHeight(hunit * item.flex);
                  //~ console.log(item.region,' : height set to',item.getHeight());
              }
          }
          //~ else console.log('non-vertical item in VBoderPanel:',item)
        }
      }
      Lino.VBorderPanel.superclass.onBodyResize.call(this, w, h);
    }
});


/*
  modifications to the standard behaviour of a CellSelectionModel:
  
*/
Ext.override(Ext.grid.CellSelectionModel, {
//~ var dummy = {

    handleKeyDown : function(e){
        /* removed because F2 wouldn't pass
        if(!e.isNavKeyPress()){
            return;
        }
        */
        //~ console.log('handleKeyDown',e)
        var k = e.getKey(),
            g = this.grid,
            s = this.selection,
            sm = this,
            walk = function(row, col, step){
                return g.walkCells(
                    row,
                    col,
                    step,
                    g.isEditor && g.editing ? sm.acceptsNav : sm.isSelectable, 
                    sm
                );
            },
            cell, newCell, r, c, ae;

        switch(k){
            case e.ESC:
            case e.PAGE_UP:
            case e.PAGE_DOWN:
                break;
            default:
                // e.stopEvent(); // removed because Browser keys like Alt-Home, Ctrl-R wouldn't work
                break;
        }

        if(!s){
            cell = walk(0, 0, 1); 
            if(cell){
                this.select(cell[0], cell[1]);
            }
            return;
        }

        cell = s.cell;
        r = cell[0];    
        c = cell[1];    
        
        switch(k){
            case e.TAB:
                if(e.shiftKey){
                    newCell = walk(r, c - 1, -1);
                }else{
                    newCell = walk(r, c + 1, 1);
                }
                break;
            case e.HOME:
                if (! (g.isEditor && g.editing)) {
                  if (!e.hasModifier()){
                      newCell = [r, 0];
                      //~ console.log('home',newCell);
                      break;
                  }else if(e.ctrlKey){
                      var t = g.getTopToolbar();
                      var activePage = Math.ceil((t.cursor + t.pageSize) / t.pageSize);
                      if (activePage > 1) {
                          e.stopEvent();
                          t.moveFirst();
                          return;
                      }
                      newCell = [0, c];
                      break;
                  }
                }
            case e.END:
                if (! (g.isEditor && g.editing)) {
                  c = g.colModel.getColumnCount()-1;
                  if (!e.hasModifier()) {
                      newCell = [r, c];
                      //~ console.log('end',newCell);
                      break;
                  }else if(e.ctrlKey){
                      var t = g.getTopToolbar();
                      var d = t.getPageData();
                      if (d.activePage < d.pages) {
                          e.stopEvent();
                          var self = this;
                          t.on('change',function(tb,pageData) {
                              var r = g.store.getCount()-2;
                              self.select(r, c);
                              //~ console.log('change',r,c);
                          },this,{single:true});
                          t.moveLast();
                          return;
                      } else {
                          newCell = [g.store.getCount()-1, c];
                          //~ console.log('ctrl-end',newCell);
                          break;
                      }
                  }
                }
            case e.DOWN:
                newCell = walk(r + 1, c, 1);
                break;
            case e.UP:
                newCell = walk(r - 1, c, -1);
                break;
            case e.RIGHT:
                newCell = walk(r, c + 1, 1);
                break;
            case e.LEFT:
                newCell = walk(r, c - 1, -1);
                break;
            case e.F2:
                if (!e.hasModifier()) {
                    if (g.isEditor && !g.editing) {
                        g.startEditing(r, c);
                        e.stopEvent();
                        return;
                    }
                    break;
                }
            case e.INSERT:
                if (!e.hasModifier()) {
                    if (g.ls_insert_handler && !g.editing) {
                        e.stopEvent();
                        Lino.show_insert(g);
                        return;
                    }
                    break;
                }
            // case e.DELETE:
            //     if (!e.hasModifier()) {
            //         if (!g.editing) {
            //             e.stopEvent();
            //             Lino.delete_selected(g);
            //             return;
            //         }
            //         break;
            //     }

            case e.ENTER:
                e.stopEvent();
                g.onCellDblClick(r,c);
                break;

            default:
                g.handle_key_event(e);
                
        }
        

        if(newCell){
          e.stopEvent();
          r = newCell[0];
          c = newCell[1];
          this.select(r, c); 
          if(g.isEditor && g.editing){ 
            ae = g.activeEditor;
            if(ae && ae.field.triggerBlur){
                ae.field.triggerBlur();
            }
            g.startEditing(r, c);
          }
        //~ } else if (g.isEditor && !g.editing && e.charCode) {
        //~ // } else if (!e.isSpecialKey() && g.isEditor && !g.editing) {
            //~ g.set_start_value(String.fromCharCode(e.charCode));
            //~ // g.set_start_value(String.fromCharCode(k));
            //~ // g.set_start_value(e.charCode);
            //~ g.startEditing(r, c);
            //~ // e.stopEvent();
            //~ return;
        // } else {
          // console.log('20120513',e,g);
        }
        
    }


//~ };
});

 

function PseudoConsole() {
    this.log = function() {};
};
if (typeof(console) == 'undefined') console = new PseudoConsole();

Lino.notify = function(msg) {
  if (msg == undefined) msg = ''; else console.log(msg);
  
    if (msg == undefined) return;
    // Lino.alert(msg);
  
};

Lino.alert = function(msg) {
  Ext.MessageBox.alert('Notify',msg);
};


//~ Lino.show_about = function() {
  //~ new Ext.Window({
    //~ width: 400, height: 400,
    //~ title: "About",
    //~ html: '<a href="http://www.extjs.com" target="_blank">ExtJS</a> version ' + Ext.version
  //~ }).show();
//~ };

function obj2str(o) {
  if (typeof o != 'object') return String(o);
  var s = '';
  for (var p in o) {
    s += p + ': ' + obj2str(o[p]) + '\n';
  }
  return s;
}

Lino.on_store_exception = function (store,type,action,options,response,arg) {
  //~ throw response;
  console.log("on_store_exception: store=",store,
    "type=",type,
    "action=",action,
    "options=",options,
    "response=",response,
    "arg=",arg);
  if (arg) { console.log(arg.stack)};
};

//~ Lino.on_submit_success = function(form, action) {
   //~ Lino.notify(action.result.message);
   //~ this.close();
//~ };

Lino.on_submit_failure = function(form, action) {
    //~ Lino.notify();
  // action may be undefined
    switch (action.failureType) {
        case Ext.form.Action.CLIENT_INVALID:
            Ext.Msg.alert('Client-side failure', 'Form fields may not be submitted with invalid values');
            break;
        case Ext.form.Action.CONNECT_FAILURE:
            Ext.Msg.alert('Connection failure', 'Ajax communication failed');
            break;
        case Ext.form.Action.SERVER_INVALID:
            Ext.Msg.alert('Server-side failure', action.result.message);
   }
};



/*
Lino.save_wc_handler = function(ww) {
  return function(event,toolEl,panel,tc) {
    var pos = panel.getPosition();
    var size = panel.getSize();
    wc = ww.get_window_config();
    Ext.applyIf(wc,{ 
      x:pos[0],y:pos[1],height:size.height,width:size.width,
      maximized:panel.maximized});
    Lino.do_action(ww,{url:'/window_configs/'+ww.config.permalink_name,params:wc,method:'POST'});
  }
};

*/

Lino.show_in_own_window_button = function(handler) {
  return {
    qtip: "Show this panel in own window", 
    id: "up",
    handler: function(event,toolEl,panel, tc) {
      //~ console.log('20111206 report_window_button',panel,handler);
      handler.run(null,{base_params:panel.containing_panel.get_master_params()});
    }
  }
}

Lino.action_handler = function (panel, on_success, on_confirm) {
  return function (response) {
      if (!panel) { 
          if (Lino.current_window) 
              panel = Lino.current_window.main_item;
          else panel = Lino.viewport;
      }
      
    if (panel.loadMask) panel.loadMask.hide(); // 20120211
    if (!response.responseText) return ;
    var result = Ext.decode(response.responseText);
    Lino.handle_action_result(panel, result, on_success, on_confirm);
  }
};

Lino.handle_action_result = function (panel, result, on_success, on_confirm) {

    // console.log('20150514 Lino.handle_action_result()', result);
    
    // if (panel instanceof Lino.GridPanel) {
    //     gridmode = true;
    // } else {
    //     gridmode = false;
    // }

    //~ if (result.goto_record) {
        //~ var js = "Lino." + result.goto_record[0] + '.detail.run';
        //~ var h = eval(js);
        //~ h(panel,{record_id:result.goto_record[1]});
    //~ }
    
    if (result.xcallback) {
        //~ var config = {title:"Confirmation"};
        var config = {title:result.xcallback.title};
        //~ config.buttons = Ext.MessageBox.YESNOCANCEL;
        //~ config.buttons = Ext.MessageBox.YESNO;
        var p = {};
        Lino.insert_subst_user(p);
        config.buttons = result.xcallback.buttons;
        config.msg = result.message;
        config.fn = function(buttonId, text, opt) {
          panel.loadMask.show(); 
          //~ Lino.insert_subst_user(p);
          Ext.Ajax.request({
            method: 'GET',
            url: '/callbacks/'
                  + result.xcallback.id + '/' + buttonId,
            params: p,
            success: Lino.action_handler(panel, on_success, on_confirm)
          });
        }
        Ext.MessageBox.show(config);
        return;
    }

    // `record_id` and/or `data_record` both mean "display the detail
    // of this record". 
    
    if(result.detail_handler_name) {
        // TODO: make sure that result.detail_handler_name is secure
        var detail_handler = eval("Lino." + result.detail_handler_name);
    }
    var ns = {};  // new status
    if (result.close_window) {
        
        // Subsequent processing expects that `panel` is "the current
        // panel". But if we close the window, `panel` must point
        // to the previous window. Note the case of an insert window
        // that has been invoked by double-clicking on the phantom row
        // of a slave table in a detail window. In that case we want
        // `panel` to become the grid panel of the slave table who
        // called the insert window, not the master's detail form
        // panel.  When the insert window has been called by an action
        // link (e.g. generated using ar.insert_button), then
        // Lino.close_window can return `undefined`.

        if(result.record_id || result.data_record) {
            var ww = Lino.calling_window();
            if (ww && ww.window.main_item instanceof Lino.FormPanel) {
                if (ww.window.main_item.ls_detail_handler == detail_handler) {
                    ns.record_id = result.record_id;
                    ns.data_record = result.data_record;
                    // console.log("20150514 use new status.");
                }
            }
        }

        panel = Lino.close_window(
            function(ww) { Ext.apply(ww.status, ns) }); 
        if (!panel) 
            // console.log("20150514 close_window returned no panel.");
            if (Lino.current_window)
                panel = Lino.current_window.main_item;

    }

    if(result.record_id || result.data_record) {
        if (! (ns.record_id || ns.data_record)) {
          // no close_window, so we must update record data in current
          // panel (if it is the detail_handler for this record) or
          // open the detail handler.
          var st = {
              record_id: result.record_id,
              data_record: result.data_record
          };
          if (result.active_tab) st.active_tab = result.active_tab;
          if (panel instanceof Lino.FormPanel 
              && panel.ls_detail_handler == detail_handler) 
            {
              // console.log("20150514 use panel.set_status().");
              panel.set_status(st);
          } else {
              // console.log("20150514 run detail_handler.");
              st.base_params = panel.get_base_params();
              detail_handler.run(null, st);
          }

          // if (panel instanceof Lino.FormPanel 
          //     && panel.ls_url == result.actor_url) {
          //     // console.log("20140506 case 2 it's a FormPanel:", panel);
          //     panel.set_status({
          //         record_id: result.record_id,
          //         data_record: result.data_record});
          // } else if (panel.ls_detail_handler 
          //            && panel.ls_url == result.actor_url) {
          //     // console.log("20140506 case 4");
          //     panel.ls_detail_handler.run(null, {
          //         record_id: result.record_id,
          //         data_record: result.data_record,
          //         base_params: panel.get_base_params()});
          // } else {
          //     result.refresh_all = true;
          //     console.log("20140604 case 6", result.actor_url);
          // }
        }
    }

    // `eval_js` must get handled after `close_window` because it
    // might ask to open a new window (and we don't want to close that
    // new window).  It must execute *before* any MessageBox,
    // otherwise the box would get hidden by a window that opens
    // afterwards.

    if (result.eval_js) {
        //~ console.log(20120618,result.eval_js);
        eval(result.eval_js);
    }
    
    if (on_success && result.success) {
        // console.log("20140430 handle_action_result calls on_success", 
        //             on_success);
        on_success(result);
    }
    
    if (result.info_message) {
        console.log(result.info_message);
    }
    
    if (result.warning_message) {
        if (!result.alert) result.alert = "Warning";
        Ext.MessageBox.alert(result.alert, result.warning_message);
    }
    
    if (result.message) {
        //~ if (result.alert && ! gridmode) {
        if (result.alert) { // 20120628b 
            //~ Ext.MessageBox.alert('Alert',result.alert_msg);
            if (result.alert === true) result.alert = "Alert";
            Ext.MessageBox.alert(result.alert, result.message);
        } else {
            Lino.notify(result.message);
        }
    }

    if(result.record_deleted && panel.ls_detail_handler == detail_handler) {
        panel.after_delete();
    }
    
    if (result.refresh_all) {
        var cw = Lino.current_window;
        // var cw = panel.get_containing_window();
        if (cw) {
            // console.log("20140917 refresh_all calls refresh on", cw.main_item);
            cw.main_item.refresh();
        } else { Lino.viewport.refresh(); }
        // else console.log("20140917 cannot refresh_all because ",
        //                  "there is no current_window");
    } else {
        if (result.refresh) {
            // console.log("20140917 Gonna call panel.refresh()", panel);
            panel.refresh();
        }
    }if (result.open_url) {
        //~ console.log(20111126,result.open_url);
        //~ if (!result.message)
            //~ Lino.notify('Open new window <a href="'+result.open_url+'" target="_blank">'+result.open_url+'</a>');
        window.open(result.open_url,'foo',"");
        //~ document.location = result.open_url;
    }
};

// obsolete but still used for deleting records.
Lino.do_action = function(caller,action) { 
  action.success = function(response) {
    if (caller.loadMask) caller.loadMask.hide();
    //~ console.log('Lino.do_action()',action,'action success',response);
    if (action.after_success) {
        //~ console.log('Lino.do_action() calling after_success');
        action.after_success();
    }
    if (response.responseText) {
      var result = Ext.decode(response.responseText);
      //~ console.log('Lino.do_action()',action.name,'result is',result);
      if (result.message) {
          if (result.alert) {
              //~ Ext.MessageBox.alert('Alert',result.alert_msg);
              Ext.MessageBox.alert('Alert',result.message);
          } else {
              Lino.notify(result.message);
          }
      }
      
      //~ if (result.alert_msg) Ext.MessageBox.alert('Alert',result.alert_msg);
      //~ if (result.message) Lino.notify(result.message);
      if (result.notify_msg) Lino.notify(result.notify_msg);
      if (result.js_code) { 
        //~ console.log('Lino.do_action()',action,'gonna call js_code in',result);
        var jsr = result.js_code(caller);
        //~ console.log('Lino.do_action()',action,'returned from js_code in',result);
        if (action.after_js_code) {
          //~ console.log('Lino.do_action()',action,'gonna call after_js_code');
          action.after_js_code(jsr);
          //~ console.log('Lino.do_action()',action,'returned from after_js_code');
        //~ } else {
          //~ console.log('Lino.do_action()',action,' : after_js_code is false');
        }
      };
    }
  };
  Ext.applyIf(action,{
    waitMsg: "Please wait...",
    failure: Lino.ajax_error_handler(caller),
    params: {}
  });
  //~ action.params.su = Lino.subst_user;
  Lino.insert_subst_user(action.params);
  
  Ext.Ajax.request(action);
};

//~ Lino.gup = function( name )
//~ {
  //~ // Thanks to http://www.netlobo.com/url_query_string_javascript.html
  //~ name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
  //~ var regexS = "[\\?&]"+name+"=([^&#]*)";
  //~ var regex = new RegExp( regexS );
  //~ var results = regex.exec( window.location.href );
  //~ if( results == null )
    //~ return "";
  //~ else
    //~ return results[1];
//~ };

//~ Lino.refresh_handler = function (ww) {
  //~ return function() { 
      //~ console.log('refresh',ww);
      //~ ww.main_item.doLayout(false,true);
      //~ ww.main_item.syncSize();
  //~ }
//~ };

//~ Lino.tools_close_handler = function (ww) {
  //~ return function() { 
      //~ ww.close();
  //~ }
//~ };
Lino.permalink_handler = function (ww) {
  return function() { 
    //~ document.location = ww.main_item.get_permalink();
    //~ console.log('20130723 Lino.permalink_handler',ww);
    
    /* Uncaught TypeError: Cannot read property 'main_item' of null  */
    if (ww) {
        var url = ww.main_item.get_permalink();
    } else {
        var url = Lino.viewport.get_permalink();
    }
    Lino.load_url(url);
  }
};
//~ Lino.run_permalink = function() {
  //~ var plink = Lino.gup('permalink');
  //~ if(plink) { eval('Lino.'+plink); }
//~ }


Lino.ajax_error_handler = function(panel) {
  return function(response,options) {
    console.log('Ajax failure:', response, options);
    if (panel.loadMask) panel.loadMask.hide();
    if (response.responseText) {
      var lines = response.responseText.split('\n');
      if (lines.length > 10) {
          line = lines.splice(5, lines.length-10, "(...)");
      }
      //~ console.log(20131005, response.statusText.toCamel());
      Ext.MessageBox.alert(
        response.statusText.toCamel(),
        lines.join('<br/>')
        //~ response.responseText.replace(/\n/g,'<br/>'))
      )
    } else {
      Ext.MessageBox.alert('Action failed',
        'Lino server did not respond to Ajax request');
    }
  }
}
// Ext.Ajax.on('requestexception',Lino.ajax_error_handler)
 


Ext.QuickTips.init();

/* setting QuickTips dismissDelay to 0 */
// Apply a set of config properties to the singleton
//~ Ext.apply(Ext.QuickTips.getQuickTip(), {
//~ Ext.apply(Ext.ToolTip, {
    //~ dismissDelay: 0
    //~ autoHide: false,
    //~ closable: true,
    //~ maxWidth: 200,
    //~ minWidth: 100,
    //~ showDelay: 50      // Show 50ms after entering target
    //~ ,trackMouse: true
//~ });


//~ Ext.apply(Ext.QuickTip, {
    //~ dismissDelay: 0,
//~ });
  
Lino.quicktip_renderer = function(title, body) {
  return function(c) {
    //~ if (c instanceof Ext.Panel) var t = c.bwrap; else // 20130129
      if (c instanceof Ext.Panel)
          var t = c.header;
      else // 20130129
          var t = c.getEl();
    // if (title == 'a2btn') console.log(20160829, c, t, body);
    //~ t.dismissDelay = 0;
    Ext.QuickTips.register({
      target: t,
      //~ cls: 'lino-quicktip-classical',
      dismissDelay: 0,
      //~ autoHide: false,
      showDelay: 50,      // Show 50ms after entering target
      //~ title: title,
      text: body
    });
  }
};


  
Lino.help_text_editor = function() {
  //~ var bp = {
      //~ mk:this.content_type,
      //~ mt:1
    //~ };
    //~ console.log(20120202,bp);
  //~ Lino.lino.ContentTypes.detail({},{base_params:bp});
  //~ Lino.lino.ContentTypes.detail.run(null,{record_id:this.content_type});
  Lino.lino.ContentTypes.detail.run(null,{record_id:this.content_type});
}

// Path to the blank image should point to a valid location on your server
//~ Ext.BLANK_IMAGE_URL = MEDIA_URL + '/extjs/resources/images/default/s.gif'; 


// used as Ext.grid.Column.renderer for id columns in order to hide the special id value -99999
Lino.id_renderer = function(value, metaData, record, rowIndex, colIndex, store) {
  //~ if (record.phantom) return '';
  return value;
}

Lino.raw_renderer = function(value, metaData, record, rowIndex, colIndex, store) {
  return value;
}

Lino.text_renderer = function(value, metaData, record, rowIndex, colIndex, store) {
  //~ return "not implemented"; 
  return value;
}

Lino.NullNumberColumn = Ext.extend(Ext.grid.Column, {
    align : 'right', 
    format : '0,00/i', 
    renderer : function(value, metaData, record, rowIndex, colIndex, store) {
        // if( colIndex == 3)
        //     console.log(20130128,"NullNumberColumn.renderer",value);
        if (value === null) return '';
        return Ext.util.Format.number(value, this.format);
    }
});


Lino.link_button = function(url) {
    // return '<a href="' + url + '"><img src="/media/lino/extjs/images/xsite/link.png" alt="link_button"></a>'
    return '<a href="' + url + '" style="text-decoration:none;">&#10138;</a>'
}

Lino.fk_renderer = function(fkname,handlername) {
  //~ console.log('Lino.fk_renderer handler=',handler);
  return function(value, metaData, record, rowIndex, colIndex, store) {
    //~ console.log('Lino.fk_renderer',fkname,rowIndex,colIndex,record,metaData,store);
    //~ if (record.phantom) return '';
    if (value) {
        return Lino.link_button('javascript:'+handlername + '.run(null,{record_id:\'' + String(record.data[fkname]) + '\'})")') + value;
        // until 20140822 (clickable foreign keys):
        // var s = '<a href="javascript:' ;
        // s += handlername + '.run(null,{record_id:\'' + String(record.data[fkname]) + '\'})">';
        // s += value + '</a>';
        // return s
    }
    return '';
  }
};

Lino.lfk_renderer = function(panel,fkname) {
  //~ console.log('Lino.fk_renderer handler=',handler);
  var handlername = 'console.log';
  return function(value, metaData, record, rowIndex, colIndex, store) {
    //~ console.log('Lino.fk_renderer',fkname,rowIndex,colIndex,record,metaData,store);
    if (record.phantom) return '';
    if (value) {
        var s = '<a href="javascript:' ;
        s += handlername + '({},{record_id:\'' + String(record.data[fkname]) + '\'})">';
        s += value + '</a>';
        //~ console.log('Lino.fk_renderer',value,'-->',s);
        return s
    }
    return '';
  }
};

//~ Lino.gfk_renderer = function() {
  //~ return function(value, metaData, record, rowIndex, colIndex, store) {
    //~ if (record.phantom) return '';
    //~ console.log('Lino.gfk_renderer',value,colIndex,record,metaData,store);
    //~ return value;
  //~ }
//~ };


Lino.build_buttons = function(panel,actions) {
  //~ console.log("20121006 Lino.build_buttons",actions);
  if (actions) {
    var buttons = Array(actions.length);
    var cmenu = Array(actions.length);
    var keyhandlers = {};
    for (var i=0; i < actions.length; i++) { 
      var a = actions[i];
      if (a.menu) a.menu = Lino.build_buttons(panel,a.menu).bbar;
      buttons[i] = a;
      cmenu[i] = {
            text : a.menu_item_text,
            iconCls : a.iconCls,
            menu : a.menu
          };
      if (a.panel_btn_handler) {
          var h = a.panel_btn_handler.createCallback(panel);
          if (a.auto_save == true) {
              h = panel.do_when_clean.createDelegate(panel,[true,h]);
          } else if (a.auto_save == null) {
              h = panel.do_when_clean.createDelegate(panel,[false,h]);
          } else if (a.auto_save == false) {
              // h = h;
          } else {
              console.log("20120703 unhandled auto_save value",a)
          }
          buttons[i].handler = h;
          cmenu[i].handler = h;
          if (a.keycode) {
              keyhandlers[a.keycode] = h;
          }
          //~ if (buttons[i].xtype == 'splitbutton') {
              //~ cmenu[i].menu = a.menu;
          //~ } else {
              //~ cmenu[i].handler = h;
          //~ }
      } else {
          console.log("action without panel_btn_handler",a)
          // cmenu[i].handler = a.handler;
      }
    }
    return {
        bbar:buttons, 
        cmenu:new Ext.menu.Menu(cmenu),
        keyhandlers: keyhandlers
    };
  }
}

Lino.do_when_visible = function(cmp,todo) {
  //~ if (cmp.el && cmp.el.dom) 
  if (cmp.isVisible()) { 
    // 'visible' means 'rendered and not hidden'
    //~ console.log(cmp.title,'-> cmp is visible now');
    todo(); 
  //~ } else {
      //~ cmp.on('resize',todo,cmp,{single:true});
  //~ }
  //~ if (false) { // 20120213
  } else { 
    //~ console.log('Lino.do_when_visible() must defer because not isVisible()',todo,cmp);
    if (cmp.rendered) {
      //~ console.log(cmp,'-> cmp is rendered but not visible: and now?');
      //~ console.log(cmp.title,'-> cmp is rendered but not visible: try again in a moment...');
      //~ var fn = function() {Lino.do_when_visible(cmp,todo)};
      //~ fn.defer(100);
      
      Lino.do_when_visible.defer(50,this,[cmp,todo]);
      //~ Lino.do_when_visible.defer(100,this,[cmp,todo]);
      
    } else {
      //~ console.log(cmp.title,'-> after render');
      cmp.on('afterrender',todo,cmp,{single:true});
    }
  }
  
};    

/*
*/
Lino.do_on_current_record = function(panel, fn, phantom_fn) {
  // console.log('20140930 do_on_current_record', arguments);
  var rec = panel.get_current_record();
  if (rec == undefined) {
    Lino.notify("There's no selected record.");
    return;
  }
  // 20120307 A VirtualTable with a Detail (lino.Models) has only "phantom" records.
  if (rec.phantom) {
    //~ if (!panel.editable) { console.log("20120312 not editable:",panel)}
    if (phantom_fn) {
      phantom_fn(panel);
    } else {
      Lino.notify("Action not available on phantom record.");
    }
    return;
  }
  return fn(rec);
};


Lino.call_ajax_action = function(
    panel, method, url, p, actionName, step, on_confirm, on_success) {
  p.an = actionName;
  if (!panel || !panel.isVisible()) {
  //~ if (true) { // 20131026 : workflow_actions of a newly created record detail executed but did't refresh the screen because their requesting panel was the insert (not the detail) formpanel.
      if (Lino.current_window) 
          panel = Lino.current_window.main_item;
      else panel = Lino.viewport;
  }
  // console.log("20150130 a", p.pv);
  // Ext.apply(p, panel.get_base_params());
  // console.log("20150130 b", p.pv);

  if (panel.get_selected) {
      var selected_recs = panel.get_selected();
      //~ console.log("20130831",selected_recs);
      var rs = Array(selected_recs.length);
      for(var i=0; i < selected_recs.length;i++) {
          rs[i] = selected_recs[i].data.id;
      };
      p.sr = rs;
  }
  
  // console.log("20140516 Lino.call_ajax_action", p, actionName, step);
  
  if (panel.loadMask) panel.loadMask.show(); 
    
  Ext.Ajax.request({
    method: method
    ,url: url
    ,params: p
    ,success: Lino.action_handler(panel, on_success, on_confirm)
    ,failure: Lino.ajax_error_handler(panel)
  });
};




Lino.row_action_handler = function(actionName, hm, pp) {
  var p = {};
  var fn = function(panel, btn, step) {
      // console.log('20150514 row_action_handler');
      if (pp) { p = pp(panel); if (! p) return; }
      
      if (!panel || panel.get_current_record == undefined) { // AFTER_20130725
        // console.log('20140930 row_action_handler 2', panel);
        panel = Ext.getCmp(panel);
        if (panel == undefined) {
          console.log("20160410 Invalid panel spec.", actionName, hm, pp);
          Lino.notify("Invalid panel spec.");
          return;
        }
      }
      
      Lino.do_on_current_record(panel, function(rec) {
          //~ console.log(panel);
          panel.add_param_values(p, true);
          Ext.apply(p, panel.get_base_params());
          Lino.call_ajax_action(
              panel, hm, panel.get_record_url(rec.id), 
              p, actionName, step, fn);
      });
  };
  return fn;
};

Lino.list_action_handler = function(ls_url,actionName,hm,pp) {
  var p = {};
  var url = '/api' + ls_url
  var fn = function(panel,btn,step) {
      //~ console.log("20121210 Lino.list_action_handler",arguments);
      if (pp) { p = pp(panel);  if (! p) return; }
      if (panel) { // may be undefined when called e.g. from quicklink
          panel.add_param_values(p, true);
          Ext.apply(p, panel.get_base_params());
      }
      Lino.call_ajax_action(panel, hm,url, p, actionName, step, fn);
  };
  return fn;
};

Lino.param_action_handler = function(window_action) { // 20121012
  var fn = function(panel,btn,step) {
    Lino.do_on_current_record(panel,function(rec) {
      window_action.run(panel.getId(),{}); 
    });
  };
  return fn;
};


Lino.run_row_action = function(
    requesting_panel, url, meth, pk, actionName, params, preprocessor) {
  //~ var panel = action.get_window().main_item;
  // console.log("20140930 Lino.run_row_action", params);
  url = '/api' + url  + '/' + pk;
  var panel = Ext.getCmp(requesting_panel);
  if (!params) params = {};
  if (preprocessor) {
      var p = preprocessor(); 
      Ext.apply(params, p);
  }
  if (panel) 
      Ext.apply(params, panel.get_base_params());
  var fn = function(panel, btn, step) {
    Lino.call_ajax_action(panel, meth, url, params, actionName, step, fn);
  }
  fn(panel, null, null);
}

Lino.put = function(requesting_panel, pk, data) {
    var panel = Ext.getCmp(requesting_panel);
    //~ var panel = null; // 20131026
    var p = {};
    p.an = 'put'; // SubmitDetail.action_name

    Ext.apply(p,data);
    var req = {
        params:p
        ,waitMsg: 'Saving your data...'
        ,scope: panel
        ,success: Lino.action_handler( panel, function(result) { 
            panel.refresh();
        })
        ,failure: Lino.ajax_error_handler(panel)
    };
    req.method = 'PUT';
    req.url = '/api' + panel.ls_url + '/' + pk;
    if (panel.loadMask) panel.loadMask.show(); 
    Ext.Ajax.request(req);
}



Lino.show_detail = function(panel, btn) {
  Lino.do_on_current_record(panel, 
    function(rec) {
      //~ panel.loadMask.show();
      Lino.run_detail_handler(panel, rec.id);
    },
    Lino.show_insert
  );
};

Lino.run_detail_handler = function(panel,pk) {
  var bp = panel.get_base_params();
  panel.add_param_values(bp); // 20120918
  var status = {
    record_id:pk,
    base_params:bp
  }
  //~ console.log("20120918 Lino.show_detail",status);
  panel.ls_detail_handler.run(null,status);
}

Lino.show_fk_detail = function(combo,detail_action,insert_action) {
    //~ console.log("Lino.show_fk_detail",combo,handler);
    pk = combo.getValue();
    if (pk) {
        detail_action.run(null,{record_id: pk})
      } else {
        insert_action.run(null);
        //~ Lino.notify("Cannot show detail for empty foreign key.");
      }
};

Lino.show_insert = function(panel,btn) {
  var bp = panel.get_base_params();
  //~ console.log('20120125 Lino.show_insert',bp)
  //~ panel.ls_insert_handler.run(null,{record_id:-99999,base_params:bp});
  panel.ls_insert_handler.run(panel.getId(),{base_params:bp});
};



if (Ext.ux.grid !== undefined) {
    Lino.GridFilters = Ext.extend(Ext.ux.grid.GridFilters,{
      encode:true,
      local:false
    });
} else {
    Lino.GridFilters = function() {}; // dummy
    Ext.override(Lino.GridFilters,{
      init : function() {}
    });
};



Lino.FieldBoxMixin = {
  before_init : function(config,params) {
    if (params) Ext.apply(config,params);
    var actions = Lino.build_buttons(this, config.ls_bbar_actions);
    if (actions) config.bbar = actions.bbar;
  },
  //~ constructor : function(ww,config,params){
    //~ this.containing_window = ww;
    //~ if (params) Ext.apply(config,params);
    //~ var actions = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ if (actions) config.bbar = actions.bbar;
    //~ Lino.FieldBoxMixin.superclass.constructor.call(this, config);
  //~ },
  do_when_clean : function(auto_save,todo) { todo() },
  //~ format_data : function(html) { return '<div class="htmlText">' + html + '</div>' },
  format_data : function(html) { return html },
  get_base_params : function() {
    // needed for insert action
    var p = Ext.apply({}, this.base_params);
    Lino.insert_subst_user(p);
    return p;
  },
  set_base_params : function(p) {
    this.base_params = Ext.apply({},p);
    //~ if (p.param_values) this.set_param_values(p.param_values);  
  },
  clear_base_params : function() {
      this.base_params = {};
      Lino.insert_subst_user(this.base_params);
  },
  set_base_param : function(k,v) {
    this.base_params[k] = v;
  }
};

Ext.override(Ext.form.HtmlEditor, {
    fixKeys : function(){
        if(Ext.isIE){
            return function(e){
                var k = e.getKey(),
                    doc = this.getDoc(),
                        r;
                if(k == e.TAB){
                    e.stopEvent();
                    r = doc.selection.createRange();
                    if(r){
                        r.collapse(true);
                        r.pasteHTML('&nbsp;&nbsp;&nbsp;&nbsp;');
                        this.deferFocus();
                    }
                }else if(k == e.ENTER){
                    r = doc.selection.createRange();
                    if(r){
                        var target = r.parentElement();
                        if(!target || target.tagName.toLowerCase() != 'li'){
                            e.stopEvent();
                            r.pasteHTML('<br />');
                            r.collapse(false);
                            r.select();
                        }
                    }
                }
            };
        }else if(Ext.isOpera){
            return function(e){
                var k = e.getKey();
                if(k == e.TAB){
                    e.stopEvent();
                    this.win.focus();
                    this.execCmd('InsertHTML','&nbsp;&nbsp;&nbsp;&nbsp;');
                    this.deferFocus();
                }
            };
        }else if(Ext.isWebKit){
            // HKC : this is probably our most used case.
            return function(e){
                var k = e.getKey();
                if(k == e.TAB){
                    e.stopEvent();
                    this.execCmd('InsertText','\t');
                    this.deferFocus();
                }else if(k == e.ENTER){
                    e.stopEvent();
                    this.execCmd('InsertHtml','<br /><br />');
                    this.deferFocus();
                }
             //   HKC
               else if (k == e.S && e.ctrlKey){
                    e.stopEvent();
                    e.preventDefault();
                    //this.getWin.fireEvent('keyup');
                    // this.fireKey(e);
                    console.log('HTMLEditor is saving...');
                }
             };
        }
    }(),
    // bubbleEvents : ['keypress']
    // initComponent : function() {
    //     Ext.form.HtmlEditor.superclass.initComponent.call(this);
    //     this.addEvents('submit');
    // },
    // submit : function (event) {
    //     console.log("rrrrr");
    // },
    // initEditor : function() {
    //     Ext.form.HtmlEditor.superclass.initEditor.call(this);
    //     if (Ext.isGecko) {
    //         Ext.EventManager.on(this, 'keypress', this.fireSubmit, this);
    //     }
    //     if (Ext.isIE || Ext.isWebKit || Ext.isOpera) {
    //         Ext.EventManager.on(this, 'keydown', this.fireSubmit,
    //             this);
    //     }
    // },
    fireSubmit : function(e) {
        console.log("fireSubmit ...");
    }
});


Lino.HtmlBoxPanel = Ext.extend(Ext.Panel, Lino.PanelMixin);
Lino.HtmlBoxPanel = Ext.extend(Lino.HtmlBoxPanel, Lino.FieldBoxMixin);
Lino.HtmlBoxPanel = Ext.extend(Lino.HtmlBoxPanel, {
  disabled_in_insert_window : true,
  constructor : function(config,params) {
    this.before_init(config,params);
    Lino.HtmlBoxPanel.superclass.constructor.call(this, config);
  },
  //~ constructor : function(ww,config,params){
    //~ this.ww = ww;
    //~ if (params) Ext.apply(config,params);
    //~ var actions = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ if (actions) config.bbar = actions.bbar;
    //~ Lino.FieldBoxMixin.constructor.call(this, ww,config,params);
  //~ },
  //~ constructor : function(ww,config,params){
    //~ this.ww = ww;
    //~ if (params) Ext.apply(config,params);
    //~ var actions = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ if (actions) config.bbar = actions.bbar;
    //~ Lino.FieldBoxMixin.superclass.constructor.call(this, config);
  //~ },
  //~ disable : function() { var tb = this.getBottomToolbar(); if(tb) tb.disable()},
  //~ enable : function() { var tb = this.getBottomToolbar(); if(tb) tb.enable()},
  onRender : function(ct, position){
    Lino.HtmlBoxPanel.superclass.onRender.call(this, ct, position);
    //~ console.log(20111125,this.containing_window);
    if (this.containing_panel) {
      this.containing_panel.on('enable',this.enable,this);
      this.containing_panel.on('disable',this.disable,this);
    }
    this.el.on({
      dragenter:function(event){
        event.browserEvent.dataTransfer.dropEffect = 'move';
        return true;
      }
      ,dragover:function(event){
        event.browserEvent.dataTransfer.dropEffect = 'move';
        event.stopEvent();
        return true;
      }
      ,drop:{
        scope:this
        ,fn:function(event){
          event.stopEvent();
          //~ console.log(20110516);
          var files = event.browserEvent.dataTransfer.files;
          if(files === undefined){
            return true;
          }
          var len = files.length;
          while(--len >= 0){
            console.log(files[len]);
            //~ this.processDragAndDropFileUpload(files[len]);
          }
          Lino.show_insert(this);
        }
      }
    });
  },
  refresh : function(unused) { 
      // this.containing_panel.refresh();
      this.refresh_with_after();
  },
  /* HtmlBoxPanel */
  refresh_with_after : function(after) {
      // var todo = this.containing_panel.refresh();
      var box = this.items.get(0);
      var todo = function() {
        if (this.disabled) { return; }
        this.set_base_params(this.containing_panel.get_master_params());

        var el = box.getEl();
        if (el) {
            var record = this.containing_panel.get_current_record();
            var newcontent = record ? 
                this.format_data(record.data[this.name]) : '';
            // console.log('20140917 HtmlBox.refresh()',
            //             this.name, record.data.LinksByHuman);
            el.update(newcontent, true);
        // } else {
        //     console.log('20140502 cannot HtmlBox.refresh()',this.name);
        }
      };

      Lino.do_when_visible(box, todo.createDelegate(this));
  }
});
//~ Ext.override(Lino.HtmlBoxPanel,Lino.FieldBoxMixin);


Lino.ActionFormPanel = Ext.extend(Ext.form.FormPanel,Lino.MainPanel);
Lino.ActionFormPanel = Ext.extend(Lino.ActionFormPanel, Lino.PanelMixin);
Lino.ActionFormPanel = Ext.extend(Lino.ActionFormPanel, Lino.FieldBoxMixin);
Lino.ActionFormPanel = Ext.extend(Lino.ActionFormPanel, {
  //~ layout:'fit'
  //~ ,autoHeight: true
  //~ ,frame: true
  window_title : "Action Parameters",
  constructor : function(config){
    config.bbar = [
        {text: 'OK', handler: this.on_ok, scope: this},
        {text: 'Cancel', handler: this.on_cancel, scope: this}
    ];
    Lino.ActionFormPanel.superclass.constructor.call(this, config);
  }
  //~ ,initComponent : function(){
    //~ Lino.ActionFormPanel.superclass.initComponent.call(this);
  //~ }
  ,on_cancel : function() { 
    this.get_containing_window().close();
  }
  ,on_ok : function() { 
    var panel = this.requesting_panel;
    // var panel = this.get_containing_window().main_item;
    // console.log("20131004 on_ok",this,panel,arguments);
    var actionName = this.action_name;
    var pk = this.record_id || this.default_record_id;
    if (pk == undefined && this.base_params) { pk = this.base_params.mk; }
    if (pk == undefined && panel) {
        pk = panel.get_current_record().id;
    }
    if (pk == undefined) {
        // 20170101 VerifyUser action
        pk = '-99998';
        // Lino.alert("Sorry, dialog action without base_params.mk");
        // return;
    }
    var self = this;
    // function on_success() { self.get_containing_window().close(); };
    // see 20131004 and 20140430
    var url = '/api';

    // 20150119 : The OK button on AgentsByClient.create_visit went to
    // /api/pcsw/Clients/ instead of /api/pcsw/Coachings/
    // if (panel) 
    //     url += panel.ls_url;
    // else 
    //     url += this.ls_url;

    if (this.ls_url) 
        url += this.ls_url;
    else 
        url += panel.ls_url;
    url += '/' + pk;
    // wrap into function to prepare possible recursive call
    var fn = function(panel, btn, step) {
      var p = {};
      self.add_field_values(p)
      if (panel) Ext.apply(p, panel.get_base_params());
      delete p.pv;
      // console.log("20150130", p.pv);

      Lino.call_ajax_action(
          panel, 'GET', url, p, actionName, step, fn); //  , on_success);
    }
    fn(panel, null, null);
    
    
  }
  /* ActionFormPanel*/
  ,set_status : function(status, rp){
    this.requesting_panel = Ext.getCmp(rp);
    //~ console.log('20120918 ActionFormPanel.set_status()',status,rp,this.requesting_panel);
    this.clear_base_params();
    if (status == undefined) status = {};
    //~ if (status.param_values) 
    this.set_field_values(status.field_values);
    if (status.base_params) this.set_base_params(status.base_params);
    this.record_id = status.record_id;
  }
  
  ,before_row_edit : function(record) {}
  ,add_field_values : function (p) { // similar to add_param_values()
      /* LS 20160517 : Until now Lino tested whether the form is
       dirty, and if not, submitted only the values which had been set
       by set_status. But now status_field_values can be empty because
       Action.keep_user_values is True. In that case we must submit
       the current values even if the form is not dirty.  I don't
       remember why we had this feature of not submitting unmodified
       field values, so I remove this feature for now. */
      p.fv = this.get_field_values();
      // if (this.form.isDirty()) {
      //   p.fv = this.get_field_values();
      // }else{
      //   // console.log("20160517 add_param_values not dirty, status_field_values",
      //   //             this.status_field_values);
      //   if (this.status_field_values) 
      //     p.fv = Lino.fields2array(
      //         this.fields, this.status_field_values);
      // }
      //~ console.log("20120203 add_param_values added pv",pv,"to",p);
  }
  ,get_field_values : function() {
      return Lino.fields2array(this.fields);
  }
  ,set_field_values : function(pv) {
      // console.log('20160516 MainPanel.set_param_values', pv);
      // if Action.keep_user_values, we receive an empty dict ({})
      this.status_field_values = pv;
      if (pv) {
          this.form.my_loadRecord(pv);
          var record = { data: pv };
          this.before_row_edit(record);
      } else {
          this.form.reset(); 
          this.before_row_edit();
      }
  }
  ,config_containing_window : function(wincfg) { 
      wincfg.title = this.window_title;
      wincfg.keys = [
        { key: Ext.EventObject.ENTER, fn: this.on_ok }
      ]
      
      if (!wincfg.defaultButton) this.getForm().items.each(function(f){
          if(f.isFormField){ 
              wincfg.defaultButton = f;
              return false;
          }
      });

  }
});

    
Lino.fields2array = function(fields, values) {
    // console.log('20160517 fields2array gonna loop on', fields, values);
    var pv = Array(fields.length);
    for(var i=0; i < fields.length;i++) {
        var f = fields[i]
        if (values) 
          var v = values[f.name];
        else 
          var v = f.getValue();
        if (f.formatDate) {
            pv[i] = f.formatDate(v); 
        } else {
            pv[i] = v; // f.getValue(); 
        }
    }
    // console.log('20160517 fields2array returns', pv);
    return pv;
}


Lino.FormPanel = Ext.extend(Ext.form.FormPanel,Lino.MainPanel);
Lino.FormPanel = Ext.extend(Lino.FormPanel,Lino.PanelMixin);
Lino.FormPanel = Ext.extend(Lino.FormPanel,{
  params_panel_hidden : false,
  save_action_name : null, 
  //~ base_params : {},
  //~ trackResetOnLoad : true,
  //~ query_params : {},
  //~ 20110119b quick_search_text : '',
  constructor : function(config,params){
    if (params) Ext.apply(config,params);
    this.base_params = {};
    //~ ww.config.base_params.query = ''; // 20111018
    //~ console.log(config);
    //~ console.log('FormPanel.constructor() 1',config)
    //~ Ext.applyIf(config,{base_params:{}});
    //~ console.log('FormPanel.constructor() 2',config)
      
    config.trackResetOnLoad = true;
    
    Lino.FormPanel.superclass.constructor.call(this, config);
      
    //~ this.set_base_param('$URL_PARAM_FILTER',null); // 20111018
    //~ this.set_base_param('$URL_PARAM_FILTER',''); // 20111018
      
  },
  initComponent : function(){
    
    this.containing_panel = this;

    //~ console.log("20111201 containing_window",this.containing_window,this);


    var actions = Lino.build_buttons(this, this.ls_bbar_actions);
    if (actions) {
        this.bbar = actions.bbar;
        // console.log("20160829 tooltip", actions.bbar);
    //~ } else {
        //~ this.bbar = [];
    }
    //~ Ext.apply(config,Lino.build_buttons(this,config.ls_bbar_actions));
    //~ config.bbar = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ var config = this;
    
    //~ if (this.containing_window instanceof Lino.DetailWrapper) {
    
    //~ console.log('20120121 initComponent', this.action_name);
    //~ if (this.action_name == 'detail' | this.action_name == 'show') {
    //~ if (this.action_name != 'insert') {
    if (! this.hide_top_toolbar) {
      this.tbar = [];
      // 20111015    
      if (! this.hide_navigator) {
        this.record_selector = new Lino.RemoteComboFieldElement({
          store: new Lino.ComplexRemoteComboStore({
            //~ baseParams: this.containing_window.config.base_params,
            baseParams: this.get_base_params(),
            //~ value: this.containing_window.config.base_params.query,
            proxy: new Ext.data.HttpProxy({
              url: '/choices' + this.ls_url,
              method:'GET'
            })
          }),
          pageSize:25,
          listeners: { 
            scope:this, 
            select:function(combo,record,index) {
              //~ console.log('jumpto_select',arguments);
              this.goto_record_id(record.id);
            }
          },
          emptyText: "Go to record"
        })
        this.tbar = this.tbar.concat([this.record_selector]);
        
        this.tbar = this.tbar.concat([
          this.first = new Ext.Toolbar.Button({
              tooltip:"First",disabled:true,
              handler:this.moveFirst,scope:this,iconCls:'x-tbar-page-first'}),
          this.prev = new Ext.Toolbar.Button({
              tooltip:"Previous",disabled:true,
              handler:this.movePrev,scope:this,iconCls:'x-tbar-page-prev'}),
          this.next = new Ext.Toolbar.Button({
              tooltip:"Next",disabled:true,
              handler:this.moveNext,scope:this,iconCls:'x-tbar-page-next'}),
          this.last = new Ext.Toolbar.Button({
              tooltip:"Last",disabled:true,
              handler:this.moveLast,scope:this,iconCls:'x-tbar-page-last'})
        ]);
      }
      this.tbar = this.add_params_panel(this.tbar);
      
      //~ console.log(20101117,this.containing_window.refresh);
      this.tbar = this.tbar.concat([
        {
          //~ text:'Refresh',
          handler:function(){ this.do_when_clean(false,this.refresh.createDelegate(this)) },
          iconCls: 'x-tbar-loading',
          tooltip:"Reload current record",
          scope:this}
      ]);
          
      if (this.bbar) { // since 20121016
        if (this.tbar) {
            this.tbar = this.tbar.concat(['-']) ;
        } else {
          this.tbar = [];
        }
        this.tbar = this.tbar.concat(this.bbar) ;
        this.bbar = undefined;
      }
    
      this.tbar = this.tbar.concat([
          '->',
          this.displayItem = new Ext.Toolbar.TextItem({})
      ]);
          
    }
    //~ if (this.content_type && this.action_name != 'insert') {
      //~ this.bbar = this.bbar.concat([
        //~ '->',
        //~ { text: "[$_('Help Text Editor')]",
          //~ handler: Lino.help_text_editor,
          //~ qtip: "$_('Edit help texts for fields on this model.')",
          //~ scope: this}
      //~ ])
    //~ }
    //~ this.before_row_edit = config.before_row_edit.createDelegate(this);
      
    //~ if (this.master_panel) {
        //~ this.set_base_params(this.master_panel.get_master_params());
    //~ }
      
    Lino.FormPanel.superclass.initComponent.call(this);

    // this.on('show',
    //         function(){ this.init_focus();}, 
    //         this);
    
    this.on('render',function(){
      this.loadMask = new Ext.LoadMask(this.bwrap,{msg:"Please wait..."});
    },this);
    
    
    if (this.action_name == 'insert') {
      this.cascade(function(cmp){
        if (cmp.disabled_in_insert_window) {
            // console.log('20110613 disabled_in_insert_window', cmp);
            //~ cmp.disable();
            cmp.hide();
        }
      });
      
    }
    
  },
  
  unused_init_focus : function(){ 
    // set focus to the first field
    console.log("20140205 Lino.FormPanel.init_focus");
    // Lino.FormPanel.superclass.focus.call(this);
    this.getForm().items.each(function(f){
        if(f.isFormField && f.rendered){ 
            f.focus();
            console.log("20140205 focus", f);
            return false;
        }
    });
  },

  /* FormPanel */
  get_status : function(){
      var st = {
        base_params: this.get_base_params(),
        // data_record : this.get_current_record()
      }
      var rec = this.get_current_record();
      if (rec) st.record_id = rec.id;
      // 20140917 : get_status must not store the whole data_record
      // because that would prevent the form to actually reload
      // when set_status is called after a child window closed.
      
      var tp = this.items.get(0);
      if (tp instanceof Ext.TabPanel) {
        st.active_tab = tp.getActiveTab();
      }
      st.param_values = this.status_param_values;
      return st;
  },

  /* FormPanel */
  set_status : function(status, rp){
    this.requesting_panel = Ext.getCmp(rp);
    // console.log('20140917 FormPanel.set_status()', status);
    this.clear_base_params();
    if (status == undefined) status = {};
    //~ if (status.param_values) 
    this.set_param_values(status.param_values);
    if (status.base_params) this.set_base_params(status.base_params);
    var tp = this.items.get(0);
    if (tp instanceof Ext.TabPanel) {
      if (status.active_tab) {
        //~ console.log('20111201 active_tab',this.active_tab,this.items.get(0));
        //~ tp.activeTab = status.active_tab;
        tp.setActiveTab(status.active_tab);
        //~ this.main_item.items.get(0).activate(status.active_tab);
      } else {
        if (! status.data_record) {  // 20141206
            tp.setActiveTab(0);
        }
      }
    }
    
    if (status.data_record) {
      /* defer because set_window_title() didn't work otherwise */
      // 20140421 removed defer for bughunting to simplify side effects
      // this.set_current_record.createDelegate(
      //     this, [status.data_record]).defer(100);
      this.set_current_record(status.data_record);
      //~ return;
    } else {
        var record_id = status.record_id || this.default_record_id;
        if (record_id != undefined) { 
          /* possible values include 0 and null, 0 being a valid record id, 
          null the equivalent of undefined
          */
          this.load_record_id(record_id);
        } else {
            this.set_current_record(undefined);
        }
    }
    // this.init_focus()
  }
  ,get_base_params : function() {  /* FormPanel */
    // needed for insert_action
    var p = Ext.apply({}, this.base_params);
    Lino.insert_subst_user(p);
    return p;
  }
  ,set_base_params : function(p) {
    //~ this.base_params = Ext.apply({},this.base_params); // make sure it is an instance variable
    delete p['query'] // 20120725
    Ext.apply(this.base_params,p);
    if (this.record_selector) {
        var store = this.record_selector.getStore();
        for (k in p) store.setBaseParam(k,p[k]);
        delete this.record_selector.lastQuery;
        //~ console.log("20120725 record_selector.setBaseParam",p)
    }
  }
  ,clear_base_params : function() {
      this.base_params = {};
      Lino.insert_subst_user(this.base_params);
  }
  ,set_base_param : function(k,v) {
    this.base_params[k] = v;
  }
  ,after_delete : function() {
    if (this.current_record.navinfo.next)
      this.moveNext();
    else if (this.current_record.navinfo.prev)
      this.movePrev();
    else 
      this.abandon();
  }
  ,moveFirst : function() {this.goto_record_id(
      this.current_record.navinfo.first)}
  ,movePrev : function() {this.goto_record_id(
      this.current_record.navinfo.prev)}
  ,moveNext : function() {this.goto_record_id(
      this.current_record.navinfo.next)}
  ,moveLast : function() {this.goto_record_id(
      this.current_record.navinfo.last)}
  
  ,refresh : function(unused) { 
      this.refresh_with_after();
  }
  /* FormPanel */
  ,refresh_with_after : function(after) { 
    // console.log('20140917 Lino.FormPanel.refresh_with_after()',this);
    if (this.current_record) {
        this.load_record_id(this.current_record.id, after);
    } else {
        this.set_current_record(undefined, after);
    }
  }
  
  ,do_when_clean : function(auto_save, todo) {
    var this_ = this;
    if (this.form.isDirty()) {
        // console.log('20140421 do_when_clean : form is dirty')
        if (auto_save) {
            this_.save(todo);
        } else {
          //~ console.log('20111217 do_when_clean() form is dirty',this.form);
          var config = {title:"Confirmation"};
          config.buttons = Ext.MessageBox.YESNOCANCEL;
          config.msg = "Save changes to current record ?";
          config.fn = function(buttonId,text,opt) {
            //~ console.log('do_when_clean',buttonId)
            if (buttonId == "yes") {
                //~ Lino.submit_detail(this_,undefined,todo);
                //~ this_.containing_window.save(todo);
                this_.save(todo);
            } else if (buttonId == "no") { 
              todo();
            }
          }
          Ext.MessageBox.show(config);
        }
    }else{
      // console.log('20140421 do_when_clean : now!')
      todo();
    }
  }
  
  ,goto_record_id : function(record_id) {
    // console.log('20140917 Lino.FormPanel.goto_record_id()',record_id);
    //~ var this_ = this;
    //~ this.do_when_clean(function() { this_.load_record_id(record_id) }
    this.do_when_clean(
        true, this.load_record_id.createDelegate(this, [record_id]));
  }
  
  ,load_record_id : function(record_id, after) {
    var this_ = this;
    var p = Ext.apply({}, this.get_base_params());
    if (this.action_name)
        p.an = this.action_name;
    p.rp = this.getId();
    p.fmt = 'json';
    this.add_param_values(p);
    if (this.loadMask) this.loadMask.show();
    Ext.Ajax.request({ 
      waitMsg: 'Loading record...',
      method: 'GET',
      params: p,
      scope: this,
      url: this.get_record_url(record_id),
      success: function(response) {   
        // todo: convert to Lino.action_handler.... but result 
        if (this.loadMask) this.loadMask.hide();
        if (response.responseText) {
          var rec = Ext.decode(response.responseText);
          // console.log('20150905 load_record_id success', rec);
          this.set_param_values(rec.param_values);
          this.set_current_record(rec, after);
        }
      },
      failure: Lino.ajax_error_handler(this)
    });
  }

  ,abandon : function () {
    Ext.MessageBox.alert('Note',
      "No more records to display. Detail window has been closed.");
    Lino.close_window();
  }
  
  ,set_current_record : function(record, after) {
    // console.log('20160825 set_current_record', record);
    if (this.record_selector) {
        this.record_selector.clearValue();
        // e.g. InsertWrapper FormPanel doesn't have a record_selector
    }
    this.current_record = record;
    if (record && record.data) {
      this.enable();
      this.form.my_loadRecord(record.data);
      this.set_window_title(record.title);
      //~ this.getBottomToolbar().enable();
      var da = record.data.disabled_actions;
      if (da) {
          //~ console.log('20120528 disabled_actions =',da,this.getBottomToolbar());
          //~ 20121016 this.getBottomToolbar().items.each(function(item,index,length){
          if(this.hide_top_toolbar) {
              var tb = this.getBottomToolbar();
          } else {
              var tb = this.getTopToolbar();
          }
          if (tb) tb.items.each(function(item,index,length){
              //~ console.log('20120528 ',item.itemId,'-->',da[item.itemId]);
              if (da[item.itemId]) item.disable(); else item.enable();
          });
      };
      if (this.disable_editing | record.data.disable_editing) {
          //~ console.log("20120202 disable_editing",record.title);
          this.form.items.each(function(cmp){
            if (!cmp.always_enabled) cmp.disable();
          },this);
      } else {
          this.form.items.each(function(cmp){
            //~ console.log("20120202",cmp);
            if (record.data.disabled_fields[cmp.name]) cmp.disable();
            else cmp.enable();
          },this);
        
          //~ if (record.data.disabled_fields) {
              //~ for (i = 0; i < record.data.disabled_fields.length; i++) {
                  //~ var flds = this.find('name',record.data.disabled_fields[i]);
                  //~ if (flds.length == 1) { 
                    //~ flds[0].disable(); 
                  //~ }
              //~ }
          //~ }
      };
      if (this.first) {
        if (record.navinfo  && ! this.hide_navigator) {
          this.first.setDisabled(!record.navinfo.first);
          this.prev.setDisabled(!record.navinfo.prev);
          this.next.setDisabled(!record.navinfo.next);
          this.last.setDisabled(!record.navinfo.last);
          this.displayItem.setText(record.navinfo.message);
        } else {
          this.first.setDisabled(true);
          this.prev.setDisabled(true);
          this.next.setDisabled(true);
          this.last.setDisabled(true);
        }
      }
    } else {
      if (this.form.rendered) 
        this.form.reset(); /* FileUploadField would fail when resetting a non-rendered form */
      //~ this.disable();
      //~ this.getBottomToolbar().disable();
      this.form.items.each(function(cmp){
        cmp.disable();
      },this);
      this.set_window_title(this.empty_title);
      //~ this.containing_window.window.setTitle(this.empty_title);
      if (!this.hide_navigator) {
        this.first.disable();
        this.prev.disable();
        this.next.disable();
        this.last.disable();
      }
    }
    // console.log('20140917 gonna call before_row_edit', record);
        var current_focus_fields = false;
        for (var i = 0; i < this.form.items.items.length;i++) {
            if (this.form.items.items[i].hasFocus) current_focus_fields = i;
        }
    this.before_row_edit(record);
        if (current_focus_fields != false){
            this.form.items.items[current_focus_fields].focus();
        }
    // console.log('20140917 gonna call after', after);
    if (after) after();
  },
  
  /* FormPanel */
  before_row_edit : function(record) {},
  search_change : function(field,oldValue,newValue) {
    //~ console.log('search_change',field.getValue(),oldValue,newValue)
    this.set_base_param('query',field.getValue()); 
    this.refresh();
  },
  
  get_selected : function() { return [ this.current_record ] },
  get_current_record : function() {  
    //~ console.log(20100714,this.current_record);
    return this.current_record 
  },
  
  get_permalink_url : function() {
      var rec = this.get_current_record();
      if (rec && ! rec.phantom && rec.id != -99998)
          return '/api' 
              + this.ls_url + '/' + rec.id;
      return '/api' + this.ls_url;
    
  },
  add_param_tab : function(p) {
    var main = this.items.get(0);
    if (main.activeTab) {
      var tab = main.items.indexOf(main.activeTab);
      // console.log('20150130 main.activeTab', tab, main.activeTab);
      if (tab) p.tab = tab;
    // } else {
    //   console.log('20150130 no main.activeTab');
    }
  },
  get_permalink_params : function() {
    var p = {};
    //~ var p = {an:'detail'};
    if (this.action_name)
        p.an = this.action_name;
    this.add_param_tab(p)
    this.add_param_values(p)
    return p;
  }
  
  ,validate_form : function() {  // not used. see actions.ValidateForm
      // var ov = {};
      // this.form.items.each(function(f){
      //     ov[f.name] = f.originalValue
      // });

      // console.log('20140509 FormPanel.validate_form', ov);
      // var after = function() { 
      //     this.form.items.each(function(f){
      //         f.originalValue = ov[f.name];
      //     });
      // }
      // this.save2(null, 'validate', after);
      this.save2(null, 'validate');
  }

  /* Lino.FormPanel */
  ,save : function(after) {
    var action_name = this.save_action_name;
    if (!action_name) 
        action_name = this.action_name;
    // console.log('20140503 FormPanel.save', action_name);
    this.save2(after, action_name);
  }

  ,save2 : function(after, action_name) {
    var rec = this.get_current_record();
    if (!rec) { 
        Lino.notify("Sorry, no current record."); 
        return; 
    }
    var panel = this;
    if (this.has_file_upload) this.form.fileUpload = true;
    this.loadMask.show();
    var p = {};
    Ext.apply(p, this.get_base_params());
    p.rp = this.getId();
    p.an = action_name;
    this.add_param_tab(p)
    // console.log('20150216 FormPanel.save()', rec, this.form);
    var submit_config = {
        params: p, 
        scope: this,
        success: function(form, action) {
          this.loadMask.hide();
          Lino.notify(action.result.message);
          Lino.handle_action_result(this, action.result, after);
        },
        failure: function(form,action) { 
          this.loadMask.hide();
          Lino.on_submit_failure(form, action);
        },
        clientValidation: true
    };
    if (rec.phantom) {  // it's a new record
      Ext.apply(submit_config, {
        url: '/api' + this.ls_url,
        method: 'POST'
      });
      // panel.refresh();
      // temporarily disabled. See 20151002
    } else {  // submit on existing row
      Ext.apply(submit_config, {
        url: '/api' 
              + this.ls_url + '/' + rec.id,
        method: 'PUT'
      })
    }
    this.form.submit(submit_config);
  }
  
  ,on_cancel : function() { 
    this.get_containing_window().close();
  }
  ,on_ok : function() { 
      // console.log("20140424");
      // this.save(null, true, this.save_action_name);
      this.save();
  }
  ,config_containing_window : function(wincfg) { 

      // Note that defaultButton means: which component should receive
      // focus when Window is focussed.  If no defaultButton set,
      // specify the first form field.

      if (!wincfg.defaultButton) this.getForm().items.each(function(f){
          if(f.isFormField){ 
              wincfg.defaultButton = f;
              // console.log("20140205 defaultButton", f);
              return false;
          }
      });

      wincfg.keys = [];

      wincfg.keys.push({
          key: Ext.EventObject.ESCAPE, 
          handler: this.on_cancel, scope:this });
      wincfg.keys.push({
          key: 's', ctrl: true, 
             stopEvent: true, handler: this.on_ok, scope:this });
  }

});



Lino.getRowClass = function(record, rowIndex, rowParams, store) {
    //~ console.log(20130816,record);
    //~ return 'x-grid3-row-green';
    //~ return record.data.row_class + ' auto-height';
    return record.data.row_class;
  //~ if (true) {
      //~ return 'x-grid3-row-red';
  //~ }
  //~ if (record.phantom) {
    //~ console.log(20101009,record);
    //~ rowParams.bodyStyle = "color:red;background-color:blue";
    //~ return 'lino-phantom-row';
    //~ }
  //~ console.log('20101009 not a phantom:',record);
  //~ return '';
}

//~ FOO = 0;



Lino.GridStore = Ext.extend(Ext.data.ArrayStore,{ 
  autoLoad: false
  ,load: function(options) {
    //~ foo.bar = baz; // 20120213
    if (!options) options = {};
    if (!options.params) options.params = {};
    options.params.fmt = 'json';
    options.params.rp = this.grid_panel.getId();
    Lino.insert_subst_user(options.params); // since 20121016
      
    var start = this.grid_panel.start_at_bottom ? -1 : 0;
    if (this.grid_panel.hide_top_toolbar) {
        //~ console.log("20120206 GridStore.load() toolbar is hidden");
        options.params.start = start;
        if (this.grid_panel.preview_limit) {
          options.params.limit = this.grid_panel.preview_limit;
        }
    } else {
        var ps = this.grid_panel.calculatePageSize();
        if (!ps) {
          // console.log("GridStore.load() failed to calculate pagesize");
          return false;
        } 
        options.params.limit = ps;
      
        this.grid_panel.getTopToolbar().pageSize =  ps;
        if (options.params.start == undefined)
            // if (start != -1) 
            //     start = this.grid_panel.getTopToolbar().cursor
            options.params.start = start;
      
        // console.log("20141108 GridStore.load() ", options.params);
    }
      
    this.grid_panel.add_param_values(options.params);
    //~ Lino.insert_subst_user(options.params);
    //~ console.log("20120814 GridStore.load()",options.params,this.baseParams);
    return Lino.GridStore.superclass.load.call(this, options);
  }
  // ,insert : function(index, records) {
  //   return Ext.data.Store.prototype.insert.call(this, index, records)
    // return Lino.GridStore.superclass.insert.call(this, index, records);
  // }
});

Lino.get_current_grid_config = function(panel) {
    return panel.get_current_grid_config();
}


// Like the default value for GridView.cellTpl but adds a class "lino-auto-height"
Lino.auto_height_cell_template = new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
    '<div class="lino-auto-height x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" {attr}>{value}</div>',
'</td>'
);

Lino.GridPanel = Ext.extend(Ext.grid.EditorGridPanel, Lino.MainPanel);
Lino.GridPanel = Ext.extend(Lino.GridPanel, Lino.PanelMixin);
Lino.GridPanel = Ext.extend(Lino.GridPanel, {
  quick_search_text : '',
  start_at_bottom : false,
  is_searching : false,
  disabled_in_insert_window : true,
  clicksToEdit:2,
  enableColLock: false,
  autoHeight: false,
  params_panel_hidden : false,
  preview_limit : undefined, 
  // fake_row_content: '<br>',
  row_height: 1,
  //~ loadMask: true,
  //~ viewConfig: {
          //~ getRowClass: Lino.getRowClass,
          //~ emptyText:"$_('No data to display.')"
        //~ },
        
        
  loadMask: {msg:"Please wait..."},
  
  constructor : function(config){

    config.plugins = [new Lino.GridFilters()];
    
    
    Lino.GridPanel.superclass.constructor.call(this,config);
    
    //~ if (this.containing_window) {
        //~ console.log("20111206 install refresh");
        //~ this.containing_window.on('show',this.refresh,this);
    //~ }
    
  },
  
  init_containing_window : function(win) { 
    //~ console.log("20111206 install refresh");
    //~ win.on('show',this.refresh,this);
  }

  ,handle_key_event : function(e) {
    // console.log("20140514 handle_key_event", e, this.keyhandlers);
    var h = this.keyhandlers[e.keyCode];
    if (h) {
        h(this);
        e.stopEvent();
    }
  }
  
  ,initComponent : function(){
    
    /* 
    Problem 20111206:
    When a GridPanel is the main item of the window, then it doesn't 
    have it's own header but uses the window's header bar.
    We must do this in initComponent because e.g. in beforerender 
    it's already to late: a header element has been created because 
    there was a title.
    But Lino.Window adds itself as `this.containing_window` 
    only after the GridPanel has been initialized.
    Workaround is to generate a line "params.containing_window = true;" 
    in the handler function.
    */ 
    if (this.is_main_window) {
        //~ console.log(20111206, 'delete title',this.title,'from',this);
        this.tools = undefined;  
        this.title = undefined;  /* simply deleting it 
          isn't enough because that would only 
          unhide the title defined in some base class. */
    } 
    //~ else console.log(20111206, 'dont delete title',this.title,'from',this);
    
    /* e.g. when slave gridwindow called from a permalink */
    //~ if (this.base_params) Ext.apply(bp,this.base_params);  
    
    var proxy = new Ext.data.HttpProxy({ 
      // 20120814 
      url: '/api' + this.ls_url
      ,method: "GET"
      //~ ,url: ADMIN_URL + '/restful' + this.ls_url
      //~ ,restful: true 
      //~ ,listeners: {load:on_proxy_load} 
      //~ ,listeners: {write:on_proxy_write} 
    });
    //~ config.store = new Ext.data.JsonStore({ 
    //~ this.store = new Ext.data.ArrayStore({ 
    this.store = new Lino.GridStore({ 
      grid_panel: this
      ,listeners: { exception: Lino.on_store_exception }
      ,remoteSort: true
      ,totalProperty: "count"
      ,root: "rows"
      //~ ,id: "id" 
      ,proxy: proxy
      //~ autoLoad: this.containing_window ? true : false
      ,idIndex: this.pk_index
      //~ ,baseParams: bp
      ,fields: this.ls_store_fields
      ,idProperty: this.ls_id_property 
      // 20120814
      //~ ,writer : new Ext.data.JsonWriter({
        //~ writeAllFields: false
        //~ ,listful: true
      //~ })
      //~ ,restful : true
    });
      
    //~ console.log('config.pk_index',config.pk_index,config.store),
    delete this.ls_store_fields;
      
    var this_ = this;
    //~ var grid = this;
    this.store.on('load', function() {
        //~ console.log('20120814 GridStore.on(load)',this_.store);
        this_.set_param_values(this_.store.reader.arrayData.param_values);
        //~ this_.set_status(this_.store.reader.arrayData.status);
        //~ 20120918
        this.getView().getRowClass = Lino.getRowClass;
        
        if (this_.store.reader.arrayData.no_data_text) {
            //~ this.viewConfig.emptyText = this_.store.reader.arrayData.no_data_text;
            this.getView().emptyText = this_.store.reader.arrayData.no_data_text;
            this.getView().refresh();
        }
        if (this_.containing_window)
            this_.set_window_title(this_.store.reader.arrayData.title);
            //~ this_.containing_window.setTitle(this_.store.reader.arrayData.title);
        if (!this.is_searching) { // disabled 20121025: quick_search_field may not lose focus
          this.is_searching = false;
          if (this_.selModel.getSelectedCell){
              if (this_.getStore().getCount()) // there may be no data
                  this_.selModel.select(0,0); 
          } else {
              this_.selModel.selectFirstRow();
              this_.getView().focusEl.focus();
          }
        } 
        //~ else console.log("is_searching -> no focussing");
        //~ var t = this.getTopToolbar();
        //~ var activePage = Math.ceil((t.cursor + t.pageSize) / t.pageSize);
        //~ this.quick_search_field.focus(); // 20121024
      }, this
    );
    var actions = Lino.build_buttons(this, this.ls_bbar_actions);
    //~ Ext.apply(config,Lino.build_buttons(this,config.ls_bbar_actions));
    //~ config.bbar, this.cmenu = Lino.build_buttons(this,config.ls_bbar_actions);
    //~ this.cmenu = new Ext.menu.Menu({items: config.bbar});
    delete this.ls_bbar_actions
    if (actions) {
        this.cmenu = actions.cmenu;
        this.keyhandlers = actions.keyhandlers;
    }
    
    if (!this.hide_top_toolbar) {  
      var tbar = [ 
        this.quick_search_field = new Ext.form.TextField({ 
          //~ fieldLabel: "Search"
          listeners: { 
            scope:this_
            //~ ,change:this_.search_change
            
            ,render: Lino.quicktip_renderer("Quick Search","Enter a text to use as quick search filter")
            
            //~ ,keypress: this.search_keypress 
            ,blur: function() { this.is_searching = false}
          }
          ,validator:function(value) { return this_.search_validate(value) }
          //~ ,tooltip: "Enter a quick search text, then press TAB"
          //~ value: text
          //~ scope:this, 
          //~ ,enableKeyEvents: true
          //~ listeners: { keypress: this.search_keypress }, 
          //~ id: "seachString" 
      })];
      tbar = this.add_params_panel(tbar);
      var menu = [];
      var set_gc = function(index) {
        return function() {
          //~ console.log('set_gc() 20100812');
          this.getColumnModel().setConfig(
              this.apply_grid_config(index,this.ls_grid_configs,this.ls_columns));
        }
      }
      for (var i = 0; i < this.ls_grid_configs.length;i++) {
        var gc = this.ls_grid_configs[i];
        menu.push({text:gc.label,handler:set_gc(i),scope:this})
      }
      if(menu.length > 1) {
        tbar = tbar.concat([
          { text:"View",
            menu: menu,
            tooltip:"Select another view of this report"
          }
        ]);
      }
      
      if (actions) {
        tbar = tbar.concat(actions.bbar);
          //~ this.bbar = actions.bbar;
      }
      
      this.tbar = new Ext.PagingToolbar({ 
        store: this.store, 
        prependButtons: true, 
        //~ pageSize: this.page_length, 
        pageSize: 1, 
        displayInfo: true, 
        beforePageText: "Page",
        afterPageText: "of {0}",
        displayMsg: "Displaying {0} - {1} of {2}",
        firstText: "First page",
        lastText: "Last page",
        prevText: "Previous page",
        nextText: "Next page",
        items: tbar
      });
    }
      
    if (this.cell_edit) {
      this.selModel = new Ext.grid.CellSelectionModel()
      this.get_selected = function() {
        //~ console.log(this.getSelectionModel().selection);
        if (this.selModel.selection)
            return [ this.selModel.selection.record ];
        return [this.store.getAt(0)];
      };
      this.get_current_record = function() { 
        if (this.getSelectionModel().selection) 
          return this.selModel.selection.record;
        return this.store.getAt(0);
      };
    } else { 
      this.selModel = new Ext.grid.RowSelectionModel() 
      this.get_selected = function() {
        var sels = this.selModel.getSelections();
        if (sels.length == 0) sels = [this.store.getAt(0)];
        return sels
      };
      this.get_current_record = function() { 
        var rec = this.selModel.getSelected();
        if (rec == undefined) rec = this.store.getAt(0);
        return rec
      };
    };
    this.columns  = this.apply_grid_config(this.gc_name,this.ls_grid_configs,this.ls_columns);
    
    Lino.GridPanel.superclass.initComponent.call(this);
    
    this.on('resize', function(){
      //~ console.log("20120213 resize",arguments)
      this.refresh();
      },this);
    this.on('viewready', function(){
      //~ console.log("20120213 resize",arguments);
      this.view_is_ready = true;
      this.refresh(); // removed 20130911
      },this);
    this.on('afteredit', this.on_afteredit); // 20120814
    this.on('beforeedit', this.on_beforeedit);
    this.on('beforeedit',function(e) { this.before_row_edit(e.record)},this);
    if (this.cell_edit) {
        this.on('cellcontextmenu', Lino.cell_context_menu, this);
    } else {
        this.on('rowcontextmenu', Lino.row_context_menu, this);
    }
    //~ this.on('contextmenu', Lino.grid_context_menu, this);
    
    delete this.cell_edit;
    
  },
  
  //~ onResize : function(){
      //~ console.log("20120206 GridPanel.onResize",arguments);
      //~ Lino.GridPanel.superclass.onResize.apply(this, arguments);
      //~ this.refresh();
  //~ },
  
  
  get_status : function(){
    var st = { base_params : this.get_base_params()};
    if (!this.hide_top_toolbar) {
        // #866
        if (this.getStore().lastOptions != undefined && this.getStore().lastOptions.params != undefined){
            st.current_page = Math.round(this.getStore().lastOptions.params.start / this.getStore().lastOptions.params.limit ) + 1 ;
        }
    }
    st.param_values = this.status_param_values;
    //~ console.log("20120213 GridPanel.get_status",st);
    return st;
  },
  
  /* 
  Lino.GridPanel.set_status() 
  */
  set_status : function(status, rp){
    this.requesting_panel = Ext.getCmp(rp);
    // console.log("20140527 GridPanel.set_status", status);
    this.clear_base_params();
    if (status == undefined) status = {base_params:{}};
    this.set_param_values(status.param_values);
    if (status.base_params) { 
      this.set_base_params(status.base_params);
    }
    if (status.show_params_panel != undefined) {
        if (this.toggle_params_panel_btn) {
            //~ this.toggle_params_panel_btn.toggle(status.show_params_panel=='true');
            this.toggle_params_panel_btn.toggle(status.show_params_panel);
        }
    }
    if (!this.hide_top_toolbar) {
      //~ console.log("20120213 GridPanel.getTopToolbar().changePage",
          //~ status.current_page || 1);
      this.getTopToolbar().changePage(status.current_page || 1);
    }
    //~ this.fireEvent('resize');
    //~ this.refresh.defer(100,this); 
    //~ this.onResize.defer(100,this); 
    //~ this.refresh(); 
    //~ this.doLayout(); 
    //~ this.onResize(); 
    //~ this.store.load();
  },
  
  refresh : function(unused) { 
    this.refresh_with_after();
  },
  /* GridPanel */
  refresh_with_after : function(after) { 
    // console.log('20140504 Lino.GridPanel.refresh '+ this.store.proxy.url);
    //~ var bp = { fmt:'json' }
    if (! this.view_is_ready) return;
    
    if (this.containing_panel) {
        //~ Ext.apply(p,this.master_panel.get_master_params());
        //~ Ext.apply(options.params,this.containing_panel.get_master_params());
        this.set_base_params(this.containing_panel.get_master_params());
        // 20130911
        if (!this.store.baseParams.mk) {  
            return;
        }
    }
    
    //~ console.log('20130911 Lino.GridPanel.refresh_with_after',this.containing_panel.get_master_params());
    
    var options = {};
    if (after) {
        options.callback = function(r,options,success) {if(success) after()}
    }
      
    //~ if (!this.rendered) {
        //~ console.log("20120206 GridPanel.refresh() must wait until rendered",options);
        //~ this.grid_panel.on('render',this.load.createDelegate(this,options))
        //~ return;
    //~ }
    // Ticket 802
    if (this.store.lastOptions != undefined){
        var params = {};
        params.limit = this.store.lastOptions.params.limit;
        params.start = this.store.lastOptions.params.start;
        options.params = params;
    }
    this.store.load(options);
  },
  
  /* pageSize depends on grid height (Trying to remove scrollbar)
  Thanks to 
  - Christophe Badoit on http://www.sencha.com/forum/showthread.php?82647
  - http://www.sencha.com/forum/archive/index.php/t-37231.html
  */
  calculatePageSize : function(second_attempt) {
    //~ if (!this.rendered) { 
    if (!this.view_is_ready) { 
      //~ console.log('Cannot calculatePageSize() : not rendered');
      return false; }
    //~ if (!this.isVisible()) { 
      //~ console.log('calculatePageSize : not visible');
      //~ return false; }
      
    //~ console.log('getFrameHeight() is',this.getFrameHeight());
    //~ console.log('getView().scroller.getHeight() is',this.getView().scroller.getHeight());
    //~ console.log('mainBody.getHeight() is',this.getView().mainBody.getHeight());
    //~ console.log('getInnerHeight() is',this.getInnerHeight());
    //~ console.log('getHeight() is',this.getHeight());
    //~ console.log('el.getHeight() is',this.getEl().getHeight());
    //~ console.log('getGridEl().getHeight() is',this.getGridEl().getHeight());
    //~ console.log('getOuterSize().height is',this.getOuterSize().height);
    //~ console.log('getBox().height is',this.getBox().height);
    //~ console.log('getResizeEl.getHeight() is',this.getResizeEl().getHeight());
    //~ console.log('getLayoutTarget().getHeight() is',this.getLayoutTarget().getHeight());
      
    // var rowHeight = this.row_height * 11; experimental value 11
    // same as in ext_renderer.py that's not enough because it is the
    // height of one text line. But here we need the outer height of a
    // grid row containing that many text lines.

    var row_content = '&nbsp;'
    for (var i = 0; i < this.row_height;i++) {
        row_content += '<br>';
    }

    var Element = Ext.Element;
    var gv = this.view;
    var fakeBody = new Element(Element.fly(gv.scroller).child('div.x-grid3-body'));
    var rowTemplate = gv.templates.row;
    var cellTemplate = gv.templates.cell;
    var tstyle  = 'width:' + gv.getGridInnerWidth() + 'px;';
    // console.log("20160615", this.fake_row_content);
    var cells = cellTemplate.apply({value:row_content});
    var markup = rowTemplate.apply({
            tstyle: tstyle,
            cols  : 1,
            cells : cells,
            alt   : ''
        });        
    fakeBody.dom.innerHTML = gv.templates.body.apply({rows: markup});
    var row = fakeBody.dom.childNodes[0];
    var rowHeight = Ext.get(row).getHeight();

    //~ console.log('rowHeight is ',rowHeight,this,caller);
    //~ this.getView().syncScroll();
    //~ this.getView().initTemplates();
    var height = this.getView().scroller.getHeight();

    //~ console.log('getView().scroller.getHeight() is',this.getView().scroller.getHeight());
    //~ console.log('getInnerHeight() - getFrameHeight() is',
      //~ this.getInnerHeight(), '-',
      //~ this.getFrameHeight(), '=',
      //~ this.getInnerHeight() - this.getFrameHeight());
    //~ var height = this.getView().mainBody.getHeight();
    //~ var height = this.getView().mainWrap.getHeight();
    //~ var height = this.getView().resizeMarker.getHeight();
    //~ this.syncSize();
    //~ var height = this.getInnerHeight() - this.getFrameHeight();
    //~ var height = this.getHeight() - this.getFrameHeight();
    height -= Ext.getScrollBarWidth(); // leave room for a possible horizontal scrollbar... 
    //~ height -= this.getView().scrollOffset;
    var ps = Math.floor(height / rowHeight);
    //~ console.log('20130816 calculatePageSize():',height,'/',rowHeight,'->',ps);
    ps -= 1; // leave room for a possible phantom row
    //~ return (ps > 1 ? ps : false);
    if (ps > 1) return ps;
    //~ console.log('calculatePageSize() found less than 1 row:',height,'/',rowHeight,'->',ps);
    //~ foo.bar = baz; // 20120213
    return 5; // preview_limit
    //~ if (second_attempt) {
        //~ console.log('calculatePageSize() abandons after second attempt:',
          //~ height,'/',rowHeight,'->',ps);
      //~ return 5;
    //~ }
    //~ return this.calculatePageSize.defer(500,this,[true]);
  },
  
  onCellDblClick : function(grid, row, col){
      //~ console.log("20120307 onCellDblClick",this,grid, row, col);
      if (this.ls_detail_handler) {
          //~ Lino.notify('show detail');
          Lino.show_detail(this);
          return false;
      }else{
        //~ console.log('startEditing');
        this.startEditing(row,col);
      }
  },
  get_base_params : function() {  /* Lino.GridPanel */
    var p = Ext.apply({}, this.store.baseParams);
    Lino.insert_subst_user(p);
    // if (this.quick_search_field)
    //     if (this.quick_search_field.getValue())
    //         p.query = this.quick_search_field.getValue();
    return p;
  },
  set_base_params : function(p) {
    // console.log('20130911 GridPanel.set_base_params',p)
    for (k in p) this.store.setBaseParam(k,p[k]);
    //~ this.store.baseParams = p;
    if (this.quick_search_field)
      this.quick_search_field.setValue(p.query || "");
    //~ if (p.param_values) 
        //~ this.set_param_values(p.param_values);  
  },
  clear_base_params : function() {
      this.store.baseParams = {};
      Lino.insert_subst_user(this.store.baseParams);
  },
  set_base_param : function(k,v) {
    this.store.setBaseParam(k,v);
  },
  
  //~ get_permalink_params : function() {
    //~ var p = {};
    //~ return p;
  //~ },
  
  before_row_edit : function(record) {},
    
  //~ search_keypress : function(){
    //~ console.log("2012124 search_keypress",arguments);
  //~ },
  search_validate : function(value) {
    if (value == this.quick_search_text) return true;
    this.is_searching = true;
    //~ console.log('search_validate',value)
    this.quick_search_text = value;
    this.set_base_param('query',value); 
    //~ this.getTopToolbar().changePage(1);
    this.getTopToolbar().moveFirst();
    //~ this.refresh();
    return true;
  },
  
  search_change : function(field,oldValue,newValue) {
    //~ console.log('search_change',field.getValue(),oldValue,newValue)
    this.set_base_param('query',field.getValue()); 
    this.getTopToolbar().moveFirst();
    //~ this.refresh();
  },
  
  apply_grid_config : function(index,grid_configs,rpt_columns) {
    //~ var rpt_columns = this.ls_columns;
    var gc = grid_configs[index];    
    //~ console.log('apply_grid_config() 20100812',name,gc);
    this.gc_name = index;
    if (gc == undefined) {
      return rpt_columns;
      //~ config.columns = config.ls_columns;
      //~ return;
    } 
    //~ delete config.ls_filters
    
    //~ console.log(20100805,config.ls_columns);
    var columns = Array(gc.columns.length);
    for (var j = 0; j < rpt_columns.length;j++) {
      var col = rpt_columns[j];
      for (var i = 0; i < gc.columns.length; i++) {
        if (col.dataIndex == gc.ci[i]) {
          col.width = gc.cw[i];
          col.hidden = gc.ch[i];
          columns[i] = col;
          break;
        }
      }
    }
    
    //~ var columns = Array(rpt_columns.length);
    //~ for (var i = 0; i < rpt_columns.length; i++) {
      //~ columns[i] = rpt_columns[gc.columns[i]];
      //~ columns[i].width = gc.widths[i];
    //~ }
    
    //~ if (gc.hidden_cols) {
      //~ for (var i = 0; i < gc.hidden_cols.length; i++) {
        //~ var hc = gc.hidden_cols[i];
        //~ for (var j = 0; j < columns.length;j++) {
          //~ var col = columns[j];
          //~ if (col.dataIndex == hc) {
            //~ col.hidden = true;
            //~ break
          //~ }
        //~ }
      //~ }
    //~ }
    if (gc.filters) {
      //~ console.log(20100811,'config.ls_filters',config.ls_filters);
      //~ console.log(20100811,'config.ls_grid_config.filters',config.ls_grid_config.filters);
      for (var i = 0; i < gc.filters.length; i++) {
        var fv = gc.filters[i];
        for (var j = 0; j < columns.length;j++) {
          var col = columns[j];
          if (col.dataIndex == fv.field) {
            //~ console.log(20100811, f,' == ',fv);
            if (fv.type == 'string') {
              col.filter.value = fv.value;
              //~ if (fv.comparison !== undefined) f.comparison = fv.comparison;
            } else {
              //~ console.log(20100811, fv);
              col.filter.value = {};
              col.filter.value[fv.comparison] = fv.value;
            }
            break;
          }
        };
      }
    }
    
    return columns;
    //~ config.columns = cols;
    //~ delete config.ls_columns
  },
  
  get_current_grid_config : function () {
    var cm = this.getColumnModel();
    var widths = Array(cm.config.length);
    var hiddens = Array(cm.config.length);
    //~ var hiddens = Array(cm.config.length);
    var columns = Array(cm.config.length);
    //~ var columns = Array(cm.config.length);
    //~ var hidden_cols = [];
    //~ var filters = this.filters.getFilterValues();
    var p = this.filters.buildQuery(this.filters.getFilterData())
    for (var i = 0; i < cm.config.length; i++) {
      var col = cm.config[i];
      columns[i] = col.dataIndex;
      //~ hiddens[i] = col.hidden;
      widths[i] = col.width;
      hiddens[i] = col.hidden;
      //~ if (col.hidden) hidden_cols.push(col.dataIndex);
    }
    //~ p['hidden_cols'] = hidden_cols;
    p.cw = widths;
    p.ch = hiddens;
    p.ci = columns;
    //~ p['widths'] = widths;
    //~ p['hiddens'] = hiddens;
    //~ p['columns'] = columns;
    p['name'] = this.gc_name;
    //~ var gc = this.ls_grid_configs[this.gc_name];
    //~ if (gc !== undefined) 
        //~ p['label'] = gc.label
    //~ console.log('20100810 save_grid_config',p);
    return p;
  },
  
  unused_manage_grid_configs : function() {
    var data = [];
    for (k in this.ls_grid_configs) {
      var v = this.ls_grid_configs[k];
      var i = [k,String(v.columns),String(v.hidden_cols),String(v.filters)];
      data.push(i)
    }
    if (this.ls_grid_configs[this.gc_name] == undefined) {
      var v = this.get_current_grid_config();
      var i = [k,String(v.columns),String(v.hidden_cols),String(v.filters)];
      data.push(i);
    }
    //~ console.log(20100811, data);
    var main = new Ext.grid.GridPanel({
      store: new Ext.data.ArrayStore({
        idIndex:0,
        fields:['name','columns','hidden_cols','filters'],
        autoDestroy:true,
        data: data}),
      //~ autoHeight:true,
      selModel: new Ext.grid.RowSelectionModel(),
      listeners: { 
        rowdblclick: function(grid,rowIndex,e) {
          console.log('row doubleclicked',grid, rowIndex,e);
        },
        rowclick: function(grid,rowIndex,e) {
          console.log('row clicked',grid, rowIndex,e);
        }
      },
      columns: [ 
        {dataIndex:'name',header:'Name'}, 
        {dataIndex:'columns',header:'columns'}, 
        {dataIndex:'hidden_cols',header:'hidden columns'}, 
        {dataIndex:'filters',header:'filters'} 
      ]
    });
    var win = new Ext.Window({title:'GridConfigs Manager',layout:'fit',items:main,height:200});
    win.show();
  },
  
  unused_edit_grid_config : function(name) {
    gc = this.ls_grid_configs[name];
    var win = new Ext.Window({
      title:'Edit Grid Config',layout:'vbox', 
      //~ layoutConfig:'stretch'
      items:[
        {xtype:'text', value: gc.name},
        {xtype:'text', value: gc.columns},
        {xtype:'text', value: gc.hidden_cols},
        {xtype:'text', value: gc.filters}
      ]
    });
    win.show();
  },
  
  unused_save_grid_config : function () {
    //~ console.log('TODO: save_grid_config',this);
    //~ p.column_widths = Ext.pluck(this.colModel.columns,'width');
    var a = { 
      params:this.get_current_grid_config(), 
      method:'PUT',
      url:'/grid_config' + this.ls_url,
      success: Lino.action_handler(this),
      scope: this,
      failure: Lino.ajax_error_handler(this)
    };
    this.loadMask.show(); // 20120211
    Ext.Ajax.request(a);
    //~ Lino.do_action(this,a);
  },
  
  on_beforeedit : function(e) {
    //~ console.log('20130128 GridPanel.on_beforeedit()',e,e.record.data.disable_editing);
    if(this.disable_editing | e.record.data.disable_editing) {
      e.cancel = true;
      Lino.notify("This record is disabled");
      return;
    }
    if(e.record.data.disabled_fields && e.record.data.disabled_fields[e.field]) {
      e.cancel = true;
      Lino.notify("This field is disabled");
      return;
    }
    //~ if (e.record.data.disabled_fields) {
      //~ for (i in e.record.data.disabled_fields) {
        //~ if(e.record.data.disabled_fields[i] == e.field) {
          //~ e.cancel = true;
          //~ Lino.notify(String.format('Field "{0}" is disabled for this record',e.field));
          //~ return
        //~ }
      //~ }
    //~ }
  },
  save_grid_data : function() {
      //~ console.log("20120814 save_grid_data");
      this.getStore().commitChanges();
  },
  on_afteredit : function(e) {
    /*
    e.grid - The grid that fired the event
    e.record - The record being edited
    e.field - The field name being edited
    e.value - The value being set
    e.originalValue - The original value for the field, before the edit.
    e.row - The grid row index
    e.column - The grid column index
    */
    var p = {};
    // console.log('20140403 afteredit: ',e.record);
    //~ console.log('20101130 value: ',e.value);
    //~ var p = e.record.getChanges();
    //~ console.log('20101130 getChanges: ',e.record.getChanges());
    //~ this.before_row_edit(e.record);

    for(k in e.record.getChanges()) {
        var v = e.record.get(k);
    //~ for(k in e.record.modified) {
        //~ console.log('20101130',k,'=',v);
        //~ var cm = e.grid.getColumnModel();
        //~ var di = cm.getDataIndex(k);
        var f = e.record.fields.get(k);
        //~ console.log('20101130 f = ',f);
        //~ var v = e.record.get(di);
        if (f.type.type == 'date') {
            p[k] = Ext.util.Format.date(v, f.dateFormat);
        }else{
            p[k] = v;
            var v = e.record.get(k+'Hidden');
            if (v !== undefined) {
              p[k+'Hidden'] = v;
            }
        }
    }
    // add value used by ForeignKeyStoreField CHOICES_HIDDEN_SUFFIX
    // not sure whether this is still needed:
    p[e.field+'Hidden'] = e.value;
    //~ p.su = Lino.subst_user;
    Lino.insert_subst_user(p);
    // this one is needed so that this field can serve as choice context:
    e.record.data[e.field+'Hidden'] = e.value;
    // p[pk] = e.record.data[pk];
    // console.log("grid_afteredit:",e.field,'=',e.value);
    Ext.apply(p, this.get_base_params()); // needed for POST, ignored for PUT
    //~ Ext.apply(p,this.containing_window.config.base_params);
    //~ 20121109 p['$constants.URL_PARAM_ACTION_NAME'] = 'grid';
    var self = this;
    var req = {
        params:p,
        waitMsg: 'Saving your data...',
        success: Lino.action_handler( this, function(result) {
          // console.log("20140728 afteredit.success got ", result);
          //~ if (result.data_record) {
          if (result.refresh_all) {
              var cw = self.get_containing_window();
              if (cw) {
                  cw.main_item.refresh();
              }
              else console.log("20120123 cannot refresh_all",self);
          } else if (result.rows) {
              //~ self.getStore().loadData(result,true);
              var r = self.getStore().reader.readRecords(result);
              if (e.record.phantom) {
                  // console.log("20140728 gonna call Store.insert()", self.getStore(), e.row, r.records);
                  self.getStore().insert(e.row, r.records);
              }else{
                  // console.log("20140728 afteredit.success doUpdate", r.records[0]);
                  self.getStore().doUpdate(r.records[0]);
              }
              self.getStore().rejectChanges(); 
              /* 
              get rid of the red triangles without saving the record again
              */
              //~ self.getStore().commitChanges(); // get rid of the red triangles
          } else {
              self.getStore().commitChanges(); // get rid of the red triangles
              self.getStore().reload();        // reload our datastore.
          }
          }),
        scope: this,
        failure: Lino.ajax_error_handler(this)
    };
    if (e.record.phantom) {
      req.params.an = 'grid_post'; // CreateRow.action_name
      Ext.apply(req,{
        method: 'POST',
        url: '/api' + this.ls_url
      });
    } else {
      req.params.an = 'grid_put'; // SaveRow.action_name
      Ext.apply(req,{
        method: 'PUT',
        url: '/api' + this.ls_url + '/' + e.record.id
      });
    }
    //~ console.log('20110406 on_afteredit',req);
    this.loadMask.show(); // 20120211
    Ext.Ajax.request(req);
  },

  afterRender : function() {
    Lino.GridPanel.superclass.afterRender.call(this);
    // this.getView().mainBody.focus();
    // console.log(20100114,this.getView().getRows());
    // if (this.getView().getRows().length > 0) {
    //  this.getView().focusRow(1);
    // }
    //~ this.my_load_mask = new Ext.LoadMask(this.getEl(), {
        //~ msg:'$_("Please wait...")',
        //~ store:this.store});
      
    var tbar = this.getTopToolbar();
    // tbar.on('change',function() {this.getView().focusRow(1);},this);
    // tbar.on('change',function() {this.getSelectionModel().selectFirstRow();this.getView().mainBody.focus();},this);
    // tbar.on('change',function() {this.getView().mainBody.focus();},this);
    // tbar.on('change',function() {this.getView().focusRow(1);},this);
    this.nav = new Ext.KeyNav(this.getEl(),{
      pageUp: function() {tbar.movePrevious(); },
      pageDown: function() {tbar.moveNext(); },
      home: function() {tbar.moveFirst(); },
      end: function() {tbar.moveLast(); },
      scope: this
    });

  },
  after_delete : function() {
    //~ console.log('Lino.GridPanel.after_delete');
    this.refresh();
  },
  add_row_listener : function(fn,scope) {
    this.getSelectionModel().addListener('rowselect',fn,scope);
  },
  postEditValue : function(value, originalValue, r, field){
    value = Lino.GridPanel.superclass.postEditValue.call(this,value,originalValue,r,field);
    //~ console.log('GridPanel.postEdit()',value, originalValue, r, field);
    return value;
  },
  
  set_start_value : function(v) {
      this.start_value = v;
  },
  preEditValue : function(r, field){
      if (this.start_value) {
        var v = this.start_value;
        delete this.start_value;
        this.activeEditor.selectOnFocus = false;
        return v;
      }
      var value = r.data[field];
      return this.autoEncode && Ext.isString(value) ? Ext.util.Format.htmlDecode(value) : value;
  },
  
  on_master_changed : function() {
    //~ if (! this.enabled) return;
    //~ cmp = this;
    //~ console.log('20130911 Lino.GridPanel.on_master_changed()',this.title,this.rendered);
    if (! this.rendered) return; // 20120213
    var todo = function() {
      if (this.disabled) return;
      //~ if (this.disabled) return;
      //~ if (this.enabled) {
          //~ var src = caller.config.url_data + "/" + record.id + ".jpg"
          //~ console.log(20111125, this.containing_window);
          //~ for (k in p) this.getStore().setBaseParam(k,p[k]);
          //~ console.log('Lino.GridPanel.on_master_changed()',this.title,p);
          this.refresh();
          //~ this.set_base_params(this.master_panel.get_master_params());
          //~ this.getStore().load(); 
      //~ }
    };
    Lino.do_when_visible(this,todo.createDelegate(this));
  },
  load_record_id : function(record_id,after) {
      Lino.run_detail_handler(this,record_id)
  }
  
});
  

//~ Lino.MainPanelMixin = {
  //~ tbar_items : function() {
      //~ return ;
  //~ }
//~ };

//~ Ext.override(Lino.GridPanel,Lino.MainPanelMixin);
//~ Ext.override(Lino.FormPanel,Lino.MainPanelMixin);

//~ Lino.grid_context_menu = function(e) {
  //~ console.log('contextmenu',arguments);
//~ }

Lino.row_context_menu = function(grid,row,col,e) {
  console.log('20130927 rowcontextmenu',grid,row,col,e,grid.store.reader.arrayData.rows[row]);
}

Lino.cell_context_menu = function(grid,row,col,e) {
  //~ console.log('20120531 cellcontextmenu',grid,row,col,e,grid.store.reader.arrayData.rows[row]);
  e.stopEvent();
  //~ grid.getView().focusCell(row,col);
  grid.getSelectionModel().select(row,col);
  //~ console.log(grid.store.getAt(row));
  //~ grid.getView().focusRow(row);
  //~ return;
  if(!grid.cmenu.el){grid.cmenu.render(); }
  //~ if(e.record.data.disabled_fields) {
  
  var da = grid.store.reader.arrayData.rows[row][grid.disabled_actions_index];
  if (da) {
      this.cmenu.cascade(function(item){ 
        //~ console.log(20120531, item.itemId, da[item.itemId]);
        if (da[item.itemId]) item.disable(); else item.enable();
      });
  };
  
  var xy = e.getXY();
  xy[1] -= grid.cmenu.el.getHeight();
  grid.cmenu.showAt(xy);
}


Lino.chooser_handler = function(combo,name) {
  return function(cmp, newValue, oldValue) {
    //~ console.log('Lino.chooser_handler()',cmp,oldValue,newValue);
    combo.setContextValue(name, newValue);
  }
};



Lino.ComboBox = Ext.extend(Ext.form.ComboBox,{
  forceSelection: "yes but select on tab",
  // forceSelection: true,
  triggerAction: 'all',
  minListWidth:280, // 20131022
  autoSelect: false,
  selectOnFocus: true, // select any existing text in the field immediately on focus.
  submitValue: true,
  displayField: 'text', // 'text', 
  valueField: 'value', // 'value',
  
  //~ initComponent : Ext.form.ComboBox.prototype.initComponent.createSequence(function() {
  initComponent : function(){
      this.contextParams = {};
      //~ Ext.form.ComboBox.initComponent(this);
      Lino.ComboBox.superclass.initComponent.call(this);
  },
  setValue : function(v, record_data){
      /*
      Based on feature request developed in http://extjs.net/forum/showthread.php?t=75751
      */
      /* `record_data` is used to get the text corresponding to this value */
      //~ if(this.name == 'city') 
      //~ console.log('20120203', this.name,'.setValue(', v ,') this=', this,'record_data=',record_data);
      var text = v;
      if(this.valueField){
        if(v == null || v == '') { 
            //~ if (this.name == 'birth_country') 
                //~ console.log(this.name,'.setValue',v,'no lookup needed, value is empty');
            //~ v = undefined;
            v = '';
            //~ text = '';
        } else if (Ext.isDefined(record_data)) {
          text = record_data[this.name];
          //~ if (this.name == 'birth_country') 
            //~ console.log(this.name,'.setValue',v,'got text ',text,' from record ',record);
        } else {
          // if(this.mode == 'remote' && !Ext.isDefined(this.store.totalLength)){
          if(this.mode == 'remote' && ( this.lastQuery === null || (!Ext.isDefined(this.store.totalLength)))){
              //~ if (this.name == 'birth_country') console.log(this.name,'.setValue',v,'store not yet loaded');
              this.store.on('load', this.setValue.createDelegate(this, arguments), null, {single: true});
              if(this.store.lastOptions === null || this.lastQuery === null){
                  var params;
                  if(this.valueParam){
                      params = {};
                      params[this.valueParam] = v;
                  }else{
                      var q = this.allQuery;
                      this.lastQuery = q;
                      this.store.setBaseParam(this.queryParam, q);
                      params = this.getParams(q);
                  }
                  //~ if (this.name == 'birth_country') 
                    //~ console.log(this.name,'.setValue',v,' : call load() with params ',params);
                  this.store.load({params: params});
              //~ }else{
                  //~ if (this.name == 'birth_country') 
                    //~ console.log(this.name,'.setValue',v,' : but store is loading',this.store.lastOptions);
              }
              return;
          //~ }else{
              //~ if (this.name == 'birth_country') 
                //~ console.log(this.name,'.setValue',v,' : store is loaded, lastQuery is "',this.lastQuery,'"');
          }
          var r = this.findRecord(this.valueField, v);
          if(r){
              text = r.data[this.displayField];
          }else if(this.valueNotFoundText !== undefined){
              text = this.valueNotFoundText;
          }
        }
      }
      this.lastSelectionText = text;
      //~ this.lastSelectionText = v;
      if(this.hiddenField){
          //~ this.hiddenField.originalValue = v;
          this.hiddenField.value = v;
      }
      Ext.form.ComboBox.superclass.setValue.call(this, text);
      this.value = v; // needed for grid.afteredit
  },
  
  getParams : function(q){
    // p = Ext.form.ComboBox.superclass.getParams.call(this, q);
    // causes "Ext.form.ComboBox.superclass.getParams is undefined"
    var p = {};
    if(this.pageSize){
        p['start'] = 0;
        p['limit'] = this.pageSize;
    }
    // now my code:
    if(this.contextParams) Ext.apply(p, this.contextParams);
    return p;
  },
  setContextValue : function(name,value) {
    //~ console.log('setContextValue',this,this.name,':',name,'=',value);
    //~ if (this.contextValues === undefined) {
        //~ this.contextValues = Array(); // this.contextParams.length);
    //~ }
    if (this.contextParams[name] != value) {
      //~ console.log('setContextValue 1',this.contextParams);
      this.contextParams[name] = value;
      this.lastQuery = null;
      //~ console.log('setContextValue 2',this.contextParams);
    }
  }
});

Lino.ChoicesFieldElement = Ext.extend(Lino.ComboBox,{
  mode: 'local'
});


Lino.SimpleRemoteComboStore = Ext.extend(Ext.data.JsonStore,{
  // forceSelection: true,  20140206 why was this here?
  constructor: function(config){
      Lino.SimpleRemoteComboStore.superclass.constructor.call(this, Ext.apply(config, {
          totalProperty: 'count',
          root: 'rows',
          id: 'value', // 'value'
          fields: ['value' ], 
          listeners: { exception: Lino.on_store_exception }
      }));
  }
});

Lino.ComplexRemoteComboStore = Ext.extend(Ext.data.JsonStore,{
  constructor: function(config){
      Lino.ComplexRemoteComboStore.superclass.constructor.call(this, Ext.apply(config, {
          totalProperty: 'count',
          root: 'rows',
          id: 'value', // constants.CHOICES_VALUE_FIELD
          fields: ['value','text'], // constants.CHOICES_VALUE_FIELD, // constants.CHOICES_TEXT_FIELD
          listeners: { exception: Lino.on_store_exception }
      }));
  }
});

Lino.RemoteComboFieldElement = Ext.extend(Lino.ComboBox,{
  mode: 'remote',
  //~ forceSelection:false,
  minChars: 2, // default 4 is too much
  queryDelay: 300, // default 500 is maybe slow
  queryParam: 'query', 
  //~ typeAhead: true,
  //~ selectOnFocus: true, // select any existing text in the field immediately on focus.
  resizable: true
  ,initList : function() {
      Lino.RemoteComboFieldElement.superclass.initList.call(this);
      if (this.pageTb) {
          
          var me = this;
          this.pageTb.on("beforechange", function(toolbar, o){
              if(me.contextParams)
                  Ext.apply(o, me.contextParams);
          });
          
          //~ 
          //~ var btn = ls_buttons
          //~ this.pageTb.items = this.pageTb.items.concat([btn]);
          //~ console.log("20131022 pageTb.items is", this.pageTb.items)
      }
  }
});

/*
Thanks to Animal for posting the basic idea:
http://www.sencha.com/forum/showthread.php?15842-2.0-SOLVED-Combobox-twintrigger-clear&p=76130&viewfull=1#post76130

*/
Lino.TwinCombo = Ext.extend(Lino.RemoteComboFieldElement,{
    trigger2Class : 'x-form-search-trigger',
    //~ trigger2Class : 'x-tbar-detail',
    initComponent : function() {
        //~ Lino.TwinCombo.superclass.initComponent.call(this);
        Lino.ComboBox.prototype.initComponent.call(this);
        Ext.form.TwinTriggerField.prototype.initComponent.call(this);
    },
    onTrigger2Click : function() {
        //~ console.log('onTrigger2Click',this,arguments);
    }
  });
//~ Lino.TwinCombo.prototype.initComponent = Ext.form.TwinTriggerField.prototype.initComponent;
Lino.TwinCombo.prototype.getTrigger = Ext.form.TwinTriggerField.prototype.getTrigger;
Lino.TwinCombo.prototype.getOuterSize = Ext.form.TwinTriggerField.prototype.getOuterSize;
Lino.TwinCombo.prototype.initTrigger = Ext.form.TwinTriggerField.prototype.initTrigger;
Lino.TwinCombo.prototype.onTrigger1Click = Ext.form.ComboBox.prototype.onTriggerClick;
//~ Lino.TwinCombo.prototype.onTrigger2Click = function() {
    //~ console.log('onTrigger2Click',arguments);
//~ };



Lino.SimpleRemoteComboFieldElement = Ext.extend(Lino.RemoteComboFieldElement,{
  displayField: 'value', 
  valueField: null,
  forceSelection: false
});




Lino.Window = Ext.extend(Ext.Window,{
  //~ layout: "fit", 
  closeAction : 'hide',
  renderTo: 'main_area', 
  constrain: true,
  maximized: true,
  draggable: false,
  width: 700,
  height: 500,
  maximizable: false,
  constructor : function (config) {
    if (config.main_item.params_panel) {
        config.layout = 'border';
        config.main_item.region = 'center';
        config.main_item.params_panel.region = 'north';
        //~ config.main_item.params_panel.autoHeight = false; // 20130924
        config.main_item.params_panel.hidden = config.main_item.params_panel_hidden;
        config.items = [config.main_item.params_panel, config.main_item];
        //~ 20130923b
    } else {
        config.layout = 'fit';
        config.items = config.main_item;
    }
    this.main_item = config.main_item; 

    if (typeof config.width == "string" && config.width.slice(-1) == "%") {
        config.width = Lino.perc2width(parseInt(config.width.slice(0, -1)));
    }
    
    delete config.main_item;
    //~ delete config.params_item;
    
    //~ this.main_item = config.items.get(0);
    this.main_item.containing_window = this;
    
    //~ console.log('20120110 Lino.Window.constructor() 1');
    //~ if (Lino.current_window) { // all windows except the top are closable
    if (this.main_item.hide_window_title) { 
      config.closable = false;
      config.frame = false;
      config.shadow = false;
      //~ config.border = true;
      //~ config.title = undefined;
      //~ config.tools = null;
      delete config.title;
      delete config.tools;
    } else {
      config.title = this.main_item.empty_title;
      config.closable = true;
      config.tools = [ 
        { qtip: 'permalink', handler: Lino.permalink_handler(this), id: "pin" }
      ];
      if (this.main_item.content_type && this.main_item.action_name != 'insert') {
        config.tools = [ {
          handler: Lino.help_text_editor,
          qtip: "Edit help texts for fields on this model.",
          scope: this.main_item,
          id: "gear"
        }].concat(config.tools);
      }
        
    //~ { qtip: '', handler: Lino.save_wc_handler(this), id: "save" }, 
    //~ { qtip: this.config.qtip, handler: Lino.save_wc_handler(this), id: "save" }, 
    //~ { qtip: 'Call doLayout() on main Container.', handler: Lino.refresh_handler(this), id: "refresh" },
    //~ if (this.main_item.params_panel) {
        //~ config.tools = config.tools.concat([ 
          //~ { qtip: 'Show/hide parameter panel', handler: this.toggle_params_panel, id: "gear", scope:this } 
        //~ ]);
    //~ }
    //~ if (config.closable !== false) {
      // if undefined, will take default behaviour
      //~ config.tools = config.tools.concat([ 
        //~ { qtip: 'close', handler: this.hide, id: "close", scope:this } 
      //~ ]);
    }
    
    this.main_item.config_containing_window(config);
    
    // console.log('20150514 Lino.Window.constructor() 2');
    Lino.Window.superclass.constructor.call(this, config);
    
    //~ console.log('20120110 Lino.Window.constructor() 3');
    
  },
  initComponent : function() {
    this.main_item.init_containing_window(this);
    Lino.Window.superclass.initComponent.call(this);
  
  },
  hide : function() { 
      this.main_item.do_when_clean(false,function() { 
        Lino.close_window(); });
  },
  hide_really : function() { 
    Lino.Window.superclass.hide.call(this);
  },
  onRender : function(ct, position){
    // console.log('20140829 Lino.Window.onRender() 1');
    Lino.Window.superclass.onRender.call(this, ct, position);
    var main_area = Ext.getCmp('main_area')
    //~ console.log('20120110 Lino.Window.onRender() 2');
  
    this.on('show', function(win) {
        // console.log('20140829 Lino.Window.on(show) : add resize handler');
        main_area.on('resize', win.onWindowResize, win);
    });
    this.on('hide', function(win) {
        // console.log('20140829 Lino.Window.on(hide) : remove resize handler');
        main_area.un('resize', win.onWindowResize, win);
    });
    // console.log('20140829 Lino.Window.onRender() 3');
  }
});


Ext.override(Ext.form.BasicForm,{
    my_loadRecord : function(record_data){
    //~ loadRecord : function(record){
        /* Same as ExtJS's loadRecord() (setValues()), except that we
        forward also the record_data to field.setValue(). This second
        parameter is used by Lino.Combobox.
        */
        //~ console.log('20120918 my_loadRecord', record_data)
        if(Ext.isArray(record_data)){ 
            for(var i = 0, len = record_data.length; i < len; i++){
                var v = record_data[i];
                var f = this.findField(v.id);
                if(f){
                    f.setValue(v.value, record_data);
                    if(this.trackResetOnLoad){
                        f.originalValue = f.getValue();
                    }
                }
            }
        }else{ 
            var field, id;
            for(id in record_data){
                if(!Ext.isFunction(record_data[id]) && (field = this.findField(id))){
                    field.setValue(record_data[id], record_data);
                    if(this.trackResetOnLoad){
                        field.originalValue = field.getValue();
                        //~ if (field.hiddenField) {
                          //~ field.hiddenField.originalValue = field.hiddenField.value;
                        //~ }
                    }
                }
            }
        }
        return this;
    }
});




function initializeFooBarDropZone(cmp) {
    //~ console.log('initializeFooBarDropZone',cmp);
    cmp.dropTarget = new Ext.dd.DropTarget(cmp.bwrap, {
      //~ ddGroup     : 'gridDDGroup',
      notifyEnter : function(ddSource, e, data) {
        console.log('notifyEnter',ddSource,e,data);
        //Add some flare to invite drop.
        cmp.body.stopFx();
        cmp.body.highlight();
      },
      notifyDrop  : function(ddSource, e, data){
        console.log('notifyDrop',ddSource,e,data);
        // Reference the record (single selection) for readability
        //~ var selectedRecord = ddSource.dragData.selections[0];


        // Load the record into the form
        //~ formPanel.getForm().my_loadRecord(selectedRecord);


        // Delete record from the grid.  not really required.
        //~ ddSource.grid.store.remove(selectedRecord);

        return(true);
      }
    })
}



Lino.show_mti_child = function(fieldname,detail_handler) {
  //~ console.log('show_mti_child',this);
  //~ console.log('show_mti_child',panel.find("main_area"));
  rec = Lino.current_window.main_item.get_current_record();
  //~ rec = panel.get_current_record();
  if (rec) {
    //~ console.log('show_mti_child',Lino.current_window,rec);
    if (rec.phantom) {
      Lino.notify('Not allowed on phantom record.');
    }else if (rec.data[fieldname]) {
      //~ console.log('show_mti_child',rec.id);
      //~ detail_handler(Lino.current_window.main_item,{},{record_id:rec.id});
      detail_handler.run(null,{record_id:rec.id});
      //~ window.open(urlroot + '/' + rec.id);
      //~ document.location = urlroot + '/' + rec.id;
      //~ window.open(urlroot + '/' + rec.id,'_blank');
    } else {
      Lino.alert("Cannot show MTI child if checkbox is off.");
    }
  } else {
    Lino.notify('No current record.');
  }
};


/*
captureEvents utility by Aaron Conran
<http://www.sencha.com/learn/grid-faq/>

Ext.onReady(function(){
    var grid = new Ext.grid.GridPanel({
        ... 
    });
    captureEvents(grid);
});
*/
function captureEvents(observable) {
    Ext.util.Observable.capture(
        observable,
        function(eventName) {
            console.info(eventName);
        },
        this
    );		
}

// settings.SITE.get_plugin_snippets()




// from lino_xl.lib.beid (media_name=eidreader):beid/eidreader.js


Lino.beid_read_card_processor = function() {
    var card = document.applets.EIDReader.readCard();
    // if (!card) {
    //     Lino.alert("Could not find any card on your reader.");
    //     return null;
    // } 
    // console.log(20140301, card);
    return { card_data: card };
}


// from lino_xl.lib.sepa:iban/uppercasetextfield.js

Lino.UppercaseTextField = Ext.extend(Ext.form.TextField,{
  style: 'text-transform:uppercase;',
  listeners:{
    change: function(field, newValue, oldValue){
      // console.log("20140403 UppercaseTextField",newValue, newValue.toUpperCase());
      field.setRawValue(newValue.toUpperCase());
    }
  }
});


Lino.iban_renderer = function(
    value, metaData, record, rowIndex, colIndex, store) 
{
    var reg = new RegExp(".{4}", "g");
    if(value) {
        return value.replace(reg, function (a) { return a + ' '; });
    }
    return value;
}




// from lino_xl.lib.extensible (media_name=extensible-1.0.1):snippets/extensible.js

/*
  This is the `extensible.js` snippet. 
  Used in lino.modlib.extensible.App.site_js_snippets
*/

/*
Mappings towards lino.modlib.extensible.models.PanelCalendars
*/
// Sset SS = Ssite.modules.extensible.PanelCalendars.get_handle(Sui).store
Ext.ensible.cal.CalendarMappings = {
    CalendarId:   {name:'ID',       mapping: 'id', type: 'int'},
    Title:        {name:'CalTitle', mapping: 'summary', type: 'string'},
    Description:  {name:'Desc',     mapping: 'description', type: 'string'},
    ColorId:      {name:'Color',    mapping: 'color', type: 'int'},
    IsHidden:     {name:'Hidden',   mapping: 'is_hidden', type: 'boolean'},    
};
Ext.ensible.cal.CalendarRecord.reconfigure();  


/*
Mappings towards lino.modlib.extensible.models.PanelEvents 
*/
// Sset SS = Ssite.modules.extensible.PanelEvents.get_handle(Sui).store
Ext.ensible.cal.EventMappings = {
    EventId:     {name: 'ID',        mapping: 'id', type:'int'},
    CalendarId:  {name: 'CalID',     mapping: 'calendarHidden', type: 'int'},
    Title:       {name: 'EvtTitle',  mapping: 'summary'},
    StartDate:   {name: 'StartDt',   mapping: 'start_dt', 
      type: 'date', 
      dateFormat: "Y-m-d\TH:i:s" },
    EndDate:     {name: 'EndDt',     mapping: 'end_dt', 
      type: 'date', 
      dateFormat: "Y-m-d\TH:i:s"},
    RRule:       {name: 'RecurRule', mapping: 'rsetHidden'},
    Location:    {name: 'Location',  mapping: 'placeHidden'},
    Notes:       {name: 'Desc',      mapping: 'description'},
    Url:         {name: 'LinkUrl',   mapping: 'url'},
    IsAllDay:    {name: 'AllDay',    mapping: 'all_day', type: 'boolean'},
    Reminder:    {name: 'Reminder',  mapping: 'reminder'}
    
};
Ext.ensible.cal.EventRecord.reconfigure();


//~ Lino.on_eventclick = 
    
Lino.on_editdetails = 

Lino.format_time = function(dt) {
    return dt.getHours() + ':' + dt.getMinutes();
}
    
Lino.on_eventdelete = function() {
  //~ console.log("Lino.on_eventdelete",arguments);
};

Lino.on_eventadd  = function(cp,rec,el) {
  //~ console.log("Lino.on_eventadd ",arguments);
  return false;
}
    
Lino.on_eventresize  = function(cp,rec,el) {
  //~ console.log("Lino.on_eventresize ",arguments);
  //~ Lino.cal.Events.insert(cp);
  //~ return false;
}
    
Lino.on_eventupdate  = function(cp,rec,el) {
  //~ console.log("Lino.on_eventupdate",arguments);
  //~ Lino.cal.Events.insert(cp);
  //~ return false;
}
    

//~ Lino.eventStore = new Ext.ensible.cal.EventStore({ 
//~ Lino.eventStore = new Ext.data.ArrayStore({ 
Lino.unused_eventStore = new Ext.data.JsonStore({ 
  listeners: { exception: Lino.on_store_exception }
  ,url: '/restful/extensible/PanelEvents'
  ,restful : true
  ,proxy: new Ext.data.HttpProxy({ 
      url: '/restful/extensible/PanelEvents', 
      disableCaching: false // no need for cache busting when loading via Ajax
      //~ disableCaching:true,
  })
  ,fields: Ext.ensible.cal.EventRecord.prototype.fields.getRange()
  ,totalProperty: "count"
  ,root: "rows"
  ,idProperty: Ext.ensible.cal.EventMappings.EventId.mapping
  ,writer : new Ext.data.JsonWriter({
    writeAllFields: false
  })
  ,load: function(options) {
    //~ foo.bar = baz; // 20120213
      if (!options) options = {};
      if (!options.params) options.params = {};
      //~ options.params.$constants.URL_PARAM_TEAM_VIEW = Lino.calendar_app.team_view_button.pressed;
      
      var view = this.cal_panel.getActiveView();
      var bounds = view.getViewBounds();
      //~ var p = {sd:'05.02.2012',ed:'11.02.2012'};
      //~ var p = {};
      options.params[view.dateParamStart] = bounds.start.format(view.dateParamFormat);
      options.params[view.dateParamEnd] = bounds.end.format(view.dateParamFormat);
      Lino.insert_subst_user(options.params);
      //~ Ext.apply(options.params,p)
      //~ console.log('20120710 eventStore.load()',this.baseParams,options);
    
    return Ext.data.JsonStore.prototype.load.call(this,options);
  }
});


Lino.CalendarCfg = {
    dateParamFormat: 'd.m.Y',
    dateParamStart:'sd',
    dateParamEnd:'ed'
};
//~ 20120704 Lino.CalendarPanel = Ext.extend(Ext.ensible.cal.CalendarPanel,Lino.MainPanel);
//~ Lino.CalendarPanel = Ext.extend(Lino.CalendarPanel,{
Ext.override(Ext.ensible.cal.CalendarPanel,Lino.MainPanel);
Ext.override(Ext.ensible.cal.CalendarPanel,{
  //~ empty_title : "\$ui.get_actor('cal.Panel').report.label",
  empty_title : "Calendar"
  ,activeItem: 1 // 0: day, 1: week
  ,ls_url: '/extensible/CalendarPanel'
  //~ ,disableCaching:true
  //~ ,eventStore: Lino.eventStore
  //~ ,calendarStore: Lino.calendarStore
  //~ ,initComponent : function(){
    //~ Ext.ensible.cal.CalendarPanel.superclass.initComponent.call(this);
    //~ this.eventStore.on('load',function(){
      //~ console.log("20130808",Lino.eventStore);
      //~ if (this.eventStore.reader.jsonData) {
        //~ console.log("20130808 b",this.eventStore.reader.jsonData.title);
        //~ this.set_window_title(this.eventStore.reader.jsonData.title);
      //~ }
    //~ },this);
  //~ }
  ,listeners: { 
    editdetails: function(cp,rec,el) {
      //~ console.log("Lino.on_editdetails",arguments);
      if (rec.data.ID)
          Lino.extensible.PanelEvents.detail.run(null,{
              record_id:rec.data.ID,
              base_params:this.app_instance.event_store.baseParams});
      return false;
    }
    ,eventclick: function(cp,rec,el) {
      //~ console.log("Lino.on_eventclick",arguments);
      //~ Lino.cal.Events.detail_action.run({record_id:rec.data.ID});
      Lino.extensible.PanelEvents.detail.run(null,{
            record_id:rec.data.ID,
                base_params:this.app_instance.event_store.baseParams});
      return false;
    }
    //~ ,eventadd: Lino.on_eventadd
    //~ ,eventdelete: Lino.on_eventdelete
    //~ ,eventresize: Lino.on_eventresize
    ,afterrender : function(config) {
      // console.log("20140402 CalendarPanel.afterrender");
      this.app_instance.calendar_store.cal_panel = this;
      // 20140402 this.app_instance.calendar_store.load();
      //~ console.log("20120704 afterrender calls eventStore.load()",p);
      this.app_instance.event_store.cal_panel = this;
      //~ Lino.eventStore.load({params:p});
      //~ 20130905 removed: this.app_instance.event_store.load();
      //~ Lino.CalendarPanel.superclass.constructor.call(this, config);
      //~ console.log(20120118, config,this);
    }
    }
  ,enableEditDetails: false
  //~ ,monthViewCfg: Lino.CalendarCfg
  //~ ,weekViewCfg: Lino.CalendarCfg
  //~ ,multiDayViewCfg: Lino.CalendarCfg
  //~ ,multiWeekViewCfg: Lino.CalendarCfg
  //~ ,dayViewCfg: Lino.CalendarCfg
  //~ ,initComponent : function() {
    //~ // this.on('eventadd',Lino.on_eventadd);
    //~ Lino.CalendarPanel.superclass.initComponent.call(this);
  //~ }
});




Lino.CalendarAppPanel = Ext.extend(Ext.Panel,Lino.MainPanel);
Lino.CalendarAppPanel = Ext.extend(Lino.CalendarAppPanel,Lino.PanelMixin);
Lino.CalendarAppPanel = Ext.extend(Lino.CalendarAppPanel,{
  app_instance : null
  //~ empty_title : "\$ui.get_actor('cal.Panel').report.label",
  ,empty_title : "Calendar"
  ,ls_url: '/extensible/CalendarPanel'
  ,set_status : function(status,rp) { 
      // console.log('20140402 CalendarAppPanel.set_status()', status);
      this.requesting_panel = Ext.getCmp(rp);
      this.clear_base_params();
      if (status == undefined) status = {};
      //~ if (status.param_values) 
      //~ this.set_field_values(status.field_values);
      if (status.base_params) this.set_base_params(status.base_params);
      this.refresh();
      }
  ,refresh : function() {
      //~ this.app_instance.event_store.reload(); 20130905
      this.app_instance.calendar_store.load();  // added 20140402
      this.app_instance.event_store.load();
  }
  ,layout: 'fit'
  ,get_base_params : function() {
    // console.log('20140402 getbase_params has', this.base_params);
    var p = Ext.apply({}, this.base_params);
    Lino.insert_subst_user(p);
    // console.log('20140402 getbase_params returns', p);
    return p;
  }
  ,set_base_params : function(p) {
    this.base_params = Ext.apply(this.app_instance.event_store.baseParams,p);
    this.app_instance.event_store.baseParams = this.base_params;
    // console.log('20140402 this.base_params is', this.base_params);
  }
  ,clear_base_params : function() {
      this.base_params = {};
      Lino.insert_subst_user(this.base_params);
  }
  ,set_base_param : function(k,v) {
      if (!this.base_params) this.base_params = {};
      this.base_params[k] = v;
  }
});

Lino.CalendarApp = function() { return {
  team_view_button : null 
  ,get_main_panel : function() {
      var cap = null;
      this.event_store = new Ext.data.JsonStore({ 
          listeners: { exception: Lino.on_store_exception }
          ,url: '/restful/extensible/PanelEvents'
          ,restful : true
          ,proxy: new Ext.data.HttpProxy({ 
              url: '/restful/extensible/PanelEvents', 
              disableCaching: false // no need for cache busting when loading via Ajax
              //~ disableCaching:true,
          })
          ,fields: Ext.ensible.cal.EventRecord.prototype.fields.getRange()
          ,totalProperty: "count"
          ,root: "rows"
          ,idProperty: Ext.ensible.cal.EventMappings.EventId.mapping
          ,writer : new Ext.data.JsonWriter({
            writeAllFields: false
          })
          ,load: function(options) {
            //~ foo.bar = baz; // 20120213
              if (!options) options = {};
              if (!options.params) options.params = {};
              //~ options.params.$constants.URL_PARAM_TEAM_VIEW = Lino.calendar_app.team_view_button.pressed;
              
              var view = this.cal_panel.getActiveView();
              var bounds = view.getViewBounds();
              //~ var p = {sd:'05.02.2012',ed:'11.02.2012'};
              //~ var p = {};
              options.params[view.dateParamStart] = bounds.start.format(view.dateParamFormat);
              options.params[view.dateParamEnd] = bounds.end.format(view.dateParamFormat);
              Lino.insert_subst_user(options.params);
              Ext.apply(options.params, cap.get_base_params());
              //~ this.cal_panel.base_params.su.toString();
              //~ if (this.cal_panel) {
                  // Ext.apply(options.params,this.cal_panel.base_params);
              //~ }
              //~ Ext.apply(options.params,p)
              //~ console.log('20130905 eventStore.load()',this.cal_panel,this.baseParams,options.params);
            
            return Ext.data.JsonStore.prototype.load.call(this,options);
          }
      });

      //~ Lino.calendarStore
      this.calendar_store = new Ext.data.JsonStore({ 
          listeners: { exception: Lino.on_store_exception }
          ,restful : true
          ,proxy: new Ext.data.HttpProxy({ 
              url: '/restful/extensible/PanelCalendars?fmt=json', 
              disableCaching: false // no need for cache busting when loading via Ajax
              //~ restful : true
              //~ method: "GET"
          })
          //~ ,autoLoad: true
          //~ ,remoteSort: true
          //~ ,baseParams: bp
          ,totalProperty: "count"
          ,root: "rows"
          ,fields: Ext.ensible.cal.CalendarRecord.prototype.fields.getRange()
          ,idProperty: Ext.ensible.cal.CalendarMappings.CalendarId.mapping
          //~ ,idIndex: Ext.ensible.cal.CalendarMappings.CalendarId.mapping
          ,load: function(options) {
              // new since 20140402 add substitute user when calling
              // calendars
              if (!options) options = {};
              if (!options.params) options.params = {};
              // Lino.insert_subst_user(options.params);
              Ext.apply(options.params, cap.get_base_params());
              // console.log("20140402 calendar_store.load", options.params, 
              //             this.cal_panel, cap.get_base_params());
            return Ext.data.JsonStore.prototype.load.call(this,options);
          }
      });
      
      cap = new Lino.CalendarAppPanel({ 
          app_instance: this, 
          items : 
        //~ [{
          //~ id: 'app-header',
          //~ region: 'north',
          //~ height: 35,
          //~ border: false,
          // contentEl: 'app-header-content'
        //~ },
      {
          id: 'app-center',
          title: '...', // will be updated to the current view's date range
          region: 'center',
          layout: 'border',
          listeners: {
              'afterrender': function(){
                  Ext.getCmp('app-center').header.addClass('app-center-header');
              }
          },
          items: [{
              id:'app-west',
              region: 'west',
              width: 176,
              border: false,
              items: [{
                  xtype: 'datepicker',
                  id: 'app-nav-picker',
                  cls: 'ext-cal-nav-picker',
                  listeners: {
                      'select': {
                          fn: function(dp, dt){
                              // console.log("20131017",dp);
                              //~ Lino.calendarPanel.setStartDate(dt);
                              //~ cap.setStartDate(dt);
                              Ext.getCmp('app-calendar').setStartDate(dt);
                          },
                          //~ scope: this
                      }
                  }
              //~ },{ 
                //~ layout:'fit',
                //~ items: [
                  //~ new Ext.form.Checkbox({
                    //~ boxLabel:"$_('Team view')",
                    //~ hideLabel:true
                    //~ listeners: { click: }
                  //~ })
                //~ ]
              //~ },{ 
                //~ layout:'form',
                //~ items: [
                  //~ this.team_view_button = new Ext.Button({
                    //~ text:"Team view",
                    //~ enableToggle:true,
                    //~ pressed:false,
                    //~ toggleHandler: function(btn,state) { 
                      //~ // console.log('20120716 teamView.toggle()');
                      //~ this.event_store.setBaseParam('tv',state);
                      //~ this.event_store.load();
                      //~ // console.log("team view",state);
                    //~ }
                  //~ })
                //~ ]
              },{
                  xtype: 'extensible.calendarlist',
                  store: this.calendar_store,
                  border: false,
                  width: 175
              }]
          },{
              xtype: 'extensible.calendarpanel', // Ext.ensible.cal.CalendarPanel
              eventStore: this.event_store,
              app_instance: this,
              calendarStore: this.calendar_store,
              border: false,
              id:'app-calendar',
              region: 'center',
              //~ activeItem: 3, // month view
              
              // Any generic view options that should be applied to all sub views:
              viewConfig: {
                  // Lino.CalendarCfg
                  dateParamFormat: 'd.m.Y',
                  dateParamStart:'sd',
                  dateParamEnd:'ed',
                
                  //enableFx: false,
                  //ddIncrement: 10, //only applies to DayView and subclasses, but convenient to put it here
                  viewStartHour: 9, // 8
                  viewEndHour: 21 // 18
                  //minEventDisplayMinutes: 15
              },
              
              // View options specific to a certain view (if the same options exist in viewConfig
              // they will be overridden by the view-specific config):
              monthViewCfg: {
                  showHeader: true,
                  showWeekLinks: true,
                  showWeekNumbers: true,
                  eventBodyMarkup: ['{Title}',
                    //~ '<tpl if="url">',
                        //~ '<a href="{url}">XX</a>',
                    //~ '</tpl>',
                    '<tpl if="_isReminder">',
                        '<i class="ext-cal-ic ext-cal-ic-rem">&#160;</i>',
                    '</tpl>',
                    '<tpl if="_isRecurring">',
                        '<i class="ext-cal-ic ext-cal-ic-rcr">&#160;</i>',
                    '</tpl>',
                    '<tpl if="spanLeft">',
                        '<i class="ext-cal-spl">&#160;</i>',
                    '</tpl>',
                    '<tpl if="spanRight">',
                        '<i class="ext-cal-spr">&#160;</i>',
                    '</tpl>'
                ].join('')
              },
              
              multiWeekViewCfg: {
                  //weekCount: 3
              },
              
              // Some optional CalendarPanel configs to experiment with:
              //readOnly: true,
              //showDayView: false,
              //showMultiDayView: true,
              //showWeekView: false,
              //showMultiWeekView: false,
              //showMonthView: false,
              //showNavBar: false,
              //showTodayText: false,
              //showTime: false,
              //editModal: true,
              //enableEditDetails: false,
              //title: 'My Calendar', // the header of the calendar, could be a subtitle for the app
              
              // Once this component inits it will set a reference to itself as an application
              // member property for easy reference in other functions within App.
              //~ initComponent: function() {
                  //~ Lino.calendarPanel = this;
                  //~ this.constructor.prototype.initComponent.apply(this, arguments);
              //~ },
              
              listeners: {
                  //~ 'eventclick': {
                      //~ fn: function(vw, rec, el){
                          //~ this.clearMsg();
                      //~ },
                      //~ scope: this
                  //~ },
                  'eventover': function(vw, rec, el){
                      //console.log('Entered evt rec='+rec.data[Ext.ensible.cal.EventMappings.Title.name]', view='+ vw.id +', el='+el.id);
                  },
                  'eventout': function(vw, rec, el){
                      //console.log('Leaving evt rec='+rec.data[Ext.ensible.cal.EventMappings.Title.name]+', view='+ vw.id +', el='+el.id);
                  },
                  'eventadd': {
                      fn: function(cp, rec){
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was added');
                      },
                      scope: this
                  },
                  'eventupdate': {
                      fn: function(cp, rec){
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was updated');
                      },
                      scope: this
                  },
                  'eventdelete': {
                      fn: function(cp, rec){
                          //this.eventStore.remove(rec);
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was deleted');
                      },
                      scope: this
                  },
                  'eventcancel': {
                      fn: function(cp, rec){
                          // edit canceled
                      },
                      scope: this
                  },
                  'viewchange': {
                      fn: function(p, vw, dateInfo){
                          if(this.editWin){
                              this.editWin.hide();
                          };
                          if(dateInfo !== null){
                              // will be null when switching to the event edit form so ignore
                              Ext.getCmp('app-nav-picker').setValue(dateInfo.activeDate);
                              this.updateTitle(dateInfo.viewStart, dateInfo.viewEnd);
                          }
                          
                      },
                      scope: this
                  },
                  'dayclick': {
                      fn: function(vw, dt, ad, el){
                          this.clearMsg();
                      },
                      scope: this
                  },
                  'rangeselect': {
                      fn: function(vw, dates, onComplete){
                          this.clearMsg();
                      },
                      scope: this
                  },
                  'eventmove': {
                      fn: function(vw, rec){
                          rec.commit();
                          var time = rec.data[Ext.ensible.cal.EventMappings.IsAllDay.name] ? '' : ' \\a\\t g:i a';
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was moved to '+
                              rec.data[Ext.ensible.cal.EventMappings.StartDate.name].format('F jS'+time));
                      },
                      scope: this
                  },
                  'eventresize': {
                      fn: function(vw, rec){
                          rec.commit();
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was updated');
                      },
                      scope: this
                  },
                  'eventdelete': {
                      fn: function(win, rec){
                          this.event_store.remove(rec);
                          this.showMsg('Event '+ rec.data[Ext.ensible.cal.EventMappings.Title.name] +' was deleted');
                      },
                      scope: this
                  },
                  'initdrag': {
                      fn: function(vw){
                          if(this.editWin && this.editWin.isVisible()){
                              this.editWin.hide();
                          }
                      },
                      scope: this
                  }
              }
          }]
        }
        //~ ]
        
      });
      
      this.event_store.on('load',function(){
        //~ console.log("20130905 on event_store load",this.event_store.reader.jsonData);
        if (this.event_store.reader.jsonData) {
          //~ console.log("20130808 b",this.event_store.reader.jsonData.title);
          //~ console.log("20130808 c",this);
          cap.set_window_title(this.event_store.reader.jsonData.title);
        }
      },this);
      
      //~ cap.app_instance = this;
      return cap;
      
  }
  ,updateTitle: function(startDt, endDt){
      var p = Ext.getCmp('app-center');
      
      if(startDt.clearTime().getTime() == endDt.clearTime().getTime()){
          p.setTitle(startDt.format('F j, Y'));
      }
      else if(startDt.getFullYear() == endDt.getFullYear()){
          if(startDt.getMonth() == endDt.getMonth()){
              p.setTitle(startDt.format('F j') + ' - ' + endDt.format('j, Y'));
          }
          else{
              p.setTitle(startDt.format('F j') + ' - ' + endDt.format('F j, Y'));
          }
      }
      else{
          p.setTitle(startDt.format('F j, Y') + ' - ' + endDt.format('F j, Y'));
      }
  }
  // This is an application-specific way to communicate CalendarPanel event messages back to the user.
  // This could be replaced with a function to do "toast" style messages, growl messages, etc. This will
  // vary based on application requirements, which is why it's not baked into the CalendarPanel.
  ,showMsg: function(msg){
      Lino.notify(msg);
      //~ Ext.fly('app-msg').update(msg).removeClass('x-hidden');
  }
  
  ,clearMsg: function(){
      Lino.notify('');
      //~ Ext.fly('app-msg').update('').addClass('x-hidden');
  }
}
};

Lino.main_menu = [ { "menu": { "items": [ { "handler": function() {Lino.contacts.Persons.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of all Persons.") }, "text": "Persons" }, { "handler": function() {Lino.contacts.Companies.grid.run(null)}, "text": "Organizations" }, { "handler": function() {Lino.contacts.Partners.grid.run(null)}, "text": "Partners" }, { "handler": function() {Lino.lists.Lists.grid.run(null)}, "text": "Partner Lists" } ] }, "text": "Contacts" }, { "menu": { "items": [ { "handler": function() {Lino.plausibility.MyProblems.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows the plausibility problems assigned to this user.") }, "text": "Plausibility problems assigned to me" }, { "handler": function() {Lino.notify.MyMessages.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows messages emitted to you.") }, "text": "My Notification messages" }, { "handler": function() {Lino.notes.MyNotes.grid.run(null)}, "text": "My Notes" }, { "handler": function() {Lino.uploads.MyUploads.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows only my Uploads (i.e. those whose author is current user).") }, "text": "My Uploads" }, { "handler": function() {Lino.outbox.MyOutbox.grid.run(null)}, "text": "My Outbox" }, { "handler": function() {Lino.excerpts.MyExcerpts.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for all tables on Excerpt.") }, "text": "My Excerpts" } ] }, "text": "Office" }, { "menu": { "items": [ { "handler": function() {Lino.cal.MyEntries.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Table which shows today's and all future appointments of the\nrequesting user.  The default filter parameters are set to show\nonly appointments.") }, "text": "My appointments" }, { "handler": function() {Lino.cal.MyUnconfirmedAppointments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows appointments in the near future which are still in draft\nstate.") }, "text": "Unconfirmed appointments" }, { "handler": function() {Lino.cal.MyTasks.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Table of all my tasks.") }, "text": "My tasks" }, { "handler": function() {Lino.cal.MyGuests.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table for Guest.") }, "text": "My guests" }, { "handler": function() {Lino.cal.MyPresences.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all my presences in calendar events, independently of their\nstate.") }, "text": "My presences" }, { "handler": function() {Lino.cal.MyOverdueAppointments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Like OverdueAppointments, but only for myself.") }, "text": "My overdue appointments" }, { "handler": function() {Lino.extensible.CalendarPanel.grid.run(null)}, "iconCls": "x-tbar-calendar", "listeners": { "render": Lino.quicktip_renderer("Foo","Displays your events in a \"calendar view\"     with the possibility to switch between daily, weekly, monthly view.") }, "text": "Calendar" } ] }, "text": "Calendar" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.sales.InvoicesByJournal.grid.run(null,{ "base_params": { "mk": 1, "mt": 37 }, "param_values": { "cleared": null, "clearedHidden": null, "partner": null, "partnerHidden": null, "state": null, "stateHidden": null, "year": null, "yearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all invoices of a given journal (whose voucher_type must be\nVatProductInvoice)") }, "text": "Sales invoices (SLS)" }, { "handler": function() {Lino.sales.InvoicesByJournal.grid.run(null,{ "base_params": { "mk": 2, "mt": 37 }, "param_values": { "cleared": null, "clearedHidden": null, "partner": null, "partnerHidden": null, "state": null, "stateHidden": null, "year": null, "yearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all invoices of a given journal (whose voucher_type must be\nVatProductInvoice)") }, "text": "Sales credit notes (SLC)" } ] }, "text": "Sales" }, { "menu": { "items": [ { "handler": function() {Lino.vat.InvoicesByJournal.grid.run(null,{ "base_params": { "mk": 3, "mt": 37 }, "param_values": { "partner": null, "partnerHidden": null, "state": null, "stateHidden": null, "year": null, "yearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all invoices of a given journal (whose\nvoucher_type\nmust be lino_xl.lib.vat.models.VatAccountInvoice)") }, "text": "Purchase invoices (PRC)" } ] }, "text": "Purchases" }, { "menu": { "items": [ { "handler": function() {Lino.finan.PaymentOrdersByJournal.grid.run(null,{ "base_params": { "mk": 4, "mt": 37 }, "param_values": { "pjournal": null, "pjournalHidden": null, "pyear": null, "pyearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table of all PaymentOrder vouchers.") }, "text": "Payment Orders (PMO)" }, { "handler": function() {Lino.finan.BankStatementsByJournal.grid.run(null,{ "base_params": { "mk": 5, "mt": 37 }, "param_values": { "pjournal": null, "pjournalHidden": null, "pyear": null, "pyearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table of all BankStatement vouchers.") }, "text": "Cash (CSH)" }, { "handler": function() {Lino.finan.BankStatementsByJournal.grid.run(null,{ "base_params": { "mk": 6, "mt": 37 }, "param_values": { "pjournal": null, "pjournalHidden": null, "pyear": null, "pyearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table of all BankStatement vouchers.") }, "text": "Bestbank (BNK)" }, { "handler": function() {Lino.finan.JournalEntriesByJournal.grid.run(null,{ "base_params": { "mk": 7, "mt": 37 }, "param_values": { "pjournal": null, "pjournalHidden": null, "pyear": null, "pyearHidden": null } })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for the default tables of all other financial voucher\ntypes (JournalEntries , PaymentOrders and\nBankStatemens).") }, "text": "Miscellaneous Journal Entries (MSC)" } ] }, "text": "Financial" }, { "handler": function() {Lino.list_action_handler('/invoicing/Plans','start_invoicing','POST',null)()}, "iconCls": "x-tbar-basket", "listeners": { "render": Lino.quicktip_renderer("Foo","Base for StartInvoicingForJournal,\nStartInvoicingForPartner.") }, "text": "Create invoices" } ] }, "text": "Accounting" }, { "menu": { "items": [ { "handler": function() {Lino.courses.Pupils.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The global list of all pupils.") }, "text": "Participants" }, { "handler": function() {Lino.courses.Teachers.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of all Persons.") }, "text": "Instructors" }, "-", { "handler": function() {Lino.courses.Courses.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Courses" }, { "handler": function() {Lino.courses.Hikes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Hikes" }, { "handler": function() {Lino.courses.Journeys.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Journeys" }, "-", { "handler": function() {Lino.courses.Lines.grid.run(null)}, "text": "Activity lines" }, "-", { "handler": function() {Lino.courses.PendingRequestedEnrolments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show all requested enrolments.") }, "text": "Pending requested enrolments" }, { "handler": function() {Lino.courses.PendingConfirmedEnrolments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show all confirmed enrolments.") }, "text": "Pending confirmed enrolments" } ] }, "text": "Activities" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.ledger.Situation.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Overview of the financial situation on a given date.") }, "text": "Situation" }, { "handler": function() {Lino.ledger.ActivityReport.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Overview of the financial activity during a given period.") }, "text": "Activity Report" }, { "handler": function() {Lino.ledger.Debtors.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of partners who are in debt towards us (usually customers).") }, "text": "Debtors" }, { "handler": function() {Lino.ledger.Creditors.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","List of partners who are giving credit to us (usually suppliers).") }, "text": "Creditors" } ] }, "text": "Accounting" }, { "menu": { "items": [ { "handler": function() {Lino.sales.DueInvoices.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Shows all due product invoices.") }, "text": "Due invoices" } ] }, "text": "VAT" }, { "menu": { "items": [ { "handler": function() {Lino.courses.StatusReport.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Gives an overview about what's up today .") }, "text": "Status Report" } ] }, "text": "Activities" } ] }, "text": "Reports" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.system.SiteConfigs.detail.run(null,{ "record_id": 1 })}, "iconCls": "x-tbar-application_form", "text": "Site Parameters" }, { "handler": function() {Lino.gfks.HelpTexts.grid.run(null)}, "text": "Help Texts" } ] }, "text": "System" }, { "menu": { "items": [ { "handler": function() {Lino.countries.Countries.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The table of all countries.") }, "text": "Countries" }, { "handler": function() {Lino.countries.Places.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","\n    The table of known geographical places.\n    A geographical place can be a city, a town, a suburb,\n    a province, a lake... any named geographic entity,\n    except for countries because these have their own table.\n    ") }, "text": "Places" } ] }, "text": "Places" }, { "menu": { "items": [ { "handler": function() {Lino.contacts.CompanyTypes.grid.run(null)}, "text": "Organization types" }, { "handler": function() {Lino.contacts.RoleTypes.grid.run(null)}, "text": "Functions" }, { "handler": function() {Lino.lists.ListTypes.grid.run(null)}, "text": "List Types" } ] }, "text": "Contacts" }, { "menu": { "items": [ { "handler": function() {Lino.cal.GuestRoles.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The role of a guest expresses what the partner is going to do there.") }, "text": "Guest Roles" } ] }, "text": "Calendar" }, { "menu": { "items": [ { "handler": function() {Lino.products.Products.grid.run(null)}, "text": "Tariffs" }, { "handler": function() {Lino.products.ProductCats.grid.run(null)}, "text": "Tariff Categories" } ] }, "text": "Tariffs" }, { "menu": { "items": [ { "handler": function() {Lino.courses.CourseTypes.grid.run(null)}, "text": "Activity types" }, { "handler": function() {Lino.courses.TeacherTypes.grid.run(null)}, "text": "Instructor Types" }, { "handler": function() {Lino.courses.PupilTypes.grid.run(null)}, "text": "Participant Types" } ] }, "text": "Activities" } ] }, "text": "Configure" }, { "menu": { "items": [ { "menu": { "items": [ { "handler": function() {Lino.gfks.ContentTypes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Default table for django.contrib.ContentType.") }, "text": "content types" }, { "handler": function() {Lino.plausibility.Checkers.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The list of plausibility problem types known by this application.") }, "text": "Plausibility checkers" }, { "handler": function() {Lino.plausibility.AllProblems.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show all plausibility problems.") }, "text": "Plausibility problems" }, { "handler": function() {Lino.changes.Changes.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table for Change.") }, "text": "Changes" } ] }, "text": "System" }, { "menu": { "items": [ { "handler": function() {Lino.contacts.Roles.grid.run(null)}, "text": "Contact Persons" }, { "handler": function() {Lino.lists.AllMembers.grid.run(null)}, "text": "List memberships" } ] }, "text": "Contacts" }, { "menu": { "items": [ { "handler": function() {Lino.cal.AllEntries.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Table which shows all calendar events.") }, "text": "Calendar entries" }, { "handler": function() {Lino.cal.AllGuests.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The default table for Guest.") }, "text": "Presences" }, { "handler": function() {Lino.cal.EntryStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","The possible states of a calendar event.") }, "text": "Event states" }, { "handler": function() {Lino.cal.GuestStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Possible values for the state of a Guest. The list of choices for\nthe Guest.state field.") }, "text": "Guest states" }, { "handler": function() {Lino.cal.TaskStates.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Possible values for the state of a Task. The list of\nchoices for the Task.state field. By default it contains\nthe following values (which can be redefined in\nworkflows_module):") }, "text": "Task states" } ] }, "text": "Calendar" }, { "menu": { "items": [ { "handler": function() {Lino.sales.Invoices.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base class for tables of partner vouchers.") }, "text": "Product invoices" } ] }, "text": "VAT" }, { "menu": { "items": [ { "handler": function() {Lino.courses.AllActivities.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Base table for all activities.") }, "text": "Activities" }, { "handler": function() {Lino.courses.AllEnrolments.grid.run(null)}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show global list of all enrolments.") }, "text": "Enrolments" } ] }, "text": "Activities" } ] }, "text": "Explorer" }, { "menu": { "items": [ { "handler": function() {Lino.about.About.show.run(null,{ "record_id": -99998 })}, "listeners": { "render": Lino.quicktip_renderer("Foo","Show information about this site.") }, "text": "About" } ] }, "text": "Site" }, { "handler": function() {Lino.handle_home_button()}, "text": "Home" } ];
Ext.namespace('Lino.system.SiteConfigs')
Ext.namespace('Lino.countries.Countries')
Ext.namespace('Lino.countries.Places')
Ext.namespace('Lino.contacts.Partners')
Ext.namespace('Lino.contacts.Persons')
Ext.namespace('Lino.contacts.CompanyTypes')
Ext.namespace('Lino.contacts.Companies')
Ext.namespace('Lino.contacts.RoleTypes')
Ext.namespace('Lino.contacts.Roles')
Ext.namespace('Lino.lists.ListTypes')
Ext.namespace('Lino.lists.Lists')
Ext.namespace('Lino.lists.Members')
Ext.namespace('Lino.lists.AllMembers')
Ext.namespace('Lino.gfks.ContentTypes')
Ext.namespace('Lino.gfks.HelpTexts')
Ext.namespace('Lino.plausibility.Problems')
Ext.namespace('Lino.plausibility.AllProblems')
Ext.namespace('Lino.plausibility.MyProblems')
Ext.namespace('Lino.cal.RemoteCalendars')
Ext.namespace('Lino.cal.AllRooms')
Ext.namespace('Lino.cal.Priorities')
Ext.namespace('Lino.cal.Calendars')
Ext.namespace('Lino.cal.Subscriptions')
Ext.namespace('Lino.cal.Tasks')
Ext.namespace('Lino.cal.MyTasks')
Ext.namespace('Lino.cal.GuestRoles')
Ext.namespace('Lino.cal.Guests')
Ext.namespace('Lino.cal.AllGuests')
Ext.namespace('Lino.cal.MyPresences')
Ext.namespace('Lino.cal.MyPendingPresences')
Ext.namespace('Lino.cal.MyGuests')
Ext.namespace('Lino.cal.EventTypes')
Ext.namespace('Lino.cal.RecurrentEvents')
Ext.namespace('Lino.cal.Events')
Ext.namespace('Lino.cal.AllEntries')
Ext.namespace('Lino.cal.PublicEntries')
Ext.namespace('Lino.cal.EntriesByDay')
Ext.namespace('Lino.cal.OneEvent')
Ext.namespace('Lino.cal.MyEntriesToday')
Ext.namespace('Lino.cal.MyAssignedEvents')
Ext.namespace('Lino.cal.OverdueAppointments')
Ext.namespace('Lino.cal.MyOverdueAppointments')
Ext.namespace('Lino.cal.MyUnconfirmedAppointments')
Ext.namespace('Lino.cal.EventPolicies')
Ext.namespace('Lino.cal.Rooms')
Ext.namespace('Lino.cal.MyEntries')
Ext.namespace('Lino.ledger.Journals')
Ext.namespace('Lino.ledger.AccountingPeriods')
Ext.namespace('Lino.ledger.PaymentTerms')
Ext.namespace('Lino.ledger.Vouchers')
Ext.namespace('Lino.ledger.AllVouchers')
Ext.namespace('Lino.ledger.MatchRules')
Ext.namespace('Lino.ledger.PartnerVouchers')
Ext.namespace('Lino.ledger.Movements')
Ext.namespace('Lino.ledger.AllMovements')
Ext.namespace('Lino.vat.VatRules')
Ext.namespace('Lino.vat.Invoices')
Ext.namespace('Lino.products.ProductCats')
Ext.namespace('Lino.products.Products')
Ext.namespace('Lino.rooms.Bookings')
Ext.namespace('Lino.accounts.Groups')
Ext.namespace('Lino.accounts.Accounts')
Ext.namespace('Lino.sales.PaperTypes')
Ext.namespace('Lino.sales.SalesDocuments')
Ext.namespace('Lino.sales.Invoices')
Ext.namespace('Lino.sales.DueInvoices')
Ext.namespace('Lino.sales.InvoiceItems')
Ext.namespace('Lino.sales.DocumentsToSign')
Ext.namespace('Lino.invoicing.Plans')
Ext.namespace('Lino.invoicing.MyPlans')
Ext.namespace('Lino.invoicing.AllPlans')
Ext.namespace('Lino.invoicing.Items')
Ext.namespace('Lino.finan.FinancialVouchers')
Ext.namespace('Lino.finan.JournalEntries')
Ext.namespace('Lino.finan.PaymentOrders')
Ext.namespace('Lino.finan.BankStatements')
Ext.namespace('Lino.finan.AllBankStatements')
Ext.namespace('Lino.finan.AllJournalEntries')
Ext.namespace('Lino.finan.AllPaymentOrders')
Ext.namespace('Lino.sepa.Accounts')
Ext.namespace('Lino.notify.Messages')
Ext.namespace('Lino.notify.AllMessages')
Ext.namespace('Lino.notify.MyMessages')
Ext.namespace('Lino.notes.NoteTypes')
Ext.namespace('Lino.notes.EventTypes')
Ext.namespace('Lino.notes.Notes')
Ext.namespace('Lino.notes.AllNotes')
Ext.namespace('Lino.notes.MyNotes')
Ext.namespace('Lino.uploads.UploadTypes')
Ext.namespace('Lino.uploads.Uploads')
Ext.namespace('Lino.uploads.AllUploads')
Ext.namespace('Lino.uploads.MyUploads')
Ext.namespace('Lino.uploads.AreaUploads')
Ext.namespace('Lino.outbox.Recipients')
Ext.namespace('Lino.outbox.Mails')
Ext.namespace('Lino.outbox.Attachments')
Ext.namespace('Lino.excerpts.ExcerptTypes')
Ext.namespace('Lino.excerpts.Excerpts')
Ext.namespace('Lino.excerpts.AllExcerpts')
Ext.namespace('Lino.excerpts.MyExcerpts')
Ext.namespace('Lino.extensible.PanelCalendars')
Ext.namespace('Lino.extensible.PanelEvents')
Ext.namespace('Lino.changes.Changes')
Ext.namespace('Lino.users.Users')
Ext.namespace('Lino.users.AllUsers')
Ext.namespace('Lino.users.UsersOverview')
Ext.namespace('Lino.users.MySettings')
Ext.namespace('Lino.users.Authorities')
Ext.namespace('Lino.courses.Slots')
Ext.namespace('Lino.courses.Topics')
Ext.namespace('Lino.courses.Lines')
Ext.namespace('Lino.courses.Activities')
Ext.namespace('Lino.courses.Courses')
Ext.namespace('Lino.courses.AllActivities')
Ext.namespace('Lino.courses.MyActivities')
Ext.namespace('Lino.courses.DraftCourses')
Ext.namespace('Lino.courses.ActiveCourses')
Ext.namespace('Lino.courses.InactiveCourses')
Ext.namespace('Lino.courses.ClosedCourses')
Ext.namespace('Lino.courses.Enrolments')
Ext.namespace('Lino.courses.AllEnrolments')
Ext.namespace('Lino.courses.PendingConfirmedEnrolments')
Ext.namespace('Lino.courses.TeacherTypes')
Ext.namespace('Lino.courses.PupilTypes')
Ext.namespace('Lino.courses.CourseTypes')
Ext.namespace('Lino.courses.PendingRequestedEnrolments')
Ext.namespace('Lino.courses.Teachers')
Ext.namespace('Lino.courses.Pupils')
Ext.namespace('Lino.courses.Hikes')
Ext.namespace('Lino.courses.Journeys')
Ext.namespace('Lino.sessions.SessionTable')
Ext.namespace('Lino.vat.InvoiceItemTable')
Ext.namespace('Lino.finan.JournalEntryItemTable')
Ext.namespace('Lino.finan.BankStatementItemTable')
Ext.namespace('Lino.finan.PaymentOrderItemTable')
Ext.namespace('Lino.countries.PlacesByPlace')
Ext.namespace('Lino.countries.PlacesByCountry')
Ext.namespace('Lino.contacts.PartnersByCity')
Ext.namespace('Lino.contacts.PartnersByCountry')
Ext.namespace('Lino.contacts.RolesByCompany')
Ext.namespace('Lino.contacts.RolesByPerson')
Ext.namespace('Lino.lists.MembersByList')
Ext.namespace('Lino.lists.MembersByPartner')
Ext.namespace('Lino.plausibility.ProblemsByChecker')
Ext.namespace('Lino.cal.SubscriptionsByUser')
Ext.namespace('Lino.cal.SubscriptionsByCalendar')
Ext.namespace('Lino.cal.TasksByUser')
Ext.namespace('Lino.cal.GuestsByEvent')
Ext.namespace('Lino.cal.GuestsByRole')
Ext.namespace('Lino.cal.GuestsByPartner')
Ext.namespace('Lino.cal.EntriesByType')
Ext.namespace('Lino.cal.ConflictingEvents')
Ext.namespace('Lino.cal.EntriesByRoom')
Ext.namespace('Lino.ledger.MatchRulesByAccount')
Ext.namespace('Lino.ledger.MatchRulesByJournal')
Ext.namespace('Lino.ledger.MovementsByVoucher')
Ext.namespace('Lino.ledger.MovementsByPartner')
Ext.namespace('Lino.ledger.MovementsByAccount')
Ext.namespace('Lino.ledger.MovementsByMatch')
Ext.namespace('Lino.vat.InvoicesByJournal')
Ext.namespace('Lino.vat.ItemsByInvoice')
Ext.namespace('Lino.products.ProductsByCategory')
Ext.namespace('Lino.rooms.BookingsByCompany')
Ext.namespace('Lino.accounts.AccountsByGroup')
Ext.namespace('Lino.sales.PartnersByInvoiceRecipient')
Ext.namespace('Lino.sales.InvoicesByJournal')
Ext.namespace('Lino.sales.ItemsByInvoice')
Ext.namespace('Lino.sales.ItemsByInvoicePrint')
Ext.namespace('Lino.sales.ItemsByInvoicePrintNoQtyColumn')
Ext.namespace('Lino.sales.InvoiceItemsByProduct')
Ext.namespace('Lino.sales.InvoicesByPartner')
Ext.namespace('Lino.invoicing.ItemsByPlan')
Ext.namespace('Lino.finan.PaymentOrdersByJournal')
Ext.namespace('Lino.finan.JournalEntriesByJournal')
Ext.namespace('Lino.finan.BankStatementsByJournal')
Ext.namespace('Lino.finan.ItemsByJournalEntry')
Ext.namespace('Lino.finan.ItemsByBankStatement')
Ext.namespace('Lino.finan.ItemsByPaymentOrder')
Ext.namespace('Lino.sepa.AccountsByPartner')
Ext.namespace('Lino.notes.NotesByType')
Ext.namespace('Lino.notes.NotesByEventType')
Ext.namespace('Lino.notes.NotesByCompany')
Ext.namespace('Lino.notes.NotesByPerson')
Ext.namespace('Lino.uploads.UploadsByType')
Ext.namespace('Lino.outbox.RecipientsByMail')
Ext.namespace('Lino.outbox.MyOutbox')
Ext.namespace('Lino.outbox.MailsByUser')
Ext.namespace('Lino.outbox.SentByPartner')
Ext.namespace('Lino.outbox.AttachmentsByMail')
Ext.namespace('Lino.excerpts.ExcerptsByType')
Ext.namespace('Lino.users.AuthoritiesGiven')
Ext.namespace('Lino.users.AuthoritiesTaken')
Ext.namespace('Lino.courses.LinesByTopic')
Ext.namespace('Lino.courses.EntriesByTeacher')
Ext.namespace('Lino.courses.CoursesByTeacher')
Ext.namespace('Lino.courses.MyCoursesGiven')
Ext.namespace('Lino.courses.CoursesBySlot')
Ext.namespace('Lino.courses.EnrolmentsByOption')
Ext.namespace('Lino.courses.EnrolmentsByPupil')
Ext.namespace('Lino.courses.EnrolmentsByCourse')
Ext.namespace('Lino.courses.EnrolmentsByFee')
Ext.namespace('Lino.courses.TeachersByType')
Ext.namespace('Lino.courses.PupilsByType')
Ext.namespace('Lino.courses.CoursesByTopic')
Ext.namespace('Lino.courses.CoursesByLine')
Ext.namespace('Lino.courses.LinesByType')
Ext.namespace('Lino.courses.EnrolmentsAndPaymentsByCourse')
Ext.namespace('Lino.courses.EnrolmentsByHike')
Ext.namespace('Lino.courses.EnrolmentsByJourney')
Ext.namespace('Lino.uploads.UploadsByController')
Ext.namespace('Lino.changes.ChangesByObject')
Ext.namespace('Lino.invoicing.InvoicingsByInvoiceable')
Ext.namespace('Lino.notes.NotesByOwner')
Ext.namespace('Lino.cal.TasksByController')
Ext.namespace('Lino.gfks.HelpTextsByModel')
Ext.namespace('Lino.outbox.MailsByController')
Ext.namespace('Lino.plausibility.ProblemsByOwner')
Ext.namespace('Lino.changes.ChangesByMaster')
Ext.namespace('Lino.cal.EntriesByController')
Ext.namespace('Lino.outbox.AttachmentsByController')
Ext.namespace('Lino.courses.EntriesByCourse')
Ext.namespace('Lino.excerpts.ExcerptsByOwner')
Ext.namespace('Lino.about.Models')
Ext.namespace('Lino.about.FieldsByModel')
Ext.namespace('Lino.about.Inspector')
Ext.namespace('Lino.about.SourceFiles')
Ext.namespace('Lino.ipdict.Connections')
Ext.namespace('Lino.gfks.BrokenGFKs')
Ext.namespace('Lino.gfks.BrokenGFKsByModel')
Ext.namespace('Lino.ledger.ExpectedMovements')
Ext.namespace('Lino.ledger.DebtsByAccount')
Ext.namespace('Lino.ledger.DebtsByPartner')
Ext.namespace('Lino.ledger.GeneralAccountsBalance')
Ext.namespace('Lino.ledger.PartnerAccountsBalance')
Ext.namespace('Lino.ledger.CustomerAccountsBalance')
Ext.namespace('Lino.ledger.SupplierAccountsBalance')
Ext.namespace('Lino.ledger.Debtors')
Ext.namespace('Lino.ledger.Creditors')
Ext.namespace('Lino.vat.VouchersByPartner')
Ext.namespace('Lino.finan.SuggestionsByVoucher')
Ext.namespace('Lino.finan.SuggestionsByJournalEntry')
Ext.namespace('Lino.finan.SuggestionsByPaymentOrder')
Ext.namespace('Lino.finan.SuggestionsByBankStatement')
Ext.namespace('Lino.finan.SuggestionsByVoucherItem')
Ext.namespace('Lino.finan.SuggestionsByBankStatementItem')
Ext.namespace('Lino.finan.SuggestionsByPaymentOrderItem')
Ext.namespace('Lino.about.About')
Ext.namespace('Lino.ledger.Situation')
Ext.namespace('Lino.ledger.ActivityReport')
Ext.namespace('Lino.extensible.CalendarPanel')
Ext.namespace('Lino.courses.StatusReport')
Ext.namespace('Lino.plausibility.Checkers')
Ext.namespace('Lino.notes.SpecialTypes')
Ext.namespace('Lino.notify.MailModes')
Ext.namespace('Lino.vat.VatClasses')
Ext.namespace('Lino.beid.CivilStates')
Ext.namespace('Lino.ledger.TradeTypes')
Ext.namespace('Lino.changes.ChangeTypes')
Ext.namespace('Lino.cal.DurationUnits')
Ext.namespace('Lino.courses.Sections')
Ext.namespace('Lino.cal.TaskStates')
Ext.namespace('Lino.ledger.JournalGroups')
Ext.namespace('Lino.cal.Weekdays')
Ext.namespace('Lino.rooms.BookingStates')
Ext.namespace('Lino.ledger.FiscalYears')
Ext.namespace('Lino.beid.BeIdCardTypes')
Ext.namespace('Lino.excerpts.Shortcuts')
Ext.namespace('Lino.system.PeriodEvents')
Ext.namespace('Lino.notify.MessageTypes')
Ext.namespace('Lino.beid.ResidenceTypes')
Ext.namespace('Lino.accounts.AccountTypes')
Ext.namespace('Lino.cal.Recurrencies')
Ext.namespace('Lino.system.Genders')
Ext.namespace('Lino.uploads.Shortcuts')
Ext.namespace('Lino.courses.EnrolmentStates')
Ext.namespace('Lino.ledger.VoucherStates')
Ext.namespace('Lino.ledger.PeriodStates')
Ext.namespace('Lino.cal.EventEvents')
Ext.namespace('Lino.cal.GuestStates')
Ext.namespace('Lino.products.DeliveryUnit')
Ext.namespace('Lino.vat.VatRegimes')
Ext.namespace('Lino.ledger.VoucherTypes')
Ext.namespace('Lino.printing.BuildMethods')
Ext.namespace('Lino.cal.EntryStates')
Ext.namespace('Lino.uploads.UploadAreas')
Ext.namespace('Lino.outbox.RecipientTypes')
Ext.namespace('Lino.cal.AccessClasses')
Ext.namespace('Lino.system.YesNo')
Ext.namespace('Lino.courses.CourseAreas')
Ext.namespace('Lino.users.UserTypes')
Ext.namespace('Lino.contacts.PartnerEvents')
Ext.namespace('Lino.courses.CourseStates')
Ext.namespace('Lino.countries.PlaceTypes')

// ChoiceLists: 
Lino.plausibility.Checkers = [ [ "printing.CachedPrintableChecker", "Check for missing target files" ], [ "countries.PlaceChecker", "Check plausibility of geographical places." ], [ "beid.BeIdCardHolderChecker", "Check for invalid SSINs" ], [ "cal.EventGuestChecker", "Entries without participants" ], [ "cal.ConflictingEventsChecker", "Check for conflicting calendar entries" ], [ "cal.ObsoleteEventTypeChecker", "Obsolete event type of generated entries" ], [ "cal.LongEntryChecker", "Too long-lasting calendar entries" ], [ "ledger.VoucherChecker", "Check integrity of ledger movements" ], [ "sepa.BankAccountChecker", "Check for partner mismatches in bank accounts" ], [ "courses.MemberChecker", "Check membership payments" ] ];
Lino.notes.SpecialTypes = [  ];
Lino.notify.MailModes = [ [ "never", "Never" ], [ "immediately", "Immediately" ], [ "often", "Often" ], [ "daily", "Daily" ], [ "weekly", "Weekly" ] ];
Lino.vat.VatClasses = [ [ "0", "Exempt" ], [ "1", "Reduced" ], [ "2", "Normal" ] ];
Lino.beid.CivilStates = [ [ "10", "Single" ], [ "20", "Married" ], [ "30", "Widowed" ], [ "40", "Divorced" ], [ "50", "Separated" ], [ "51", "De facto separated" ], [ "60", "Cohabitating" ] ];
Lino.ledger.TradeTypes = [ [ "S", "Sales" ], [ "P", "Purchases" ], [ "W", "Wages" ], [ "C", "Clearings" ] ];
Lino.changes.ChangeTypes = [ [ "C", "Create" ], [ "U", "Update" ], [ "D", "Delete" ], [ "R", "Remove child" ], [ "A", "Add child" ], [ "M", "Merge" ] ];
Lino.cal.DurationUnits = [ [ "s", "seconds" ], [ "m", "minutes" ], [ "h", "hours" ], [ "D", "days" ], [ "W", "weeks" ], [ "M", "months" ], [ "Y", "years" ] ];
Lino.courses.Sections = [ [ "eupen", "Eupen" ], [ "nidrum", "Nidrum" ], [ "walhorn", "Walhorn" ], [ "herresbach", "Herresbach" ], [ "eynatten", "Eynatten" ], [ "kelmis", "Kelmis" ], [ "hergenrath", "Hergenrath" ], [ "hauset", "Hauset" ], [ "elsenborn", "Elsenborn" ], [ "weywertz", "Weywertz" ], [ "etc", "Sonstige" ] ];
Lino.cal.TaskStates = [ [ "10", "To do" ], [ "15", "Important" ], [ "20", "Started" ], [ "30", "Done" ], [ "50", "Cancelled" ] ];
Lino.ledger.JournalGroups = [ [ "10", "Sales" ], [ "20", "Purchases" ], [ "30", "Wages" ], [ "40", "Financial" ] ];
Lino.cal.Weekdays = [ [ "1", "Monday" ], [ "2", "Tuesday" ], [ "3", "Wednesday" ], [ "4", "Thursday" ], [ "5", "Friday" ], [ "6", "Saturday" ], [ "7", "Sunday" ] ];
Lino.rooms.BookingStates = [ [ "10", "Draft" ], [ "20", "Option" ], [ "30", "Registered" ], [ "40", "Cancelled" ] ];
Lino.ledger.FiscalYears = [ [ "14", "2014" ], [ "15", "2015" ], [ "16", "2016" ], [ "17", "2017" ], [ "18", "2018" ], [ "19", "2019" ], [ "20", "2020" ] ];
Lino.beid.BeIdCardTypes = [ [ "1", "Belgian citizen" ], [ "6", "Kids card (< 12 year)" ], [ "11", "Foreigner card A" ], [ "12", "Foreigner card B" ], [ "13", "Foreigner card C" ], [ "14", "Foreigner card D" ], [ "15", "Foreigner card E" ], [ "16", "Foreigner card E+" ], [ "17", "Foreigner card F" ], [ "18", "Foreigner card F+" ] ];
Lino.excerpts.Shortcuts = [  ];
Lino.system.PeriodEvents = [ [ "10", "Starts" ], [ "20", "Is active" ], [ "30", "Ends" ] ];
Lino.notify.MessageTypes = [ [ "100", "System event" ], [ "200", "Change" ], [ "300", "Action" ] ];
Lino.beid.ResidenceTypes = [ [ "1", "Registry of citizens" ], [ "2", "Registry of foreigners" ], [ "3", "Waiting for registry" ] ];
Lino.accounts.AccountTypes = [ [ "A", "Assets" ], [ "L", "Liabilities" ], [ "I", "Incomes" ], [ "E", "Expenses" ], [ "C", "Capital" ], [ "B", "Bank accounts" ] ];
Lino.cal.Recurrencies = [ [ "O", "once" ], [ "D", "daily" ], [ "W", "weekly" ], [ "M", "monthly" ], [ "Y", "yearly" ], [ "P", "per weekday" ], [ "E", "Relative to Easter" ] ];
Lino.system.Genders = [ [ "M", "Male" ], [ "F", "Female" ] ];
Lino.uploads.Shortcuts = [  ];
Lino.courses.EnrolmentStates = [ [ "10", "Requested" ], [ "11", "Trying" ], [ "20", "Confirmed" ], [ "30", "Cancelled" ] ];
Lino.ledger.VoucherStates = [ [ "10", "Draft" ], [ "20", "Registered" ], [ "30", "Signed" ], [ "40", "Cancelled" ] ];
Lino.ledger.PeriodStates = [ [ "10", "Open" ], [ "20", "Closed" ] ];
Lino.cal.EventEvents = [ [ "10", "Stable" ], [ "20", "Unstable" ] ];
Lino.cal.GuestStates = [ [ "10", "Invited" ], [ "40", "Present" ], [ "50", "Absent" ], [ "60", "Excused" ] ];
Lino.products.DeliveryUnit = [ [ "10", "Hour" ], [ "20", "Piece" ], [ "30", "Kg" ] ];
Lino.vat.VatRegimes = [ [ "10", "Private person" ], [ "11", "Private person (reduced)" ], [ "20", "Subject to VAT" ], [ "25", "Co-contractor" ], [ "30", "Intra-community" ], [ "40", "Outside EU" ], [ "50", "Exempt" ], [ "70", "Germany" ], [ "71", "Luxemburg" ] ];
Lino.ledger.VoucherTypes = [ [ "vat.InvoicesByJournal", "Invoice (vat.InvoicesByJournal)" ], [ "finan.JournalEntriesByJournal", "Journal Entry (finan.JournalEntriesByJournal)" ], [ "finan.PaymentOrdersByJournal", "Payment Order (finan.PaymentOrdersByJournal)" ], [ "finan.BankStatementsByJournal", "Bank Statement (finan.BankStatementsByJournal)" ], [ "sales.InvoicesByJournal", "Product invoice (sales.InvoicesByJournal)" ] ];
Lino.printing.BuildMethods = [ [ "latex", "LatexBuildMethod" ], [ "pisa", "PisaBuildMethod" ], [ "rtf", "RtfBuildMethod" ], [ "weasy2html", "WeasyHtmlBuildMethod" ], [ "weasy2pdf", "WeasyPdfBuildMethod" ], [ "wkhtmltopdf", "WkBuildMethod" ], [ "appyodt", "AppyOdtBuildMethod" ], [ "appydoc", "AppyDocBuildMethod" ], [ "appypdf", "AppyPdfBuildMethod" ], [ "appyrtf", "AppyRtfBuildMethod" ] ];
Lino.cal.EntryStates = [ [ "10", "Suggested" ], [ "20", "Draft" ], [ "50", "Took place" ], [ "70", "Cancelled" ] ];
Lino.uploads.UploadAreas = [ [ "90", "Uploads" ] ];
Lino.outbox.RecipientTypes = [ [ "to", "to" ], [ "cc", "cc" ], [ "bcc", "bcc" ] ];
Lino.cal.AccessClasses = [ [ "10", "Private" ], [ "20", "Show busy" ], [ "30", "Public" ] ];
Lino.system.YesNo = [ [ "y", "Yes" ], [ "n", "No" ] ];
Lino.courses.CourseAreas = [ [ "C", "Courses" ], [ "H", "Hikes" ], [ "J", "Journeys" ] ];
Lino.users.UserTypes = [ [ "000", "000 (Anonymous)" ], [ "100", "100 (User)" ], [ "200", "200 (Secretary)" ], [ "300", "300 (Teacher)" ], [ "900", "900 (Administrator)" ] ];
Lino.contacts.PartnerEvents = [ [ "has_open_movements", "Has open movements" ] ];
Lino.courses.CourseStates = [ [ "10", "Draft" ], [ "20", "Active" ], [ "30", "Inactive" ], [ "40", "Closed" ] ];
Lino.countries.PlaceTypes = [ [ "10", "Member State" ], [ "11", "Division" ], [ "12", "Region" ], [ "13", "Community" ], [ "14", "Territory" ], [ "20", "County" ], [ "21", "Province" ], [ "22", "Shire" ], [ "23", "Subregion" ], [ "24", "Department" ], [ "25", "Arrondissement" ], [ "26", "Prefecture" ], [ "27", "District" ], [ "28", "Sector" ], [ "50", "City" ], [ "51", "Town" ], [ "52", "Municipality" ], [ "54", "Parish" ], [ "55", "Township" ], [ "56", "Quarter" ], [ "61", "Borough" ], [ "62", "Small borough" ], [ "70", "Village" ] ];

Lino.notes.Notes.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user1 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(notes.Notes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/user" }) }) });
    this.items = [ { "autoHeight": true, "items": user1, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user1 ];
    Lino.notes.Notes.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Authorities.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user4 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(users.Authorities.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Authorities/user" }) }) });
    this.items = [ { "autoHeight": true, "items": user4, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user4 ];
    Lino.users.Authorities.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Vouchers.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var year7 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(ledger.Vouchers.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var journal8 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.Vouchers.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/journal" }) }) });
    this.items = [ { "autoHeight": true, "flex": 25, "items": year7, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 74, "items": journal8, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ year7, journal8 ];
    Lino.ledger.Vouchers.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.InvoicesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner12 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.InvoicesByJournal.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/partner" }) }) });
    var state13 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(vat.InvoicesByJournal.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var year14 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(vat.InvoicesByJournal.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    this.items = [ { "autoHeight": true, "flex": 50, "items": partner12, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": state13, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": year14, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner12, state13, year14 ];
    Lino.vat.InvoicesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.VatRules.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date19 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(vat.VatRules.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date20 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(vat.VatRules.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_date19, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_date20, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date19, end_date20 ];
    Lino.vat.VatRules.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.notify.Messages.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var user24 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "User", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("User","(notify.Messages.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/Messages/user" }) }) });
    var show_seen25 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Seen", "forceSelection": true, "hiddenName": "show_seenHidden", "listeners": { "render": Lino.quicktip_renderer("Seen","(notify.Messages.show_seen) ") }, "name": "show_seen", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var start_date26 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(notify.Messages.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date27 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(notify.Messages.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 37, "items": user24, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": show_seen25, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": start_date26, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": end_date27, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user24, show_seen25, start_date26, end_date27 ];
    Lino.notify.Messages.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Guests.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  labelWidth: 72,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date33 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(cal.Guests.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date34 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.Guests.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var user35 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible user</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible user","(cal.Guests.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/user" }) }) });
    var event_state36 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Event state</span>", "forceSelection": true, "hiddenName": "event_stateHidden", "listeners": { "render": Lino.quicktip_renderer("Event state","(cal.Guests.event_state) Only rows having this event state.") }, "name": "event_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EntryStates) });
    var guest_state37 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Guest state</span>", "forceSelection": true, "hiddenName": "guest_stateHidden", "listeners": { "render": Lino.quicktip_renderer("Guest state","(cal.Guests.guest_state) Only rows having this guest state.") }, "name": "guest_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.GuestStates) });
    var main_1_panel38 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": start_date33, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": end_date34, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": user35, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": event_state36, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": guest_state37, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var partner44 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(cal.Guests.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    this.items = [ main_1_panel38, { "anchor": "-20", "autoHeight": true, "items": partner44, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date33, end_date34, user35, event_state36, guest_state37, partner44 ];
    Lino.cal.Guests.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.RecurrentEvents.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user47 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.RecurrentEvents.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/user" }) }) });
    this.items = [ { "autoHeight": true, "items": user47, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user47 ];
    Lino.cal.RecurrentEvents.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.Uploads.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date50 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(uploads.Uploads.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date51 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(uploads.Uploads.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var user52 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Uploaded by", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Uploaded by","(uploads.Uploads.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var upload_type53 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Upload Type...", "fieldLabel": "Upload Type", "hiddenName": "upload_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.Uploads.upload_type) ") }, "name": "upload_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/upload_type" }) }) });
    this.items = [ { "autoHeight": true, "flex": 19, "items": start_date50, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_date51, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": user52, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": upload_type53, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date50, end_date51, user52, upload_type53 ];
    Lino.uploads.Uploads.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.AccountingPeriods.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date59 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.AccountingPeriods.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date60 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.AccountingPeriods.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_date59, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_date60, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date59, end_date60 ];
    Lino.ledger.AccountingPeriods.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 90,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var profile64 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "User type", "forceSelection": true, "hiddenName": "profileHidden", "listeners": { "render": Lino.quicktip_renderer("User type","(users.Users.profile) ") }, "name": "profile", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    this.items = [ { "autoHeight": true, "items": profile64, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ profile64 ];
    Lino.users.Users.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Enrolments.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 162,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date67 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(courses.Enrolments.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date68 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(courses.Enrolments.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var author69 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "User", "hiddenName": "authorHidden", "listeners": { "render": Lino.quicktip_renderer("User","(courses.Enrolments.author) ") }, "name": "author", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/author" }) }) });
    var state70 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Enrolments.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.EnrolmentStates) });
    var course_state71 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Course state", "forceSelection": true, "hiddenName": "course_stateHidden", "listeners": { "render": Lino.quicktip_renderer("Course state","(courses.Enrolments.course_state) ") }, "name": "course_state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.CourseStates) });
    var participants_only72 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Participants only", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Participants only","(courses.Enrolments.participants_only) Hide cancelled enrolments. Ignored if you specify an explicit enrolment state.") }, "name": "participants_only", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 16, "items": start_date67, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": end_date68, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": author69, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": state70, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": course_state71, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": participants_only72, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date67, end_date68, author69, state70, course_state71, participants_only72 ];
    Lino.courses.Enrolments.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Events.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date80 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(cal.Events.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date81 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.Events.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var observed_event82 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Observed event", "forceSelection": true, "hiddenName": "observed_eventHidden", "listeners": { "render": Lino.quicktip_renderer("Observed event","(cal.Events.observed_event) ") }, "name": "observed_event", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EventEvents) });
    var state83 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.Events.state) Only rows having this state.") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EntryStates) });
    var main_1_panel84 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 26, "items": start_date80, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": end_date81, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": observed_event82, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": state83, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user89 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Managed by</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Managed by","(cal.Events.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/user" }) }) });
    var assigned_to90 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Assigned to</span>", "hiddenName": "assigned_toHidden", "listeners": { "render": Lino.quicktip_renderer("Assigned to","(cal.Events.assigned_to) Only events assigned to this user.") }, "name": "assigned_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/assigned_to" }) }) });
    var event_type91 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "Calendar entry type", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.Events.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/event_type" }) }) });
    var room92 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(cal.Events.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var show_appointments93 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Appointments</span>", "forceSelection": true, "hiddenName": "show_appointmentsHidden", "listeners": { "render": Lino.quicktip_renderer("Appointments","(cal.Events.show_appointments) Whether only appointments should be\nshown.  \"Yes\" means only appointments, \"No\"\nmeans no appointments and leaving it to blank shows both types\nof events.") }, "name": "show_appointments", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_2_panel94 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": user89, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": assigned_to90, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": event_type91, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": room92, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": show_appointments93, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel84, main_2_panel94 ];
    this.fields = [ start_date80, end_date81, observed_event82, state83, user89, assigned_to90, event_type91, room92, show_appointments93 ];
    Lino.cal.Events.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var topic101 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Topic...", "fieldLabel": "Topic", "hiddenName": "topicHidden", "listeners": { "render": Lino.quicktip_renderer("Topic","(courses.Activities.topic) ") }, "name": "topic", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Topics.detail,Lino.courses.Topics.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/topic" }) }) });
    var line102 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "Activity line", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Activities.line) ") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var user103 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Activities.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/user" }) }) });
    var teacher104 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Activities.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var state105 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Activities.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.CourseStates) });
    var main_1_panel106 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": topic101, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line102, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": user103, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher104, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": state105, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room112 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Activities.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/room" }) }) });
    var can_enroll113 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "can enroll", "forceSelection": true, "hiddenName": "can_enrollHidden", "listeners": { "render": Lino.quicktip_renderer("can enroll","(courses.Activities.can_enroll) ") }, "name": "can_enroll", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var start_date114 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(courses.Activities.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date115 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(courses.Activities.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var show_active116 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Active</span>", "forceSelection": true, "hiddenName": "show_activeHidden", "listeners": { "render": Lino.quicktip_renderer("Active","(courses.Activities.show_active) Whether to show rows in some active state") }, "name": "show_active", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_2_panel117 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": room112, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": can_enroll113, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date114, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date115, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": show_active116, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel106, main_2_panel117 ];
    this.fields = [ topic101, line102, user103, teacher104, state105, room112, can_enroll113, start_date114, end_date115, show_active116 ];
    Lino.courses.Activities.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner124 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var state125 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(sales.Invoices.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal126 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(sales.Invoices.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/journal" }) }) });
    var year127 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(sales.Invoices.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var cleared128 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Show cleared vouchers", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(sales.Invoices.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 29, "items": partner124, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": state125, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": journal126, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": year127, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": cleared128, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner124, state125, journal126, year127, cleared128 ];
    Lino.sales.Invoices.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.InvoicesByJournal.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner135 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.InvoicesByJournal.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/partner" }) }) });
    var year136 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(sales.InvoicesByJournal.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var state137 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(sales.InvoicesByJournal.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var cleared138 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Show cleared vouchers", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(sales.InvoicesByJournal.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 42, "items": partner135, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": year136, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": state137, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": cleared138, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner135, year136, state137, cleared138 ];
    Lino.sales.InvoicesByJournal.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Debtors.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var today144 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Situation on</span>", "listeners": { "render": Lino.quicktip_renderer("Situation on","(ledger.Debtors.today) Date of observation") }, "name": "today", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "items": today144, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ today144 ];
    Lino.ledger.Debtors.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.plausibility.Problems.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 189,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var user147 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(plausibility.Problems.user) Only problems for this responsible.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/user" }) }) });
    var checker148 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Plausibility checker</span>", "forceSelection": true, "hiddenName": "checkerHidden", "listeners": { "render": Lino.quicktip_renderer("Plausibility checker","(plausibility.Problems.checker) Only problems by this checker.") }, "name": "checker", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.plausibility.Checkers) });
    this.items = [ { "autoHeight": true, "flex": 50, "items": user147, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": checker148, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user147, checker148 ];
    Lino.plausibility.Problems.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var course152 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity</span>", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.Pupils.course) Show only pupils who participate in the given course.") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/course" }) }) });
    var partner_list153 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner List...", "fieldLabel": "Partner List", "hiddenName": "partner_listHidden", "listeners": { "render": Lino.quicktip_renderer("Partner List","(courses.Pupils.partner_list) ") }, "name": "partner_list", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.lists.Lists.detail,Lino.lists.Lists.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/partner_list" }) }) });
    var gender154 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gender</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Pupils.gender) Show only persons with the given gender.") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var show_members155 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Members</span>", "forceSelection": true, "hiddenName": "show_membersHidden", "listeners": { "render": Lino.quicktip_renderer("Members","(courses.Pupils.show_members) Show those whose 'Member until' is after today.") }, "name": "show_members", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_lfv156 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "LFV", "forceSelection": true, "hiddenName": "show_lfvHidden", "listeners": { "render": Lino.quicktip_renderer("LFV","(courses.Pupils.show_lfv) ") }, "name": "show_lfv", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_ckk157 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "CKK", "forceSelection": true, "hiddenName": "show_ckkHidden", "listeners": { "render": Lino.quicktip_renderer("CKK","(courses.Pupils.show_ckk) ") }, "name": "show_ckk", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var show_raviva158 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Raviva", "forceSelection": true, "hiddenName": "show_ravivaHidden", "listeners": { "render": Lino.quicktip_renderer("Raviva","(courses.Pupils.show_raviva) ") }, "name": "show_raviva", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 25, "items": course152, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": partner_list153, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": gender154, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": show_members155, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": show_lfv156, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": show_ckk157, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": show_raviva158, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ course152, partner_list153, gender154, show_members155, show_lfv156, show_ckk157, show_raviva158 ];
    Lino.courses.Pupils.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Tasks.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date167 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(cal.Tasks.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date168 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.Tasks.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var user169 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Managed by</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Managed by","(cal.Tasks.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var state170 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.Tasks.state) Only rows having this state.") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.TaskStates) });
    var main_1_panel171 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": start_date167, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": end_date168, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": user169, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": state170, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel171 ];
    this.fields = [ start_date167, end_date168, user169, state170 ];
    Lino.cal.Tasks.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.outbox.Mails.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user177 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Sender", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Sender","(outbox.Mails.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/user" }) }) });
    this.items = [ { "autoHeight": true, "items": user177, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user177 ];
    Lino.outbox.Mails.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Partners.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 135,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var observed_event180 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Observed event</span>", "forceSelection": true, "hiddenName": "observed_eventHidden", "listeners": { "render": Lino.quicktip_renderer("Observed event","(contacts.Partners.observed_event) Extended filter criteria") }, "name": "observed_event", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.contacts.PartnerEvents) });
    var start_date181 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(contacts.Partners.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date182 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(contacts.Partners.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    this.items = [ { "autoHeight": true, "flex": 44, "items": observed_event180, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": start_date181, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_date182, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ observed_event180, start_date181, end_date182 ];
    Lino.contacts.Partners.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Situation.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var today187 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Situation on</span>", "listeners": { "render": Lino.quicktip_renderer("Situation on","(ledger.Situation.today) Date of observation") }, "name": "today", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "items": today187, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ today187 ];
    Lino.ledger.Situation.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.PartnerVouchers.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner190 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(ledger.PartnerVouchers.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/partner" }) }) });
    var state191 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(ledger.PartnerVouchers.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal192 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.PartnerVouchers.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/journal" }) }) });
    var year193 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(ledger.PartnerVouchers.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var cleared194 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Show cleared vouchers", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(ledger.PartnerVouchers.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 29, "items": partner190, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": state191, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": journal192, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": year193, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": cleared194, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner190, state191, journal192, year193, cleared194 ];
    Lino.ledger.PartnerVouchers.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.invoicing.Plans.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user201 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(invoicing.Plans.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/user" }) }) });
    this.items = [ { "autoHeight": true, "items": user201, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user201 ];
    Lino.invoicing.Plans.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.rooms.Bookings.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var company204 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "Organization", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Organization","(rooms.Bookings.company) ") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var state205 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(rooms.Bookings.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.rooms.BookingStates) });
    this.items = [ { "autoHeight": true, "flex": 60, "items": company204, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": state205, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ company204, state205 ];
    Lino.rooms.Bookings.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Subscriptions.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 63,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var user209 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.Subscriptions.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Subscriptions/user" }) }) });
    this.items = [ { "autoHeight": true, "items": user209, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ user209 ];
    Lino.cal.Subscriptions.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.OneEvent.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date212 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(cal.OneEvent.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date213 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(cal.OneEvent.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var observed_event214 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Observed event", "forceSelection": true, "hiddenName": "observed_eventHidden", "listeners": { "render": Lino.quicktip_renderer("Observed event","(cal.OneEvent.observed_event) ") }, "name": "observed_event", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EventEvents) });
    var state215 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.OneEvent.state) Only rows having this state.") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.EntryStates) });
    var main_1_panel216 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 26, "items": start_date212, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": end_date213, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": observed_event214, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": state215, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user221 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Managed by</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Managed by","(cal.OneEvent.user) Only rows managed by this user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/user" }) }) });
    var assigned_to222 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Assigned to</span>", "hiddenName": "assigned_toHidden", "listeners": { "render": Lino.quicktip_renderer("Assigned to","(cal.OneEvent.assigned_to) Only events assigned to this user.") }, "name": "assigned_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/assigned_to" }) }) });
    var event_type223 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "Calendar entry type", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.OneEvent.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/event_type" }) }) });
    var room224 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(cal.OneEvent.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/room" }) }) });
    var show_appointments225 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Appointments</span>", "forceSelection": true, "hiddenName": "show_appointmentsHidden", "listeners": { "render": Lino.quicktip_renderer("Appointments","(cal.OneEvent.show_appointments) Whether only appointments should be\nshown.  \"Yes\" means only appointments, \"No\"\nmeans no appointments and leaving it to blank shows both types\nof events.") }, "name": "show_appointments", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_2_panel226 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": user221, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": assigned_to222, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": event_type223, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": room224, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": show_appointments225, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel216, main_2_panel226 ];
    this.fields = [ start_date212, end_date213, observed_event214, state215, user221, assigned_to222, event_type223, room224, show_appointments225 ];
    Lino.cal.OneEvent.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.ActivityReport.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var start_date233 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.ActivityReport.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true });
    var end_date234 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.ActivityReport.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 50, "items": start_date233, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_date234, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ start_date233, end_date234 ];
    Lino.ledger.ActivityReport.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.changes.Changes.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var date238 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Only changes from", "listeners": { "render": Lino.quicktip_renderer("Only changes from","(changes.Changes.date) ") }, "name": "date", "selectOnFocus": true });
    var user239 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "User", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("User","(changes.Changes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/user" }) }) });
    var change_type240 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Change Type", "forceSelection": false, "hiddenName": "change_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Change Type","(changes.Changes.change_type) ") }, "name": "change_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.changes.ChangeTypes) });
    var object_type241 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a content type...", "fieldLabel": "Object type", "hiddenName": "object_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Object type","(changes.Changes.object_type) ") }, "name": "object_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,Lino.gfks.ContentTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_type" }) }) });
    var object_id242 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Object ID", "hiddenName": "object_idHidden", "listeners": { "render": Lino.quicktip_renderer("Object ID","(changes.Changes.object_id) ") }, "name": "object_id", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_id" }) }) });
    var main_1_panel243 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": date238, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user239, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": change_type240, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": object_type241, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": object_id242, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel243 ];
    this.fields = [ date238, user239, change_type240, object_type241, object_id242 ];
    Lino.changes.Changes.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.CoursesByTopic.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 126,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var line250 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "Activity line", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.CoursesByTopic.line) ") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/line" }) }) });
    var teacher251 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.CoursesByTopic.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/teacher" }) }) });
    var user252 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.CoursesByTopic.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/user" }) }) });
    var state253 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.CoursesByTopic.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.CourseStates) });
    var can_enroll254 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "can enroll", "forceSelection": true, "hiddenName": "can_enrollHidden", "listeners": { "render": Lino.quicktip_renderer("can enroll","(courses.CoursesByTopic.can_enroll) ") }, "name": "can_enroll", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 24, "items": line250, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": teacher251, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": user252, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": state253, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": can_enroll254, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ line250, teacher251, user252, state253, can_enroll254 ];
    Lino.courses.CoursesByTopic.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.about.Inspector.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 153,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var inspected261 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Inspected object", "listeners": { "render": Lino.quicktip_renderer("Inspected object","(about.Inspector.inspected) ") }, "maxLength": 100, "name": "inspected", "selectOnFocus": true });
    var show_callables262 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "show callables", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("show callables","(about.Inspector.show_callables) ") }, "name": "show_callables", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "flex": 67, "items": inspected261, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": show_callables262, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ inspected261, show_callables262 ];
    Lino.about.Inspector.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Creditors.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  border: false,
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var today266 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Situation on</span>", "listeners": { "render": Lino.quicktip_renderer("Situation on","(ledger.Creditors.today) Date of observation") }, "name": "today", "selectOnFocus": true });
    this.items = [ { "autoHeight": true, "items": today266, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ today266 ];
    Lino.ledger.Creditors.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Movements.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date269 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(ledger.Movements.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date270 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(ledger.Movements.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var cleared271 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Show cleared movements", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared movements","(ledger.Movements.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_1_panel272 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": start_date269, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": end_date270, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": cleared271, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 207, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var journal_group276 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Journal group", "forceSelection": true, "hiddenName": "journal_groupHidden", "listeners": { "render": Lino.quicktip_renderer("Journal group","(ledger.Movements.journal_group) ") }, "name": "journal_group", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.JournalGroups) });
    var journal277 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.Movements.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/journal" }) }) });
    var year278 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(ledger.Movements.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var partner279 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(ledger.Movements.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/partner" }) }) });
    var account280 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Account", "hiddenName": "accountHidden", "listeners": { "render": Lino.quicktip_renderer("Account","(ledger.Movements.account) ") }, "name": "account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/account" }) }) });
    var main_2_panel281 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": journal_group276, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": journal277, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": year278, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": partner279, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": account280, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel272, main_2_panel281 ];
    this.fields = [ start_date269, end_date270, cleared271, journal_group276, journal277, year278, partner279, account280 ];
    Lino.ledger.Movements.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.Excerpts.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoScroll: false,
  autoHeight: true,
  border: false,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'form',
  autoHeight: true,
  initComponent : function() {
    var start_date288 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(excerpts.Excerpts.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true, "value": null });
    var end_date289 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(excerpts.Excerpts.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true, "value": null });
    var pcertifying290 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Certifying excerpts", "forceSelection": true, "hiddenName": "pcertifyingHidden", "listeners": { "render": Lino.quicktip_renderer("Certifying excerpts","(excerpts.Excerpts.pcertifying) ") }, "name": "pcertifying", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    var main_1_panel291 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": start_date288, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": end_date289, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": pcertifying290, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user295 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "Author", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(excerpts.Excerpts.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/user" }) }) });
    var excerpt_type296 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Excerpt Type...", "fieldLabel": "Excerpt Type", "hiddenName": "excerpt_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Excerpt Type","(excerpts.Excerpts.excerpt_type) ") }, "name": "excerpt_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.excerpts.ExcerptTypes.detail,Lino.excerpts.ExcerptTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var main_2_panel297 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": user295, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": excerpt_type296, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    this.items = [ main_1_panel291, main_2_panel297 ];
    this.fields = [ start_date288, end_date289, pcertifying290, user295, excerpt_type296 ];
    Lino.excerpts.Excerpts.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.FinancialVouchers.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 108,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var pjournal301 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "pjournalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.FinancialVouchers.pjournal) ") }, "name": "pjournal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/pjournal" }) }) });
    var pyear302 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "pyearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(finan.FinancialVouchers.pyear) ") }, "name": "pyear", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    this.items = [ { "autoHeight": true, "flex": 74, "items": pjournal301, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": pyear302, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ pjournal301, pyear302 ];
    Lino.finan.FinancialVouchers.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.Invoices.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 198,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var partner306 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.Invoices.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var state307 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "State", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(vat.Invoices.state) ") }, "name": "state", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.VoucherStates) });
    var journal308 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.Invoices.journal) ") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var year309 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fiscal Year", "forceSelection": true, "hiddenName": "yearHidden", "listeners": { "render": Lino.quicktip_renderer("Fiscal Year","(vat.Invoices.year) ") }, "name": "year", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.FiscalYears) });
    var cleared310 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Show cleared vouchers", "forceSelection": true, "hiddenName": "clearedHidden", "listeners": { "render": Lino.quicktip_renderer("Show cleared vouchers","(vat.Invoices.cleared) ") }, "name": "cleared", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.YesNo) });
    this.items = [ { "autoHeight": true, "flex": 29, "items": partner306, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": state307, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": journal308, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": year309, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": cleared310, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ partner306, state307, journal308, year309, cleared310 ];
    Lino.vat.Invoices.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.ExpectedMovements.ParamsPanel = Ext.extend(Ext.form.FormPanel, {
  autoHeight: true,
  frame: true,
  layoutConfig: { "align": "stretchmax" },
  hideCheckBoxLabels: true,
  autoScroll: false,
  labelWidth: 117,
  border: false,
  bodyBorder: false,
  labelAlign: "top",
  layout: 'hbox',
  autoHeight: true,
  initComponent : function() {
    var trade_type317 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Trade type", "forceSelection": true, "hiddenName": "trade_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Trade type","(ledger.ExpectedMovements.trade_type) ") }, "name": "trade_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.TradeTypes) });
    var date_until318 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Date until", "listeners": { "render": Lino.quicktip_renderer("Date until","(ledger.ExpectedMovements.date_until) ") }, "name": "date_until", "selectOnFocus": true });
    var from_journal319 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Journal", "hiddenName": "from_journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(ledger.ExpectedMovements.from_journal) ") }, "name": "from_journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/from_journal" }) }) });
    var for_journal320 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "Clearable by", "hiddenName": "for_journalHidden", "listeners": { "render": Lino.quicktip_renderer("Clearable by","(ledger.ExpectedMovements.for_journal) ") }, "name": "for_journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/for_journal" }) }) });
    var partner321 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(ledger.ExpectedMovements.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/partner" }) }) });
    var account322 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Account", "hiddenName": "accountHidden", "listeners": { "render": Lino.quicktip_renderer("Account","(ledger.ExpectedMovements.account) ") }, "name": "account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/ExpectedMovements/account" }) }) });
    this.items = [ { "autoHeight": true, "flex": 11, "items": trade_type317, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": date_until318, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": from_journal319, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": for_journal320, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": partner321, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": account322, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ trade_type317, date_until318, from_journal319, for_journal320, partner321, account322 ];
    Lino.ledger.ExpectedMovements.ParamsPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.merge_row_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 351,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'merge_row',
  ls_url: "/courses/Pupils",
  window_title: "Merge",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.merge_to367 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant...", "fieldLabel": "into...", "hiddenName": "merge_toHidden", "listeners": { "render": Lino.quicktip_renderer("into...","(Merge.merge_to) ") }, "name": "merge_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/apchoices/courses/Pupils/merge_row/merge_to" }) }) });
    this.sepa_Account368 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Also reassign volatile related objects", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(Merge.sepa_Account) ") }, "name": "sepa_Account", "selectOnFocus": true });
    this.reason369 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Reason", "listeners": { "render": Lino.quicktip_renderer("Reason","(Merge.reason) ") }, "maxLength": 100, "name": "reason", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.merge_to367, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.sepa_Account368, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.reason369, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.merge_to367, this.sepa_Account368, this.reason369 ];
    Lino.courses.Pupils.merge_row_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.print_presence_sheet_html_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'print_presence_sheet_html',
  ls_url: "/courses/Activities",
  window_title: "Presence sheet (HTML)",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.start_date349 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(Presence sheet (HTML).start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true });
    this.end_date350 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(Presence sheet (HTML).end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true });
    this.show_remarks351 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Show remarks", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show remarks","(Presence sheet (HTML).show_remarks) ") }, "name": "show_remarks", "selectOnFocus": true });
    this.show_states352 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Show states", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show states","(Presence sheet (HTML).show_states) ") }, "name": "show_states", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.start_date349, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.end_date350, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_remarks351, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_states352, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.start_date349, this.end_date350, this.show_remarks351, this.show_states352 ];
    Lino.courses.Activities.print_presence_sheet_html_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.AllUsers.send_welcome_email_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 135,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'send_welcome_email',
  ls_url: "/users/AllUsers",
  window_title: "Welcome mail",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.email344 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "e-mail address", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(Welcome mail.email) ") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    this.subject345 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Subject", "listeners": { "render": Lino.quicktip_renderer("Subject","(Welcome mail.subject) ") }, "maxLength": 250, "name": "subject", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.email344, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.subject345, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.email344, this.subject345 ];
    Lino.users.AllUsers.send_welcome_email_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Companies.merge_row_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 351,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'merge_row',
  ls_url: "/contacts/Companies",
  window_title: "Merge",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.merge_to330 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "into...", "hiddenName": "merge_toHidden", "listeners": { "render": Lino.quicktip_renderer("into...","(Merge.merge_to) ") }, "name": "merge_to", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/apchoices/contacts/Companies/merge_row/merge_to" }) }) });
    this.sepa_Account331 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Also reassign volatile related objects", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(Merge.sepa_Account) ") }, "name": "sepa_Account", "selectOnFocus": true });
    this.reason332 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Reason", "listeners": { "render": Lino.quicktip_renderer("Reason","(Merge.reason) ") }, "maxLength": 100, "name": "reason", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.merge_to330, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.sepa_Account331, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.reason332, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.merge_to330, this.sepa_Account331, this.reason332 ];
    Lino.contacts.Companies.merge_row_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.change_password_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 171,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'change_password',
  ls_url: "/users/Users",
  window_title: "Change password",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.current337 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Current password", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("Current password","(Change password.current) ") }, "maxLength": null, "name": "current", "selectOnFocus": true });
    this.new1338 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "New password", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("New password","(Change password.new1) ") }, "maxLength": null, "name": "new1", "selectOnFocus": true });
    this.new2339 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "New password again", "inputType": "password", "listeners": { "render": Lino.quicktip_renderer("New password again","(Change password.new2) ") }, "maxLength": null, "name": "new2", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.current337, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.new1338, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.new2339, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.current337, this.new1338, this.new2339 ];
    Lino.users.Users.change_password_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.print_presence_sheet_ActionFormPanel = Ext.extend(Lino.ActionFormPanel,{
  autoScroll: false,
  autoHeight: true,
  border: false,
  layout: "form",
  labelWidth: 117,
  hideCheckBoxLabels: true,
  frame: true,
  bodyBorder: false,
  labelAlign: "top",
  action_name: 'print_presence_sheet',
  ls_url: "/courses/Activities",
  window_title: "Presence sheet",
  before_row_edit : function(record) {
  },
  autoHeight: true,
  initComponent : function() {
    this.start_date358 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Period from</span>", "listeners": { "render": Lino.quicktip_renderer("Period from","(Presence sheet.start_date) Start date of observed period") }, "name": "start_date", "selectOnFocus": true });
    this.end_date359 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">until</span>", "listeners": { "render": Lino.quicktip_renderer("until","(Presence sheet.end_date) End date of observed period") }, "name": "end_date", "selectOnFocus": true });
    this.show_remarks360 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Show remarks", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show remarks","(Presence sheet.show_remarks) ") }, "name": "show_remarks", "selectOnFocus": true });
    this.show_states361 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Show states", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Show states","(Presence sheet.show_states) ") }, "name": "show_states", "selectOnFocus": true });
    this.items = [ { "anchor": "-20", "autoHeight": true, "items": this.start_date358, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.end_date359, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_remarks360, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": this.show_states361, "labelAlign": "top", "layout": "form", "xtype": "panel" } ];
    this.fields = [ this.start_date358, this.end_date359, this.show_remarks360, this.show_states361 ];
    Lino.courses.Activities.print_presence_sheet_ActionFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Events.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 23,
  initComponent : function() {
    var event_type813 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry type</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.Events.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/event_type" }) }) });
    var summary814 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Short description</span>", "listeners": { "render": Lino.quicktip_renderer("Short description","(cal.Events.summary) A one-line descriptive text.") }, "maxLength": 200, "name": "summary", "selectOnFocus": true });
    var user815 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible user</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible user","(cal.Events.user) The responsible user.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/user" }) }) });
    var general_1_panel816 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": event_type813, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": summary814, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": user815, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date820 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.Events.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time821 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(cal.Events.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var start_panel822 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": start_date820, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": start_time821, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var end_date825 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.Events.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time826 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">End Time</span>", "listeners": { "render": Lino.quicktip_renderer("End Time","(cal.Events.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.") }, "name": "end_time", "selectOnFocus": true });
    var end_panel827 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": end_date825, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": end_time826, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var general_2_panel830 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ start_panel822, end_panel827 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room831 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(cal.Events.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var priority832 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Priority...", "fieldLabel": "Priority", "hiddenName": "priorityHidden", "listeners": { "render": Lino.quicktip_renderer("Priority","(cal.Events.priority) ") }, "name": "priority", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/priority" }) }) });
    var access_class833 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Access Class</span>", "forceSelection": true, "hiddenName": "access_classHidden", "listeners": { "render": Lino.quicktip_renderer("Access Class","(cal.Events.access_class) Whether this is private, public or between.") }, "name": "access_class", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var transparent834 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Transparent", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Transparent","(cal.Events.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.") }, "name": "transparent", "selectOnFocus": true });
    var general_3_panel835 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room831, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": priority832, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": access_class833, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": transparent834, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var owner_disp840 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Controlled by", "name": "owner" });
    var workflow_buttons_disp841 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(cal.Events.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_4_panel842 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": owner_disp840, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": workflow_buttons_disp841, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description845 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Description</span>", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.Events.description) A longer descriptive text.") }, "name": "description", "selectOnFocus": true });
    var general_panel846 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel816, general_2_panel830, general_3_panel835, general_4_panel842, { "flex": 45, "items": description845, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var id848 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Events.id) ") }, "name": "id", "selectOnFocus": true });
    var created849 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Created</span>", "listeners": { "render": Lino.quicktip_renderer("Created","(cal.Events.created) The timestame when this object was created.") }, "name": "created", "value": "<br>" });
    var modified850 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Modified", "listeners": { "render": Lino.quicktip_renderer("Modified","(cal.Events.modified) ") }, "name": "modified", "value": "<br>" });
    var state851 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.Events.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.") }, "name": "state", "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var more_1_panel852 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 8, "items": id848, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": created849, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": modified850, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": state851, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var cal_GuestsByEvent_grid883 = new Lino.cal.GuestsByEvent.GridPanel({ "containing_panel": this, "flex": 36, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Presences","(cal.cal.GuestsByEvent) The default table for Guest.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.GuestsByEvent.grid) ] });
    var notes_NotesByOwner_grid934 = new Lino.notes.NotesByOwner.GridPanel({ "containing_panel": this, "flex": 63, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByOwner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByOwner.grid) ] });
    var more_2_panel935 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 83, "frame": false, "hideCheckBoxLabels": true, "items": [ cal_GuestsByEvent_grid883, notes_NotesByOwner_grid934 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var more_panel936 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel852, more_2_panel935 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var main_panel937 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel846, more_panel936 ], "labelAlign": "top", "split": true });
    this.items = main_panel937;
    this.before_row_edit = function(record) {
      cal_GuestsByEvent_grid883.on_master_changed();
      notes_NotesByOwner_grid934.on_master_changed();
    }
    Lino.cal.Events.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.lists.Lists.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 14,
  initComponent : function() {
    var ref938 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(lists.Lists.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var list_type939 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a List Type...", "fieldLabel": "List Type", "hiddenName": "list_typeHidden", "listeners": { "render": Lino.quicktip_renderer("List Type","(lists.Lists.list_type) ") }, "name": "list_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Lists/list_type" }) }) });
    var id940 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(lists.Lists.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel941 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 45, "items": ref938, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": list_type939, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": id940, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name945 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(lists.Lists.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de946 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(lists.Lists.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr947 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(lists.Lists.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel948 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name945, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de946, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr947, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks952 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(lists.Lists.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var MembersByList_grid963 = new Lino.lists.MembersByList.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Members","(lists.lists.MembersByList) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByList.grid) ] });
    var main_panel964 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel941, main_2_panel948, { "flex": 41, "items": remarks952, "labelAlign": "top", "layout": "form", "xtype": "panel" }, MembersByList_grid963 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel964;
    this.before_row_edit = function(record) {
      MembersByList_grid963.on_master_changed();
    }
    Lino.lists.Lists.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 45,
  initComponent : function() {
    var voucher_date412 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(sales.Invoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var partner413 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.Invoices.partner) Mandatory field to be defined in another class.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var vat_regime414 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(sales.Invoices.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.") }, "name": "vat_regime", "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var invoice_header_1_panel415 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": voucher_date412, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": partner413, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": vat_regime414, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var subject419 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Subject line", "listeners": { "render": Lino.quicktip_renderer("Subject line","(sales.Invoices.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var your_ref420 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Your reference", "listeners": { "render": Lino.quicktip_renderer("Your reference","(sales.Invoices.your_ref) ") }, "maxLength": 200, "name": "your_ref", "selectOnFocus": true });
    var match421 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Match</span>", "listeners": { "render": Lino.quicktip_renderer("Match","(sales.Invoices.match) The movement to be matched.") }, "name": "match", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/match" }) }) });
    var invoice_header_2_panel422 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": subject419, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": your_ref420, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": match421, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term426 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(sales.Invoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/payment_term" }) }) });
    var due_date427 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Due date", "listeners": { "render": Lino.quicktip_renderer("Due date","(sales.Invoices.due_date) ") }, "name": "due_date", "selectOnFocus": true });
    var paper_type428 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "Paper type", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(sales.Invoices.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/paper_type" }) }) });
    var printed_disp429 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Printed", "listeners": { "render": Lino.quicktip_renderer("Printed","(sales.Invoices.printed) ") }, "name": "printed", "value": "<br/>" });
    var invoice_header_3_panel430 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": payment_term426, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": due_date427, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": paper_type428, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": printed_disp429, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoice_header_panel435 = new Ext.form.FieldSet({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 75, "frame": true, "hideCheckBoxLabels": true, "items": [ invoice_header_1_panel415, invoice_header_2_panel422, invoice_header_3_panel430 ], "labelAlign": "top", "layout": "form", "title": "Header" });
    var total_incl436 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total incl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(sales.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var balance_before437 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "fieldLabel": "Balance before", "listeners": { "render": Lino.quicktip_renderer("Balance before","(sales.Invoices.balance_before) ") }, "name": "balance_before" });
    var balance_to_pay438 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "fieldLabel": "Balance to pay", "listeners": { "render": Lino.quicktip_renderer("Balance to pay","(sales.Invoices.balance_to_pay) ") }, "name": "balance_to_pay" });
    var workflow_buttons_disp439 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(sales.Invoices.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var totals_panel440 = new Ext.form.FieldSet({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 25, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": total_incl436, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": balance_before437, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": balance_to_pay438, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": workflow_buttons_disp439, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "form", "title": "Totals" });
    var general_1_panel445 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ invoice_header_panel435, totals_panel440 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ItemsByInvoice_grid507 = new Lino.sales.ItemsByInvoice.GridPanel({ "containing_panel": this, "flex": 45, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Content","(sales.sales.ItemsByInvoice) Shows all sales invoice items.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.ItemsByInvoice.grid) ] });
    var general_panel508 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel445, ItemsByInvoice_grid507 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var id509 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(sales.Invoices.id) ") }, "name": "id", "selectOnFocus": true });
    var user510 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(sales.Invoices.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/user" }) }) });
    var language511 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Language", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(sales.Invoices.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var more_1_panel512 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": id509, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": user510, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": language511, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var intro516 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Introductive Text", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Introductive Text","(sales.Invoices.intro) ") }, "name": "intro", "selectOnFocus": true });
    var more_panel517 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel512, { "flex": 83, "items": intro516, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var entry_date519 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Entry date</span>", "listeners": { "render": Lino.quicktip_renderer("Entry date","(sales.Invoices.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.") }, "name": "entry_date", "selectOnFocus": true });
    var journal520 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(sales.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/journal" }) }) });
    var accounting_period521 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Accounting period...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Accounting period</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(sales.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/accounting_period" }) }) });
    var number522 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(sales.Invoices.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var narration523 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Narration</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(sales.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var ledger_1_panel524 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": entry_date519, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": journal520, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": accounting_period521, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": number522, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": narration523, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox530 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(sales.Invoices.MovementsByVoucher) Show the ledger movements of a voucher.") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel531 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel524, MovementsByVoucher_htmlbox530 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel532 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel508, more_panel517, ledger_panel531 ], "labelAlign": "top", "split": true });
    this.items = main_panel532;
    this.before_row_edit = function(record) {
      match421.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match421.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      ItemsByInvoice_grid507.on_master_changed();
      accounting_period521.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      MovementsByVoucher_htmlbox530.refresh();
    }
    this.onRender = function(ct, position) {
      journal520.on('change',Lino.chooser_handler(match421,'journal'));
      partner413.on('change',Lino.chooser_handler(match421,'partner'));
      entry_date519.on('change',Lino.chooser_handler(accounting_period521,'entry_date'));
      Lino.sales.Invoices.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.sales.Invoices.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.InvoiceItems.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 44,
  initComponent : function() {
    var seqno467 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(sales.InvoiceItems.seqno) The sequence number of this item with its parent.") }, "name": "seqno", "selectOnFocus": true });
    var product468 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "Tariff", "hiddenName": "productHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(sales.InvoiceItems.product) ") }, "name": "product", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/product" }) }) });
    var discount469 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Discount", "listeners": { "render": Lino.quicktip_renderer("Discount","(sales.InvoiceItems.discount) ") }, "name": "discount", "selectOnFocus": true });
    var main_1_panel470 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": seqno467, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 62, "items": product468, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": discount469, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var unit_price474 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Unit price", "listeners": { "render": Lino.quicktip_renderer("Unit price","(sales.InvoiceItems.unit_price) ") }, "name": "unit_price", "selectOnFocus": true });
    var qty475 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(6), "fieldLabel": "Quantity", "listeners": { "render": Lino.quicktip_renderer("Quantity","(sales.InvoiceItems.qty) ") }, "maxLength": 6, "name": "qty", "selectOnFocus": true });
    var total_base476 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total excl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total excl. VAT","(sales.InvoiceItems.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.") }, "name": "total_base", "selectOnFocus": true });
    var total_vat477 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT</span>", "listeners": { "render": Lino.quicktip_renderer("VAT","(sales.InvoiceItems.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.") }, "name": "total_vat", "selectOnFocus": true });
    var total_incl478 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total incl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(sales.InvoiceItems.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var main_2_panel479 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": unit_price474, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": qty475, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": total_base476, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": total_vat477, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": total_incl478, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var title485 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Heading</span>", "listeners": { "render": Lino.quicktip_renderer("Heading","(sales.InvoiceItems.title) The title of this voucher.") }, "maxLength": 200, "name": "title", "selectOnFocus": true });
    var invoiceable_type486 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a content type...", "fieldLabel": "Invoiced object (type)", "hiddenName": "invoiceable_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Invoiced object (type)","(sales.InvoiceItems.invoiceable_type) ") }, "name": "invoiceable_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,Lino.gfks.ContentTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/invoiceable_type" }) }) });
    var invoiceable_id487 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Invoiced object (object)", "hiddenName": "invoiceable_idHidden", "listeners": { "render": Lino.quicktip_renderer("Invoiced object (object)","(sales.InvoiceItems.invoiceable_id) ") }, "name": "invoiceable_id", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/invoiceable_id" }) }) });
    var invoiceable_disp488 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Invoiced object", "name": "invoiceable" });
    var main_4_panel489 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": invoiceable_type486, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": invoiceable_id487, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 62, "items": invoiceable_disp488, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description493 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Description</span>", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(sales.InvoiceItems.description) A multi-line rich text to be printed in the resulting printable\ndocument.") }, "name": "description", "selectOnFocus": true });
    var main_panel494 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel470, main_2_panel479, { "autoHeight": true, "items": title485, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel489, { "flex": 55, "items": description493, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel494;
    this.before_row_edit = function(record) {
      invoiceable_id487.setContextValue('invoiceable_type', record ? record.data['invoiceable_typeHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      invoiceable_type486.on('change',Lino.chooser_handler(invoiceable_id487,'invoiceable_type'));
      Lino.sales.InvoiceItems.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.sales.InvoiceItems.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.changes.Changes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 77,
  disable_editing: true,
  initComponent : function() {
    var time966 = new Ext.form.DisplayField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "time", "listeners": { "render": Lino.quicktip_renderer("time","(changes.Changes.time) ") }, "name": "time", "selectOnFocus": true, "value": "<br>" });
    var user967 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "User", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("User","(changes.Changes.user) ") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/user" }) }) });
    var type968 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Change Type", "forceSelection": true, "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Change Type","(changes.Changes.type) ") }, "name": "type", "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var master_disp969 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Master</span>", "name": "master" });
    var object_disp970 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Object</span>", "name": "object" });
    var id971 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(changes.Changes.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel972 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": time966, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user967, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": type968, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": master_disp969, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": object_disp970, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id971, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var diff979 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Changes", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Changes","(changes.Changes.diff) ") }, "name": "diff", "selectOnFocus": true });
    var main_panel980 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel972, { "flex": 83, "items": diff979, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel980;
    this.before_row_edit = function(record) {
    }
    Lino.changes.Changes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Events.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 23,
  initComponent : function() {
    var start_date982 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.Events.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time983 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(cal.Events.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var start_panel984 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": start_date982, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": start_time983, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var end_date987 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.Events.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time988 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">End Time</span>", "listeners": { "render": Lino.quicktip_renderer("End Time","(cal.Events.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.") }, "name": "end_time", "selectOnFocus": true });
    var end_panel989 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": end_date987, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": end_time988, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_1_panel992 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ start_panel984, end_panel989 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room993 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(cal.Events.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Events/room" }) }) });
    var main_panel994 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel992, { "anchor": "-20", "autoHeight": true, "items": room993, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 45, "layout": "form" });
    this.items = main_panel994;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Events.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.EventTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 22,
  initComponent : function() {
    var name996 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.EventTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de997 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.EventTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr998 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.EventTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel999 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name996, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de997, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr998, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var event_label1003 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Entry label</span>", "listeners": { "render": Lino.quicktip_renderer("Entry label","(cal.EventTypes.event_label) Default text for summary of new entries.") }, "maxLength": 200, "name": "event_label", "selectOnFocus": true });
    var event_label_de1004 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Entry label (de)", "listeners": { "render": Lino.quicktip_renderer("Entry label (de)","(cal.EventTypes.event_label_de) ") }, "maxLength": 200, "name": "event_label_de", "selectOnFocus": true });
    var event_label_fr1005 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Entry label (fr)", "listeners": { "render": Lino.quicktip_renderer("Entry label (fr)","(cal.EventTypes.event_label_fr) ") }, "maxLength": 200, "name": "event_label_fr", "selectOnFocus": true });
    var main_2_panel1006 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": event_label1003, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_de1004, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_fr1005, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1010 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel999, main_2_panel1006 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1010;
    this.before_row_edit = function(record) {
    }
    Lino.cal.EventTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.FinancialVouchers.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 63,
  initComponent : function() {
    var voucher_date773 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(finan.FinancialVouchers.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var user774 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.FinancialVouchers.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/user" }) }) });
    var narration775 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Narration</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(finan.FinancialVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var workflow_buttons_disp776 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(finan.FinancialVouchers.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel777 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": voucher_date773, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": user774, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": narration775, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 35, "items": workflow_buttons_disp776, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var finan_ItemsByJournalEntry_grid799 = new Lino.finan.ItemsByJournalEntry.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Journal Entry items","(finan.finan.ItemsByJournalEntry) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.finan.ItemsByJournalEntry.grid) ] });
    var general_panel800 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel777, finan_ItemsByJournalEntry_grid799 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var journal801 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.FinancialVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/journal" }) }) });
    var accounting_period802 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Accounting period...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Accounting period</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(finan.FinancialVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/accounting_period" }) }) });
    var number803 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(finan.FinancialVouchers.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var id804 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(finan.FinancialVouchers.id) ") }, "name": "id", "selectOnFocus": true });
    var ledger_1_panel805 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": journal801, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": accounting_period802, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": number803, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": id804, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox810 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(finan.FinancialVouchers.MovementsByVoucher) Show the ledger movements of a voucher.") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel811 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel805, MovementsByVoucher_htmlbox810 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel812 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel800, ledger_panel811 ], "labelAlign": "top", "split": true });
    this.items = main_panel812;
    this.before_row_edit = function(record) {
      finan_ItemsByJournalEntry_grid799.on_master_changed();
      accounting_period802.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      MovementsByVoucher_htmlbox810.refresh();
    }
    Lino.finan.FinancialVouchers.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.FinancialVouchers.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 63,
  initComponent : function() {
    var voucher_date681 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(finan.FinancialVouchers.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var narration682 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Narration</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(finan.FinancialVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var main_panel683 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": voucher_date681, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": narration682, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel683;
    this.before_row_edit = function(record) {
    }
    Lino.finan.FinancialVouchers.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.Invoices.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 41,
  initComponent : function() {
    var id564 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(vat.Invoices.id) ") }, "name": "id", "selectOnFocus": true });
    var voucher_date565 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(vat.Invoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var partner566 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.Invoices.partner) Mandatory field to be defined in another class.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var user567 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(vat.Invoices.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/user" }) }) });
    var general_1_panel568 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 8, "items": id564, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": voucher_date565, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": partner566, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": user567, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var due_date573 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Due date", "listeners": { "render": Lino.quicktip_renderer("Due date","(vat.Invoices.due_date) ") }, "name": "due_date", "selectOnFocus": true });
    var your_ref574 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Your reference", "listeners": { "render": Lino.quicktip_renderer("Your reference","(vat.Invoices.your_ref) ") }, "maxLength": 200, "name": "your_ref", "selectOnFocus": true });
    var vat_regime575 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(vat.Invoices.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.") }, "name": "vat_regime", "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var general_2_panel576 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": due_date573, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": your_ref574, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": vat_regime575, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ItemsByInvoice_grid587 = new Lino.vat.ItemsByInvoice.GridPanel({ "containing_panel": this, "flex": 75, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Account invoice items","(vat.vat.ItemsByInvoice) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.vat.ItemsByInvoice.grid) ] });
    var total_base588 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total excl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total excl. VAT","(vat.Invoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.") }, "name": "total_base", "selectOnFocus": true });
    var total_vat589 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT</span>", "listeners": { "render": Lino.quicktip_renderer("VAT","(vat.Invoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.") }, "name": "total_vat", "selectOnFocus": true });
    var total_incl590 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total incl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(vat.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var workflow_buttons_disp591 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(vat.Invoices.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var totals_panel592 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 25, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": total_base588, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": total_vat589, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": total_incl590, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": workflow_buttons_disp591, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "form" });
    var general_3_panel597 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ItemsByInvoice_grid587, totals_panel592 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var general_panel598 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel568, general_2_panel576, general_3_panel597 ], "labelAlign": "top", "layout": "form", "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var journal599 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var accounting_period600 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Accounting period...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Accounting period</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(vat.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/accounting_period" }) }) });
    var number601 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(vat.Invoices.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var narration602 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Narration</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(vat.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var ledger_1_panel603 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": journal599, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": accounting_period600, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": number601, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": narration602, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox608 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(vat.Invoices.MovementsByVoucher) Show the ledger movements of a voucher.") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel609 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel603, MovementsByVoucher_htmlbox608 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel610 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel598, ledger_panel609 ], "labelAlign": "top", "split": true });
    this.items = main_panel610;
    this.before_row_edit = function(record) {
      ItemsByInvoice_grid587.on_master_changed();
      accounting_period600.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      MovementsByVoucher_htmlbox608.refresh();
    }
    Lino.vat.Invoices.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.PaymentTerms.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 39,
  initComponent : function() {
    var ref1011 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(ledger.PaymentTerms.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var months1012 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Months</span>", "listeners": { "render": Lino.quicktip_renderer("Months","(ledger.PaymentTerms.months) Number of months to add to voucher_date.") }, "name": "months", "selectOnFocus": true, "value": 0 });
    var days1013 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Days</span>", "listeners": { "render": Lino.quicktip_renderer("Days","(ledger.PaymentTerms.days) Number of days to add to voucher_date.") }, "name": "days", "selectOnFocus": true, "value": 0 });
    var end_of_month1014 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "End of month", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("End of month","(ledger.PaymentTerms.end_of_month) Whether to move voucher_date to the end of month.") }, "name": "end_of_month", "selectOnFocus": true });
    var main_1_panel1015 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": ref1011, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": months1012, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": days1013, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": end_of_month1014, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name1020 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(ledger.PaymentTerms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1021 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(ledger.PaymentTerms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1022 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(ledger.PaymentTerms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel1023 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name1020, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de1021, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr1022, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var printed_text1027 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Printed text</span>", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Printed text","(ledger.PaymentTerms.printed_text) Used in sales/VatProductInvoice/trailer.html as\nfollows:") }, "name": "printed_text", "selectOnFocus": true });
    var printed_text_de1028 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Printed text (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Printed text (de)","(ledger.PaymentTerms.printed_text_de) ") }, "name": "printed_text_de", "selectOnFocus": true });
    var printed_text_fr1029 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Printed text (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Printed text (fr)","(ledger.PaymentTerms.printed_text_fr) ") }, "name": "printed_text_fr", "selectOnFocus": true });
    var main_3_panel1030 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 71, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": printed_text1027, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": printed_text_de1028, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": printed_text_fr1029, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel1034 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1015, main_2_panel1023, main_3_panel1030 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1034;
    this.before_row_edit = function(record) {
    }
    Lino.ledger.PaymentTerms.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.PaymentOrders.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 64,
  initComponent : function() {
    var voucher_date639 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(finan.PaymentOrders.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var user640 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.PaymentOrders.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/user" }) }) });
    var narration641 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Narration</span>", "listeners": { "render": Lino.quicktip_renderer("Narration","(finan.PaymentOrders.narration) A short explanation which ascertains the subject matter of\nthis journal entry.") }, "maxLength": 200, "name": "narration", "selectOnFocus": true });
    var total642 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Total", "listeners": { "render": Lino.quicktip_renderer("Total","(finan.PaymentOrders.total) ") }, "name": "total", "selectOnFocus": true });
    var execution_date643 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Execution date", "listeners": { "render": Lino.quicktip_renderer("Execution date","(finan.PaymentOrders.execution_date) ") }, "name": "execution_date", "selectOnFocus": true });
    var workflow_buttons_disp644 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(finan.PaymentOrders.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel645 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": voucher_date639, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": user640, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": narration641, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": total642, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": execution_date643, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": workflow_buttons_disp644, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var finan_ItemsByPaymentOrder_grid667 = new Lino.finan.ItemsByPaymentOrder.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Content","(finan.finan.ItemsByPaymentOrder) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.finan.ItemsByPaymentOrder.grid) ] });
    var general_panel668 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel645, finan_ItemsByPaymentOrder_grid667 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var journal669 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.PaymentOrders.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/journal" }) }) });
    var accounting_period670 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Accounting period...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Accounting period</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(finan.PaymentOrders.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/accounting_period" }) }) });
    var number671 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(finan.PaymentOrders.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var id672 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(finan.PaymentOrders.id) ") }, "name": "id", "selectOnFocus": true });
    var ledger_1_panel673 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": journal669, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": accounting_period670, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": number671, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": id672, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox678 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(finan.PaymentOrders.MovementsByVoucher) Show the ledger movements of a voucher.") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel679 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel673, MovementsByVoucher_htmlbox678 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel680 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel668, ledger_panel679 ], "labelAlign": "top", "split": true });
    this.items = main_panel680;
    this.before_row_edit = function(record) {
      finan_ItemsByPaymentOrder_grid667.on_master_changed();
      accounting_period670.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      MovementsByVoucher_htmlbox678.refresh();
    }
    Lino.finan.PaymentOrders.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.BankStatements.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 61,
  initComponent : function() {
    var voucher_date707 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(finan.BankStatements.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var balance1708 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Old balance</span>", "listeners": { "render": Lino.quicktip_renderer("Old balance","(finan.BankStatements.balance1) The old (or start) balance.") }, "name": "balance1", "selectOnFocus": true, "value": 0 });
    var balance2709 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">New balance</span>", "listeners": { "render": Lino.quicktip_renderer("New balance","(finan.BankStatements.balance2) The new (or end) balance.") }, "name": "balance2", "selectOnFocus": true, "value": 0 });
    var user710 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(finan.BankStatements.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/user" }) }) });
    var workflow_buttons_disp711 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(finan.BankStatements.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel712 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": voucher_date707, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": balance1708, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 13, "items": balance2709, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": user710, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": workflow_buttons_disp711, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var finan_ItemsByBankStatement_grid735 = new Lino.finan.ItemsByBankStatement.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank Statement items","(finan.finan.ItemsByBankStatement) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.finan.ItemsByBankStatement.grid) ] });
    var general_panel736 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel712, finan_ItemsByBankStatement_grid735 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var journal737 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(finan.BankStatements.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/journal" }) }) });
    var accounting_period738 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Accounting period...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Accounting period</span>", "hiddenName": "accounting_periodHidden", "listeners": { "render": Lino.quicktip_renderer("Accounting period","(finan.BankStatements.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.") }, "name": "accounting_period", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/accounting_period" }) }) });
    var number739 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(finan.BankStatements.number) The sequence number of this voucher in the journal.") }, "name": "number", "selectOnFocus": true });
    var id740 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(finan.BankStatements.id) ") }, "name": "id", "selectOnFocus": true });
    var ledger_1_panel741 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": journal737, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": accounting_period738, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": number739, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": id740, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByVoucher_htmlbox746 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 75, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(finan.BankStatements.MovementsByVoucher) Show the ledger movements of a voucher.") }, "master_panel": this, "name": "MovementsByVoucher", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByVoucher.grid) ], "value": "<br/>" });
    var ledger_panel747 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel741, MovementsByVoucher_htmlbox746 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel748 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel736, ledger_panel747 ], "labelAlign": "top", "split": true });
    this.items = main_panel748;
    this.before_row_edit = function(record) {
      finan_ItemsByBankStatement_grid735.on_master_changed();
      accounting_period738.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      MovementsByVoucher_htmlbox746.refresh();
    }
    Lino.finan.BankStatements.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Tasks.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 18,
  initComponent : function() {
    var start_date1035 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.Tasks.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var due_date1036 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Due date", "listeners": { "render": Lino.quicktip_renderer("Due date","(cal.Tasks.due_date) ") }, "name": "due_date", "selectOnFocus": true });
    var id1037 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Tasks.id) ") }, "name": "id", "selectOnFocus": true });
    var workflow_buttons_disp1038 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(cal.Tasks.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var main_1_panel1039 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 21, "items": start_date1035, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": due_date1036, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": id1037, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 49, "items": workflow_buttons_disp1038, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var summary1044 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Short description", "listeners": { "render": Lino.quicktip_renderer("Short description","(cal.Tasks.summary) ") }, "maxLength": 200, "name": "summary", "selectOnFocus": true });
    var user1045 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.Tasks.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var owner_disp1046 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Controlled by", "name": "owner" });
    var created1047 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Created</span>", "listeners": { "render": Lino.quicktip_renderer("Created","(cal.Tasks.created) The timestame when this object was created.") }, "name": "created", "value": "<br>" });
    var modified1048 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Modified", "listeners": { "render": Lino.quicktip_renderer("Modified","(cal.Tasks.modified) ") }, "name": "modified", "value": "<br>" });
    var main_4_panel1049 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": owner_disp1046, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": created1047, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": modified1048, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description1053 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.Tasks.description) ") }, "name": "description", "selectOnFocus": true });
    var main_panel1054 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1039, { "autoHeight": true, "items": summary1044, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "items": user1045, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel1049, { "flex": 45, "items": description1053, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1054;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Tasks.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 52,
  initComponent : function() {
    var start_date1058 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Activities.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var line1059 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity line</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Activities.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var teacher1060 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Activities.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var main_2_panel1061 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": line1059, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": teacher1060, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1064 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": start_date1058, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel1061 ], "labelAlign": "top", "labelWidth": 99, "layout": "form" });
    this.items = main_panel1064;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Activities.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Hikes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref1066 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Hikes.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line1067 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity line</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Hikes.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/line" }) }) });
    var teacher1068 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Hikes.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/teacher" }) }) });
    var workflow_buttons_disp1069 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(courses.Hikes.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel1070 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref1066, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line1067, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher1068, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp1069, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room1075 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Hikes.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/room" }) }) });
    var start_date1076 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Hikes.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date1077 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Hikes.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time1078 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Hikes.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time1079 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Hikes.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel1080 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room1075, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date1076, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date1077, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time1078, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time1079, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name1086 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Hikes.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark1087 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remark", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Hikes.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel1088 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1070, general_2_panel1080, { "autoHeight": true, "items": name1086, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark1087, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var every_unit1091 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Hikes.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every1092 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Hikes.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date1093 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Generate events until", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Hikes.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events1094 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Number of events", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Hikes.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel1095 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit1091, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every1092, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date1093, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events1094, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday1100 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Hikes.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday1101 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Tuesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Hikes.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday1102 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wednesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Hikes.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday1103 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Thursday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Hikes.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday1104 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Friday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Hikes.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday1105 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Saturday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Hikes.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday1106 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sunday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Hikes.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel1107 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday1100, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday1101, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday1102, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday1103, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday1104, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday1105, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday1106, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EntriesByCourse_htmlbox1115 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Hikes.EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "EntriesByCourse", "title": "Calendar entries", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel1116 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel1095, events_2_panel1107, EntriesByCourse_htmlbox1115 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Events" });
    var enrolments_until1117 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Enrolments until", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Hikes.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee1118 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Default participation fee</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Default participation fee","(courses.Hikes.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/fee" }) }) });
    var max_places1119 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Available places</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Hikes.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed1120 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Confirmed", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Hikes.confirmed) ") }, "name": "confirmed" });
    var free_places1121 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Free places", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Hikes.free_places) ") }, "name": "free_places" });
    var print_actions_disp1122 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Print", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Hikes.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel1123 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until1117, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee1118, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places1119, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed1120, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places1121, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp1122, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByHike_htmlbox1130 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Hikes.EnrolmentsByHike) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" } ], "ls_insert_handler": Lino.courses.EnrolmentsByHike.insert, "master_panel": this, "name": "EnrolmentsByHike", "title": "Enrolments", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByHike.grid) ], "value": "<br/>" });
    var enrolments_panel1131 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel1123, EnrolmentsByHike_htmlbox1130 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Enrolments" });
    var state1132 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Hikes.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user1133 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Hikes.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/user" }) }) });
    var payment_term1134 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Hikes.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/payment_term" }) }) });
    var paper_type1135 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Paper type</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Hikes.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/paper_type" }) }) });
    var id1136 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Hikes.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel1137 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state1132, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user1133, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term1134, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type1135, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id1136, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid1167 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel1168 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1137, invoicing_InvoicingsByInvoiceable_grid1167 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var main_panel1169 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1088, events_panel1116, enrolments_panel1131, more_panel1168 ], "labelAlign": "top", "split": true });
    this.items = main_panel1169;
    this.before_row_edit = function(record) {
      EntriesByCourse_htmlbox1115.refresh();
      fee1118.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByHike_htmlbox1130.refresh();
      invoicing_InvoicingsByInvoiceable_grid1167.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line1067.on('change',Lino.chooser_handler(fee1118,'line'));
      Lino.courses.Hikes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Hikes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.AllRooms.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 20,
  initComponent : function() {
    var id1170 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.AllRooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name1171 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.AllRooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1172 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.AllRooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1173 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.AllRooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1174 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1170, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name1171, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de1172, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr1173, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company1179 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.AllRooms.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/company" }) }) });
    var contact_person1180 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Contact person</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.AllRooms.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/contact_person" }) }) });
    var main_2_panel1181 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": company1179, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": contact_person1180, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description1184 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.AllRooms.description) ") }, "name": "description", "selectOnFocus": true });
    var main_panel1222 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1174, main_2_panel1181, { "flex": 41, "items": description1184, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1222;
    this.before_row_edit = function(record) {
      contact_person1180.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company1179.on('change',Lino.chooser_handler(contact_person1180,'company'));
      Lino.cal.AllRooms.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.AllRooms.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.products.Products.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 31,
  initComponent : function() {
    var id1224 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(products.Products.id) ") }, "name": "id", "selectOnFocus": true });
    var cat1225 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff Category...", "fieldLabel": "Category", "hiddenName": "catHidden", "listeners": { "render": Lino.quicktip_renderer("Category","(products.Products.cat) ") }, "name": "cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,Lino.products.ProductCats.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/cat" }) }) });
    var sales_price1226 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Sales price", "listeners": { "render": Lino.quicktip_renderer("Sales price","(products.Products.sales_price) ") }, "name": "sales_price", "selectOnFocus": true });
    var number_of_events1227 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Number of events</span>", "listeners": { "render": Lino.quicktip_renderer("Number of events","(products.Products.number_of_events) Number of calendar events paid per invoicing.") }, "name": "number_of_events", "selectOnFocus": true });
    var min_asset1228 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Invoice threshold</span>", "listeners": { "render": Lino.quicktip_renderer("Invoice threshold","(products.Products.min_asset) Minimum quantity to pay in advance.") }, "name": "min_asset", "selectOnFocus": true, "value": 1 });
    var general_1_panel1229 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 8, "items": id1224, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 35, "items": cat1225, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": sales_price1226, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": number_of_events1227, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": min_asset1228, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var vat_class1235 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "VAT Class", "forceSelection": true, "hiddenName": "vat_classHidden", "listeners": { "render": Lino.quicktip_renderer("VAT Class","(products.Products.vat_class) ") }, "name": "vat_class", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var delivery_unit1236 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Delivery unit", "forceSelection": true, "hiddenName": "delivery_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Delivery unit","(products.Products.delivery_unit) ") }, "name": "delivery_unit", "selectOnFocus": true, "store": Lino.products.DeliveryUnit, "value": "20" });
    var general_2_panel1237 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 55, "items": vat_class1235, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": delivery_unit1236, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name1240 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(products.Products.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1241 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(products.Products.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1242 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(products.Products.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var general_3_panel1243 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name1240, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de1241, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr1242, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description1247 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Long description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Long description","(products.Products.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de1248 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Long description (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Long description (de)","(products.Products.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr1249 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Long description (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Long description (fr)","(products.Products.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var general_4_panel1250 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 62, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description1247, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de1248, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr1249, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel1254 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1229, general_2_panel1237, general_3_panel1243, general_4_panel1250 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var EnrolmentsByFee_htmlbox1255 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 3, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments using this fee","(products.Products.EnrolmentsByFee) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" } ], "ls_insert_handler": Lino.courses.EnrolmentsByFee.insert, "master_panel": this, "name": "EnrolmentsByFee", "region": "north", "split": true, "title": "Enrolments using this fee", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByFee.grid) ], "value": "<br/>" });
    var courses_EnrolmentsByOption_grid1332 = new Lino.courses.EnrolmentsByOption.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Enrolments using this option","(courses.courses.EnrolmentsByOption) Base class for all enrolment tables.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByOption.grid) ] });
    var courses_panel1333 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ EnrolmentsByFee_htmlbox1255, courses_EnrolmentsByOption_grid1332 ], "labelAlign": "top", "labelWidth": 234, "listeners": { "activate": Lino.on_tab_activate }, "title": "Enrolments" });
    var main_panel1334 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1254, courses_panel1333 ], "labelAlign": "top", "split": true });
    this.items = main_panel1334;
    this.before_row_edit = function(record) {
      EnrolmentsByFee_htmlbox1255.refresh();
      courses_EnrolmentsByOption_grid1332.on_master_changed();
    }
    Lino.products.Products.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Journeys.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref1335 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Journeys.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line1336 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity line</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Journeys.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/line" }) }) });
    var teacher1337 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Journeys.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/teacher" }) }) });
    var workflow_buttons_disp1338 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(courses.Journeys.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel1339 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref1335, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line1336, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher1337, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp1338, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room1344 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Journeys.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/room" }) }) });
    var start_date1345 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Journeys.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date1346 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Journeys.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time1347 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Journeys.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time1348 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Journeys.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel1349 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room1344, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date1345, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date1346, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time1347, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time1348, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name1355 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Journeys.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark1356 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remark", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Journeys.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel1357 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1339, general_2_panel1349, { "autoHeight": true, "items": name1355, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark1356, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var every_unit1360 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Journeys.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every1361 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Journeys.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date1362 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Generate events until", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Journeys.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events1363 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Number of events", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Journeys.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel1364 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit1360, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every1361, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date1362, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events1363, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday1369 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Journeys.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday1370 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Tuesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Journeys.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday1371 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wednesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Journeys.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday1372 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Thursday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Journeys.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday1373 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Friday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Journeys.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday1374 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Saturday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Journeys.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday1375 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sunday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Journeys.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel1376 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday1369, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday1370, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday1371, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday1372, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday1373, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday1374, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday1375, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EntriesByCourse_htmlbox1384 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Journeys.EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "EntriesByCourse", "title": "Calendar entries", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel1385 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel1364, events_2_panel1376, EntriesByCourse_htmlbox1384 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Events" });
    var enrolments_until1386 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Enrolments until", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Journeys.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee1387 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Default participation fee</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Default participation fee","(courses.Journeys.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/fee" }) }) });
    var max_places1388 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Available places</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Journeys.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed1389 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Confirmed", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Journeys.confirmed) ") }, "name": "confirmed" });
    var free_places1390 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Free places", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Journeys.free_places) ") }, "name": "free_places" });
    var print_actions_disp1391 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Print", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Journeys.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel1392 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until1386, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee1387, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places1388, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed1389, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places1390, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp1391, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByJourney_htmlbox1399 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Journeys.EnrolmentsByJourney) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" } ], "ls_insert_handler": Lino.courses.EnrolmentsByJourney.insert, "master_panel": this, "name": "EnrolmentsByJourney", "title": "Enrolments", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByJourney.grid) ], "value": "<br/>" });
    var enrolments_panel1400 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel1392, EnrolmentsByJourney_htmlbox1399 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Enrolments" });
    var state1401 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Journeys.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user1402 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Journeys.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/user" }) }) });
    var payment_term1403 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Journeys.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/payment_term" }) }) });
    var paper_type1404 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Paper type</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Journeys.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/paper_type" }) }) });
    var id1405 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Journeys.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel1406 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state1401, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user1402, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term1403, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type1404, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id1405, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid1412 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel1413 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1406, invoicing_InvoicingsByInvoiceable_grid1412 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var main_panel1414 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1357, events_panel1385, enrolments_panel1400, more_panel1413 ], "labelAlign": "top", "split": true });
    this.items = main_panel1414;
    this.before_row_edit = function(record) {
      EntriesByCourse_htmlbox1384.refresh();
      fee1387.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByJourney_htmlbox1399.refresh();
      invoicing_InvoicingsByInvoiceable_grid1412.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line1336.on('change',Lino.chooser_handler(fee1387,'line'));
      Lino.courses.Journeys.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Journeys.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Guests.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 19,
  initComponent : function() {
    var event876 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry</span>", "hiddenName": "eventHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry","(cal.Guests.event) The calendar event to which this presence applies.") }, "name": "event", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.OneEvent.detail,Lino.cal.OneEvent.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/event" }) }) });
    var partner877 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(cal.Guests.partner) The partner to which this presence applies.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    var role878 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Guest Role...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Role</span>", "hiddenName": "roleHidden", "listeners": { "render": Lino.quicktip_renderer("Role","(cal.Guests.role) The role of this partner in this presence.") }, "name": "role", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,Lino.cal.GuestRoles.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/role" }) }) });
    var main_panel879 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": event876, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": partner877, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": role878, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel879;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Guests.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sepa.AccountsByPartner.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 65,
  initComponent : function() {
    var iban1415 = new Lino.UppercaseTextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "IBAN", "listeners": { "render": Lino.quicktip_renderer("IBAN","(sepa.AccountsByPartner.iban) ") }, "maxLength": 34, "name": "iban", "selectOnFocus": true });
    var bic1416 = new Lino.UppercaseTextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "BIC", "listeners": { "render": Lino.quicktip_renderer("BIC","(sepa.AccountsByPartner.bic) ") }, "maxLength": 11, "name": "bic", "selectOnFocus": true });
    var main_1_panel1417 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 63, "items": iban1415, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": bic1416, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 45, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1420 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(sepa.AccountsByPartner.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var main_panel1421 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1417, { "anchor": "-20", "autoHeight": true, "items": remark1420, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "form" });
    this.items = main_panel1421;
    this.before_row_edit = function(record) {
    }
    Lino.sepa.AccountsByPartner.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.ActivityReport.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var body_htmlbox1423 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(ledger.ActivityReport.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel1424 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox1423 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel1424;
    this.before_row_edit = function(record) {
      body_htmlbox1423.refresh();
    }
    Lino.ledger.ActivityReport.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Companies.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 7,
  initComponent : function() {
    var overview_disp1425 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Description", "listeners": { "render": Lino.quicktip_renderer("Description","(contacts.Companies.overview) ") }, "name": "overview", "value": "<br/>" });
    var email1426 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Companies.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone1427 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Phone</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(contacts.Companies.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm1428 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(contacts.Companies.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var fax1429 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Fax", "listeners": { "render": Lino.quicktip_renderer("Fax","(contacts.Companies.fax) ") }, "maxLength": 200, "name": "fax", "selectOnFocus": true });
    var contact_box_panel1430 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email1426, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone1427, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm1428, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": fax1429, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid1445 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel1446 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp1425, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel1430, lists_MembersByPartner_grid1445 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks1448 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(contacts.Companies.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_grid1472 = new Lino.plausibility.ProblemsByOwner.GridPanel({ "containing_panel": this, "flex": 37, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ] });
    var bottom_box_1_panel1473 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks1448, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_grid1472 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel1475 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1446, bottom_box_1_panel1473 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var prefix1476 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Name prefix", "listeners": { "render": Lino.quicktip_renderer("Name prefix","(contacts.Companies.prefix) ") }, "maxLength": 200, "name": "prefix", "selectOnFocus": true });
    var name1477 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Companies.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var address_box_1_panel1478 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": prefix1476, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": name1477, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street1481 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Street</span>", "listeners": { "render": Lino.quicktip_renderer("Street","(contacts.Companies.street) Name of street, without house number.") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box1482 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Box</span>", "listeners": { "render": Lino.quicktip_renderer("Box","(contacts.Companies.street_box) Text to print after street nuber on the same line.") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel1483 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street1481, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box1482, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr21486 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line after street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(contacts.Companies.addr2) Address line to print below street line.") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var country1487 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Country...", "fieldLabel": "Country", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(contacts.Companies.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/country" }) }) });
    var zip_code1488 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Zip code", "listeners": { "render": Lino.quicktip_renderer("Zip code","(contacts.Companies.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city1489 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Place...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">City</span>", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("City","(contacts.Companies.city) A pointer to Place.") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,Lino.countries.Places.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/city" }) }) });
    var address_box_4_panel1490 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country1487, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code1488, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city1489, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel1494 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel1478, address_box_2_panel1483, { "anchor": "-20", "autoHeight": true, "items": addr21486, "labelAlign": "top", "layout": "form", "xtype": "panel" }, address_box_4_panel1490 ], "labelAlign": "top", "labelWidth": 234, "layout": "form" });
    var contacts_RolesByCompany_grid1504 = new Lino.contacts.RolesByCompany.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact persons","(contacts.contacts.RolesByCompany) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByCompany.grid) ] });
    var sepa_AccountsByPartner_grid1516 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel1517 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 55, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByCompany_grid1504, sepa_AccountsByPartner_grid1516 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel1518 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel1494, address_2_panel1517 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Address" });
    var id1519 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Companies.id) ") }, "name": "id", "selectOnFocus": true });
    var language1520 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Companies.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var type1521 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Organization type</span>", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Organization type","(contacts.Companies.type) Pointer to the CompanyType.") }, "name": "type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/type" }) }) });
    var vat_id1522 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "VAT id", "listeners": { "render": Lino.quicktip_renderer("VAT id","(contacts.Companies.vat_id) ") }, "maxLength": 200, "name": "vat_id", "selectOnFocus": true });
    var more_1_panel1523 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1519, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": language1520, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": type1521, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": vat_id1522, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr11528 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line before street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(contacts.Companies.addr1) Address line before street") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var url1529 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "URL", "listeners": { "render": Lino.quicktip_renderer("URL","(contacts.Companies.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_2_panel1530 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr11528, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": url1529, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByCompany_grid1657 = new Lino.notes.NotesByCompany.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByCompany) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByCompany.grid) ] });
    var more_panel1658 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1523, more_2_panel1530, notes_NotesByCompany_grid1657 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var invoice_recipient1659 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Invoicing address</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(contacts.Companies.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/invoice_recipient" }) }) });
    var vat_regime1660 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(contacts.Companies.vat_regime) The default VAT regime for         sales and purchases of this partner.") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel1661 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": invoice_recipient1659, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 57, "items": vat_regime1660, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term1664 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(contacts.Companies.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/payment_term" }) }) });
    var paper_type1665 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "Paper type", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(contacts.Companies.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/paper_type" }) }) });
    var ledger_a_2_panel1666 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term1664, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type1665, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel1669 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 61, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel1661, ledger_a_2_panel1666 ], "labelAlign": "top", "layout": "form" });
    var MovementsByPartner_htmlbox1670 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 38, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(contacts.Companies.MovementsByPartner) Show the ledger movements of a partner.\nSee also lino_xl.lib.ledger.models.Movement.") }, "master_panel": this, "name": "MovementsByPartner", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel1671 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel1669, MovementsByPartner_htmlbox1670 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid1704 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel1705 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel1671, sales_InvoicesByPartner_grid1704 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel1706 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1475, address_panel1518, more_panel1658, ledger_panel1705 ], "labelAlign": "top", "split": true });
    this.items = main_panel1706;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid1445.on_master_changed();
      plausibility_ProblemsByOwner_grid1472.on_master_changed();
      city1489.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city1489.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByCompany_grid1504.on_master_changed();
      sepa_AccountsByPartner_grid1516.on_master_changed();
      notes_NotesByCompany_grid1657.on_master_changed();
      MovementsByPartner_htmlbox1670.refresh();
      sales_InvoicesByPartner_grid1704.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country1487.on('change',Lino.chooser_handler(city1489,'country'));
      Lino.contacts.Companies.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.contacts.Companies.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city1489.on("change", function(){ this.save() }, this);
    zip_code1488.on("change", function(){ this.save() }, this);
  }
});


Lino.courses.PupilTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 50,
  initComponent : function() {
    var id1707 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.PupilTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name1708 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.PupilTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de1709 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.PupilTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr1710 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.PupilTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel1711 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id1707, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name1708, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de1709, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr1710, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_PupilsByType_grid1967 = new Lino.courses.PupilsByType.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Participants","(courses.courses.PupilsByType) The global list of all pupils.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.PupilsByType.grid) ] });
    var main_panel1968 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1711, courses_PupilsByType_grid1967 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1968;
    this.before_row_edit = function(record) {
      courses_PupilsByType_grid1967.on_master_changed();
    }
    Lino.courses.PupilTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.system.SiteConfigs.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 1,
  initComponent : function() {
    var site_company1969 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Site owner</span>", "hiddenName": "site_companyHidden", "listeners": { "render": Lino.quicktip_renderer("Site owner","(system.SiteConfigs.site_company) The organisation who runs this site.  This is used e.g. when\nprinting your address in certain documents or reports.  Or\nnewly created partners inherit the country of the site owner.") }, "name": "site_company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_company" }) }) });
    var next_partner_id1970 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Next partner id</span>", "listeners": { "render": Lino.quicktip_renderer("Next partner id","(system.SiteConfigs.next_partner_id) The next automatic id for any new partner.") }, "name": "next_partner_id", "selectOnFocus": true, "value": 100 });
    var main_1_panel1971 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 66, "items": site_company1969, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": next_partner_id1970, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var default_build_method1974 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Default build method</span>", "forceSelection": true, "hiddenName": "default_build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Default build method","(system.SiteConfigs.default_build_method) The default build method to use when rendering printable documents.") }, "name": "default_build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var simulate_today1975 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Simulated date</span>", "listeners": { "render": Lino.quicktip_renderer("Simulated date","(system.SiteConfigs.simulate_today) A constant user-defined date to be substituted as current\nsystem date.") }, "name": "simulate_today", "selectOnFocus": true });
    var main_2_panel1976 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 63, "items": default_build_method1974, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": simulate_today1975, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var clients_account1979 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Clients account", "hiddenName": "clients_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Clients account","(system.SiteConfigs.clients_account) ") }, "name": "clients_account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/clients_account" }) }) });
    var sales_account1980 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Sales Base account", "hiddenName": "sales_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Sales Base account","(system.SiteConfigs.sales_account) ") }, "name": "sales_account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/sales_account" }) }) });
    var sales_vat_account1981 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Sales VAT account", "hiddenName": "sales_vat_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Sales VAT account","(system.SiteConfigs.sales_vat_account) ") }, "name": "sales_vat_account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/sales_vat_account" }) }) });
    var main_3_panel1982 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": clients_account1979, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": sales_account1980, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": sales_vat_account1981, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var suppliers_account1986 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Suppliers account", "hiddenName": "suppliers_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Suppliers account","(system.SiteConfigs.suppliers_account) ") }, "name": "suppliers_account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/suppliers_account" }) }) });
    var purchases_account1987 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Purchases Base account", "hiddenName": "purchases_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Purchases Base account","(system.SiteConfigs.purchases_account) ") }, "name": "purchases_account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/purchases_account" }) }) });
    var purchases_vat_account1988 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Purchases VAT account", "hiddenName": "purchases_vat_accountHidden", "listeners": { "render": Lino.quicktip_renderer("Purchases VAT account","(system.SiteConfigs.purchases_vat_account) ") }, "name": "purchases_vat_account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/purchases_vat_account" }) }) });
    var main_4_panel1989 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": suppliers_account1986, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": purchases_account1987, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": purchases_vat_account1988, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 207, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var site_calendar1993 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Site Calendar</span>", "hiddenName": "site_calendarHidden", "listeners": { "render": Lino.quicktip_renderer("Site Calendar","(system.SiteConfigs.site_calendar) The default calendar of this site.") }, "name": "site_calendar", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.Calendars.detail,Lino.cal.Calendars.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_calendar" }) }) });
    var default_event_type1994 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Default Event Type</span>", "hiddenName": "default_event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Default Event Type","(system.SiteConfigs.default_event_type) The default type of events on this site.") }, "name": "default_event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/default_event_type" }) }) });
    var pupil_guestrole1995 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Guest Role...", "fieldLabel": "Guest role for pupils", "hiddenName": "pupil_guestroleHidden", "listeners": { "render": Lino.quicktip_renderer("Guest role for pupils","(system.SiteConfigs.pupil_guestrole) ") }, "name": "pupil_guestrole", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,Lino.cal.GuestRoles.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/pupil_guestrole" }) }) });
    var main_5_panel1996 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": site_calendar1993, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": default_event_type1994, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": pupil_guestrole1995, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var max_auto_events2000 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Max automatic events</span>", "listeners": { "render": Lino.quicktip_renderer("Max automatic events","(system.SiteConfigs.max_auto_events) Maximum number of automatic events to be generated.") }, "name": "max_auto_events", "selectOnFocus": true, "value": 72 });
    var hide_events_before2001 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Hide events before</span>", "listeners": { "render": Lino.quicktip_renderer("Hide events before","(system.SiteConfigs.hide_events_before) If this is specified, certain tables show only \nevents after the given date.") }, "name": "hide_events_before", "selectOnFocus": true });
    var main_6_panel2002 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 27, "items": max_auto_events2000, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 72, "items": hide_events_before2001, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2005 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1971, main_2_panel1976, main_3_panel1982, main_4_panel1989, main_5_panel1996, main_6_panel2002 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2005;
    this.before_row_edit = function(record) {
    }
    Lino.system.SiteConfigs.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.rooms.Bookings.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 32,
  initComponent : function() {
    var start_date1617 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(rooms.Bookings.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time1618 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(rooms.Bookings.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time1619 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(rooms.Bookings.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_1_panel1620 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 44, "items": start_date1617, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": start_time1618, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": end_time1619, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room1624 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(rooms.Bookings.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/room" }) }) });
    var event_type1625 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry type</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(rooms.Bookings.event_type) The Event Type to which events will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/event_type" }) }) });
    var main_2_panel1626 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": room1624, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": event_type1625, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company1629 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Organizer</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Organizer","(rooms.Bookings.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var contact_person1630 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Contact person</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(rooms.Bookings.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/contact_person" }) }) });
    var main_3_panel1631 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": company1629, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": contact_person1630, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1634 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1620, main_2_panel1626, main_3_panel1631 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1634;
    this.before_row_edit = function(record) {
      contact_person1630.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company1629.on('change',Lino.chooser_handler(contact_person1630,'company'));
      Lino.rooms.Bookings.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.rooms.Bookings.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.Invoices.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 45,
  initComponent : function() {
    var partner533 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(sales.Invoices.partner) Mandatory field to be defined in another class.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var voucher_date534 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(sales.Invoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var main_1_panel535 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 60, "items": partner533, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": voucher_date534, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var subject538 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Subject line", "listeners": { "render": Lino.quicktip_renderer("Subject line","(sales.Invoices.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var main_panel539 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel535, { "anchor": "-20", "autoHeight": true, "items": subject538, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel539;
    this.before_row_edit = function(record) {
    }
    Lino.sales.Invoices.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Rooms.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 20,
  initComponent : function() {
    var id2006 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Rooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name2007 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Rooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2008 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Rooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2009 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Rooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var calendar2010 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar</span>", "hiddenName": "calendarHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar","(cal.Rooms.calendar) Calendar where events in this room are published.") }, "name": "calendar", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.Calendars.detail,Lino.cal.Calendars.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/calendar" }) }) });
    var main_1_panel2011 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 5, "items": id2006, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name2007, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_de2008, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_fr2009, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": calendar2010, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var fee2017 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "Tariff", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(cal.Rooms.fee) ") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/fee" }) }) });
    var company2018 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.Rooms.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/company" }) }) });
    var contact_person2019 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Contact person</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.Rooms.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_person" }) }) });
    var contact_role2020 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Function...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">represented as</span>", "hiddenName": "contact_roleHidden", "listeners": { "render": Lino.quicktip_renderer("represented as","(cal.Rooms.contact_role) The optional Role\nof the contact_person within company.") }, "name": "contact_role", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_role" }) }) });
    var main_2_panel2021 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": fee2017, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": company2018, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": contact_person2019, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": contact_role2020, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2027 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2011, main_2_panel2021 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2027;
    this.before_row_edit = function(record) {
      contact_person2019.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company2018.on('change',Lino.chooser_handler(contact_person2019,'company'));
      Lino.cal.Rooms.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.Rooms.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Persons.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 8,
  initComponent : function() {
    var overview_disp2028 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Description", "listeners": { "render": Lino.quicktip_renderer("Description","(contacts.Persons.overview) ") }, "name": "overview", "value": "<br/>" });
    var email2029 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Persons.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone2030 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Phone</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(contacts.Persons.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm2031 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(contacts.Persons.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel2032 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email2029, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone2030, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm2031, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid2036 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel2037 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp2028, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel2032, lists_MembersByPartner_grid2036 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks2039 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(contacts.Persons.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_grid2040 = new Lino.plausibility.ProblemsByOwner.GridPanel({ "containing_panel": this, "flex": 37, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ] });
    var bottom_box_1_panel2041 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks2039, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_grid2040 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel2043 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2037, bottom_box_1_panel2041 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var last_name2044 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Last name</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(contacts.Persons.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var first_name2045 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">First name</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(contacts.Persons.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var gender2046 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gender</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(contacts.Persons.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var address_box_1_panel2047 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 46, "items": last_name2044, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": first_name2045, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": gender2046, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street2051 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Street</span>", "listeners": { "render": Lino.quicktip_renderer("Street","(contacts.Persons.street) Name of street, without house number.") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box2052 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Box</span>", "listeners": { "render": Lino.quicktip_renderer("Box","(contacts.Persons.street_box) Text to print after street nuber on the same line.") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel2053 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street2051, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box2052, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var country2056 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Country...", "fieldLabel": "Country", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(contacts.Persons.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/country" }) }) });
    var zip_code2057 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Zip code", "listeners": { "render": Lino.quicktip_renderer("Zip code","(contacts.Persons.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city2058 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Place...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">City</span>", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("City","(contacts.Persons.city) A pointer to Place.") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,Lino.countries.Places.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/city" }) }) });
    var address_box_3_panel2059 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country2056, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code2057, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city2058, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var birth_date2063 = new Lino.IncompleteDateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Birth date</span>", "listeners": { "render": Lino.quicktip_renderer("Birth date","(contacts.Persons.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".") }, "name": "birth_date", "selectOnFocus": true });
    var age_disp2064 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Age", "listeners": { "render": Lino.quicktip_renderer("Age","(contacts.Persons.age) ") }, "name": "age", "value": "<br/>" });
    var national_id2065 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">National ID</span>", "listeners": { "render": Lino.quicktip_renderer("National ID","(contacts.Persons.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.") }, "maxLength": 200, "name": "national_id", "selectOnFocus": true });
    var card_number2066 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "eID card number", "listeners": { "render": Lino.quicktip_renderer("eID card number","(contacts.Persons.card_number) ") }, "maxLength": 20, "name": "card_number", "selectOnFocus": true });
    var personal_panel2067 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 65, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": national_id2065, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": card_number2066, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_4_panel2070 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": birth_date2063, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": age_disp2064, "labelAlign": "top", "layout": "form", "xtype": "panel" }, personal_panel2067 ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel2073 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel2047, address_box_2_panel2053, address_box_3_panel2059, address_box_4_panel2070 ], "labelAlign": "top", "layout": "form" });
    var contacts_RolesByPerson_grid2074 = new Lino.contacts.RolesByPerson.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact for","(contacts.contacts.RolesByPerson) Shows all roles of a person.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByPerson.grid) ] });
    var sepa_AccountsByPartner_grid2075 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel2076 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 45, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByPerson_grid2074, sepa_AccountsByPartner_grid2075 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel2077 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel2073, address_2_panel2076 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Address" });
    var invoice_recipient2078 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Invoicing address</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(contacts.Persons.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/invoice_recipient" }) }) });
    var vat_regime2079 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(contacts.Persons.vat_regime) The default VAT regime for         sales and purchases of this partner.") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel2080 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": invoice_recipient2078, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 57, "items": vat_regime2079, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term2083 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(contacts.Persons.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/payment_term" }) }) });
    var paper_type2084 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "Paper type", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(contacts.Persons.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/paper_type" }) }) });
    var ledger_a_2_panel2085 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term2083, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type2084, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel2088 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 61, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel2080, ledger_a_2_panel2085 ], "labelAlign": "top", "layout": "form" });
    var MovementsByPartner_htmlbox2089 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 38, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(contacts.Persons.MovementsByPartner) Show the ledger movements of a partner.\nSee also lino_xl.lib.ledger.models.Movement.") }, "master_panel": this, "name": "MovementsByPartner", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel2090 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel2088, MovementsByPartner_htmlbox2089 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid2091 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel2092 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel2090, sales_InvoicesByPartner_grid2091 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var id2093 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Persons.id) ") }, "name": "id", "selectOnFocus": true });
    var language2094 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Persons.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url2095 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "URL", "listeners": { "render": Lino.quicktip_renderer("URL","(contacts.Persons.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_1_panel2096 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 10, "items": id2093, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": language2094, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": url2095, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr12100 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line before street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(contacts.Persons.addr1) Address line before street") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var addr22101 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line after street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(contacts.Persons.addr2) Address line to print below street line.") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var more_2_panel2102 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr12100, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": addr22101, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByPerson_grid2105 = new Lino.notes.NotesByPerson.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByPerson.grid) ] });
    var more_panel2106 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel2096, more_2_panel2102, notes_NotesByPerson_grid2105 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var main_panel2107 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2043, address_panel2077, ledger_panel2092, more_panel2106 ], "labelAlign": "top", "split": true });
    this.items = main_panel2107;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid2036.on_master_changed();
      plausibility_ProblemsByOwner_grid2040.on_master_changed();
      city2058.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city2058.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByPerson_grid2074.on_master_changed();
      sepa_AccountsByPartner_grid2075.on_master_changed();
      MovementsByPartner_htmlbox2089.refresh();
      sales_InvoicesByPartner_grid2091.on_master_changed();
      notes_NotesByPerson_grid2105.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country2056.on('change',Lino.chooser_handler(city2058,'country'));
      Lino.contacts.Persons.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.contacts.Persons.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city2058.on("change", function(){ this.save() }, this);
    zip_code2057.on("change", function(){ this.save() }, this);
  }
});


Lino.uploads.Uploads.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 71,
  initComponent : function() {
    var file2108 = Lino.file_field_handler(this,{ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">File</span>", "listeners": { "render": Lino.quicktip_renderer("File","(uploads.Uploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file") }, "maxLength": 100, "name": "file", "selectOnFocus": true });
    var user2109 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Uploaded by</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Uploaded by","(uploads.Uploads.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var main_1_panel2110 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": file2108, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": user2109, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var upload_area2113 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Upload Area", "forceSelection": true, "hiddenName": "upload_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Area","(uploads.Uploads.upload_area) ") }, "name": "upload_area", "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var type2114 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Upload Type...", "fieldLabel": "Upload Type", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.Uploads.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/type" }) }) });
    var description2115 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Description</span>", "listeners": { "render": Lino.quicktip_renderer("Description","(uploads.Uploads.description) A short description entered manually by the user.") }, "maxLength": 200, "name": "description", "selectOnFocus": true });
    var main_2_panel2116 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": upload_area2113, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": type2114, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": description2115, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var owner_disp2120 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Controlled by", "name": "owner" });
    var main_panel2121 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2110, main_2_panel2116, { "anchor": "-20", "autoHeight": true, "items": owner_disp2120, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "form" });
    this.items = main_panel2121;
    this.before_row_edit = function(record) {
      type2114.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      upload_area2113.on('change',Lino.chooser_handler(type2114,'upload_area'));
      Lino.uploads.Uploads.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.uploads.Uploads.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.gfks.ContentTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 15,
  initComponent : function() {
    var id2123 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(gfks.ContentTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var app_label2124 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "app label", "listeners": { "render": Lino.quicktip_renderer("app label","(gfks.ContentTypes.app_label) ") }, "maxLength": 100, "name": "app_label", "selectOnFocus": true });
    var model2125 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "python model class name", "listeners": { "render": Lino.quicktip_renderer("python model class name","(gfks.ContentTypes.model) ") }, "maxLength": 100, "name": "model", "selectOnFocus": true });
    var base_classes_disp2126 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Base classes", "listeners": { "render": Lino.quicktip_renderer("Base classes","(gfks.ContentTypes.base_classes) ") }, "name": "base_classes", "value": "<br/>" });
    var main_1_panel2127 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 6, "items": id2123, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": app_label2124, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": model2125, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": base_classes_disp2126, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 216, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var HelpTextsByModel_grid2138 = new Lino.gfks.HelpTextsByModel.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Help Texts","(gfks.gfks.HelpTextsByModel) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.gfks.HelpTextsByModel.grid) ] });
    var BrokenGFKsByModel_grid2143 = new Lino.gfks.BrokenGFKsByModel.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Broken GFKs","(gfks.gfks.BrokenGFKsByModel) Shows all database objects (model instances) who have a broken\nGeneriForeignKey field.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.gfks.BrokenGFKsByModel.grid) ] });
    var main_panel2144 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2127, HelpTextsByModel_grid2138, BrokenGFKsByModel_grid2143 ], "labelAlign": "top" });
    this.items = main_panel2144;
    this.before_row_edit = function(record) {
      HelpTextsByModel_grid2138.on_master_changed();
      BrokenGFKsByModel_grid2143.on_master_changed();
    }
    Lino.gfks.ContentTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.about.About.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var server_status_disp2146 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Server status", "listeners": { "render": Lino.quicktip_renderer("Server status","(about.About.server_status) ") }, "name": "server_status", "value": "<br/>" });
    var main_panel2147 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "flex": 25, "html": "<div class=\"htmlText\"><span>This is <a href=\"http://voga.lino-framework.org\" target=\"_blank\">Lino Voga</a> 2016.12.0 using <a href=\"http://www.lino-framework.org\" target=\"_blank\">Lino</a> 2016.12.0, <a href=\"http://www.djangoproject.com\" target=\"_blank\">Django</a> 1.9.12, <a href=\"http://www.python.org/\" target=\"_blank\">Python</a> 2.7.12, <a href=\"http://babel.edgewall.org/\" target=\"_blank\">Babel</a> 2.3.4, <a href=\"http://jinja.pocoo.org/\" target=\"_blank\">Jinja</a> 2.9.5, <a href=\"http://labix.org/python-dateutil\" target=\"_blank\">python-dateutil</a> 2.6.0, <a href=\"http://getbootstrap.com\" target=\"_blank\">Bootstrap</a> 3.3.4, <a href=\"http://www.sencha.com\" target=\"_blank\">ExtJS</a> <a href=\"#\" onclick=\"alert('ExtJS client version is ' + Ext.version);\" title=\"Click to see ExtJS client version\">(version)</a>, <a href=\"http://www.famfamfam.com/lab/icons/silk/\" target=\"_blank\">Silk Icons</a> 1.3, <a href=\"https://github.com/django/channels\" target=\"_blank\">Channels (inactive)</a> 1.0.3, <a href=\"http://ext.ensible.com/products/calendar/\" target=\"_blank\">Ext.ensible adapter</a> <a href=\"#\" onclick=\"alert('Extensible Calendar version is '             + Ext.ensible.version);\" title=\"Click to see Extensible Calendar version\">(version)</a>, <a href=\"http://appyframework.org/pod.html\" target=\"_blank\">Appy</a> 0.9.5 (2017/03/01 08:14)</span><p>Languages: en, de, fr</p><p>Server uptime : <b>05/04/2017 at 02:40</b> (None)</p><p>This is a Lino demo site.</p><p>We are running with simulated date set to Friday, 22 May 2015.</p><p>Source timestamps:</p><ul><li>atelier : <b>15/03/2017 at 18:14</b></li><li>django : <b>31/03/2017 at 03:50</b></li><li>lino_xl : <b>04/04/2017 at 18:52</b></li><li>lino_cosi : <b>04/04/2017 at 18:52</b></li><li>lino_voga : <b>05/04/2017 at 01:21</b></li><li>lino : <b>05/04/2017 at 02:40</b></li></ul></div>", "xtype": "label" }, { "autoHeight": true, "items": server_status_disp2146, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2147;
    this.before_row_edit = function(record) {
    }
    Lino.about.About.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Slots.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 49,
  initComponent : function() {
    var start_time2149 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start Time", "listeners": { "render": Lino.quicktip_renderer("Start Time","(courses.Slots.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2150 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Slots.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_1_panel2151 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": start_time2149, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": end_time2150, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2154 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Name", "listeners": { "render": Lino.quicktip_renderer("Name","(courses.Slots.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var main_panel2155 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2151, { "anchor": "-20", "autoHeight": true, "items": name2154, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 45, "layout": "form" });
    this.items = main_panel2155;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Slots.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.countries.Countries.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 4,
  initComponent : function() {
    var isocode2157 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">ISO code</span>", "listeners": { "render": Lino.quicktip_renderer("ISO code","(countries.Countries.isocode)         The two-letter code for this country as defined by ISO 3166-1.\n        For countries that no longer exist it may be a 4-letter code.") }, "maxLength": 4, "name": "isocode", "selectOnFocus": true });
    var short_code2158 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Short code</span>", "listeners": { "render": Lino.quicktip_renderer("Short code","(countries.Countries.short_code) A short abbreviation for regional usage. Obsolete.") }, "maxLength": 4, "name": "short_code", "selectOnFocus": true });
    var main_1_panel2159 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": isocode2157, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": short_code2158, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2162 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(countries.Countries.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2163 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(countries.Countries.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2164 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(countries.Countries.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2165 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2162, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2163, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2164, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2169 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2159, main_2_panel2165 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2169;
    this.before_row_edit = function(record) {
    }
    Lino.countries.Countries.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.NoteTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 69,
  initComponent : function() {
    var id2170 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(notes.NoteTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name2171 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(notes.NoteTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2172 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(notes.NoteTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2173 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(notes.NoteTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2174 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id2170, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name2171, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de2172, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr2173, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var build_method2179 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Build method</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(notes.NoteTypes.build_method) A pointer to an item of\nlino.modlib.printing.choicelists.BuildMethods.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template2180 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Template</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(notes.NoteTypes.template) The name of the file to be used as template.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NoteTypes/template" }) }) });
    var special_type2181 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(5), "fieldLabel": "Special note type", "listeners": { "render": Lino.quicktip_renderer("Special note type","(notes.NoteTypes.special_type) ") }, "maxLength": 5, "name": "special_type", "selectOnFocus": true });
    var email_template2182 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Email template</span>", "listeners": { "render": Lino.quicktip_renderer("Email template","(notes.NoteTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.") }, "name": "email_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NoteTypes/email_template" }) }) });
    var attach_to_email2183 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Attach to email", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Attach to email","(notes.NoteTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n") }, "name": "attach_to_email", "selectOnFocus": true });
    var main_2_panel2184 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 38, "items": build_method2179, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": template2180, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": special_type2181, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": email_template2182, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": attach_to_email2183, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark2190 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remark", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(notes.NoteTypes.remark) ") }, "name": "remark", "selectOnFocus": true });
    var notes_NotesByType_grid2212 = new Lino.notes.NotesByType.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByType) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByType.grid) ] });
    var main_panel2213 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2174, main_2_panel2184, { "flex": 41, "items": remark2190, "labelAlign": "top", "layout": "form", "xtype": "panel" }, notes_NotesByType_grid2212 ], "labelAlign": "top", "labelWidth": 63, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2213;
    this.before_row_edit = function(record) {
      template2180.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      notes_NotesByType_grid2212.on_master_changed();
    }
    this.onRender = function(ct, position) {
      build_method2179.on('change',Lino.chooser_handler(template2180,'build_method'));
      Lino.notes.NoteTypes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.notes.NoteTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.Notes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 67,
  initComponent : function() {
    var date905 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Date", "listeners": { "render": Lino.quicktip_renderer("Date","(notes.Notes.date) ") }, "name": "date", "selectOnFocus": true });
    var time906 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Time", "listeners": { "render": Lino.quicktip_renderer("Time","(notes.Notes.time) ") }, "name": "time", "selectOnFocus": true });
    var event_type907 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Event Type...", "fieldLabel": "Event Type (Form)", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Event Type (Form)","(notes.Notes.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.notes.EventTypes.detail,Lino.notes.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/event_type" }) }) });
    var type908 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Note Type...", "fieldLabel": "Note Type (Content)", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Note Type (Content)","(notes.Notes.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.notes.NoteTypes.detail,Lino.notes.NoteTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/type" }) }) });
    var main_1_panel909 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": date905, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": time906, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": event_type907, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 36, "items": type908, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var subject914 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Subject", "listeners": { "render": Lino.quicktip_renderer("Subject","(notes.Notes.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var company915 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recipient (Organization)</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Organization)","(notes.Notes.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/company" }) }) });
    var contact_person916 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recipient (Person)</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Person)","(notes.Notes.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_person" }) }) });
    var contact_role917 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Function...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">represented as</span>", "hiddenName": "contact_roleHidden", "listeners": { "render": Lino.quicktip_renderer("represented as","(notes.Notes.contact_role) The optional Role\nof the contact_person within company.") }, "name": "contact_role", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_role" }) }) });
    var main_3_panel918 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": company915, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": contact_person916, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": contact_role917, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id922 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(notes.Notes.id) ") }, "name": "id", "selectOnFocus": true });
    var user923 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(notes.Notes.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/user" }) }) });
    var language924 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Language", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(notes.Notes.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var build_time925 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">build time</span>", "listeners": { "render": Lino.quicktip_renderer("build time","(notes.Notes.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.") }, "name": "build_time", "value": "<br>" });
    var main_4_panel926 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 12, "items": id922, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user923, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": language924, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": build_time925, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var body931 = new Ext.form.HtmlEditor({ "fieldLabel": "Body", "flex": 55, "listeners": { "render": Lino.quicktip_renderer("Body","(notes.Notes.body) ") }, "name": "body", "selectOnFocus": true });
    var main_panel932 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel909, { "autoHeight": true, "items": subject914, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel918, main_4_panel926, body931 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel932;
    this.before_row_edit = function(record) {
      contact_person916.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company915.on('change',Lino.chooser_handler(contact_person916,'company'));
      Lino.notes.Notes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.notes.Notes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.AllRooms.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 20,
  initComponent : function() {
    var id2215 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.AllRooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name2216 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.AllRooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2217 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.AllRooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2218 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.AllRooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2219 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id2215, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name2216, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de2217, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr2218, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company2224 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.AllRooms.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/company" }) }) });
    var contact_person2225 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Contact person</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.AllRooms.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllRooms/contact_person" }) }) });
    var main_panel2226 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2219, { "anchor": "-20", "autoHeight": true, "items": company2224, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": contact_person2225, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel2226;
    this.before_row_edit = function(record) {
      contact_person2225.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company2224.on('change',Lino.chooser_handler(contact_person2225,'company'));
      Lino.cal.AllRooms.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.AllRooms.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.countries.Countries.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 4,
  initComponent : function() {
    var isocode2229 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">ISO code</span>", "listeners": { "render": Lino.quicktip_renderer("ISO code","(countries.Countries.isocode)         The two-letter code for this country as defined by ISO 3166-1.\n        For countries that no longer exist it may be a 4-letter code.") }, "maxLength": 4, "name": "isocode", "selectOnFocus": true });
    var name2230 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(countries.Countries.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2231 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(countries.Countries.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2232 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(countries.Countries.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var short_code2233 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(4), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Short code</span>", "listeners": { "render": Lino.quicktip_renderer("Short code","(countries.Countries.short_code) A short abbreviation for regional usage. Obsolete.") }, "maxLength": 4, "name": "short_code", "selectOnFocus": true });
    var main_1_panel2234 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 12, "items": isocode2229, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name2230, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de2231, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr2232, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": short_code2233, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var countries_PlacesByCountry_grid2429 = new Lino.countries.PlacesByCountry.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Places","(countries.countries.PlacesByCountry) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.countries.PlacesByCountry.grid) ] });
    var main_panel2430 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2234, countries_PlacesByCountry_grid2429 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2430;
    this.before_row_edit = function(record) {
      countries_PlacesByCountry_grid2429.on_master_changed();
    }
    Lino.countries.Countries.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.lists.Lists.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 14,
  initComponent : function() {
    var ref2431 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(lists.Lists.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var list_type2432 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a List Type...", "fieldLabel": "List Type", "hiddenName": "list_typeHidden", "listeners": { "render": Lino.quicktip_renderer("List Type","(lists.Lists.list_type) ") }, "name": "list_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Lists/list_type" }) }) });
    var main_1_panel2433 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": ref2431, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": list_type2432, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2436 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(lists.Lists.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2437 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(lists.Lists.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2438 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(lists.Lists.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2439 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2436, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2437, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2438, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks2443 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(lists.Lists.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var main_panel2444 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2433, main_2_panel2439, { "flex": 71, "items": remarks2443, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2444;
    this.before_row_edit = function(record) {
    }
    Lino.lists.Lists.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Rooms.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 20,
  initComponent : function() {
    var id2446 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Rooms.id) ") }, "name": "id", "selectOnFocus": true });
    var name2447 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Rooms.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2448 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Rooms.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2449 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Rooms.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2450 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id2446, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name2447, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de2448, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr2449, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company2455 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(cal.Rooms.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/company" }) }) });
    var contact_person2456 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Contact person</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(cal.Rooms.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Rooms/contact_person" }) }) });
    var main_panel2457 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2450, { "anchor": "-20", "autoHeight": true, "items": company2455, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": contact_person2456, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    this.items = main_panel2457;
    this.before_row_edit = function(record) {
      contact_person2456.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company2455.on('change',Lino.chooser_handler(contact_person2456,'company'));
      Lino.cal.Rooms.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.cal.Rooms.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Courses.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var ref2460 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Courses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.") }, "maxLength": 40, "name": "ref", "preferred_with": 6, "selectOnFocus": true });
    var line2461 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity line</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Courses.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/line" }) }) });
    var teacher2462 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Courses.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/teacher" }) }) });
    var workflow_buttons_disp2463 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(courses.Courses.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_1_panel2464 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": ref2460, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": line2461, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": teacher2462, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": workflow_buttons_disp2463, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room2469 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Courses.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/room" }) }) });
    var start_date2470 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Courses.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date2471 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Courses.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time2472 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Courses.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2473 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Courses.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_2_panel2474 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": room2469, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": start_date2470, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": end_date2471, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": start_time2472, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 12, "items": end_time2473, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2480 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Courses.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var remark2481 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remark", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Courses.remark) ") }, "name": "remark", "selectOnFocus": true });
    var general_panel2482 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2464, general_2_panel2474, { "autoHeight": true, "items": name2480, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 50, "items": remark2481, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var every_unit2485 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Courses.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2486 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Courses.every) ") }, "name": "every", "selectOnFocus": true });
    var max_date2487 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Generate events until", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Courses.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var max_events2488 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Number of events", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Courses.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var events_1_panel2489 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": every_unit2485, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every2486, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date2487, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": max_events2488, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday2494 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Courses.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday2495 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Tuesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Courses.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday2496 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wednesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Courses.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday2497 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Thursday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Courses.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday2498 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Friday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Courses.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday2499 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Saturday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Courses.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday2500 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sunday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Courses.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var events_2_panel2501 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday2494, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday2495, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday2496, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday2497, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday2498, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday2499, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday2500, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EntriesByCourse_htmlbox2509 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Courses.EntriesByCourse) Shows the events linked to this course.") }, "master_panel": this, "name": "EntriesByCourse", "title": "Calendar entries", "tools": [ Lino.show_in_own_window_button(Lino.courses.EntriesByCourse.grid) ], "value": "<br/>" });
    var events_panel2510 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ events_1_panel2489, events_2_panel2501, EntriesByCourse_htmlbox2509 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Events" });
    var enrolments_until2511 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Enrolments until", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Courses.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var fee2512 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Default participation fee</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Default participation fee","(courses.Courses.fee) The default participation fee to apply for new enrolments.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/fee" }) }) });
    var max_places2513 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Available places</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Courses.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed2514 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Confirmed", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Courses.confirmed) ") }, "name": "confirmed" });
    var free_places2515 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Free places", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Courses.free_places) ") }, "name": "free_places" });
    var print_actions_disp2516 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Print", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Courses.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel2517 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": enrolments_until2511, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": fee2512, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_places2513, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": confirmed2514, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": free_places2515, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 22, "items": print_actions_disp2516, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 234, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByCourse_htmlbox2524 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Courses.EnrolmentsByCourse) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" } ], "ls_insert_handler": Lino.courses.EnrolmentsByCourse.insert, "master_panel": this, "name": "EnrolmentsByCourse", "title": "Enrolments", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByCourse.grid) ], "value": "<br/>" });
    var enrolments_panel2525 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel2517, EnrolmentsByCourse_htmlbox2524 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Enrolments" });
    var state2526 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(courses.Courses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".") }, "name": "state", "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var user2527 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Courses.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/user" }) }) });
    var payment_term2528 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Courses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/payment_term" }) }) });
    var paper_type2529 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Paper type</span>", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Courses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/paper_type" }) }) });
    var id2530 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Courses.id) ") }, "name": "id", "selectOnFocus": true });
    var more_1_panel2531 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": state2526, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": user2527, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": payment_term2528, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 26, "items": paper_type2529, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id2530, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_InvoicingsByInvoiceable_grid2537 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var more_panel2538 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel2531, invoicing_InvoicingsByInvoiceable_grid2537 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var main_panel2539 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2482, events_panel2510, enrolments_panel2525, more_panel2538 ], "labelAlign": "top", "split": true });
    this.items = main_panel2539;
    this.before_row_edit = function(record) {
      EntriesByCourse_htmlbox2509.refresh();
      fee2512.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      EnrolmentsByCourse_htmlbox2524.refresh();
      invoicing_InvoicingsByInvoiceable_grid2537.on_master_changed();
    }
    this.onRender = function(ct, position) {
      line2461.on('change',Lino.chooser_handler(fee2512,'line'));
      Lino.courses.Courses.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Courses.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Lines.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 57,
  initComponent : function() {
    var name2540 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Lines.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2541 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Lines.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2542 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Lines.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2543 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2540, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2541, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2542, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ref2547 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Lines.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var topic2548 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Topic...", "fieldLabel": "Topic", "hiddenName": "topicHidden", "listeners": { "render": Lino.quicktip_renderer("Topic","(courses.Lines.topic) ") }, "name": "topic", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Topics.detail,Lino.courses.Topics.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/topic" }) }) });
    var main_2_panel2549 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": ref2547, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": topic2548, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var every_unit2552 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Lines.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2553 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Lines.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var event_type2554 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry type</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(courses.Lines.event_type) The type of calendar events to be generated. If this is empty, no calendar events will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/event_type" }) }) });
    var main_3_panel2555 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 45, "items": every_unit2552, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": every2553, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": event_type2554, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description2559 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Lines.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de2560 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (de)","(courses.Lines.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr2561 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (fr)","(courses.Lines.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var main_4_panel2562 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 62, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description2559, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de2560, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr2561, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel2566 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2543, main_2_panel2549, main_3_panel2555, main_4_panel2562 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2566;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Lines.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Partners.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 10,
  initComponent : function() {
    var overview_disp2334 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Description", "listeners": { "render": Lino.quicktip_renderer("Description","(contacts.Partners.overview) ") }, "name": "overview", "value": "<br/>" });
    var email2335 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Partners.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone2336 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Phone</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(contacts.Partners.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm2337 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(contacts.Partners.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel2338 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email2335, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone2336, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm2337, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid2342 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel2343 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp2334, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel2338, lists_MembersByPartner_grid2342 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks2345 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(contacts.Partners.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_grid2346 = new Lino.plausibility.ProblemsByOwner.GridPanel({ "containing_panel": this, "flex": 37, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ] });
    var bottom_box_1_panel2347 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks2345, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_grid2346 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel2349 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2343, bottom_box_1_panel2347 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var name2350 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Partners.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var street2351 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Street</span>", "listeners": { "render": Lino.quicktip_renderer("Street","(contacts.Partners.street) Name of street, without house number.") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box2352 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Box</span>", "listeners": { "render": Lino.quicktip_renderer("Box","(contacts.Partners.street_box) Text to print after street nuber on the same line.") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel2353 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street2351, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box2352, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr22356 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line after street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(contacts.Partners.addr2) Address line to print below street line.") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var country2357 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Country...", "fieldLabel": "Country", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(contacts.Partners.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/country" }) }) });
    var zip_code2358 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Zip code", "listeners": { "render": Lino.quicktip_renderer("Zip code","(contacts.Partners.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city2359 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Place...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">City</span>", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("City","(contacts.Partners.city) A pointer to Place.") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,Lino.countries.Places.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/city" }) }) });
    var address_box_4_panel2360 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country2357, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code2358, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city2359, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel2364 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": name2350, "labelAlign": "top", "layout": "form", "xtype": "panel" }, address_box_2_panel2353, { "anchor": "-20", "autoHeight": true, "items": addr22356, "labelAlign": "top", "layout": "form", "xtype": "panel" }, address_box_4_panel2360 ], "labelAlign": "top", "labelWidth": 234, "layout": "form" });
    var sepa_AccountsByPartner_grid2367 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 55, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_panel2368 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel2364, sepa_AccountsByPartner_grid2367 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Address" });
    var id2369 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Partners.id) ") }, "name": "id", "selectOnFocus": true });
    var language2370 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Partners.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var more_1_panel2371 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": id2369, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 80, "items": language2370, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr12374 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line before street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(contacts.Partners.addr1) Address line before street") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var url2375 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "URL", "listeners": { "render": Lino.quicktip_renderer("URL","(contacts.Partners.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_2_panel2376 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr12374, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": url2375, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var changes_ChangesByMaster_grid2395 = new Lino.changes.ChangesByMaster.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Changes","(changes.changes.ChangesByMaster) Slave Table showing the changes related to the current object,\nincluding those applied to \"child\" objects.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.changes.ChangesByMaster.grid) ] });
    var ExcerptsByOwner_htmlbox2396 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Existing excerpts","(contacts.Partners.ExcerptsByOwner) History of excerpts based on this data record.") }, "master_panel": this, "name": "ExcerptsByOwner", "title": "Existing excerpts", "tools": [ Lino.show_in_own_window_button(Lino.excerpts.ExcerptsByOwner.grid) ], "value": "<br/>" });
    var GuestsByPartner_htmlbox2397 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Presences","(contacts.Partners.GuestsByPartner) The default table for Guest.") }, "master_panel": this, "name": "GuestsByPartner", "title": "Presences", "tools": [ Lino.show_in_own_window_button(Lino.cal.GuestsByPartner.grid) ], "value": "<br/>" });
    var more_5_panel2398 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 30, "frame": false, "hideCheckBoxLabels": true, "items": [ ExcerptsByOwner_htmlbox2396, GuestsByPartner_htmlbox2397 ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var more_panel2399 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel2371, more_2_panel2376, changes_ChangesByMaster_grid2395, more_5_panel2398 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var invoice_recipient2400 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Invoicing address</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(contacts.Partners.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/invoice_recipient" }) }) });
    var vat_regime2401 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(contacts.Partners.vat_regime) The default VAT regime for         sales and purchases of this partner.") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel2402 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": invoice_recipient2400, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 57, "items": vat_regime2401, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term2405 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(contacts.Partners.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/payment_term" }) }) });
    var paper_type2406 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "Paper type", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(contacts.Partners.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/paper_type" }) }) });
    var ledger_a_2_panel2407 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term2405, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type2406, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel2410 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 61, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel2402, ledger_a_2_panel2407 ], "labelAlign": "top", "layout": "form" });
    var MovementsByPartner_htmlbox2411 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 38, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(contacts.Partners.MovementsByPartner) Show the ledger movements of a partner.\nSee also lino_xl.lib.ledger.models.Movement.") }, "master_panel": this, "name": "MovementsByPartner", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel2412 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel2410, MovementsByPartner_htmlbox2411 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid2413 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel2414 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel2412, sales_InvoicesByPartner_grid2413 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var main_panel2415 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2349, address_panel2368, more_panel2399, ledger_panel2414 ], "labelAlign": "top", "split": true });
    this.items = main_panel2415;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid2342.on_master_changed();
      plausibility_ProblemsByOwner_grid2346.on_master_changed();
      city2359.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city2359.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      sepa_AccountsByPartner_grid2367.on_master_changed();
      changes_ChangesByMaster_grid2395.on_master_changed();
      ExcerptsByOwner_htmlbox2396.refresh();
      GuestsByPartner_htmlbox2397.refresh();
      MovementsByPartner_htmlbox2411.refresh();
      sales_InvoicesByPartner_grid2413.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country2357.on('change',Lino.chooser_handler(city2359,'country'));
      Lino.contacts.Partners.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.contacts.Partners.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city2359.on("change", function(){ this.save() }, this);
    zip_code2358.on("change", function(){ this.save() }, this);
  }
});


Lino.contacts.Persons.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 8,
  initComponent : function() {
    var first_name2567 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">First name</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(contacts.Persons.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var last_name2568 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Last name</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(contacts.Persons.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var main_1_panel2569 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": first_name2567, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": last_name2568, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var gender2572 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gender</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(contacts.Persons.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var language2573 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Persons.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var main_2_panel2574 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": gender2572, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 68, "items": language2573, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2577 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2569, main_2_panel2574 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2577;
    this.before_row_edit = function(record) {
    }
    Lino.contacts.Persons.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.EventTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 22,
  initComponent : function() {
    var name2578 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.EventTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2579 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.EventTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2580 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.EventTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2581 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2578, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2579, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2580, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var event_label2585 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Entry label</span>", "listeners": { "render": Lino.quicktip_renderer("Entry label","(cal.EventTypes.event_label) Default text for summary of new entries.") }, "maxLength": 200, "name": "event_label", "selectOnFocus": true });
    var event_label_de2586 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Entry label (de)", "listeners": { "render": Lino.quicktip_renderer("Entry label (de)","(cal.EventTypes.event_label_de) ") }, "maxLength": 200, "name": "event_label_de", "selectOnFocus": true });
    var event_label_fr2587 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Entry label (fr)", "listeners": { "render": Lino.quicktip_renderer("Entry label (fr)","(cal.EventTypes.event_label_fr) ") }, "maxLength": 200, "name": "event_label_fr", "selectOnFocus": true });
    var main_2_panel2588 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": event_label2585, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_de2586, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": event_label_fr2587, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date2592 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.EventTypes.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var max_days2593 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Maximum days</span>", "listeners": { "render": Lino.quicktip_renderer("Maximum days","(cal.EventTypes.max_days) The maximal number of days allowed as duration.") }, "name": "max_days", "selectOnFocus": true, "value": 1 });
    var id2594 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.EventTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var main_3_panel2595 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 56, "items": start_date2592, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": max_days2593, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": id2594, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var email_template2599 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Email template</span>", "listeners": { "render": Lino.quicktip_renderer("Email template","(cal.EventTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.") }, "name": "email_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EventTypes/email_template" }) }) });
    var attach_to_email2600 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Attach to email", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Attach to email","(cal.EventTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n") }, "name": "attach_to_email", "selectOnFocus": true });
    var main_4_panel2601 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": email_template2599, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": attach_to_email2600, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var is_appointment2604 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Appointment", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Appointment","(cal.EventTypes.is_appointment) Whether entries of this type should be considered\n\"appointments\" (i.e. whose time and place have been agreed\nupon with other users or external parties).") }, "name": "is_appointment", "selectOnFocus": true });
    var all_rooms2605 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Locks all rooms", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Locks all rooms","(cal.EventTypes.all_rooms) ") }, "name": "all_rooms", "selectOnFocus": true });
    var locks_user2606 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Locks the user", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Locks the user","(cal.EventTypes.locks_user) Whether calendar entries of this type make the user\nunavailable for other locking events at the same time.") }, "name": "locks_user", "selectOnFocus": true });
    var max_conflicting2607 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Simultaneous entries</span>", "listeners": { "render": Lino.quicktip_renderer("Simultaneous entries","(cal.EventTypes.max_conflicting) How many conflicting events should be tolerated.") }, "name": "max_conflicting", "selectOnFocus": true, "value": 1 });
    var main_5_panel2608 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": is_appointment2604, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": all_rooms2605, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": locks_user2606, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": max_conflicting2607, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2650 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2581, main_2_panel2588, main_3_panel2595, main_4_panel2601, main_5_panel2608 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2650;
    this.before_row_edit = function(record) {
    }
    Lino.cal.EventTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Tasks.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 18,
  initComponent : function() {
    var summary2651 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Short description", "listeners": { "render": Lino.quicktip_renderer("Short description","(cal.Tasks.summary) ") }, "maxLength": 200, "name": "summary", "selectOnFocus": true });
    var user2652 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.Tasks.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Tasks/user" }) }) });
    var main_panel2653 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": summary2651, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": user2652, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "form" });
    this.items = main_panel2653;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Tasks.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.RecurrentEvents.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 21,
  initComponent : function() {
    var name2656 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.RecurrentEvents.name) See lino.utils.mldbc.mixins.BabelNamed.name.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2657 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.RecurrentEvents.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2658 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.RecurrentEvents.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2659 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2656, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2657, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2658, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id2663 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.RecurrentEvents.id) ") }, "name": "id", "selectOnFocus": true });
    var user2664 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(cal.RecurrentEvents.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/user" }) }) });
    var event_type2665 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "Calendar entry type", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.RecurrentEvents.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/event_type" }) }) });
    var main_2_panel2666 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": id2663, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": user2664, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 44, "items": event_type2665, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date2670 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.RecurrentEvents.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time2671 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(cal.RecurrentEvents.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_date2672 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.RecurrentEvents.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time2673 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(cal.RecurrentEvents.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_3_panel2674 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": start_date2670, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": start_time2671, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": end_date2672, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_time2673, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var every_unit2679 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recurrency</span>", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(cal.RecurrentEvents.every_unit) Inherited from RecurrentSet.every_unit.") }, "name": "every_unit", "selectOnFocus": true, "store": Lino.cal.Recurrencies });
    var every2680 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(cal.RecurrentEvents.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var max_events2681 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Number of events", "listeners": { "render": Lino.quicktip_renderer("Number of events","(cal.RecurrentEvents.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var main_4_panel2682 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 67, "items": every_unit2679, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": every2680, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": max_events2681, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday2686 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(cal.RecurrentEvents.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday2687 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Tuesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(cal.RecurrentEvents.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday2688 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wednesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(cal.RecurrentEvents.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday2689 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Thursday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(cal.RecurrentEvents.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday2690 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Friday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(cal.RecurrentEvents.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday2691 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Saturday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(cal.RecurrentEvents.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday2692 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sunday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(cal.RecurrentEvents.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var main_5_panel2693 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday2686, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday2687, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday2688, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday2689, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday2690, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday2691, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday2692, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description2701 = new Ext.form.HtmlEditor({ "fieldLabel": "Description", "flex": 66, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.RecurrentEvents.description) ") }, "name": "description", "selectOnFocus": true });
    var EntriesByController_htmlbox2702 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 33, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(cal.RecurrentEvents.EntriesByController) Shows the events linked to this database object.") }, "master_panel": this, "name": "EntriesByController", "title": "Calendar entries", "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByController.grid) ], "value": "<br/>" });
    var main_6_panel2703 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ description2701, EntriesByController_htmlbox2702 ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel2704 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2659, main_2_panel2666, main_3_panel2674, main_4_panel2682, main_5_panel2693, main_6_panel2703 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2704;
    this.before_row_edit = function(record) {
      EntriesByController_htmlbox2702.refresh();
    }
    Lino.cal.RecurrentEvents.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Guests.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 19,
  initComponent : function() {
    var event861 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry</span>", "hiddenName": "eventHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry","(cal.Guests.event) The calendar event to which this presence applies.") }, "name": "event", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.OneEvent.detail,Lino.cal.OneEvent.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/event" }) }) });
    var partner862 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(cal.Guests.partner) The partner to which this presence applies.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    var role863 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Guest Role...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Role</span>", "hiddenName": "roleHidden", "listeners": { "render": Lino.quicktip_renderer("Role","(cal.Guests.role) The role of this partner in this presence.") }, "name": "role", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,Lino.cal.GuestRoles.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/role" }) }) });
    var main_1_panel864 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": event861, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": partner862, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": role863, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var state868 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">State</span>", "forceSelection": true, "hiddenName": "stateHidden", "listeners": { "render": Lino.quicktip_renderer("State","(cal.Guests.state) The state of this presence.") }, "name": "state", "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var remark869 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(cal.Guests.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var workflow_buttons_disp870 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(cal.Guests.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var main_2_panel871 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": state868, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 34, "items": remark869, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 49, "items": workflow_buttons_disp870, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel875 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel864, main_2_panel871 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel875;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Guests.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.rooms.Bookings.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 32,
  initComponent : function() {
    var start_date1564 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(rooms.Bookings.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var start_time1565 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(rooms.Bookings.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_date1566 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(rooms.Bookings.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var end_time1567 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(rooms.Bookings.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_1_panel1568 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": start_date1564, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": start_time1565, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": end_date1566, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_time1567, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room1573 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(rooms.Bookings.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/room" }) }) });
    var event_type1574 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry type</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(rooms.Bookings.event_type) The Event Type to which events will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/event_type" }) }) });
    var workflow_buttons_disp1575 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(rooms.Bookings.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var general_2_panel1576 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": room1573, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": event_type1574, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 42, "items": workflow_buttons_disp1575, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var max_events1580 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Number of events", "listeners": { "render": Lino.quicktip_renderer("Number of events","(rooms.Bookings.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var max_date1581 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Generate events until", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(rooms.Bookings.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var every_unit1582 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(rooms.Bookings.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every1583 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(rooms.Bookings.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var general_3_panel1584 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": max_events1580, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date1581, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": every_unit1582, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every1583, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday1589 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(rooms.Bookings.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday1590 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Tuesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(rooms.Bookings.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday1591 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wednesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(rooms.Bookings.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday1592 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Thursday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(rooms.Bookings.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday1593 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Friday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(rooms.Bookings.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday1594 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Saturday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(rooms.Bookings.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday1595 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sunday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(rooms.Bookings.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var general_4_panel1596 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday1589, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday1590, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday1591, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday1592, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday1593, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday1594, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday1595, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company1604 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Organizer</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Organizer","(rooms.Bookings.company) Pointer to lino_xl.lib.contacts.models.Company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/company" }) }) });
    var contact_person1605 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Contact person</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Contact person","(rooms.Bookings.contact_person) Pointer to lino_xl.lib.contacts.models.Person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/contact_person" }) }) });
    var user1606 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(rooms.Bookings.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/rooms/Bookings/user" }) }) });
    var id1607 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(rooms.Bookings.id) ") }, "name": "id", "selectOnFocus": true });
    var general_5_panel1608 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 29, "items": company1604, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": contact_person1605, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": user1606, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": id1607, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EntriesByController_htmlbox1613 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 30, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(rooms.Bookings.EntriesByController) Shows the events linked to this database object.") }, "master_panel": this, "name": "EntriesByController", "title": "Calendar entries", "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByController.grid) ], "value": "<br/>" });
    var general_panel1614 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1568, general_2_panel1576, general_3_panel1584, general_4_panel1596, general_5_panel1608, EntriesByController_htmlbox1613 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var invoicing_InvoicingsByInvoiceable_grid1615 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "hide_top_toolbar": true, "listeners": { "activate": Lino.on_tab_activate }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "title": "Invoicings", "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var main_panel1616 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1614, invoicing_InvoicingsByInvoiceable_grid1615 ], "labelAlign": "top", "split": true });
    this.items = main_panel1616;
    this.before_row_edit = function(record) {
      contact_person1605.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      EntriesByController_htmlbox1613.refresh();
      invoicing_InvoicingsByInvoiceable_grid1615.on_master_changed();
    }
    this.onRender = function(ct, position) {
      company1604.on('change',Lino.chooser_handler(contact_person1605,'company'));
      Lino.rooms.Bookings.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.rooms.Bookings.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.EnrolmentsByHike.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var pupil2705 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant...", "fieldLabel": "Participant", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.EnrolmentsByHike.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/pupil" }) }) });
    var places2706 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Places used</span>", "listeners": { "render": Lino.quicktip_renderer("Places used","(courses.EnrolmentsByHike.places) The number of participants in this enrolment.") }, "name": "places", "selectOnFocus": true, "value": 1 });
    var option2707 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "Option", "hiddenName": "optionHidden", "listeners": { "render": Lino.quicktip_renderer("Option","(courses.EnrolmentsByHike.option) ") }, "name": "option", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/option" }) }) });
    var main_2_panel2708 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": places2706, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 80, "items": option2707, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark2711 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.EnrolmentsByHike.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var request_date2712 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Date of request", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.EnrolmentsByHike.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user2713 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.EnrolmentsByHike.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/user" }) }) });
    var main_4_panel2714 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date2712, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user2713, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2717 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": pupil2705, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel2708, { "anchor": "-20", "autoHeight": true, "items": remark2711, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel2714 ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel2717;
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil2705.setContextValue('mk',bp['mk']);
      pupil2705.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option2707.setContextValue('mk',bp['mk']);
      option2707.setContextValue('mt',bp['mt']);
    }
    Lino.courses.EnrolmentsByHike.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.RecurrentEvents.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 21,
  initComponent : function() {
    var name2720 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.RecurrentEvents.name) See lino.utils.mldbc.mixins.BabelNamed.name.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2721 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.RecurrentEvents.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2722 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.RecurrentEvents.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2723 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2720, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2721, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2722, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date2727 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(cal.RecurrentEvents.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date2728 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(cal.RecurrentEvents.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var every_unit2729 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recurrency</span>", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(cal.RecurrentEvents.every_unit) Inherited from RecurrentSet.every_unit.") }, "name": "every_unit", "selectOnFocus": true, "store": Lino.cal.Recurrencies });
    var event_type2730 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "Calendar entry type", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(cal.RecurrentEvents.event_type) ") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/RecurrentEvents/event_type" }) }) });
    var main_2_panel2731 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": start_date2727, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": end_date2728, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": every_unit2729, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": event_type2730, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2736 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2723, main_2_panel2731 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel2736;
    this.before_row_edit = function(record) {
    }
    Lino.cal.RecurrentEvents.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Enrolments.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var request_date1319 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Date of request", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.Enrolments.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user1320 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Enrolments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/user" }) }) });
    var main_1_panel1321 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date1319, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user1320, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var course1324 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity...", "fieldLabel": "Activity", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.Enrolments.course) ") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/course" }) }) });
    var pupil1325 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant...", "fieldLabel": "Participant", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.Enrolments.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/pupil" }) }) });
    var main_2_panel1326 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": course1324, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": pupil1325, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1329 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Enrolments.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var main_panel1330 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1321, main_2_panel1326, { "anchor": "-20", "autoHeight": true, "items": remark1329, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "form" });
    this.items = main_panel1330;
    this.before_row_edit = function(record) {
      course1324.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1324.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil1325.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      request_date1319.on('change',Lino.chooser_handler(course1324,'request_date'));
      course1324.on('change',Lino.chooser_handler(pupil1325,'course'));
      Lino.courses.Enrolments.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Enrolments.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.about.Models.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var app_disp2737 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "app_label", "listeners": { "render": Lino.quicktip_renderer("app_label","(about.Models.app) ") }, "name": "app", "value": "<br/>" });
    var name_disp2738 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "name", "listeners": { "render": Lino.quicktip_renderer("name","(about.Models.name) ") }, "name": "name", "value": "<br/>" });
    var docstring_disp2739 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "docstring", "listeners": { "render": Lino.quicktip_renderer("docstring","(about.Models.docstring) ") }, "name": "docstring", "value": "<br/>" });
    var rows2740 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Rows", "listeners": { "render": Lino.quicktip_renderer("Rows","(about.Models.rows) ") }, "name": "rows" });
    var main_1_panel2741 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": app_disp2737, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": name_disp2738, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": docstring_disp2739, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 5, "items": rows2740, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var about_FieldsByModel_grid2750 = new Lino.about.FieldsByModel.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Fields","(about.about.FieldsByModel) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.about.FieldsByModel.grid) ] });
    var main_panel2751 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2741, about_FieldsByModel_grid2750 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2751;
    this.before_row_edit = function(record) {
      about_FieldsByModel_grid2750.on_master_changed();
    }
    Lino.about.Models.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.outbox.Mails.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 72,
  initComponent : function() {
    var subject2752 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Subject", "listeners": { "render": Lino.quicktip_renderer("Subject","(outbox.Mails.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var date2753 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Date</span>", "listeners": { "render": Lino.quicktip_renderer("Date","(outbox.Mails.date) \n        The official date to be printed on the document.\n        ") }, "name": "date", "selectOnFocus": true });
    var main_1_panel2754 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 61, "items": subject2752, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": date2753, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user2757 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Sender</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Sender","(outbox.Mails.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/Mails/user" }) }) });
    var sent2758 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "sent", "listeners": { "render": Lino.quicktip_renderer("sent","(outbox.Mails.sent) ") }, "name": "sent", "value": "<br>" });
    var id2759 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(outbox.Mails.id) ") }, "name": "id", "selectOnFocus": true });
    var owner_disp2760 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Controlled by", "name": "owner" });
    var main_2_panel2761 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": user2757, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 31, "items": sent2758, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": id2759, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": owner_disp2760, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var RecipientsByMail_grid2776 = new Lino.outbox.RecipientsByMail.GridPanel({ "containing_panel": this, "flex": 55, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Recipients","(outbox.outbox.RecipientsByMail) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.outbox.RecipientsByMail.grid) ] });
    var AttachmentsByMail_htmlbox2777 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 22, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Attachments","(outbox.Mails.AttachmentsByMail) ") }, "master_panel": this, "name": "AttachmentsByMail", "title": "Attachments", "tools": [ Lino.show_in_own_window_button(Lino.outbox.AttachmentsByMail.grid) ], "value": "<br/>" });
    var UploadsByController_htmlbox2778 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 22, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Uploads","(outbox.Mails.UploadsByController) Shows all Uploads") }, "master_panel": this, "name": "UploadsByController", "title": "Uploads", "tools": [ Lino.show_in_own_window_button(Lino.uploads.UploadsByController.grid) ], "value": "<br/>" });
    var main_3_panel2779 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 29, "frame": false, "hideCheckBoxLabels": true, "items": [ RecipientsByMail_grid2776, AttachmentsByMail_htmlbox2777, UploadsByController_htmlbox2778 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var body2780 = new Ext.form.HtmlEditor({ "fieldLabel": "Body", "flex": 58, "listeners": { "render": Lino.quicktip_renderer("Body","(outbox.Mails.body) ") }, "name": "body", "selectOnFocus": true });
    var main_panel2781 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2754, main_2_panel2761, main_3_panel2779, body2780 ], "labelAlign": "top", "labelWidth": 45, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2781;
    this.before_row_edit = function(record) {
      RecipientsByMail_grid2776.on_master_changed();
      AttachmentsByMail_htmlbox2777.refresh();
      UploadsByController_htmlbox2778.refresh();
    }
    Lino.outbox.Mails.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.UploadTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 70,
  initComponent : function() {
    var id2782 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(uploads.UploadTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var upload_area2783 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Upload Area", "forceSelection": true, "hiddenName": "upload_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Area","(uploads.UploadTypes.upload_area) ") }, "name": "upload_area", "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var wanted2784 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wanted", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wanted","(uploads.UploadTypes.wanted) Add a (+) button when there is no upload of this type.") }, "name": "wanted", "selectOnFocus": true });
    var max_number2785 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Max. number</span>", "listeners": { "render": Lino.quicktip_renderer("Max. number","(uploads.UploadTypes.max_number) No need to upload more uploads than N of this type.\n-1 means no limit.") }, "name": "max_number", "selectOnFocus": true, "value": -1 });
    var shortcut2786 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Upload shortcut</span>", "listeners": { "render": Lino.quicktip_renderer("Upload shortcut","(uploads.UploadTypes.shortcut) Optional pointer to a virtual upload shortcut field.  If\nthis is not empty, then the given shortcut field will manage\nuploads of this type.  See also Shortcuts.") }, "maxLength": 50, "name": "shortcut", "selectOnFocus": true });
    var main_1_panel2787 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 9, "items": id2782, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": upload_area2783, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": wanted2784, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": max_number2785, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 41, "items": shortcut2786, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2793 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(uploads.UploadTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2794 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(uploads.UploadTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2795 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(uploads.UploadTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel2796 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2793, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2794, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2795, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var uploads_UploadsByType_grid2824 = new Lino.uploads.UploadsByType.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Uploads","(uploads.uploads.UploadsByType) Shows all Uploads") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.uploads.UploadsByType.grid) ] });
    var main_panel2825 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2787, main_2_panel2796, uploads_UploadsByType_grid2824 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2825;
    this.before_row_edit = function(record) {
      uploads_UploadsByType_grid2824.on_master_changed();
    }
    Lino.uploads.UploadTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.UploadTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 70,
  initComponent : function() {
    var name2826 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(uploads.UploadTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2827 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(uploads.UploadTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2828 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(uploads.UploadTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2829 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name2826, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de2827, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr2828, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var upload_area2833 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Upload Area", "forceSelection": true, "hiddenName": "upload_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Area","(uploads.UploadTypes.upload_area) ") }, "name": "upload_area", "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var main_panel2834 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2829, { "anchor": "-20", "autoHeight": true, "items": upload_area2833, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel2834;
    this.before_row_edit = function(record) {
    }
    Lino.uploads.UploadTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.GuestRoles.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 26,
  initComponent : function() {
    var id2836 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.GuestRoles.id) ") }, "name": "id", "selectOnFocus": true });
    var name2837 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.GuestRoles.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2838 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.GuestRoles.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2839 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.GuestRoles.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel2840 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id2836, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name2837, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de2838, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr2839, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var cal_GuestsByRole_grid2856 = new Lino.cal.GuestsByRole.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Presences","(cal.cal.GuestsByRole) The default table for Guest.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.GuestsByRole.grid) ] });
    var main_panel2857 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2840, cal_GuestsByRole_grid2856 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2857;
    this.before_row_edit = function(record) {
      cal_GuestsByRole_grid2856.on_master_changed();
    }
    Lino.cal.GuestRoles.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.EnrolmentsByCourse.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var pupil2858 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant...", "fieldLabel": "Participant", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.EnrolmentsByCourse.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/pupil" }) }) });
    var remark2859 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.EnrolmentsByCourse.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var request_date2860 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Date of request", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.EnrolmentsByCourse.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user2861 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.EnrolmentsByCourse.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/user" }) }) });
    var main_3_panel2862 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date2860, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user2861, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2865 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": pupil2858, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": remark2859, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel2862 ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel2865;
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil2858.setContextValue('mk',bp['mk']);
      pupil2858.setContextValue('mt',bp['mt']);
    }
    Lino.courses.EnrolmentsByCourse.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Slots.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 49,
  initComponent : function() {
    var name2868 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Name", "listeners": { "render": Lino.quicktip_renderer("Name","(courses.Slots.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var start_time2869 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start Time", "listeners": { "render": Lino.quicktip_renderer("Start Time","(courses.Slots.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2870 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Slots.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var main_1_panel2871 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 56, "items": name2868, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": start_time2869, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": end_time2870, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_CoursesBySlot_grid2996 = new Lino.courses.CoursesBySlot.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesBySlot) Base table for all activities.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesBySlot.grid) ] });
    var main_panel2997 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2871, courses_CoursesBySlot_grid2996 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2997;
    this.before_row_edit = function(record) {
      courses_CoursesBySlot_grid2996.on_master_changed();
    }
    Lino.courses.Slots.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.Excerpts.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 76,
  initComponent : function() {
    var excerpt_type2998 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Excerpt Type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Excerpt Type</span>", "hiddenName": "excerpt_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Excerpt Type","(excerpts.Excerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).") }, "name": "excerpt_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.excerpts.ExcerptTypes.detail,Lino.excerpts.ExcerptTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var company2999 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recipient (Organization)</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Organization)","(excerpts.Excerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/company" }) }) });
    var contact_person3000 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recipient (Person)</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Person)","(excerpts.Excerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_person" }) }) });
    var main_2_panel3001 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": company2999, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": contact_person3000, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3004 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": excerpt_type2998, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel3001 ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel3004;
    this.before_row_edit = function(record) {
      excerpt_type2998.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person3000.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      company2999.on('change',Lino.chooser_handler(contact_person3000,'company'));
      Lino.excerpts.Excerpts.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.Excerpts.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Activities.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 52,
  initComponent : function() {
    var line2924 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity line...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity line</span>", "hiddenName": "lineHidden", "listeners": { "render": Lino.quicktip_renderer("Activity line","(courses.Activities.line) Pointer to the course series.") }, "name": "line", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Lines.detail,Lino.courses.Lines.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var teacher2925 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor...", "fieldLabel": "Instructor", "hiddenName": "teacherHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor","(courses.Activities.teacher) ") }, "name": "teacher", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Teachers.detail,Lino.courses.Teachers.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var start_date2926 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Activities.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date2927 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Date", "listeners": { "render": Lino.quicktip_renderer("End Date","(courses.Activities.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var start_time2928 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start time", "listeners": { "render": Lino.quicktip_renderer("Start time","(courses.Activities.start_time) ") }, "name": "start_time", "selectOnFocus": true });
    var end_time2929 = new Lino.TimeField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End Time", "listeners": { "render": Lino.quicktip_renderer("End Time","(courses.Activities.end_time) ") }, "name": "end_time", "selectOnFocus": true });
    var general_1_panel2930 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 24, "items": line2924, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": teacher2925, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": start_date2926, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": end_date2927, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": start_time2928, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": end_time2929, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var room2937 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Room...", "fieldLabel": "Room", "hiddenName": "roomHidden", "listeners": { "render": Lino.quicktip_renderer("Room","(courses.Activities.room) ") }, "name": "room", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.AllRooms.detail,Lino.cal.AllRooms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/room" }) }) });
    var workflow_buttons_disp2938 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(courses.Activities.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var id2939 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Activities.id) ") }, "name": "id", "selectOnFocus": true });
    var user2940 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Activities.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/user" }) }) });
    var general_2_panel2941 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": room2937, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 38, "items": workflow_buttons_disp2938, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": id2939, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user2940, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name2946 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Activities.name) A short designation for this course. An extension of the\nref.") }, "maxLength": 100, "name": "name", "selectOnFocus": true });
    var description2947 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Activities.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de2948 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (de)","(courses.Activities.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr2949 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (fr)","(courses.Activities.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var general_4_panel2950 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description2947, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de2948, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr2949, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel2954 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel2930, general_2_panel2941, { "autoHeight": true, "items": name2946, "labelAlign": "top", "layout": "form", "xtype": "panel" }, general_4_panel2950 ], "labelAlign": "top", "labelWidth": 108, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var max_events2956 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Number of events", "listeners": { "render": Lino.quicktip_renderer("Number of events","(courses.Activities.max_events) ") }, "name": "max_events", "selectOnFocus": true });
    var max_date2957 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Generate events until", "listeners": { "render": Lino.quicktip_renderer("Generate events until","(courses.Activities.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var every_unit2958 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Activities.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2959 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Activities.every) ") }, "name": "every", "selectOnFocus": true });
    var cal_tab_1_panel2960 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 11, "items": max_events2956, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 29, "items": max_date2957, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 47, "items": every_unit2958, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": every2959, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 198, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var monday2965 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Monday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Monday","(courses.Activities.monday) ") }, "name": "monday", "selectOnFocus": true });
    var tuesday2966 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Tuesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Tuesday","(courses.Activities.tuesday) ") }, "name": "tuesday", "selectOnFocus": true });
    var wednesday2967 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Wednesday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Wednesday","(courses.Activities.wednesday) ") }, "name": "wednesday", "selectOnFocus": true });
    var thursday2968 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Thursday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Thursday","(courses.Activities.thursday) ") }, "name": "thursday", "selectOnFocus": true });
    var friday2969 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Friday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Friday","(courses.Activities.friday) ") }, "name": "friday", "selectOnFocus": true });
    var saturday2970 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Saturday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Saturday","(courses.Activities.saturday) ") }, "name": "saturday", "selectOnFocus": true });
    var sunday2971 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Sunday", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Sunday","(courses.Activities.sunday) ") }, "name": "sunday", "selectOnFocus": true });
    var cal_tab_2_panel2972 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": monday2965, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": tuesday2966, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": wednesday2967, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": thursday2968, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": friday2969, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": saturday2970, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": sunday2971, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EntriesByController_htmlbox2980 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 60, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Calendar entries","(courses.Activities.EntriesByController) Shows the events linked to this database object.") }, "master_panel": this, "name": "EntriesByController", "title": "Calendar entries", "tools": [ Lino.show_in_own_window_button(Lino.cal.EntriesByController.grid) ], "value": "<br/>" });
    var cal_tab_panel2981 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ cal_tab_1_panel2960, cal_tab_2_panel2972, EntriesByController_htmlbox2980 ], "labelAlign": "top", "labelWidth": 153, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Calendar" });
    var enrolments_until2982 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Enrolments until", "listeners": { "render": Lino.quicktip_renderer("Enrolments until","(courses.Activities.enrolments_until) ") }, "name": "enrolments_until", "selectOnFocus": true });
    var max_places2983 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Available places</span>", "listeners": { "render": Lino.quicktip_renderer("Available places","(courses.Activities.max_places) Maximum number of participants") }, "name": "max_places", "selectOnFocus": true });
    var confirmed2984 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Confirmed", "listeners": { "render": Lino.quicktip_renderer("Confirmed","(courses.Activities.confirmed) ") }, "name": "confirmed" });
    var free_places2985 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Free places", "listeners": { "render": Lino.quicktip_renderer("Free places","(courses.Activities.free_places) ") }, "name": "free_places" });
    var print_actions_disp2986 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Print", "listeners": { "render": Lino.quicktip_renderer("Print","(courses.Activities.print_actions) ") }, "name": "print_actions", "value": "<br/>" });
    var enrolments_top_panel2987 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 24, "items": enrolments_until2982, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": max_places2983, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": confirmed2984, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": free_places2985, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": print_actions_disp2986, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var EnrolmentsByCourse_htmlbox2993 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.Activities.EnrolmentsByCourse) The Voga version of EnrolmentsByCourse.") }, "ls_bbar_actions": [ { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" } ], "ls_insert_handler": Lino.courses.EnrolmentsByCourse.insert, "master_panel": this, "name": "EnrolmentsByCourse", "title": "Enrolments", "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByCourse.grid) ], "value": "<br/>" });
    var enrolments_panel2994 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ enrolments_top_panel2987, EnrolmentsByCourse_htmlbox2993 ], "labelAlign": "top", "labelWidth": 99, "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Enrolments" });
    var main_panel2995 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel2954, cal_tab_panel2981, enrolments_panel2994 ], "labelAlign": "top", "split": true });
    this.items = main_panel2995;
    this.before_row_edit = function(record) {
      EntriesByController_htmlbox2980.refresh();
      EnrolmentsByCourse_htmlbox2993.refresh();
    }
    Lino.courses.Activities.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.CourseTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 51,
  initComponent : function() {
    var id3006 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.CourseTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3007 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.CourseTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3008 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.CourseTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3009 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.CourseTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3010 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3006, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3007, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3008, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3009, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_LinesByType_grid3144 = new Lino.courses.LinesByType.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activity lines","(courses.courses.LinesByType) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.LinesByType.grid) ] });
    var main_panel3145 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3010, courses_LinesByType_grid3144 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3145;
    this.before_row_edit = function(record) {
      courses_LinesByType_grid3144.on_master_changed();
    }
    Lino.courses.CourseTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.invoicing.Plans.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 48,
  initComponent : function() {
    var user3146 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(invoicing.Plans.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/user" }) }) });
    var journal3147 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(invoicing.Plans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/journal" }) }) });
    var today3148 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Invoicing date", "listeners": { "render": Lino.quicktip_renderer("Invoicing date","(invoicing.Plans.today) ") }, "name": "today", "selectOnFocus": true });
    var max_date3149 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Invoiceables until", "listeners": { "render": Lino.quicktip_renderer("Invoiceables until","(invoicing.Plans.max_date) ") }, "name": "max_date", "selectOnFocus": true });
    var main_1_panel3150 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": user3146, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": journal3147, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": today3148, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": max_date3149, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var partner3155 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "Partner", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(invoicing.Plans.partner) ") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/partner" }) }) });
    var course3156 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Activity</span>", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(invoicing.Plans.course) If this field is nonempty, select only enrolments of that\ngiven course.") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/course" }) }) });
    var main_2_panel3157 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": partner3155, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": course3156, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var invoicing_ItemsByPlan_grid3174 = new Lino.invoicing.ItemsByPlan.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicing suggestions","(invoicing.invoicing.ItemsByPlan) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.ItemsByPlan.grid) ] });
    var main_panel3175 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3150, main_2_panel3157, invoicing_ItemsByPlan_grid3174 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3175;
    this.before_row_edit = function(record) {
      invoicing_ItemsByPlan_grid3174.on_master_changed();
    }
    Lino.invoicing.Plans.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.EnrolmentsByPupil.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 53,
  initComponent : function() {
    var course_area1872 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Layout", "forceSelection": true, "hiddenName": "course_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Layout","(courses.EnrolmentsByPupil.course_area) ") }, "name": "course_area", "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var course1873 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity...", "fieldLabel": "Activity", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.EnrolmentsByPupil.course) ") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/course" }) }) });
    var places1874 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Places used</span>", "listeners": { "render": Lino.quicktip_renderer("Places used","(courses.EnrolmentsByPupil.places) The number of participants in this enrolment.") }, "name": "places", "selectOnFocus": true, "value": 1 });
    var option1875 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "Option", "hiddenName": "optionHidden", "listeners": { "render": Lino.quicktip_renderer("Option","(courses.EnrolmentsByPupil.option) ") }, "name": "option", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/option" }) }) });
    var main_3_panel1876 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 20, "items": places1874, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 80, "items": option1875, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1879 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.EnrolmentsByPupil.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var request_date1880 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Date of request", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.EnrolmentsByPupil.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user1881 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.EnrolmentsByPupil.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/user" }) }) });
    var main_5_panel1882 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": request_date1880, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 60, "items": user1881, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1885 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": course_area1872, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": course1873, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_3_panel1876, { "anchor": "-20", "autoHeight": true, "items": remark1879, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_5_panel1882 ], "labelAlign": "top", "labelWidth": 81, "layout": "form" });
    this.items = main_panel1885;
    this.before_row_edit = function(record) {
      course1873.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1873.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      option1875.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      course_area1872.on('change',Lino.chooser_handler(course1873,'course_area'));
      request_date1880.on('change',Lino.chooser_handler(course1873,'request_date'));
      course1873.on('change',Lino.chooser_handler(option1875,'course'));
      Lino.courses.EnrolmentsByPupil.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.EnrolmentsByPupil.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Journals.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 37,
  initComponent : function() {
    var name3176 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(ledger.Journals.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3177 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(ledger.Journals.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3178 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(ledger.Journals.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var ref3179 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(ledger.Journals.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var main_1_panel3180 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": name3176, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3177, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3178, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 7, "items": ref3179, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var trade_type3185 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Trade type</span>", "forceSelection": true, "hiddenName": "trade_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Trade type","(ledger.Journals.trade_type) Pointer to TradeTypes.") }, "name": "trade_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.ledger.TradeTypes) });
    var seqno3186 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">No.</span>", "listeners": { "render": Lino.quicktip_renderer("No.","(ledger.Journals.seqno) The sequence number of this item with its parent.") }, "name": "seqno", "selectOnFocus": true });
    var id3187 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(ledger.Journals.id) ") }, "name": "id", "selectOnFocus": true });
    var voucher_type3188 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher type</span>", "forceSelection": true, "hiddenName": "voucher_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Voucher type","(ledger.Journals.voucher_type) Pointer to an item of VoucherTypes.") }, "name": "voucher_type", "selectOnFocus": true, "store": Lino.ledger.VoucherTypes });
    var journal_group3189 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal group</span>", "forceSelection": true, "hiddenName": "journal_groupHidden", "listeners": { "render": Lino.quicktip_renderer("Journal group","(ledger.Journals.journal_group) Pointer to an item of JournalGroups.") }, "name": "journal_group", "selectOnFocus": true, "store": Lino.ledger.JournalGroups });
    var main_2_panel3190 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": trade_type3185, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": seqno3186, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": id3187, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": voucher_type3188, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": journal_group3189, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var account3196 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account...", "fieldLabel": "Account", "hiddenName": "accountHidden", "listeners": { "render": Lino.quicktip_renderer("Account","(ledger.Journals.account) ") }, "name": "account", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Accounts.detail,Lino.accounts.Accounts.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/account" }) }) });
    var build_method3197 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Build method</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(ledger.Journals.build_method) A pointer to an item of\nlino.modlib.printing.choicelists.BuildMethods.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template3198 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Template</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(ledger.Journals.template) See PrintableType.template.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Journals/template" }) }) });
    var main_3_panel3199 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": account3196, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": build_method3197, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": template3198, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var dc3203 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Primary booking direction", "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Primary booking direction","(ledger.Journals.dc) Debit (checked) or Credit (not checked)") }, "name": "dc", "selectOnFocus": true });
    var force_sequence3204 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Force chronological sequence", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Force chronological sequence","(ledger.Journals.force_sequence) ") }, "name": "force_sequence", "selectOnFocus": true });
    var yearly_numbering3205 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Yearly numbering", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Yearly numbering","(ledger.Journals.yearly_numbering) Whether the\nnumber of\nvouchers should restart at 1 every year.") }, "name": "yearly_numbering", "selectOnFocus": true });
    var auto_check_clearings3206 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Check clearing", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Check clearing","(ledger.Journals.auto_check_clearings) Automatically update the cleared status of involved transactions when (de)registering a voucher of this journal") }, "name": "auto_check_clearings", "selectOnFocus": true });
    var main_4_panel3207 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": dc3203, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": force_sequence3204, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": yearly_numbering3205, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": auto_check_clearings3206, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 261, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var printed_name3212 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Printed document designation", "listeners": { "render": Lino.quicktip_renderer("Printed document designation","(ledger.Journals.printed_name) ") }, "maxLength": 100, "name": "printed_name", "selectOnFocus": true });
    var printed_name_de3213 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Printed document designation (de)", "listeners": { "render": Lino.quicktip_renderer("Printed document designation (de)","(ledger.Journals.printed_name_de) ") }, "maxLength": 100, "name": "printed_name_de", "selectOnFocus": true });
    var printed_name_fr3214 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Printed document designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Printed document designation (fr)","(ledger.Journals.printed_name_fr) ") }, "maxLength": 100, "name": "printed_name_fr", "selectOnFocus": true });
    var main_5_panel3215 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": printed_name3212, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": printed_name_de3213, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": printed_name_fr3214, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 306, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MatchRulesByJournal_grid3226 = new Lino.ledger.MatchRulesByJournal.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Match rules","(ledger.ledger.MatchRulesByJournal) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.ledger.MatchRulesByJournal.grid) ] });
    var main_panel3227 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3180, main_2_panel3190, main_3_panel3199, main_4_panel3207, main_5_panel3215, MatchRulesByJournal_grid3226 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3227;
    this.before_row_edit = function(record) {
      template3198.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template3198.setContextValue('voucher_type', record ? record.data['voucher_typeHidden'] : undefined);
      MatchRulesByJournal_grid3226.on_master_changed();
    }
    this.onRender = function(ct, position) {
      build_method3197.on('change',Lino.chooser_handler(template3198,'build_method'));
      voucher_type3188.on('change',Lino.chooser_handler(template3198,'voucher_type'));
      Lino.ledger.Journals.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.ledger.Journals.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Journals.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 37,
  initComponent : function() {
    var ref3228 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(ledger.Journals.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var name3229 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(ledger.Journals.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3230 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(ledger.Journals.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3231 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(ledger.Journals.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3232 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": ref3228, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name3229, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de3230, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr3231, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var journal_group3237 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal group</span>", "forceSelection": true, "hiddenName": "journal_groupHidden", "listeners": { "render": Lino.quicktip_renderer("Journal group","(ledger.Journals.journal_group) Pointer to an item of JournalGroups.") }, "name": "journal_group", "selectOnFocus": true, "store": Lino.ledger.JournalGroups });
    var voucher_type3238 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher type</span>", "forceSelection": true, "hiddenName": "voucher_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Voucher type","(ledger.Journals.voucher_type) Pointer to an item of VoucherTypes.") }, "name": "voucher_type", "selectOnFocus": true, "store": Lino.ledger.VoucherTypes });
    var main_panel3239 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3232, { "anchor": "-20", "autoHeight": true, "items": journal_group3237, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": voucher_type3238, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "form" });
    this.items = main_panel3239;
    this.before_row_edit = function(record) {
    }
    Lino.ledger.Journals.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.NoteTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 69,
  initComponent : function() {
    var name3242 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(notes.NoteTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3243 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(notes.NoteTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3244 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(notes.NoteTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3245 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3242, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3243, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3244, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var build_method3249 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Build method</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(notes.NoteTypes.build_method) A pointer to an item of\nlino.modlib.printing.choicelists.BuildMethods.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var main_panel3250 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3245, { "anchor": "-20", "autoHeight": true, "items": build_method3249, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel3250;
    this.before_row_edit = function(record) {
    }
    Lino.notes.NoteTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.StatusReport.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var body_htmlbox3252 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(courses.StatusReport.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel3253 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox3252 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel3253;
    this.before_row_edit = function(record) {
      body_htmlbox3252.refresh();
    }
    Lino.courses.StatusReport.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.TeacherTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 55,
  initComponent : function() {
    var id3254 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.TeacherTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3255 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.TeacherTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3256 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.TeacherTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3257 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.TeacherTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3258 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3254, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3255, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3256, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3257, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_TeachersByType_grid3451 = new Lino.courses.TeachersByType.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Instructors","(courses.courses.TeachersByType) List of all Persons.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.TeachersByType.grid) ] });
    var main_panel3452 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3258, courses_TeachersByType_grid3451 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3452;
    this.before_row_edit = function(record) {
      courses_TeachersByType_grid3451.on_master_changed();
    }
    Lino.courses.TeacherTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Enrolments.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 53,
  initComponent : function() {
    var id1281 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Enrolments.id) ") }, "name": "id", "selectOnFocus": true });
    var course1282 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity...", "fieldLabel": "Activity", "hiddenName": "courseHidden", "listeners": { "render": Lino.quicktip_renderer("Activity","(courses.Enrolments.course) ") }, "name": "course", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Activities.detail,Lino.courses.Activities.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/course" }) }) });
    var pupil1283 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant...", "fieldLabel": "Participant", "forceSelection": false, "hiddenName": "pupilHidden", "listeners": { "render": Lino.quicktip_renderer("Participant","(courses.Enrolments.pupil) ") }, "name": "pupil", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Pupils.detail,Lino.courses.Pupils.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/pupil" }) }) });
    var request_date1284 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Date of request", "listeners": { "render": Lino.quicktip_renderer("Date of request","(courses.Enrolments.request_date) ") }, "name": "request_date", "selectOnFocus": true });
    var user1285 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(courses.Enrolments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/user" }) }) });
    var main_1_panel1286 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 6, "items": id1281, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": course1282, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": pupil1283, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": request_date1284, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": user1285, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var start_date1292 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Start date", "listeners": { "render": Lino.quicktip_renderer("Start date","(courses.Enrolments.start_date) ") }, "name": "start_date", "selectOnFocus": true });
    var end_date1293 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "End date", "listeners": { "render": Lino.quicktip_renderer("End date","(courses.Enrolments.end_date) ") }, "name": "end_date", "selectOnFocus": true });
    var places1294 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Places used</span>", "listeners": { "render": Lino.quicktip_renderer("Places used","(courses.Enrolments.places) The number of participants in this enrolment.") }, "name": "places", "selectOnFocus": true, "value": 1 });
    var fee1295 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Tariff</span>", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(courses.Enrolments.fee) The participation fee to apply for this enrolment.") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/fee" }) }) });
    var free_events1296 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Free events</span>", "listeners": { "render": Lino.quicktip_renderer("Free events","(courses.Enrolments.free_events) Number of events to add for first invoicing for this enrolment.") }, "name": "free_events", "selectOnFocus": true });
    var amount1297 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Amount</span>", "listeners": { "render": Lino.quicktip_renderer("Amount","(courses.Enrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.") }, "name": "amount", "selectOnFocus": true });
    var main_2_panel1298 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 17, "items": start_date1292, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 17, "items": end_date1293, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": places1294, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": fee1295, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 10, "items": free_events1296, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": amount1297, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remark1305 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Remark", "listeners": { "render": Lino.quicktip_renderer("Remark","(courses.Enrolments.remark) ") }, "maxLength": 200, "name": "remark", "selectOnFocus": true });
    var workflow_buttons_disp1306 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Actions", "listeners": { "render": Lino.quicktip_renderer("Actions","(courses.Enrolments.workflow_buttons) ") }, "name": "workflow_buttons", "value": "<br/>" });
    var printed_disp1307 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Printed", "listeners": { "render": Lino.quicktip_renderer("Printed","(courses.Enrolments.printed) ") }, "name": "printed", "value": "<br/>" });
    var invoicing_info_disp1308 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Invoicing info", "listeners": { "render": Lino.quicktip_renderer("Invoicing info","(courses.Enrolments.invoicing_info) ") }, "name": "invoicing_info", "value": "<br/>" });
    var main_3_panel1309 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": remark1305, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": workflow_buttons_disp1306, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": printed_disp1307, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 27, "items": invoicing_info_disp1308, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var confirmation_details1314 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Confirmation details", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Confirmation details","(courses.Enrolments.confirmation_details) ") }, "name": "confirmation_details", "selectOnFocus": true });
    var invoicing_InvoicingsByInvoiceable_grid1315 = new Lino.invoicing.InvoicingsByInvoiceable.GridPanel({ "containing_panel": this, "flex": 66, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Invoicings","(invoicing.invoicing.InvoicingsByInvoiceable) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.invoicing.InvoicingsByInvoiceable.grid) ] });
    var main_4_panel1316 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": confirmation_details1314, "labelAlign": "top", "layout": "form", "xtype": "panel" }, invoicing_InvoicingsByInvoiceable_grid1315 ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel1318 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1286, main_2_panel1298, main_3_panel1309, main_4_panel1316 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel1318;
    this.before_row_edit = function(record) {
      course1282.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1282.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil1283.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee1295.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      invoicing_InvoicingsByInvoiceable_grid1315.on_master_changed();
    }
    this.onRender = function(ct, position) {
      request_date1284.on('change',Lino.chooser_handler(course1282,'request_date'));
      course1282.on('change',Lino.chooser_handler(pupil1283,'course'));
      course1282.on('change',Lino.chooser_handler(fee1295,'course'));
      Lino.courses.Enrolments.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Enrolments.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.outbox.Mails.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 72,
  initComponent : function() {
    var subject3453 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Subject", "listeners": { "render": Lino.quicktip_renderer("Subject","(outbox.Mails.subject) ") }, "maxLength": 200, "name": "subject", "selectOnFocus": true });
    var body3454 = new Ext.form.HtmlEditor({ "fieldLabel": "Body", "flex": 83, "listeners": { "render": Lino.quicktip_renderer("Body","(outbox.Mails.body) ") }, "name": "body", "selectOnFocus": true });
    var main_panel3455 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "items": subject3453, "labelAlign": "top", "layout": "form", "xtype": "panel" }, body3454 ], "labelAlign": "top", "labelWidth": 72, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3455;
    this.before_row_edit = function(record) {
    }
    Lino.outbox.Mails.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Calendars.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 27,
  initComponent : function() {
    var name3457 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Calendars.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3458 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Calendars.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3459 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Calendars.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var color3460 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "color", "listeners": { "render": Lino.quicktip_renderer("color","(cal.Calendars.color) ") }, "name": "color", "selectOnFocus": true });
    var id3461 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(cal.Calendars.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel3462 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": name3457, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": name_de3458, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": name_fr3459, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": color3460, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 6, "items": id3461, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description3468 = new Ext.form.HtmlEditor({ "fieldLabel": "Description", "flex": 33, "listeners": { "render": Lino.quicktip_renderer("Description","(cal.Calendars.description) ") }, "name": "description", "selectOnFocus": true });
    var SubscriptionsByCalendar_grid3477 = new Lino.cal.SubscriptionsByCalendar.GridPanel({ "containing_panel": this, "flex": 66, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Subscriptions","(cal.cal.SubscriptionsByCalendar) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.cal.SubscriptionsByCalendar.grid) ] });
    var main_2_panel3478 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 83, "frame": false, "hideCheckBoxLabels": true, "items": [ description3468, SubscriptionsByCalendar_grid3477 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel3479 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3462, main_2_panel3478 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3479;
    this.before_row_edit = function(record) {
      SubscriptionsByCalendar_grid3477.on_master_changed();
    }
    Lino.cal.Calendars.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.Excerpts.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 76,
  initComponent : function() {
    var id3480 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(excerpts.Excerpts.id) ") }, "name": "id", "selectOnFocus": true });
    var excerpt_type3481 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Excerpt Type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Excerpt Type</span>", "hiddenName": "excerpt_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Excerpt Type","(excerpts.Excerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).") }, "name": "excerpt_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.excerpts.ExcerptTypes.detail,Lino.excerpts.ExcerptTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var main_1_panel3482 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": id3480, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 83, "items": excerpt_type3481, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var user3485 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Author</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Author","(excerpts.Excerpts.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/user" }) }) });
    var build_method3486 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Build method", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(excerpts.Excerpts.build_method) ") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var main_2_panel3487 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 30, "items": user3485, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 69, "items": build_method3486, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var company3490 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recipient (Organization)</span>", "hiddenName": "companyHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Organization)","(excerpts.Excerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.") }, "name": "company", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Companies.detail,Lino.contacts.Companies.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/company" }) }) });
    var contact_person3491 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Person...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Recipient (Person)</span>", "hiddenName": "contact_personHidden", "listeners": { "render": Lino.quicktip_renderer("Recipient (Person)","(excerpts.Excerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.") }, "name": "contact_person", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Persons.detail,Lino.contacts.Persons.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_person" }) }) });
    var language3492 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(excerpts.Excerpts.language) The language used for printing this excerpt.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var main_3_panel3493 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": company3490, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": contact_person3491, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": language3492, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 225, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var owner_disp3497 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Controlled by</span>", "name": "owner" });
    var build_time3498 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">build time</span>", "listeners": { "render": Lino.quicktip_renderer("build time","(excerpts.Excerpts.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.") }, "name": "build_time", "value": "<br>" });
    var main_4_panel3499 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 38, "items": owner_disp3497, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 61, "items": build_time3498, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3502 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3482, main_2_panel3487, main_3_panel3493, main_4_panel3499 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3502;
    this.before_row_edit = function(record) {
      excerpt_type3481.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person3491.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      owner_disp3497.on('change',Lino.chooser_handler(excerpt_type3481,'owner'));
      company3490.on('change',Lino.chooser_handler(contact_person3491,'company'));
      Lino.excerpts.Excerpts.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.Excerpts.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Lines.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 57,
  initComponent : function() {
    var id3044 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Lines.id) ") }, "name": "id", "selectOnFocus": true });
    var name3045 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Lines.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3046 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Lines.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3047 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Lines.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var ref3048 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(courses.Lines.ref) The reference. This must be either empty or unique.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var main_1_panel3049 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 5, "items": id3044, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name3045, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_de3046, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": name_fr3047, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": ref3048, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var course_area3055 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Layout</span>", "forceSelection": true, "hiddenName": "course_areaHidden", "listeners": { "render": Lino.quicktip_renderer("Layout","(courses.Lines.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.") }, "name": "course_area", "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var topic3056 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Topic...", "fieldLabel": "Topic", "hiddenName": "topicHidden", "listeners": { "render": Lino.quicktip_renderer("Topic","(courses.Lines.topic) ") }, "name": "topic", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.Topics.detail,Lino.courses.Topics.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/topic" }) }) });
    var fees_cat3057 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff Category...", "fieldLabel": "Fees category", "hiddenName": "fees_catHidden", "listeners": { "render": Lino.quicktip_renderer("Fees category","(courses.Lines.fees_cat) ") }, "name": "fees_cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,Lino.products.ProductCats.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fees_cat" }) }) });
    var fee3058 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "Participation fee", "hiddenName": "feeHidden", "listeners": { "render": Lino.quicktip_renderer("Participation fee","(courses.Lines.fee) ") }, "name": "fee", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fee" }) }) });
    var options_cat3059 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff Category...", "fieldLabel": "Options category", "hiddenName": "options_catHidden", "listeners": { "render": Lino.quicktip_renderer("Options category","(courses.Lines.options_cat) ") }, "name": "options_cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,Lino.products.ProductCats.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/options_cat" }) }) });
    var body_template3060 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Body template</span>", "listeners": { "render": Lino.quicktip_renderer("Body template","(courses.Lines.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.") }, "name": "body_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/body_template" }) }) });
    var main_2_panel3061 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 12, "items": course_area3055, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": topic3056, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": fees_cat3057, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": fee3058, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 19, "items": options_cat3059, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 9, "items": body_template3060, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var course_type3068 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Activity type...", "fieldLabel": "Activity type", "hiddenName": "course_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Activity type","(courses.Lines.course_type) ") }, "name": "course_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.CourseTypes.detail,Lino.courses.CourseTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/course_type" }) }) });
    var event_type3069 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Calendar entry type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Calendar entry type</span>", "hiddenName": "event_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Calendar entry type","(courses.Lines.event_type) The type of calendar events to be generated. If this is empty, no calendar events will be generated.") }, "name": "event_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.EventTypes.detail,Lino.cal.EventTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/event_type" }) }) });
    var guest_role3070 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Guest Role...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Manage presences as</span>", "hiddenName": "guest_roleHidden", "listeners": { "render": Lino.quicktip_renderer("Manage presences as","(courses.Lines.guest_role) The default guest role for particpants of events for courses in this series. Leave empty if you don't want any presence management.") }, "name": "guest_role", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.cal.GuestRoles.detail,Lino.cal.GuestRoles.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/guest_role" }) }) });
    var every_unit3071 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Recurrency", "forceSelection": true, "hiddenName": "every_unitHidden", "listeners": { "render": Lino.quicktip_renderer("Recurrency","(courses.Lines.every_unit) ") }, "name": "every_unit", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3072 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Repeat every", "listeners": { "render": Lino.quicktip_renderer("Repeat every","(courses.Lines.every) ") }, "name": "every", "selectOnFocus": true, "value": 1 });
    var main_3_panel3073 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 23, "items": course_type3068, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": event_type3069, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": guest_role3070, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": every_unit3071, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 5, "items": every3072, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var description3079 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Lines.description) ") }, "name": "description", "selectOnFocus": true });
    var description_de3080 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description (de)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (de)","(courses.Lines.description_de) ") }, "name": "description_de", "selectOnFocus": true });
    var description_fr3081 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Description (fr)", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Description (fr)","(courses.Lines.description_fr) ") }, "name": "description_fr", "selectOnFocus": true });
    var main_4_panel3082 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 35, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 33, "items": description3079, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_de3080, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "flex": 33, "items": description_fr3081, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var excerpt_title3086 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Excerpt title</span>", "listeners": { "render": Lino.quicktip_renderer("Excerpt title","(courses.Lines.excerpt_title) The title to be used when printing an excerpt.") }, "maxLength": 200, "name": "excerpt_title", "selectOnFocus": true });
    var excerpt_title_de3087 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Excerpt title (de)", "listeners": { "render": Lino.quicktip_renderer("Excerpt title (de)","(courses.Lines.excerpt_title_de) ") }, "maxLength": 200, "name": "excerpt_title_de", "selectOnFocus": true });
    var excerpt_title_fr3088 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Excerpt title (fr)", "listeners": { "render": Lino.quicktip_renderer("Excerpt title (fr)","(courses.Lines.excerpt_title_fr) ") }, "maxLength": 200, "name": "excerpt_title_fr", "selectOnFocus": true });
    var main_5_panel3089 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": excerpt_title3086, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": excerpt_title_de3087, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": excerpt_title_fr3088, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 171, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_CoursesByLine_grid3142 = new Lino.courses.CoursesByLine.GridPanel({ "containing_panel": this, "flex": 35, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesByLine) Like lino_xl.lib.courses.CoursesByLine, but with other\ndefault values in the filter parameters. In Voga we want to see\nonly courses for which new enrolments can happen.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesByLine.grid) ] });
    var main_panel3143 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3049, main_2_panel3061, main_3_panel3073, main_4_panel3082, main_5_panel3089, courses_CoursesByLine_grid3142 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3143;
    this.before_row_edit = function(record) {
      fee3058.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
      courses_CoursesByLine_grid3142.on_master_changed();
    }
    this.onRender = function(ct, position) {
      fees_cat3057.on('change',Lino.chooser_handler(fee3058,'fees_cat'));
      Lino.courses.Lines.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Lines.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.accounts.Accounts.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 33,
  initComponent : function() {
    var ref3503 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(accounts.Accounts.ref) An optional unique name which can be used to reference a given\naccount.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var group3504 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account Group...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Account Group</span>", "hiddenName": "groupHidden", "listeners": { "render": Lino.quicktip_renderer("Account Group","(accounts.Accounts.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.") }, "name": "group", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Groups.detail,Lino.accounts.Groups.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/Accounts/group" }) }) });
    var type3505 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Account Type</span>", "forceSelection": true, "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Accounts.type) The account type of this account.  This points to an item of\nAccountTypes.") }, "name": "type", "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var main_1_panel3506 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 36, "items": ref3503, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 35, "items": group3504, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": type3505, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name3510 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Accounts.name) The multilingual designation of this account, as the users see\nit.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3511 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Accounts.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3512 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Accounts.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel3513 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3510, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3511, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3512, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3517 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3506, main_2_panel3513 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3517;
    this.before_row_edit = function(record) {
    }
    Lino.accounts.Accounts.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.Uploads.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 71,
  initComponent : function() {
    var type2815 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Upload Type...", "fieldLabel": "Upload Type", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.Uploads.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/type" }) }) });
    var description2816 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Description</span>", "listeners": { "render": Lino.quicktip_renderer("Description","(uploads.Uploads.description) A short description entered manually by the user.") }, "maxLength": 200, "name": "description", "selectOnFocus": true });
    var file2817 = Lino.file_field_handler(this,{ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">File</span>", "listeners": { "render": Lino.quicktip_renderer("File","(uploads.Uploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file") }, "maxLength": 100, "name": "file", "selectOnFocus": true });
    var user2818 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Uploaded by</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Uploaded by","(uploads.Uploads.user) The author of this object.\nA pointer to lino.modlib.users.models.User.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var main_panel2819 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": type2815, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": description2816, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": file2817, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": user2818, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel2819;
    this.before_row_edit = function(record) {
      type2815.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    }
    Lino.uploads.Uploads.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.ExcerptTypes.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 75,
  initComponent : function() {
    var name3518 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(excerpts.ExcerptTypes.name) The designation of this excerpt type.\nOne field for every language.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3519 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(excerpts.ExcerptTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3520 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(excerpts.ExcerptTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3521 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3518, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3519, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3520, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var content_type3525 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a content type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Model</span>", "hiddenName": "content_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Model","(excerpts.ExcerptTypes.content_type) The model that can issue printouts of this type.") }, "name": "content_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,Lino.gfks.ContentTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/content_type" }) }) });
    var primary3526 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Primary", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Primary","(excerpts.ExcerptTypes.primary) Whether this is the default type to use for this model. There's at most one primary type per model. Enabling this field will automatically make the other types non-primary.") }, "name": "primary", "selectOnFocus": true });
    var certifying3527 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Certifying", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Certifying","(excerpts.ExcerptTypes.certifying) Whether an excerpt of this type is a unique printout.") }, "name": "certifying", "selectOnFocus": true });
    var main_2_panel3528 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": content_type3525, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": primary3526, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": certifying3527, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var build_method3532 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Build method</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(excerpts.ExcerptTypes.build_method) See lino.modlib.printing.mixins.PrintableType.build_method.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template3533 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Template</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(excerpts.ExcerptTypes.template) The main template to be used when printing an excerpt of this type.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/template" }) }) });
    var body_template3534 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Body template</span>", "listeners": { "render": Lino.quicktip_renderer("Body template","(excerpts.ExcerptTypes.body_template) The body template to be used when         rendering a printable of this type. This is a list of files         with extension `.body.html`.") }, "name": "body_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/body_template" }) }) });
    var main_3_panel3535 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 53, "items": build_method3532, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": template3533, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": body_template3534, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3539 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3521, main_2_panel3528, main_3_panel3535 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3539;
    this.before_row_edit = function(record) {
      template3533.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template3533.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      body_template3534.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
    }
    this.onRender = function(ct, position) {
      build_method3532.on('change',Lino.chooser_handler(template3533,'build_method'));
      content_type3525.on('change',Lino.chooser_handler(template3533,'content_type'));
      content_type3525.on('change',Lino.chooser_handler(body_template3534,'content_type'));
      Lino.excerpts.ExcerptTypes.InsertFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.ExcerptTypes.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 56,
  initComponent : function() {
    var overview_disp1774 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Description", "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Pupils.overview) ") }, "name": "overview", "value": "<br/>" });
    var email1775 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(courses.Pupils.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone1776 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Phone</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(courses.Pupils.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm1777 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(courses.Pupils.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel1778 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email1775, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone1776, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm1777, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid1782 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel1783 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp1774, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel1778, lists_MembersByPartner_grid1782 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks1785 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(courses.Pupils.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_grid1786 = new Lino.plausibility.ProblemsByOwner.GridPanel({ "containing_panel": this, "flex": 37, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ] });
    var bottom_box_1_panel1787 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks1785, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_grid1786 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel1789 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel1783, bottom_box_1_panel1787 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var last_name1790 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Last name</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(courses.Pupils.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var first_name1791 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">First name</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(courses.Pupils.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var gender1792 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gender</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Pupils.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var address_box_1_panel1793 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 46, "items": last_name1790, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": first_name1791, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": gender1792, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street1797 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Street</span>", "listeners": { "render": Lino.quicktip_renderer("Street","(courses.Pupils.street) Name of street, without house number.") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box1798 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Box</span>", "listeners": { "render": Lino.quicktip_renderer("Box","(courses.Pupils.street_box) Text to print after street nuber on the same line.") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel1799 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street1797, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box1798, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var country1802 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Country...", "fieldLabel": "Country", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(courses.Pupils.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/country" }) }) });
    var zip_code1803 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Zip code", "listeners": { "render": Lino.quicktip_renderer("Zip code","(courses.Pupils.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city1804 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Place...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">City</span>", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("City","(courses.Pupils.city) A pointer to Place.") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,Lino.countries.Places.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/city" }) }) });
    var address_box_3_panel1805 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country1802, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code1803, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city1804, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var birth_date1809 = new Lino.IncompleteDateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Birth date</span>", "listeners": { "render": Lino.quicktip_renderer("Birth date","(courses.Pupils.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".") }, "name": "birth_date", "selectOnFocus": true });
    var age_disp1810 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Age", "listeners": { "render": Lino.quicktip_renderer("Age","(courses.Pupils.age) ") }, "name": "age", "value": "<br/>" });
    var pupil_type1811 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant Type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Participant Type</span>", "hiddenName": "pupil_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Participant Type","(courses.Pupils.pupil_type) Pointer to PupilType.") }, "name": "pupil_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.PupilTypes.detail,Lino.courses.PupilTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/pupil_type" }) }) });
    var national_id1812 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">National ID</span>", "listeners": { "render": Lino.quicktip_renderer("National ID","(courses.Pupils.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.") }, "maxLength": 200, "name": "national_id", "selectOnFocus": true });
    var card_number1813 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "eID card number", "listeners": { "render": Lino.quicktip_renderer("eID card number","(courses.Pupils.card_number) ") }, "maxLength": 20, "name": "card_number", "selectOnFocus": true });
    var personal_panel1814 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 73, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 32, "items": pupil_type1811, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": national_id1812, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": card_number1813, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_4_panel1818 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 14, "items": birth_date1809, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": age_disp1810, "labelAlign": "top", "layout": "form", "xtype": "panel" }, personal_panel1814 ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel1821 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel1793, address_box_2_panel1799, address_box_3_panel1805, address_box_4_panel1818 ], "labelAlign": "top", "layout": "form" });
    var contacts_RolesByPerson_grid1830 = new Lino.contacts.RolesByPerson.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact for","(contacts.contacts.RolesByPerson) Shows all roles of a person.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByPerson.grid) ] });
    var sepa_AccountsByPartner_grid1831 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel1832 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 45, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByPerson_grid1830, sepa_AccountsByPartner_grid1831 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel1833 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel1821, address_2_panel1832 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Address" });
    var legacy_id1834 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Legacy ID", "listeners": { "render": Lino.quicktip_renderer("Legacy ID","(courses.Pupils.legacy_id) ") }, "maxLength": 12, "name": "legacy_id", "selectOnFocus": true });
    var member_until1835 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Mitglied bis", "listeners": { "render": Lino.quicktip_renderer("Mitglied bis","(courses.Pupils.member_until) ") }, "name": "member_until", "selectOnFocus": true });
    var section1836 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Section", "forceSelection": true, "hiddenName": "sectionHidden", "listeners": { "render": Lino.quicktip_renderer("Section","(courses.Pupils.section) ") }, "name": "section", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var is_lfv1837 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "LFV", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("LFV","(courses.Pupils.is_lfv) ") }, "name": "is_lfv", "selectOnFocus": true });
    var is_ckk1838 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "CKK", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("CKK","(courses.Pupils.is_ckk) ") }, "name": "is_ckk", "selectOnFocus": true });
    var is_raviva1839 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Raviva", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Raviva","(courses.Pupils.is_raviva) ") }, "name": "is_raviva", "selectOnFocus": true });
    var courses_1_panel1840 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 18, "items": legacy_id1834, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": member_until1835, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 18, "items": section1836, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": is_lfv1837, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": is_ckk1838, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": is_raviva1839, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var courses_EnrolmentsByPupil_grid1889 = new Lino.courses.EnrolmentsByPupil.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Enrolments","(courses.courses.EnrolmentsByPupil) Show all enrolments of a given pupil.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.courses.EnrolmentsByPupil.grid) ] });
    var courses_panel1890 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ courses_1_panel1840, courses_EnrolmentsByPupil_grid1889 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Activities" });
    var invoice_recipient1891 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Invoicing address</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(courses.Pupils.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/invoice_recipient" }) }) });
    var vat_regime1892 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(courses.Pupils.vat_regime) The default VAT regime for         sales and purchases of this partner.") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel1893 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": invoice_recipient1891, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 57, "items": vat_regime1892, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term1896 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Pupils.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/payment_term" }) }) });
    var paper_type1897 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "Paper type", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Pupils.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/paper_type" }) }) });
    var ledger_a_2_panel1898 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term1896, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type1897, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel1901 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 61, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel1893, ledger_a_2_panel1898 ], "labelAlign": "top", "layout": "form" });
    var MovementsByPartner_htmlbox1902 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 38, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(courses.Pupils.MovementsByPartner) Show the ledger movements of a partner.\nSee also lino_xl.lib.ledger.models.Movement.") }, "master_panel": this, "name": "MovementsByPartner", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel1903 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel1901, MovementsByPartner_htmlbox1902 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid1904 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel1905 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel1903, sales_InvoicesByPartner_grid1904 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var id1906 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Pupils.id) ") }, "name": "id", "selectOnFocus": true });
    var language1907 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(courses.Pupils.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url1908 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "URL", "listeners": { "render": Lino.quicktip_renderer("URL","(courses.Pupils.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_1_panel1909 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 10, "items": id1906, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": language1907, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": url1908, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr11913 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line before street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(courses.Pupils.addr1) Address line before street") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var addr21914 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line after street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(courses.Pupils.addr2) Address line to print below street line.") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var more_2_panel1915 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr11913, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": addr21914, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByPerson_grid1939 = new Lino.notes.NotesByPerson.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByPerson.grid) ] });
    var more_panel1940 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel1909, more_2_panel1915, notes_NotesByPerson_grid1939 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var main_panel1941 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel1789, address_panel1833, courses_panel1890, ledger_panel1905, more_panel1940 ], "labelAlign": "top", "split": true });
    this.items = main_panel1941;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid1782.on_master_changed();
      plausibility_ProblemsByOwner_grid1786.on_master_changed();
      city1804.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city1804.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByPerson_grid1830.on_master_changed();
      sepa_AccountsByPartner_grid1831.on_master_changed();
      courses_EnrolmentsByPupil_grid1889.on_master_changed();
      MovementsByPartner_htmlbox1902.refresh();
      sales_InvoicesByPartner_grid1904.on_master_changed();
      notes_NotesByPerson_grid1939.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country1802.on('change',Lino.chooser_handler(city1804,'country'));
      Lino.courses.Pupils.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Pupils.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city1804.on("change", function(){ this.save() }, this);
    zip_code1803.on("change", function(){ this.save() }, this);
  }
});


Lino.courses.Topics.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 54,
  initComponent : function() {
    var id3540 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Topics.id) ") }, "name": "id", "selectOnFocus": true });
    var name3541 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Topics.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3542 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Topics.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3543 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Topics.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3544 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3540, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3541, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3542, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3543, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var courses_LinesByTopic_grid3578 = new Lino.courses.LinesByTopic.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activity lines","(courses.courses.LinesByTopic) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.LinesByTopic.grid) ] });
    var courses_CoursesByTopic_grid3628 = new Lino.courses.CoursesByTopic.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesByTopic) Shows the courses of a given topic.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesByTopic.grid) ] });
    var main_panel3629 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3544, courses_LinesByTopic_grid3578, courses_CoursesByTopic_grid3628 ], "labelAlign": "top" });
    this.items = main_panel3629;
    this.before_row_edit = function(record) {
      courses_LinesByTopic_grid3578.on_master_changed();
      courses_CoursesByTopic_grid3628.on_master_changed();
    }
    Lino.courses.Topics.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.uploads.UploadsByController.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 71,
  initComponent : function() {
    var file3630 = Lino.file_field_handler(this,{ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">File</span>", "listeners": { "render": Lino.quicktip_renderer("File","(uploads.UploadsByController.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file") }, "maxLength": 100, "name": "file", "selectOnFocus": true });
    var type3631 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Upload Type...", "fieldLabel": "Upload Type", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Upload Type","(uploads.UploadsByController.type) ") }, "name": "type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.uploads.UploadTypes.detail,Lino.uploads.UploadTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/type" }) }) });
    var description3632 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Description</span>", "listeners": { "render": Lino.quicktip_renderer("Description","(uploads.UploadsByController.description) A short description entered manually by the user.") }, "maxLength": 200, "name": "description", "selectOnFocus": true });
    var main_panel3633 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": file3630, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": type3631, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": description3632, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 108, "layout": "form" });
    this.items = main_panel3633;
    this.before_row_edit = function(record) {
      type3631.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    }
    Lino.uploads.UploadsByController.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.users.Users.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 2,
  initComponent : function() {
    var username3637 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Username</span>", "listeners": { "render": Lino.quicktip_renderer("Username","(users.Users.username) Must be unique. Leaving this empty means that the user cannot log in.") }, "maxLength": 30, "name": "username", "selectOnFocus": true });
    var profile3638 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">User type</span>", "forceSelection": true, "hiddenName": "profileHidden", "listeners": { "render": Lino.quicktip_renderer("User type","(users.Users.profile) The profile of a user is what defines her or his permissions.") }, "name": "profile", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var partner3639 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(users.Users.partner) Pointer to the Partner instance related to\nthis user.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/partner" }) }) });
    var box1_1_panel3640 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 34, "items": username3637, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": profile3638, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": partner3639, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var first_name3644 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "First name", "listeners": { "render": Lino.quicktip_renderer("First name","(users.Users.first_name) ") }, "maxLength": 30, "name": "first_name", "selectOnFocus": true });
    var last_name3645 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Last name", "listeners": { "render": Lino.quicktip_renderer("Last name","(users.Users.last_name) ") }, "maxLength": 30, "name": "last_name", "selectOnFocus": true });
    var initials3646 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Initials", "listeners": { "render": Lino.quicktip_renderer("Initials","(users.Users.initials) ") }, "maxLength": 10, "name": "initials", "selectOnFocus": true });
    var box1_2_panel3647 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 39, "items": first_name3644, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 39, "items": last_name3645, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": initials3646, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var email3651 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "e-mail address", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(users.Users.email) ") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var language3652 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Language", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(users.Users.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var box1_3_panel3653 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 51, "items": email3651, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": language3652, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id3656 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(users.Users.id) ") }, "name": "id", "selectOnFocus": true });
    var created3657 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Created</span>", "listeners": { "render": Lino.quicktip_renderer("Created","(users.Users.created) The timestame when this object was created.") }, "name": "created", "value": "<br>" });
    var modified3658 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Modified", "listeners": { "render": Lino.quicktip_renderer("Modified","(users.Users.modified) ") }, "name": "modified", "value": "<br>" });
    var box1_4_panel3659 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 13, "items": id3656, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": created3657, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": modified3658, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var box1_panel3663 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ box1_1_panel3640, box1_2_panel3647, box1_3_panel3653, box1_4_panel3659 ], "labelAlign": "top", "layout": "form" });
    var remarks3664 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(users.Users.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var AuthoritiesGiven_grid3667 = new Lino.users.AuthoritiesGiven.GridPanel({ "containing_panel": this, "flex": 33, "hideHeaders": true, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Authorities given","(users.users.AuthoritiesGiven) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.users.AuthoritiesGiven.grid) ] });
    var main_2_panel3668 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 55, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 66, "items": remarks3664, "labelAlign": "top", "layout": "form", "xtype": "panel" }, AuthoritiesGiven_grid3667 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var main_panel3670 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ box1_panel3663, main_2_panel3668 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3670;
    this.before_row_edit = function(record) {
      AuthoritiesGiven_grid3667.on_master_changed();
    }
    Lino.users.Users.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    partner3639.on("change", function(){ this.save() }, this);
  }
});


Lino.users.Users.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 2,
  initComponent : function() {
    var username3671 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Username</span>", "listeners": { "render": Lino.quicktip_renderer("Username","(users.Users.username) Must be unique. Leaving this empty means that the user cannot log in.") }, "maxLength": 30, "name": "username", "selectOnFocus": true });
    var email3672 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "e-mail address", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(users.Users.email) ") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var main_1_panel3673 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": username3671, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": email3672, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var first_name3676 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "First name", "listeners": { "render": Lino.quicktip_renderer("First name","(users.Users.first_name) ") }, "maxLength": 30, "name": "first_name", "selectOnFocus": true });
    var last_name3677 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Last name", "listeners": { "render": Lino.quicktip_renderer("Last name","(users.Users.last_name) ") }, "maxLength": 30, "name": "last_name", "selectOnFocus": true });
    var main_2_panel3678 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": first_name3676, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": last_name3677, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var partner3681 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(users.Users.partner) Pointer to the Partner instance related to\nthis user.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/partner" }) }) });
    var language3682 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Language", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(users.Users.language) ") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var profile3683 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">User type</span>", "forceSelection": true, "hiddenName": "profileHidden", "listeners": { "render": Lino.quicktip_renderer("User type","(users.Users.profile) The profile of a user is what defines her or his permissions.") }, "name": "profile", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var main_4_panel3684 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 47, "items": language3682, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 52, "items": profile3683, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3687 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3673, main_2_panel3678, { "anchor": "-20", "autoHeight": true, "items": partner3681, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_4_panel3684 ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel3687;
    this.before_row_edit = function(record) {
    }
    Lino.users.Users.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.plausibility.Problems.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 17,
  disable_editing: true,
  initComponent : function() {
    var user1460 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a User...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Responsible</span>", "hiddenName": "userHidden", "listeners": { "render": Lino.quicktip_renderer("Responsible","(plausibility.Problems.user) The user reponsible\nfor fixing this problem.") }, "name": "user", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.users.Users.detail,Lino.users.Users.insert)}, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/user" }) }) });
    var owner_disp1461 = new Ext.form.DisplayField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Controlled by", "name": "owner" });
    var checker1462 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Plausibility checker</span>", "forceSelection": true, "hiddenName": "checkerHidden", "listeners": { "render": Lino.quicktip_renderer("Plausibility checker","(plausibility.Problems.checker) The Checker which reported\nthis problem.") }, "name": "checker", "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id1463 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(plausibility.Problems.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel1464 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 28, "items": user1460, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": owner_disp1461, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": checker1462, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": id1463, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 189, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var message1469 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Message</span>", "listeners": { "render": Lino.quicktip_renderer("Message","(plausibility.Problems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.") }, "maxLength": 250, "name": "message", "selectOnFocus": true });
    var main_panel1470 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1464, { "anchor": "-20", "autoHeight": true, "items": message1469, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel1470;
    this.before_row_edit = function(record) {
    }
    Lino.plausibility.Problems.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.Invoices.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 41,
  initComponent : function() {
    var journal3689 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Journal...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Journal</span>", "hiddenName": "journalHidden", "listeners": { "render": Lino.quicktip_renderer("Journal","(vat.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.") }, "name": "journal", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.Journals.detail,Lino.ledger.Journals.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var partner3690 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.Invoices.partner) Mandatory field to be defined in another class.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var main_1_panel3691 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": journal3689, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": partner3690, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var voucher_date3694 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(vat.Invoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var total_incl3695 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total incl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(vat.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var main_2_panel3696 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": voucher_date3694, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": total_incl3695, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3699 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3691, main_2_panel3696 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3699;
    this.before_row_edit = function(record) {
    }
    Lino.vat.Invoices.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.products.ProductCats.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 30,
  initComponent : function() {
    var id3700 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(products.ProductCats.id) ") }, "name": "id", "selectOnFocus": true });
    var name3701 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(products.ProductCats.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3702 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(products.ProductCats.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3703 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(products.ProductCats.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3704 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3700, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3701, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3702, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3703, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var description3709 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "description", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("description","(products.ProductCats.description) ") }, "name": "description", "selectOnFocus": true });
    var ProductsByCategory_grid3739 = new Lino.products.ProductsByCategory.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Tariffs","(products.products.ProductsByCategory) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.products.ProductsByCategory.grid) ] });
    var main_panel3740 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3704, { "flex": 5, "items": description3709, "labelAlign": "top", "layout": "form", "region": "center", "split": true, "xtype": "panel" }, ProductsByCategory_grid3739 ], "labelAlign": "top", "labelWidth": 108 });
    this.items = main_panel3740;
    this.before_row_edit = function(record) {
      ProductsByCategory_grid3739.on_master_changed();
    }
    Lino.products.ProductCats.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.countries.Places.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 5,
  initComponent : function() {
    var name2253 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(countries.Places.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de2254 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(countries.Places.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr2255 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(countries.Places.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var country2256 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a Country...", "fieldLabel": "Country", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(countries.Places.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/country" }) }) });
    var main_1_panel2257 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": name2253, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de2254, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr2255, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 24, "items": country2256, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var type2262 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Place Type", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Place Type","(countries.Places.type) ") }, "name": "type", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/type" }) }) });
    var parent2263 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Place...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Part of</span>", "hiddenName": "parentHidden", "listeners": { "render": Lino.quicktip_renderer("Part of","(countries.Places.parent) The superordinate geographic place of which this place is a part.") }, "name": "parent", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,Lino.countries.Places.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/parent" }) }) });
    var zip_code2264 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(8), "fieldLabel": "zip code", "listeners": { "render": Lino.quicktip_renderer("zip code","(countries.Places.zip_code) ") }, "maxLength": 8, "name": "zip_code", "selectOnFocus": true });
    var id2265 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(countries.Places.id) ") }, "name": "id", "selectOnFocus": true });
    var main_2_panel2266 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 22, "items": type2262, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": parent2263, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code2264, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 11, "items": id2265, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var PlacesByPlace_grid2426 = new Lino.countries.PlacesByPlace.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Subdivisions","(countries.countries.PlacesByPlace) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.countries.PlacesByPlace.grid) ] });
    var contacts_PartnersByCity_grid2427 = new Lino.contacts.PartnersByCity.GridPanel({ "containing_panel": this, "flex": 41, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Partners","(contacts.contacts.PartnersByCity) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.PartnersByCity.grid) ] });
    var main_panel2428 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel2257, main_2_panel2266, PlacesByPlace_grid2426, contacts_PartnersByCity_grid2427 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel2428;
    this.before_row_edit = function(record) {
      type2262.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      PlacesByPlace_grid2426.on_master_changed();
      contacts_PartnersByCity_grid2427.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country2256.on('change',Lino.chooser_handler(type2262,'country'));
      Lino.countries.Places.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.countries.Places.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.vat.InvoicesByJournal.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 41,
  initComponent : function() {
    var partner611 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Partner</span>", "hiddenName": "partnerHidden", "listeners": { "render": Lino.quicktip_renderer("Partner","(vat.InvoicesByJournal.partner) Mandatory field to be defined in another class.") }, "name": "partner", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/partner" }) }) });
    var voucher_date612 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(vat.InvoicesByJournal.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var total_incl613 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Total incl. VAT</span>", "listeners": { "render": Lino.quicktip_renderer("Total incl. VAT","(vat.InvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.") }, "name": "total_incl", "selectOnFocus": true });
    var main_2_panel614 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 52, "items": voucher_date612, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 48, "items": total_incl613, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel617 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": partner611, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel614 ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel617;
    this.before_row_edit = function(record) {
    }
    Lino.vat.InvoicesByJournal.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Teachers.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 58,
  initComponent : function() {
    var overview_disp3314 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Description", "listeners": { "render": Lino.quicktip_renderer("Description","(courses.Teachers.overview) ") }, "name": "overview", "value": "<br/>" });
    var email3315 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(courses.Teachers.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var phone3316 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Phone</span>", "listeners": { "render": Lino.quicktip_renderer("Phone","(courses.Teachers.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.") }, "maxLength": 200, "name": "phone", "selectOnFocus": true });
    var gsm3317 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">GSM</span>", "listeners": { "render": Lino.quicktip_renderer("GSM","(courses.Teachers.gsm) The primary mobile phone number.") }, "maxLength": 200, "name": "gsm", "selectOnFocus": true });
    var contact_box_panel3318 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 37, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": email3315, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": phone3316, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": gsm3317, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "form" });
    var lists_MembersByPartner_grid3322 = new Lino.lists.MembersByPartner.GridPanel({ "containing_panel": this, "flex": 25, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("List memberships","(lists.lists.MembersByPartner) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.lists.MembersByPartner.grid) ] });
    var general_1_panel3323 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 37, "items": overview_disp3314, "labelAlign": "top", "layout": "form", "xtype": "panel" }, contact_box_panel3318, lists_MembersByPartner_grid3322 ], "labelAlign": "top", "labelWidth": 108, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var remarks3325 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remarks", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remarks","(courses.Teachers.remarks) ") }, "name": "remarks", "selectOnFocus": true });
    var plausibility_ProblemsByOwner_grid3326 = new Lino.plausibility.ProblemsByOwner.GridPanel({ "containing_panel": this, "flex": 37, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByOwner) Show data problems related to this database object.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByOwner.grid) ] });
    var bottom_box_1_panel3327 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 50, "frame": false, "hideCheckBoxLabels": true, "items": [ { "flex": 62, "items": remarks3325, "labelAlign": "top", "layout": "form", "xtype": "panel" }, plausibility_ProblemsByOwner_grid3326 ], "labelAlign": "top", "labelWidth": 72, "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var general_panel3329 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ general_1_panel3323, bottom_box_1_panel3327 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "General" });
    var last_name3330 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Last name</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(courses.Teachers.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var first_name3331 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">First name</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(courses.Teachers.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var gender3332 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gender</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Teachers.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var address_box_1_panel3333 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 46, "items": last_name3330, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": first_name3331, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": gender3332, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var street3337 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Street</span>", "listeners": { "render": Lino.quicktip_renderer("Street","(courses.Teachers.street) Name of street, without house number.") }, "maxLength": 200, "name": "street", "selectOnFocus": true });
    var street_box3338 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Box</span>", "listeners": { "render": Lino.quicktip_renderer("Box","(courses.Teachers.street_box) Text to print after street nuber on the same line.") }, "maxLength": 10, "name": "street_box", "selectOnFocus": true });
    var address_box_2_panel3339 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 69, "items": street3337, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": street_box3338, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var country3342 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Country...", "fieldLabel": "Country", "hiddenName": "countryHidden", "listeners": { "render": Lino.quicktip_renderer("Country","(courses.Teachers.country) ") }, "name": "country", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Countries.detail,Lino.countries.Countries.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/country" }) }) });
    var zip_code3343 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(10), "fieldLabel": "Zip code", "listeners": { "render": Lino.quicktip_renderer("Zip code","(courses.Teachers.zip_code) ") }, "maxLength": 10, "name": "zip_code", "selectOnFocus": true });
    var city3344 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Place...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">City</span>", "forceSelection": false, "hiddenName": "cityHidden", "listeners": { "render": Lino.quicktip_renderer("City","(courses.Teachers.city) A pointer to Place.") }, "name": "city", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.countries.Places.detail,Lino.countries.Places.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/city" }) }) });
    var address_box_3_panel3345 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 40, "items": country3342, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": zip_code3343, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 40, "items": city3344, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var birth_date3349 = new Lino.IncompleteDateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Birth date</span>", "listeners": { "render": Lino.quicktip_renderer("Birth date","(courses.Teachers.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".") }, "name": "birth_date", "selectOnFocus": true });
    var age_disp3350 = new Ext.form.DisplayField({ "always_enabled": true, "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "Age", "listeners": { "render": Lino.quicktip_renderer("Age","(courses.Teachers.age) ") }, "name": "age", "value": "<br/>" });
    var teacher_type3351 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Instructor Type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Instructor Type</span>", "hiddenName": "teacher_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Instructor Type","(courses.Teachers.teacher_type) Pointer to TeacherType.") }, "name": "teacher_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.TeacherTypes.detail,Lino.courses.TeacherTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/teacher_type" }) }) });
    var national_id3352 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">National ID</span>", "listeners": { "render": Lino.quicktip_renderer("National ID","(courses.Teachers.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.") }, "maxLength": 200, "name": "national_id", "selectOnFocus": true });
    var personal_panel3353 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "flex": 65, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 48, "items": teacher_type3351, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 51, "items": national_id3352, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 144, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_4_panel3356 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 19, "items": birth_date3349, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": age_disp3350, "labelAlign": "top", "layout": "form", "xtype": "panel" }, personal_panel3353 ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var address_box_panel3359 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_1_panel3333, address_box_2_panel3339, address_box_3_panel3345, address_box_4_panel3356 ], "labelAlign": "top", "layout": "form" });
    var contacts_RolesByPerson_grid3360 = new Lino.contacts.RolesByPerson.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Contact for","(contacts.contacts.RolesByPerson) Shows all roles of a person.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.contacts.RolesByPerson.grid) ] });
    var sepa_AccountsByPartner_grid3361 = new Lino.sepa.AccountsByPartner.GridPanel({ "containing_panel": this, "flex": 50, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Bank accounts","(sepa.sepa.AccountsByPartner) Show the bank account(s) defined for a given partner. To be\nincluded to a detail window on partner.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sepa.AccountsByPartner.grid) ] });
    var address_2_panel3362 = new Ext.Panel({ "autoScroll": false, "border": false, "flex": 45, "frame": false, "hideCheckBoxLabels": true, "items": [ contacts_RolesByPerson_grid3360, sepa_AccountsByPartner_grid3361 ], "labelAlign": "top", "layout": "hbox", "layoutConfig": { "align": "stretch" } });
    var address_panel3363 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ address_box_panel3359, address_2_panel3362 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Address" });
    var invoice_recipient3364 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Partner...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Invoicing address</span>", "hiddenName": "invoice_recipientHidden", "listeners": { "render": Lino.quicktip_renderer("Invoicing address","(courses.Teachers.invoice_recipient) Redirect to another partner all invoices which should go to this partner.") }, "name": "invoice_recipient", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.contacts.Partners.detail,Lino.contacts.Partners.insert)}, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/invoice_recipient" }) }) });
    var vat_regime3365 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">VAT regime</span>", "forceSelection": true, "hiddenName": "vat_regimeHidden", "listeners": { "render": Lino.quicktip_renderer("VAT regime","(courses.Teachers.vat_regime) The default VAT regime for         sales and purchases of this partner.") }, "name": "vat_regime", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var ledger_a_1_panel3366 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": invoice_recipient3364, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 57, "items": vat_regime3365, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var payment_term3369 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Payment Term...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Payment Term</span>", "hiddenName": "payment_termHidden", "listeners": { "render": Lino.quicktip_renderer("Payment Term","(courses.Teachers.payment_term) The default payment term for sales invoices to this customer.") }, "name": "payment_term", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.ledger.PaymentTerms.detail,Lino.ledger.PaymentTerms.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/payment_term" }) }) });
    var paper_type3370 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Paper type...", "fieldLabel": "Paper type", "hiddenName": "paper_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Paper type","(courses.Teachers.paper_type) ") }, "name": "paper_type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/paper_type" }) }) });
    var ledger_a_2_panel3371 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": payment_term3369, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": paper_type3370, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var ledger_a_panel3374 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "flex": 61, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_a_1_panel3366, ledger_a_2_panel3371 ], "labelAlign": "top", "layout": "form" });
    var MovementsByPartner_htmlbox3375 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 38, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(courses.Teachers.MovementsByPartner) Show the ledger movements of a partner.\nSee also lino_xl.lib.ledger.models.Movement.") }, "master_panel": this, "name": "MovementsByPartner", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByPartner.grid) ], "value": "<br/>" });
    var ledger_1_panel3376 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ ledger_a_panel3374, MovementsByPartner_htmlbox3375 ], "labelAlign": "top", "labelWidth": 90, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var sales_InvoicesByPartner_grid3377 = new Lino.sales.InvoicesByPartner.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Product invoices","(sales.sales.InvoicesByPartner) Base class for tables of partner vouchers.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.sales.InvoicesByPartner.grid) ] });
    var ledger_panel3378 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ ledger_1_panel3376, sales_InvoicesByPartner_grid3377 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "Ledger" });
    var id3379 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Teachers.id) ") }, "name": "id", "selectOnFocus": true });
    var language3380 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(courses.Teachers.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url3381 = new Lino.URLField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "URL", "listeners": { "render": Lino.quicktip_renderer("URL","(courses.Teachers.url) ") }, "maxLength": 200, "name": "url", "selectOnFocus": true });
    var more_1_panel3382 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 10, "items": id3379, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 43, "items": language3380, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 45, "items": url3381, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var addr13386 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line before street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line before street","(courses.Teachers.addr1) Address line before street") }, "maxLength": 200, "name": "addr1", "selectOnFocus": true });
    var addr23387 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Address line after street</span>", "listeners": { "render": Lino.quicktip_renderer("Address line after street","(courses.Teachers.addr2) Address line to print below street line.") }, "maxLength": 200, "name": "addr2", "selectOnFocus": true });
    var more_2_panel3388 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": addr13386, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": addr23387, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 243, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var notes_NotesByPerson_grid3391 = new Lino.notes.NotesByPerson.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByPerson) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByPerson.grid) ] });
    var more_panel3392 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ more_1_panel3382, more_2_panel3388, notes_NotesByPerson_grid3391 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" }, "listeners": { "activate": Lino.on_tab_activate }, "title": "More" });
    var courses_CoursesByTeacher_grid3448 = new Lino.courses.CoursesByTeacher.GridPanel({ "containing_panel": this, "flex": 5, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Activities","(courses.courses.CoursesByTeacher) Base table for all activities.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "center", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.courses.CoursesByTeacher.grid) ] });
    var courses_panel3449 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ courses_CoursesByTeacher_grid3448 ], "labelAlign": "top", "listeners": { "activate": Lino.on_tab_activate }, "title": "Activities" });
    var main_panel3450 = new Ext.TabPanel({ "activeTab": 0, "autoScroll": false, "bodyBorder": false, "border": false, "enableTabScroll": true, "frame": true, "hideCheckBoxLabels": true, "items": [ general_panel3329, address_panel3363, ledger_panel3378, more_panel3392, courses_panel3449 ], "labelAlign": "top", "split": true });
    this.items = main_panel3450;
    this.before_row_edit = function(record) {
      lists_MembersByPartner_grid3322.on_master_changed();
      plausibility_ProblemsByOwner_grid3326.on_master_changed();
      city3344.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city3344.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      contacts_RolesByPerson_grid3360.on_master_changed();
      sepa_AccountsByPartner_grid3361.on_master_changed();
      MovementsByPartner_htmlbox3375.refresh();
      sales_InvoicesByPartner_grid3377.on_master_changed();
      notes_NotesByPerson_grid3391.on_master_changed();
      courses_CoursesByTeacher_grid3448.on_master_changed();
    }
    this.onRender = function(ct, position) {
      country3342.on('change',Lino.chooser_handler(city3344,'country'));
      Lino.courses.Teachers.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.courses.Teachers.DetailFormPanel.superclass.initComponent.call(this);
    // active_fields:
    city3344.on("change", function(){ this.save() }, this);
    zip_code3343.on("change", function(){ this.save() }, this);
  }
});


Lino.accounts.Accounts.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 33,
  initComponent : function() {
    var ref3742 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Reference</span>", "listeners": { "render": Lino.quicktip_renderer("Reference","(accounts.Accounts.ref) An optional unique name which can be used to reference a given\naccount.") }, "maxLength": 40, "name": "ref", "selectOnFocus": true });
    var group3743 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Account Group...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Account Group</span>", "hiddenName": "groupHidden", "listeners": { "render": Lino.quicktip_renderer("Account Group","(accounts.Accounts.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.") }, "name": "group", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.accounts.Groups.detail,Lino.accounts.Groups.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/Accounts/group" }) }) });
    var type3744 = new Lino.ChoicesFieldElement({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Account Type</span>", "forceSelection": true, "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Accounts.type) The account type of this account.  This points to an item of\nAccountTypes.") }, "name": "type", "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var id3745 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(accounts.Accounts.id) ") }, "name": "id", "selectOnFocus": true });
    var main_1_panel3746 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": ref3742, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 32, "items": group3743, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": type3744, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 8, "items": id3745, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 126, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var name3751 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Accounts.name) The multilingual designation of this account, as the users see\nit.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3752 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Accounts.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3753 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Accounts.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel3754 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3751, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3752, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3753, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var needs_partner3758 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Needs partner", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Needs partner","(accounts.Accounts.needs_partner) Whether bookings to this account need a partner specified.") }, "name": "needs_partner", "selectOnFocus": true });
    var clearable3759 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Clearable", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Clearable","(accounts.Accounts.clearable) ") }, "name": "clearable", "selectOnFocus": true });
    var default_amount3760 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Default amount</span>", "listeners": { "render": Lino.quicktip_renderer("Default amount","(accounts.Accounts.default_amount) The default amount to book in bank statements or journal\nentries when this account has been selected manually. The\ndefault booking direction is that of the type.") }, "name": "default_amount", "selectOnFocus": true });
    var main_3_panel3761 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 42, "items": needs_partner3758, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 42, "items": clearable3759, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 14, "items": default_amount3760, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var MovementsByAccount_htmlbox3765 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "flex": 50, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer("Movements","(accounts.Accounts.MovementsByAccount) Shows the movements done on a given general account.") }, "master_panel": this, "name": "MovementsByAccount", "title": "Movements", "tools": [ Lino.show_in_own_window_button(Lino.ledger.MovementsByAccount.grid) ], "value": "<br/>" });
    var main_panel3766 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3746, main_2_panel3754, main_3_panel3761, MovementsByAccount_htmlbox3765 ], "labelAlign": "top", "labelWidth": 90, "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3766;
    this.before_row_edit = function(record) {
      MovementsByAccount_htmlbox3765.refresh();
    }
    Lino.accounts.Accounts.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.accounts.Groups.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 34,
  initComponent : function() {
    var name3767 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Groups.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3768 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Groups.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3769 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Groups.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3770 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3767, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3768, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3769, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var account_type3774 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Account Type", "forceSelection": true, "hiddenName": "account_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Groups.account_type) ") }, "name": "account_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.accounts.AccountTypes) });
    var ref3775 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ref", "listeners": { "render": Lino.quicktip_renderer("ref","(accounts.Groups.ref) ") }, "maxLength": 20, "name": "ref", "selectOnFocus": true });
    var main_2_panel3776 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 43, "items": account_type3774, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 56, "items": ref3775, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3779 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3770, main_2_panel3776 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel3779;
    this.before_row_edit = function(record) {
    }
    Lino.accounts.Groups.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.products.Products.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 31,
  initComponent : function() {
    var cat3729 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff Category...", "fieldLabel": "Category", "hiddenName": "catHidden", "listeners": { "render": Lino.quicktip_renderer("Category","(products.Products.cat) ") }, "name": "cat", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.ProductCats.detail,Lino.products.ProductCats.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/cat" }) }) });
    var name3730 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(products.Products.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3731 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(products.Products.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3732 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(products.Products.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_2_panel3733 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3730, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3731, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3732, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3737 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": cat3729, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel3733 ], "labelAlign": "top", "labelWidth": 81, "layout": "form" });
    this.items = main_panel3737;
    this.before_row_edit = function(record) {
    }
    Lino.products.Products.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.accounts.Groups.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 34,
  initComponent : function() {
    var ref3780 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ref", "listeners": { "render": Lino.quicktip_renderer("ref","(accounts.Groups.ref) ") }, "maxLength": 20, "name": "ref", "selectOnFocus": true });
    var name3781 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(accounts.Groups.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3782 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(accounts.Groups.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3783 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(accounts.Groups.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3784 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 25, "items": ref3780, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name3781, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_de3782, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 25, "items": name_fr3783, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var account_type3789 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Account Type", "forceSelection": true, "hiddenName": "account_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Account Type","(accounts.Groups.account_type) ") }, "name": "account_type", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.accounts.AccountTypes) });
    var id3790 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(accounts.Groups.id) ") }, "name": "id", "selectOnFocus": true });
    var main_2_panel3791 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 76, "items": account_type3789, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 23, "items": id3790, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var AccountsByGroup_grid3814 = new Lino.accounts.AccountsByGroup.GridPanel({ "containing_panel": this, "flex": 71, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Accounts","(accounts.accounts.AccountsByGroup) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.accounts.AccountsByGroup.grid) ] });
    var main_panel3815 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3784, main_2_panel3791, AccountsByGroup_grid3814 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3815;
    this.before_row_edit = function(record) {
      AccountsByGroup_grid3814.on_master_changed();
    }
    Lino.accounts.Groups.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Companies.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 7,
  initComponent : function() {
    var name3816 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Companies.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var language3817 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Companies.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var email3818 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Companies.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var main_2_panel3819 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": language3817, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 66, "items": email3818, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var type3822 = new Lino.RemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Organization type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Organization type</span>", "hiddenName": "typeHidden", "listeners": { "render": Lino.quicktip_renderer("Organization type","(contacts.Companies.type) Pointer to the CompanyType.") }, "name": "type", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/type" }) }) });
    var id3823 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(contacts.Companies.id) ") }, "name": "id", "selectOnFocus": true });
    var main_3_panel3824 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 80, "items": type3822, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": id3823, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 162, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel3827 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": name3816, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel3819, main_3_panel3824 ], "labelAlign": "top", "labelWidth": 45, "layout": "form" });
    this.items = main_panel3827;
    this.before_row_edit = function(record) {
    }
    Lino.contacts.Companies.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.excerpts.ExcerptTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 75,
  initComponent : function() {
    var id3829 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(excerpts.ExcerptTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3830 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Designation</span>", "listeners": { "render": Lino.quicktip_renderer("Designation","(excerpts.ExcerptTypes.name) The designation of this excerpt type.\nOne field for every language.") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3831 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(excerpts.ExcerptTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3832 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(excerpts.ExcerptTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3833 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3829, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3830, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3831, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3832, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var content_type3838 = new Lino.TwinCombo({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "emptyText": "Select a content type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Model</span>", "hiddenName": "content_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Model","(excerpts.ExcerptTypes.content_type) The model that can issue printouts of this type.") }, "name": "content_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.gfks.ContentTypes.detail,Lino.gfks.ContentTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/content_type" }) }) });
    var build_method3839 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Build method</span>", "forceSelection": true, "hiddenName": "build_methodHidden", "listeners": { "render": Lino.quicktip_renderer("Build method","(excerpts.ExcerptTypes.build_method) See lino.modlib.printing.mixins.PrintableType.build_method.") }, "name": "build_method", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var template3840 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Template</span>", "listeners": { "render": Lino.quicktip_renderer("Template","(excerpts.ExcerptTypes.template) The main template to be used when printing an excerpt of this type.") }, "name": "template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/template" }) }) });
    var body_template3841 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Body template</span>", "listeners": { "render": Lino.quicktip_renderer("Body template","(excerpts.ExcerptTypes.body_template) The body template to be used when         rendering a printable of this type. This is a list of files         with extension `.body.html`.") }, "name": "body_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/body_template" }) }) });
    var email_template3842 = new Lino.SimpleRemoteComboFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Email template</span>", "listeners": { "render": Lino.quicktip_renderer("Email template","(excerpts.ExcerptTypes.email_template) The name of the file to be used as template when creating an email from a mailable of this type.") }, "name": "email_template", "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptTypes/email_template" }) }) });
    var shortcut3843 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Excerpt shortcut</span>", "listeners": { "render": Lino.quicktip_renderer("Excerpt shortcut","(excerpts.ExcerptTypes.shortcut) Optional pointer to a shortcut field.  If this is not empty, then\nthe given shortcut field will manage excerpts of this type.") }, "maxLength": 50, "name": "shortcut", "selectOnFocus": true });
    var main_2_panel3844 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 15, "items": content_type3838, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": build_method3839, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": template3840, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": body_template3841, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 15, "items": email_template3842, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 21, "items": shortcut3843, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var primary3851 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Primary", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Primary","(excerpts.ExcerptTypes.primary) Whether this is the default type to use for this model. There's at most one primary type per model. Enabling this field will automatically make the other types non-primary.") }, "name": "primary", "selectOnFocus": true });
    var print_directly3852 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Print directly", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Print directly","(excerpts.ExcerptTypes.print_directly) ") }, "name": "print_directly", "selectOnFocus": true });
    var certifying3853 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Certifying", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Certifying","(excerpts.ExcerptTypes.certifying) Whether an excerpt of this type is a unique printout.") }, "name": "certifying", "selectOnFocus": true });
    var print_recipient3854 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Print recipient", "checked": true, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Print recipient","(excerpts.ExcerptTypes.print_recipient) Whether to print a recipient field in document.") }, "name": "print_recipient", "selectOnFocus": true });
    var backward_compat3855 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Backward compatible", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Backward compatible","(excerpts.ExcerptTypes.backward_compat) Check this to have `this` in template context point to owner instead of excerpt.") }, "name": "backward_compat", "selectOnFocus": true });
    var attach_to_email3856 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Attach to email", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Attach to email","(excerpts.ExcerptTypes.attach_to_email) Whether the printable file should be attached to the email\nwhen creating an email from a mailable of this type.\n") }, "name": "attach_to_email", "selectOnFocus": true });
    var main_3_panel3857 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 16, "items": primary3851, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": print_directly3852, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": certifying3853, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": print_recipient3854, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": backward_compat3855, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 16, "items": attach_to_email3856, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 180, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var excerpts_ExcerptsByType_grid3882 = new Lino.excerpts.ExcerptsByType.GridPanel({ "containing_panel": this, "flex": 62, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Excerpts","(excerpts.excerpts.ExcerptsByType) Base class for all tables on Excerpt.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.excerpts.ExcerptsByType.grid) ] });
    var main_panel3883 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3833, main_2_panel3844, main_3_panel3857, excerpts_ExcerptsByType_grid3882 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3883;
    this.before_row_edit = function(record) {
      template3840.setContextValue('build_method', record ? record.data['build_methodHidden'] : undefined);
      template3840.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      body_template3841.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      email_template3842.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
      excerpts_ExcerptsByType_grid3882.on_master_changed();
    }
    this.onRender = function(ct, position) {
      build_method3839.on('change',Lino.chooser_handler(template3840,'build_method'));
      content_type3838.on('change',Lino.chooser_handler(template3840,'content_type'));
      content_type3838.on('change',Lino.chooser_handler(body_template3841,'content_type'));
      content_type3838.on('change',Lino.chooser_handler(email_template3842,'content_type'));
      Lino.excerpts.ExcerptTypes.DetailFormPanel.superclass.onRender.call(this, ct, position);
    }
    Lino.excerpts.ExcerptTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.contacts.Partners.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 10,
  initComponent : function() {
    var name2416 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Name</span>", "listeners": { "render": Lino.quicktip_renderer("Name","(contacts.Partners.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var language2417 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(contacts.Partners.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var email2418 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">e-mail address</span>", "listeners": { "render": Lino.quicktip_renderer("e-mail address","(contacts.Partners.email) The primary email address.") }, "maxLength": 254, "name": "email", "selectOnFocus": true });
    var main_2_panel2419 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 48, "items": language2417, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 51, "items": email2418, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 135, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel2422 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": name2416, "labelAlign": "top", "layout": "form", "xtype": "panel" }, main_2_panel2419 ], "labelAlign": "top", "labelWidth": 45, "layout": "form" });
    this.items = main_panel2422;
    this.before_row_edit = function(record) {
    }
    Lino.contacts.Partners.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.notes.EventTypes.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  content_type: 68,
  initComponent : function() {
    var id3884 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(notes.EventTypes.id) ") }, "name": "id", "selectOnFocus": true });
    var name3885 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(notes.EventTypes.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3886 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(notes.EventTypes.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3887 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(notes.EventTypes.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3888 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 7, "items": id3884, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name3885, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_de3886, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 30, "items": name_fr3887, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" }, "region": "north", "split": true });
    var remark3893 = new Ext.form.TextArea({ "anchor": "-20 -10", "fieldLabel": "Remark", "growMax": 2000, "listeners": { "render": Lino.quicktip_renderer("Remark","(notes.EventTypes.remark) ") }, "name": "remark", "selectOnFocus": true });
    var notes_NotesByEventType_grid3915 = new Lino.notes.NotesByEventType.GridPanel({ "containing_panel": this, "flex": 6, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Notes","(notes.notes.NotesByEventType) ") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "region": "south", "split": true, "tools": [ Lino.show_in_own_window_button(Lino.notes.NotesByEventType.grid) ] });
    var main_panel3916 = new Lino.VBorderPanel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3888, { "flex": 3, "items": remark3893, "labelAlign": "top", "layout": "form", "region": "center", "split": true, "xtype": "panel" }, notes_NotesByEventType_grid3915 ], "labelAlign": "top", "labelWidth": 63 });
    this.items = main_panel3916;
    this.before_row_edit = function(record) {
      notes_NotesByEventType_grid3915.on_master_changed();
    }
    Lino.notes.EventTypes.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.plausibility.Checkers.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var value3918 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "value", "listeners": { "render": Lino.quicktip_renderer("value","(plausibility.Checkers.value) ") }, "maxLength": 20, "name": "value" });
    var text3919 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "disabled": true, "fieldLabel": "text", "listeners": { "render": Lino.quicktip_renderer("text","(plausibility.Checkers.text) ") }, "maxLength": 50, "name": "text" });
    var main_1_panel3920 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": value3918, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": text3919, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 54, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var plausibility_ProblemsByChecker_grid3934 = new Lino.plausibility.ProblemsByChecker.GridPanel({ "containing_panel": this, "flex": 83, "hide_top_toolbar": true, "listeners": { "render": Lino.quicktip_renderer("Plausibility problems","(plausibility.plausibility.ProblemsByChecker) Show the plausibility problems by checker.") }, "master_panel": this, "params_panel_hidden": true, "preview_limit": 15, "tools": [ Lino.show_in_own_window_button(Lino.plausibility.ProblemsByChecker.grid) ] });
    var main_panel3935 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3920, plausibility_ProblemsByChecker_grid3934 ], "labelAlign": "top", "layout": "vbox", "layoutConfig": { "align": "stretch" } });
    this.items = main_panel3935;
    this.before_row_edit = function(record) {
      plausibility_ProblemsByChecker_grid3934.on_master_changed();
    }
    Lino.plausibility.Checkers.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.finan.BankStatements.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 61,
  initComponent : function() {
    var voucher_date749 = new Lino.DateField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Voucher date</span>", "listeners": { "render": Lino.quicktip_renderer("Voucher date","(finan.BankStatements.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.") }, "name": "voucher_date", "selectOnFocus": true });
    var balance1750 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Old balance</span>", "listeners": { "render": Lino.quicktip_renderer("Old balance","(finan.BankStatements.balance1) The old (or start) balance.") }, "name": "balance1", "selectOnFocus": true, "value": 0 });
    var main_panel751 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ { "anchor": "-20", "autoHeight": true, "items": voucher_date749, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "anchor": "-20", "autoHeight": true, "items": balance1750, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 117, "layout": "form" });
    this.items = main_panel751;
    this.before_row_edit = function(record) {
    }
    Lino.finan.BankStatements.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.cal.Calendars.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 27,
  initComponent : function() {
    var name3936 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(cal.Calendars.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3937 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(cal.Calendars.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3938 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(cal.Calendars.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3939 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3936, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3937, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3938, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var color3943 = new Ext.form.NumberField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "color", "listeners": { "render": Lino.quicktip_renderer("color","(cal.Calendars.color) ") }, "name": "color", "selectOnFocus": true });
    var main_panel3944 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3939, { "anchor": "-20", "autoHeight": true, "items": color3943, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 54, "layout": "form" });
    this.items = main_panel3944;
    this.before_row_edit = function(record) {
    }
    Lino.cal.Calendars.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.sales.InvoiceItems.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 44,
  initComponent : function() {
    var product497 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Tariff...", "fieldLabel": "Tariff", "hiddenName": "productHidden", "listeners": { "render": Lino.quicktip_renderer("Tariff","(sales.InvoiceItems.product) ") }, "name": "product", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.products.Products.detail,Lino.products.Products.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoiceItems/product" }) }) });
    var discount498 = new Ext.form.NumberField({ "allowBlank": true, "anchor": "-20", "autoHeight": true, "decimalPrecision": 2, "decimalSeparator": ",", "fieldLabel": "Discount", "listeners": { "render": Lino.quicktip_renderer("Discount","(sales.InvoiceItems.discount) ") }, "name": "discount", "selectOnFocus": true });
    var qty499 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "boxMinWidth": Lino.chars2width(6), "fieldLabel": "Quantity", "listeners": { "render": Lino.quicktip_renderer("Quantity","(sales.InvoiceItems.qty) ") }, "maxLength": 6, "name": "qty", "selectOnFocus": true });
    var main_1_panel500 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 58, "items": product497, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": discount498, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 20, "items": qty499, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var title504 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Heading</span>", "listeners": { "render": Lino.quicktip_renderer("Heading","(sales.InvoiceItems.title) The title of this voucher.") }, "maxLength": 200, "name": "title", "selectOnFocus": true });
    var main_panel505 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel500, { "anchor": "-20", "autoHeight": true, "items": title504, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 72, "layout": "form" });
    this.items = main_panel505;
    this.before_row_edit = function(record) {
    }
    Lino.sales.InvoiceItems.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.ledger.Situation.DetailFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  disable_editing: true,
  initComponent : function() {
    var body_htmlbox3946 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "listeners": { "render": Lino.quicktip_renderer(null,"(ledger.Situation.body) ") }, "name": "body", "value": "<br/>" });
    var main_panel3947 = new Ext.Panel({ "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ body_htmlbox3946 ], "labelAlign": "top", "labelWidth": 0, "layout": "fit" });
    this.items = main_panel3947;
    this.before_row_edit = function(record) {
      body_htmlbox3946.refresh();
    }
    Lino.ledger.Situation.DetailFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Topics.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 54,
  initComponent : function() {
    var name3948 = new Ext.form.TextField({ "allowBlank": false, "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation", "listeners": { "render": Lino.quicktip_renderer("Designation","(courses.Topics.name) ") }, "maxLength": 200, "name": "name", "selectOnFocus": true });
    var name_de3949 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (de)", "listeners": { "render": Lino.quicktip_renderer("Designation (de)","(courses.Topics.name_de) ") }, "maxLength": 200, "name": "name_de", "selectOnFocus": true });
    var name_fr3950 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Designation (fr)", "listeners": { "render": Lino.quicktip_renderer("Designation (fr)","(courses.Topics.name_fr) ") }, "maxLength": 200, "name": "name_fr", "selectOnFocus": true });
    var main_1_panel3951 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": name3948, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_de3949, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": name_fr3950, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var id3955 = new Ext.form.NumberField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "ID", "listeners": { "render": Lino.quicktip_renderer("ID","(courses.Topics.id) ") }, "name": "id", "selectOnFocus": true });
    var main_panel3956 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel3951, { "anchor": "-20", "autoHeight": true, "items": id3955, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 27, "layout": "form" });
    this.items = main_panel3956;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Topics.InsertFormPanel.superclass.initComponent.call(this);
  }
});


Lino.courses.Pupils.InsertFormPanel = Ext.extend(Lino.FormPanel,{
  layout: 'fit',
  auto_save: true,
  autoHeight: true,
  content_type: 56,
  initComponent : function() {
    var first_name1942 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">First name</span>", "listeners": { "render": Lino.quicktip_renderer("First name","(courses.Pupils.first_name) The first name, also known as given name.") }, "maxLength": 200, "name": "first_name", "selectOnFocus": true });
    var last_name1943 = new Ext.form.TextField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Last name</span>", "listeners": { "render": Lino.quicktip_renderer("Last name","(courses.Pupils.last_name) The last name, also known as family name.") }, "maxLength": 200, "name": "last_name", "selectOnFocus": true });
    var main_1_panel1944 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 50, "items": first_name1942, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 50, "items": last_name1943, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 99, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var gender1947 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Gender</span>", "forceSelection": true, "hiddenName": "genderHidden", "listeners": { "render": Lino.quicktip_renderer("Gender","(courses.Pupils.gender) The sex of this person (male or female).") }, "name": "gender", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var language1948 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Language</span>", "hiddenName": "languageHidden", "listeners": { "render": Lino.quicktip_renderer("Language","(courses.Pupils.language) The language to use when communicating with this partner.") }, "name": "language", "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var main_2_panel1949 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 31, "items": gender1947, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 68, "items": language1948, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 81, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var pupil_type1952 = new Lino.TwinCombo({ "anchor": "-20", "autoHeight": true, "emptyText": "Select a Participant Type...", "fieldLabel": "<span style=\"border-bottom: 1px dotted #000000;\">Participant Type</span>", "hiddenName": "pupil_typeHidden", "listeners": { "render": Lino.quicktip_renderer("Participant Type","(courses.Pupils.pupil_type) Pointer to PupilType.") }, "name": "pupil_type", "onTrigger2Click": function(e){ Lino.show_fk_detail(this,Lino.courses.PupilTypes.detail,Lino.courses.PupilTypes.insert)}, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/pupil_type" }) }) });
    var section1953 = new Lino.ChoicesFieldElement({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Section", "forceSelection": true, "hiddenName": "sectionHidden", "listeners": { "render": Lino.quicktip_renderer("Section","(courses.Pupils.section) ") }, "name": "section", "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var member_until1954 = new Lino.DateField({ "anchor": "-20", "autoHeight": true, "fieldLabel": "Mitglied bis", "listeners": { "render": Lino.quicktip_renderer("Mitglied bis","(courses.Pupils.member_until) ") }, "name": "member_until", "selectOnFocus": true });
    var main_3_panel1955 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 43, "items": pupil_type1952, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": section1953, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 28, "items": member_until1954, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 153, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var is_lfv1959 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "LFV", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("LFV","(courses.Pupils.is_lfv) ") }, "name": "is_lfv", "selectOnFocus": true });
    var is_ckk1960 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "CKK", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("CKK","(courses.Pupils.is_ckk) ") }, "name": "is_ckk", "selectOnFocus": true });
    var is_raviva1961 = new Ext.form.Checkbox({ "anchor": "-20", "autoHeight": true, "boxLabel": "Raviva", "checked": false, "hideLabel": true, "listeners": { "render": Lino.quicktip_renderer("Raviva","(courses.Pupils.is_raviva) ") }, "name": "is_raviva", "selectOnFocus": true });
    var main_4_panel1962 = new Ext.Panel({ "anchor": "-20", "autoHeight": true, "autoScroll": false, "border": false, "frame": false, "hideCheckBoxLabels": true, "items": [ { "autoHeight": true, "flex": 33, "items": is_lfv1959, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": is_ckk1960, "labelAlign": "top", "layout": "form", "xtype": "panel" }, { "autoHeight": true, "flex": 33, "items": is_raviva1961, "labelAlign": "top", "layout": "form", "xtype": "panel" } ], "labelAlign": "top", "labelWidth": 63, "layout": "hbox", "layoutConfig": { "align": "stretchmax" } });
    var main_panel1966 = new Ext.Panel({ "autoHeight": true, "autoScroll": false, "bodyBorder": false, "border": false, "frame": true, "hideCheckBoxLabels": true, "items": [ main_1_panel1944, main_2_panel1949, main_3_panel1955, main_4_panel1962 ], "labelAlign": "top", "layout": "form" });
    this.items = main_panel1966;
    this.before_row_edit = function(record) {
    }
    Lino.courses.Pupils.InsertFormPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.merge_row = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Companies.merge_row_ActionFormPanel({});
});
Lino.users.Users.change_password = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.Users.change_password_ActionFormPanel({});
});
Lino.courses.Activities.print_presence_sheet_html = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Activities.print_presence_sheet_html_ActionFormPanel({});
});
Lino.courses.Activities.print_presence_sheet = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Activities.print_presence_sheet_ActionFormPanel({});
});
Lino.courses.Pupils.merge_row = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Pupils.merge_row_ActionFormPanel({});
});

// js_render_GridPanel_class system.SiteConfigs
Lino.system.SiteConfigs.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/system/SiteConfigs",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/SiteConfigs','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/SiteConfigs','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/system/SiteConfigs','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/SiteConfigs','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/SiteConfigs','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": true, "itemId": "do_build", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Rebuild the site cache.\nThis action is available on About.") }, "menu_item_text": "Rebuild site cache", "overflowText": "Rebuild site cache", "panel_btn_handler": Lino.row_action_handler('do_build','GET',null), "text": "Rebuild site cache" } ],
  cell_edit : true,
  title : "Site configurations",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 37,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "default_build_method" }, 'default_build_methodHidden', { "dateFormat": "d.m.Y", "name": "simulate_today", "type": "date" }, { "name": "site_company" }, 'site_companyHidden', { "name": "next_partner_id", "type": "int", "useNull": true }, { "name": "default_event_type" }, 'default_event_typeHidden', { "name": "site_calendar" }, 'site_calendarHidden', { "name": "max_auto_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "hide_events_before", "type": "date" }, { "name": "pupil_guestrole" }, 'pupil_guestroleHidden', { "name": "system_note_type" }, 'system_note_typeHidden', { "name": "clients_account" }, 'clients_accountHidden', { "name": "sales_vat_account" }, 'sales_vat_accountHidden', { "name": "sales_account" }, 'sales_accountHidden', { "name": "suppliers_account" }, 'suppliers_accountHidden', { "name": "purchases_vat_account" }, 'purchases_vat_accountHidden', { "name": "purchases_account" }, 'purchases_accountHidden', { "name": "wages_account" }, 'wages_accountHidden', { "name": "clearings_account" }, 'clearings_accountHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 1,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.system.SiteConfigs.detail;
    var ww = this.containing_window;
    var id3958 = new Ext.form.NumberField({ "selectOnFocus": true });
    var default_build_method3959 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var simulate_today3960 = new Lino.DateField({ "selectOnFocus": true });
    var site_company3961 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_company" }) }) });
    var next_partner_id3962 = new Ext.form.NumberField({ "selectOnFocus": true, "value": 100 });
    var default_event_type3963 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/default_event_type" }) }) });
    var site_calendar3964 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/site_calendar" }) }) });
    var max_auto_events3965 = new Ext.form.NumberField({ "selectOnFocus": true, "value": 72 });
    var hide_events_before3966 = new Lino.DateField({ "selectOnFocus": true });
    var pupil_guestrole3967 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/pupil_guestrole" }) }) });
    var system_note_type3968 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/system_note_type" }) }) });
    var clients_account3969 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/clients_account" }) }) });
    var sales_vat_account3970 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/sales_vat_account" }) }) });
    var sales_account3971 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/sales_account" }) }) });
    var suppliers_account3972 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/suppliers_account" }) }) });
    var purchases_vat_account3973 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/purchases_vat_account" }) }) });
    var purchases_account3974 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/purchases_account" }) }) });
    var wages_account3975 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/wages_account" }) }) });
    var clearings_account3976 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/system/SiteConfigs/clearings_account" }) }) });
    var workflow_buttons_disp3977 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3978 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3979 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id3958, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(system.SiteConfigs.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "default_build_method", "editable": true, "editor": default_build_method3959, "filter": { "type": "string" }, "header": "Default build method", "sortable": false, "tooltip": "(system.SiteConfigs.default_build_method) The default build method to use when rendering printable documents.", "width": Lino.chars2width(24) }, { "colIndex": 2, "dataIndex": "simulate_today", "editable": true, "editor": simulate_today3960, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Simulated date", "sortable": true, "tooltip": "(system.SiteConfigs.simulate_today) A constant user-defined date to be substituted as current\nsystem date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "site_company", "editable": true, "editor": site_company3961, "filter": { "type": "string" }, "header": "Site owner", "renderer": Lino.fk_renderer('site_companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.site_company) The organisation who runs this site.  This is used e.g. when\nprinting your address in certain documents or reports.  Or\nnewly created partners inherit the country of the site owner.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "next_partner_id", "editable": true, "editor": next_partner_id3962, "filter": { "type": "numeric" }, "format": "0", "header": "Next partner id", "sortable": true, "tooltip": "(system.SiteConfigs.next_partner_id) The next automatic id for any new partner.", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "default_event_type", "editable": true, "editor": default_event_type3963, "filter": { "type": "string" }, "header": "Default Event Type", "sortable": false, "tooltip": "(system.SiteConfigs.default_event_type) The default type of events on this site.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "site_calendar", "editable": true, "editor": site_calendar3964, "filter": { "type": "string" }, "header": "Site Calendar", "sortable": false, "tooltip": "(system.SiteConfigs.site_calendar) The default calendar of this site.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "max_auto_events", "editable": true, "editor": max_auto_events3965, "filter": { "type": "numeric" }, "format": "0", "header": "Max automatic events", "sortable": true, "tooltip": "(system.SiteConfigs.max_auto_events) Maximum number of automatic events to be generated.", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "hide_events_before", "editable": true, "editor": hide_events_before3966, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Hide events before", "sortable": true, "tooltip": "(system.SiteConfigs.hide_events_before) If this is specified, certain tables show only \nevents after the given date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "pupil_guestrole", "editable": true, "editor": pupil_guestrole3967, "filter": { "type": "string" }, "header": "Guest role for pupils", "renderer": Lino.fk_renderer('pupil_guestroleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(system.SiteConfigs.pupil_guestrole) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "system_note_type", "editable": true, "editor": system_note_type3968, "filter": { "type": "string" }, "header": "Default system note type", "sortable": false, "tooltip": "(system.SiteConfigs.system_note_type) Note Type used by system notes.\nIf this is empty, then system notes won't create any entry to the Notes table.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "clients_account", "editable": true, "editor": clients_account3969, "filter": { "type": "string" }, "header": "Clients account", "sortable": false, "tooltip": "(system.SiteConfigs.clients_account) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "sales_vat_account", "editable": true, "editor": sales_vat_account3970, "filter": { "type": "string" }, "header": "Sales VAT account", "sortable": false, "tooltip": "(system.SiteConfigs.sales_vat_account) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "sales_account", "editable": true, "editor": sales_account3971, "filter": { "type": "string" }, "header": "Sales Base account", "sortable": false, "tooltip": "(system.SiteConfigs.sales_account) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "suppliers_account", "editable": true, "editor": suppliers_account3972, "filter": { "type": "string" }, "header": "Suppliers account", "sortable": false, "tooltip": "(system.SiteConfigs.suppliers_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "purchases_vat_account", "editable": true, "editor": purchases_vat_account3973, "filter": { "type": "string" }, "header": "Purchases VAT account", "sortable": false, "tooltip": "(system.SiteConfigs.purchases_vat_account) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "purchases_account", "editable": true, "editor": purchases_account3974, "filter": { "type": "string" }, "header": "Purchases Base account", "sortable": false, "tooltip": "(system.SiteConfigs.purchases_account) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "wages_account", "editable": true, "editor": wages_account3975, "filter": { "type": "string" }, "header": "Wages account", "sortable": false, "tooltip": "(system.SiteConfigs.wages_account) ", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "clearings_account", "editable": true, "editor": clearings_account3976, "filter": { "type": "string" }, "header": "Clearings account", "sortable": false, "tooltip": "(system.SiteConfigs.clearings_account) ", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(system.SiteConfigs.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(system.SiteConfigs.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(system.SiteConfigs.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.system.SiteConfigs.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.SiteConfigs.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.system.SiteConfigs.detailPanel = Ext.extend(Lino.system.SiteConfigs.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "do_build", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Rebuild the site cache.\nThis action is available on About.") }, "menu_item_text": "Rebuild site cache", "overflowText": "Rebuild site cache", "panel_btn_handler": Lino.row_action_handler('do_build','GET',null), "text": "Rebuild site cache" } ],
  ls_url: "/system/SiteConfigs",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.system.SiteConfigs.detail;
    Lino.system.SiteConfigs.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.system.SiteConfigs.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.system.SiteConfigs.detailPanel(p);
});
Lino.system.SiteConfigs.grid = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.system.SiteConfigs.GridPanel(p);
});
Lino.system.SiteConfigs.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.SiteConfigs.do_build = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/SiteConfigs", "GET", pk, "do_build", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.Countries
Lino.countries.Countries.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/Countries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/Countries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Countries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 10,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "isocode" }, { "name": "short_code" }, { "name": "iso3" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 4,
  ls_id_property : "isocode",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Countries.detail;
    this.ls_insert_handler = Lino.countries.Countries.insert;
    var ww = this.containing_window;
    var name3981 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3982 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3983 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var isocode3984 = new Ext.form.TextField({ "allowBlank": false, "boxMinWidth": Lino.chars2width(4), "maxLength": 4, "selectOnFocus": true });
    var short_code3985 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(4), "hidden": true, "maxLength": 4, "selectOnFocus": true });
    var iso33986 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(3), "hidden": true, "maxLength": 3, "selectOnFocus": true });
    var workflow_buttons_disp3987 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3988 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3989 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name3981, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(countries.Countries.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de3982, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(countries.Countries.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr3983, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(countries.Countries.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "isocode", "editable": true, "editor": isocode3984, "filter": { "type": "string" }, "header": "ISO code", "sortable": true, "tooltip": "(countries.Countries.isocode)         The two-letter code for this country as defined by ISO 3166-1.\n        For countries that no longer exist it may be a 4-letter code.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "short_code", "editable": true, "editor": short_code3985, "filter": { "type": "string" }, "header": "Short code", "hidden": true, "sortable": true, "tooltip": "(countries.Countries.short_code) A short abbreviation for regional usage. Obsolete.", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "iso3", "editable": true, "editor": iso33986, "filter": { "type": "string" }, "header": "ISO-3 code", "hidden": true, "sortable": true, "tooltip": "(countries.Countries.iso3) The three-letter code for this country as defined by ISO 3166-1.", "width": Lino.chars2width(5) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(countries.Countries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.Countries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.Countries.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.countries.Countries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Countries.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Countries.insertPanel = Ext.extend(Lino.countries.Countries.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/countries/Countries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Countries.detail;
    this.ls_insert_handler = Lino.countries.Countries.insert;
    Lino.countries.Countries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Countries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.countries.Countries.insertPanel(p);
});
Lino.countries.Countries.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Countries.detailPanel = Ext.extend(Lino.countries.Countries.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/countries/Countries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Countries.detail;
    this.ls_insert_handler = Lino.countries.Countries.insert;
    Lino.countries.Countries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Countries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Countries.detailPanel(p);
});
Lino.countries.Countries.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Countries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Countries.GridPanel(p);
});
Lino.countries.Countries.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Countries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.Places
Lino.countries.Places.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/Places",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/Places','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/Places','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/countries/Places','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/Places','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/Places','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Places",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 16,
  ls_store_fields : [ { "name": "country" }, 'countryHidden', { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "type" }, 'typeHidden', { "name": "zip_code" }, { "name": "parent" }, 'parentHidden', { "name": "id", "type": "int" }, { "name": "children_summary" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 5,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Places.detail;
    this.ls_insert_handler = Lino.countries.Places.insert;
    var ww = this.containing_window;
    var country3991 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Country...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/country" }) }) });
    var name3992 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3993 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3994 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var type3995 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/type" }) }) });
    var zip_code3996 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(8), "maxLength": 8, "selectOnFocus": true });
    var parent3997 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/Places/parent" }) }) });
    var id3998 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var children_summary_disp3999 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4000 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4001 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4002 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type3995.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country3991.on('change',Lino.chooser_handler(type3995,'country'));
      Lino.countries.Places.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "country", "editable": true, "editor": country3991, "filter": { "type": "string" }, "header": "Country", "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(countries.Places.country) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3992, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(countries.Places.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3993, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(countries.Places.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3994, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(countries.Places.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "type", "editable": true, "editor": type3995, "filter": { "type": "string" }, "header": "Place Type", "sortable": false, "tooltip": "(countries.Places.type) ", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "zip_code", "editable": true, "editor": zip_code3996, "filter": { "type": "string" }, "header": "zip code", "sortable": true, "tooltip": "(countries.Places.zip_code) ", "width": Lino.chars2width(10) }, { "colIndex": 6, "dataIndex": "parent", "editable": true, "editor": parent3997, "filter": { "type": "string" }, "header": "Part of", "renderer": Lino.fk_renderer('parentHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(countries.Places.parent) The superordinate geographic place of which this place is a part.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id3998, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(countries.Places.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "children_summary", "editable": false, "header": "Children", "hidden": true, "sortable": false, "tooltip": "(countries.Places.children_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(countries.Places.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.Places.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.Places.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.countries.Places.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Places.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Places.insertPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/countries/Places",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Places.detail;
    this.ls_insert_handler = Lino.countries.Places.insert;
    Lino.countries.Places.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Places.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.countries.Places.insertPanel(p);
});
Lino.countries.Places.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.Places.detailPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/countries/Places",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.Places.detail;
    this.ls_insert_handler = Lino.countries.Places.insert;
    Lino.countries.Places.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.Places.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Places.detailPanel(p);
});
Lino.countries.Places.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.Places.GridPanel(p);
});
Lino.countries.Places.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.Places.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/Places", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.Partners
Lino.contacts.Partners.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Partners",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Partners','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  cell_edit : true,
  title : "Partners",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 39,
  ls_store_fields : [ { "name": "name" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mti_navigator" }, { "name": "address_column" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 37,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Partners.detail;
    this.ls_insert_handler = Lino.contacts.Partners.insert;
    var ww = this.containing_window;
    var name4004 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var email4005 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var language4006 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url4007 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone4008 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm4009 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax4010 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country4011 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/country" }) }) });
    var city4012 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/city" }) }) });
    var zip_code4013 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region4014 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/region" }) }) });
    var addr14015 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix4016 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street4017 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no4018 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box4019 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr24020 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4021 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term4022 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/payment_term" }) }) });
    var vat_regime4023 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient4024 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/invoice_recipient" }) }) });
    var paper_type4025 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Partners/paper_type" }) }) });
    var debit_balance4026 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp4027 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4028 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4029 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4030 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp4031 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var address_column_disp4032 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var id4033 = new Ext.form.NumberField({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
      city4012.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city4012.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region4014.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country4011.on('change',Lino.chooser_handler(city4012,'country'));
      region4014.on('change',Lino.chooser_handler(city4012,'region'));
      country4011.on('change',Lino.chooser_handler(region4014,'country'));
      Lino.contacts.Partners.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name4004, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(contacts.Partners.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "email", "editable": true, "editor": email4005, "filter": { "type": "string" }, "header": "e-mail address", "sortable": true, "tooltip": "(contacts.Partners.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "language", "editable": true, "editor": language4006, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "url", "editable": true, "editor": url4007, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.url) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "phone", "editable": true, "editor": phone4008, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "gsm", "editable": true, "editor": gsm4009, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "fax", "editable": true, "editor": fax4010, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "country", "editable": true, "editor": country4011, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Partners.country) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "city", "editable": true, "editor": city4012, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Partners.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "zip_code", "editable": true, "editor": zip_code4013, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 10, "dataIndex": "region", "editable": true, "editor": region4014, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Partners.region) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "addr1", "editable": true, "editor": addr14015, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix4016, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "street", "editable": true, "editor": street4017, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_no", "editable": true, "editor": street_no4018, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 15, "dataIndex": "street_box", "editable": true, "editor": street_box4019, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 16, "dataIndex": "addr2", "editable": true, "editor": addr24020, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(contacts.Partners.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "remarks", "editable": true, "editor": remarks4021, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "payment_term", "editable": true, "editor": payment_term4022, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4023, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 20, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient4024, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.Partners.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "paper_type", "editable": true, "editor": paper_type4025, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 22, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 23, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "address_column", "editable": false, "header": "Address", "hidden": true, "sortable": false, "tooltip": "(contacts.Partners.address_column) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 29, "dataIndex": "id", "editable": true, "editor": id4033, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Partners.id) ", "width": Lino.chars2width(6) } ];
    Lino.contacts.Partners.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Partners.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Partners.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/contacts/Partners",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Partners.detail;
    this.ls_insert_handler = Lino.contacts.Partners.insert;
    Lino.contacts.Partners.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Partners.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Partners.insertPanel(p);
});
Lino.contacts.Partners.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Partners.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  ls_url: "/contacts/Partners",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Partners.detail;
    this.ls_insert_handler = Lino.contacts.Partners.insert;
    Lino.contacts.Partners.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Partners.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Partners.detailPanel(p);
});
Lino.contacts.Partners.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.Partners.GridPanel(p);
});
Lino.contacts.Partners.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Partners.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Partners", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.Persons
Lino.contacts.Persons.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Persons",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Persons','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Persons",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 62,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "email" }, { "name": "phone" }, { "name": "gsm" }, { "name": "id", "type": "int" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "eid_info" }, { "name": "image" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Persons.detail;
    this.ls_insert_handler = Lino.contacts.Persons.insert;
    var ww = this.containing_window;
    var name_column_disp4035 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp4036 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var email4037 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var phone4038 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var gsm4039 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4040 = new Ext.form.NumberField({ "selectOnFocus": true });
    var language4041 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url4042 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax4043 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country4044 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/country" }) }) });
    var city4045 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/city" }) }) });
    var zip_code4046 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region4047 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/region" }) }) });
    var addr14048 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix4049 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street4050 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no4051 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box4052 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr24053 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name4054 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4055 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term4056 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/payment_term" }) }) });
    var vat_regime4057 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient4058 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/invoice_recipient" }) }) });
    var paper_type4059 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/paper_type" }) }) });
    var title4060 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name4061 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name4062 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name4063 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender4064 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date4065 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id4066 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country4067 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/birth_country" }) }) });
    var birth_place4068 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality4069 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Persons/nationality" }) }) });
    var card_number4070 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from4071 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until4072 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type4073 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer4074 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition4075 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var workflow_buttons_disp4076 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4077 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4078 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp4079 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp4080 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance4081 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var eid_info_disp4082 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var image_htmlbox4083 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    this.before_row_edit = function(record) {
      city4045.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city4045.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region4047.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox4083.refresh();
    };
    this.onRender = function(ct, position) {
      country4044.on('change',Lino.chooser_handler(city4045,'country'));
      region4047.on('change',Lino.chooser_handler(city4045,'region'));
      country4044.on('change',Lino.chooser_handler(region4047,'country'));
      Lino.contacts.Persons.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(contacts.Persons.name_column) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(contacts.Persons.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "email", "editable": true, "editor": email4037, "filter": { "type": "string" }, "header": "e-mail address", "sortable": true, "tooltip": "(contacts.Persons.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "phone", "editable": true, "editor": phone4038, "filter": { "type": "string" }, "header": "Phone", "sortable": true, "tooltip": "(contacts.Persons.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "gsm", "editable": true, "editor": gsm4039, "filter": { "type": "string" }, "header": "GSM", "sortable": true, "tooltip": "(contacts.Persons.gsm) The primary mobile phone number.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4040, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Persons.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language4041, "filter": { "type": "string" }, "header": "Language", "sortable": false, "tooltip": "(contacts.Persons.language) The language to use when communicating with this partner.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "url", "editable": true, "editor": url4042, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.url) ", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax4043, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country4044, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Persons.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "city", "editable": true, "editor": city4045, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Persons.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code4046, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region4047, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Persons.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr14048, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix4049, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street", "editable": true, "editor": street4050, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_no", "editable": true, "editor": street_no4051, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "street_box", "editable": true, "editor": street_box4052, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "addr2", "editable": true, "editor": addr24053, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "name", "editable": true, "editor": name4054, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "remarks", "editable": true, "editor": remarks4055, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 21, "dataIndex": "payment_term", "editable": true, "editor": payment_term4056, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4057, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 23, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient4058, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.Persons.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "paper_type", "editable": true, "editor": paper_type4059, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "title", "editable": true, "editor": title4060, "filter": { "type": "string" }, "header": "Title", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.title) An optional name prefix like \"Dr.\" or \"PhD\", used to specify a\nprofessional position or academic qualification.", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "first_name", "editable": true, "editor": first_name4061, "filter": { "type": "string" }, "header": "First name", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 27, "dataIndex": "middle_name", "editable": true, "editor": middle_name4062, "filter": { "type": "string" }, "header": "Middle name", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "last_name", "editable": true, "editor": last_name4063, "filter": { "type": "string" }, "header": "Last name", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 29, "dataIndex": "gender", "editable": true, "editor": gender4064, "filter": { "type": "string" }, "header": "Gender", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 30, "dataIndex": "birth_date", "editable": true, "editor": birth_date4065, "filter": { "type": "string" }, "header": "Birth date", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 31, "dataIndex": "national_id", "editable": true, "editor": national_id4066, "filter": { "type": "string" }, "header": "National ID", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "birth_country", "editable": true, "editor": birth_country4067, "filter": { "type": "string" }, "header": "Birth country", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Persons.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "birth_place", "editable": true, "editor": birth_place4068, "filter": { "type": "string" }, "header": "Birth place", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 34, "dataIndex": "nationality", "editable": true, "editor": nationality4069, "filter": { "type": "string" }, "header": "Nationality", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Persons.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "card_number", "editable": true, "editor": card_number4070, "filter": { "type": "string" }, "header": "eID card number", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 36, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from4071, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID card valid from", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 37, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until4072, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "until", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 38, "dataIndex": "card_type", "editable": true, "editor": card_type4073, "filter": { "type": "string" }, "header": "eID card type", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.card_type) ", "width": Lino.chars2width(25) }, { "colIndex": 39, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer4074, "filter": { "type": "string" }, "header": "eID card issuer", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.card_issuer) The administration who issued this ID card.", "width": Lino.chars2width(22) }, { "colIndex": 40, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition4075, "filter": { "type": "string" }, "header": "noble condition", "hidden": true, "sortable": true, "tooltip": "(contacts.Persons.noble_condition) The eventual noble condition of this person.", "width": Lino.chars2width(22) }, { "colIndex": 41, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 42, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 43, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "age", "editable": false, "header": "Age", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.age) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 47, "dataIndex": "eid_info", "editable": false, "header": "eID card", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.eid_info) ", "width": Lino.chars2width(31) }, { "colIndex": 48, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(contacts.Persons.image) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.Persons.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Persons.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Persons.insertPanel = Ext.extend(Lino.contacts.Persons.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/contacts/Persons",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Persons.detail;
    this.ls_insert_handler = Lino.contacts.Persons.insert;
    Lino.contacts.Persons.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Persons.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Persons.insertPanel(p);
});
Lino.contacts.Persons.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Persons.detailPanel = Ext.extend(Lino.contacts.Persons.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/contacts/Persons",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Persons.detail;
    this.ls_insert_handler = Lino.contacts.Persons.insert;
    Lino.contacts.Persons.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Persons.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Persons.detailPanel(p);
});
Lino.contacts.Persons.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.Persons.GridPanel(p);
});
Lino.contacts.Persons.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.read_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Persons.find_by_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Persons", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.CompanyTypes
Lino.contacts.CompanyTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/CompanyTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/CompanyTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Organization types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 11,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "abbr" }, { "name": "abbr_de" }, { "name": "abbr_fr" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 11,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var name4085 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de4086 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr4087 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4088 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var abbr4089 = new Ext.form.TextField({ "hidden": true, "maxLength": 30, "selectOnFocus": true });
    var abbr_de4090 = new Ext.form.TextField({ "hidden": true, "maxLength": 30, "selectOnFocus": true });
    var abbr_fr4091 = new Ext.form.TextField({ "hidden": true, "maxLength": 30, "selectOnFocus": true });
    var workflow_buttons_disp4092 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4093 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4094 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name4085, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(contacts.CompanyTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de4086, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(contacts.CompanyTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr4087, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(contacts.CompanyTypes.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id4088, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "abbr", "editable": true, "editor": abbr4089, "filter": { "type": "string" }, "header": "Abbreviation", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.abbr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "abbr_de", "editable": true, "editor": abbr_de4090, "filter": { "type": "string" }, "header": "Abbreviation (de)", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.abbr_de) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "abbr_fr", "editable": true, "editor": abbr_fr4091, "filter": { "type": "string" }, "header": "Abbreviation (fr)", "hidden": true, "sortable": true, "tooltip": "(contacts.CompanyTypes.abbr_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.CompanyTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.CompanyTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.CompanyTypes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.CompanyTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.CompanyTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/CompanyTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.CompanyTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.CompanyTypes.GridPanel(p);
});

// js_render_GridPanel_class contacts.Companies
Lino.contacts.Companies.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Companies",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Companies','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Merge", "overflowText": "Merge", "panel_btn_handler": Lino.param_action_handler(Lino.contacts.Companies.merge_row), "tooltip": "Merge this object into another object of same class." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  cell_edit : true,
  title : "Organizations",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 43,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "email" }, { "name": "phone" }, { "name": "gsm" }, { "name": "id", "type": "int" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "prefix" }, { "name": "type" }, 'typeHidden', { "name": "vat_id" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Companies.detail;
    this.ls_insert_handler = Lino.contacts.Companies.insert;
    var ww = this.containing_window;
    var name_column_disp4096 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp4097 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var email4098 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var phone4099 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var gsm4100 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4101 = new Ext.form.NumberField({ "selectOnFocus": true });
    var language4102 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url4103 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax4104 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country4105 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/country" }) }) });
    var city4106 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/city" }) }) });
    var zip_code4107 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region4108 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/region" }) }) });
    var addr14109 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix4110 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street4111 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no4112 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box4113 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr24114 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name4115 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks4116 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term4117 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/payment_term" }) }) });
    var vat_regime4118 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient4119 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/invoice_recipient" }) }) });
    var paper_type4120 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/paper_type" }) }) });
    var prefix4121 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var type4122 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Companies/type" }) }) });
    var vat_id4123 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4124 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4125 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4126 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp4127 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance4128 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      city4106.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city4106.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region4108.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country4105.on('change',Lino.chooser_handler(city4106,'country'));
      region4108.on('change',Lino.chooser_handler(city4106,'region'));
      country4105.on('change',Lino.chooser_handler(region4108,'country'));
      Lino.contacts.Companies.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(contacts.Companies.name_column) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(contacts.Companies.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "email", "editable": true, "editor": email4098, "filter": { "type": "string" }, "header": "e-mail address", "sortable": true, "tooltip": "(contacts.Companies.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "phone", "editable": true, "editor": phone4099, "filter": { "type": "string" }, "header": "Phone", "sortable": true, "tooltip": "(contacts.Companies.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "gsm", "editable": true, "editor": gsm4100, "filter": { "type": "string" }, "header": "GSM", "sortable": true, "tooltip": "(contacts.Companies.gsm) The primary mobile phone number.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4101, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Companies.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language4102, "filter": { "type": "string" }, "header": "Language", "sortable": false, "tooltip": "(contacts.Companies.language) The language to use when communicating with this partner.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "url", "editable": true, "editor": url4103, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.url) ", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax4104, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country4105, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.Companies.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "city", "editable": true, "editor": city4106, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Companies.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code4107, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region4108, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.Companies.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr14109, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix4110, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street", "editable": true, "editor": street4111, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_no", "editable": true, "editor": street_no4112, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "street_box", "editable": true, "editor": street_box4113, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "addr2", "editable": true, "editor": addr24114, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "name", "editable": true, "editor": name4115, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "remarks", "editable": true, "editor": remarks4116, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 21, "dataIndex": "payment_term", "editable": true, "editor": payment_term4117, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4118, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 23, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient4119, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.Companies.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "paper_type", "editable": true, "editor": paper_type4120, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "prefix", "editable": true, "editor": prefix4121, "filter": { "type": "string" }, "header": "Name prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.prefix) ", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "type", "editable": true, "editor": type4122, "filter": { "type": "string" }, "header": "Organization type", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.type) Pointer to the CompanyType.", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "vat_id", "editable": true, "editor": vat_id4123, "filter": { "type": "string" }, "header": "VAT id", "hidden": true, "sortable": true, "tooltip": "(contacts.Companies.vat_id) ", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 32, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.Companies.debit_balance) ", "width": Lino.chars2width(13) } ];
    Lino.contacts.Companies.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Companies.insertPanel = Ext.extend(Lino.contacts.Companies.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/contacts/Companies",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Companies.detail;
    this.ls_insert_handler = Lino.contacts.Companies.insert;
    Lino.contacts.Companies.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.Companies.insertPanel(p);
});
Lino.contacts.Companies.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.Companies.detailPanel = Ext.extend(Lino.contacts.Companies.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Merge", "overflowText": "Merge", "panel_btn_handler": Lino.param_action_handler(Lino.contacts.Companies.merge_row), "tooltip": "Merge this object into another object of same class." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  ls_url: "/contacts/Companies",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.Companies.detail;
    this.ls_insert_handler = Lino.contacts.Companies.insert;
    Lino.contacts.Companies.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Companies.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Companies.detailPanel(p);
});
Lino.contacts.Companies.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.Companies.GridPanel(p);
});
Lino.contacts.Companies.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Companies.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Companies", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.RoleTypes
Lino.contacts.RoleTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/RoleTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/RoleTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Functions",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 6,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id4130 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name4131 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de4132 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr4133 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4134 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4135 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4136 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4130, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.RoleTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name4131, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(contacts.RoleTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de4132, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(contacts.RoleTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr4133, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(contacts.RoleTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.RoleTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.RoleTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.RoleTypes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.RoleTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.RoleTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RoleTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RoleTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.RoleTypes.GridPanel(p);
});

// js_render_GridPanel_class contacts.Roles
Lino.contacts.Roles.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/Roles",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/Roles','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Contact Persons",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 11,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "type" }, 'typeHidden', { "name": "person" }, 'personHidden', { "name": "company" }, 'companyHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 9,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id4138 = new Ext.form.NumberField({ "selectOnFocus": true });
    var type4139 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Roles/type" }) }) });
    var person4140 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Person...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Roles/person" }) }) });
    var company4141 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Organization...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/Roles/company" }) }) });
    var workflow_buttons_disp4142 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4143 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4144 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4138, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(contacts.Roles.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type4139, "filter": { "type": "string" }, "header": "Contact Role", "sortable": false, "tooltip": "(contacts.Roles.type) The role of this person in this company.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "person", "editable": true, "editor": person4140, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(contacts.Roles.person) The person having this role in this company.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "company", "editable": true, "editor": company4141, "filter": { "type": "string" }, "header": "Organization", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(contacts.Roles.company) The company where this person has a role.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.Roles.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Roles.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.Roles.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.Roles.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.Roles.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/Roles", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.Roles.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.Roles.GridPanel(p);
});

// js_render_GridPanel_class lists.ListTypes
Lino.lists.ListTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/ListTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/ListTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "List Types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 12,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var name4146 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de4147 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr4148 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4149 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp4150 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4151 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4152 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name4146, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(lists.ListTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de4147, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(lists.ListTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr4148, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(lists.ListTypes.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id4149, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.ListTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(lists.ListTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.ListTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.ListTypes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.lists.ListTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.ListTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/ListTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.ListTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.ListTypes.GridPanel(p);
});

// js_render_GridPanel_class lists.Lists
Lino.lists.Lists.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/Lists",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/Lists','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Partner Lists",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "list_type" }, 'list_typeHidden', { "name": "id", "type": "int" }, { "name": "remarks" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 14,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.lists.Lists.detail;
    this.ls_insert_handler = Lino.lists.Lists.insert;
    var ww = this.containing_window;
    var ref4154 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name4155 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de4156 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr4157 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var list_type4158 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a List Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Lists/list_type" }) }) });
    var id4159 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var remarks4160 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp4161 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4162 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4163 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref4154, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(lists.Lists.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name4155, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(lists.Lists.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de4156, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(lists.Lists.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr4157, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(lists.Lists.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "list_type", "editable": true, "editor": list_type4158, "filter": { "type": "string" }, "header": "List Type", "sortable": false, "tooltip": "(lists.Lists.list_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4159, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.Lists.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "remarks", "editable": true, "editor": remarks4160, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.Lists.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.lists.Lists.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Lists.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.lists.Lists.insertPanel = Ext.extend(Lino.lists.Lists.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/lists/Lists",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.lists.Lists.detail;
    this.ls_insert_handler = Lino.lists.Lists.insert;
    Lino.lists.Lists.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Lists.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(12), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.lists.Lists.insertPanel(p);
});
Lino.lists.Lists.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.lists.Lists.detailPanel = Ext.extend(Lino.lists.Lists.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/lists/Lists",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.lists.Lists.detail;
    this.ls_insert_handler = Lino.lists.Lists.insert;
    Lino.lists.Lists.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Lists.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.Lists.detailPanel(p);
});
Lino.lists.Lists.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Lists.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.Lists.GridPanel(p);
});
Lino.lists.Lists.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Lists", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class lists.Members
Lino.lists.Members.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/Members",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/Members','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/Members','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/lists/Members','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/Members','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/Members','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "List memberships",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "list" }, 'listHidden', { "name": "partner" }, 'partnerHidden', { "name": "remark" }, { "name": "move_buttons" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id4165 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno4166 = new Ext.form.NumberField({ "selectOnFocus": true });
    var list4167 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner List...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Members/list" }) }) });
    var partner4168 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/Members/partner" }) }) });
    var remark4169 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var move_buttons_disp4170 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4171 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4172 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4173 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4165, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(lists.Members.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno4166, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(lists.Members.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "list", "editable": true, "editor": list4167, "filter": { "type": "string" }, "header": "Partner List", "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.Members.list) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4168, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.Members.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark4169, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(lists.Members.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(lists.Members.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(lists.Members.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.Members.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.Members.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.lists.Members.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.Members.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.Members.GridPanel(p);
});
Lino.lists.Members.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.Members.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/Members", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class lists.AllMembers
Lino.lists.AllMembers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/AllMembers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/AllMembers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "List memberships",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "list" }, 'listHidden', { "name": "partner" }, 'partnerHidden', { "name": "remark" }, { "name": "move_buttons" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id4175 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno4176 = new Ext.form.NumberField({ "selectOnFocus": true });
    var list4177 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner List...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/AllMembers/list" }) }) });
    var partner4178 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/AllMembers/partner" }) }) });
    var remark4179 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var move_buttons_disp4180 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4181 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4182 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4183 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4175, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(lists.AllMembers.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno4176, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(lists.AllMembers.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "list", "editable": true, "editor": list4177, "filter": { "type": "string" }, "header": "Partner List", "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.AllMembers.list) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4178, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.AllMembers.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark4179, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(lists.AllMembers.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.AllMembers.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.lists.AllMembers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.AllMembers.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.AllMembers.GridPanel(p);
});
Lino.lists.AllMembers.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.AllMembers.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/AllMembers", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class gfks.ContentTypes
Lino.gfks.ContentTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/gfks/ContentTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/ContentTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "content types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "app_label" }, { "name": "model" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 15,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.gfks.ContentTypes.detail;
    this.ls_insert_handler = Lino.gfks.ContentTypes.insert;
    var ww = this.containing_window;
    var id4185 = new Ext.form.NumberField({ "selectOnFocus": true });
    var app_label4186 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 100, "selectOnFocus": true });
    var model4187 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 100, "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4185, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(gfks.ContentTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "app_label", "editable": true, "editor": app_label4186, "filter": { "type": "string" }, "header": "app label", "sortable": true, "tooltip": "(gfks.ContentTypes.app_label) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "model", "editable": true, "editor": model4187, "filter": { "type": "string" }, "header": "python model class name", "sortable": true, "tooltip": "(gfks.ContentTypes.model) ", "width": Lino.chars2width(22) } ];
    Lino.gfks.ContentTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.ContentTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.gfks.ContentTypes.insertPanel = Ext.extend(Lino.gfks.ContentTypes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/gfks/ContentTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.gfks.ContentTypes.detail;
    this.ls_insert_handler = Lino.gfks.ContentTypes.insert;
    Lino.gfks.ContentTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.ContentTypes.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.gfks.ContentTypes.insertPanel(p);
});
Lino.gfks.ContentTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.gfks.ContentTypes.detailPanel = Ext.extend(Lino.gfks.ContentTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/gfks/ContentTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.gfks.ContentTypes.detail;
    this.ls_insert_handler = Lino.gfks.ContentTypes.insert;
    Lino.gfks.ContentTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.ContentTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.ContentTypes.detailPanel(p);
});
Lino.gfks.ContentTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.ContentTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.ContentTypes.GridPanel(p);
});
Lino.gfks.ContentTypes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/ContentTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class gfks.HelpTexts
Lino.gfks.HelpTexts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/gfks/HelpTexts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTexts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Help Texts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "field" }, { "name": "verbose_name" }, { "name": "help_text" }, { "name": "id", "type": "int" }, { "name": "content_type" }, 'content_typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 16,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var field4189 = new Lino.SimpleRemoteComboFieldElement({ "allowBlank": false, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTexts/field" }) }) });
    var verbose_name4190 = new Ext.form.TextField({ "disabled": true, "maxLength": 200 });
    var help_text4191 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var id4192 = new Ext.form.NumberField({ "selectOnFocus": true });
    var content_type4193 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a content type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTexts/content_type" }) }) });
    this.before_row_edit = function(record) {
      field4189.setContextValue('content_type', record ? record.data['content_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      content_type4193.on('change',Lino.chooser_handler(field4189,'content_type'));
      Lino.gfks.HelpTexts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "field", "editable": true, "editor": field4189, "filter": { "type": "string" }, "header": "Field", "sortable": false, "tooltip": "(gfks.HelpTexts.field) ", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "verbose_name", "editable": false, "header": "Verbose name", "sortable": false, "tooltip": "(gfks.HelpTexts.verbose_name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "help_text", "editable": true, "editor": help_text4191, "filter": { "type": "string" }, "header": "HelpText", "sortable": false, "tooltip": "(gfks.HelpTexts.help_text) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id4192, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(gfks.HelpTexts.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "content_type", "editable": true, "editor": content_type4193, "filter": { "type": "string" }, "header": "Model", "renderer": Lino.fk_renderer('content_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(gfks.HelpTexts.content_type) ", "width": Lino.chars2width(21) } ];
    Lino.gfks.HelpTexts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.HelpTexts.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTexts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTexts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.HelpTexts.GridPanel(p);
});

// js_render_GridPanel_class plausibility.Problems
Lino.plausibility.Problems.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/plausibility/Problems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/Problems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Plausibility problems",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 14,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Problems.detail;
    var ww = this.containing_window;
    var user4195 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/user" }) }) });
    var owner_disp4196 = new Ext.form.DisplayField({ "disabled": true });
    var message4197 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker4198 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id4199 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type4200 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/owner_type" }) }) });
    var owner_id4201 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/Problems/owner_id" }) }) });
    var workflow_buttons_disp4202 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4203 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4204 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type4200.on('change',Lino.chooser_handler(owner_id4201,'owner_type'));
      Lino.plausibility.Problems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user4195, "filter": { "type": "string" }, "header": "Responsible", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.Problems.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(plausibility.Problems.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message4197, "filter": { "type": "string" }, "header": "Message", "sortable": true, "tooltip": "(plausibility.Problems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 3, "dataIndex": "checker", "editable": true, "editor": checker4198, "filter": { "type": "string" }, "header": "Plausibility checker", "sortable": false, "tooltip": "(plausibility.Problems.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4199, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.Problems.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type4200, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.Problems.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id4201, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.Problems.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.plausibility.Problems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Problems.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.Problems.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/Problems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Problems.detail;
    Lino.plausibility.Problems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Problems.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.Problems.detailPanel(p);
});
Lino.plausibility.Problems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.Problems.GridPanel(p);
});
Lino.plausibility.Problems.update_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Problems.fix_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Problems", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.AllProblems
Lino.plausibility.AllProblems.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/plausibility/AllProblems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/AllProblems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Plausibility problems",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 14,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.AllProblems.detail;
    var ww = this.containing_window;
    var user4206 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/AllProblems/user" }) }) });
    var owner_disp4207 = new Ext.form.DisplayField({ "disabled": true });
    var message4208 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker4209 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id4210 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type4211 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/AllProblems/owner_type" }) }) });
    var owner_id4212 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/AllProblems/owner_id" }) }) });
    var workflow_buttons_disp4213 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4214 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4215 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type4211.on('change',Lino.chooser_handler(owner_id4212,'owner_type'));
      Lino.plausibility.AllProblems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user4206, "filter": { "type": "string" }, "header": "Responsible", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.AllProblems.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(plausibility.AllProblems.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message4208, "filter": { "type": "string" }, "header": "Message", "sortable": true, "tooltip": "(plausibility.AllProblems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 3, "dataIndex": "checker", "editable": true, "editor": checker4209, "filter": { "type": "string" }, "header": "Plausibility checker", "sortable": false, "tooltip": "(plausibility.AllProblems.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4210, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.AllProblems.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type4211, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.AllProblems.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id4212, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.AllProblems.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.plausibility.AllProblems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.AllProblems.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.AllProblems.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/AllProblems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.AllProblems.detail;
    Lino.plausibility.AllProblems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.AllProblems.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.AllProblems.detailPanel(p);
});
Lino.plausibility.AllProblems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.AllProblems.GridPanel(p);
});
Lino.plausibility.AllProblems.update_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.AllProblems.fix_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/AllProblems", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.MyProblems
Lino.plausibility.MyProblems.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/plausibility/MyProblems",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/MyProblems','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Plausibility problems assigned to me",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 14,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.MyProblems.detail;
    var ww = this.containing_window;
    var user4217 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/MyProblems/user" }) }) });
    var owner_disp4218 = new Ext.form.DisplayField({ "disabled": true });
    var message4219 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker4220 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var id4221 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type4222 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/MyProblems/owner_type" }) }) });
    var owner_id4223 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/MyProblems/owner_id" }) }) });
    var workflow_buttons_disp4224 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4225 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4226 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type4222.on('change',Lino.chooser_handler(owner_id4223,'owner_type'));
      Lino.plausibility.MyProblems.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user4217, "filter": { "type": "string" }, "header": "Responsible", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.MyProblems.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(plausibility.MyProblems.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message4219, "filter": { "type": "string" }, "header": "Message", "sortable": true, "tooltip": "(plausibility.MyProblems.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 3, "dataIndex": "checker", "editable": true, "editor": checker4220, "filter": { "type": "string" }, "header": "Plausibility checker", "sortable": false, "tooltip": "(plausibility.MyProblems.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4221, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.MyProblems.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type4222, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.MyProblems.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id4223, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.MyProblems.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.plausibility.MyProblems.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.MyProblems.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.MyProblems.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/MyProblems",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.MyProblems.detail;
    Lino.plausibility.MyProblems.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.MyProblems.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.MyProblems.detailPanel(p);
});
Lino.plausibility.MyProblems.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.MyProblems.GridPanel(p);
});
Lino.plausibility.MyProblems.update_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.MyProblems.fix_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/MyProblems", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyTasks
Lino.cal.MyTasks.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyTasks",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyTasks','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "My tasks",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyTasks.detail;
    this.ls_insert_handler = Lino.cal.MyTasks.insert;
    var ww = this.containing_window;
    var start_date4304 = new Lino.DateField({ "selectOnFocus": true });
    var summary4305 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4306 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date4304, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(cal.MyTasks.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary4305, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.MyTasks.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyTasks.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.MyTasks.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyTasks.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyTasks.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyTasks",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyTasks.detail;
    this.ls_insert_handler = Lino.cal.MyTasks.insert;
    Lino.cal.MyTasks.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyTasks.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyTasks.insertPanel(p);
});
Lino.cal.MyTasks.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyTasks.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/MyTasks",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyTasks.detail;
    this.ls_insert_handler = Lino.cal.MyTasks.insert;
    Lino.cal.MyTasks.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyTasks.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyTasks.detailPanel(p);
});
Lino.cal.MyTasks.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.MyTasks.GridPanel(p);
});
Lino.cal.MyTasks.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyTasks.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyTasks", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestRoles
Lino.cal.GuestRoles.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestRoles",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestRoles','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Guest Roles",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 26,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestRoles.detail;
    this.ls_insert_handler = Lino.cal.GuestRoles.insert;
    var ww = this.containing_window;
    var id4308 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name4309 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de4310 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr4311 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4312 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4313 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4314 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4308, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.GuestRoles.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name4309, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(cal.GuestRoles.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de4310, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(cal.GuestRoles.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr4311, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(cal.GuestRoles.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(cal.GuestRoles.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.GuestRoles.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.GuestRoles.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestRoles.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestRoles.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestRoles.insertPanel = Ext.extend(Lino.cal.GuestRoles.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/GuestRoles",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestRoles.detail;
    this.ls_insert_handler = Lino.cal.GuestRoles.insert;
    Lino.cal.GuestRoles.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestRoles.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestRoles.insertPanel(p);
});
Lino.cal.GuestRoles.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestRoles.detailPanel = Ext.extend(Lino.cal.GuestRoles.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/GuestRoles",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestRoles.detail;
    this.ls_insert_handler = Lino.cal.GuestRoles.insert;
    Lino.cal.GuestRoles.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestRoles.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestRoles.detailPanel(p);
});
Lino.cal.GuestRoles.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestRoles.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestRoles.GridPanel(p);
});
Lino.cal.GuestRoles.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestRoles", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.Guests
Lino.cal.Guests.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/Guests",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Guests','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Presences",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 15,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "event" }, 'eventHidden', { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Guests.detail;
    this.ls_insert_handler = Lino.cal.Guests.insert;
    var ww = this.containing_window;
    var partner4316 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/partner" }) }) });
    var role4317 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/role" }) }) });
    var workflow_buttons_disp4318 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4319 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event4320 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar entry...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/Guests/event" }) }) });
    var id4321 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4322 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp4323 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4324 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4325 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner4316, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(cal.Guests.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role4317, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.Guests.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.Guests.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark4319, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(cal.Guests.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "event", "editable": true, "editor": event4320, "filter": { "type": "string" }, "header": "Calendar entry", "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.Guests.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4321, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.Guests.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "state", "editable": true, "editor": state4322, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "event_summary", "editable": false, "header": "Event", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.Guests.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Guests.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Guests.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Guests.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/Guests",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Guests.detail;
    this.ls_insert_handler = Lino.cal.Guests.insert;
    Lino.cal.Guests.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Guests.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.Guests.insertPanel(p);
});
Lino.cal.Guests.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.Guests.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/Guests",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.Guests.detail;
    this.ls_insert_handler = Lino.cal.Guests.insert;
    Lino.cal.Guests.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Guests.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Guests.detailPanel(p);
});
Lino.cal.Guests.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.Guests.GridPanel(p);
});
Lino.cal.Guests.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Guests.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Guests", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.AllGuests
Lino.cal.AllGuests.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/AllGuests",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AllGuests','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Presences",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 15,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "event" }, 'eventHidden', { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllGuests.detail;
    this.ls_insert_handler = Lino.cal.AllGuests.insert;
    var ww = this.containing_window;
    var partner4327 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllGuests/partner" }) }) });
    var role4328 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllGuests/role" }) }) });
    var workflow_buttons_disp4329 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4330 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event4331 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar entry...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllGuests/event" }) }) });
    var id4332 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state4333 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp4334 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4335 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4336 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner4327, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(cal.AllGuests.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role4328, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.AllGuests.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.AllGuests.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark4330, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(cal.AllGuests.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "event", "editable": true, "editor": event4331, "filter": { "type": "string" }, "header": "Calendar entry", "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.AllGuests.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4332, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.AllGuests.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "state", "editable": true, "editor": state4333, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "event_summary", "editable": false, "header": "Event", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.AllGuests.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.cal.AllGuests.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllGuests.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllGuests.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/AllGuests",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllGuests.detail;
    this.ls_insert_handler = Lino.cal.AllGuests.insert;
    Lino.cal.AllGuests.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllGuests.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.AllGuests.insertPanel(p);
});
Lino.cal.AllGuests.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllGuests.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/AllGuests",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllGuests.detail;
    this.ls_insert_handler = Lino.cal.AllGuests.insert;
    Lino.cal.AllGuests.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllGuests.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AllGuests.detailPanel(p);
});
Lino.cal.AllGuests.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.AllGuests.GridPanel(p);
});
Lino.cal.AllGuests.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllGuests.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllGuests", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyPresences
Lino.cal.MyPresences.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyPresences",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyPresences','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "My presences",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "event__start_date", "type": "date" }, { "name": "event__start_time" }, { "name": "event_summary" }, { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "event" }, 'eventHidden', { "name": "partner" }, 'partnerHidden', { "name": "state" }, 'stateHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPresences.insert;
    var ww = this.containing_window;
    var event__start_date4338 = new Lino.DateField({ "disabled": true, "sortable": false });
    var event__start_time4339 = new Lino.TimeField({ "disabled": true, "sortable": false });
    var event_summary_disp4340 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var role4341 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPresences/role" }) }) });
    var workflow_buttons_disp4342 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4343 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4344 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event4345 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar entry...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPresences/event" }) }) });
    var partner4346 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPresences/partner" }) }) });
    var state4347 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var overview_disp4348 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4349 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__start_date", "editable": false, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(cal.MyPresences.event__start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "event__start_time", "editable": false, "header": "Start time", "sortable": true, "tooltip": "(cal.MyPresences.event__start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_summary", "editable": false, "header": "Event", "sortable": false, "tooltip": "(cal.MyPresences.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "role", "editable": true, "editor": role4341, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.MyPresences.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyPresences.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark4343, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(cal.MyPresences.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4344, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyPresences.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "event", "editable": true, "editor": event4345, "filter": { "type": "string" }, "header": "Calendar entry", "hidden": true, "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.MyPresences.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner4346, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(cal.MyPresences.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "state", "editable": true, "editor": state4347, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyPresences.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyPresences.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyPresences.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.cal.MyPresences.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPresences.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPresences.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyPresences",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPresences.insert;
    Lino.cal.MyPresences.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPresences.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyPresences.insertPanel(p);
});
Lino.cal.MyPresences.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPresences.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/MyPresences",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPresences.insert;
    Lino.cal.MyPresences.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPresences.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyPresences.detailPanel(p);
});
Lino.cal.MyPresences.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.MyPresences.GridPanel(p);
});
Lino.cal.MyPresences.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPresences.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPresences", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyPendingPresences
Lino.cal.MyPendingPresences.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyPendingPresences",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyPendingPresences','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "My pending invitations",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "event__when_text" }, { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPendingPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPendingPresences.insert;
    var ww = this.containing_window;
    var event__when_text_disp4351 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "sortable": false, "value": "<br/>" });
    var role4352 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyPendingPresences/role" }) }) });
    var workflow_buttons_disp4353 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4354 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__when_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.MyPendingPresences.event__when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role4352, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.MyPendingPresences.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyPendingPresences.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark4354, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(cal.MyPendingPresences.remark) ", "width": Lino.chars2width(22) } ];
    Lino.cal.MyPendingPresences.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPendingPresences.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPendingPresences.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyPendingPresences",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPendingPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPendingPresences.insert;
    Lino.cal.MyPendingPresences.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPendingPresences.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyPendingPresences.insertPanel(p);
});
Lino.cal.MyPendingPresences.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyPendingPresences.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/MyPendingPresences",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyPendingPresences.detail;
    this.ls_insert_handler = Lino.cal.MyPendingPresences.insert;
    Lino.cal.MyPendingPresences.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyPendingPresences.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyPendingPresences.detailPanel(p);
});
Lino.cal.MyPendingPresences.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.MyPendingPresences.GridPanel(p);
});
Lino.cal.MyPendingPresences.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyPendingPresences.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyPendingPresences", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyGuests
Lino.cal.MyGuests.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyGuests",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyGuests','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "My guests",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "event__start_date", "type": "date" }, { "name": "event__start_time" }, { "name": "event_summary" }, { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "event" }, 'eventHidden', { "name": "partner" }, 'partnerHidden', { "name": "state" }, 'stateHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyGuests.detail;
    this.ls_insert_handler = Lino.cal.MyGuests.insert;
    var ww = this.containing_window;
    var event__start_date4356 = new Lino.DateField({ "disabled": true, "sortable": false });
    var event__start_time4357 = new Lino.TimeField({ "disabled": true, "sortable": false });
    var event_summary_disp4358 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var role4359 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyGuests/role" }) }) });
    var workflow_buttons_disp4360 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark4361 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id4362 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event4363 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar entry...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyGuests/event" }) }) });
    var partner4364 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyGuests/partner" }) }) });
    var state4365 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var overview_disp4366 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4367 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__start_date", "editable": false, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(cal.MyGuests.event__start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "event__start_time", "editable": false, "header": "Start time", "sortable": true, "tooltip": "(cal.MyGuests.event__start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_summary", "editable": false, "header": "Event", "sortable": false, "tooltip": "(cal.MyGuests.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "role", "editable": true, "editor": role4359, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.MyGuests.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyGuests.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark4361, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(cal.MyGuests.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id4362, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyGuests.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "event", "editable": true, "editor": event4363, "filter": { "type": "string" }, "header": "Calendar entry", "hidden": true, "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.MyGuests.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner4364, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(cal.MyGuests.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "state", "editable": true, "editor": state4365, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyGuests.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyGuests.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyGuests.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.cal.MyGuests.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyGuests.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyGuests.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyGuests",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyGuests.detail;
    this.ls_insert_handler = Lino.cal.MyGuests.insert;
    Lino.cal.MyGuests.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyGuests.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyGuests.insertPanel(p);
});
Lino.cal.MyGuests.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyGuests.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/MyGuests",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyGuests.detail;
    this.ls_insert_handler = Lino.cal.MyGuests.insert;
    Lino.cal.MyGuests.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyGuests.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyGuests.detailPanel(p);
});
Lino.cal.MyGuests.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.MyGuests.GridPanel(p);
});
Lino.cal.MyGuests.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyGuests.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyGuests", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.AllEntries
Lino.cal.AllEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/AllEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AllEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Calendar entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllEntries.detail;
    this.ls_insert_handler = Lino.cal.AllEntries.insert;
    var ww = this.containing_window;
    var when_text_disp4456 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user4457 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/user" }) }) });
    var summary4458 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type4459 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/event_type" }) }) });
    var id4460 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified4461 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4462 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4463 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4464 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4465 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4466 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4467 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4468 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to4469 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/assigned_to" }) }) });
    var owner_type4470 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/owner_type" }) }) });
    var owner_id4471 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/owner_id" }) }) });
    var description4472 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4473 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4474 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4475 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4476 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4477 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/room" }) }) });
    var priority4478 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/AllEntries/priority" }) }) });
    var state4479 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4480 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4481 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4482 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4483 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4484 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4485 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4486 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4487 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4488 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4489 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4490 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4471.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4470.on('change',Lino.chooser_handler(owner_id4471,'owner_type'));
      Lino.cal.AllEntries.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.AllEntries.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user4457, "filter": { "type": "string" }, "header": "Responsible user", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.AllEntries.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary4458, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.AllEntries.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type4459, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(cal.AllEntries.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4460, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.AllEntries.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date4463, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time4464, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date4465, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time4466, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method4468, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4469, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.AllEntries.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4470, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.AllEntries.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4471, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4472, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4473, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4474, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4475, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.AllEntries.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room4477, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority4478, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state4479, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.AllEntries.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.AllEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllEntries.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllEntries.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/AllEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllEntries.detail;
    this.ls_insert_handler = Lino.cal.AllEntries.insert;
    Lino.cal.AllEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.AllEntries.insertPanel(p);
});
Lino.cal.AllEntries.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.AllEntries.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/AllEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.AllEntries.detail;
    this.ls_insert_handler = Lino.cal.AllEntries.insert;
    Lino.cal.AllEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AllEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AllEntries.detailPanel(p);
});
Lino.cal.AllEntries.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.AllEntries.GridPanel(p);
});
Lino.cal.AllEntries.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AllEntries.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AllEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.EntriesByDay
Lino.cal.EntriesByDay.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EntriesByDay",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByDay','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Appointments today",
  page_length : 20,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "start_time" }, { "name": "end_time" }, { "name": "duration" }, { "name": "room" }, 'roomHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "summary" }, { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByDay.detail;
    this.ls_insert_handler = Lino.cal.EntriesByDay.insert;
    var ww = this.containing_window;
    var start_time4492 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time4493 = new Lino.TimeField({ "selectOnFocus": true });
    var duration4494 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "maxLength": 6 });
    var room4495 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/room" }) }) });
    var event_type4496 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/event_type" }) }) });
    var summary4497 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var owner_disp4498 = new Ext.form.DisplayField({ "disabled": true });
    var workflow_buttons_disp4499 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4500 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4501 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4502 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4503 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date4504 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time4505 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4506 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4507 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/user" }) }) });
    var assigned_to4508 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/assigned_to" }) }) });
    var owner_type4509 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/owner_type" }) }) });
    var owner_id4510 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/owner_id" }) }) });
    var description4511 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4512 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4513 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4514 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4515 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority4516 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByDay/priority" }) }) });
    var state4517 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar4518 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4519 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4520 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4521 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4522 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4523 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4524 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4525 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4526 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id4510.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4509.on('change',Lino.chooser_handler(owner_id4510,'owner_type'));
      Lino.cal.EntriesByDay.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_time", "editable": true, "editor": start_time4492, "header": "Start time", "sortable": true, "tooltip": "(cal.EntriesByDay.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "end_time", "editable": true, "editor": end_time4493, "header": "End Time", "sortable": true, "tooltip": "(cal.EntriesByDay.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "sortable": false, "tooltip": "(cal.EntriesByDay.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 3, "dataIndex": "room", "editable": true, "editor": room4495, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(cal.EntriesByDay.room) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "event_type", "editable": true, "editor": event_type4496, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(cal.EntriesByDay.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "summary", "editable": true, "editor": summary4497, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.EntriesByDay.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(cal.EntriesByDay.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.EntriesByDay.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id4500, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "start_date", "editable": true, "editor": start_date4503, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "end_date", "editable": true, "editor": end_date4504, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 14, "dataIndex": "build_method", "editable": true, "editor": build_method4506, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 15, "dataIndex": "user", "editable": true, "editor": user4507, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4508, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "owner_type", "editable": true, "editor": owner_type4509, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByDay.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "owner_id", "editable": true, "editor": owner_id4510, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 19, "dataIndex": "description", "editable": true, "editor": description4511, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "access_class", "editable": true, "editor": access_class4512, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 21, "dataIndex": "sequence", "editable": true, "editor": sequence4513, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 22, "dataIndex": "auto_type", "editable": true, "editor": auto_type4514, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByDay.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 23, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority4516, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state4517, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 31, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.url) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 34, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByDay.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.cal.EntriesByDay.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByDay.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByDay.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/EntriesByDay",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByDay.detail;
    this.ls_insert_handler = Lino.cal.EntriesByDay.insert;
    Lino.cal.EntriesByDay.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByDay.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EntriesByDay.insertPanel(p);
});
Lino.cal.EntriesByDay.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByDay.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/EntriesByDay",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByDay.detail;
    this.ls_insert_handler = Lino.cal.EntriesByDay.insert;
    Lino.cal.EntriesByDay.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByDay.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntriesByDay.detailPanel(p);
});
Lino.cal.EntriesByDay.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.EntriesByDay.GridPanel(p);
});
Lino.cal.EntriesByDay.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByDay.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByDay", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.OneEvent
Lino.cal.OneEvent.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/OneEvent",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/OneEvent','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Calendar entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "when_text" }, { "name": "user" }, 'userHidden', { "name": "summary" }, { "name": "event_type" }, 'event_typeHidden', { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OneEvent.detail;
    this.ls_insert_handler = Lino.cal.OneEvent.insert;
    var ww = this.containing_window;
    var when_text_disp4528 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user4529 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/user" }) }) });
    var summary4530 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event_type4531 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/event_type" }) }) });
    var id4532 = new Ext.form.NumberField({ "selectOnFocus": true });
    var modified4533 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4534 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4535 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4536 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4537 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4538 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4539 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4540 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var assigned_to4541 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/assigned_to" }) }) });
    var owner_type4542 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/owner_type" }) }) });
    var owner_id4543 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/owner_id" }) }) });
    var description4544 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4545 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4546 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4547 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4548 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4549 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/room" }) }) });
    var priority4550 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/OneEvent/priority" }) }) });
    var state4551 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4552 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4553 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4554 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4555 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4556 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4557 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4558 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4559 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4560 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4561 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4562 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4543.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4542.on('change',Lino.chooser_handler(owner_id4543,'owner_type'));
      Lino.cal.OneEvent.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.OneEvent.when_text) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user4529, "filter": { "type": "string" }, "header": "Responsible user", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.OneEvent.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "summary", "editable": true, "editor": summary4530, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.OneEvent.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "event_type", "editable": true, "editor": event_type4531, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(cal.OneEvent.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4532, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.OneEvent.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date4535, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time4536, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date4537, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time4538, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method4540, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4541, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.OneEvent.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4542, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.OneEvent.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4543, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4544, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4545, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4546, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4547, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.OneEvent.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room4549, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority4550, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state4551, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.OneEvent.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.OneEvent.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OneEvent.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.OneEvent.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/OneEvent",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OneEvent.detail;
    this.ls_insert_handler = Lino.cal.OneEvent.insert;
    Lino.cal.OneEvent.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OneEvent.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.OneEvent.insertPanel(p);
});
Lino.cal.OneEvent.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.OneEvent.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/OneEvent",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.OneEvent.detail;
    this.ls_insert_handler = Lino.cal.OneEvent.insert;
    Lino.cal.OneEvent.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.OneEvent.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.OneEvent.detailPanel(p);
});
Lino.cal.OneEvent.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.OneEvent.ParamsPanel({});
  return new Lino.cal.OneEvent.GridPanel(p);
});
Lino.cal.OneEvent.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.OneEvent.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/OneEvent", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyEntriesToday
Lino.cal.MyEntriesToday.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyEntriesToday",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntriesToday','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "My appointments today",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "start_time" }, { "name": "end_time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntriesToday.detail;
    this.ls_insert_handler = Lino.cal.MyEntriesToday.insert;
    var ww = this.containing_window;
    var start_time4564 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time4565 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type4566 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/event_type" }) }) });
    var summary4567 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4568 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4569 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4570 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4571 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4572 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date4573 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time4574 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4575 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4576 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/user" }) }) });
    var assigned_to4577 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/assigned_to" }) }) });
    var owner_type4578 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/owner_type" }) }) });
    var owner_id4579 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/owner_id" }) }) });
    var description4580 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4581 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4582 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4583 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4584 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4585 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/room" }) }) });
    var priority4586 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntriesToday/priority" }) }) });
    var state4587 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4588 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4589 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4590 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4591 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4592 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4593 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4594 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4595 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4596 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4597 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4598 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4579.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4578.on('change',Lino.chooser_handler(owner_id4579,'owner_type'));
      Lino.cal.MyEntriesToday.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_time", "editable": true, "editor": start_time4564, "header": "Start time", "sortable": true, "tooltip": "(cal.MyEntriesToday.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "end_time", "editable": true, "editor": end_time4565, "header": "End Time", "sortable": true, "tooltip": "(cal.MyEntriesToday.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type4566, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(cal.MyEntriesToday.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "summary", "editable": true, "editor": summary4567, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.MyEntriesToday.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyEntriesToday.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4569, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "start_date", "editable": true, "editor": start_date4572, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date4573, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "build_method", "editable": true, "editor": build_method4575, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user4576, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4577, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4578, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyEntriesToday.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4579, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4580, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4581, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4582, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4583, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntriesToday.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room4585, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority4586, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state4587, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntriesToday.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyEntriesToday.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntriesToday.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntriesToday.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyEntriesToday",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntriesToday.detail;
    this.ls_insert_handler = Lino.cal.MyEntriesToday.insert;
    Lino.cal.MyEntriesToday.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntriesToday.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyEntriesToday.insertPanel(p);
});
Lino.cal.MyEntriesToday.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntriesToday.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyEntriesToday",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntriesToday.detail;
    this.ls_insert_handler = Lino.cal.MyEntriesToday.insert;
    Lino.cal.MyEntriesToday.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntriesToday.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyEntriesToday.detailPanel(p);
});
Lino.cal.MyEntriesToday.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyEntriesToday.GridPanel(p);
});
Lino.cal.MyEntriesToday.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntriesToday.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntriesToday", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyAssignedEvents
Lino.cal.MyAssignedEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyAssignedEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyAssignedEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Events assigned to me",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "overview" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "summary" }, { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyAssignedEvents.detail;
    this.ls_insert_handler = Lino.cal.MyAssignedEvents.insert;
    var ww = this.containing_window;
    var overview_disp4600 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var workflow_buttons_disp4601 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4602 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4603 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4604 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4605 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4606 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4607 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4608 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4609 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4610 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4611 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/user" }) }) });
    var assigned_to4612 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/assigned_to" }) }) });
    var owner_type4613 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/owner_type" }) }) });
    var owner_id4614 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/owner_id" }) }) });
    var summary4615 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description4616 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4617 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4618 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4619 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type4620 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/event_type" }) }) });
    var transparent4621 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4622 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/room" }) }) });
    var priority4623 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyAssignedEvents/priority" }) }) });
    var state4624 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4625 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4626 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4627 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4628 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4629 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4630 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4631 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4632 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4633 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4634 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4614.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4613.on('change',Lino.chooser_handler(owner_id4614,'owner_type'));
      Lino.cal.MyAssignedEvents.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(cal.MyAssignedEvents.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyAssignedEvents.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4602, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 4, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "start_date", "editable": true, "editor": start_date4605, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time4606, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date4607, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "end_time", "editable": true, "editor": end_time4608, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "build_method", "editable": true, "editor": build_method4610, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user4611, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4612, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_type", "editable": true, "editor": owner_type4613, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyAssignedEvents.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_id", "editable": true, "editor": owner_id4614, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "summary", "editable": true, "editor": summary4615, "filter": { "type": "string" }, "header": "Short description", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4616, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4617, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4618, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4619, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.MyAssignedEvents.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type4620, "filter": { "type": "string" }, "header": "Calendar entry type", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "room", "editable": true, "editor": room4622, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.room) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "priority", "editable": true, "editor": priority4623, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "state", "editable": true, "editor": state4624, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 25, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 31, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.url) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.MyAssignedEvents.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyAssignedEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyAssignedEvents.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyAssignedEvents.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyAssignedEvents",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyAssignedEvents.detail;
    this.ls_insert_handler = Lino.cal.MyAssignedEvents.insert;
    Lino.cal.MyAssignedEvents.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyAssignedEvents.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyAssignedEvents.insertPanel(p);
});
Lino.cal.MyAssignedEvents.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyAssignedEvents.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyAssignedEvents",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyAssignedEvents.detail;
    this.ls_insert_handler = Lino.cal.MyAssignedEvents.insert;
    Lino.cal.MyAssignedEvents.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyAssignedEvents.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyAssignedEvents.detailPanel(p);
});
Lino.cal.MyAssignedEvents.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyAssignedEvents.GridPanel(p);
});
Lino.cal.MyAssignedEvents.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyAssignedEvents.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyAssignedEvents", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyOverdueAppointments
Lino.cal.MyOverdueAppointments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyOverdueAppointments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyOverdueAppointments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "My overdue appointments",
  page_length : 20,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "overview" }, { "name": "owner" }, { "name": "event_type" }, 'event_typeHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "summary" }, { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyOverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyOverdueAppointments.insert;
    var ww = this.containing_window;
    var overview_disp4672 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var owner_disp4673 = new Ext.form.DisplayField({ "disabled": true });
    var event_type4674 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/event_type" }) }) });
    var workflow_buttons_disp4675 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4676 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4677 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4678 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4679 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4680 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4681 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4682 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4683 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4684 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4685 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/user" }) }) });
    var assigned_to4686 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/assigned_to" }) }) });
    var owner_type4687 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/owner_type" }) }) });
    var owner_id4688 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/owner_id" }) }) });
    var summary4689 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description4690 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4691 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4692 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4693 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var transparent4694 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4695 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/room" }) }) });
    var priority4696 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyOverdueAppointments/priority" }) }) });
    var state4697 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar4698 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4699 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4700 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4701 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4702 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4703 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4704 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4705 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4706 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4688.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4687.on('change',Lino.chooser_handler(owner_id4688,'owner_type'));
      Lino.cal.MyOverdueAppointments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type4674, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyOverdueAppointments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id4676, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date4679, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time4680, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date4681, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time4682, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method4684, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "user", "editable": true, "editor": user4685, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4686, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_type", "editable": true, "editor": owner_type4687, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyOverdueAppointments.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_id", "editable": true, "editor": owner_id4688, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "summary", "editable": true, "editor": summary4689, "filter": { "type": "string" }, "header": "Short description", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "description", "editable": true, "editor": description4690, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "access_class", "editable": true, "editor": access_class4691, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 20, "dataIndex": "sequence", "editable": true, "editor": sequence4692, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 21, "dataIndex": "auto_type", "editable": true, "editor": auto_type4693, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.MyOverdueAppointments.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 23, "dataIndex": "room", "editable": true, "editor": room4695, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.room) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority4696, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state4697, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 31, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.url) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.MyOverdueAppointments.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyOverdueAppointments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyOverdueAppointments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyOverdueAppointments.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyOverdueAppointments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyOverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyOverdueAppointments.insert;
    Lino.cal.MyOverdueAppointments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyOverdueAppointments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyOverdueAppointments.insertPanel(p);
});
Lino.cal.MyOverdueAppointments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyOverdueAppointments.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyOverdueAppointments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyOverdueAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyOverdueAppointments.insert;
    Lino.cal.MyOverdueAppointments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyOverdueAppointments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyOverdueAppointments.detailPanel(p);
});
Lino.cal.MyOverdueAppointments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyOverdueAppointments.GridPanel(p);
});
Lino.cal.MyOverdueAppointments.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyOverdueAppointments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyOverdueAppointments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyUnconfirmedAppointments
Lino.cal.MyUnconfirmedAppointments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyUnconfirmedAppointments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyUnconfirmedAppointments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Unconfirmed appointments",
  page_length : 20,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "when_html" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "calendar" }, 'calendarHidden', { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyUnconfirmedAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyUnconfirmedAppointments.insert;
    var ww = this.containing_window;
    var when_html_disp4708 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var summary4709 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp4710 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4711 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4712 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4713 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4714 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4715 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4716 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4717 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4718 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4719 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4720 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/user" }) }) });
    var assigned_to4721 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/assigned_to" }) }) });
    var owner_type4722 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/owner_type" }) }) });
    var owner_id4723 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/owner_id" }) }) });
    var description4724 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4725 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4726 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4727 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type4728 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/event_type" }) }) });
    var transparent4729 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room4730 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/room" }) }) });
    var priority4731 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyUnconfirmedAppointments/priority" }) }) });
    var state4732 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var owner_disp4733 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var calendar4734 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var reminder_disp4735 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp4736 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4737 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4738 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4739 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4740 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4741 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4742 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4723.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4722.on('change',Lino.chooser_handler(owner_id4723,'owner_type'));
      Lino.cal.MyUnconfirmedAppointments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_html", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary4709, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id4711, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date4714, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time4715, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date4716, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time4717, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "build_method", "editable": true, "editor": build_method4719, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user4720, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4721, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type4722, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id4723, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description4724, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class4725, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence4726, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type4727, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.MyUnconfirmedAppointments.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type4728, "filter": { "type": "string" }, "header": "Calendar entry type", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "room", "editable": true, "editor": room4730, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.room) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "priority", "editable": true, "editor": priority4731, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "state", "editable": true, "editor": state4732, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 25, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.MyUnconfirmedAppointments.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyUnconfirmedAppointments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyUnconfirmedAppointments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyUnconfirmedAppointments.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyUnconfirmedAppointments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyUnconfirmedAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyUnconfirmedAppointments.insert;
    Lino.cal.MyUnconfirmedAppointments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyUnconfirmedAppointments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyUnconfirmedAppointments.insertPanel(p);
});
Lino.cal.MyUnconfirmedAppointments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyUnconfirmedAppointments.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyUnconfirmedAppointments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyUnconfirmedAppointments.detail;
    this.ls_insert_handler = Lino.cal.MyUnconfirmedAppointments.insert;
    Lino.cal.MyUnconfirmedAppointments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyUnconfirmedAppointments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyUnconfirmedAppointments.detailPanel(p);
});
Lino.cal.MyUnconfirmedAppointments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyUnconfirmedAppointments.GridPanel(p);
});
Lino.cal.MyUnconfirmedAppointments.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyUnconfirmedAppointments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyUnconfirmedAppointments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.MyEntries
Lino.cal.MyEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/MyEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/MyEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "My appointments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "when_text" }, { "name": "summary" }, { "name": "room" }, 'roomHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntries.detail;
    this.ls_insert_handler = Lino.cal.MyEntries.insert;
    var ww = this.containing_window;
    var when_text_disp4786 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var summary4787 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var room4788 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/room" }) }) });
    var owner_disp4789 = new Ext.form.DisplayField({ "disabled": true });
    var workflow_buttons_disp4790 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id4791 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified4792 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created4793 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date4794 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time4795 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date4796 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time4797 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time4798 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method4799 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user4800 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/user" }) }) });
    var assigned_to4801 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/assigned_to" }) }) });
    var owner_type4802 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/owner_type" }) }) });
    var owner_id4803 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/owner_id" }) }) });
    var description4804 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class4805 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence4806 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type4807 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type4808 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/event_type" }) }) });
    var transparent4809 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority4810 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/MyEntries/priority" }) }) });
    var state4811 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar4812 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp4813 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp4814 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day4815 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp4816 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4817 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4818 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp4819 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration4820 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      owner_id4803.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type4802.on('change',Lino.chooser_handler(owner_id4803,'owner_type'));
      Lino.cal.MyEntries.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.MyEntries.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary4787, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.MyEntries.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room4788, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(cal.MyEntries.room) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(cal.MyEntries.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.MyEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id4791, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "start_date", "editable": true, "editor": start_date4794, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "start_time", "editable": true, "editor": start_time4795, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date4796, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "end_time", "editable": true, "editor": end_time4797, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 12, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 13, "dataIndex": "build_method", "editable": true, "editor": build_method4799, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 14, "dataIndex": "user", "editable": true, "editor": user4800, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntries.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to4801, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.MyEntries.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_type", "editable": true, "editor": owner_type4802, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.MyEntries.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "owner_id", "editable": true, "editor": owner_id4803, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "description", "editable": true, "editor": description4804, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "access_class", "editable": true, "editor": access_class4805, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 20, "dataIndex": "sequence", "editable": true, "editor": sequence4806, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 21, "dataIndex": "auto_type", "editable": true, "editor": auto_type4807, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.MyEntries.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "event_type", "editable": true, "editor": event_type4808, "filter": { "type": "string" }, "header": "Calendar entry type", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 24, "dataIndex": "priority", "editable": true, "editor": priority4810, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state4811, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 26, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 27, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 30, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.url) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 34, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.MyEntries.duration) ", "width": Lino.chars2width(8) } ];
    Lino.cal.MyEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntries.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntries.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/MyEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntries.detail;
    this.ls_insert_handler = Lino.cal.MyEntries.insert;
    Lino.cal.MyEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.MyEntries.insertPanel(p);
});
Lino.cal.MyEntries.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.MyEntries.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/MyEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.MyEntries.detail;
    this.ls_insert_handler = Lino.cal.MyEntries.insert;
    Lino.cal.MyEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.MyEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.MyEntries.detailPanel(p);
});
Lino.cal.MyEntries.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.MyEntries.GridPanel(p);
});
Lino.cal.MyEntries.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.MyEntries.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/MyEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.Vouchers
Lino.ledger.Vouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/Vouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Vouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Vouchers",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date4872 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number4873 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id4874 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4875 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/user" }) }) });
    var journal4876 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/journal" }) }) });
    var voucher_date4877 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4878 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Vouchers/accounting_period" }) }) });
    var narration4879 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4880 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp4881 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4882 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4883 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4884 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      entry_date4872.on('change',Lino.chooser_handler(accounting_period4878,'entry_date'));
      Lino.ledger.Vouchers.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date4872, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "sortable": true, "tooltip": "(ledger.Vouchers.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number4873, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(ledger.Vouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4874, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.Vouchers.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user4875, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(ledger.Vouchers.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal4876, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4877, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "hidden": true, "sortable": true, "tooltip": "(ledger.Vouchers.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4878, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration4879, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(ledger.Vouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state4880, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.Vouchers.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Vouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Vouchers.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Vouchers.ParamsPanel({});
  return new Lino.ledger.Vouchers.GridPanel(p);
});
Lino.ledger.Vouchers.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Vouchers.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Vouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.PartnerVouchers
Lino.ledger.PartnerVouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/PartnerVouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerVouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Vouchers",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 18,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date4907 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number4908 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id4909 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user4910 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/user" }) }) });
    var journal4911 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/journal" }) }) });
    var voucher_date4912 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4913 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/PartnerVouchers/accounting_period" }) }) });
    var narration4914 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4915 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp4916 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4917 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4918 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4919 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period4913.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date4907.on('change',Lino.chooser_handler(accounting_period4913,'entry_date'));
      Lino.ledger.PartnerVouchers.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date4907, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "sortable": true, "tooltip": "(ledger.PartnerVouchers.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number4908, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(ledger.PartnerVouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id4909, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.PartnerVouchers.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user4910, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(ledger.PartnerVouchers.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal4911, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4912, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "hidden": true, "sortable": true, "tooltip": "(ledger.PartnerVouchers.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4913, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration4914, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(ledger.PartnerVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state4915, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.PartnerVouchers.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.PartnerVouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PartnerVouchers.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerVouchers.ParamsPanel({});
  return new Lino.ledger.PartnerVouchers.GridPanel(p);
});
Lino.ledger.PartnerVouchers.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerVouchers.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerVouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.Movements
Lino.ledger.Movements.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/Movements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Movements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Movements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "voucher_partner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date4921 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp4922 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp4923 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit4924 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit4925 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp4926 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared4927 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id4928 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher4929 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Voucher...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/voucher" }) }) });
    var partner4930 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/partner" }) }) });
    var seqno4931 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account4932 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/account" }) }) });
    var amount4933 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc4934 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match4935 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/Movements/match" }) }) });
    var voucher_partner_disp4936 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp4937 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4938 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4939 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner4930.on('change',Lino.chooser_handler(match4935,'partner'));
      account4932.on('change',Lino.chooser_handler(match4935,'account'));
      Lino.ledger.Movements.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date4921, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Value date", "sortable": true, "tooltip": "(ledger.Movements.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Voucher", "sortable": false, "tooltip": "(ledger.Movements.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.Movements.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.Movements.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.Movements.credit) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.Movements.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Cleared", "sortable": false, "tooltip": "(ledger.Movements.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id4928, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.Movements.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "voucher", "editable": true, "editor": voucher4929, "filter": { "type": "string" }, "header": "Voucher", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "partner", "editable": true, "editor": partner4930, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.Movements.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "seqno", "editable": true, "editor": seqno4931, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.No.", "hidden": true, "sortable": true, "tooltip": "(ledger.Movements.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "account", "editable": true, "editor": account4932, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 12, "dataIndex": "amount", "editable": true, "editor": amount4933, "filter": { "type": "numeric" }, "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.Movements.amount) ", "width": Lino.chars2width(13) }, { "colIndex": 13, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "match", "editable": true, "editor": match4935, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "voucher_partner", "editable": false, "header": "Voucher partner", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.Movements.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Movements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Movements.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Movements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Movements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Movements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Movements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Movements", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Movements", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Movements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.Movements.GridPanel(p);
});

// js_render_GridPanel_class vat.Invoices
Lino.vat.Invoices.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/Invoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/Invoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 30,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "id", "type": "int" }, { "name": "number", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "number_with_year" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 1,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.Invoices.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    var ww = this.containing_window;
    var voucher_date4975 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var id4976 = new Ext.form.NumberField({ "selectOnFocus": true });
    var number4977 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner4978 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/partner" }) }) });
    var total_incl4979 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var user4980 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/user" }) }) });
    var journal4981 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/journal" }) }) });
    var entry_date4982 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period4983 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/accounting_period" }) }) });
    var narration4984 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state4985 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term4986 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/payment_term" }) }) });
    var match4987 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/Invoices/match" }) }) });
    var total_base4988 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat4989 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime4990 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var your_ref4991 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date4992 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp4993 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp4994 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp4995 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp4996 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period4983.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      match4987.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match4987.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date4982.on('change',Lino.chooser_handler(accounting_period4983,'entry_date'));
      journal4981.on('change',Lino.chooser_handler(match4987,'journal'));
      partner4978.on('change',Lino.chooser_handler(match4987,'partner'));
      Lino.vat.Invoices.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date4975, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(vat.Invoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id4976, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(vat.Invoices.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 2, "dataIndex": "number", "editable": true, "editor": number4977, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(vat.Invoices.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner4978, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.Invoices.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl4979, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(vat.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user4980, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(vat.Invoices.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "journal", "editable": true, "editor": journal4981, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "entry_date", "editable": true, "editor": entry_date4982, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period4983, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "narration", "editable": true, "editor": narration4984, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state4985, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "payment_term", "editable": true, "editor": payment_term4986, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "match", "editable": true, "editor": match4987, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 13, "dataIndex": "total_base", "editable": true, "editor": total_base4988, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 14, "dataIndex": "total_vat", "editable": true, "editor": total_vat4989, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime4990, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.", "width": Lino.chars2width(28) }, { "colIndex": 16, "dataIndex": "your_ref", "editable": true, "editor": your_ref4991, "filter": { "type": "string" }, "header": "Your reference", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "due_date", "editable": true, "editor": due_date4992, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "hidden": true, "sortable": true, "tooltip": "(vat.Invoices.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(vat.Invoices.number_with_year) ", "width": Lino.chars2width(9) } ];
    Lino.vat.Invoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.Invoices.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.Invoices.insertPanel = Ext.extend(Lino.vat.Invoices.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/vat/Invoices",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.Invoices.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    Lino.vat.Invoices.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.Invoices.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.vat.Invoices.insertPanel(p);
});
Lino.vat.Invoices.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.Invoices.detailPanel = Ext.extend(Lino.vat.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/vat/Invoices",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.Invoices.detail;
    this.ls_insert_handler = Lino.vat.Invoices.insert;
    Lino.vat.Invoices.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.Invoices.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.Invoices.detailPanel(p);
});
Lino.vat.Invoices.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.Invoices.ParamsPanel({});
  return new Lino.vat.Invoices.GridPanel(p);
});
Lino.vat.Invoices.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.Invoices.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/Invoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class products.ProductCats
Lino.products.ProductCats.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/products/ProductCats",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/ProductCats','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Tariff Categories",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 9,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "description" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 30,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductCats.detail;
    this.ls_insert_handler = Lino.products.ProductCats.insert;
    var ww = this.containing_window;
    var id4998 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name4999 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5000 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5001 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var description5002 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var workflow_buttons_disp5003 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5004 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5005 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id4998, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(products.ProductCats.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name4999, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(products.ProductCats.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de5000, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(products.ProductCats.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr5001, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(products.ProductCats.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description5002, "filter": { "type": "string" }, "header": "description", "sortable": false, "tooltip": "(products.ProductCats.description) ", "width": Lino.chars2width(61) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(products.ProductCats.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(products.ProductCats.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(products.ProductCats.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.products.ProductCats.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductCats.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductCats.insertPanel = Ext.extend(Lino.products.ProductCats.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/products/ProductCats",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductCats.detail;
    this.ls_insert_handler = Lino.products.ProductCats.insert;
    Lino.products.ProductCats.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductCats.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.products.ProductCats.insertPanel(p);
});
Lino.products.ProductCats.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductCats.detailPanel = Ext.extend(Lino.products.ProductCats.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/products/ProductCats",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductCats.detail;
    this.ls_insert_handler = Lino.products.ProductCats.insert;
    Lino.products.ProductCats.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductCats.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductCats.detailPanel(p);
});
Lino.products.ProductCats.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductCats.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductCats.GridPanel(p);
});
Lino.products.ProductCats.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductCats", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class products.Products
Lino.products.Products.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/products/Products",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/Products','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/Products','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/products/Products','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/Products','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/Products','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Tariffs",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 24,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "cat" }, 'catHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "delivery_unit" }, 'delivery_unitHidden', { "name": "number_of_events", "type": "int", "useNull": true }, { "name": "min_asset", "type": "int", "useNull": true }, { "name": "sales_account" }, 'sales_accountHidden', { "name": "sales_price" }, { "name": "purchases_account" }, 'purchases_accountHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 31,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.Products.detail;
    this.ls_insert_handler = Lino.products.Products.insert;
    var ww = this.containing_window;
    var id5007 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name5008 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5009 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5010 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var cat5011 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/cat" }) }) });
    var vat_class5012 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description5013 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5014 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5015 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var delivery_unit5016 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.products.DeliveryUnit, "value": "20" });
    var number_of_events5017 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var min_asset5018 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true, "value": 1 });
    var sales_account5019 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/sales_account" }) }) });
    var sales_price5020 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var purchases_account5021 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/Products/purchases_account" }) }) });
    var workflow_buttons_disp5022 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5023 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5024 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5007, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(products.Products.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5008, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(products.Products.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de5009, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(products.Products.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr5010, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(products.Products.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "cat", "editable": true, "editor": cat5011, "filter": { "type": "string" }, "header": "Category", "renderer": Lino.fk_renderer('catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(products.Products.cat) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "vat_class", "editable": true, "editor": vat_class5012, "filter": { "type": "string" }, "header": "VAT Class", "sortable": false, "tooltip": "(products.Products.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "description", "editable": true, "editor": description5013, "filter": { "type": "string" }, "header": "Long description", "hidden": true, "sortable": false, "tooltip": "(products.Products.description) ", "width": Lino.chars2width(61) }, { "colIndex": 7, "dataIndex": "description_de", "editable": true, "editor": description_de5014, "filter": { "type": "string" }, "header": "Long description (de)", "hidden": true, "sortable": false, "tooltip": "(products.Products.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "description_fr", "editable": true, "editor": description_fr5015, "filter": { "type": "string" }, "header": "Long description (fr)", "hidden": true, "sortable": false, "tooltip": "(products.Products.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "delivery_unit", "editable": true, "editor": delivery_unit5016, "filter": { "type": "string" }, "header": "Delivery unit", "hidden": true, "sortable": false, "tooltip": "(products.Products.delivery_unit) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 10, "dataIndex": "number_of_events", "editable": true, "editor": number_of_events5017, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(products.Products.number_of_events) Number of calendar events paid per invoicing.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 11, "dataIndex": "min_asset", "editable": true, "editor": min_asset5018, "filter": { "type": "numeric" }, "format": "0", "header": "Invoice threshold", "hidden": true, "sortable": true, "tooltip": "(products.Products.min_asset) Minimum quantity to pay in advance.", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "sales_account", "editable": true, "editor": sales_account5019, "filter": { "type": "string" }, "header": "Sales Base account", "hidden": true, "sortable": false, "tooltip": "(products.Products.sales_account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 13, "dataIndex": "sales_price", "editable": true, "editor": sales_price5020, "filter": { "type": "numeric" }, "header": "Sales price", "hidden": true, "sortable": true, "tooltip": "(products.Products.sales_price) ", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "purchases_account", "editable": true, "editor": purchases_account5021, "filter": { "type": "string" }, "header": "Purchases Base account", "hidden": true, "sortable": false, "tooltip": "(products.Products.purchases_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(products.Products.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(products.Products.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(products.Products.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.products.Products.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.Products.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.Products.insertPanel = Ext.extend(Lino.products.Products.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/products/Products",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.Products.detail;
    this.ls_insert_handler = Lino.products.Products.insert;
    Lino.products.Products.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.products.Products.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.products.Products.insertPanel(p);
});
Lino.products.Products.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.Products.detailPanel = Ext.extend(Lino.products.Products.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/products/Products",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.products.Products.detail;
    this.ls_insert_handler = Lino.products.Products.insert;
    Lino.products.Products.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.products.Products.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.Products.detailPanel(p);
});
Lino.products.Products.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.Products.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.Products.GridPanel(p);
});
Lino.products.Products.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/Products", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.SalesDocuments
Lino.sales.SalesDocuments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/SalesDocuments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/SalesDocuments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Vouchers",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 18,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "number_with_year" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var entry_date5096 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var number5097 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id5098 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5099 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/SalesDocuments/user" }) }) });
    var journal5100 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/SalesDocuments/journal" }) }) });
    var voucher_date5101 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period5102 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/SalesDocuments/accounting_period" }) }) });
    var narration5103 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5104 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var number_with_year_disp5105 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5106 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5107 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5108 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5102.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5096.on('change',Lino.chooser_handler(accounting_period5102,'entry_date'));
      Lino.sales.SalesDocuments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "entry_date", "editable": true, "editor": entry_date5096, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "sortable": true, "tooltip": "(sales.SalesDocuments.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "number", "editable": true, "editor": number5097, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(sales.SalesDocuments.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id5098, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.SalesDocuments.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user5099, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.SalesDocuments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "journal", "editable": true, "editor": journal5100, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5101, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "hidden": true, "sortable": true, "tooltip": "(sales.SalesDocuments.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5102, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration5103, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(sales.SalesDocuments.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state5104, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.SalesDocuments.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.sales.SalesDocuments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.SalesDocuments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.PartnerVouchers.ParamsPanel({});
  return new Lino.sales.SalesDocuments.GridPanel(p);
});
Lino.sales.SalesDocuments.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.SalesDocuments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/SalesDocuments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.Invoices
Lino.sales.Invoices.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/Invoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/Invoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Product invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 41,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.Invoices.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    var ww = this.containing_window;
    var id5110 = new Ext.form.NumberField({ "selectOnFocus": true });
    var voucher_date5111 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var partner5112 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/partner" }) }) });
    var total_incl5113 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var user5114 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/user" }) }) });
    var journal5115 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/journal" }) }) });
    var entry_date5116 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period5117 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/accounting_period" }) }) });
    var number5118 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration5119 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5120 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term5121 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/payment_term" }) }) });
    var match5122 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/match" }) }) });
    var total_base5123 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat5124 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime5125 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var your_ref5126 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date5127 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var printed_by5128 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var language5129 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var subject5130 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro5131 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type5132 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/Invoices/paper_type" }) }) });
    var balance_before5133 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay5134 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var workflow_buttons_disp5135 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5136 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5137 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5138 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp5139 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5117.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      match5122.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match5122.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5116.on('change',Lino.chooser_handler(accounting_period5117,'entry_date'));
      journal5115.on('change',Lino.chooser_handler(match5122,'journal'));
      partner5112.on('change',Lino.chooser_handler(match5122,'partner'));
      Lino.sales.Invoices.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5110, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(sales.Invoices.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5111, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(sales.Invoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner5112, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.Invoices.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl5113, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.Invoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user5114, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.Invoices.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "journal", "editable": true, "editor": journal5115, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "entry_date", "editable": true, "editor": entry_date5116, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5117, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 8, "dataIndex": "number", "editable": true, "editor": number5118, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "narration", "editable": true, "editor": narration5119, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state5120, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "payment_term", "editable": true, "editor": payment_term5121, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "match", "editable": true, "editor": match5122, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 13, "dataIndex": "total_base", "editable": true, "editor": total_base5123, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 14, "dataIndex": "total_vat", "editable": true, "editor": total_vat5124, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5125, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.", "width": Lino.chars2width(28) }, { "colIndex": 16, "dataIndex": "your_ref", "editable": true, "editor": your_ref5126, "filter": { "type": "string" }, "header": "Your reference", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "due_date", "editable": true, "editor": due_date5127, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 18, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.Invoices.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "language", "editable": true, "editor": language5129, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.language) ", "width": Lino.chars2width(21) }, { "colIndex": 20, "dataIndex": "subject", "editable": true, "editor": subject5130, "filter": { "type": "string" }, "header": "Subject line", "hidden": true, "sortable": true, "tooltip": "(sales.Invoices.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "intro", "editable": true, "editor": intro5131, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "paper_type", "editable": true, "editor": paper_type5132, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 23, "dataIndex": "balance_before", "editable": false, "header": "Balance before", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.balance_before) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 24, "dataIndex": "balance_to_pay", "editable": false, "header": "Balance to pay", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.balance_to_pay) ", "width": Lino.chars2width(13) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(sales.Invoices.number_with_year) ", "width": Lino.chars2width(9) } ];
    Lino.sales.Invoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.Invoices.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.Invoices.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/Invoices",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.Invoices.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    Lino.sales.Invoices.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.Invoices.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.Invoices.insertPanel(p);
});
Lino.sales.Invoices.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.Invoices.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/Invoices",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.Invoices.detail;
    this.ls_insert_handler = Lino.sales.Invoices.insert;
    Lino.sales.Invoices.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.Invoices.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.Invoices.detailPanel(p);
});
Lino.sales.Invoices.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.Invoices.GridPanel(p);
});
Lino.sales.Invoices.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.Invoices.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/Invoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.DueInvoices
Lino.sales.DueInvoices.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/DueInvoices",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/DueInvoices','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Due invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 42,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "journal__ref" }, { "name": "number", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "your_ref" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DueInvoices.detail;
    this.ls_insert_handler = Lino.sales.DueInvoices.insert;
    var ww = this.containing_window;
    var due_date5141 = new Lino.DateField({ "selectOnFocus": true });
    var journal__ref5142 = new Ext.form.TextField({ "disabled": true, "maxLength": 40, "sortable": false });
    var number5143 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner5144 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/partner" }) }) });
    var total_incl5145 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var balance_before5146 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var balance_to_pay5147 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var id5148 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5149 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/user" }) }) });
    var journal5150 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/journal" }) }) });
    var voucher_date5151 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var entry_date5152 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period5153 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/accounting_period" }) }) });
    var narration5154 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5155 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term5156 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/payment_term" }) }) });
    var match5157 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/match" }) }) });
    var total_base5158 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat5159 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime5160 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var your_ref5161 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var printed_by5162 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var language5163 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var subject5164 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro5165 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type5166 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DueInvoices/paper_type" }) }) });
    var workflow_buttons_disp5167 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5168 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5169 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5170 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp5171 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5153.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      match5157.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      match5157.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5152.on('change',Lino.chooser_handler(accounting_period5153,'entry_date'));
      journal5150.on('change',Lino.chooser_handler(match5157,'journal'));
      partner5144.on('change',Lino.chooser_handler(match5157,'partner'));
      Lino.sales.DueInvoices.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": true, "editor": due_date5141, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "sortable": true, "tooltip": "(sales.DueInvoices.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "journal__ref", "editable": false, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(sales.DueInvoices.journal__ref) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "number", "editable": true, "editor": number5143, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(sales.DueInvoices.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner5144, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl5145, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.DueInvoices.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "balance_before", "editable": false, "header": "Balance before", "sortable": false, "tooltip": "(sales.DueInvoices.balance_before) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "balance_to_pay", "editable": false, "header": "Balance to pay", "sortable": false, "tooltip": "(sales.DueInvoices.balance_to_pay) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5148, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user5149, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "journal", "editable": true, "editor": journal5150, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5151, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "entry_date", "editable": true, "editor": entry_date5152, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 12, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5153, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "narration", "editable": true, "editor": narration5154, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state5155, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 15, "dataIndex": "payment_term", "editable": true, "editor": payment_term5156, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "match", "editable": true, "editor": match5157, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 17, "dataIndex": "total_base", "editable": true, "editor": total_base5158, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "total_vat", "editable": true, "editor": total_vat5159, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 19, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime5160, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.", "width": Lino.chars2width(28) }, { "colIndex": 20, "dataIndex": "your_ref", "editable": true, "editor": your_ref5161, "filter": { "type": "string" }, "header": "Your reference", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.DueInvoices.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "language", "editable": true, "editor": language5163, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.language) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "subject", "editable": true, "editor": subject5164, "filter": { "type": "string" }, "header": "Subject line", "hidden": true, "sortable": true, "tooltip": "(sales.DueInvoices.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 24, "dataIndex": "intro", "editable": true, "editor": intro5165, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "paper_type", "editable": true, "editor": paper_type5166, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(sales.DueInvoices.number_with_year) ", "width": Lino.chars2width(9) } ];
    Lino.sales.DueInvoices.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DueInvoices.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DueInvoices.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/DueInvoices",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DueInvoices.detail;
    this.ls_insert_handler = Lino.sales.DueInvoices.insert;
    Lino.sales.DueInvoices.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DueInvoices.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.DueInvoices.insertPanel(p);
});
Lino.sales.DueInvoices.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DueInvoices.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/DueInvoices",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DueInvoices.detail;
    this.ls_insert_handler = Lino.sales.DueInvoices.insert;
    Lino.sales.DueInvoices.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DueInvoices.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.DueInvoices.detailPanel(p);
});
Lino.sales.DueInvoices.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.DueInvoices.GridPanel(p);
});
Lino.sales.DueInvoices.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DueInvoices.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DueInvoices", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.DocumentsToSign
Lino.sales.DocumentsToSign.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/DocumentsToSign",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/DocumentsToSign','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Product invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 10,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "subject" }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "voucher_ptr" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 45,
  ls_id_property : "voucher_ptr",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DocumentsToSign.detail;
    this.ls_insert_handler = Lino.sales.DocumentsToSign.insert;
    var ww = this.containing_window;
    var number5194 = new Ext.form.NumberField({ "selectOnFocus": true });
    var voucher_date5195 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var partner5196 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/DocumentsToSign/partner" }) }) });
    var subject5197 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total_incl5198 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base5199 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat5200 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number5194, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(sales.DocumentsToSign.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(5) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5195, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(sales.DocumentsToSign.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner5196, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.DocumentsToSign.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "subject", "editable": true, "editor": subject5197, "filter": { "type": "string" }, "header": "Subject line", "sortable": true, "tooltip": "(sales.DocumentsToSign.subject) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl5198, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.DocumentsToSign.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "total_base", "editable": true, "editor": total_base5199, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "sortable": true, "tooltip": "(sales.DocumentsToSign.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "total_vat", "editable": true, "editor": total_vat5200, "filter": { "type": "numeric" }, "header": "VAT", "sortable": true, "tooltip": "(sales.DocumentsToSign.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) } ];
    Lino.sales.DocumentsToSign.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DocumentsToSign.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DocumentsToSign.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/DocumentsToSign",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DocumentsToSign.detail;
    this.ls_insert_handler = Lino.sales.DocumentsToSign.insert;
    Lino.sales.DocumentsToSign.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DocumentsToSign.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.DocumentsToSign.insertPanel(p);
});
Lino.sales.DocumentsToSign.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.DocumentsToSign.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/DocumentsToSign",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.DocumentsToSign.detail;
    this.ls_insert_handler = Lino.sales.DocumentsToSign.insert;
    Lino.sales.DocumentsToSign.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.DocumentsToSign.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.DocumentsToSign.detailPanel(p);
});
Lino.sales.DocumentsToSign.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.DocumentsToSign.GridPanel(p);
});
Lino.sales.DocumentsToSign.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.DocumentsToSign.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/DocumentsToSign", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.Plans
Lino.invoicing.Plans.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/Plans",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/Plans','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Toggle selections", "overflowText": "Toggle selections", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Toggle selections" } ],
  cell_edit : true,
  title : "Invoicing plans",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 15,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "today", "type": "date" }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "course" }, 'courseHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 48,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.Plans.detail;
    this.ls_insert_handler = Lino.invoicing.Plans.insert;
    var ww = this.containing_window;
    var id5202 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user5203 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/user" }) }) });
    var journal5204 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Journal...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/journal" }) }) });
    var today5205 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var max_date5206 = new Lino.DateField({ "selectOnFocus": true });
    var partner5207 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/partner" }) }) });
    var course5208 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Plans/course" }) }) });
    var workflow_buttons_disp5209 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5210 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5211 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5202, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.Plans.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user5203, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(invoicing.Plans.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal5204, "filter": { "type": "string" }, "header": "Journal", "sortable": false, "tooltip": "(invoicing.Plans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "today", "editable": true, "editor": today5205, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Invoicing date", "sortable": true, "tooltip": "(invoicing.Plans.today) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "max_date", "editable": true, "editor": max_date5206, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Invoiceables until", "sortable": true, "tooltip": "(invoicing.Plans.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "partner", "editable": true, "editor": partner5207, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.Plans.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "course", "editable": true, "editor": course5208, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(invoicing.Plans.course) If this field is nonempty, select only enrolments of that\ngiven course.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(invoicing.Plans.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.Plans.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.Plans.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.Plans.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Plans.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.Plans.insertPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/invoicing/Plans",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.Plans.detail;
    this.ls_insert_handler = Lino.invoicing.Plans.insert;
    Lino.invoicing.Plans.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Plans.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.invoicing.Plans.insertPanel(p);
});
Lino.invoicing.Plans.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.Plans.detailPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Toggle selections", "overflowText": "Toggle selections", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Toggle selections" } ],
  ls_url: "/invoicing/Plans",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.Plans.detail;
    this.ls_insert_handler = Lino.invoicing.Plans.insert;
    Lino.invoicing.Plans.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Plans.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.Plans.detailPanel(p);
});
Lino.invoicing.Plans.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.invoicing.Plans.ParamsPanel({});
  return new Lino.invoicing.Plans.GridPanel(p);
});
Lino.invoicing.Plans.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.update_plan = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "update_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.execute_plan = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "execute_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Plans.toggle_selections = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Plans", "GET", pk, "toggle_selections", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.MyPlans
Lino.invoicing.MyPlans.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/MyPlans",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/MyPlans','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Toggle selections", "overflowText": "Toggle selections", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Toggle selections" } ],
  cell_edit : true,
  title : "My Invoicing plans",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 15,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "today", "type": "date" }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "course" }, 'courseHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 48,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.MyPlans.detail;
    this.ls_insert_handler = Lino.invoicing.MyPlans.insert;
    var ww = this.containing_window;
    var id5213 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user5214 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/user" }) }) });
    var journal5215 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Journal...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/journal" }) }) });
    var today5216 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var max_date5217 = new Lino.DateField({ "selectOnFocus": true });
    var partner5218 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/partner" }) }) });
    var course5219 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/MyPlans/course" }) }) });
    var workflow_buttons_disp5220 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5221 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5222 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5213, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.MyPlans.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user5214, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal5215, "filter": { "type": "string" }, "header": "Journal", "sortable": false, "tooltip": "(invoicing.MyPlans.journal) The journal where to create invoices.  When this field is\nempty, you can fill the plan with suggestions but cannot\nexecute the plan.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "today", "editable": true, "editor": today5216, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Invoicing date", "sortable": true, "tooltip": "(invoicing.MyPlans.today) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "max_date", "editable": true, "editor": max_date5217, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Invoiceables until", "sortable": true, "tooltip": "(invoicing.MyPlans.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "partner", "editable": true, "editor": partner5218, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "course", "editable": true, "editor": course5219, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(invoicing.MyPlans.course) If this field is nonempty, select only enrolments of that\ngiven course.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(invoicing.MyPlans.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.MyPlans.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.MyPlans.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.MyPlans.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.MyPlans.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.MyPlans.insertPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/invoicing/MyPlans",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.MyPlans.detail;
    this.ls_insert_handler = Lino.invoicing.MyPlans.insert;
    Lino.invoicing.MyPlans.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.MyPlans.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.invoicing.MyPlans.insertPanel(p);
});
Lino.invoicing.MyPlans.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.invoicing.MyPlans.detailPanel = Ext.extend(Lino.invoicing.Plans.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "update_plan", "menu_item_text": "update_plan", "overflowText": "update_plan", "panel_btn_handler": Lino.row_action_handler('update_plan','GET',null), "tooltip": "Build a new list of suggestions. This will remove all current suggestions" }, { "auto_save": true, "iconCls": "x-tbar-money", "itemId": "execute_plan", "menu_item_text": "execute_plan", "overflowText": "execute_plan", "panel_btn_handler": Lino.row_action_handler('execute_plan','GET',null), "tooltip": "Execute this invoicing plan. Create an invoice for each selected suggestion." }, { "auto_save": true, "itemId": "toggle_selections", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Invert selection status for all suggestions.") }, "menu_item_text": "Toggle selections", "overflowText": "Toggle selections", "panel_btn_handler": Lino.row_action_handler('toggle_selections','GET',null), "text": "Toggle selections" } ],
  ls_url: "/invoicing/MyPlans",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.invoicing.MyPlans.detail;
    this.ls_insert_handler = Lino.invoicing.MyPlans.insert;
    Lino.invoicing.MyPlans.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.MyPlans.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.MyPlans.detailPanel(p);
});
Lino.invoicing.MyPlans.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.invoicing.Plans.ParamsPanel({});
  return new Lino.invoicing.MyPlans.GridPanel(p);
});
Lino.invoicing.MyPlans.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.update_plan = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "update_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.execute_plan = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "execute_plan", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.MyPlans.toggle_selections = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/MyPlans", "GET", pk, "toggle_selections", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.Items
Lino.invoicing.Items.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/Items",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/Items','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Invoicing suggestions",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "plan" }, 'planHidden', { "name": "partner" }, 'partnerHidden', { "dateFormat": "d.m.Y", "name": "first_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "last_date", "type": "date" }, { "name": "amount" }, { "name": "number_of_invoiceables", "type": "int", "useNull": true }, { "name": "preview" }, { "name": "selected", "type": "boolean" }, { "name": "invoice" }, 'invoiceHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 47,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id5235 = new Ext.form.NumberField({ "selectOnFocus": true });
    var plan5236 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Invoicing plan...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Items/plan" }) }) });
    var partner5237 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Items/partner" }) }) });
    var first_date5238 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var last_date5239 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var amount5240 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var number_of_invoiceables5241 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 0 });
    var preview5242 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var selected5243 = new Ext.form.Checkbox({ "checked": true, "selectOnFocus": true });
    var invoice5244 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Product invoice...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/Items/invoice" }) }) });
    var workflow_buttons_disp5245 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5246 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5247 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5235, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(invoicing.Items.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "plan", "editable": true, "editor": plan5236, "filter": { "type": "string" }, "header": "Invoicing plan", "renderer": Lino.fk_renderer('planHidden','Lino.invoicing.Plans.detail'), "sortable": false, "tooltip": "(invoicing.Items.plan) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "partner", "editable": true, "editor": partner5237, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.Items.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "first_date", "editable": true, "editor": first_date5238, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "First date", "sortable": true, "tooltip": "(invoicing.Items.first_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "last_date", "editable": true, "editor": last_date5239, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Last date", "sortable": true, "tooltip": "(invoicing.Items.last_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "amount", "editable": true, "editor": amount5240, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(invoicing.Items.amount) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "number_of_invoiceables", "editable": true, "editor": number_of_invoiceables5241, "filter": { "type": "numeric" }, "format": "0", "header": "Number", "sortable": true, "tooltip": "(invoicing.Items.number_of_invoiceables) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "preview", "editable": true, "editor": preview5242, "filter": { "type": "string" }, "header": "Preview", "sortable": false, "tooltip": "(invoicing.Items.preview) A textual preview of the invoiceable items to be included in\nthe invoice.", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "selected", "editable": true, "filter": { "type": "boolean" }, "header": "Selected", "sortable": false, "tooltip": "(invoicing.Items.selected) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "invoice", "editable": true, "editor": invoice5244, "filter": { "type": "string" }, "header": "Invoice", "renderer": Lino.fk_renderer('invoiceHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(invoicing.Items.invoice) The invoice that has been generated. This field is empty for\nnew items. When an item has been executed, this field points\nto the generated invoice.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(invoicing.Items.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.Items.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.Items.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.invoicing.Items.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.Items.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.Items.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.Items.GridPanel(p);
});
Lino.invoicing.Items.exec_item = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/Items", "GET", pk, "exec_item", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.FinancialVouchers
Lino.finan.FinancialVouchers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/FinancialVouchers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/FinancialVouchers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Journal Entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 25,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "number_with_year" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.FinancialVouchers.detail;
    this.ls_insert_handler = Lino.finan.FinancialVouchers.insert;
    var ww = this.containing_window;
    var id5249 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user5250 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/user" }) }) });
    var journal5251 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/journal" }) }) });
    var voucher_date5252 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var entry_date5253 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var accounting_period5254 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/accounting_period" }) }) });
    var number5255 = new Ext.form.NumberField({ "selectOnFocus": true });
    var narration5256 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var state5257 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by5258 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account5259 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/FinancialVouchers/item_account" }) }) });
    var item_remark5260 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var last_item_date5261 = new Lino.DateField({ "selectOnFocus": true });
    var number_with_year_disp5262 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5263 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5264 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5265 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5266 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5254.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5253.on('change',Lino.chooser_handler(accounting_period5254,'entry_date'));
      Lino.finan.FinancialVouchers.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5249, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.FinancialVouchers.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user5250, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.FinancialVouchers.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "journal", "editable": true, "editor": journal5251, "filter": { "type": "string" }, "header": "Journal", "sortable": false, "tooltip": "(finan.FinancialVouchers.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5252, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.FinancialVouchers.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "entry_date", "editable": true, "editor": entry_date5253, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "sortable": true, "tooltip": "(finan.FinancialVouchers.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5254, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.FinancialVouchers.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "number", "editable": true, "editor": number5255, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.FinancialVouchers.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "narration", "editable": true, "editor": narration5256, "filter": { "type": "string" }, "header": "Narration", "sortable": true, "tooltip": "(finan.FinancialVouchers.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "state", "editable": true, "editor": state5257, "filter": { "type": "string" }, "header": "State", "sortable": false, "tooltip": "(finan.FinancialVouchers.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 9, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.FinancialVouchers.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "item_account", "editable": true, "editor": item_account5259, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(finan.FinancialVouchers.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "item_remark", "editable": true, "editor": item_remark5260, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.FinancialVouchers.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date5261, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "sortable": true, "tooltip": "(finan.FinancialVouchers.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.FinancialVouchers.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.FinancialVouchers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.FinancialVouchers.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.FinancialVouchers.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/FinancialVouchers",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.FinancialVouchers.detail;
    this.ls_insert_handler = Lino.finan.FinancialVouchers.insert;
    Lino.finan.FinancialVouchers.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.FinancialVouchers.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.FinancialVouchers.insertPanel(p);
});
Lino.finan.FinancialVouchers.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.FinancialVouchers.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/FinancialVouchers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.FinancialVouchers.detail;
    this.ls_insert_handler = Lino.finan.FinancialVouchers.insert;
    Lino.finan.FinancialVouchers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.FinancialVouchers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.FinancialVouchers.detailPanel(p);
});
Lino.finan.FinancialVouchers.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.FinancialVouchers.GridPanel(p);
});
Lino.finan.FinancialVouchers.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.FinancialVouchers.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/FinancialVouchers", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.JournalEntries
Lino.finan.JournalEntries.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/JournalEntries",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntries','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Journal Entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 25,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntries.detail;
    this.ls_insert_handler = Lino.finan.JournalEntries.insert;
    var ww = this.containing_window;
    var number_with_year_disp5268 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var voucher_date5269 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var accounting_period5270 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/accounting_period" }) }) });
    var workflow_buttons_disp5271 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5272 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5273 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/user" }) }) });
    var journal5274 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/journal" }) }) });
    var entry_date5275 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number5276 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration5277 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5278 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by5279 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account5280 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntries/item_account" }) }) });
    var item_remark5281 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date5282 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var overview_disp5283 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5284 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5285 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5270.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5275.on('change',Lino.chooser_handler(accounting_period5270,'entry_date'));
      Lino.finan.JournalEntries.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "No.", "sortable": false, "tooltip": "(finan.JournalEntries.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5269, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.JournalEntries.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5270, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.JournalEntries.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.JournalEntries.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5272, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user5273, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.JournalEntries.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "journal", "editable": true, "editor": journal5274, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "entry_date", "editable": true, "editor": entry_date5275, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "number", "editable": true, "editor": number5276, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "narration", "editable": true, "editor": narration5277, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state5278, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.JournalEntries.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "item_account", "editable": true, "editor": item_account5280, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_remark", "editable": true, "editor": item_remark5281, "filter": { "type": "string" }, "header": "External reference", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date5282, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntries.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntries.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.JournalEntries.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntries.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntries.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/JournalEntries",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntries.detail;
    this.ls_insert_handler = Lino.finan.JournalEntries.insert;
    Lino.finan.JournalEntries.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntries.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.JournalEntries.insertPanel(p);
});
Lino.finan.JournalEntries.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntries.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/JournalEntries",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntries.detail;
    this.ls_insert_handler = Lino.finan.JournalEntries.insert;
    Lino.finan.JournalEntries.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntries.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.JournalEntries.detailPanel(p);
});
Lino.finan.JournalEntries.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.JournalEntries.GridPanel(p);
});
Lino.finan.JournalEntries.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntries.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntries", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.PaymentOrders
Lino.finan.PaymentOrders.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/PaymentOrders",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrders','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Payment Orders",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 26,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "narration" }, { "name": "total" }, { "dateFormat": "d.m.Y", "name": "execution_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "name": "number_with_year" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrders.insert;
    var ww = this.containing_window;
    var number5287 = new Ext.form.NumberField({ "selectOnFocus": true });
    var voucher_date5288 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration5289 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total5290 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var execution_date5291 = new Lino.DateField({ "selectOnFocus": true });
    var accounting_period5292 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/accounting_period" }) }) });
    var workflow_buttons_disp5293 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5294 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5295 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/user" }) }) });
    var journal5296 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/journal" }) }) });
    var entry_date5297 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var state5298 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by5299 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account5300 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrders/item_account" }) }) });
    var item_remark5301 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var number_with_year_disp5302 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5303 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5304 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5305 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5292.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5297.on('change',Lino.chooser_handler(accounting_period5292,'entry_date'));
      Lino.finan.PaymentOrders.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number5287, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.PaymentOrders.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5288, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.PaymentOrders.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration5289, "filter": { "type": "string" }, "header": "Narration", "sortable": true, "tooltip": "(finan.PaymentOrders.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "total", "editable": true, "editor": total5290, "filter": { "type": "numeric" }, "header": "Total", "sortable": true, "tooltip": "(finan.PaymentOrders.total) ", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "execution_date", "editable": true, "editor": execution_date5291, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Execution date", "sortable": true, "tooltip": "(finan.PaymentOrders.execution_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5292, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.PaymentOrders.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.PaymentOrders.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5294, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user5295, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.PaymentOrders.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "journal", "editable": true, "editor": journal5296, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "entry_date", "editable": true, "editor": entry_date5297, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state5298, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.PaymentOrders.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_account", "editable": true, "editor": item_account5300, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_remark", "editable": true, "editor": item_remark5301, "filter": { "type": "string" }, "header": "External reference", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrders.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrders.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.PaymentOrders.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrders.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrders.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/PaymentOrders",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrders.insert;
    Lino.finan.PaymentOrders.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrders.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.PaymentOrders.insertPanel(p);
});
Lino.finan.PaymentOrders.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrders.detailPanel = Ext.extend(Lino.finan.PaymentOrders.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/PaymentOrders",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrders.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrders.insert;
    Lino.finan.PaymentOrders.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrders.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.PaymentOrders.detailPanel(p);
});
Lino.finan.PaymentOrders.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.PaymentOrders.GridPanel(p);
});
Lino.finan.PaymentOrders.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrders.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrders", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.BankStatements
Lino.finan.BankStatements.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/BankStatements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Bank Statements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 27,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "balance1" }, { "name": "balance2" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatements.detail;
    this.ls_insert_handler = Lino.finan.BankStatements.insert;
    var ww = this.containing_window;
    var number_with_year_disp5307 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var voucher_date5308 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var balance15309 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var balance25310 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var accounting_period5311 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/accounting_period" }) }) });
    var workflow_buttons_disp5312 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5313 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5314 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/user" }) }) });
    var journal5315 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/journal" }) }) });
    var entry_date5316 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number5317 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration5318 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state5319 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by5320 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account5321 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatements/item_account" }) }) });
    var item_remark5322 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date5323 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var overview_disp5324 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5325 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp5326 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      accounting_period5311.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date5316.on('change',Lino.chooser_handler(accounting_period5311,'entry_date'));
      Lino.finan.BankStatements.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "No.", "sortable": false, "tooltip": "(finan.BankStatements.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date5308, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.BankStatements.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "balance1", "editable": true, "editor": balance15309, "filter": { "type": "numeric" }, "header": "Old balance", "sortable": true, "tooltip": "(finan.BankStatements.balance1) The old (or start) balance.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "balance2", "editable": true, "editor": balance25310, "filter": { "type": "numeric" }, "header": "New balance", "sortable": true, "tooltip": "(finan.BankStatements.balance2) The new (or end) balance.", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period5311, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.BankStatements.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.BankStatements.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5313, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user5314, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.BankStatements.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "journal", "editable": true, "editor": journal5315, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "entry_date", "editable": true, "editor": entry_date5316, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 10, "dataIndex": "number", "editable": true, "editor": number5317, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "narration", "editable": true, "editor": narration5318, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state5319, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.BankStatements.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_account", "editable": true, "editor": item_account5321, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "item_remark", "editable": true, "editor": item_remark5322, "filter": { "type": "string" }, "header": "External reference", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date5323, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatements.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatements.printed) ", "width": Lino.chars2width(31) } ];
    Lino.finan.BankStatements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatements.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatements.insertPanel = Ext.extend(Lino.finan.BankStatements.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/BankStatements",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatements.detail;
    this.ls_insert_handler = Lino.finan.BankStatements.insert;
    Lino.finan.BankStatements.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatements.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.BankStatements.insertPanel(p);
});
Lino.finan.BankStatements.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatements.detailPanel = Ext.extend(Lino.finan.BankStatements.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/BankStatements",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatements.detail;
    this.ls_insert_handler = Lino.finan.BankStatements.insert;
    Lino.finan.BankStatements.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatements.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.BankStatements.detailPanel(p);
});
Lino.finan.BankStatements.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.BankStatements.GridPanel(p);
});
Lino.finan.BankStatements.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatements.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatements", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notify.Messages
Lino.notify.Messages.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notify/Messages",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "mark_all_seen", "menu_item_text": "Mark all as seen", "overflowText": "Mark all as seen", "panel_btn_handler": Lino.list_action_handler('/notify/Messages','mark_all_seen','POST',null), "text": "Mark all as seen" } ],
  cell_edit : true,
  title : "Notification messages",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "name": "created" }, { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "seen" }, { "name": "sent" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "message_type" }, 'message_typeHidden', { "name": "body" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 66,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var created5399 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject5400 = new Ext.form.TextField({ "disabled": true, "maxLength": 250 });
    var user5401 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "store": new Lino.ComplexRemoteComboStore({  }) });
    var seen5402 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var sent5403 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var id5404 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type5405 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/Messages/owner_type" }) }) });
    var owner_id5406 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/Messages/owner_id" }) }) });
    var message_type5407 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MessageTypes });
    var body5408 = new Ext.form.HtmlEditor({ "disabled": true, "hidden": true });
    var mail_mode5409 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var owner_disp5410 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp5411 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5412 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5413 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp5414 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id5406.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type5405.on('change',Lino.chooser_handler(owner_id5406,'owner_type'));
      Lino.notify.Messages.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "created", "editable": false, "header": "Created", "sortable": true, "tooltip": "(notify.Messages.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": false, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notify.Messages.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": false, "filter": { "type": "string" }, "header": "Recipient", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notify.Messages.user) The recipient.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "seen", "editable": false, "header": "seen", "sortable": true, "tooltip": "(notify.Messages.seen) ", "width": Lino.chars2width(17) }, { "colIndex": 4, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(notify.Messages.sent) ", "width": Lino.chars2width(17) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id5404, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notify.Messages.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type5405, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notify.Messages.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id5406, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "message_type", "editable": true, "editor": message_type5407, "filter": { "type": "string" }, "header": "Message Type", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.message_type) ", "width": Lino.chars2width(16) }, { "colIndex": 9, "dataIndex": "body", "editable": false, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.body) ", "width": Lino.chars2width(61) }, { "colIndex": 10, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode5409, "filter": { "type": "string" }, "header": "Email notification mode", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.mail_mode) ", "width": Lino.chars2width(15) }, { "colIndex": 11, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.owner) The database object which controls this message.", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(notify.Messages.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.notify.Messages.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.Messages.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notify.Messages.ParamsPanel({});
  return new Lino.notify.Messages.GridPanel(p);
});
Lino.notify.Messages.mark_seen = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "mark_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.clear_seen = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "GET", pk, "clear_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.Messages.mark_all_seen = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/Messages", "POST", pk, "mark_all_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notify.MyMessages
Lino.notify.MyMessages.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notify/MyMessages",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "mark_all_seen", "menu_item_text": "Mark all as seen", "overflowText": "Mark all as seen", "panel_btn_handler": Lino.list_action_handler('/notify/MyMessages','mark_all_seen','POST',null), "text": "Mark all as seen" } ],
  cell_edit : true,
  title : "My Notification messages",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "name": "created" }, { "name": "subject" }, { "name": "message_type" }, 'message_typeHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "seen" }, { "name": "sent" }, { "name": "body" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "owner" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 66,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var created5433 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject5434 = new Ext.form.TextField({ "disabled": true, "maxLength": 250 });
    var message_type5435 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.notify.MessageTypes });
    var workflow_buttons_disp5436 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5437 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user5438 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "store": new Lino.ComplexRemoteComboStore({  }) });
    var owner_type5439 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/MyMessages/owner_type" }) }) });
    var owner_id5440 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notify/MyMessages/owner_id" }) }) });
    var seen5441 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var sent5442 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var body5443 = new Ext.form.HtmlEditor({ "disabled": true, "hidden": true });
    var mail_mode5444 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var owner_disp5445 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var overview_disp5446 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5447 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp5448 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id5440.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type5439.on('change',Lino.chooser_handler(owner_id5440,'owner_type'));
      Lino.notify.MyMessages.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "created", "editable": false, "header": "Created", "sortable": true, "tooltip": "(notify.MyMessages.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": false, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notify.MyMessages.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "message_type", "editable": true, "editor": message_type5435, "filter": { "type": "string" }, "header": "Message Type", "sortable": false, "tooltip": "(notify.MyMessages.message_type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(notify.MyMessages.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5437, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notify.MyMessages.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "user", "editable": false, "filter": { "type": "string" }, "header": "Recipient", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notify.MyMessages.user) The recipient.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type5439, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notify.MyMessages.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id5440, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "seen", "editable": false, "header": "seen", "hidden": true, "sortable": true, "tooltip": "(notify.MyMessages.seen) ", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "sent", "editable": false, "header": "sent", "hidden": true, "sortable": true, "tooltip": "(notify.MyMessages.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "body", "editable": false, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.body) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode5444, "filter": { "type": "string" }, "header": "Email notification mode", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.mail_mode) ", "width": Lino.chars2width(15) }, { "colIndex": 12, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.owner) The database object which controls this message.", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(notify.MyMessages.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.notify.MyMessages.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.MyMessages.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notify.Messages.ParamsPanel({});
  return new Lino.notify.MyMessages.GridPanel(p);
});
Lino.notify.MyMessages.mark_seen = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "mark_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.mark_all_seen = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "POST", pk, "mark_all_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MyMessages.clear_seen = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MyMessages", "GET", pk, "clear_seen", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.Notes
Lino.notes.Notes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/Notes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/Notes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "body" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.Notes.detail;
    this.ls_insert_handler = Lino.notes.Notes.insert;
    var ww = this.containing_window;
    var date5477 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time5478 = new Lino.TimeField({ "selectOnFocus": true });
    var id5479 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user5480 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/user" }) }) });
    var event_type5481 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/event_type" }) }) });
    var type5482 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/type" }) }) });
    var subject5483 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var build_time5484 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method5485 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company5486 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/company" }) }) });
    var contact_person5487 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_person" }) }) });
    var contact_role5488 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/contact_role" }) }) });
    var owner_type5489 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/owner_type" }) }) });
    var owner_id5490 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/Notes/owner_id" }) }) });
    var language5491 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp5492 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp5493 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5494 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5495 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body5496 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
      contact_person5487.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id5490.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company5486.on('change',Lino.chooser_handler(contact_person5487,'company'));
      owner_type5489.on('change',Lino.chooser_handler(owner_id5490,'owner_type'));
      Lino.notes.Notes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date5477, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.Notes.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time5478, "header": "Time", "sortable": true, "tooltip": "(notes.Notes.time) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id5479, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(notes.Notes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user5480, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.Notes.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "event_type", "editable": true, "editor": event_type5481, "filter": { "type": "string" }, "header": "Event Type (Form)", "sortable": false, "tooltip": "(notes.Notes.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "type", "editable": true, "editor": type5482, "filter": { "type": "string" }, "header": "Note Type (Content)", "sortable": false, "tooltip": "(notes.Notes.type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "subject", "editable": true, "editor": subject5483, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.Notes.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.Notes.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method5485, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company5486, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.Notes.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_person", "editable": true, "editor": contact_person5487, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.Notes.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_role", "editable": true, "editor": contact_role5488, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_type", "editable": true, "editor": owner_type5489, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.Notes.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_id", "editable": true, "editor": owner_id5490, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language5491, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.Notes.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "body", "editable": true, "editor": body5496, "filter": { "type": "string" }, "header": "Body", "sortable": false, "tooltip": "(notes.Notes.body) ", "width": Lino.chars2width(61) } ];
    Lino.notes.Notes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.Notes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.Notes.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/Notes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.Notes.detail;
    this.ls_insert_handler = Lino.notes.Notes.insert;
    Lino.notes.Notes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.Notes.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.Notes.insertPanel(p);
});
Lino.notes.Notes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.Notes.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/Notes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.Notes.detail;
    this.ls_insert_handler = Lino.notes.Notes.insert;
    Lino.notes.Notes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.Notes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.Notes.detailPanel(p);
});
Lino.notes.Notes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.Notes.GridPanel(p);
});
Lino.notes.Notes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.Notes.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/Notes", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.MyNotes
Lino.notes.MyNotes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/MyNotes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/MyNotes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "My Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "body" }, { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.MyNotes.detail;
    this.ls_insert_handler = Lino.notes.MyNotes.insert;
    var ww = this.containing_window;
    var date5519 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time5520 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type5521 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/event_type" }) }) });
    var type5522 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/type" }) }) });
    var subject5523 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var body5524 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    var id5525 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time5526 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method5527 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user5528 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/user" }) }) });
    var company5529 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/company" }) }) });
    var contact_person5530 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/contact_person" }) }) });
    var contact_role5531 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/contact_role" }) }) });
    var owner_type5532 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/owner_type" }) }) });
    var owner_id5533 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/MyNotes/owner_id" }) }) });
    var language5534 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp5535 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp5536 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5537 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5538 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person5530.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id5533.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company5529.on('change',Lino.chooser_handler(contact_person5530,'company'));
      owner_type5532.on('change',Lino.chooser_handler(owner_id5533,'owner_type'));
      Lino.notes.MyNotes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date5519, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.MyNotes.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time5520, "header": "Time", "sortable": true, "tooltip": "(notes.MyNotes.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type5521, "filter": { "type": "string" }, "header": "Event Type (Form)", "sortable": false, "tooltip": "(notes.MyNotes.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type5522, "filter": { "type": "string" }, "header": "Note Type (Content)", "sortable": false, "tooltip": "(notes.MyNotes.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject5523, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.MyNotes.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "body", "editable": true, "editor": body5524, "filter": { "type": "string" }, "header": "Body", "sortable": false, "tooltip": "(notes.MyNotes.body) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5525, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.MyNotes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.MyNotes.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method5527, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "user", "editable": true, "editor": user5528, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.MyNotes.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "company", "editable": true, "editor": company5529, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.MyNotes.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_person", "editable": true, "editor": contact_person5530, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.MyNotes.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_role", "editable": true, "editor": contact_role5531, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_type", "editable": true, "editor": owner_type5532, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.MyNotes.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_id", "editable": true, "editor": owner_id5533, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "language", "editable": true, "editor": language5534, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.language) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.MyNotes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.notes.MyNotes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.MyNotes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.MyNotes.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/MyNotes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.MyNotes.detail;
    this.ls_insert_handler = Lino.notes.MyNotes.insert;
    Lino.notes.MyNotes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.MyNotes.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.MyNotes.insertPanel(p);
});
Lino.notes.MyNotes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.MyNotes.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/MyNotes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.MyNotes.detail;
    this.ls_insert_handler = Lino.notes.MyNotes.insert;
    Lino.notes.MyNotes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.MyNotes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.MyNotes.detailPanel(p);
});
Lino.notes.MyNotes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.MyNotes.GridPanel(p);
});
Lino.notes.MyNotes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.MyNotes.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/MyNotes", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.Uploads
Lino.uploads.Uploads.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/Uploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/Uploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "description" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.Uploads.detail;
    this.ls_insert_handler = Lino.uploads.Uploads.insert;
    var ww = this.containing_window;
    var file5552 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type5553 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Upload Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/type" }) }) });
    var user5554 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/user" }) }) });
    var owner_disp5555 = new Ext.form.DisplayField({ "disabled": true });
    var description5556 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id5557 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype5558 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type5559 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/owner_type" }) }) });
    var owner_id5560 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/Uploads/owner_id" }) }) });
    var upload_area5561 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp5562 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5563 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5564 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5565 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type5553.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id5560.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area5561.on('change',Lino.chooser_handler(type5553,'upload_area'));
      owner_type5559.on('change',Lino.chooser_handler(owner_id5560,'owner_type'));
      Lino.uploads.Uploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file5552, "filter": { "type": "string" }, "header": "File", "sortable": true, "tooltip": "(uploads.Uploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type5553, "filter": { "type": "string" }, "header": "Upload Type", "sortable": false, "tooltip": "(uploads.Uploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user5554, "filter": { "type": "string" }, "header": "Uploaded by", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.Uploads.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(uploads.Uploads.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description5556, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(uploads.Uploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id5557, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.Uploads.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME type", "hidden": true, "sortable": true, "tooltip": "(uploads.Uploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type5559, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.Uploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id5560, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "upload_area", "editable": true, "editor": upload_area5561, "filter": { "type": "string" }, "header": "Upload Area", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.Uploads.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.Uploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Uploads.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.Uploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/uploads/Uploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.Uploads.detail;
    this.ls_insert_handler = Lino.uploads.Uploads.insert;
    Lino.uploads.Uploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Uploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.Uploads.insertPanel(p);
});
Lino.uploads.Uploads.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.Uploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/uploads/Uploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.Uploads.detail;
    this.ls_insert_handler = Lino.uploads.Uploads.insert;
    Lino.uploads.Uploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Uploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.Uploads.detailPanel(p);
});
Lino.uploads.Uploads.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Uploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.Uploads.GridPanel(p);
});
Lino.uploads.Uploads.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Uploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.MyUploads
Lino.uploads.MyUploads.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/MyUploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/MyUploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "My Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "file" }, { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "type" }, 'typeHidden', { "name": "description_link" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.MyUploads.detail;
    this.ls_insert_handler = Lino.uploads.MyUploads.insert;
    var ww = this.containing_window;
    var file5582 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var description5583 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user5584 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/user" }) }) });
    var owner_disp5585 = new Ext.form.DisplayField({ "disabled": true });
    var id5586 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype5587 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type5588 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/owner_type" }) }) });
    var owner_id5589 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/owner_id" }) }) });
    var upload_area5590 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var type5591 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Upload Type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/MyUploads/type" }) }) });
    var description_link_disp5592 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5593 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5594 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5595 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      owner_id5589.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      type5591.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type5588.on('change',Lino.chooser_handler(owner_id5589,'owner_type'));
      upload_area5590.on('change',Lino.chooser_handler(type5591,'upload_area'));
      Lino.uploads.MyUploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file5582, "filter": { "type": "string" }, "header": "File", "sortable": true, "tooltip": "(uploads.MyUploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "description", "editable": true, "editor": description5583, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(uploads.MyUploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user5584, "filter": { "type": "string" }, "header": "Uploaded by", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.MyUploads.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(uploads.MyUploads.owner) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5586, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.MyUploads.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME type", "hidden": true, "sortable": true, "tooltip": "(uploads.MyUploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type5588, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.MyUploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id5589, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "upload_area", "editable": true, "editor": upload_area5590, "filter": { "type": "string" }, "header": "Upload Area", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "type", "editable": true, "editor": type5591, "filter": { "type": "string" }, "header": "Upload Type", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.MyUploads.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.MyUploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.MyUploads.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.MyUploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/uploads/MyUploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.MyUploads.detail;
    this.ls_insert_handler = Lino.uploads.MyUploads.insert;
    Lino.uploads.MyUploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.MyUploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.MyUploads.insertPanel(p);
});
Lino.uploads.MyUploads.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.MyUploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/uploads/MyUploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.MyUploads.detail;
    this.ls_insert_handler = Lino.uploads.MyUploads.insert;
    Lino.uploads.MyUploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.MyUploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.MyUploads.detailPanel(p);
});
Lino.uploads.MyUploads.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.MyUploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.MyUploads.GridPanel(p);
});
Lino.uploads.MyUploads.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/MyUploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.AreaUploads
Lino.uploads.AreaUploads.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/AreaUploads",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/AreaUploads','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "description" }, { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AreaUploads.detail;
    this.ls_insert_handler = Lino.uploads.AreaUploads.insert;
    var ww = this.containing_window;
    var file5597 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type5598 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Upload Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/type" }) }) });
    var user5599 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/user" }) }) });
    var owner_disp5600 = new Ext.form.DisplayField({ "disabled": true });
    var description5601 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id5602 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype5603 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type5604 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/owner_type" }) }) });
    var owner_id5605 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/AreaUploads/owner_id" }) }) });
    var upload_area5606 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp5607 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5608 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5609 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5610 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      type5598.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id5605.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area5606.on('change',Lino.chooser_handler(type5598,'upload_area'));
      owner_type5604.on('change',Lino.chooser_handler(owner_id5605,'owner_type'));
      Lino.uploads.AreaUploads.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file5597, "filter": { "type": "string" }, "header": "File", "sortable": true, "tooltip": "(uploads.AreaUploads.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type5598, "filter": { "type": "string" }, "header": "Upload Type", "sortable": false, "tooltip": "(uploads.AreaUploads.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user5599, "filter": { "type": "string" }, "header": "Uploaded by", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.AreaUploads.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(uploads.AreaUploads.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description5601, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(uploads.AreaUploads.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id5602, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.AreaUploads.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME type", "hidden": true, "sortable": true, "tooltip": "(uploads.AreaUploads.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type5604, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.AreaUploads.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id5605, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "upload_area", "editable": true, "editor": upload_area5606, "filter": { "type": "string" }, "header": "Upload Area", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "description_link", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.AreaUploads.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.AreaUploads.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AreaUploads.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.AreaUploads.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/uploads/AreaUploads",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AreaUploads.detail;
    this.ls_insert_handler = Lino.uploads.AreaUploads.insert;
    Lino.uploads.AreaUploads.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AreaUploads.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.AreaUploads.insertPanel(p);
});
Lino.uploads.AreaUploads.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.AreaUploads.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/uploads/AreaUploads",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.AreaUploads.detail;
    this.ls_insert_handler = Lino.uploads.AreaUploads.insert;
    Lino.uploads.AreaUploads.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.AreaUploads.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.AreaUploads.detailPanel(p);
});
Lino.uploads.AreaUploads.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.AreaUploads.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.AreaUploads.GridPanel(p);
});
Lino.uploads.AreaUploads.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/AreaUploads", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.Excerpts
Lino.excerpts.Excerpts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/Excerpts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/Excerpts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" } ],
  cell_edit : true,
  title : "Excerpts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 27,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "owner" }, { "name": "company" }, 'companyHidden', { "name": "language" }, 'languageHidden', { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.Excerpts.detail;
    var ww = this.containing_window;
    var id5667 = new Ext.form.NumberField({ "selectOnFocus": true });
    var excerpt_type5668 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Excerpt Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/excerpt_type" }) }) });
    var owner_disp5669 = new Ext.form.DisplayField({ "disabled": true });
    var company5670 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/company" }) }) });
    var language5671 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var build_time5672 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var build_method5673 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user5674 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/user" }) }) });
    var contact_person5675 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_person" }) }) });
    var contact_role5676 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/contact_role" }) }) });
    var owner_type5677 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/owner_type" }) }) });
    var owner_id5678 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/Excerpts/owner_id" }) }) });
    var body_template_content5679 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox5680 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Preview", "value": "<br/>" });
    var workflow_buttons_disp5681 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5682 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5683 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      excerpt_type5668.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person5675.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id5678.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox5680.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp5669.on('change',Lino.chooser_handler(excerpt_type5668,'owner'));
      company5670.on('change',Lino.chooser_handler(contact_person5675,'company'));
      owner_type5677.on('change',Lino.chooser_handler(owner_id5678,'owner_type'));
      Lino.excerpts.Excerpts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5667, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(excerpts.Excerpts.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type5668, "filter": { "type": "string" }, "header": "Excerpt Type", "sortable": false, "tooltip": "(excerpts.Excerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(excerpts.Excerpts.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "company", "editable": true, "editor": company5670, "filter": { "type": "string" }, "header": "Recipient (Organization)", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language5671, "filter": { "type": "string" }, "header": "Language", "sortable": false, "tooltip": "(excerpts.Excerpts.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "build_time", "editable": false, "header": "build time", "sortable": true, "tooltip": "(excerpts.Excerpts.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "build_method", "editable": true, "editor": build_method5673, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user5674, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "contact_person", "editable": true, "editor": contact_person5675, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_role", "editable": true, "editor": contact_role5676, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "owner_type", "editable": true, "editor": owner_type5677, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.Excerpts.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_id", "editable": true, "editor": owner_id5678, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "body_template_content", "editable": false, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "preview", "editable": false, "header": "Preview", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.Excerpts.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.Excerpts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.Excerpts.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.Excerpts.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" } ],
  ls_url: "/excerpts/Excerpts",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.Excerpts.detail;
    Lino.excerpts.Excerpts.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.Excerpts.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.Excerpts.detailPanel(p);
});
Lino.excerpts.Excerpts.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.Excerpts.GridPanel(p);
});
Lino.excerpts.Excerpts.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Excerpts.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Excerpts", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.MyExcerpts
Lino.excerpts.MyExcerpts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/MyExcerpts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/MyExcerpts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "My Excerpts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 27,
  ls_store_fields : [ { "name": "build_time" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "id", "type": "int" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "body_template_content" }, { "name": "preview" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.MyExcerpts.detail;
    var ww = this.containing_window;
    var build_time5703 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var excerpt_type5704 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Excerpt Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/excerpt_type" }) }) });
    var id5705 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_method5706 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user5707 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/user" }) }) });
    var company5708 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/company" }) }) });
    var contact_person5709 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/contact_person" }) }) });
    var contact_role5710 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/contact_role" }) }) });
    var owner_type5711 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/owner_type" }) }) });
    var owner_id5712 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/MyExcerpts/owner_id" }) }) });
    var language5713 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp5714 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var body_template_content5715 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox5716 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Preview", "value": "<br/>" });
    var workflow_buttons_disp5717 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5718 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5719 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      excerpt_type5704.setContextValue('owner', record ? record.data['owner'] : undefined);
      contact_person5709.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id5712.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox5716.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp5714.on('change',Lino.chooser_handler(excerpt_type5704,'owner'));
      company5708.on('change',Lino.chooser_handler(contact_person5709,'company'));
      owner_type5711.on('change',Lino.chooser_handler(owner_id5712,'owner_type'));
      Lino.excerpts.MyExcerpts.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "build_time", "editable": false, "header": "build time", "sortable": true, "tooltip": "(excerpts.MyExcerpts.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type5704, "filter": { "type": "string" }, "header": "Excerpt Type", "sortable": false, "tooltip": "(excerpts.MyExcerpts.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id5705, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.MyExcerpts.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "build_method", "editable": true, "editor": build_method5706, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user5707, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company5708, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_person", "editable": true, "editor": contact_person5709, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "contact_role", "editable": true, "editor": contact_role5710, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type5711, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.MyExcerpts.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id5712, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language5713, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "body_template_content", "editable": false, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "preview", "editable": false, "header": "Preview", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.MyExcerpts.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.MyExcerpts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.MyExcerpts.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.MyExcerpts.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/MyExcerpts",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.MyExcerpts.detail;
    Lino.excerpts.MyExcerpts.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.MyExcerpts.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.MyExcerpts.detailPanel(p);
});
Lino.excerpts.MyExcerpts.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.MyExcerpts.GridPanel(p);
});
Lino.excerpts.MyExcerpts.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.MyExcerpts.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/MyExcerpts", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class extensible.PanelCalendars
Lino.extensible.PanelCalendars.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/extensible/PanelCalendars",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelCalendars','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Calendars",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "summary" }, { "name": "description" }, { "name": "color", "type": "int", "useNull": true }, { "name": "is_hidden", "type": "boolean" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 27,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelCalendars.detail;
    this.ls_insert_handler = Lino.extensible.PanelCalendars.insert;
    var ww = this.containing_window;
    var id5721 = new Ext.form.NumberField({ "selectOnFocus": true });
    var summary_disp5722 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description5723 = new Ext.form.HtmlEditor({ "selectOnFocus": true });
    var color5724 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true });
    var is_hidden_disp5725 = new Ext.form.DisplayField({ "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5721, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(extensible.PanelCalendars.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "summary", "editable": false, "header": "summary", "sortable": false, "tooltip": "(extensible.PanelCalendars.summary) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "description", "editable": true, "editor": description5723, "filter": { "type": "string" }, "header": "Description", "sortable": false, "tooltip": "(extensible.PanelCalendars.description) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "color", "editable": true, "editor": color5724, "filter": { "type": "numeric" }, "format": "0", "header": "color", "sortable": true, "tooltip": "(extensible.PanelCalendars.color) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "is_hidden", "editable": false, "header": "Hidden", "sortable": false, "tooltip": "(extensible.PanelCalendars.is_hidden) ", "width": Lino.chars2width(21) } ];
    Lino.extensible.PanelCalendars.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelCalendars.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelCalendars.insertPanel = Ext.extend(Lino.cal.Calendars.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/extensible/PanelCalendars",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelCalendars.detail;
    this.ls_insert_handler = Lino.extensible.PanelCalendars.insert;
    Lino.extensible.PanelCalendars.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelCalendars.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.extensible.PanelCalendars.insertPanel(p);
});
Lino.extensible.PanelCalendars.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelCalendars.detailPanel = Ext.extend(Lino.cal.Calendars.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/extensible/PanelCalendars",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelCalendars.detail;
    this.ls_insert_handler = Lino.extensible.PanelCalendars.insert;
    Lino.extensible.PanelCalendars.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelCalendars.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.extensible.PanelCalendars.detailPanel(p);
});
Lino.extensible.PanelCalendars.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelCalendars.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.extensible.PanelCalendars.GridPanel(p);
});
Lino.extensible.PanelCalendars.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelCalendars", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class extensible.PanelEvents
Lino.extensible.PanelEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/extensible/PanelEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/extensible/PanelEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Calendar entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 15,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "start_dt" }, { "name": "end_dt" }, { "name": "summary" }, { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "room" }, 'roomHidden', { "name": "calendar" }, 'calendarHidden', { "name": "url" }, { "name": "all_day", "type": "boolean" }, { "name": "reminder" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelEvents.detail;
    this.ls_insert_handler = Lino.extensible.PanelEvents.insert;
    var ww = this.containing_window;
    var id5727 = new Ext.form.NumberField({ "selectOnFocus": true });
    var start_dt5728 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var end_dt5729 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var summary5730 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var description5731 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var user5732 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/extensible/PanelEvents/user" }) }) });
    var room5733 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/extensible/PanelEvents/room" }) }) });
    var calendar5734 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var url_disp5735 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var all_day5736 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var reminder_disp5737 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5727, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(extensible.PanelEvents.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "start_dt", "editable": true, "editor": start_dt5728, "header": "Start", "sortable": false, "tooltip": "(extensible.PanelEvents.start_dt) ", "width": Lino.chars2width(17) }, { "colIndex": 2, "dataIndex": "end_dt", "editable": true, "editor": end_dt5729, "header": "End", "sortable": false, "tooltip": "(extensible.PanelEvents.end_dt) ", "width": Lino.chars2width(17) }, { "colIndex": 3, "dataIndex": "summary", "editable": true, "editor": summary5730, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(extensible.PanelEvents.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "description", "editable": true, "editor": description5731, "filter": { "type": "string" }, "header": "Description", "sortable": false, "tooltip": "(extensible.PanelEvents.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user5732, "filter": { "type": "string" }, "header": "Responsible user", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(extensible.PanelEvents.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "room", "editable": true, "editor": room5733, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(extensible.PanelEvents.room) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "calendar", "editable": false, "header": "Calendar", "sortable": false, "tooltip": "(extensible.PanelEvents.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "url", "editable": false, "header": "Link URL", "sortable": false, "tooltip": "(extensible.PanelEvents.url) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "all_day", "editable": true, "header": "all day", "sortable": false, "tooltip": "(extensible.PanelEvents.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "reminder", "editable": false, "header": "Reminder", "sortable": false, "tooltip": "(extensible.PanelEvents.reminder) ", "width": Lino.chars2width(31) } ];
    Lino.extensible.PanelEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelEvents.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelEvents.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/extensible/PanelEvents",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelEvents.detail;
    this.ls_insert_handler = Lino.extensible.PanelEvents.insert;
    Lino.extensible.PanelEvents.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelEvents.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.extensible.PanelEvents.insertPanel(p);
});
Lino.extensible.PanelEvents.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.extensible.PanelEvents.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/extensible/PanelEvents",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.extensible.PanelEvents.detail;
    this.ls_insert_handler = Lino.extensible.PanelEvents.insert;
    Lino.extensible.PanelEvents.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.extensible.PanelEvents.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.extensible.PanelEvents.detailPanel(p);
});
Lino.extensible.PanelEvents.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.extensible.PanelEvents.GridPanel(p);
});
Lino.extensible.PanelEvents.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.PanelEvents.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/extensible/PanelEvents", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class changes.Changes
Lino.changes.Changes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/changes/Changes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/Changes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" } ],
  cell_edit : true,
  title : "Changes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 21,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "time" }, { "name": "type" }, 'typeHidden', { "name": "user" }, 'userHidden', { "name": "object_type" }, 'object_typeHidden', { "name": "object_id" }, 'object_idHidden', { "name": "master_type" }, 'master_typeHidden', { "name": "master_id" }, 'master_idHidden', { "name": "diff" }, { "name": "changed_fields" }, { "name": "object" }, { "name": "master" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 77,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.Changes.detail;
    var ww = this.containing_window;
    var id5739 = new Ext.form.NumberField({ "selectOnFocus": true });
    var time5740 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var type5741 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var user5742 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/user" }) }) });
    var object_type5743 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_type" }) }) });
    var object_id5744 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/object_id" }) }) });
    var master_type5745 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/master_type" }) }) });
    var master_id5746 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/Changes/master_id" }) }) });
    var diff5747 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var changed_fields5748 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var object_disp5749 = new Ext.form.DisplayField({ "disabled": true });
    var master_disp5750 = new Ext.form.DisplayField({ "disabled": true });
    var workflow_buttons_disp5751 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5752 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5753 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      object_type5743.on('change',Lino.chooser_handler(object_id5744,'object_type'));
      master_type5745.on('change',Lino.chooser_handler(master_id5746,'master_type'));
      Lino.changes.Changes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id5739, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(changes.Changes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time5740, "header": "time", "sortable": true, "tooltip": "(changes.Changes.time) ", "width": Lino.chars2width(17) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type5741, "filter": { "type": "string" }, "header": "Change Type", "sortable": false, "tooltip": "(changes.Changes.type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user5742, "filter": { "type": "string" }, "header": "User", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(changes.Changes.user) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "object_type", "editable": true, "editor": object_type5743, "filter": { "type": "string" }, "header": "Object type", "renderer": Lino.fk_renderer('object_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.Changes.object_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "object_id", "editable": true, "editor": object_id5744, "filter": { "type": "string" }, "header": "object id", "sortable": false, "tooltip": "(changes.Changes.object_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "master_type", "editable": true, "editor": master_type5745, "filter": { "type": "string" }, "header": "Master type", "renderer": Lino.fk_renderer('master_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.Changes.master_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "master_id", "editable": true, "editor": master_id5746, "filter": { "type": "string" }, "header": "master id", "sortable": false, "tooltip": "(changes.Changes.master_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "diff", "editable": true, "editor": diff5747, "filter": { "type": "string" }, "header": "Changes", "sortable": false, "tooltip": "(changes.Changes.diff) ", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "changed_fields", "editable": true, "editor": changed_fields5748, "filter": { "type": "string" }, "header": "Fields", "sortable": true, "tooltip": "(changes.Changes.changed_fields) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "object", "editable": false, "header": "Object", "sortable": false, "tooltip": "(changes.Changes.object) The database object which has been modified.", "width": Lino.chars2width(11) }, { "colIndex": 11, "dataIndex": "master", "editable": false, "header": "Master", "sortable": false, "tooltip": "(changes.Changes.master) The database object which acts as \"master\".", "width": Lino.chars2width(11) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(changes.Changes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(changes.Changes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(changes.Changes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.changes.Changes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.Changes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/Changes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/Changes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/Changes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/Changes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/Changes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.Changes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/Changes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.changes.Changes.detailPanel = Ext.extend(Lino.changes.Changes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/changes/Changes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.Changes.detail;
    Lino.changes.Changes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.Changes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.Changes.detailPanel(p);
});
Lino.changes.Changes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.changes.Changes.ParamsPanel({});
  return new Lino.changes.Changes.GridPanel(p);
});

// js_render_GridPanel_class users.Users
Lino.users.Users.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/Users",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/Users','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/Users','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/users/Users','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/Users','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/Users','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  cell_edit : true,
  title : "Users",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 30,
  ls_store_fields : [ { "name": "username" }, { "name": "profile" }, 'profileHidden', { "name": "first_name" }, { "name": "last_name" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "modified" }, { "name": "created" }, { "name": "password" }, { "name": "last_login" }, { "name": "initials" }, { "name": "remarks" }, { "name": "access_class" }, 'access_classHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "notify_myself", "type": "boolean" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "partner" }, 'partnerHidden', { "name": "name_column" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.Users.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    var ww = this.containing_window;
    var username5755 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var profile5756 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var first_name5757 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var last_name5758 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var id5759 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5760 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5761 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var modified5762 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created5763 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var password5764 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 128, "selectOnFocus": true });
    var last_login5765 = new Ext.form.DisplayField({ "hidden": true, "selectOnFocus": true, "value": "<br>" });
    var initials5766 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var remarks5767 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class5768 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.AccessClasses });
    var event_type5769 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/event_type" }) }) });
    var notify_myself5770 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mail_mode5771 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var partner5772 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/Users/partner" }) }) });
    var name_column_disp5773 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5774 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5775 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5776 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp5777 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username5755, "filter": { "type": "string" }, "header": "Username", "sortable": true, "tooltip": "(users.Users.username) Must be unique. Leaving this empty means that the user cannot log in.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "profile", "editable": true, "editor": profile5756, "filter": { "type": "string" }, "header": "User type", "sortable": false, "tooltip": "(users.Users.profile) The profile of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "first_name", "editable": true, "editor": first_name5757, "filter": { "type": "string" }, "header": "First name", "sortable": true, "tooltip": "(users.Users.first_name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "last_name", "editable": true, "editor": last_name5758, "filter": { "type": "string" }, "header": "Last name", "sortable": true, "tooltip": "(users.Users.last_name) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5759, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(users.Users.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "email", "editable": true, "editor": email5760, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(users.Users.email) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language5761, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(users.Users.language) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(users.Users.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(users.Users.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "password", "editable": true, "editor": password5764, "filter": { "type": "string" }, "header": "password", "hidden": true, "sortable": true, "tooltip": "(users.Users.password) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "last_login", "editable": true, "editor": last_login5765, "header": "last login", "hidden": true, "sortable": true, "tooltip": "(users.Users.last_login) Not used in Lino.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "initials", "editable": true, "editor": initials5766, "filter": { "type": "string" }, "header": "Initials", "hidden": true, "sortable": true, "tooltip": "(users.Users.initials) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "remarks", "editable": true, "editor": remarks5767, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(users.Users.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "access_class", "editable": true, "editor": access_class5768, "filter": { "type": "string" }, "header": "Default access class", "hidden": true, "sortable": false, "tooltip": "(users.Users.access_class) The default access class for your calendar events and tasks.", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "event_type", "editable": true, "editor": event_type5769, "filter": { "type": "string" }, "header": "Default Event Type", "hidden": true, "sortable": false, "tooltip": "(users.Users.event_type) The default event type for your calendar events.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "notify_myself", "editable": true, "filter": { "type": "boolean" }, "header": "Notify myself", "hidden": true, "sortable": false, "tooltip": "(users.Users.notify_myself) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode5771, "filter": { "type": "string" }, "header": "Email notification mode", "hidden": true, "sortable": false, "tooltip": "(users.Users.mail_mode) ", "width": Lino.chars2width(15) }, { "colIndex": 17, "dataIndex": "partner", "editable": true, "editor": partner5772, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(users.Users.partner) Pointer to the Partner instance related to\nthis user.", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(users.Users.name_column) ", "width": Lino.chars2width(16) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(users.Users.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(users.Users.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(users.Users.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(users.Users.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.users.Users.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Users.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.Users.insertPanel = Ext.extend(Lino.users.Users.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/users/Users",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.Users.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.Users.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Users.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.Users.insertPanel(p);
});
Lino.users.Users.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.Users.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/Users",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.Users.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.Users.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.Users.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.users.Users.detailPanel(p);
});
Lino.users.Users.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.Users.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Users.ParamsPanel({});
  return new Lino.users.Users.GridPanel(p);
});
Lino.users.Users.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/Users", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.UsersOverview
Lino.users.UsersOverview.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/UsersOverview",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/UsersOverview','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  cell_edit : true,
  title : "Users",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "username" }, { "name": "profile" }, 'profileHidden', { "name": "language" }, 'languageHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.UsersOverview.detail;
    this.ls_insert_handler = Lino.users.UsersOverview.insert;
    var ww = this.containing_window;
    var username5803 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var profile5804 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var language5805 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username5803, "filter": { "type": "string" }, "header": "Username", "sortable": true, "tooltip": "(users.UsersOverview.username) Must be unique. Leaving this empty means that the user cannot log in.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "profile", "editable": true, "editor": profile5804, "filter": { "type": "string" }, "header": "User type", "sortable": false, "tooltip": "(users.UsersOverview.profile) The profile of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "language", "editable": true, "editor": language5805, "filter": { "type": "string" }, "header": "Language", "sortable": false, "tooltip": "(users.UsersOverview.language) ", "width": Lino.chars2width(21) } ];
    Lino.users.UsersOverview.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UsersOverview.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.UsersOverview.insertPanel = Ext.extend(Lino.users.Users.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/users/UsersOverview",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.UsersOverview.detail;
    this.ls_insert_handler = Lino.users.UsersOverview.insert;
    Lino.users.UsersOverview.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UsersOverview.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.UsersOverview.insertPanel(p);
});
Lino.users.UsersOverview.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.UsersOverview.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/UsersOverview",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.UsersOverview.detail;
    this.ls_insert_handler = Lino.users.UsersOverview.insert;
    Lino.users.UsersOverview.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.UsersOverview.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.users.UsersOverview.detailPanel(p);
});
Lino.users.UsersOverview.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.UsersOverview.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Users.ParamsPanel({});
  return new Lino.users.UsersOverview.GridPanel(p);
});
Lino.users.UsersOverview.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/UsersOverview", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.MySettings
Lino.users.MySettings.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/MySettings",
  ls_bbar_actions : [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  cell_edit : true,
  title : "Users",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 30,
  ls_store_fields : [ { "name": "username" }, { "name": "profile" }, 'profileHidden', { "name": "first_name" }, { "name": "last_name" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "modified" }, { "name": "created" }, { "name": "password" }, { "name": "last_login" }, { "name": "initials" }, { "name": "remarks" }, { "name": "access_class" }, 'access_classHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "notify_myself", "type": "boolean" }, { "name": "mail_mode" }, 'mail_modeHidden', { "name": "partner" }, 'partnerHidden', { "name": "name_column" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 2,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.users.MySettings.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    var ww = this.containing_window;
    var username5807 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var profile5808 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.users.UserTypes) });
    var first_name5809 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var last_name5810 = new Ext.form.TextField({ "maxLength": 30, "selectOnFocus": true });
    var id5811 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email5812 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language5813 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var modified5814 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created5815 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var password5816 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 128, "selectOnFocus": true });
    var last_login5817 = new Ext.form.DisplayField({ "hidden": true, "selectOnFocus": true, "value": "<br>" });
    var initials5818 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var remarks5819 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class5820 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.AccessClasses });
    var event_type5821 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/MySettings/event_type" }) }) });
    var notify_myself5822 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var mail_mode5823 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.notify.MailModes });
    var partner5824 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/MySettings/partner" }) }) });
    var name_column_disp5825 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp5826 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5827 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5828 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp5829 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "username", "editable": true, "editor": username5807, "filter": { "type": "string" }, "header": "Username", "sortable": true, "tooltip": "(users.MySettings.username) Must be unique. Leaving this empty means that the user cannot log in.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "profile", "editable": true, "editor": profile5808, "filter": { "type": "string" }, "header": "User type", "sortable": false, "tooltip": "(users.MySettings.profile) The profile of a user is what defines her or his permissions.", "width": Lino.chars2width(23) }, { "colIndex": 2, "dataIndex": "first_name", "editable": true, "editor": first_name5809, "filter": { "type": "string" }, "header": "First name", "sortable": true, "tooltip": "(users.MySettings.first_name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "last_name", "editable": true, "editor": last_name5810, "filter": { "type": "string" }, "header": "Last name", "sortable": true, "tooltip": "(users.MySettings.last_name) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id5811, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "email", "editable": true, "editor": email5812, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.email) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "language", "editable": true, "editor": language5813, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.language) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "password", "editable": true, "editor": password5816, "filter": { "type": "string" }, "header": "password", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.password) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "last_login", "editable": true, "editor": last_login5817, "header": "last login", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.last_login) Not used in Lino.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "initials", "editable": true, "editor": initials5818, "filter": { "type": "string" }, "header": "Initials", "hidden": true, "sortable": true, "tooltip": "(users.MySettings.initials) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "remarks", "editable": true, "editor": remarks5819, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 13, "dataIndex": "access_class", "editable": true, "editor": access_class5820, "filter": { "type": "string" }, "header": "Default access class", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.access_class) The default access class for your calendar events and tasks.", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "event_type", "editable": true, "editor": event_type5821, "filter": { "type": "string" }, "header": "Default Event Type", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.event_type) The default event type for your calendar events.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "notify_myself", "editable": true, "filter": { "type": "boolean" }, "header": "Notify myself", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.notify_myself) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "mail_mode", "editable": true, "editor": mail_mode5823, "filter": { "type": "string" }, "header": "Email notification mode", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.mail_mode) ", "width": Lino.chars2width(15) }, { "colIndex": 17, "dataIndex": "partner", "editable": true, "editor": partner5824, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(users.MySettings.partner) Pointer to the Partner instance related to\nthis user.", "width": Lino.chars2width(21) }, { "colIndex": 18, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.name_column) ", "width": Lino.chars2width(16) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(users.MySettings.created_natural) ", "width": Lino.chars2width(31) } ];
    Lino.users.MySettings.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.MySettings.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.MySettings.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.users.MySettings.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Users",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/MySettings",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.MySettings.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.MySettings.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.MySettings.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.MySettings.detailPanel(p);
});

Lino.users.MySettings.detailPanel = Ext.extend(Lino.users.Users.DetailFormPanel,{
  empty_title: "Users",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "change_password", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Change the password of this user.") }, "menu_item_text": "Change password", "overflowText": "Change password", "panel_btn_handler": Lino.param_action_handler(Lino.users.Users.change_password), "text": " <font size=\"4\">\u2731</font>" } ],
  ls_url: "/users/MySettings",
  initComponent : function() {
    this.ls_detail_handler = Lino.users.MySettings.detail;
    this.ls_insert_handler = Lino.users.Users.insert;
    Lino.users.MySettings.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.users.MySettings.detail = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.users.MySettings.detailPanel(p);
});
Lino.users.MySettings.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/MySettings", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Lines
Lino.courses.Lines.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Lines",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Lines','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Activity lines",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 41,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "topic" }, 'topicHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "guest_role" }, 'guest_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "excerpt_title" }, { "name": "excerpt_title_de" }, { "name": "excerpt_title_fr" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "fee" }, 'feeHidden', { "name": "options_cat" }, 'options_catHidden', { "name": "fees_cat" }, 'fees_catHidden', { "name": "body_template" }, { "name": "course_type" }, 'course_typeHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 15,
  ls_grid_configs : [  ],
  content_type : 57,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Lines.detail;
    this.ls_insert_handler = Lino.courses.Lines.insert;
    var ww = this.containing_window;
    var ref5856 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name5857 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de5858 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr5859 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var topic5860 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Topic...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/topic" }) }) });
    var course_area5861 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var event_type5862 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/event_type" }) }) });
    var guest_role5863 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/guest_role" }) }) });
    var every_unit5864 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5865 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var id5866 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var company5867 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/company" }) }) });
    var contact_person5868 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/contact_person" }) }) });
    var contact_role5869 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/contact_role" }) }) });
    var excerpt_title5870 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_de5871 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_fr5872 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description5873 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5874 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5875 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee5876 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fee" }) }) });
    var options_cat5877 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/options_cat" }) }) });
    var fees_cat5878 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/fees_cat" }) }) });
    var body_template5879 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/body_template" }) }) });
    var course_type5880 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Activity type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Lines/course_type" }) }) });
    var workflow_buttons_disp5881 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp5882 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5883 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person5868.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      fee5876.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company5867.on('change',Lino.chooser_handler(contact_person5868,'company'));
      fees_cat5878.on('change',Lino.chooser_handler(fee5876,'fees_cat'));
      Lino.courses.Lines.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref5856, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.Lines.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name5857, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.Lines.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de5858, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(courses.Lines.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr5859, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(courses.Lines.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "topic", "editable": true, "editor": topic5860, "filter": { "type": "string" }, "header": "Topic", "sortable": false, "tooltip": "(courses.Lines.topic) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course_area", "editable": true, "editor": course_area5861, "filter": { "type": "string" }, "header": "Layout", "sortable": false, "tooltip": "(courses.Lines.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.", "width": Lino.chars2width(14) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type5862, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(courses.Lines.event_type) The type of calendar events to be generated. If this is empty, no calendar events will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "guest_role", "editable": true, "editor": guest_role5863, "filter": { "type": "string" }, "header": "Manage presences as", "renderer": Lino.fk_renderer('guest_roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(courses.Lines.guest_role) The default guest role for particpants of events for courses in this series. Leave empty if you don't want any presence management.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "every_unit", "editable": true, "editor": every_unit5864, "filter": { "type": "string" }, "header": "Recurrency", "sortable": false, "tooltip": "(courses.Lines.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 9, "dataIndex": "every", "editable": true, "editor": every5865, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "sortable": true, "tooltip": "(courses.Lines.every) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id5866, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.id) ", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "company", "editable": true, "editor": company5867, "filter": { "type": "string" }, "header": "Company", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(courses.Lines.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_person", "editable": true, "editor": contact_person5868, "filter": { "type": "string" }, "header": "represented by", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(courses.Lines.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "contact_role", "editable": true, "editor": contact_role5869, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "excerpt_title", "editable": true, "editor": excerpt_title5870, "filter": { "type": "string" }, "header": "Excerpt title", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.excerpt_title) The title to be used when printing an excerpt.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "excerpt_title_de", "editable": true, "editor": excerpt_title_de5871, "filter": { "type": "string" }, "header": "Excerpt title (de)", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.excerpt_title_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "excerpt_title_fr", "editable": true, "editor": excerpt_title_fr5872, "filter": { "type": "string" }, "header": "Excerpt title (fr)", "hidden": true, "sortable": true, "tooltip": "(courses.Lines.excerpt_title_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description5873, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "description_de", "editable": true, "editor": description_de5874, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "description_fr", "editable": true, "editor": description_fr5875, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee5876, "filter": { "type": "string" }, "header": "Participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Lines.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "options_cat", "editable": true, "editor": options_cat5877, "filter": { "type": "string" }, "header": "Options category", "hidden": true, "renderer": Lino.fk_renderer('options_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.Lines.options_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "fees_cat", "editable": true, "editor": fees_cat5878, "filter": { "type": "string" }, "header": "Fees category", "hidden": true, "renderer": Lino.fk_renderer('fees_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.Lines.fees_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "body_template", "editable": true, "editor": body_template5879, "filter": { "type": "string" }, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "course_type", "editable": true, "editor": course_type5880, "filter": { "type": "string" }, "header": "Activity type", "hidden": true, "renderer": Lino.fk_renderer('course_typeHidden','Lino.courses.CourseTypes.detail'), "sortable": false, "tooltip": "(courses.Lines.course_type) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Lines.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Lines.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Lines.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Lines.insertPanel = Ext.extend(Lino.courses.Lines.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Lines",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Lines.detail;
    this.ls_insert_handler = Lino.courses.Lines.insert;
    Lino.courses.Lines.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Lines.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(16), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Lines.insertPanel(p);
});
Lino.courses.Lines.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Lines.detailPanel = Ext.extend(Lino.courses.Lines.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/courses/Lines",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Lines.detail;
    this.ls_insert_handler = Lino.courses.Lines.insert;
    Lino.courses.Lines.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Lines.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Lines.detailPanel(p);
});
Lino.courses.Lines.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Lines.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Lines.GridPanel(p);
});
Lino.courses.Lines.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Lines", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Activities
Lino.courses.Activities.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Activities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Activities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "room" }, 'roomHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Activities.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    var ww = this.containing_window;
    var start_date5885 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until5886 = new Lino.DateField({ "selectOnFocus": true });
    var line5887 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/line" }) }) });
    var teacher5888 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/teacher" }) }) });
    var room5889 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/room" }) }) });
    var workflow_buttons_disp5890 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5891 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5892 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_time5893 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5894 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5895 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5896 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/user" }) }) });
    var every_unit5897 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5898 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5899 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5900 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5901 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5902 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5903 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5904 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5905 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5906 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5907 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot5908 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/slot" }) }) });
    var description5909 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5910 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5911 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5912 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5913 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5914 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5915 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var fee5916 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/fee" }) }) });
    var payment_term5917 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/payment_term" }) }) });
    var paper_type5918 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Activities/paper_type" }) }) });
    var overview_disp5919 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5920 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5921 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5922 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5923 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5924 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5925 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5926 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying5927 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5928 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp5929 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5930 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp5931 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5932 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5916.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5926.refresh();
    };
    this.onRender = function(ct, position) {
      line5887.on('change',Lino.chooser_handler(fee5916,'line'));
      Lino.courses.Activities.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date5885, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.Activities.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5886, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "sortable": true, "tooltip": "(courses.Activities.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "line", "editable": true, "editor": line5887, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Activities.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "teacher", "editable": true, "editor": teacher5888, "filter": { "type": "string" }, "header": "Instructor", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Activities.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room5889, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.Activities.room) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.Activities.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id5891, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "ref", "editable": true, "editor": ref5892, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time5893, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date5894, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time5895, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user5896, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Activities.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit5897, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every5898, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.every) ", "width": Lino.chars2width(6) }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events5906, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5907, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot5908, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description5909, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de5910, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr5911, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark5912, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state5913, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places5914, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name5915, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.Activities.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5916, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Activities.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5917, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5918, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.Activities.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Activities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Activities.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Activities.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Activities",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Activities.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    Lino.courses.Activities.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Activities.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Activities.insertPanel(p);
});
Lino.courses.Activities.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Activities.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Activities",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Activities.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    Lino.courses.Activities.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Activities.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Activities.detailPanel(p);
});
Lino.courses.Activities.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Activities.GridPanel(p);
});
Lino.courses.Activities.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Activities.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Activities", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Courses
Lino.courses.Courses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Courses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Courses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Courses",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "room" }, 'roomHidden', { "name": "teacher" }, 'teacherHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Courses.detail;
    this.ls_insert_handler = Lino.courses.Courses.insert;
    var ww = this.containing_window;
    var ref5934 = new Ext.form.TextField({ "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date5935 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until5936 = new Lino.DateField({ "selectOnFocus": true });
    var line5937 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/line" }) }) });
    var room5938 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/room" }) }) });
    var teacher5939 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/teacher" }) }) });
    var workflow_buttons_disp5940 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5941 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time5942 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5943 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5944 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user5945 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/user" }) }) });
    var every_unit5946 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every5947 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday5948 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday5949 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday5950 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday5951 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday5952 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday5953 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday5954 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events5955 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date5956 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot5957 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/slot" }) }) });
    var description5958 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de5959 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr5960 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark5961 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state5962 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places5963 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name5964 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var fee5965 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/fee" }) }) });
    var payment_term5966 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/payment_term" }) }) });
    var paper_type5967 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Courses/paper_type" }) }) });
    var overview_disp5968 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp5969 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp5970 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments5971 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp5972 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested5973 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed5974 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox5975 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying5976 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places5977 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp5978 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp5979 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp5980 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration5981 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee5965.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox5975.refresh();
    };
    this.onRender = function(ct, position) {
      line5937.on('change',Lino.chooser_handler(fee5965,'line'));
      Lino.courses.Courses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref5934, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.Courses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date5935, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.Courses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until5936, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "sortable": true, "tooltip": "(courses.Courses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "line", "editable": true, "editor": line5937, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Courses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room5938, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.Courses.room) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "teacher", "editable": true, "editor": teacher5939, "filter": { "type": "string" }, "header": "Instructor", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Courses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.Courses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id5941, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time5942, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date5943, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time5944, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user5945, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Courses.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit5946, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every5947, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.every) ", "width": Lino.chars2width(6) }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events5955, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date5956, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot5957, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description5958, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de5959, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr5960, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark5961, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state5962, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places5963, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name5964, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.Courses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee5965, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Courses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term5966, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type5967, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.Courses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Courses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Courses.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Courses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Courses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Courses.detail;
    this.ls_insert_handler = Lino.courses.Courses.insert;
    Lino.courses.Courses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Courses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Courses.insertPanel(p);
});
Lino.courses.Courses.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Courses.detailPanel = Ext.extend(Lino.courses.Courses.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Courses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Courses.detail;
    this.ls_insert_handler = Lino.courses.Courses.insert;
    Lino.courses.Courses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Courses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Courses.detailPanel(p);
});
Lino.courses.Courses.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Courses.GridPanel(p);
});
Lino.courses.Courses.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Courses.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Courses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.AllActivities
Lino.courses.AllActivities.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/AllActivities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/AllActivities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 11,
  ls_store_fields : [ { "name": "line" }, 'lineHidden', { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "user" }, 'userHidden', { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllActivities.detail;
    this.ls_insert_handler = Lino.courses.AllActivities.insert;
    var ww = this.containing_window;
    var line5983 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllActivities/line" }) }) });
    var start_date5984 = new Lino.DateField({ "selectOnFocus": true });
    var teacher5985 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllActivities/teacher" }) }) });
    var user5986 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllActivities/user" }) }) });
    var weekdays_text_disp5987 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var times_text_disp5988 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "line", "editable": true, "editor": line5983, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.AllActivities.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date5984, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.AllActivities.start_date) ", "width": Lino.chars2width(9), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "teacher", "editable": true, "editor": teacher5985, "filter": { "type": "string" }, "header": "Instructor", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.AllActivities.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user5986, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.AllActivities.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "weekdays_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(courses.AllActivities.weekdays_text) ", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "times_text", "editable": false, "header": "Times", "sortable": false, "tooltip": "(courses.AllActivities.times_text) ", "width": Lino.chars2width(11) } ];
    Lino.courses.AllActivities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllActivities.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllActivities.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/AllActivities",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllActivities.detail;
    this.ls_insert_handler = Lino.courses.AllActivities.insert;
    Lino.courses.AllActivities.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllActivities.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.AllActivities.insertPanel(p);
});
Lino.courses.AllActivities.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllActivities.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/AllActivities",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllActivities.detail;
    this.ls_insert_handler = Lino.courses.AllActivities.insert;
    Lino.courses.AllActivities.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllActivities.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.AllActivities.detailPanel(p);
});
Lino.courses.AllActivities.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.AllActivities.GridPanel(p);
});
Lino.courses.AllActivities.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllActivities.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllActivities", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.MyActivities
Lino.courses.MyActivities.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/MyActivities",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/MyActivities','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "My Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "room" }, 'roomHidden', { "name": "name" }, { "name": "line" }, 'lineHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.MyActivities.detail;
    this.ls_insert_handler = Lino.courses.MyActivities.insert;
    var ww = this.containing_window;
    var start_date5990 = new Lino.DateField({ "selectOnFocus": true });
    var room5991 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/room" }) }) });
    var name5992 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var line5993 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/line" }) }) });
    var workflow_buttons_disp5994 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id5995 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref5996 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_time5997 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date5998 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time5999 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6000 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/user" }) }) });
    var every_unit6001 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6002 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6003 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6004 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6005 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6006 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6007 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6008 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6009 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6010 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date6011 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var teacher6012 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/teacher" }) }) });
    var slot6013 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/slot" }) }) });
    var description6014 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6015 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6016 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6017 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6018 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6019 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var enrolments_until6020 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee6021 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/fee" }) }) });
    var payment_term6022 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/payment_term" }) }) });
    var paper_type6023 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/MyActivities/paper_type" }) }) });
    var overview_disp6024 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6025 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6026 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments6027 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp6028 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6029 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6030 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6031 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6032 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places6033 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6034 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6035 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6036 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6037 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6021.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6031.refresh();
    };
    this.onRender = function(ct, position) {
      line5993.on('change',Lino.chooser_handler(fee6021,'line'));
      Lino.courses.MyActivities.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date5990, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.MyActivities.start_date) ", "width": Lino.chars2width(9), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "room", "editable": true, "editor": room5991, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.MyActivities.room) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name5992, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.MyActivities.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "line", "editable": true, "editor": line5993, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.MyActivities.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.MyActivities.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id5995, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref5996, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time5997, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date5998, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time5999, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user6000, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.MyActivities.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit6001, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every6002, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.every) ", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events6010, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 21, "dataIndex": "max_date", "editable": true, "editor": max_date6011, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 22, "dataIndex": "teacher", "editable": true, "editor": teacher6012, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.MyActivities.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot6013, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description6014, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de6015, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr6016, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark6017, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state6018, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places6019, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 30, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6020, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.MyActivities.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee6021, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.MyActivities.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term6022, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type6023, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.MyActivities.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.MyActivities.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.MyActivities.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.MyActivities.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/MyActivities",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.MyActivities.detail;
    this.ls_insert_handler = Lino.courses.MyActivities.insert;
    Lino.courses.MyActivities.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.MyActivities.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.MyActivities.insertPanel(p);
});
Lino.courses.MyActivities.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.MyActivities.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/MyActivities",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.MyActivities.detail;
    this.ls_insert_handler = Lino.courses.MyActivities.insert;
    Lino.courses.MyActivities.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.MyActivities.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.MyActivities.detailPanel(p);
});
Lino.courses.MyActivities.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.MyActivities.GridPanel(p);
});
Lino.courses.MyActivities.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.MyActivities.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/MyActivities", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.DraftCourses
Lino.courses.DraftCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/DraftCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/DraftCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Draft activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "overview" }, { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.DraftCourses.detail;
    this.ls_insert_handler = Lino.courses.DraftCourses.insert;
    var ww = this.containing_window;
    var overview_disp6039 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var room6040 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/room" }) }) });
    var id6041 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref6042 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date6043 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time6044 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date6045 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time6046 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6047 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/user" }) }) });
    var every_unit6048 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6049 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6050 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6051 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6052 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6053 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6054 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6055 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6056 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6057 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date6058 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line6059 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/line" }) }) });
    var teacher6060 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/teacher" }) }) });
    var slot6061 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/slot" }) }) });
    var description6062 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6063 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6064 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6065 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6066 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6067 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name6068 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until6069 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee6070 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/fee" }) }) });
    var payment_term6071 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/payment_term" }) }) });
    var paper_type6072 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/DraftCourses/paper_type" }) }) });
    var workflow_buttons_disp6073 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6074 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6075 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments6076 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp6077 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6078 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6079 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6080 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6081 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places6082 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6083 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6084 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6085 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6086 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6070.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6080.refresh();
    };
    this.onRender = function(ct, position) {
      line6059.on('change',Lino.chooser_handler(fee6070,'line'));
      Lino.courses.DraftCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(courses.DraftCourses.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "room", "editable": true, "editor": room6040, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.DraftCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id6041, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "ref", "editable": true, "editor": ref6042, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "start_date", "editable": true, "editor": start_date6043, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "start_time", "editable": true, "editor": start_time6044, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 6, "dataIndex": "end_date", "editable": true, "editor": end_date6045, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "end_time", "editable": true, "editor": end_time6046, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user6047, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "every_unit", "editable": true, "editor": every_unit6048, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 10, "dataIndex": "every", "editable": true, "editor": every6049, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.every) ", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 18, "dataIndex": "max_events", "editable": true, "editor": max_events6057, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 19, "dataIndex": "max_date", "editable": true, "editor": max_date6058, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 20, "dataIndex": "line", "editable": true, "editor": line6059, "filter": { "type": "string" }, "header": "Activity line", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "teacher", "editable": true, "editor": teacher6060, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "slot", "editable": true, "editor": slot6061, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "description", "editable": true, "editor": description6062, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 24, "dataIndex": "description_de", "editable": true, "editor": description_de6063, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_fr", "editable": true, "editor": description_fr6064, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "remark", "editable": true, "editor": remark6065, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "state", "editable": true, "editor": state6066, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 28, "dataIndex": "max_places", "editable": true, "editor": max_places6067, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 29, "dataIndex": "name", "editable": true, "editor": name6068, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6069, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.DraftCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee6070, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.DraftCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term6071, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type6072, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.DraftCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.DraftCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.DraftCourses.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.DraftCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/DraftCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.DraftCourses.detail;
    this.ls_insert_handler = Lino.courses.DraftCourses.insert;
    Lino.courses.DraftCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.DraftCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.DraftCourses.insertPanel(p);
});
Lino.courses.DraftCourses.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.DraftCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/DraftCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.DraftCourses.detail;
    this.ls_insert_handler = Lino.courses.DraftCourses.insert;
    Lino.courses.DraftCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.DraftCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.DraftCourses.detailPanel(p);
});
Lino.courses.DraftCourses.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.DraftCourses.GridPanel(p);
});
Lino.courses.DraftCourses.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.DraftCourses.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/DraftCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.ActiveCourses
Lino.courses.ActiveCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/ActiveCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/ActiveCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Current activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "overview" }, { "name": "enrolments" }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "teacher" }, 'teacherHidden', { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ActiveCourses.detail;
    this.ls_insert_handler = Lino.courses.ActiveCourses.insert;
    var ww = this.containing_window;
    var overview_disp6088 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var enrolments6089 = new Ext.form.NumberField({ "disabled": true });
    var free_places6090 = new Ext.form.NumberField({ "disabled": true });
    var teacher6091 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/teacher" }) }) });
    var room6092 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/room" }) }) });
    var id6093 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref6094 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date6095 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time6096 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date6097 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time6098 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6099 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/user" }) }) });
    var every_unit6100 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6101 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6102 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6103 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6104 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6105 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6106 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6107 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6108 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6109 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date6110 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line6111 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/line" }) }) });
    var slot6112 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/slot" }) }) });
    var description6113 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6114 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6115 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6116 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6117 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6118 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name6119 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until6120 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee6121 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/fee" }) }) });
    var payment_term6122 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/payment_term" }) }) });
    var paper_type6123 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ActiveCourses/paper_type" }) }) });
    var workflow_buttons_disp6124 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6125 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6126 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var print_actions_disp6127 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6128 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6129 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6130 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6131 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6132 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6133 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6134 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6135 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6121.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6130.refresh();
    };
    this.onRender = function(ct, position) {
      line6111.on('change',Lino.chooser_handler(fee6121,'line'));
      Lino.courses.ActiveCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(courses.ActiveCourses.overview) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "sortable": false, "tooltip": "(courses.ActiveCourses.enrolments) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "sortable": false, "tooltip": "(courses.ActiveCourses.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "teacher", "editable": true, "editor": teacher6091, "filter": { "type": "string" }, "header": "Instructor", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room6092, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.ActiveCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id6093, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref6094, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date6095, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time6096, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date6097, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time6098, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6099, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit6100, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every6101, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.every) ", "width": Lino.chars2width(6) }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events6109, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date6110, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "line", "editable": true, "editor": line6111, "filter": { "type": "string" }, "header": "Activity line", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot6112, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description6113, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de6114, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr6115, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark6116, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state6117, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places6118, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 31, "dataIndex": "name", "editable": true, "editor": name6119, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6120, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.ActiveCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 33, "dataIndex": "fee", "editable": true, "editor": fee6121, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.ActiveCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "payment_term", "editable": true, "editor": payment_term6122, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "paper_type", "editable": true, "editor": paper_type6123, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 38, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.events_text) ", "width": Lino.chars2width(31) }, { "colIndex": 39, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 40, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 41, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 42, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.trying) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.ActiveCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.ActiveCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ActiveCourses.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ActiveCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/ActiveCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ActiveCourses.detail;
    this.ls_insert_handler = Lino.courses.ActiveCourses.insert;
    Lino.courses.ActiveCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ActiveCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.ActiveCourses.insertPanel(p);
});
Lino.courses.ActiveCourses.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ActiveCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/ActiveCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ActiveCourses.detail;
    this.ls_insert_handler = Lino.courses.ActiveCourses.insert;
    Lino.courses.ActiveCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ActiveCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.ActiveCourses.detailPanel(p);
});
Lino.courses.ActiveCourses.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.ActiveCourses.GridPanel(p);
});
Lino.courses.ActiveCourses.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ActiveCourses.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ActiveCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.InactiveCourses
Lino.courses.InactiveCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/InactiveCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/InactiveCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Inactive courses",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "overview" }, { "name": "enrolments" }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.InactiveCourses.detail;
    this.ls_insert_handler = Lino.courses.InactiveCourses.insert;
    var ww = this.containing_window;
    var overview_disp6137 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var enrolments6138 = new Ext.form.NumberField({ "disabled": true });
    var free_places6139 = new Ext.form.NumberField({ "disabled": true });
    var room6140 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/room" }) }) });
    var id6141 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref6142 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date6143 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time6144 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date6145 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time6146 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6147 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/user" }) }) });
    var every_unit6148 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6149 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6150 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6151 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6152 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6153 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6154 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6155 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6156 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6157 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date6158 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line6159 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/line" }) }) });
    var teacher6160 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/teacher" }) }) });
    var slot6161 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/slot" }) }) });
    var description6162 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6163 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6164 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6165 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6166 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6167 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name6168 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until6169 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee6170 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/fee" }) }) });
    var payment_term6171 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/payment_term" }) }) });
    var paper_type6172 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/InactiveCourses/paper_type" }) }) });
    var workflow_buttons_disp6173 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6174 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6175 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var print_actions_disp6176 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6177 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6178 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6179 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6180 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6181 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6182 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6183 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6184 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6170.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6179.refresh();
    };
    this.onRender = function(ct, position) {
      line6159.on('change',Lino.chooser_handler(fee6170,'line'));
      Lino.courses.InactiveCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(courses.InactiveCourses.overview) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "sortable": false, "tooltip": "(courses.InactiveCourses.enrolments) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 2, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "sortable": false, "tooltip": "(courses.InactiveCourses.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "room", "editable": true, "editor": room6140, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.InactiveCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id6141, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "ref", "editable": true, "editor": ref6142, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date6143, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time6144, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date6145, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time6146, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user6147, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit6148, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every6149, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.every) ", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events6157, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 21, "dataIndex": "max_date", "editable": true, "editor": max_date6158, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 22, "dataIndex": "line", "editable": true, "editor": line6159, "filter": { "type": "string" }, "header": "Activity line", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "teacher", "editable": true, "editor": teacher6160, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot6161, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description6162, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de6163, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr6164, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark6165, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state6166, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places6167, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 31, "dataIndex": "name", "editable": true, "editor": name6168, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6169, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.InactiveCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 33, "dataIndex": "fee", "editable": true, "editor": fee6170, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.InactiveCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "payment_term", "editable": true, "editor": payment_term6171, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "paper_type", "editable": true, "editor": paper_type6172, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 38, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.events_text) ", "width": Lino.chars2width(31) }, { "colIndex": 39, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 40, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 41, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 42, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.trying) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.InactiveCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.InactiveCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.InactiveCourses.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.InactiveCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/InactiveCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.InactiveCourses.detail;
    this.ls_insert_handler = Lino.courses.InactiveCourses.insert;
    Lino.courses.InactiveCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.InactiveCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.InactiveCourses.insertPanel(p);
});
Lino.courses.InactiveCourses.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.InactiveCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/InactiveCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.InactiveCourses.detail;
    this.ls_insert_handler = Lino.courses.InactiveCourses.insert;
    Lino.courses.InactiveCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.InactiveCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.InactiveCourses.detailPanel(p);
});
Lino.courses.InactiveCourses.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.InactiveCourses.GridPanel(p);
});
Lino.courses.InactiveCourses.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.InactiveCourses.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/InactiveCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.ClosedCourses
Lino.courses.ClosedCourses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/ClosedCourses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/ClosedCourses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Closed courses",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "overview" }, { "name": "enrolments" }, { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ClosedCourses.detail;
    this.ls_insert_handler = Lino.courses.ClosedCourses.insert;
    var ww = this.containing_window;
    var overview_disp6186 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var enrolments6187 = new Ext.form.NumberField({ "disabled": true });
    var room6188 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/room" }) }) });
    var id6189 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref6190 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date6191 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time6192 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date6193 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time6194 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6195 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/user" }) }) });
    var every_unit6196 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6197 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6198 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6199 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6200 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6201 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6202 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6203 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6204 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6205 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date6206 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line6207 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/line" }) }) });
    var teacher6208 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/teacher" }) }) });
    var slot6209 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/slot" }) }) });
    var description6210 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6211 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6212 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6213 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6214 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6215 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name6216 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until6217 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee6218 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/fee" }) }) });
    var payment_term6219 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/payment_term" }) }) });
    var paper_type6220 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/ClosedCourses/paper_type" }) }) });
    var workflow_buttons_disp6221 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6222 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6223 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var print_actions_disp6224 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6225 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6226 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6227 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6228 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places6229 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6230 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6231 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6232 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6233 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6218.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6227.refresh();
    };
    this.onRender = function(ct, position) {
      line6207.on('change',Lino.chooser_handler(fee6218,'line'));
      Lino.courses.ClosedCourses.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(courses.ClosedCourses.overview) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "sortable": false, "tooltip": "(courses.ClosedCourses.enrolments) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room6188, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.ClosedCourses.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6189, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "ref", "editable": true, "editor": ref6190, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "start_date", "editable": true, "editor": start_date6191, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time6192, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date6193, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "end_time", "editable": true, "editor": end_time6194, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "user", "editable": true, "editor": user6195, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "every_unit", "editable": true, "editor": every_unit6196, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 11, "dataIndex": "every", "editable": true, "editor": every6197, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.every) ", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 19, "dataIndex": "max_events", "editable": true, "editor": max_events6205, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "max_date", "editable": true, "editor": max_date6206, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 21, "dataIndex": "line", "editable": true, "editor": line6207, "filter": { "type": "string" }, "header": "Activity line", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "teacher", "editable": true, "editor": teacher6208, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot6209, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description6210, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de6211, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr6212, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark6213, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state6214, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places6215, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name6216, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6217, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.ClosedCourses.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 32, "dataIndex": "fee", "editable": true, "editor": fee6218, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.ClosedCourses.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "payment_term", "editable": true, "editor": payment_term6219, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "paper_type", "editable": true, "editor": paper_type6220, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.events_text) ", "width": Lino.chars2width(31) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.ClosedCourses.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.ClosedCourses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ClosedCourses.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ClosedCourses.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/ClosedCourses",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ClosedCourses.detail;
    this.ls_insert_handler = Lino.courses.ClosedCourses.insert;
    Lino.courses.ClosedCourses.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ClosedCourses.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.ClosedCourses.insertPanel(p);
});
Lino.courses.ClosedCourses.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.ClosedCourses.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/ClosedCourses",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.ClosedCourses.detail;
    this.ls_insert_handler = Lino.courses.ClosedCourses.insert;
    Lino.courses.ClosedCourses.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.ClosedCourses.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.ClosedCourses.detailPanel(p);
});
Lino.courses.ClosedCourses.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.ClosedCourses.GridPanel(p);
});
Lino.courses.ClosedCourses.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.ClosedCourses.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/ClosedCourses", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Enrolments
Lino.courses.Enrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Enrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Enrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "workflow_buttons" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "option" }, 'optionHidden', { "name": "remark" }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Enrolments.detail;
    this.ls_insert_handler = Lino.courses.Enrolments.insert;
    var ww = this.containing_window;
    var request_date6235 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course6236 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/course" }) }) });
    var pupil6237 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/pupil" }) }) });
    var workflow_buttons_disp6238 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user6239 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/user" }) }) });
    var id6240 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date6241 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date6242 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var printed_by6243 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6244 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6245 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places6246 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var option6247 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/option" }) }) });
    var remark6248 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var confirmation_details6249 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount6250 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee6251 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Enrolments/fee" }) }) });
    var free_events6252 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6253 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp6254 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6255 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6256 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6257 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6258 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course6236.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6236.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil6237.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option6247.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee6251.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox6253.refresh();
    };
    this.onRender = function(ct, position) {
      course_area6244.on('change',Lino.chooser_handler(course6236,'course_area'));
      request_date6235.on('change',Lino.chooser_handler(course6236,'request_date'));
      course6236.on('change',Lino.chooser_handler(pupil6237,'course'));
      course6236.on('change',Lino.chooser_handler(option6247,'course'));
      course6236.on('change',Lino.chooser_handler(fee6251,'course'));
      Lino.courses.Enrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6235, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.Enrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course6236, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.Enrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "pupil", "editable": true, "editor": pupil6237, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.Enrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.Enrolments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user6239, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Enrolments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id6240, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date6241, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date6242, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.Enrolments.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state6245, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "places", "editable": true, "editor": places6246, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.places) The number of participants in this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "option", "editable": true, "editor": option6247, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Enrolments.option) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "remark", "editable": true, "editor": remark6248, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6249, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 15, "dataIndex": "amount", "editable": true, "editor": amount6250, "filter": { "type": "numeric" }, "header": "Amount", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 16, "dataIndex": "fee", "editable": true, "editor": fee6251, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Enrolments.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 17, "dataIndex": "free_events", "editable": true, "editor": free_events6252, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.Enrolments.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 18, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.Enrolments.printed) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Enrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Enrolments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Enrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Enrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Enrolments.detail;
    this.ls_insert_handler = Lino.courses.Enrolments.insert;
    Lino.courses.Enrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Enrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Enrolments.insertPanel(p);
});
Lino.courses.Enrolments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Enrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/Enrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Enrolments.detail;
    this.ls_insert_handler = Lino.courses.Enrolments.insert;
    Lino.courses.Enrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Enrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Enrolments.detailPanel(p);
});
Lino.courses.Enrolments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.Enrolments.GridPanel(p);
});
Lino.courses.Enrolments.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Enrolments.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Enrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.AllEnrolments
Lino.courses.AllEnrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/AllEnrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/AllEnrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 41,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "pupil__birth_date" }, { "name": "pupil__age" }, { "name": "pupil__country" }, 'pupil__countryHidden', { "name": "pupil__city" }, 'pupil__cityHidden', { "name": "pupil__gender" }, 'pupil__genderHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "option" }, 'optionHidden', { "name": "remark" }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllEnrolments.detail;
    this.ls_insert_handler = Lino.courses.AllEnrolments.insert;
    var ww = this.containing_window;
    var id6260 = new Ext.form.NumberField({ "selectOnFocus": true });
    var request_date6261 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var start_date6262 = new Lino.DateField({ "selectOnFocus": true });
    var end_date6263 = new Lino.DateField({ "selectOnFocus": true });
    var user6264 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/user" }) }) });
    var course6265 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/course" }) }) });
    var pupil6266 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/pupil" }) }) });
    var pupil__birth_date6267 = new Lino.IncompleteDateField({ "disabled": true, "sortable": false });
    var pupil__age_disp6268 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "sortable": false, "value": "<br/>" });
    var pupil__country6269 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Country...", "pageSize": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    var pupil__city6270 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Place...", "pageSize": 20, "sortable": false, "store": new Lino.ComplexRemoteComboStore({  }) });
    var pupil__gender6271 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "disabled": true, "maxLength": 10, "sortable": false });
    var printed_by6272 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6273 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6274 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places6275 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var option6276 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/option" }) }) });
    var remark6277 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var confirmation_details6278 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount6279 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee6280 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/AllEnrolments/fee" }) }) });
    var free_events6281 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6282 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp6283 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6284 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6285 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6286 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6287 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6288 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course6265.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6265.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil6266.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option6276.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee6280.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox6282.refresh();
    };
    this.onRender = function(ct, position) {
      course_area6273.on('change',Lino.chooser_handler(course6265,'course_area'));
      request_date6261.on('change',Lino.chooser_handler(course6265,'request_date'));
      course6265.on('change',Lino.chooser_handler(pupil6266,'course'));
      course6265.on('change',Lino.chooser_handler(option6276,'course'));
      course6265.on('change',Lino.chooser_handler(fee6280,'course'));
      Lino.courses.AllEnrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6260, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.AllEnrolments.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "request_date", "editable": true, "editor": request_date6261, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.AllEnrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date6262, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.AllEnrolments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date6263, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "sortable": true, "tooltip": "(courses.AllEnrolments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user6264, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course", "editable": true, "editor": course6265, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "pupil", "editable": true, "editor": pupil6266, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "pupil__birth_date", "editable": false, "filter": { "type": "string" }, "header": "Birth date", "sortable": true, "tooltip": "(courses.AllEnrolments.pupil__birth_date) ", "width": Lino.chars2width(13) }, { "colIndex": 8, "dataIndex": "pupil__age", "editable": false, "header": "Age", "sortable": false, "tooltip": "(courses.AllEnrolments.pupil__age) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "pupil__country", "editable": false, "filter": { "type": "string" }, "header": "Country", "sortable": false, "tooltip": "(courses.AllEnrolments.pupil__country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "pupil__city", "editable": false, "filter": { "type": "string" }, "header": "City", "sortable": false, "tooltip": "(courses.AllEnrolments.pupil__city) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "pupil__gender", "editable": false, "filter": { "type": "string" }, "header": "Gender", "sortable": true, "tooltip": "(courses.AllEnrolments.pupil__gender) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6274, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 15, "dataIndex": "places", "editable": true, "editor": places6275, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.places) The number of participants in this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 16, "dataIndex": "option", "editable": true, "editor": option6276, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.option) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "remark", "editable": true, "editor": remark6277, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6278, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 19, "dataIndex": "amount", "editable": true, "editor": amount6279, "filter": { "type": "numeric" }, "header": "Amount", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee6280, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.AllEnrolments.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 21, "dataIndex": "free_events", "editable": true, "editor": free_events6281, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.AllEnrolments.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.AllEnrolments.printed) ", "width": Lino.chars2width(31) } ];
    Lino.courses.AllEnrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllEnrolments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllEnrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/AllEnrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllEnrolments.detail;
    this.ls_insert_handler = Lino.courses.AllEnrolments.insert;
    Lino.courses.AllEnrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllEnrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.AllEnrolments.insertPanel(p);
});
Lino.courses.AllEnrolments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.AllEnrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/AllEnrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.AllEnrolments.detail;
    this.ls_insert_handler = Lino.courses.AllEnrolments.insert;
    Lino.courses.AllEnrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.AllEnrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.AllEnrolments.detailPanel(p);
});
Lino.courses.AllEnrolments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.AllEnrolments.GridPanel(p);
});
Lino.courses.AllEnrolments.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.AllEnrolments.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/AllEnrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PendingConfirmedEnrolments
Lino.courses.PendingConfirmedEnrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PendingConfirmedEnrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PendingConfirmedEnrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Pending confirmed enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "workflow_buttons" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "option" }, 'optionHidden', { "name": "remark" }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingConfirmedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingConfirmedEnrolments.insert;
    var ww = this.containing_window;
    var request_date6290 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course6291 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/course" }) }) });
    var pupil6292 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/pupil" }) }) });
    var workflow_buttons_disp6293 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var user6294 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/user" }) }) });
    var id6295 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date6296 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date6297 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var printed_by6298 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6299 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6300 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places6301 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var option6302 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/option" }) }) });
    var remark6303 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var confirmation_details6304 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount6305 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee6306 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingConfirmedEnrolments/fee" }) }) });
    var free_events6307 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6308 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp6309 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6310 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6311 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6312 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6313 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course6291.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6291.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil6292.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option6302.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee6306.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox6308.refresh();
    };
    this.onRender = function(ct, position) {
      course_area6299.on('change',Lino.chooser_handler(course6291,'course_area'));
      request_date6290.on('change',Lino.chooser_handler(course6291,'request_date'));
      course6291.on('change',Lino.chooser_handler(pupil6292,'course'));
      course6291.on('change',Lino.chooser_handler(option6302,'course'));
      course6291.on('change',Lino.chooser_handler(fee6306,'course'));
      Lino.courses.PendingConfirmedEnrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6290, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course6291, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "pupil", "editable": true, "editor": pupil6292, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user6294, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id6295, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date6296, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date6297, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state6300, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "places", "editable": true, "editor": places6301, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.places) The number of participants in this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "option", "editable": true, "editor": option6302, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.option) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "remark", "editable": true, "editor": remark6303, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6304, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 15, "dataIndex": "amount", "editable": true, "editor": amount6305, "filter": { "type": "numeric" }, "header": "Amount", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 16, "dataIndex": "fee", "editable": true, "editor": fee6306, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 17, "dataIndex": "free_events", "editable": true, "editor": free_events6307, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.PendingConfirmedEnrolments.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 18, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.PendingConfirmedEnrolments.printed) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PendingConfirmedEnrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingConfirmedEnrolments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingConfirmedEnrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/PendingConfirmedEnrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingConfirmedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingConfirmedEnrolments.insert;
    Lino.courses.PendingConfirmedEnrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingConfirmedEnrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PendingConfirmedEnrolments.insertPanel(p);
});
Lino.courses.PendingConfirmedEnrolments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingConfirmedEnrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/PendingConfirmedEnrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingConfirmedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingConfirmedEnrolments.insert;
    Lino.courses.PendingConfirmedEnrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingConfirmedEnrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PendingConfirmedEnrolments.detailPanel(p);
});
Lino.courses.PendingConfirmedEnrolments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.PendingConfirmedEnrolments.GridPanel(p);
});
Lino.courses.PendingConfirmedEnrolments.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingConfirmedEnrolments.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingConfirmedEnrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.TeacherTypes
Lino.courses.TeacherTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/TeacherTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/TeacherTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  cell_edit : true,
  title : "Instructor Types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 9,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 55,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeacherTypes.detail;
    this.ls_insert_handler = Lino.courses.TeacherTypes.insert;
    var ww = this.containing_window;
    var id6315 = new Ext.form.NumberField({ "selectOnFocus": true });
    var ref6316 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name6317 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de6318 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr6319 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6320 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6321 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6322 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6315, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.TeacherTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "ref", "editable": true, "editor": ref6316, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.TeacherTypes.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name6317, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.TeacherTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de6318, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(courses.TeacherTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr6319, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(courses.TeacherTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.TeacherTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.TeacherTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.TeacherTypes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.courses.TeacherTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeacherTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeacherTypes.insertPanel = Ext.extend(Lino.courses.TeacherTypes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/TeacherTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeacherTypes.detail;
    this.ls_insert_handler = Lino.courses.TeacherTypes.insert;
    Lino.courses.TeacherTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeacherTypes.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.TeacherTypes.insertPanel(p);
});
Lino.courses.TeacherTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeacherTypes.detailPanel = Ext.extend(Lino.courses.TeacherTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/courses/TeacherTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeacherTypes.detail;
    this.ls_insert_handler = Lino.courses.TeacherTypes.insert;
    Lino.courses.TeacherTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeacherTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.TeacherTypes.detailPanel(p);
});
Lino.courses.TeacherTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeacherTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.TeacherTypes.GridPanel(p);
});
Lino.courses.TeacherTypes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeacherTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PupilTypes
Lino.courses.PupilTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PupilTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PupilTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  cell_edit : true,
  title : "Participant Types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 9,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 50,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilTypes.detail;
    this.ls_insert_handler = Lino.courses.PupilTypes.insert;
    var ww = this.containing_window;
    var id6324 = new Ext.form.NumberField({ "selectOnFocus": true });
    var ref6325 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name6326 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de6327 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr6328 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6329 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6330 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6331 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6324, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.PupilTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "ref", "editable": true, "editor": ref6325, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.PupilTypes.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name6326, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.PupilTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de6327, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(courses.PupilTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr6328, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(courses.PupilTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.PupilTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.PupilTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.PupilTypes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PupilTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilTypes.insertPanel = Ext.extend(Lino.courses.PupilTypes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/PupilTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilTypes.detail;
    this.ls_insert_handler = Lino.courses.PupilTypes.insert;
    Lino.courses.PupilTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilTypes.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PupilTypes.insertPanel(p);
});
Lino.courses.PupilTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilTypes.detailPanel = Ext.extend(Lino.courses.PupilTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/courses/PupilTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilTypes.detail;
    this.ls_insert_handler = Lino.courses.PupilTypes.insert;
    Lino.courses.PupilTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PupilTypes.detailPanel(p);
});
Lino.courses.PupilTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PupilTypes.GridPanel(p);
});
Lino.courses.PupilTypes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CourseTypes
Lino.courses.CourseTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CourseTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CourseTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Activity types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 9,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 51,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CourseTypes.detail;
    this.ls_insert_handler = Lino.courses.CourseTypes.insert;
    var ww = this.containing_window;
    var id6333 = new Ext.form.NumberField({ "selectOnFocus": true });
    var ref6334 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name6335 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de6336 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr6337 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6338 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6339 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6340 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6333, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(courses.CourseTypes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "ref", "editable": true, "editor": ref6334, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.CourseTypes.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name6335, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.CourseTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_de", "editable": true, "editor": name_de6336, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(courses.CourseTypes.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name_fr", "editable": true, "editor": name_fr6337, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(courses.CourseTypes.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.CourseTypes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CourseTypes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CourseTypes.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.courses.CourseTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CourseTypes.insertPanel = Ext.extend(Lino.courses.CourseTypes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/CourseTypes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CourseTypes.detail;
    this.ls_insert_handler = Lino.courses.CourseTypes.insert;
    Lino.courses.CourseTypes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseTypes.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CourseTypes.insertPanel(p);
});
Lino.courses.CourseTypes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CourseTypes.detailPanel = Ext.extend(Lino.courses.CourseTypes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/courses/CourseTypes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CourseTypes.detail;
    this.ls_insert_handler = Lino.courses.CourseTypes.insert;
    Lino.courses.CourseTypes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseTypes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseTypes.detailPanel(p);
});
Lino.courses.CourseTypes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseTypes.GridPanel(p);
});
Lino.courses.CourseTypes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseTypes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PendingRequestedEnrolments
Lino.courses.PendingRequestedEnrolments.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PendingRequestedEnrolments",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PendingRequestedEnrolments','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Pending requested enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "remark" }, { "name": "user" }, 'userHidden', { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingRequestedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingRequestedEnrolments.insert;
    var ww = this.containing_window;
    var request_date6342 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course6343 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingRequestedEnrolments/course" }) }) });
    var pupil6344 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingRequestedEnrolments/pupil" }) }) });
    var remark6345 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user6346 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PendingRequestedEnrolments/user" }) }) });
    var amount6347 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6348 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      course6343.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6343.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil6344.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      request_date6342.on('change',Lino.chooser_handler(course6343,'request_date'));
      course6343.on('change',Lino.chooser_handler(pupil6344,'course'));
      Lino.courses.PendingRequestedEnrolments.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6342, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.PendingRequestedEnrolments.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course6343, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "pupil", "editable": true, "editor": pupil6344, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark6345, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.PendingRequestedEnrolments.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user6346, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "amount", "editable": true, "editor": amount6347, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(courses.PendingRequestedEnrolments.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.PendingRequestedEnrolments.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PendingRequestedEnrolments.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingRequestedEnrolments.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingRequestedEnrolments.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/PendingRequestedEnrolments",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingRequestedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingRequestedEnrolments.insert;
    Lino.courses.PendingRequestedEnrolments.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingRequestedEnrolments.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PendingRequestedEnrolments.insertPanel(p);
});
Lino.courses.PendingRequestedEnrolments.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PendingRequestedEnrolments.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/PendingRequestedEnrolments",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PendingRequestedEnrolments.detail;
    this.ls_insert_handler = Lino.courses.PendingRequestedEnrolments.insert;
    Lino.courses.PendingRequestedEnrolments.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PendingRequestedEnrolments.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PendingRequestedEnrolments.detailPanel(p);
});
Lino.courses.PendingRequestedEnrolments.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.PendingRequestedEnrolments.GridPanel(p);
});
Lino.courses.PendingRequestedEnrolments.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PendingRequestedEnrolments.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PendingRequestedEnrolments", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Teachers
Lino.courses.Teachers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Teachers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Teachers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Instructors",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 64,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "teacher_type" }, 'teacher_typeHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "eid_info" }, { "name": "image" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Teachers.detail;
    this.ls_insert_handler = Lino.courses.Teachers.insert;
    var ww = this.containing_window;
    var name_column_disp6350 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp6351 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var teacher_type6352 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/teacher_type" }) }) });
    var id6353 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email6354 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language6355 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url6356 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone6357 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm6358 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax6359 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country6360 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/country" }) }) });
    var city6361 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/city" }) }) });
    var zip_code6362 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region6363 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/region" }) }) });
    var addr16364 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix6365 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street6366 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no6367 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box6368 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr26369 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name6370 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks6371 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term6372 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/payment_term" }) }) });
    var vat_regime6373 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient6374 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/invoice_recipient" }) }) });
    var paper_type6375 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/paper_type" }) }) });
    var title6376 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name6377 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name6378 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name6379 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender6380 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date6381 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id6382 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country6383 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/birth_country" }) }) });
    var birth_place6384 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality6385 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Teachers/nationality" }) }) });
    var card_number6386 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from6387 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until6388 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type6389 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer6390 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition6391 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var workflow_buttons_disp6392 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6393 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6394 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp6395 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp6396 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance6397 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var eid_info_disp6398 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var image_htmlbox6399 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    this.before_row_edit = function(record) {
      city6361.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city6361.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region6363.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox6399.refresh();
    };
    this.onRender = function(ct, position) {
      country6360.on('change',Lino.chooser_handler(city6361,'country'));
      region6363.on('change',Lino.chooser_handler(city6361,'region'));
      country6360.on('change',Lino.chooser_handler(region6363,'country'));
      Lino.courses.Teachers.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.Teachers.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(courses.Teachers.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "teacher_type", "editable": true, "editor": teacher_type6352, "filter": { "type": "string" }, "header": "Instructor Type", "renderer": Lino.fk_renderer('teacher_typeHidden','Lino.courses.TeacherTypes.detail'), "sortable": false, "tooltip": "(courses.Teachers.teacher_type) Pointer to TeacherType.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6353, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "email", "editable": true, "editor": email6354, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "language", "editable": true, "editor": language6355, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "url", "editable": true, "editor": url6356, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.url) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "phone", "editable": true, "editor": phone6357, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "gsm", "editable": true, "editor": gsm6358, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "fax", "editable": true, "editor": fax6359, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "country", "editable": true, "editor": country6360, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Teachers.country) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "city", "editable": true, "editor": city6361, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Teachers.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "zip_code", "editable": true, "editor": zip_code6362, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 13, "dataIndex": "region", "editable": true, "editor": region6363, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Teachers.region) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "addr1", "editable": true, "editor": addr16364, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix6365, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street", "editable": true, "editor": street6366, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "street_no", "editable": true, "editor": street_no6367, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "street_box", "editable": true, "editor": street_box6368, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 19, "dataIndex": "addr2", "editable": true, "editor": addr26369, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "name", "editable": true, "editor": name6370, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "remarks", "editable": true, "editor": remarks6371, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "payment_term", "editable": true, "editor": payment_term6372, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime6373, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 24, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient6374, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.Teachers.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "paper_type", "editable": true, "editor": paper_type6375, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "title", "editable": true, "editor": title6376, "filter": { "type": "string" }, "header": "Title", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.title) An optional name prefix like \"Dr.\" or \"PhD\", used to specify a\nprofessional position or academic qualification.", "width": Lino.chars2width(22) }, { "colIndex": 27, "dataIndex": "first_name", "editable": true, "editor": first_name6377, "filter": { "type": "string" }, "header": "First name", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "middle_name", "editable": true, "editor": middle_name6378, "filter": { "type": "string" }, "header": "Middle name", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 29, "dataIndex": "last_name", "editable": true, "editor": last_name6379, "filter": { "type": "string" }, "header": "Last name", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "gender", "editable": true, "editor": gender6380, "filter": { "type": "string" }, "header": "Gender", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 31, "dataIndex": "birth_date", "editable": true, "editor": birth_date6381, "filter": { "type": "string" }, "header": "Birth date", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 32, "dataIndex": "national_id", "editable": true, "editor": national_id6382, "filter": { "type": "string" }, "header": "National ID", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 33, "dataIndex": "birth_country", "editable": true, "editor": birth_country6383, "filter": { "type": "string" }, "header": "Birth country", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Teachers.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "birth_place", "editable": true, "editor": birth_place6384, "filter": { "type": "string" }, "header": "Birth place", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "nationality", "editable": true, "editor": nationality6385, "filter": { "type": "string" }, "header": "Nationality", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Teachers.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "card_number", "editable": true, "editor": card_number6386, "filter": { "type": "string" }, "header": "eID card number", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 37, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from6387, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID card valid from", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 38, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until6388, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "until", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 39, "dataIndex": "card_type", "editable": true, "editor": card_type6389, "filter": { "type": "string" }, "header": "eID card type", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.card_type) ", "width": Lino.chars2width(25) }, { "colIndex": 40, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer6390, "filter": { "type": "string" }, "header": "eID card issuer", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.card_issuer) The administration who issued this ID card.", "width": Lino.chars2width(22) }, { "colIndex": 41, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition6391, "filter": { "type": "string" }, "header": "noble condition", "hidden": true, "sortable": true, "tooltip": "(courses.Teachers.noble_condition) The eventual noble condition of this person.", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 43, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "age", "editable": false, "header": "Age", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.age) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 48, "dataIndex": "eid_info", "editable": false, "header": "eID card", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.eid_info) ", "width": Lino.chars2width(31) }, { "colIndex": 49, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.Teachers.image) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Teachers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Teachers.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Teachers.insertPanel = Ext.extend(Lino.contacts.Persons.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Teachers",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Teachers.detail;
    this.ls_insert_handler = Lino.courses.Teachers.insert;
    Lino.courses.Teachers.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Teachers.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Teachers.insertPanel(p);
});
Lino.courses.Teachers.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Teachers.detailPanel = Ext.extend(Lino.courses.Teachers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/Teachers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Teachers.detail;
    this.ls_insert_handler = Lino.courses.Teachers.insert;
    Lino.courses.Teachers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Teachers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Teachers.detailPanel(p);
});
Lino.courses.Teachers.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.courses.Teachers.GridPanel(p);
});
Lino.courses.Teachers.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.read_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Teachers.find_by_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Teachers", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Pupils
Lino.courses.Pupils.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Pupils",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Pupils','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Merge", "overflowText": "Merge", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Merge this object into another object of same class." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Participants",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 72,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "pupil_type" }, 'pupil_typeHidden', { "name": "section" }, 'sectionHidden', { "name": "is_lfv", "type": "boolean" }, { "name": "is_ckk", "type": "boolean" }, { "name": "is_raviva", "type": "boolean" }, { "dateFormat": "d.m.Y", "name": "member_until", "type": "date" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "legacy_id" }, { "name": "is_member", "type": "boolean" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "eid_info" }, { "name": "image" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Pupils.detail;
    this.ls_insert_handler = Lino.courses.Pupils.insert;
    var ww = this.containing_window;
    var name_column_disp6401 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp6402 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var pupil_type6403 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Participant Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/pupil_type" }) }) });
    var section6404 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var is_lfv6405 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_ckk6406 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_raviva6407 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var member_until6408 = new Lino.DateField({ "selectOnFocus": true });
    var id6409 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email6410 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language6411 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url6412 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone6413 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm6414 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax6415 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country6416 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/country" }) }) });
    var city6417 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/city" }) }) });
    var zip_code6418 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region6419 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/region" }) }) });
    var addr16420 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix6421 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street6422 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no6423 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box6424 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr26425 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name6426 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks6427 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term6428 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/payment_term" }) }) });
    var vat_regime6429 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient6430 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/invoice_recipient" }) }) });
    var paper_type6431 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/paper_type" }) }) });
    var title6432 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name6433 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name6434 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name6435 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender6436 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date6437 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id6438 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country6439 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/birth_country" }) }) });
    var birth_place6440 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality6441 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Pupils/nationality" }) }) });
    var card_number6442 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from6443 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until6444 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type6445 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer6446 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition6447 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var legacy_id6448 = new Ext.form.TextField({ "hidden": true, "maxLength": 12, "selectOnFocus": true });
    var is_member6449 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp6450 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6451 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6452 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp6453 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp6454 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance6455 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var eid_info_disp6456 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var image_htmlbox6457 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    this.before_row_edit = function(record) {
      city6417.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city6417.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region6419.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox6457.refresh();
    };
    this.onRender = function(ct, position) {
      country6416.on('change',Lino.chooser_handler(city6417,'country'));
      region6419.on('change',Lino.chooser_handler(city6417,'region'));
      country6416.on('change',Lino.chooser_handler(region6419,'country'));
      Lino.courses.Pupils.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.Pupils.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(courses.Pupils.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "pupil_type", "editable": true, "editor": pupil_type6403, "filter": { "type": "string" }, "header": "Participant Type", "renderer": Lino.fk_renderer('pupil_typeHidden','Lino.courses.PupilTypes.detail'), "sortable": false, "tooltip": "(courses.Pupils.pupil_type) Pointer to PupilType.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "section", "editable": true, "editor": section6404, "filter": { "type": "string" }, "header": "Section", "sortable": false, "tooltip": "(courses.Pupils.section) ", "width": Lino.chars2width(14) }, { "colIndex": 4, "dataIndex": "is_lfv", "editable": true, "filter": { "type": "boolean" }, "header": "LFV", "sortable": false, "tooltip": "(courses.Pupils.is_lfv) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "is_ckk", "editable": true, "filter": { "type": "boolean" }, "header": "CKK", "sortable": false, "tooltip": "(courses.Pupils.is_ckk) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "is_raviva", "editable": true, "filter": { "type": "boolean" }, "header": "Raviva", "sortable": false, "tooltip": "(courses.Pupils.is_raviva) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "member_until", "editable": true, "editor": member_until6408, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Mitglied bis", "sortable": true, "tooltip": "(courses.Pupils.member_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id6409, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "email", "editable": true, "editor": email6410, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language6411, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "url", "editable": true, "editor": url6412, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.url) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "phone", "editable": true, "editor": phone6413, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "gsm", "editable": true, "editor": gsm6414, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "fax", "editable": true, "editor": fax6415, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "country", "editable": true, "editor": country6416, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Pupils.country) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "city", "editable": true, "editor": city6417, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Pupils.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "zip_code", "editable": true, "editor": zip_code6418, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "region", "editable": true, "editor": region6419, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.Pupils.region) ", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "addr1", "editable": true, "editor": addr16420, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix6421, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "street", "editable": true, "editor": street6422, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "street_no", "editable": true, "editor": street_no6423, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 23, "dataIndex": "street_box", "editable": true, "editor": street_box6424, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 24, "dataIndex": "addr2", "editable": true, "editor": addr26425, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 25, "dataIndex": "name", "editable": true, "editor": name6426, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "remarks", "editable": true, "editor": remarks6427, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "payment_term", "editable": true, "editor": payment_term6428, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime6429, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 29, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient6430, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.Pupils.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 30, "dataIndex": "paper_type", "editable": true, "editor": paper_type6431, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 31, "dataIndex": "title", "editable": true, "editor": title6432, "filter": { "type": "string" }, "header": "Title", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.title) An optional name prefix like \"Dr.\" or \"PhD\", used to specify a\nprofessional position or academic qualification.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "first_name", "editable": true, "editor": first_name6433, "filter": { "type": "string" }, "header": "First name", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 33, "dataIndex": "middle_name", "editable": true, "editor": middle_name6434, "filter": { "type": "string" }, "header": "Middle name", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 34, "dataIndex": "last_name", "editable": true, "editor": last_name6435, "filter": { "type": "string" }, "header": "Last name", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "gender", "editable": true, "editor": gender6436, "filter": { "type": "string" }, "header": "Gender", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 36, "dataIndex": "birth_date", "editable": true, "editor": birth_date6437, "filter": { "type": "string" }, "header": "Birth date", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 37, "dataIndex": "national_id", "editable": true, "editor": national_id6438, "filter": { "type": "string" }, "header": "National ID", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 38, "dataIndex": "birth_country", "editable": true, "editor": birth_country6439, "filter": { "type": "string" }, "header": "Birth country", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Pupils.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 39, "dataIndex": "birth_place", "editable": true, "editor": birth_place6440, "filter": { "type": "string" }, "header": "Birth place", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 40, "dataIndex": "nationality", "editable": true, "editor": nationality6441, "filter": { "type": "string" }, "header": "Nationality", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.Pupils.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 41, "dataIndex": "card_number", "editable": true, "editor": card_number6442, "filter": { "type": "string" }, "header": "eID card number", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from6443, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID card valid from", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 43, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until6444, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "until", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 44, "dataIndex": "card_type", "editable": true, "editor": card_type6445, "filter": { "type": "string" }, "header": "eID card type", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.card_type) ", "width": Lino.chars2width(25) }, { "colIndex": 45, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer6446, "filter": { "type": "string" }, "header": "eID card issuer", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.card_issuer) The administration who issued this ID card.", "width": Lino.chars2width(22) }, { "colIndex": 46, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition6447, "filter": { "type": "string" }, "header": "noble condition", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.noble_condition) The eventual noble condition of this person.", "width": Lino.chars2width(22) }, { "colIndex": 47, "dataIndex": "legacy_id", "editable": true, "editor": legacy_id6448, "filter": { "type": "string" }, "header": "Legacy ID", "hidden": true, "sortable": true, "tooltip": "(courses.Pupils.legacy_id) ", "width": Lino.chars2width(14) }, { "colIndex": 48, "dataIndex": "is_member", "editable": true, "filter": { "type": "boolean" }, "header": "Member", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.is_member) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 49, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 50, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 51, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 52, "dataIndex": "age", "editable": false, "header": "Age", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.age) ", "width": Lino.chars2width(31) }, { "colIndex": 53, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 54, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 55, "dataIndex": "eid_info", "editable": false, "header": "eID card", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.eid_info) ", "width": Lino.chars2width(31) }, { "colIndex": 56, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.Pupils.image) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Pupils.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Pupils.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Pupils.insertPanel = Ext.extend(Lino.courses.Pupils.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Pupils",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Pupils.detail;
    this.ls_insert_handler = Lino.courses.Pupils.insert;
    Lino.courses.Pupils.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Pupils.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Pupils.insertPanel(p);
});
Lino.courses.Pupils.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Pupils.detailPanel = Ext.extend(Lino.courses.Pupils.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Merge", "overflowText": "Merge", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Merge this object into another object of same class." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/Pupils",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Pupils.detail;
    this.ls_insert_handler = Lino.courses.Pupils.insert;
    Lino.courses.Pupils.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Pupils.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Pupils.detailPanel(p);
});
Lino.courses.Pupils.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Pupils.ParamsPanel({});
  return new Lino.courses.Pupils.GridPanel(p);
});
Lino.courses.Pupils.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.read_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Pupils.find_by_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Pupils", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Hikes
Lino.courses.Hikes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Hikes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Hikes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Hikes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Hikes.detail;
    this.ls_insert_handler = Lino.courses.Hikes.insert;
    var ww = this.containing_window;
    var ref6459 = new Ext.form.TextField({ "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var name6460 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var start_date6461 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until6462 = new Lino.DateField({ "selectOnFocus": true });
    var line6463 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/line" }) }) });
    var workflow_buttons_disp6464 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6465 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time6466 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date6467 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time6468 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6469 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/user" }) }) });
    var every_unit6470 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6471 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6472 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6473 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6474 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6475 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6476 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6477 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6478 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6479 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var room6480 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/room" }) }) });
    var max_date6481 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var teacher6482 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/teacher" }) }) });
    var slot6483 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/slot" }) }) });
    var description6484 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6485 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6486 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6487 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6488 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6489 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var fee6490 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/fee" }) }) });
    var payment_term6491 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/payment_term" }) }) });
    var paper_type6492 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Hikes/paper_type" }) }) });
    var overview_disp6493 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6494 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6495 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments6496 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp6497 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6498 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6499 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6500 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6501 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places6502 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6503 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6504 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6505 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6506 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6490.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6500.refresh();
    };
    this.onRender = function(ct, position) {
      line6463.on('change',Lino.chooser_handler(fee6490,'line'));
      Lino.courses.Hikes.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref6459, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.Hikes.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name6460, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.Hikes.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date6461, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.Hikes.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6462, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "sortable": true, "tooltip": "(courses.Hikes.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "line", "editable": true, "editor": line6463, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Hikes.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.Hikes.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id6465, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time6466, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date6467, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time6468, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user6469, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Hikes.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit6470, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every6471, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.every) ", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events6479, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room6480, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date6481, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "teacher", "editable": true, "editor": teacher6482, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Hikes.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot6483, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description6484, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de6485, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr6486, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark6487, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state6488, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places6489, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.Hikes.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee6490, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Hikes.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term6491, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type6492, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.Hikes.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Hikes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Hikes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Hikes.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Hikes",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Hikes.detail;
    this.ls_insert_handler = Lino.courses.Hikes.insert;
    Lino.courses.Hikes.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Hikes.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Hikes.insertPanel(p);
});
Lino.courses.Hikes.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Hikes.detailPanel = Ext.extend(Lino.courses.Hikes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Hikes",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Hikes.detail;
    this.ls_insert_handler = Lino.courses.Hikes.insert;
    Lino.courses.Hikes.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Hikes.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Hikes.detailPanel(p);
});
Lino.courses.Hikes.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Hikes.GridPanel(p);
});
Lino.courses.Hikes.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Hikes.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Hikes", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.Journeys
Lino.courses.Journeys.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/Journeys",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Journeys','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Journeys",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Journeys.detail;
    this.ls_insert_handler = Lino.courses.Journeys.insert;
    var ww = this.containing_window;
    var ref6508 = new Ext.form.TextField({ "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var name6509 = new Ext.form.TextField({ "maxLength": 100, "selectOnFocus": true });
    var start_date6510 = new Lino.DateField({ "selectOnFocus": true });
    var end_date6511 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until6512 = new Lino.DateField({ "selectOnFocus": true });
    var line6513 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/line" }) }) });
    var workflow_buttons_disp6514 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6515 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_time6516 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_time6517 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user6518 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/user" }) }) });
    var every_unit6519 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every6520 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday6521 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday6522 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday6523 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday6524 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday6525 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday6526 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday6527 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events6528 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var room6529 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/room" }) }) });
    var max_date6530 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var teacher6531 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/teacher" }) }) });
    var slot6532 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/slot" }) }) });
    var description6533 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de6534 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr6535 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark6536 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state6537 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places6538 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var fee6539 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/fee" }) }) });
    var payment_term6540 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/payment_term" }) }) });
    var paper_type6541 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/Journeys/paper_type" }) }) });
    var overview_disp6542 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6543 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp6544 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments6545 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp6546 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested6547 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed6548 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox6549 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying6550 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places6551 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp6552 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp6553 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp6554 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration6555 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee6539.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox6549.refresh();
    };
    this.onRender = function(ct, position) {
      line6513.on('change',Lino.chooser_handler(fee6539,'line'));
      Lino.courses.Journeys.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref6508, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.Journeys.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name6509, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.Journeys.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date6510, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.Journeys.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date6511, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "sortable": true, "tooltip": "(courses.Journeys.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until6512, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "sortable": true, "tooltip": "(courses.Journeys.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "line", "editable": true, "editor": line6513, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.Journeys.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.Journeys.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id6515, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time6516, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time6517, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user6518, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.Journeys.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "every_unit", "editable": true, "editor": every_unit6519, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 12, "dataIndex": "every", "editable": true, "editor": every6520, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.every) ", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 20, "dataIndex": "max_events", "editable": true, "editor": max_events6528, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 21, "dataIndex": "room", "editable": true, "editor": room6529, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.room) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date6530, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "teacher", "editable": true, "editor": teacher6531, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.Journeys.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "slot", "editable": true, "editor": slot6532, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "description", "editable": true, "editor": description6533, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_de", "editable": true, "editor": description_de6534, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "description_fr", "editable": true, "editor": description_fr6535, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "remark", "editable": true, "editor": remark6536, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 29, "dataIndex": "state", "editable": true, "editor": state6537, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 30, "dataIndex": "max_places", "editable": true, "editor": max_places6538, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.Journeys.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 31, "dataIndex": "fee", "editable": true, "editor": fee6539, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.Journeys.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "payment_term", "editable": true, "editor": payment_term6540, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "paper_type", "editable": true, "editor": paper_type6541, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 37, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 38, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 39, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 40, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 41, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 42, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 43, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.Journeys.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.Journeys.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Journeys.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Journeys.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/Journeys",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Journeys.detail;
    this.ls_insert_handler = Lino.courses.Journeys.insert;
    Lino.courses.Journeys.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Journeys.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.Journeys.insertPanel(p);
});
Lino.courses.Journeys.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.Journeys.detailPanel = Ext.extend(Lino.courses.Journeys.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/Journeys",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.Journeys.detail;
    this.ls_insert_handler = Lino.courses.Journeys.insert;
    Lino.courses.Journeys.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Journeys.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Journeys.detailPanel(p);
});
Lino.courses.Journeys.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.Journeys.GridPanel(p);
});
Lino.courses.Journeys.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Journeys.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Journeys", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sessions.SessionTable
Lino.sessions.SessionTable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sessions/SessionTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sessions/SessionTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "sessions",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "session_key" }, { "name": "session_data" }, { "name": "expire_date" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 78,
  ls_id_property : "session_key",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var session_key6557 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 40, "selectOnFocus": true });
    var session_data6558 = new Ext.form.TextArea({ "allowBlank": false, "growMax": 2000, "selectOnFocus": true });
    var expire_date6559 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "session_key", "editable": true, "editor": session_key6557, "filter": { "type": "string" }, "header": "session key", "sortable": true, "tooltip": "(sessions.SessionTable.session_key) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "session_data", "editable": true, "editor": session_data6558, "filter": { "type": "string" }, "header": "session data", "sortable": false, "tooltip": "(sessions.SessionTable.session_data) ", "width": Lino.chars2width(61) }, { "colIndex": 2, "dataIndex": "expire_date", "editable": true, "editor": expire_date6559, "header": "expire date", "sortable": true, "tooltip": "(sessions.SessionTable.expire_date) ", "width": Lino.chars2width(17) } ];
    Lino.sessions.SessionTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sessions.SessionTable.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sessions/SessionTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sessions.SessionTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sessions.SessionTable.GridPanel(p);
});

// js_render_GridPanel_class vat.InvoiceItemTable
Lino.vat.InvoiceItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/InvoiceItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/InvoiceItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Account invoice items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "voucher" }, 'voucherHidden', { "name": "title" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 43,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6561 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno6562 = new Ext.form.NumberField({ "selectOnFocus": true });
    var account6563 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoiceItemTable/account" }) }) });
    var total_incl6564 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base6565 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat6566 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var vat_class6567 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var voucher6568 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Invoice...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoiceItemTable/voucher" }) }) });
    var title6569 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6570 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6571 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6572 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6573 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      account6563.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher6568.on('change',Lino.chooser_handler(account6563,'voucher'));
      Lino.vat.InvoiceItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6561, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(vat.InvoiceItemTable.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno6562, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(vat.InvoiceItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "account", "editable": true, "editor": account6563, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(vat.InvoiceItemTable.account) ForeignKey pointing to the account (accounts.Account) that is to be moved.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl6564, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(vat.InvoiceItemTable.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "total_base", "editable": true, "editor": total_base6565, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "sortable": true, "tooltip": "(vat.InvoiceItemTable.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "total_vat", "editable": true, "editor": total_vat6566, "filter": { "type": "numeric" }, "header": "VAT", "sortable": true, "tooltip": "(vat.InvoiceItemTable.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "vat_class", "editable": true, "editor": vat_class6567, "filter": { "type": "string" }, "header": "VAT Class", "sortable": false, "tooltip": "(vat.InvoiceItemTable.vat_class) The VAT class to be applied for this item. A pointer to\nVatClasses.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "voucher", "editable": true, "editor": voucher6568, "filter": { "type": "string" }, "header": "Invoice", "renderer": Lino.fk_renderer('voucherHidden','Lino.vat.Invoices.detail'), "sortable": false, "tooltip": "(vat.InvoiceItemTable.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "title", "editable": true, "editor": title6569, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(vat.InvoiceItemTable.title) The title of this voucher.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(vat.InvoiceItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.vat.InvoiceItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoiceItemTable.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.InvoiceItemTable.GridPanel(p);
});
Lino.vat.InvoiceItemTable.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoiceItemTable.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoiceItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.JournalEntryItemTable
Lino.finan.JournalEntryItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/JournalEntryItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntryItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Journal Entry items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "match" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "remark" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "voucher" }, 'voucherHidden', { "name": "credit" }, { "name": "debit" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 60,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6575 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno6576 = new Ext.form.NumberField({ "selectOnFocus": true });
    var match6577 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/match" }) }) });
    var amount6578 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var dc6579 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var remark6580 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account6581 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/account" }) }) });
    var partner6582 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/partner" }) }) });
    var date6583 = new Lino.DateField({ "selectOnFocus": true });
    var voucher6584 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal Entry...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntryItemTable/voucher" }) }) });
    var credit6585 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var debit6586 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp6587 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6588 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6589 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6590 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match6577.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
      match6577.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher6584.on('change',Lino.chooser_handler(match6577,'voucher'));
      partner6582.on('change',Lino.chooser_handler(match6577,'partner'));
      Lino.finan.JournalEntryItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6575, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno6576, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "match", "editable": true, "editor": match6577, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.JournalEntryItemTable.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "amount", "editable": true, "editor": amount6578, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.amount) The amount to be booked. If this is empty, then the voucher\ncannot be registered.", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "sortable": false, "tooltip": "(finan.JournalEntryItemTable.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark6580, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.remark) External reference. The description of this transation\nas seen by the external partner.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "account", "editable": true, "editor": account6581, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(finan.JournalEntryItemTable.account) The general account to be used in the primary booking.\nIf this is empty, use item_account of the voucher.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": true, "editor": partner6582, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.JournalEntryItemTable.partner) The partner account to be used in the primary booking.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "date", "editable": true, "editor": date6583, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.JournalEntryItemTable.date) The value date of this item.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "voucher", "editable": true, "editor": voucher6584, "filter": { "type": "string" }, "header": "Journal Entry", "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.FinancialVouchers.detail'), "sortable": false, "tooltip": "(finan.JournalEntryItemTable.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "credit", "editable": true, "editor": credit6585, "header": "Credit", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.credit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "debit", "editable": true, "editor": debit6586, "header": "Debit", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.debit) ", "width": Lino.chars2width(13) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntryItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.finan.JournalEntryItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntryItemTable.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.JournalEntryItemTable.GridPanel(p);
});
Lino.finan.JournalEntryItemTable.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntryItemTable.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntryItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.BankStatementItemTable
Lino.finan.BankStatementItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/BankStatementItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Bank Statement items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "match" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "remark" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "voucher" }, 'voucherHidden', { "name": "credit" }, { "name": "debit" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 62,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6592 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno6593 = new Ext.form.NumberField({ "selectOnFocus": true });
    var match6594 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/match" }) }) });
    var amount6595 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var dc6596 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var remark6597 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account6598 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/account" }) }) });
    var partner6599 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/partner" }) }) });
    var date6600 = new Lino.DateField({ "selectOnFocus": true });
    var voucher6601 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Bank Statement...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementItemTable/voucher" }) }) });
    var credit6602 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var debit6603 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp6604 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6605 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6606 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6607 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match6594.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
      match6594.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher6601.on('change',Lino.chooser_handler(match6594,'voucher'));
      partner6599.on('change',Lino.chooser_handler(match6594,'partner'));
      Lino.finan.BankStatementItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6592, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.BankStatementItemTable.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno6593, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.BankStatementItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "match", "editable": true, "editor": match6594, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.BankStatementItemTable.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "amount", "editable": true, "editor": amount6595, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(finan.BankStatementItemTable.amount) The amount to be booked. If this is empty, then the voucher\ncannot be registered.", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "sortable": false, "tooltip": "(finan.BankStatementItemTable.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark6597, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.BankStatementItemTable.remark) External reference. The description of this transation\nas seen by the external partner.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "account", "editable": true, "editor": account6598, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(finan.BankStatementItemTable.account) The general account to be used in the primary booking.\nIf this is empty, use item_account of the voucher.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": true, "editor": partner6599, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.BankStatementItemTable.partner) The partner account to be used in the primary booking.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "date", "editable": true, "editor": date6600, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.BankStatementItemTable.date) The value date of this item.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "voucher", "editable": true, "editor": voucher6601, "filter": { "type": "string" }, "header": "Bank Statement", "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.BankStatements.detail'), "sortable": false, "tooltip": "(finan.BankStatementItemTable.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "credit", "editable": true, "editor": credit6602, "header": "Expense", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.credit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "debit", "editable": true, "editor": debit6603, "header": "Income", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.debit) ", "width": Lino.chars2width(13) }, { "colIndex": 12, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.finan.BankStatementItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementItemTable.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.BankStatementItemTable.GridPanel(p);
});
Lino.finan.BankStatementItemTable.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementItemTable.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.PaymentOrderItemTable
Lino.finan.PaymentOrderItemTable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/PaymentOrderItemTable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrderItemTable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Payment Order items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 19,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "match" }, { "name": "bank_account" }, 'bank_accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "remark" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "voucher" }, 'voucherHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 59,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6609 = new Ext.form.NumberField({ "selectOnFocus": true });
    var seqno6610 = new Ext.form.NumberField({ "selectOnFocus": true });
    var match6611 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/match" }) }) });
    var bank_account6612 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Bank account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/bank_account" }) }) });
    var amount6613 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var dc6614 = new Ext.form.Checkbox({ "selectOnFocus": true });
    var remark6615 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var account6616 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/account" }) }) });
    var partner6617 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/partner" }) }) });
    var voucher6618 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Payment Order...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrderItemTable/voucher" }) }) });
    var workflow_buttons_disp6619 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6620 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6621 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp6622 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      match6611.setContextValue('voucher', record ? record.data['voucherHidden'] : undefined);
      match6611.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      bank_account6612.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      bank_account6612.setContextValue('project', record ? record.data['project'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher6618.on('change',Lino.chooser_handler(match6611,'voucher'));
      partner6617.on('change',Lino.chooser_handler(match6611,'partner'));
      partner6617.on('change',Lino.chooser_handler(bank_account6612,'partner'));
      Lino.finan.PaymentOrderItemTable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6609, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 1, "dataIndex": "seqno", "editable": true, "editor": seqno6610, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "match", "editable": true, "editor": match6611, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "bank_account", "editable": true, "editor": bank_account6612, "filter": { "type": "string" }, "header": "Bank account", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.bank_account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "amount", "editable": true, "editor": amount6613, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.amount) The amount to be booked. If this is empty, then the voucher\ncannot be registered.", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "remark", "editable": true, "editor": remark6615, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.PaymentOrderItemTable.remark) External reference. The description of this transation\nas seen by the external partner.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "account", "editable": true, "editor": account6616, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.account) The general account to be used in the primary booking.\nIf this is empty, use item_account of the voucher.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner6617, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.partner) The partner account to be used in the primary booking.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "voucher", "editable": true, "editor": voucher6618, "filter": { "type": "string" }, "header": "Payment Order", "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.PaymentOrders.detail'), "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrderItemTable.move_buttons) ", "width": Lino.chars2width(6) } ];
    Lino.finan.PaymentOrderItemTable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrderItemTable.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.PaymentOrderItemTable.GridPanel(p);
});
Lino.finan.PaymentOrderItemTable.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrderItemTable.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrderItemTable", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.PlacesByPlace
Lino.countries.PlacesByPlace.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/PlacesByPlace",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByPlace','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Subdivisions",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 16,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "type" }, 'typeHidden', { "name": "zip_code" }, { "name": "id", "type": "int" }, { "name": "country" }, 'countryHidden', { "name": "children_summary" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "parent" }, 'parentHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 5,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByPlace.detail;
    this.ls_insert_handler = Lino.countries.PlacesByPlace.insert;
    var ww = this.containing_window;
    var name2271 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de2272 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr2273 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var type2274 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByPlace/type" }) }) });
    var zip_code2275 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(8), "maxLength": 8, "selectOnFocus": true });
    var id2276 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var country2277 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByPlace/country" }) }) });
    var children_summary_disp2278 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2279 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2280 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2281 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var parent2282 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByPlace/parent" }) }) });
    this.before_row_edit = function(record) {
      type2274.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country2277.on('change',Lino.chooser_handler(type2274,'country'));
      Lino.countries.PlacesByPlace.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name2271, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(countries.PlacesByPlace.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de2272, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(countries.PlacesByPlace.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr2273, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(countries.PlacesByPlace.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type2274, "filter": { "type": "string" }, "header": "Place Type", "sortable": false, "tooltip": "(countries.PlacesByPlace.type) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "zip_code", "editable": true, "editor": zip_code2275, "filter": { "type": "string" }, "header": "zip code", "sortable": true, "tooltip": "(countries.PlacesByPlace.zip_code) ", "width": Lino.chars2width(10) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2276, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByPlace.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "country", "editable": true, "editor": country2277, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(countries.PlacesByPlace.country) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "children_summary", "editable": false, "header": "Children", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.children_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByPlace.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "parent", "editable": true, "editor": parent2282, "filter": { "type": "string" }, "header": "Part of", "hidden": true, "renderer": Lino.fk_renderer('parentHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(countries.PlacesByPlace.parent) The superordinate geographic place of which this place is a part.", "width": Lino.chars2width(21) } ];
    Lino.countries.PlacesByPlace.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByPlace.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.PlacesByPlace.insertPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/countries/PlacesByPlace",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByPlace.detail;
    this.ls_insert_handler = Lino.countries.PlacesByPlace.insert;
    Lino.countries.PlacesByPlace.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByPlace.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.countries.PlacesByPlace.insertPanel(p);
});
Lino.countries.PlacesByPlace.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.PlacesByPlace.detailPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/countries/PlacesByPlace",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByPlace.detail;
    this.ls_insert_handler = Lino.countries.PlacesByPlace.insert;
    Lino.countries.PlacesByPlace.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByPlace.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByPlace.detailPanel(p);
});
Lino.countries.PlacesByPlace.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByPlace.GridPanel(p);
});
Lino.countries.PlacesByPlace.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByPlace.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByPlace", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class countries.PlacesByCountry
Lino.countries.PlacesByCountry.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/countries/PlacesByCountry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/PlacesByCountry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Places",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 16,
  ls_store_fields : [ { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "type" }, 'typeHidden', { "name": "zip_code" }, { "name": "id", "type": "int" }, { "name": "parent" }, 'parentHidden', { "name": "children_summary" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "country" }, 'countryHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 5,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByCountry.detail;
    this.ls_insert_handler = Lino.countries.PlacesByCountry.insert;
    var ww = this.containing_window;
    var name2240 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de2241 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr2242 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var type2243 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByCountry/type" }) }) });
    var zip_code2244 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(8), "maxLength": 8, "selectOnFocus": true });
    var id2245 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var parent2246 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByCountry/parent" }) }) });
    var children_summary_disp2247 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2248 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2249 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2250 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var country2251 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/countries/PlacesByCountry/country" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      type2243.setContextValue('mk',bp['mk']);
      type2243.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      country2251.on('change',Lino.chooser_handler(type2243,'country'));
      Lino.countries.PlacesByCountry.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name2240, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(countries.PlacesByCountry.name) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name_de", "editable": true, "editor": name_de2241, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(countries.PlacesByCountry.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_fr", "editable": true, "editor": name_fr2242, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(countries.PlacesByCountry.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type2243, "filter": { "type": "string" }, "header": "Place Type", "sortable": false, "tooltip": "(countries.PlacesByCountry.type) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "zip_code", "editable": true, "editor": zip_code2244, "filter": { "type": "string" }, "header": "zip code", "sortable": true, "tooltip": "(countries.PlacesByCountry.zip_code) ", "width": Lino.chars2width(10) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2245, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(countries.PlacesByCountry.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "parent", "editable": true, "editor": parent2246, "filter": { "type": "string" }, "header": "Part of", "hidden": true, "renderer": Lino.fk_renderer('parentHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(countries.PlacesByCountry.parent) The superordinate geographic place of which this place is a part.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "children_summary", "editable": false, "header": "Children", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.children_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(countries.PlacesByCountry.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "country", "editable": true, "editor": country2251, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(countries.PlacesByCountry.country) ", "width": Lino.chars2width(21) } ];
    Lino.countries.PlacesByCountry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByCountry.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.PlacesByCountry.insertPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/countries/PlacesByCountry",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByCountry.detail;
    this.ls_insert_handler = Lino.countries.PlacesByCountry.insert;
    Lino.countries.PlacesByCountry.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByCountry.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.countries.PlacesByCountry.insertPanel(p);
});
Lino.countries.PlacesByCountry.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.countries.PlacesByCountry.detailPanel = Ext.extend(Lino.countries.Places.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/countries/PlacesByCountry",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.countries.PlacesByCountry.detail;
    this.ls_insert_handler = Lino.countries.PlacesByCountry.insert;
    Lino.countries.PlacesByCountry.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlacesByCountry.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByCountry.detailPanel(p);
});
Lino.countries.PlacesByCountry.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlacesByCountry.GridPanel(p);
});
Lino.countries.PlacesByCountry.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlacesByCountry.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlacesByCountry", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.PartnersByCity
Lino.contacts.PartnersByCity.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/PartnersByCity",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCity','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  cell_edit : true,
  title : "Partners",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 39,
  ls_store_fields : [ { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "language" }, 'languageHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mti_navigator" }, { "name": "address_column" }, { "name": "city" }, 'cityHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCity.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCity.insert;
    var ww = this.containing_window;
    var street2303 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var street_no2304 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "maxLength": 10, "selectOnFocus": true });
    var street_box2305 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "maxLength": 10, "selectOnFocus": true });
    var addr22306 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name2307 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var language2308 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var id2309 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email2310 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var url2311 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone2312 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm2313 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax2314 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country2315 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/country" }) }) });
    var zip_code2316 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region2317 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/region" }) }) });
    var addr12318 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix2319 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks2320 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term2321 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/payment_term" }) }) });
    var vat_regime2322 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient2323 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/invoice_recipient" }) }) });
    var paper_type2324 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/paper_type" }) }) });
    var debit_balance2325 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp2326 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2327 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2328 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2329 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp2330 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var address_column_disp2331 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var city2332 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCity/city" }) }) });
    this.before_row_edit = function(record) {
      region2317.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city2332.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city2332.setContextValue('region', record ? record.data['regionHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country2315.on('change',Lino.chooser_handler(region2317,'country'));
      country2315.on('change',Lino.chooser_handler(city2332,'country'));
      region2317.on('change',Lino.chooser_handler(city2332,'region'));
      Lino.contacts.PartnersByCity.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "street", "editable": true, "editor": street2303, "filter": { "type": "string" }, "header": "Street", "sortable": true, "tooltip": "(contacts.PartnersByCity.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "street_no", "editable": true, "editor": street_no2304, "filter": { "type": "string" }, "header": "No.", "sortable": true, "tooltip": "(contacts.PartnersByCity.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 2, "dataIndex": "street_box", "editable": true, "editor": street_box2305, "filter": { "type": "string" }, "header": "Box", "sortable": true, "tooltip": "(contacts.PartnersByCity.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 3, "dataIndex": "addr2", "editable": true, "editor": addr22306, "filter": { "type": "string" }, "header": "Address line after street", "sortable": true, "tooltip": "(contacts.PartnersByCity.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "name", "editable": true, "editor": name2307, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(contacts.PartnersByCity.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "language", "editable": true, "editor": language2308, "filter": { "type": "string" }, "header": "Language", "sortable": false, "tooltip": "(contacts.PartnersByCity.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id2309, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "email", "editable": true, "editor": email2310, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "url", "editable": true, "editor": url2311, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.url) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "phone", "editable": true, "editor": phone2312, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "gsm", "editable": true, "editor": gsm2313, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "fax", "editable": true, "editor": fax2314, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "country", "editable": true, "editor": country2315, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.country) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "zip_code", "editable": true, "editor": zip_code2316, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 14, "dataIndex": "region", "editable": true, "editor": region2317, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.region) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "addr1", "editable": true, "editor": addr12318, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix2319, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCity.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "remarks", "editable": true, "editor": remarks2320, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "payment_term", "editable": true, "editor": payment_term2321, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime2322, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 20, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient2323, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "paper_type", "editable": true, "editor": paper_type2324, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 22, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 23, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "address_column", "editable": false, "header": "Address", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCity.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "city", "editable": true, "editor": city2332, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCity.city) A pointer to Place.", "width": Lino.chars2width(21) } ];
    Lino.contacts.PartnersByCity.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCity.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCity.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/contacts/PartnersByCity",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCity.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCity.insert;
    Lino.contacts.PartnersByCity.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCity.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.PartnersByCity.insertPanel(p);
});
Lino.contacts.PartnersByCity.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCity.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  ls_url: "/contacts/PartnersByCity",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCity.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCity.insert;
    Lino.contacts.PartnersByCity.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCity.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.PartnersByCity.detailPanel(p);
});
Lino.contacts.PartnersByCity.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.PartnersByCity.GridPanel(p);
});
Lino.contacts.PartnersByCity.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCity.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCity", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.PartnersByCountry
Lino.contacts.PartnersByCountry.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/PartnersByCountry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnersByCountry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  cell_edit : true,
  title : "Partners",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 39,
  ls_store_fields : [ { "name": "city" }, 'cityHidden', { "name": "street" }, { "name": "street_no" }, { "name": "name" }, { "name": "language" }, 'languageHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mti_navigator" }, { "name": "address_column" }, { "name": "country" }, 'countryHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCountry.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCountry.insert;
    var ww = this.containing_window;
    var city6624 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/city" }) }) });
    var street6625 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var street_no6626 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "maxLength": 10, "selectOnFocus": true });
    var name6627 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var language6628 = new Lino.ChoicesFieldElement({ "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var id6629 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email6630 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var url6631 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone6632 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm6633 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax6634 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var zip_code6635 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region6636 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/region" }) }) });
    var addr16637 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix6638 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_box6639 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr26640 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks6641 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term6642 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/payment_term" }) }) });
    var vat_regime6643 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient6644 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/invoice_recipient" }) }) });
    var paper_type6645 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/paper_type" }) }) });
    var debit_balance6646 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp6647 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6648 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6649 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6650 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp6651 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var address_column_disp6652 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var country6653 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/PartnersByCountry/country" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      city6624.setContextValue('mk',bp['mk']);
      city6624.setContextValue('mt',bp['mt']);
      city6624.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      var bp = this.get_base_params();
      region6636.setContextValue('mk',bp['mk']);
      region6636.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      country6653.on('change',Lino.chooser_handler(city6624,'country'));
      region6636.on('change',Lino.chooser_handler(city6624,'region'));
      country6653.on('change',Lino.chooser_handler(region6636,'country'));
      Lino.contacts.PartnersByCountry.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "city", "editable": true, "editor": city6624, "filter": { "type": "string" }, "header": "City", "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "street", "editable": true, "editor": street6625, "filter": { "type": "string" }, "header": "Street", "sortable": true, "tooltip": "(contacts.PartnersByCountry.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "street_no", "editable": true, "editor": street_no6626, "filter": { "type": "string" }, "header": "No.", "sortable": true, "tooltip": "(contacts.PartnersByCountry.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 3, "dataIndex": "name", "editable": true, "editor": name6627, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(contacts.PartnersByCountry.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language6628, "filter": { "type": "string" }, "header": "Language", "sortable": false, "tooltip": "(contacts.PartnersByCountry.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id6629, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "email", "editable": true, "editor": email6630, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "url", "editable": true, "editor": url6631, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.url) ", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "phone", "editable": true, "editor": phone6632, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "gsm", "editable": true, "editor": gsm6633, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "fax", "editable": true, "editor": fax6634, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code6635, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region6636, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr16637, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix6638, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_box", "editable": true, "editor": street_box6639, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 16, "dataIndex": "addr2", "editable": true, "editor": addr26640, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(contacts.PartnersByCountry.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "remarks", "editable": true, "editor": remarks6641, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "payment_term", "editable": true, "editor": payment_term6642, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime6643, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 20, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient6644, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "paper_type", "editable": true, "editor": paper_type6645, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 22, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 23, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 24, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "address_column", "editable": false, "header": "Address", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnersByCountry.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "country", "editable": true, "editor": country6653, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(contacts.PartnersByCountry.country) ", "width": Lino.chars2width(21) } ];
    Lino.contacts.PartnersByCountry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCountry.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCountry.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/contacts/PartnersByCountry",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCountry.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCountry.insert;
    Lino.contacts.PartnersByCountry.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCountry.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.contacts.PartnersByCountry.insertPanel(p);
});
Lino.contacts.PartnersByCountry.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.contacts.PartnersByCountry.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  ls_url: "/contacts/PartnersByCountry",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.contacts.PartnersByCountry.detail;
    this.ls_insert_handler = Lino.contacts.PartnersByCountry.insert;
    Lino.contacts.PartnersByCountry.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnersByCountry.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.PartnersByCountry.detailPanel(p);
});
Lino.contacts.PartnersByCountry.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.contacts.PartnersByCountry.GridPanel(p);
});
Lino.contacts.PartnersByCountry.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnersByCountry.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnersByCountry", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class contacts.RolesByCompany
Lino.contacts.RolesByCompany.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/RolesByCompany",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByCompany','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Contact persons",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 11,
  ls_store_fields : [ { "name": "person" }, 'personHidden', { "name": "type" }, 'typeHidden', { "name": "id", "type": "int" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "company" }, 'companyHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 9,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var person1496 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Person...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByCompany/person" }) }) });
    var type1497 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByCompany/type" }) }) });
    var id1498 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp1499 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1500 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1501 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var company1502 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByCompany/company" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "person", "editable": true, "editor": person1496, "filter": { "type": "string" }, "header": "Person", "renderer": Lino.fk_renderer('personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(contacts.RolesByCompany.person) The person having this role in this company.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type1497, "filter": { "type": "string" }, "header": "Contact Role", "sortable": false, "tooltip": "(contacts.RolesByCompany.type) The role of this person in this company.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id1498, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.RolesByCompany.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByCompany.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByCompany.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByCompany.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "company", "editable": true, "editor": company1502, "filter": { "type": "string" }, "header": "Organization", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(contacts.RolesByCompany.company) The company where this person has a role.", "width": Lino.chars2width(21) } ];
    Lino.contacts.RolesByCompany.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.RolesByCompany.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByCompany", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByCompany.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.RolesByCompany.GridPanel(p);
});

// js_render_GridPanel_class contacts.RolesByPerson
Lino.contacts.RolesByPerson.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/contacts/RolesByPerson",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/RolesByPerson','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Contact for",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 11,
  ls_store_fields : [ { "name": "company" }, 'companyHidden', { "name": "type" }, 'typeHidden', { "name": "id", "type": "int" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "person" }, 'personHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 9,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var company1822 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Organization...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByPerson/company" }) }) });
    var type1823 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByPerson/type" }) }) });
    var id1824 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp1825 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1826 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1827 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var person1828 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/contacts/RolesByPerson/person" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "company", "editable": true, "editor": company1822, "filter": { "type": "string" }, "header": "Organization", "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(contacts.RolesByPerson.company) The company where this person has a role.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type1823, "filter": { "type": "string" }, "header": "Contact Role", "sortable": false, "tooltip": "(contacts.RolesByPerson.type) The role of this person in this company.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id1824, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(contacts.RolesByPerson.id) ", "width": Lino.chars2width(6) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByPerson.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByPerson.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(contacts.RolesByPerson.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "person", "editable": true, "editor": person1828, "filter": { "type": "string" }, "header": "Person", "hidden": true, "renderer": Lino.fk_renderer('personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(contacts.RolesByPerson.person) The person having this role in this company.", "width": Lino.chars2width(21) } ];
    Lino.contacts.RolesByPerson.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.RolesByPerson.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/RolesByPerson", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.RolesByPerson.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.RolesByPerson.GridPanel(p);
});

// js_render_GridPanel_class lists.MembersByList
Lino.lists.MembersByList.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/MembersByList",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByList','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Members",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "remark" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "move_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "list" }, 'listHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno953 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner954 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByList/partner" }) }) });
    var remark955 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp956 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id957 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var move_buttons_disp958 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp959 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp960 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var list961 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner List...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByList/list" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno953, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(lists.MembersByList.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner954, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.MembersByList.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "remark", "editable": true, "editor": remark955, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(lists.MembersByList.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(lists.MembersByList.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id957, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.MembersByList.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByList.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByList.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByList.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "list", "editable": true, "editor": list961, "filter": { "type": "string" }, "header": "Partner List", "hidden": true, "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.MembersByList.list) ", "width": Lino.chars2width(21) } ];
    Lino.lists.MembersByList.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.MembersByList.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.MembersByList.GridPanel(p);
});
Lino.lists.MembersByList.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByList.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByList", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class lists.MembersByPartner
Lino.lists.MembersByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/lists/MembersByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/lists/MembersByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "List memberships",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "list" }, 'listHidden', { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "move_buttons" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 13,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var list1435 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner List...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByPartner/list" }) }) });
    var remark1436 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id1437 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno1438 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var move_buttons_disp1439 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1440 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1441 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1442 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner1443 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/lists/MembersByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "list", "editable": true, "editor": list1435, "filter": { "type": "string" }, "header": "Partner List", "renderer": Lino.fk_renderer('listHidden','Lino.lists.Lists.detail'), "sortable": false, "tooltip": "(lists.MembersByPartner.list) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "remark", "editable": true, "editor": remark1436, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(lists.MembersByPartner.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "id", "editable": true, "editor": id1437, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(lists.MembersByPartner.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 3, "dataIndex": "seqno", "editable": true, "editor": seqno1438, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(lists.MembersByPartner.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(lists.MembersByPartner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner1443, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(lists.MembersByPartner.partner) ", "width": Lino.chars2width(21) } ];
    Lino.lists.MembersByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.lists.MembersByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.lists.MembersByPartner.GridPanel(p);
});
Lino.lists.MembersByPartner.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.lists.MembersByPartner.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/lists/MembersByPartner", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.ProblemsByChecker
Lino.plausibility.ProblemsByChecker.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/plausibility/ProblemsByChecker",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByChecker','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Plausibility problems",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 14,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "owner" }, { "name": "message" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "checker" }, 'checkerHidden', { "name": "disabled_actions" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByChecker.detail;
    var ww = this.containing_window;
    var user3923 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByChecker/user" }) }) });
    var owner_disp3924 = new Ext.form.DisplayField({ "disabled": true });
    var message3925 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var id3926 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type3927 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByChecker/owner_type" }) }) });
    var owner_id3928 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByChecker/owner_id" }) }) });
    var workflow_buttons_disp3929 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3930 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3931 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var checker3932 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type3927.on('change',Lino.chooser_handler(owner_id3928,'owner_type'));
      Lino.plausibility.ProblemsByChecker.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user3923, "filter": { "type": "string" }, "header": "Responsible", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "message", "editable": true, "editor": message3925, "filter": { "type": "string" }, "header": "Message", "sortable": true, "tooltip": "(plausibility.ProblemsByChecker.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3926, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.ProblemsByChecker.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "owner_type", "editable": true, "editor": owner_type3927, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_id", "editable": true, "editor": owner_id3928, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "checker", "editable": true, "editor": checker3932, "filter": { "type": "string" }, "header": "Plausibility checker", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByChecker.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) } ];
    Lino.plausibility.ProblemsByChecker.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByChecker.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.ProblemsByChecker.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/ProblemsByChecker",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByChecker.detail;
    Lino.plausibility.ProblemsByChecker.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByChecker.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.ProblemsByChecker.detailPanel(p);
});
Lino.plausibility.ProblemsByChecker.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.ProblemsByChecker.GridPanel(p);
});
Lino.plausibility.ProblemsByChecker.update_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByChecker.fix_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByChecker", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.SubscriptionsByUser
Lino.cal.SubscriptionsByUser.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/SubscriptionsByUser",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByUser','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Subscriptions",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 10,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "calendar" }, 'calendarHidden', { "name": "is_hidden", "type": "boolean" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "user" }, 'userHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 29,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6655 = new Ext.form.NumberField({ "selectOnFocus": true });
    var calendar6656 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByUser/calendar" }) }) });
    var is_hidden6657 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var workflow_buttons_disp6658 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6659 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6660 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var user6661 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByUser/user" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6655, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.SubscriptionsByUser.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "calendar", "editable": true, "editor": calendar6656, "filter": { "type": "string" }, "header": "Calendar", "sortable": false, "tooltip": "(cal.SubscriptionsByUser.calendar) The calendar you want to subscribe to.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "is_hidden", "editable": true, "filter": { "type": "boolean" }, "header": "hidden", "sortable": false, "tooltip": "(cal.SubscriptionsByUser.is_hidden) Whether this subscription should \"\n        \"initially be displayed as a hidden calendar.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByUser.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByUser.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByUser.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user6661, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.SubscriptionsByUser.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) } ];
    Lino.cal.SubscriptionsByUser.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.SubscriptionsByUser.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByUser", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByUser.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Subscriptions.ParamsPanel({});
  return new Lino.cal.SubscriptionsByUser.GridPanel(p);
});

// js_render_GridPanel_class cal.SubscriptionsByCalendar
Lino.cal.SubscriptionsByCalendar.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/SubscriptionsByCalendar",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/SubscriptionsByCalendar','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Subscriptions",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 10,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "is_hidden", "type": "boolean" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "calendar" }, 'calendarHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 29,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id3469 = new Ext.form.NumberField({ "selectOnFocus": true });
    var user3470 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByCalendar/user" }) }) });
    var is_hidden3471 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var workflow_buttons_disp3472 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3473 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3474 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var calendar3475 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/SubscriptionsByCalendar/calendar" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id3469, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.SubscriptionsByCalendar.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user3470, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "is_hidden", "editable": true, "filter": { "type": "boolean" }, "header": "hidden", "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.is_hidden) Whether this subscription should \"\n        \"initially be displayed as a hidden calendar.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "calendar", "editable": true, "editor": calendar3475, "filter": { "type": "string" }, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.SubscriptionsByCalendar.calendar) The calendar you want to subscribe to.", "width": Lino.chars2width(21) } ];
    Lino.cal.SubscriptionsByCalendar.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.SubscriptionsByCalendar.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/SubscriptionsByCalendar", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.SubscriptionsByCalendar.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Subscriptions.ParamsPanel({});
  return new Lino.cal.SubscriptionsByCalendar.GridPanel(p);
});

// js_render_GridPanel_class cal.TasksByUser
Lino.cal.TasksByUser.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/TasksByUser",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByUser','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Tasks",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 28,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "name": "start_time" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "due_time" }, { "name": "percent", "type": "int", "useNull": true }, { "name": "state" }, 'stateHidden', { "name": "owner" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "user" }, 'userHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByUser.detail;
    this.ls_insert_handler = Lino.cal.TasksByUser.insert;
    var ww = this.containing_window;
    var start_date6663 = new Lino.DateField({ "selectOnFocus": true });
    var summary6664 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp6665 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6666 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified6667 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created6668 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_time6669 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var owner_type6670 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/TasksByUser/owner_type" }) }) });
    var owner_id6671 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/TasksByUser/owner_id" }) }) });
    var description6672 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class6673 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence6674 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type6675 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var due_date6676 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var due_time6677 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var percent6678 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state6679 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.TaskStates });
    var owner_disp6680 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var overview_disp6681 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6682 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp6683 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var user6684 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/TasksByUser/user" }) }) });
    this.before_row_edit = function(record) {
      owner_id6671.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6670.on('change',Lino.chooser_handler(owner_id6671,'owner_type'));
      Lino.cal.TasksByUser.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date6663, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(cal.TasksByUser.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary6664, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.TasksByUser.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.TasksByUser.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6666, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_time", "editable": true, "editor": start_time6669, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 7, "dataIndex": "owner_type", "editable": true, "editor": owner_type6670, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.TasksByUser.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_id", "editable": true, "editor": owner_id6671, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "description", "editable": true, "editor": description6672, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.description) ", "width": Lino.chars2width(61) }, { "colIndex": 10, "dataIndex": "access_class", "editable": true, "editor": access_class6673, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "sequence", "editable": true, "editor": sequence6674, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 12, "dataIndex": "auto_type", "editable": true, "editor": auto_type6675, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "due_date", "editable": true, "editor": due_date6676, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 14, "dataIndex": "due_time", "editable": true, "editor": due_time6677, "header": "Due time", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.due_time) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 15, "dataIndex": "percent", "editable": true, "editor": percent6678, "filter": { "type": "numeric" }, "format": "0", "header": "Duration value", "hidden": true, "sortable": true, "tooltip": "(cal.TasksByUser.percent) ", "width": Lino.chars2width(6) }, { "colIndex": 16, "dataIndex": "state", "editable": true, "editor": state6679, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.state) The state of this Task. one of TaskStates.", "width": Lino.chars2width(13) }, { "colIndex": 17, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.TasksByUser.created_natural) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "user", "editable": true, "editor": user6684, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.TasksByUser.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) } ];
    Lino.cal.TasksByUser.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByUser.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByUser.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/TasksByUser",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByUser.detail;
    this.ls_insert_handler = Lino.cal.TasksByUser.insert;
    Lino.cal.TasksByUser.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByUser.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.TasksByUser.insertPanel(p);
});
Lino.cal.TasksByUser.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByUser.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/TasksByUser",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByUser.detail;
    this.ls_insert_handler = Lino.cal.TasksByUser.insert;
    Lino.cal.TasksByUser.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByUser.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.TasksByUser.detailPanel(p);
});
Lino.cal.TasksByUser.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.TasksByUser.GridPanel(p);
});
Lino.cal.TasksByUser.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByUser.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByUser", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestsByEvent
Lino.cal.GuestsByEvent.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestsByEvent",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByEvent','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Presences",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByEvent.detail;
    this.ls_insert_handler = Lino.cal.GuestsByEvent.insert;
    var ww = this.containing_window;
    var partner857 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByEvent/partner" }) }) });
    var role858 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByEvent/role" }) }) });
    var workflow_buttons_disp859 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner857, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(cal.GuestsByEvent.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role858, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.GuestsByEvent.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.GuestsByEvent.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestsByEvent.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByEvent.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByEvent.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/GuestsByEvent",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByEvent.detail;
    this.ls_insert_handler = Lino.cal.GuestsByEvent.insert;
    Lino.cal.GuestsByEvent.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByEvent.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestsByEvent.insertPanel(p);
});
Lino.cal.GuestsByEvent.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByEvent.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/GuestsByEvent",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByEvent.detail;
    this.ls_insert_handler = Lino.cal.GuestsByEvent.insert;
    Lino.cal.GuestsByEvent.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByEvent.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestsByEvent.detailPanel(p);
});
Lino.cal.GuestsByEvent.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.GuestsByEvent.GridPanel(p);
});
Lino.cal.GuestsByEvent.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByEvent.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByEvent", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestsByRole
Lino.cal.GuestsByRole.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestsByRole",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByRole','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Presences",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 15,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "role" }, 'roleHidden', { "name": "workflow_buttons" }, { "name": "remark" }, { "name": "event" }, 'eventHidden', { "name": "id", "type": "int" }, { "name": "state" }, 'stateHidden', { "name": "event_summary" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByRole.detail;
    this.ls_insert_handler = Lino.cal.GuestsByRole.insert;
    var ww = this.containing_window;
    var partner2845 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByRole/partner" }) }) });
    var role2846 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByRole/role" }) }) });
    var workflow_buttons_disp2847 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var remark2848 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var event2849 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Calendar entry...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/GuestsByRole/event" }) }) });
    var id2850 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var state2851 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.GuestStates });
    var event_summary_disp2852 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2853 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2854 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner2845, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(cal.GuestsByRole.partner) The partner to which this presence applies.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "role", "editable": true, "editor": role2846, "filter": { "type": "string" }, "header": "Role", "renderer": Lino.fk_renderer('roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(cal.GuestsByRole.role) The role of this partner in this presence.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.GuestsByRole.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark2848, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(cal.GuestsByRole.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "event", "editable": true, "editor": event2849, "filter": { "type": "string" }, "header": "Calendar entry", "renderer": Lino.fk_renderer('eventHidden','Lino.cal.OneEvent.detail'), "sortable": false, "tooltip": "(cal.GuestsByRole.event) The calendar event to which this presence applies.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2850, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.GuestsByRole.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "state", "editable": true, "editor": state2851, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.state) The state of this presence.", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "event_summary", "editable": false, "header": "Event", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.event_summary) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.GuestsByRole.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestsByRole.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByRole.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByRole.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/GuestsByRole",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByRole.detail;
    this.ls_insert_handler = Lino.cal.GuestsByRole.insert;
    Lino.cal.GuestsByRole.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByRole.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestsByRole.insertPanel(p);
});
Lino.cal.GuestsByRole.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByRole.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/GuestsByRole",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByRole.detail;
    this.ls_insert_handler = Lino.cal.GuestsByRole.insert;
    Lino.cal.GuestsByRole.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByRole.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestsByRole.detailPanel(p);
});
Lino.cal.GuestsByRole.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.GuestsByRole.GridPanel(p);
});
Lino.cal.GuestsByRole.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByRole.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByRole", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.GuestsByPartner
Lino.cal.GuestsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/GuestsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Presences",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "event__when_text" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 19,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByPartner.detail;
    this.ls_insert_handler = Lino.cal.GuestsByPartner.insert;
    var ww = this.containing_window;
    var event__when_text_disp6686 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "sortable": false, "value": "<br/>" });
    var workflow_buttons_disp6687 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "event__when_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.GuestsByPartner.event__when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.GuestsByPartner.workflow_buttons) ", "width": Lino.chars2width(31) } ];
    Lino.cal.GuestsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByPartner.insertPanel = Ext.extend(Lino.cal.Guests.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/GuestsByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByPartner.detail;
    this.ls_insert_handler = Lino.cal.GuestsByPartner.insert;
    Lino.cal.GuestsByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByPartner.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.GuestsByPartner.insertPanel(p);
});
Lino.cal.GuestsByPartner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.GuestsByPartner.detailPanel = Ext.extend(Lino.cal.Guests.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/GuestsByPartner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.GuestsByPartner.detail;
    this.ls_insert_handler = Lino.cal.GuestsByPartner.insert;
    Lino.cal.GuestsByPartner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestsByPartner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestsByPartner.detailPanel(p);
});
Lino.cal.GuestsByPartner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Guests.ParamsPanel({});
  return new Lino.cal.GuestsByPartner.GridPanel(p);
});
Lino.cal.GuestsByPartner.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestsByPartner.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestsByPartner", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class ledger.MatchRulesByJournal
Lino.ledger.MatchRulesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/ledger/MatchRulesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MatchRulesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Match rules",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 9,
  ls_store_fields : [ { "name": "account" }, 'accountHidden', { "name": "id", "type": "int" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 36,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var account3219 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRulesByJournal/account" }) }) });
    var id3220 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp3221 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3222 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3223 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal3224 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MatchRulesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "account", "editable": true, "editor": account3219, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id3220, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MatchRulesByJournal.id) ", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "journal", "editable": true, "editor": journal3224, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(ledger.MatchRulesByJournal.journal) ", "width": Lino.chars2width(21) } ];
    Lino.ledger.MatchRulesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MatchRulesByJournal.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MatchRulesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MatchRulesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.MatchRulesByJournal.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByVoucher
Lino.ledger.MovementsByVoucher.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/MovementsByVoucher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByVoucher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Movements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 10,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "account" }, 'accountHidden', { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno6732 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true });
    var partner6733 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByVoucher/partner" }) }) });
    var account6734 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByVoucher/account" }) }) });
    var debit6735 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit6736 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp6737 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared6738 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno6732, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.No.", "sortable": true, "tooltip": "(ledger.MovementsByVoucher.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner6733, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByVoucher.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "account", "editable": true, "editor": account6734, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.credit) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Cleared", "sortable": false, "tooltip": "(ledger.MovementsByVoucher.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" } ];
    Lino.ledger.MovementsByVoucher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByVoucher.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByVoucher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByVoucher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByVoucher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByVoucher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByVoucher", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByVoucher", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByVoucher.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByVoucher.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByPartner
Lino.ledger.MovementsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/MovementsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Movements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "voucher_partner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_actions" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date6740 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp6741 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp6742 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit6743 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit6744 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp6745 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared6746 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id6747 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher6748 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Voucher...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/voucher" }) }) });
    var seqno6749 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account6750 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/account" }) }) });
    var amount6751 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc6752 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match6753 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/match" }) }) });
    var voucher_partner_disp6754 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6755 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6756 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6757 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner6758 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner6758.on('change',Lino.chooser_handler(match6753,'partner'));
      account6750.on('change',Lino.chooser_handler(match6753,'account'));
      Lino.ledger.MovementsByPartner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date6740, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Value date", "sortable": true, "tooltip": "(ledger.MovementsByPartner.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Voucher", "sortable": false, "tooltip": "(ledger.MovementsByPartner.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.MovementsByPartner.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByPartner.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.MovementsByPartner.credit) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.MovementsByPartner.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Cleared", "sortable": false, "tooltip": "(ledger.MovementsByPartner.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id6747, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByPartner.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "voucher", "editable": true, "editor": voucher6748, "filter": { "type": "string" }, "header": "Voucher", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 9, "dataIndex": "seqno", "editable": true, "editor": seqno6749, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.No.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByPartner.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6) }, { "colIndex": 10, "dataIndex": "account", "editable": true, "editor": account6750, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "amount", "editable": true, "editor": amount6751, "filter": { "type": "numeric" }, "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByPartner.amount) ", "width": Lino.chars2width(13) }, { "colIndex": 12, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match6753, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "voucher_partner", "editable": false, "header": "Voucher partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByPartner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "partner", "editable": true, "editor": partner6758, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByPartner.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) } ];
    Lino.ledger.MovementsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByPartner.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByAccount
Lino.ledger.MovementsByAccount.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/MovementsByAccount",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByAccount','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Movements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "match_link" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "voucher_partner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "account" }, 'accountHidden', { "name": "disabled_actions" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date6760 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp6761 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp6762 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit6763 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit6764 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var match_link_disp6765 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var cleared6766 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id6767 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher6768 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Voucher...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/voucher" }) }) });
    var partner6769 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/partner" }) }) });
    var seqno6770 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var amount6771 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc6772 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match6773 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/match" }) }) });
    var voucher_partner_disp6774 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6775 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6776 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6777 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var account6778 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByAccount/account" }) }) });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner6769.on('change',Lino.chooser_handler(match6773,'partner'));
      account6778.on('change',Lino.chooser_handler(match6773,'account'));
      Lino.ledger.MovementsByAccount.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date6760, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Value date", "sortable": true, "tooltip": "(ledger.MovementsByAccount.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Voucher", "sortable": false, "tooltip": "(ledger.MovementsByAccount.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.MovementsByAccount.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByAccount.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.MovementsByAccount.credit) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "match_link", "editable": false, "header": "Match", "sortable": false, "tooltip": "(ledger.MovementsByAccount.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Cleared", "sortable": false, "tooltip": "(ledger.MovementsByAccount.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id6767, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByAccount.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "voucher", "editable": true, "editor": voucher6768, "filter": { "type": "string" }, "header": "Voucher", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "partner", "editable": true, "editor": partner6769, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByAccount.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 10, "dataIndex": "seqno", "editable": true, "editor": seqno6770, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.No.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByAccount.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 11, "dataIndex": "amount", "editable": true, "editor": amount6771, "filter": { "type": "numeric" }, "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByAccount.amount) ", "width": Lino.chars2width(13) }, { "colIndex": 12, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match6773, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "voucher_partner", "editable": false, "header": "Voucher partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "account", "editable": true, "editor": account6778, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByAccount.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) } ];
    Lino.ledger.MovementsByAccount.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByAccount.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByAccount", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByAccount", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByAccount", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByAccount", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByAccount", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByAccount", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByAccount.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByAccount.GridPanel(p);
});

// js_render_GridPanel_class ledger.MovementsByMatch
Lino.ledger.MovementsByMatch.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": Lino.auto_height_cell_template, "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/MovementsByMatch",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/MovementsByMatch','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Movements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "value_date", "type": "date" }, { "name": "voucher_link" }, { "name": "description" }, { "name": "debit" }, { "name": "credit" }, { "name": "cleared", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "voucher" }, 'voucherHidden', { "name": "partner" }, 'partnerHidden', { "name": "seqno", "type": "int", "useNull": true }, { "name": "account" }, 'accountHidden', { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "match" }, { "name": "match_link" }, { "name": "voucher_partner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_actions" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value_date6780 = new Lino.DateField({ "selectOnFocus": true });
    var voucher_link_disp6781 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp6782 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var debit6783 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var credit6784 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var cleared6785 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id6786 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var voucher6787 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Voucher...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/voucher" }) }) });
    var partner6788 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/partner" }) }) });
    var seqno6789 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var account6790 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/account" }) }) });
    var amount6791 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc6792 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var match6793 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/ledger/MovementsByMatch/match" }) }) });
    var match_link_disp6794 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher_partner_disp6795 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6796 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6797 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6798 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      partner6788.on('change',Lino.chooser_handler(match6793,'partner'));
      account6790.on('change',Lino.chooser_handler(match6793,'account'));
      Lino.ledger.MovementsByMatch.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value_date", "editable": true, "editor": value_date6780, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Value date", "sortable": true, "tooltip": "(ledger.MovementsByMatch.value_date) The date at which this movement is to be entered into the\nledger.  This is usually the voucher's entry_date, except\ne.g. for bank statements where each item can have its own\nvalue date.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher_link", "editable": false, "header": "Voucher", "sortable": false, "tooltip": "(ledger.MovementsByMatch.voucher_link) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.MovementsByMatch.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "debit", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.MovementsByMatch.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "credit", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.MovementsByMatch.credit) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "cleared", "editable": true, "filter": { "type": "boolean" }, "header": "Cleared", "sortable": false, "tooltip": "(ledger.MovementsByMatch.cleared) Whether", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id6786, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByMatch.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "voucher", "editable": true, "editor": voucher6787, "filter": { "type": "string" }, "header": "Voucher", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.voucher) Pointer to the Voucher who caused this movement.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": true, "editor": partner6788, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.MovementsByMatch.partner) Pointer to the partner involved in this movement. This may be\nblank.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 9, "dataIndex": "seqno", "editable": true, "editor": seqno6789, "filter": { "type": "numeric" }, "format": "0", "header": "Seq.No.", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByMatch.seqno) Sequential number within a voucher.", "width": Lino.chars2width(6) }, { "colIndex": 10, "dataIndex": "account", "editable": true, "editor": account6790, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.account) Pointer to the Account that is being moved by this movement.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "amount", "editable": true, "editor": amount6791, "filter": { "type": "numeric" }, "header": "amount", "hidden": true, "sortable": true, "tooltip": "(ledger.MovementsByMatch.amount) ", "width": Lino.chars2width(13) }, { "colIndex": 12, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match6793, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.match) Pointer to the Movement that is being cleared by this\nmovement.", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "match_link", "editable": false, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.match_link) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "voucher_partner", "editable": false, "header": "Voucher partner", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.voucher_partner) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(ledger.MovementsByMatch.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.MovementsByMatch.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.MovementsByMatch.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByMatch", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByMatch", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByMatch", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByMatch", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByMatch", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/MovementsByMatch", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.MovementsByMatch.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Movements.ParamsPanel({});
  return new Lino.ledger.MovementsByMatch.GridPanel(p);
});

// js_render_GridPanel_class vat.InvoicesByJournal
Lino.vat.InvoicesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/InvoicesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/InvoicesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 30,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "user" }, 'userHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "your_ref" }, { "name": "overview" }, { "name": "description_column" }, { "name": "number_with_year" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.InvoicesByJournal.insert;
    var ww = this.containing_window;
    var number541 = new Ext.form.NumberField({ "selectOnFocus": true });
    var voucher_date542 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var due_date543 = new Lino.DateField({ "selectOnFocus": true });
    var partner544 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/partner" }) }) });
    var total_incl545 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_base546 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat547 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var user548 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/user" }) }) });
    var workflow_buttons_disp549 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id550 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var entry_date551 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period552 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/accounting_period" }) }) });
    var narration553 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state554 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term555 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/payment_term" }) }) });
    var match556 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/match" }) }) });
    var vat_regime557 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var your_ref558 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var overview_disp559 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp560 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp561 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal562 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/InvoicesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      accounting_period552.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      var bp = this.get_base_params();
      match556.setContextValue('mk',bp['mk']);
      match556.setContextValue('mt',bp['mt']);
      match556.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date551.on('change',Lino.chooser_handler(accounting_period552,'entry_date'));
      journal562.on('change',Lino.chooser_handler(match556,'journal'));
      partner544.on('change',Lino.chooser_handler(match556,'partner'));
      Lino.vat.InvoicesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number541, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(vat.InvoicesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date542, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(vat.InvoicesByJournal.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "due_date", "editable": true, "editor": due_date543, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "sortable": true, "tooltip": "(vat.InvoicesByJournal.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner544, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(vat.InvoicesByJournal.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl545, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(vat.InvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "total_base", "editable": true, "editor": total_base546, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "sortable": true, "tooltip": "(vat.InvoicesByJournal.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "total_vat", "editable": true, "editor": total_vat547, "filter": { "type": "numeric" }, "header": "VAT", "sortable": true, "tooltip": "(vat.InvoicesByJournal.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user548, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(vat.InvoicesByJournal.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(vat.InvoicesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id550, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.id) ", "width": Lino.chars2width(6) }, { "colIndex": 10, "dataIndex": "entry_date", "editable": true, "editor": entry_date551, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period552, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "narration", "editable": true, "editor": narration553, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "state", "editable": true, "editor": state554, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "payment_term", "editable": true, "editor": payment_term555, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "match", "editable": true, "editor": match556, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime557, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.", "width": Lino.chars2width(28) }, { "colIndex": 17, "dataIndex": "your_ref", "editable": true, "editor": your_ref558, "filter": { "type": "string" }, "header": "Your reference", "hidden": true, "sortable": true, "tooltip": "(vat.InvoicesByJournal.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 21, "dataIndex": "journal", "editable": true, "editor": journal562, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(vat.InvoicesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.vat.InvoicesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoicesByJournal.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.InvoicesByJournal.insertPanel = Ext.extend(Lino.vat.InvoicesByJournal.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/vat/InvoicesByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.InvoicesByJournal.insert;
    Lino.vat.InvoicesByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoicesByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.vat.InvoicesByJournal.insertPanel(p);
});
Lino.vat.InvoicesByJournal.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.vat.InvoicesByJournal.detailPanel = Ext.extend(Lino.vat.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/vat/InvoicesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.vat.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.vat.InvoicesByJournal.insert;
    Lino.vat.InvoicesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.InvoicesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.InvoicesByJournal.detailPanel(p);
});
Lino.vat.InvoicesByJournal.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.vat.InvoicesByJournal.ParamsPanel({});
  return new Lino.vat.InvoicesByJournal.GridPanel(p);
});
Lino.vat.InvoicesByJournal.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.InvoicesByJournal.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/InvoicesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class vat.ItemsByInvoice
Lino.vat.ItemsByInvoice.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/vat/ItemsByInvoice",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/ItemsByInvoice','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Account invoice items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 10,
  ls_store_fields : [ { "name": "account" }, 'accountHidden', { "name": "title" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "total_base" }, { "name": "total_vat" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 43,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var account580 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/vat/ItemsByInvoice/account" }) }) });
    var title581 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var vat_class582 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var total_base583 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_vat584 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var total_incl585 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      account580.setContextValue('mk',bp['mk']);
      account580.setContextValue('mt',bp['mt']);
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "account", "editable": true, "editor": account580, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(vat.ItemsByInvoice.account) ForeignKey pointing to the account (accounts.Account) that is to be moved.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title581, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(vat.ItemsByInvoice.title) The title of this voucher.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "vat_class", "editable": true, "editor": vat_class582, "filter": { "type": "string" }, "header": "VAT Class", "sortable": false, "tooltip": "(vat.ItemsByInvoice.vat_class) The VAT class to be applied for this item. A pointer to\nVatClasses.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "total_base", "editable": true, "editor": total_base583, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "sortable": true, "tooltip": "(vat.ItemsByInvoice.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "total_vat", "editable": true, "editor": total_vat584, "filter": { "type": "numeric" }, "header": "VAT", "sortable": true, "tooltip": "(vat.ItemsByInvoice.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl585, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(vat.ItemsByInvoice.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) } ];
    Lino.vat.ItemsByInvoice.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.ItemsByInvoice.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.ItemsByInvoice.GridPanel(p);
});
Lino.vat.ItemsByInvoice.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.ItemsByInvoice.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/ItemsByInvoice", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class products.ProductsByCategory
Lino.products.ProductsByCategory.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/products/ProductsByCategory",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/ProductsByCategory','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Tariffs",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 24,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "cat" }, 'catHidden', { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "delivery_unit" }, 'delivery_unitHidden', { "name": "number_of_events", "type": "int", "useNull": true }, { "name": "min_asset", "type": "int", "useNull": true }, { "name": "sales_account" }, 'sales_accountHidden', { "name": "sales_price" }, { "name": "purchases_account" }, 'purchases_accountHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 31,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductsByCategory.detail;
    this.ls_insert_handler = Lino.products.ProductsByCategory.insert;
    var ww = this.containing_window;
    var id3710 = new Ext.form.NumberField({ "selectOnFocus": true });
    var name3711 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3712 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3713 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var cat3714 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/ProductsByCategory/cat" }) }) });
    var vat_class3715 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description3716 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3717 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3718 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var delivery_unit3719 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.products.DeliveryUnit, "value": "20" });
    var number_of_events3720 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var min_asset3721 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true, "value": 1 });
    var sales_account3722 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/ProductsByCategory/sales_account" }) }) });
    var sales_price3723 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var purchases_account3724 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/products/ProductsByCategory/purchases_account" }) }) });
    var workflow_buttons_disp3725 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3726 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3727 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id3710, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(products.ProductsByCategory.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3711, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(products.ProductsByCategory.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3712, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(products.ProductsByCategory.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3713, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(products.ProductsByCategory.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "cat", "editable": true, "editor": cat3714, "filter": { "type": "string" }, "header": "Category", "renderer": Lino.fk_renderer('catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(products.ProductsByCategory.cat) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "vat_class", "editable": true, "editor": vat_class3715, "filter": { "type": "string" }, "header": "VAT Class", "sortable": false, "tooltip": "(products.ProductsByCategory.vat_class) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "description", "editable": true, "editor": description3716, "filter": { "type": "string" }, "header": "Long description", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description) ", "width": Lino.chars2width(61) }, { "colIndex": 7, "dataIndex": "description_de", "editable": true, "editor": description_de3717, "filter": { "type": "string" }, "header": "Long description (de)", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 8, "dataIndex": "description_fr", "editable": true, "editor": description_fr3718, "filter": { "type": "string" }, "header": "Long description (fr)", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 9, "dataIndex": "delivery_unit", "editable": true, "editor": delivery_unit3719, "filter": { "type": "string" }, "header": "Delivery unit", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.delivery_unit) ", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 10, "dataIndex": "number_of_events", "editable": true, "editor": number_of_events3720, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(products.ProductsByCategory.number_of_events) Number of calendar events paid per invoicing.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 11, "dataIndex": "min_asset", "editable": true, "editor": min_asset3721, "filter": { "type": "numeric" }, "format": "0", "header": "Invoice threshold", "hidden": true, "sortable": true, "tooltip": "(products.ProductsByCategory.min_asset) Minimum quantity to pay in advance.", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "sales_account", "editable": true, "editor": sales_account3722, "filter": { "type": "string" }, "header": "Sales Base account", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.sales_account) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 13, "dataIndex": "sales_price", "editable": true, "editor": sales_price3723, "filter": { "type": "numeric" }, "header": "Sales price", "hidden": true, "sortable": true, "tooltip": "(products.ProductsByCategory.sales_price) ", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "purchases_account", "editable": true, "editor": purchases_account3724, "filter": { "type": "string" }, "header": "Purchases Base account", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.purchases_account) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(products.ProductsByCategory.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.products.ProductsByCategory.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductsByCategory.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductsByCategory.insertPanel = Ext.extend(Lino.products.Products.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/products/ProductsByCategory",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductsByCategory.detail;
    this.ls_insert_handler = Lino.products.ProductsByCategory.insert;
    Lino.products.ProductsByCategory.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductsByCategory.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.products.ProductsByCategory.insertPanel(p);
});
Lino.products.ProductsByCategory.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.products.ProductsByCategory.detailPanel = Ext.extend(Lino.products.Products.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/products/ProductsByCategory",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.products.ProductsByCategory.detail;
    this.ls_insert_handler = Lino.products.ProductsByCategory.insert;
    Lino.products.ProductsByCategory.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.products.ProductsByCategory.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductsByCategory.detailPanel(p);
});
Lino.products.ProductsByCategory.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.ProductsByCategory.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.ProductsByCategory.GridPanel(p);
});
Lino.products.ProductsByCategory.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/ProductsByCategory", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class accounts.AccountsByGroup
Lino.accounts.AccountsByGroup.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/accounts/AccountsByGroup",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountsByGroup','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Accounts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 22,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "sales_allowed", "type": "boolean" }, { "name": "purchases_allowed", "type": "boolean" }, { "name": "wages_allowed", "type": "boolean" }, { "name": "clearings_allowed", "type": "boolean" }, { "name": "type" }, 'typeHidden', { "name": "needs_partner", "type": "boolean" }, { "name": "clearable", "type": "boolean" }, { "name": "default_amount" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "group" }, 'groupHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 33,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.AccountsByGroup.detail;
    this.ls_insert_handler = Lino.accounts.AccountsByGroup.insert;
    var ww = this.containing_window;
    var ref3794 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name3795 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3796 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3797 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id3798 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno3799 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var sales_allowed3800 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var purchases_allowed3801 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wages_allowed3802 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var clearings_allowed3803 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var type3804 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.accounts.AccountTypes });
    var needs_partner3805 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var clearable3806 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var default_amount3807 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp3808 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3809 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3810 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp3811 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var group3812 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account Group...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/accounts/AccountsByGroup/group" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref3794, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(accounts.AccountsByGroup.ref) An optional unique name which can be used to reference a given\naccount.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3795, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(accounts.AccountsByGroup.name) The multilingual designation of this account, as the users see\nit.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3796, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(accounts.AccountsByGroup.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3797, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(accounts.AccountsByGroup.name_fr) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id3798, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 5, "dataIndex": "seqno", "editable": true, "editor": seqno3799, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.seqno) The sequence number of this account within its group.", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "sales_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Sales", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.sales_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "purchases_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Purchases", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.purchases_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 8, "dataIndex": "wages_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Wages", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.wages_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "clearings_allowed", "editable": true, "filter": { "type": "boolean" }, "header": "Clearings", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.clearings_allowed) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 10, "dataIndex": "type", "editable": true, "editor": type3804, "filter": { "type": "string" }, "header": "Account Type", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.type) The account type of this account.  This points to an item of\nAccountTypes.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "needs_partner", "editable": true, "filter": { "type": "boolean" }, "header": "Needs partner", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.needs_partner) Whether bookings to this account need a partner specified.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "clearable", "editable": true, "filter": { "type": "boolean" }, "header": "Clearable", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.clearable) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 13, "dataIndex": "default_amount", "editable": true, "editor": default_amount3807, "filter": { "type": "numeric" }, "header": "Default amount", "hidden": true, "sortable": true, "tooltip": "(accounts.AccountsByGroup.default_amount) The default amount to book in bank statements or journal\nentries when this account has been selected manually. The\ndefault booking direction is that of the type.", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 18, "dataIndex": "group", "editable": true, "editor": group3812, "filter": { "type": "string" }, "header": "Account Group", "hidden": true, "sortable": false, "tooltip": "(accounts.AccountsByGroup.group) The account group to which this account belongs.  Points to\nan instance of Group.  If this field is empty, the\naccount won't appear in certain reports.", "width": Lino.chars2width(21) } ];
    Lino.accounts.AccountsByGroup.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountsByGroup.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.AccountsByGroup.insertPanel = Ext.extend(Lino.accounts.Accounts.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/accounts/AccountsByGroup",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.AccountsByGroup.detail;
    this.ls_insert_handler = Lino.accounts.AccountsByGroup.insert;
    Lino.accounts.AccountsByGroup.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountsByGroup.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.accounts.AccountsByGroup.insertPanel(p);
});
Lino.accounts.AccountsByGroup.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.accounts.AccountsByGroup.detailPanel = Ext.extend(Lino.accounts.Accounts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/accounts/AccountsByGroup",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.accounts.AccountsByGroup.detail;
    this.ls_insert_handler = Lino.accounts.AccountsByGroup.insert;
    Lino.accounts.AccountsByGroup.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountsByGroup.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.AccountsByGroup.detailPanel(p);
});
Lino.accounts.AccountsByGroup.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.AccountsByGroup.GridPanel(p);
});
Lino.accounts.AccountsByGroup.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountsByGroup.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountsByGroup", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.PartnersByInvoiceRecipient
Lino.sales.PartnersByInvoiceRecipient.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/PartnersByInvoiceRecipient",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/PartnersByInvoiceRecipient','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  cell_edit : true,
  title : "Invoice senders",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 39,
  ls_store_fields : [ { "name": "name" }, { "name": "id", "type": "int" }, { "name": "address_column" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "debit_balance" }, { "name": "name_column" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mti_navigator" }, { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 1,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PartnersByInvoiceRecipient.detail;
    this.ls_insert_handler = Lino.sales.PartnersByInvoiceRecipient.insert;
    var ww = this.containing_window;
    var name6800 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var id6801 = new Ext.form.NumberField({ "selectOnFocus": true });
    var address_column_disp6802 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var email6803 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language6804 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url6805 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone6806 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm6807 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax6808 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country6809 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/country" }) }) });
    var city6810 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/city" }) }) });
    var zip_code6811 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region6812 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/region" }) }) });
    var addr16813 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix6814 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street6815 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no6816 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box6817 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr26818 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks6819 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term6820 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/payment_term" }) }) });
    var vat_regime6821 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var paper_type6822 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/paper_type" }) }) });
    var debit_balance6823 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var name_column_disp6824 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6825 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6826 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6827 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp6828 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoice_recipient6829 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/PartnersByInvoiceRecipient/invoice_recipient" }) }) });
    this.before_row_edit = function(record) {
      city6810.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city6810.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region6812.setContextValue('country', record ? record.data['countryHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      country6809.on('change',Lino.chooser_handler(city6810,'country'));
      region6812.on('change',Lino.chooser_handler(city6810,'region'));
      country6809.on('change',Lino.chooser_handler(region6812,'country'));
      Lino.sales.PartnersByInvoiceRecipient.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": true, "editor": name6800, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 1, "dataIndex": "id", "editable": true, "editor": id6801, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.id) ", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "email", "editable": true, "editor": email6803, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "language", "editable": true, "editor": language6804, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "url", "editable": true, "editor": url6805, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.url) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "phone", "editable": true, "editor": phone6806, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "gsm", "editable": true, "editor": gsm6807, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "fax", "editable": true, "editor": fax6808, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "country", "editable": true, "editor": country6809, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.country) ", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "city", "editable": true, "editor": city6810, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "zip_code", "editable": true, "editor": zip_code6811, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 12, "dataIndex": "region", "editable": true, "editor": region6812, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.region) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "addr1", "editable": true, "editor": addr16813, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix6814, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street", "editable": true, "editor": street6815, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street_no", "editable": true, "editor": street_no6816, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 17, "dataIndex": "street_box", "editable": true, "editor": street_box6817, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "addr2", "editable": true, "editor": addr26818, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(sales.PartnersByInvoiceRecipient.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 19, "dataIndex": "remarks", "editable": true, "editor": remarks6819, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "payment_term", "editable": true, "editor": payment_term6820, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime6821, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 22, "dataIndex": "paper_type", "editable": true, "editor": paper_type6822, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 23, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 24, "dataIndex": "name_column", "editable": false, "header": "Name", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.mti_navigator) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient6829, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.PartnersByInvoiceRecipient.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) } ];
    Lino.sales.PartnersByInvoiceRecipient.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PartnersByInvoiceRecipient.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.PartnersByInvoiceRecipient.insertPanel = Ext.extend(Lino.contacts.Partners.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/PartnersByInvoiceRecipient",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PartnersByInvoiceRecipient.detail;
    this.ls_insert_handler = Lino.sales.PartnersByInvoiceRecipient.insert;
    Lino.sales.PartnersByInvoiceRecipient.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PartnersByInvoiceRecipient.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.PartnersByInvoiceRecipient.insertPanel(p);
});
Lino.sales.PartnersByInvoiceRecipient.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.PartnersByInvoiceRecipient.detailPanel = Ext.extend(Lino.contacts.Partners.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" } ],
  ls_url: "/sales/PartnersByInvoiceRecipient",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.PartnersByInvoiceRecipient.detail;
    this.ls_insert_handler = Lino.sales.PartnersByInvoiceRecipient.insert;
    Lino.sales.PartnersByInvoiceRecipient.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.PartnersByInvoiceRecipient.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.PartnersByInvoiceRecipient.detailPanel(p);
});
Lino.sales.PartnersByInvoiceRecipient.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(15), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.sales.PartnersByInvoiceRecipient.GridPanel(p);
});
Lino.sales.PartnersByInvoiceRecipient.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.PartnersByInvoiceRecipient.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/PartnersByInvoiceRecipient", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.InvoicesByJournal
Lino.sales.InvoicesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/InvoicesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this journal." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Product invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 41,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "total_incl" }, { "name": "subject" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "your_ref" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "language" }, 'languageHidden', { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp381 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var voucher_date382 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var due_date383 = new Lino.DateField({ "selectOnFocus": true });
    var partner384 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/partner" }) }) });
    var total_incl385 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var subject386 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp387 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id388 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user389 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/user" }) }) });
    var entry_date390 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period391 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/accounting_period" }) }) });
    var number392 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration393 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state394 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term395 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/payment_term" }) }) });
    var match396 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/match" }) }) });
    var total_base397 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat398 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime399 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var your_ref400 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var printed_by401 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var language402 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var intro403 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type404 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/paper_type" }) }) });
    var balance_before405 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay406 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var overview_disp407 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp408 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp409 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal410 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      accounting_period391.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      var bp = this.get_base_params();
      match396.setContextValue('mk',bp['mk']);
      match396.setContextValue('mt',bp['mt']);
      match396.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date390.on('change',Lino.chooser_handler(accounting_period391,'entry_date'));
      journal410.on('change',Lino.chooser_handler(match396,'journal'));
      partner384.on('change',Lino.chooser_handler(match396,'partner'));
      Lino.sales.InvoicesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "No.", "sortable": false, "tooltip": "(sales.InvoicesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date382, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(sales.InvoicesByJournal.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "due_date", "editable": true, "editor": due_date383, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "sortable": true, "tooltip": "(sales.InvoicesByJournal.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "partner", "editable": true, "editor": partner384, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "total_incl", "editable": true, "editor": total_incl385, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.InvoicesByJournal.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "subject", "editable": true, "editor": subject386, "filter": { "type": "string" }, "header": "Subject line", "sortable": true, "tooltip": "(sales.InvoicesByJournal.subject) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(sales.InvoicesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id388, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user389, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "entry_date", "editable": true, "editor": entry_date390, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period391, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 11, "dataIndex": "number", "editable": true, "editor": number392, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "narration", "editable": true, "editor": narration393, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "state", "editable": true, "editor": state394, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "payment_term", "editable": true, "editor": payment_term395, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "match", "editable": true, "editor": match396, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 16, "dataIndex": "total_base", "editable": true, "editor": total_base397, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 17, "dataIndex": "total_vat", "editable": true, "editor": total_vat398, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 18, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime399, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.", "width": Lino.chars2width(28) }, { "colIndex": 19, "dataIndex": "your_ref", "editable": true, "editor": your_ref400, "filter": { "type": "string" }, "header": "Your reference", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByJournal.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.InvoicesByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "language", "editable": true, "editor": language402, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.language) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "intro", "editable": true, "editor": intro403, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "paper_type", "editable": true, "editor": paper_type404, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 24, "dataIndex": "balance_before", "editable": false, "header": "Balance before", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.balance_before) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 25, "dataIndex": "balance_to_pay", "editable": false, "header": "Balance to pay", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.balance_to_pay) ", "width": Lino.chars2width(13) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "journal", "editable": true, "editor": journal410, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.sales.InvoicesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByJournal.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByJournal.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/InvoicesByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByJournal.insert;
    Lino.sales.InvoicesByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.InvoicesByJournal.insertPanel(p);
});
Lino.sales.InvoicesByJournal.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByJournal.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByJournal','start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this journal." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/InvoicesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByJournal.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByJournal.insert;
    Lino.sales.InvoicesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoicesByJournal.detailPanel(p);
});
Lino.sales.InvoicesByJournal.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.InvoicesByJournal.ParamsPanel({});
  return new Lino.sales.InvoicesByJournal.GridPanel(p);
});
Lino.sales.InvoicesByJournal.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByJournal.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.ItemsByInvoice
Lino.sales.ItemsByInvoice.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/ItemsByInvoice",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoice','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Content",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 26,
  ls_store_fields : [ { "name": "product" }, 'productHidden', { "name": "title" }, { "name": "discount" }, { "name": "unit_price" }, { "name": "qty" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "description" }, { "name": "invoiceable_type" }, 'invoiceable_typeHidden', { "name": "invoiceable_id" }, 'invoiceable_idHidden', { "name": "invoiceable" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoice.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoice.insert;
    var ww = this.containing_window;
    var product446 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/product" }) }) });
    var title447 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var discount448 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var unit_price449 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var qty450 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var total_incl451 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var id452 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno453 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var total_base454 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat455 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_class456 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var description457 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var invoiceable_type458 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/invoiceable_type" }) }) });
    var invoiceable_id459 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/invoiceable_id" }) }) });
    var invoiceable_disp460 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp461 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp462 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp463 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp464 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher465 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Product invoice...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/ItemsByInvoice/voucher" }) }) });
    this.before_row_edit = function(record) {
      invoiceable_id459.setContextValue('invoiceable_type', record ? record.data['invoiceable_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      invoiceable_type458.on('change',Lino.chooser_handler(invoiceable_id459,'invoiceable_type'));
      Lino.sales.ItemsByInvoice.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "product", "editable": true, "editor": product446, "filter": { "type": "string" }, "header": "Tariff", "renderer": Lino.fk_renderer('productHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(sales.ItemsByInvoice.product) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title447, "filter": { "type": "string" }, "header": "Heading", "sortable": true, "tooltip": "(sales.ItemsByInvoice.title) The title of this voucher.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "discount", "editable": true, "editor": discount448, "filter": { "type": "numeric" }, "header": "Discount", "sortable": true, "tooltip": "(sales.ItemsByInvoice.discount) ", "width": Lino.chars2width(8) }, { "align": "right", "colIndex": 3, "dataIndex": "unit_price", "editable": true, "editor": unit_price449, "filter": { "type": "numeric" }, "header": "Unit price", "sortable": true, "tooltip": "(sales.ItemsByInvoice.unit_price) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "qty", "editable": true, "editor": qty450, "filter": { "type": "string" }, "format": "", "header": "Quantity", "sortable": true, "tooltip": "(sales.ItemsByInvoice.qty) ", "width": Lino.chars2width(8) }, { "align": "right", "colIndex": 5, "dataIndex": "total_incl", "editable": true, "editor": total_incl451, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.ItemsByInvoice.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id452, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno453, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 8, "dataIndex": "total_base", "editable": true, "editor": total_base454, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 9, "dataIndex": "total_vat", "editable": true, "editor": total_vat455, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(sales.ItemsByInvoice.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 10, "dataIndex": "vat_class", "editable": true, "editor": vat_class456, "filter": { "type": "string" }, "header": "VAT Class", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.vat_class) The VAT class to be applied for this item. A pointer to\nVatClasses.", "width": Lino.chars2width(11) }, { "colIndex": 11, "dataIndex": "description", "editable": true, "editor": description457, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.description) A multi-line rich text to be printed in the resulting printable\ndocument.", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "invoiceable_type", "editable": true, "editor": invoiceable_type458, "filter": { "type": "string" }, "header": "Invoiced object (type)", "hidden": true, "renderer": Lino.fk_renderer('invoiceable_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(sales.ItemsByInvoice.invoiceable_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "invoiceable_id", "editable": true, "editor": invoiceable_id459, "filter": { "type": "string" }, "header": "Invoiced object (object)", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.invoiceable_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "invoiceable", "editable": false, "header": "Invoiced object", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.invoiceable) ", "width": Lino.chars2width(11) }, { "colIndex": 15, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(sales.ItemsByInvoice.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 19, "dataIndex": "voucher", "editable": true, "editor": voucher465, "filter": { "type": "string" }, "header": "Product invoice", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(sales.ItemsByInvoice.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) } ];
    Lino.sales.ItemsByInvoice.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoice.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoice.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/ItemsByInvoice",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoice.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoice.insert;
    Lino.sales.ItemsByInvoice.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoice.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.ItemsByInvoice.insertPanel(p);
});
Lino.sales.ItemsByInvoice.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoice.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/ItemsByInvoice",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoice.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoice.insert;
    Lino.sales.ItemsByInvoice.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoice.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoice.detailPanel(p);
});
Lino.sales.ItemsByInvoice.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoice.GridPanel(p);
});
Lino.sales.ItemsByInvoice.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoice.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoice", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.ItemsByInvoicePrint
Lino.sales.ItemsByInvoicePrint.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/ItemsByInvoicePrint",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrint','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Content",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "description_print" }, { "name": "unit_price" }, { "name": "qty" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrint.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrint.insert;
    var ww = this.containing_window;
    var description_print_disp6831 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var unit_price6832 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var qty6833 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var total_incl6834 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description_print", "editable": false, "header": "Description", "sortable": false, "tooltip": "(sales.ItemsByInvoicePrint.description_print) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "unit_price", "editable": true, "editor": unit_price6832, "filter": { "type": "numeric" }, "header": "Unit price", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrint.unit_price) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 2, "dataIndex": "qty", "editable": true, "editor": qty6833, "filter": { "type": "string" }, "format": "", "header": "Quantity", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrint.qty) ", "width": Lino.chars2width(8) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl6834, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrint.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) } ];
    Lino.sales.ItemsByInvoicePrint.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrint.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrint.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/ItemsByInvoicePrint",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrint.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrint.insert;
    Lino.sales.ItemsByInvoicePrint.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrint.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrint.insertPanel(p);
});
Lino.sales.ItemsByInvoicePrint.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrint.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/ItemsByInvoicePrint",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrint.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrint.insert;
    Lino.sales.ItemsByInvoicePrint.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrint.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrint.detailPanel(p);
});
Lino.sales.ItemsByInvoicePrint.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrint.GridPanel(p);
});
Lino.sales.ItemsByInvoicePrint.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrint.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrint", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.ItemsByInvoicePrintNoQtyColumn
Lino.sales.ItemsByInvoicePrintNoQtyColumn.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/ItemsByInvoicePrintNoQtyColumn",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/ItemsByInvoicePrintNoQtyColumn','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Content",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "description_print" }, { "name": "total_incl" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert;
    var ww = this.containing_window;
    var description_print_disp6836 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var total_incl6837 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "description_print", "editable": false, "header": "Description", "sortable": false, "tooltip": "(sales.ItemsByInvoicePrintNoQtyColumn.description_print) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 1, "dataIndex": "total_incl", "editable": true, "editor": total_incl6837, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.ItemsByInvoicePrintNoQtyColumn.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) } ];
    Lino.sales.ItemsByInvoicePrintNoQtyColumn.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrintNoQtyColumn.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrintNoQtyColumn.insertPanel = Ext.extend(Lino.sales.InvoiceItems.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/ItemsByInvoicePrintNoQtyColumn",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert;
    Lino.sales.ItemsByInvoicePrintNoQtyColumn.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrintNoQtyColumn.insertPanel(p);
});
Lino.sales.ItemsByInvoicePrintNoQtyColumn.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.ItemsByInvoicePrintNoQtyColumn.detailPanel = Ext.extend(Lino.sales.InvoiceItems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  ls_url: "/sales/ItemsByInvoicePrintNoQtyColumn",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail;
    this.ls_insert_handler = Lino.sales.ItemsByInvoicePrintNoQtyColumn.insert;
    Lino.sales.ItemsByInvoicePrintNoQtyColumn.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.ItemsByInvoicePrintNoQtyColumn.detail = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrintNoQtyColumn.detailPanel(p);
});
Lino.sales.ItemsByInvoicePrintNoQtyColumn.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.ItemsByInvoicePrintNoQtyColumn.GridPanel(p);
});
Lino.sales.ItemsByInvoicePrintNoQtyColumn.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.ItemsByInvoicePrintNoQtyColumn.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/ItemsByInvoicePrintNoQtyColumn", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sales.InvoicesByPartner
Lino.sales.InvoicesByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sales/InvoicesByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sales/InvoicesByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Product invoices",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 42,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "journal__ref" }, { "name": "number", "type": "int", "useNull": true }, { "name": "total_incl" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "journal" }, 'journalHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "match" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "your_ref" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "printed_by" }, 'printed_byHidden', { "name": "language" }, 'languageHidden', { "name": "subject" }, { "name": "intro" }, { "name": "paper_type" }, 'paper_typeHidden', { "name": "balance_before" }, { "name": "balance_to_pay" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "number_with_year" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByPartner.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByPartner.insert;
    var ww = this.containing_window;
    var voucher_date1672 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var journal__ref1673 = new Ext.form.TextField({ "disabled": true, "maxLength": 40, "sortable": false });
    var number1674 = new Ext.form.NumberField({ "selectOnFocus": true });
    var total_incl1675 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp1676 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id1677 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user1678 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/user" }) }) });
    var journal1679 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/journal" }) }) });
    var entry_date1680 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var accounting_period1681 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/accounting_period" }) }) });
    var narration1682 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state1683 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var payment_term1684 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/payment_term" }) }) });
    var match1685 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/match" }) }) });
    var total_base1686 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat1687 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_regime1688 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.vat.VatRegimes });
    var your_ref1689 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var due_date1690 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var printed_by1691 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var language1692 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var subject1693 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var intro1694 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var paper_type1695 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/paper_type" }) }) });
    var balance_before1696 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var balance_to_pay1697 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var overview_disp1698 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1699 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp1700 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var number_with_year_disp1701 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner1702 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sales/InvoicesByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
      accounting_period1681.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
      match1685.setContextValue('journal', record ? record.data['journalHidden'] : undefined);
      var bp = this.get_base_params();
      match1685.setContextValue('mk',bp['mk']);
      match1685.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      entry_date1680.on('change',Lino.chooser_handler(accounting_period1681,'entry_date'));
      journal1679.on('change',Lino.chooser_handler(match1685,'journal'));
      partner1702.on('change',Lino.chooser_handler(match1685,'partner'));
      Lino.sales.InvoicesByPartner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date1672, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(sales.InvoicesByPartner.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "journal__ref", "editable": false, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(sales.InvoicesByPartner.journal__ref) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "number", "editable": true, "editor": number1674, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(sales.InvoicesByPartner.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 3, "dataIndex": "total_incl", "editable": true, "editor": total_incl1675, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "sortable": true, "tooltip": "(sales.InvoicesByPartner.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(sales.InvoicesByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id1677, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "user", "editable": true, "editor": user1678, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "journal", "editable": true, "editor": journal1679, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "entry_date", "editable": true, "editor": entry_date1680, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period1681, "filter": { "type": "string" }, "header": "Accounting period", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "narration", "editable": true, "editor": narration1682, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state1683, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "payment_term", "editable": true, "editor": payment_term1684, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.payment_term) See lino_xl.lib.ledger.mixins.PartnerRelated.payment_term", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "match", "editable": true, "editor": match1685, "filter": { "type": "string" }, "header": "Match", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 14, "dataIndex": "total_base", "editable": true, "editor": total_base1686, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 15, "dataIndex": "total_vat", "editable": true, "editor": total_vat1687, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 16, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime1688, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.vat_regime) The VAT regime to be used in this document.  A pointer to\nVatRegimes.", "width": Lino.chars2width(28) }, { "colIndex": 17, "dataIndex": "your_ref", "editable": true, "editor": your_ref1689, "filter": { "type": "string" }, "header": "Your reference", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.your_ref) ", "width": Lino.chars2width(22) }, { "colIndex": 18, "dataIndex": "due_date", "editable": true, "editor": due_date1690, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Due date", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 19, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 20, "dataIndex": "language", "editable": true, "editor": language1692, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.language) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "subject", "editable": true, "editor": subject1693, "filter": { "type": "string" }, "header": "Subject line", "hidden": true, "sortable": true, "tooltip": "(sales.InvoicesByPartner.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "intro", "editable": true, "editor": intro1694, "filter": { "type": "string" }, "header": "Introductive Text", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.intro) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "paper_type", "editable": true, "editor": paper_type1695, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.paper_type) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 24, "dataIndex": "balance_before", "editable": false, "header": "Balance before", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.balance_before) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 25, "dataIndex": "balance_to_pay", "editable": false, "header": "Balance to pay", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.balance_to_pay) ", "width": Lino.chars2width(13) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 29, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(sales.InvoicesByPartner.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 30, "dataIndex": "partner", "editable": true, "editor": partner1702, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sales.InvoicesByPartner.partner) Mandatory field to be defined in another class.", "width": Lino.chars2width(21) } ];
    Lino.sales.InvoicesByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByPartner.insertPanel = Ext.extend(Lino.sales.Invoices.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/sales/InvoicesByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByPartner.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByPartner.insert;
    Lino.sales.InvoicesByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByPartner.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.sales.InvoicesByPartner.insertPanel(p);
});
Lino.sales.InvoicesByPartner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.sales.InvoicesByPartner.detailPanel = Ext.extend(Lino.sales.Invoices.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Product invoice", "overflowText": "Product invoice", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/sales/InvoicesByPartner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.sales.InvoicesByPartner.detail;
    this.ls_insert_handler = Lino.sales.InvoicesByPartner.insert;
    Lino.sales.InvoicesByPartner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.sales.InvoicesByPartner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sales.InvoicesByPartner.detailPanel(p);
});
Lino.sales.InvoicesByPartner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.sales.Invoices.ParamsPanel({});
  return new Lino.sales.InvoicesByPartner.GridPanel(p);
});
Lino.sales.InvoicesByPartner.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sales.InvoicesByPartner.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sales/InvoicesByPartner", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class invoicing.ItemsByPlan
Lino.invoicing.ItemsByPlan.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:22px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/invoicing/ItemsByPlan",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/ItemsByPlan','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  page_length : 20,
  cell_edit : true,
  title : "Invoicing suggestions",
  row_height : 2,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "name": "selected", "type": "boolean" }, { "name": "partner" }, 'partnerHidden', { "name": "preview" }, { "name": "amount" }, { "name": "invoice" }, 'invoiceHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "first_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "last_date", "type": "date" }, { "name": "number_of_invoiceables", "type": "int", "useNull": true }, { "name": "overview" }, { "name": "description_column" }, { "name": "plan" }, 'planHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 47,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var selected3160 = new Ext.form.Checkbox({ "checked": true, "selectOnFocus": true });
    var partner3161 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/ItemsByPlan/partner" }) }) });
    var preview3162 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var amount3163 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var invoice3164 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Product invoice...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/ItemsByPlan/invoice" }) }) });
    var workflow_buttons_disp3165 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id3166 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var first_date3167 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var last_date3168 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number_of_invoiceables3169 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var overview_disp3170 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3171 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var plan3172 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Invoicing plan...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/ItemsByPlan/plan" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "selected", "editable": true, "filter": { "type": "boolean" }, "header": "Selected", "sortable": false, "tooltip": "(invoicing.ItemsByPlan.selected) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner3161, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(invoicing.ItemsByPlan.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "preview", "editable": true, "editor": preview3162, "filter": { "type": "string" }, "header": "Preview", "sortable": false, "tooltip": "(invoicing.ItemsByPlan.preview) A textual preview of the invoiceable items to be included in\nthe invoice.", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "amount", "editable": true, "editor": amount3163, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(invoicing.ItemsByPlan.amount) ", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "invoice", "editable": true, "editor": invoice3164, "filter": { "type": "string" }, "header": "Invoice", "renderer": Lino.fk_renderer('invoiceHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(invoicing.ItemsByPlan.invoice) The invoice that has been generated. This field is empty for\nnew items. When an item has been executed, this field points\nto the generated invoice.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(invoicing.ItemsByPlan.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id3166, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "first_date", "editable": true, "editor": first_date3167, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "First date", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.first_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "last_date", "editable": true, "editor": last_date3168, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Last date", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.last_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "number_of_invoiceables", "editable": true, "editor": number_of_invoiceables3169, "filter": { "type": "numeric" }, "format": "0", "header": "Number", "hidden": true, "sortable": true, "tooltip": "(invoicing.ItemsByPlan.number_of_invoiceables) ", "width": Lino.chars2width(6) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.ItemsByPlan.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.ItemsByPlan.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "plan", "editable": true, "editor": plan3172, "filter": { "type": "string" }, "header": "Invoicing plan", "hidden": true, "renderer": Lino.fk_renderer('planHidden','Lino.invoicing.Plans.detail'), "sortable": false, "tooltip": "(invoicing.ItemsByPlan.plan) ", "width": Lino.chars2width(21) } ];
    Lino.invoicing.ItemsByPlan.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.ItemsByPlan.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.ItemsByPlan.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.ItemsByPlan.GridPanel(p);
});
Lino.invoicing.ItemsByPlan.exec_item = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/ItemsByPlan", "GET", pk, "exec_item", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.PaymentOrdersByJournal
Lino.finan.PaymentOrdersByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/PaymentOrdersByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/PaymentOrdersByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Payment Orders",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 26,
  ls_store_fields : [ { "name": "number", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "narration" }, { "name": "total" }, { "dateFormat": "d.m.Y", "name": "execution_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "name": "number_with_year" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrdersByJournal.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrdersByJournal.insert;
    var ww = this.containing_window;
    var number619 = new Ext.form.NumberField({ "selectOnFocus": true });
    var voucher_date620 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var narration621 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var total622 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var execution_date623 = new Lino.DateField({ "selectOnFocus": true });
    var accounting_period624 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/accounting_period" }) }) });
    var workflow_buttons_disp625 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id626 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user627 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/user" }) }) });
    var entry_date628 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var state629 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by630 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account631 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/item_account" }) }) });
    var item_remark632 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var number_with_year_disp633 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp634 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp635 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp636 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal637 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/PaymentOrdersByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      accounting_period624.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date628.on('change',Lino.chooser_handler(accounting_period624,'entry_date'));
      Lino.finan.PaymentOrdersByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "number", "editable": true, "editor": number619, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date620, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "narration", "editable": true, "editor": narration621, "filter": { "type": "string" }, "header": "Narration", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "total", "editable": true, "editor": total622, "filter": { "type": "numeric" }, "header": "Total", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.total) ", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "execution_date", "editable": true, "editor": execution_date623, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Execution date", "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.execution_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 5, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period624, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id626, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user627, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "entry_date", "editable": true, "editor": entry_date628, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state629, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "item_account", "editable": true, "editor": item_account631, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_remark", "editable": true, "editor": item_remark632, "filter": { "type": "string" }, "header": "External reference", "hidden": true, "sortable": true, "tooltip": "(finan.PaymentOrdersByJournal.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "number_with_year", "editable": false, "header": "No.", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 15, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "journal", "editable": true, "editor": journal637, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(finan.PaymentOrdersByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.finan.PaymentOrdersByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrdersByJournal.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrdersByJournal.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/PaymentOrdersByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrdersByJournal.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrdersByJournal.insert;
    Lino.finan.PaymentOrdersByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrdersByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.PaymentOrdersByJournal.insertPanel(p);
});
Lino.finan.PaymentOrdersByJournal.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.PaymentOrdersByJournal.detailPanel = Ext.extend(Lino.finan.PaymentOrders.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Payment Order", "overflowText": "Payment Order", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/PaymentOrdersByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.PaymentOrdersByJournal.detail;
    this.ls_insert_handler = Lino.finan.PaymentOrdersByJournal.insert;
    Lino.finan.PaymentOrdersByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.PaymentOrdersByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.PaymentOrdersByJournal.detailPanel(p);
});
Lino.finan.PaymentOrdersByJournal.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.PaymentOrdersByJournal.GridPanel(p);
});
Lino.finan.PaymentOrdersByJournal.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.PaymentOrdersByJournal.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/PaymentOrdersByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.JournalEntriesByJournal
Lino.finan.JournalEntriesByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/JournalEntriesByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/JournalEntriesByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Journal Entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 25,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntriesByJournal.detail;
    this.ls_insert_handler = Lino.finan.JournalEntriesByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp754 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var voucher_date755 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var accounting_period756 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/accounting_period" }) }) });
    var workflow_buttons_disp757 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id758 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user759 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/user" }) }) });
    var entry_date760 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number761 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration762 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state763 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by764 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account765 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/item_account" }) }) });
    var item_remark766 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date767 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var overview_disp768 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp769 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp770 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal771 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/JournalEntriesByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      accounting_period756.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date760.on('change',Lino.chooser_handler(accounting_period756,'entry_date'));
      Lino.finan.JournalEntriesByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "No.", "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date755, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period756, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id758, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user759, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "entry_date", "editable": true, "editor": entry_date760, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 7, "dataIndex": "number", "editable": true, "editor": number761, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "narration", "editable": true, "editor": narration762, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "state", "editable": true, "editor": state763, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 10, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "item_account", "editable": true, "editor": item_account765, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "item_remark", "editable": true, "editor": item_remark766, "filter": { "type": "string" }, "header": "External reference", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date767, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.JournalEntriesByJournal.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 14, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "journal", "editable": true, "editor": journal771, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(finan.JournalEntriesByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.finan.JournalEntriesByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntriesByJournal.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntriesByJournal.insertPanel = Ext.extend(Lino.finan.FinancialVouchers.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/JournalEntriesByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntriesByJournal.detail;
    this.ls_insert_handler = Lino.finan.JournalEntriesByJournal.insert;
    Lino.finan.JournalEntriesByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntriesByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(40) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.JournalEntriesByJournal.insertPanel(p);
});
Lino.finan.JournalEntriesByJournal.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.JournalEntriesByJournal.detailPanel = Ext.extend(Lino.finan.FinancialVouchers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Journal Entry", "overflowText": "Journal Entry", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/JournalEntriesByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.JournalEntriesByJournal.detail;
    this.ls_insert_handler = Lino.finan.JournalEntriesByJournal.insert;
    Lino.finan.JournalEntriesByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.JournalEntriesByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.JournalEntriesByJournal.detailPanel(p);
});
Lino.finan.JournalEntriesByJournal.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.JournalEntriesByJournal.GridPanel(p);
});
Lino.finan.JournalEntriesByJournal.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.JournalEntriesByJournal.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/JournalEntriesByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.BankStatementsByJournal
Lino.finan.BankStatementsByJournal.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/BankStatementsByJournal",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/BankStatementsByJournal','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Bank Statements",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 27,
  ls_store_fields : [ { "name": "number_with_year" }, { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "balance1" }, { "name": "balance2" }, { "name": "accounting_period" }, 'accounting_periodHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "dateFormat": "d.m.Y", "name": "entry_date", "type": "date" }, { "name": "number", "type": "int", "useNull": true }, { "name": "narration" }, { "name": "state" }, 'stateHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "item_account" }, 'item_accountHidden', { "name": "item_remark" }, { "dateFormat": "d.m.Y", "name": "last_item_date", "type": "date" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "journal" }, 'journalHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 38,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatementsByJournal.detail;
    this.ls_insert_handler = Lino.finan.BankStatementsByJournal.insert;
    var ww = this.containing_window;
    var number_with_year_disp686 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var voucher_date687 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var balance1688 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var balance2689 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var accounting_period690 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Accounting period...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/accounting_period" }) }) });
    var workflow_buttons_disp691 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id692 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user693 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/user" }) }) });
    var entry_date694 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var number695 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var narration696 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var state697 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.ledger.VoucherStates });
    var printed_by698 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var item_account699 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/item_account" }) }) });
    var item_remark700 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_item_date701 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var overview_disp702 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp703 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp704 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var journal705 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/BankStatementsByJournal/journal" }) }) });
    this.before_row_edit = function(record) {
      accounting_period690.setContextValue('entry_date', record ? record.data['entry_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      entry_date694.on('change',Lino.chooser_handler(accounting_period690,'entry_date'));
      Lino.finan.BankStatementsByJournal.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "number_with_year", "editable": false, "header": "No.", "sortable": false, "tooltip": "(finan.BankStatementsByJournal.number_with_year) ", "width": Lino.chars2width(9) }, { "colIndex": 1, "dataIndex": "voucher_date", "editable": true, "editor": voucher_date687, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(finan.BankStatementsByJournal.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 2, "dataIndex": "balance1", "editable": true, "editor": balance1688, "filter": { "type": "numeric" }, "header": "Old balance", "sortable": true, "tooltip": "(finan.BankStatementsByJournal.balance1) The old (or start) balance.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "balance2", "editable": true, "editor": balance2689, "filter": { "type": "numeric" }, "header": "New balance", "sortable": true, "tooltip": "(finan.BankStatementsByJournal.balance2) The new (or end) balance.", "width": Lino.chars2width(13) }, { "colIndex": 4, "dataIndex": "accounting_period", "editable": true, "editor": accounting_period690, "filter": { "type": "string" }, "header": "Accounting period", "sortable": false, "tooltip": "(finan.BankStatementsByJournal.accounting_period) The accounting period and fiscal year to which this entry is\nto be assigned to. The default value is determined from\nentry_date.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.BankStatementsByJournal.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id692, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user693, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(finan.BankStatementsByJournal.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "entry_date", "editable": true, "editor": entry_date694, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Entry date", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.entry_date) The date of the journal entry, i.e. when this voucher has been\njournalized or booked.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 9, "dataIndex": "number", "editable": true, "editor": number695, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.number) The sequence number of this voucher in the journal.", "width": Lino.chars2width(6) }, { "colIndex": 10, "dataIndex": "narration", "editable": true, "editor": narration696, "filter": { "type": "string" }, "header": "Narration", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.narration) A short explanation which ascertains the subject matter of\nthis journal entry.", "width": Lino.chars2width(22) }, { "colIndex": 11, "dataIndex": "state", "editable": true, "editor": state697, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(finan.BankStatementsByJournal.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "item_account", "editable": true, "editor": item_account699, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.item_account) The default value to use when\nFinancialVoucherItem.account of an item is empty.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "item_remark", "editable": true, "editor": item_remark700, "filter": { "type": "string" }, "header": "External reference", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.item_remark) The default value to use when\nFinancialVoucherItem.remark of an item is empty.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "last_item_date", "editable": true, "editor": last_item_date701, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "last item date", "hidden": true, "sortable": true, "tooltip": "(finan.BankStatementsByJournal.last_item_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 16, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "journal", "editable": true, "editor": journal705, "filter": { "type": "string" }, "header": "Journal", "hidden": true, "sortable": false, "tooltip": "(finan.BankStatementsByJournal.journal) The journal into which this voucher has been booked. This is a\nmandatory pointer to a Journal instance.", "width": Lino.chars2width(21) } ];
    Lino.finan.BankStatementsByJournal.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementsByJournal.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatementsByJournal.insertPanel = Ext.extend(Lino.finan.BankStatements.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/finan/BankStatementsByJournal",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatementsByJournal.detail;
    this.ls_insert_handler = Lino.finan.BankStatementsByJournal.insert;
    Lino.finan.BankStatementsByJournal.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementsByJournal.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.finan.BankStatementsByJournal.insertPanel(p);
});
Lino.finan.BankStatementsByJournal.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.finan.BankStatementsByJournal.detailPanel = Ext.extend(Lino.finan.BankStatements.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Bank Statement", "overflowText": "Bank Statement", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/finan/BankStatementsByJournal",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.finan.BankStatementsByJournal.detail;
    this.ls_insert_handler = Lino.finan.BankStatementsByJournal.insert;
    Lino.finan.BankStatementsByJournal.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.BankStatementsByJournal.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.BankStatementsByJournal.detailPanel(p);
});
Lino.finan.BankStatementsByJournal.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.finan.FinancialVouchers.ParamsPanel({});
  return new Lino.finan.BankStatementsByJournal.GridPanel(p);
});
Lino.finan.BankStatementsByJournal.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.BankStatementsByJournal.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/BankStatementsByJournal", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.ItemsByJournalEntry
Lino.finan.ItemsByJournalEntry.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/ItemsByJournalEntry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByJournalEntry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Journal Entry items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "account" }, 'accountHidden', { "name": "match" }, { "name": "remark" }, { "name": "debit" }, { "name": "credit" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 60,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var date782 = new Lino.DateField({ "selectOnFocus": true });
    var partner783 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/partner" }) }) });
    var account784 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/account" }) }) });
    var match785 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/match" }) }) });
    var remark786 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var debit787 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var credit788 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var seqno789 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id790 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var amount791 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc792 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp793 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp794 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp795 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp796 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher797 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Journal Entry...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByJournalEntry/voucher" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      match785.setContextValue('mk',bp['mk']);
      match785.setContextValue('mt',bp['mt']);
      match785.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher797.on('change',Lino.chooser_handler(match785,'voucher'));
      partner783.on('change',Lino.chooser_handler(match785,'partner'));
      Lino.finan.ItemsByJournalEntry.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date782, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.date) The value date of this item.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner783, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.partner) The partner account to be used in the primary booking.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "account", "editable": true, "editor": account784, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.account) The general account to be used in the primary booking.\nIf this is empty, use item_account of the voucher.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "match", "editable": true, "editor": match785, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark786, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.remark) External reference. The description of this transation\nas seen by the external partner.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "debit", "editable": true, "editor": debit787, "header": "Debit", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "credit", "editable": true, "editor": credit788, "header": "Credit", "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.credit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno789, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id790, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 9, "dataIndex": "amount", "editable": true, "editor": amount791, "filter": { "type": "numeric" }, "header": "Amount", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByJournalEntry.amount) The amount to be booked. If this is empty, then the voucher\ncannot be registered.", "width": Lino.chars2width(13) }, { "colIndex": 10, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 15, "dataIndex": "voucher", "editable": true, "editor": voucher797, "filter": { "type": "string" }, "header": "Journal Entry", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.FinancialVouchers.detail'), "sortable": false, "tooltip": "(finan.ItemsByJournalEntry.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) } ];
    Lino.finan.ItemsByJournalEntry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.ItemsByJournalEntry.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.ItemsByJournalEntry.GridPanel(p);
});
Lino.finan.ItemsByJournalEntry.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByJournalEntry.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByJournalEntry", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.ItemsByBankStatement
Lino.finan.ItemsByBankStatement.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/ItemsByBankStatement",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByBankStatement','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Bank Statement items",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "account" }, 'accountHidden', { "name": "match" }, { "name": "remark" }, { "name": "debit" }, { "name": "credit" }, { "name": "workflow_buttons" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "amount" }, { "name": "dc", "type": "boolean" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 62,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var date718 = new Lino.DateField({ "selectOnFocus": true });
    var partner719 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/partner" }) }) });
    var account720 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/account" }) }) });
    var match721 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/match" }) }) });
    var remark722 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var debit723 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var credit724 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp725 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var seqno726 = new Ext.form.NumberField({ "selectOnFocus": true });
    var id727 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var amount728 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true, "value": 0 });
    var dc729 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var overview_disp730 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp731 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp732 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher733 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Bank Statement...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByBankStatement/voucher" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      match721.setContextValue('mk',bp['mk']);
      match721.setContextValue('mt',bp['mt']);
      match721.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      voucher733.on('change',Lino.chooser_handler(match721,'voucher'));
      partner719.on('change',Lino.chooser_handler(match721,'partner'));
      Lino.finan.ItemsByBankStatement.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date718, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "date", "sortable": true, "tooltip": "(finan.ItemsByBankStatement.date) The value date of this item.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner719, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.ItemsByBankStatement.partner) The partner account to be used in the primary booking.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "account", "editable": true, "editor": account720, "filter": { "type": "string" }, "header": "Account", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.account) The general account to be used in the primary booking.\nIf this is empty, use item_account of the voucher.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "match", "editable": true, "editor": match721, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "remark", "editable": true, "editor": remark722, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.ItemsByBankStatement.remark) External reference. The description of this transation\nas seen by the external partner.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 5, "dataIndex": "debit", "editable": true, "editor": debit723, "header": "Income", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.debit) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "credit", "editable": true, "editor": credit724, "header": "Expense", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.credit) ", "width": Lino.chars2width(13) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.ItemsByBankStatement.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "seqno", "editable": true, "editor": seqno726, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.ItemsByBankStatement.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id727, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByBankStatement.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 10, "dataIndex": "amount", "editable": true, "editor": amount728, "filter": { "type": "numeric" }, "header": "Amount", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByBankStatement.amount) The amount to be booked. If this is empty, then the voucher\ncannot be registered.", "width": Lino.chars2width(13) }, { "colIndex": 11, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByBankStatement.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 15, "dataIndex": "voucher", "editable": true, "editor": voucher733, "filter": { "type": "string" }, "header": "Bank Statement", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.BankStatements.detail'), "sortable": false, "tooltip": "(finan.ItemsByBankStatement.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) } ];
    Lino.finan.ItemsByBankStatement.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.ItemsByBankStatement.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.ItemsByBankStatement.GridPanel(p);
});
Lino.finan.ItemsByBankStatement.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByBankStatement.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByBankStatement", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.ItemsByPaymentOrder
Lino.finan.ItemsByPaymentOrder.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/finan/ItemsByPaymentOrder",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/ItemsByPaymentOrder','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Content",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 19,
  ls_store_fields : [ { "name": "seqno", "type": "int", "useNull": true }, { "name": "partner" }, 'partnerHidden', { "name": "workflow_buttons" }, { "name": "bank_account" }, 'bank_accountHidden', { "name": "match" }, { "name": "amount" }, { "name": "remark" }, { "name": "id", "type": "int" }, { "name": "dc", "type": "boolean" }, { "name": "account" }, 'accountHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "voucher" }, 'voucherHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 59,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var seqno652 = new Ext.form.NumberField({ "selectOnFocus": true });
    var partner653 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/partner" }) }) });
    var workflow_buttons_disp654 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var bank_account655 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Bank account...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/bank_account" }) }) });
    var match656 = new Lino.SimpleRemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/match" }) }) });
    var amount657 = new Ext.form.NumberField({ "allowBlank": false, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true, "value": 0 });
    var remark658 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id659 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var dc660 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var account661 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/account" }) }) });
    var overview_disp662 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp663 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp664 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var voucher665 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Payment Order...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/finan/ItemsByPaymentOrder/voucher" }) }) });
    this.before_row_edit = function(record) {
      bank_account655.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
      bank_account655.setContextValue('project', record ? record.data['project'] : undefined);
      var bp = this.get_base_params();
      match656.setContextValue('mk',bp['mk']);
      match656.setContextValue('mt',bp['mt']);
      match656.setContextValue('partner', record ? record.data['partnerHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      partner653.on('change',Lino.chooser_handler(bank_account655,'partner'));
      voucher665.on('change',Lino.chooser_handler(match656,'voucher'));
      partner653.on('change',Lino.chooser_handler(match656,'partner'));
      Lino.finan.ItemsByPaymentOrder.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "seqno", "editable": true, "editor": seqno652, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "partner", "editable": true, "editor": partner653, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.partner) The partner account to be used in the primary booking.", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "bank_account", "editable": true, "editor": bank_account655, "filter": { "type": "string" }, "header": "Bank account", "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "match", "editable": true, "editor": match656, "filter": { "type": "string" }, "header": "Match", "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.match) The movement to be matched.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "amount", "editable": true, "editor": amount657, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.amount) The amount to be booked. If this is empty, then the voucher\ncannot be registered.", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "remark", "editable": true, "editor": remark658, "filter": { "type": "string" }, "header": "External reference", "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.remark) External reference. The description of this transation\nas seen by the external partner.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id659, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(finan.ItemsByPaymentOrder.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "dc", "editable": true, "filter": { "type": "boolean" }, "header": "dc", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 9, "dataIndex": "account", "editable": true, "editor": account661, "filter": { "type": "string" }, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.account) The general account to be used in the primary booking.\nIf this is empty, use item_account of the voucher.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 13, "dataIndex": "voucher", "editable": true, "editor": voucher665, "filter": { "type": "string" }, "header": "Payment Order", "hidden": true, "renderer": Lino.fk_renderer('voucherHidden','Lino.finan.PaymentOrders.detail'), "sortable": false, "tooltip": "(finan.ItemsByPaymentOrder.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) } ];
    Lino.finan.ItemsByPaymentOrder.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.ItemsByPaymentOrder.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.suggest = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "suggest", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.finan.ItemsByPaymentOrder.GridPanel(p);
});
Lino.finan.ItemsByPaymentOrder.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.ItemsByPaymentOrder.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/ItemsByPaymentOrder", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class sepa.AccountsByPartner
Lino.sepa.AccountsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/sepa/AccountsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/sepa/AccountsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Bank accounts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "iban" }, { "name": "bic" }, { "name": "remark" }, { "name": "primary", "type": "boolean" }, { "name": "id", "type": "int" }, { "name": "statements" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "partner" }, 'partnerHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 65,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var iban1505 = new Lino.UppercaseTextField({ "allowBlank": false, "maxLength": 34, "selectOnFocus": true });
    var bic1506 = new Lino.UppercaseTextField({ "maxLength": 11, "selectOnFocus": true });
    var remark1507 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var primary1508 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var id1509 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var statements_disp1510 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1511 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1512 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1513 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var partner1514 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/sepa/AccountsByPartner/partner" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "iban", "editable": true, "editor": iban1505, "filter": { "type": "string" }, "header": "IBAN", "renderer": Lino.iban_renderer, "sortable": true, "tooltip": "(sepa.AccountsByPartner.iban) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "bic", "editable": true, "editor": bic1506, "filter": { "type": "string" }, "header": "BIC", "sortable": true, "tooltip": "(sepa.AccountsByPartner.bic) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "remark", "editable": true, "editor": remark1507, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(sepa.AccountsByPartner.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "primary", "editable": true, "filter": { "type": "boolean" }, "header": "Primary", "sortable": false, "tooltip": "(sepa.AccountsByPartner.primary) Enabling this field will automatically disable any previous primary account and update the partner's IBAN and BIC", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1509, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(sepa.AccountsByPartner.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "statements", "editable": false, "header": "Statements", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.statements) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(sepa.AccountsByPartner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "partner", "editable": true, "editor": partner1514, "filter": { "type": "string" }, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(sepa.AccountsByPartner.partner) ", "width": Lino.chars2width(21) } ];
    Lino.sepa.AccountsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.sepa.AccountsByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/sepa/AccountsByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.sepa.AccountsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.sepa.AccountsByPartner.GridPanel(p);
});

// js_render_GridPanel_class notes.NotesByType
Lino.notes.NotesByType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "type" }, 'typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByType.detail;
    this.ls_insert_handler = Lino.notes.NotesByType.insert;
    var ww = this.containing_window;
    var date2191 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time2192 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type2193 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/event_type" }) }) });
    var subject2194 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user2195 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/user" }) }) });
    var id2196 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time2197 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method2198 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company2199 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/company" }) }) });
    var contact_person2200 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/contact_person" }) }) });
    var contact_role2201 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/contact_role" }) }) });
    var owner_type2202 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/owner_type" }) }) });
    var owner_id2203 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/owner_id" }) }) });
    var body2204 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language2205 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp2206 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp2207 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2208 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2209 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type2210 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByType/type" }) }) });
    this.before_row_edit = function(record) {
      contact_person2200.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id2203.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company2199.on('change',Lino.chooser_handler(contact_person2200,'company'));
      owner_type2202.on('change',Lino.chooser_handler(owner_id2203,'owner_type'));
      Lino.notes.NotesByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date2191, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.NotesByType.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time2192, "header": "Time", "sortable": true, "tooltip": "(notes.NotesByType.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type2193, "filter": { "type": "string" }, "header": "Event Type (Form)", "sortable": false, "tooltip": "(notes.NotesByType.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "subject", "editable": true, "editor": subject2194, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.NotesByType.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user2195, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByType.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2196, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByType.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "build_method", "editable": true, "editor": build_method2198, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 8, "dataIndex": "company", "editable": true, "editor": company2199, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByType.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_person", "editable": true, "editor": contact_person2200, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByType.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role2201, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type2202, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id2203, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body2204, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language2205, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "type", "editable": true, "editor": type2210, "filter": { "type": "string" }, "header": "Note Type (Content)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByType.type) ", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByType.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/NotesByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByType.detail;
    this.ls_insert_handler = Lino.notes.NotesByType.insert;
    Lino.notes.NotesByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByType.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.NotesByType.insertPanel(p);
});
Lino.notes.NotesByType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByType.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByType.detail;
    this.ls_insert_handler = Lino.notes.NotesByType.insert;
    Lino.notes.NotesByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByType.detailPanel(p);
});
Lino.notes.NotesByType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByType.GridPanel(p);
});
Lino.notes.NotesByType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByType.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByEventType
Lino.notes.NotesByEventType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByEventType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByEventType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "event_type" }, 'event_typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByEventType.detail;
    this.ls_insert_handler = Lino.notes.NotesByEventType.insert;
    var ww = this.containing_window;
    var date3894 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time3895 = new Lino.TimeField({ "selectOnFocus": true });
    var type3896 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/type" }) }) });
    var subject3897 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user3898 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/user" }) }) });
    var id3899 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time3900 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method3901 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company3902 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/company" }) }) });
    var contact_person3903 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/contact_person" }) }) });
    var contact_role3904 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/contact_role" }) }) });
    var owner_type3905 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/owner_type" }) }) });
    var owner_id3906 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/owner_id" }) }) });
    var body3907 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language3908 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp3909 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp3910 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3911 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3912 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var event_type3913 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByEventType/event_type" }) }) });
    this.before_row_edit = function(record) {
      contact_person3903.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id3906.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3902.on('change',Lino.chooser_handler(contact_person3903,'company'));
      owner_type3905.on('change',Lino.chooser_handler(owner_id3906,'owner_type'));
      Lino.notes.NotesByEventType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date3894, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.NotesByEventType.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time3895, "header": "Time", "sortable": true, "tooltip": "(notes.NotesByEventType.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type3896, "filter": { "type": "string" }, "header": "Note Type (Content)", "sortable": false, "tooltip": "(notes.NotesByEventType.type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "subject", "editable": true, "editor": subject3897, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.NotesByEventType.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user3898, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id3899, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByEventType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByEventType.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 7, "dataIndex": "build_method", "editable": true, "editor": build_method3901, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 8, "dataIndex": "company", "editable": true, "editor": company3902, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "contact_person", "editable": true, "editor": contact_person3903, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role3904, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type3905, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByEventType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id3906, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body3907, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language3908, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "event_type", "editable": true, "editor": event_type3913, "filter": { "type": "string" }, "header": "Event Type (Form)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByEventType.event_type) ", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByEventType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByEventType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByEventType.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/NotesByEventType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByEventType.detail;
    this.ls_insert_handler = Lino.notes.NotesByEventType.insert;
    Lino.notes.NotesByEventType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByEventType.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.NotesByEventType.insertPanel(p);
});
Lino.notes.NotesByEventType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByEventType.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByEventType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByEventType.detail;
    this.ls_insert_handler = Lino.notes.NotesByEventType.insert;
    Lino.notes.NotesByEventType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByEventType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByEventType.detailPanel(p);
});
Lino.notes.NotesByEventType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByEventType.GridPanel(p);
});
Lino.notes.NotesByEventType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByEventType.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByEventType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByCompany
Lino.notes.NotesByCompany.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByCompany",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByCompany','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "company" }, 'companyHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByCompany.detail;
    this.ls_insert_handler = Lino.notes.NotesByCompany.insert;
    var ww = this.containing_window;
    var date1636 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time1637 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type1638 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/event_type" }) }) });
    var type1639 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/type" }) }) });
    var subject1640 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user1641 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/user" }) }) });
    var id1642 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time1643 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method1644 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var contact_person1645 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/contact_person" }) }) });
    var contact_role1646 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/contact_role" }) }) });
    var owner_type1647 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/owner_type" }) }) });
    var owner_id1648 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/owner_id" }) }) });
    var body1649 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language1650 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp1651 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp1652 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1653 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1654 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var company1655 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByCompany/company" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      contact_person1645.setContextValue('mk',bp['mk']);
      contact_person1645.setContextValue('mt',bp['mt']);
      owner_id1648.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company1655.on('change',Lino.chooser_handler(contact_person1645,'company'));
      owner_type1647.on('change',Lino.chooser_handler(owner_id1648,'owner_type'));
      Lino.notes.NotesByCompany.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date1636, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.NotesByCompany.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time1637, "header": "Time", "sortable": true, "tooltip": "(notes.NotesByCompany.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type1638, "filter": { "type": "string" }, "header": "Event Type (Form)", "sortable": false, "tooltip": "(notes.NotesByCompany.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type1639, "filter": { "type": "string" }, "header": "Note Type (Content)", "sortable": false, "tooltip": "(notes.NotesByCompany.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject1640, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.NotesByCompany.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user1641, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id1642, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByCompany.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByCompany.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method1644, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "contact_person", "editable": true, "editor": contact_person1645, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role1646, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type1647, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id1648, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body1649, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language1650, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByCompany.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "company", "editable": true, "editor": company1655, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByCompany.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByCompany.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByCompany.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByCompany.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/NotesByCompany",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByCompany.detail;
    this.ls_insert_handler = Lino.notes.NotesByCompany.insert;
    Lino.notes.NotesByCompany.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByCompany.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.NotesByCompany.insertPanel(p);
});
Lino.notes.NotesByCompany.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByCompany.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByCompany",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByCompany.detail;
    this.ls_insert_handler = Lino.notes.NotesByCompany.insert;
    Lino.notes.NotesByCompany.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByCompany.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByCompany.detailPanel(p);
});
Lino.notes.NotesByCompany.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByCompany.GridPanel(p);
});
Lino.notes.NotesByCompany.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByCompany.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByCompany", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByPerson
Lino.notes.NotesByPerson.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByPerson",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByPerson','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "contact_person" }, 'contact_personHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByPerson.detail;
    this.ls_insert_handler = Lino.notes.NotesByPerson.insert;
    var ww = this.containing_window;
    var date1918 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time1919 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type1920 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/event_type" }) }) });
    var type1921 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/type" }) }) });
    var subject1922 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user1923 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/user" }) }) });
    var id1924 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time1925 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method1926 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company1927 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/company" }) }) });
    var contact_role1928 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/contact_role" }) }) });
    var owner_type1929 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/owner_type" }) }) });
    var owner_id1930 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/owner_id" }) }) });
    var body1931 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language1932 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var owner_disp1933 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp1934 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1935 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1936 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var contact_person1937 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByPerson/contact_person" }) }) });
    this.before_row_edit = function(record) {
      owner_id1930.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      contact_person1937.setContextValue('company', record ? record.data['companyHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type1929.on('change',Lino.chooser_handler(owner_id1930,'owner_type'));
      company1927.on('change',Lino.chooser_handler(contact_person1937,'company'));
      Lino.notes.NotesByPerson.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date1918, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.NotesByPerson.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time1919, "header": "Time", "sortable": true, "tooltip": "(notes.NotesByPerson.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type1920, "filter": { "type": "string" }, "header": "Event Type (Form)", "sortable": false, "tooltip": "(notes.NotesByPerson.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type1921, "filter": { "type": "string" }, "header": "Note Type (Content)", "sortable": false, "tooltip": "(notes.NotesByPerson.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject1922, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.NotesByPerson.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user1923, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id1924, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByPerson.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByPerson.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method1926, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company1927, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_role", "editable": true, "editor": contact_role1928, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "owner_type", "editable": true, "editor": owner_type1929, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_id", "editable": true, "editor": owner_id1930, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 13, "dataIndex": "body", "editable": true, "editor": body1931, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.body) ", "width": Lino.chars2width(61) }, { "colIndex": 14, "dataIndex": "language", "editable": true, "editor": language1932, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.language) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByPerson.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "contact_person", "editable": true, "editor": contact_person1937, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByPerson.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) } ];
    Lino.notes.NotesByPerson.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByPerson.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByPerson.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/NotesByPerson",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByPerson.detail;
    this.ls_insert_handler = Lino.notes.NotesByPerson.insert;
    Lino.notes.NotesByPerson.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByPerson.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.NotesByPerson.insertPanel(p);
});
Lino.notes.NotesByPerson.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByPerson.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByPerson",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByPerson.detail;
    this.ls_insert_handler = Lino.notes.NotesByPerson.insert;
    Lino.notes.NotesByPerson.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByPerson.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByPerson.detailPanel(p);
});
Lino.notes.NotesByPerson.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByPerson.GridPanel(p);
});
Lino.notes.NotesByPerson.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByPerson.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByPerson", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.UploadsByType
Lino.uploads.UploadsByType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/UploadsByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "file" }, { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "owner" }, { "name": "description_link" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "type" }, 'typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByType.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByType.insert;
    var ww = this.containing_window;
    var file2800 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var description2801 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user2802 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/user" }) }) });
    var id2803 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype2804 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type2805 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/owner_type" }) }) });
    var owner_id2806 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/owner_id" }) }) });
    var upload_area2807 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var owner_disp2808 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var description_link_disp2809 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp2810 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2811 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2812 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type2813 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Upload Type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByType/type" }) }) });
    this.before_row_edit = function(record) {
      owner_id2806.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      type2813.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type2805.on('change',Lino.chooser_handler(owner_id2806,'owner_type'));
      upload_area2807.on('change',Lino.chooser_handler(type2813,'upload_area'));
      Lino.uploads.UploadsByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file2800, "filter": { "type": "string" }, "header": "File", "sortable": true, "tooltip": "(uploads.UploadsByType.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "description", "editable": true, "editor": description2801, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(uploads.UploadsByType.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user2802, "filter": { "type": "string" }, "header": "Uploaded by", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.UploadsByType.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id2803, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME type", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByType.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type2805, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.UploadsByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id2806, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "upload_area", "editable": true, "editor": upload_area2807, "filter": { "type": "string" }, "header": "Upload Area", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "description_link", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "type", "editable": true, "editor": type2813, "filter": { "type": "string" }, "header": "Upload Type", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByType.type) ", "width": Lino.chars2width(21) } ];
    Lino.uploads.UploadsByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByType.insertPanel = Ext.extend(Lino.uploads.Uploads.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/uploads/UploadsByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByType.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByType.insert;
    Lino.uploads.UploadsByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.UploadsByType.insertPanel(p);
});
Lino.uploads.UploadsByType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByType.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/uploads/UploadsByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByType.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByType.insert;
    Lino.uploads.UploadsByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByType.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadsByType.detailPanel(p);
});
Lino.uploads.UploadsByType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.UploadsByType.GridPanel(p);
});
Lino.uploads.UploadsByType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.RecipientsByMail
Lino.outbox.RecipientsByMail.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/RecipientsByMail",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientsByMail','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Recipients",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "partner" }, 'partnerHidden', { "name": "address" }, { "name": "name" }, { "name": "type" }, 'typeHidden', { "name": "id", "type": "int" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mail" }, 'mailHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 73,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var partner2766 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/RecipientsByMail/partner" }) }) });
    var address2767 = new Ext.form.TextField({ "maxLength": 254, "selectOnFocus": true });
    var name2768 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var type2769 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.outbox.RecipientTypes });
    var id2770 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp2771 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2772 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2773 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mail2774 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Outgoing Mail...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/RecipientsByMail/mail" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "partner", "editable": true, "editor": partner2766, "filter": { "type": "string" }, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(outbox.RecipientsByMail.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "address", "editable": true, "editor": address2767, "filter": { "type": "string" }, "header": "Address", "sortable": true, "tooltip": "(outbox.RecipientsByMail.address) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "name", "editable": true, "editor": name2768, "filter": { "type": "string" }, "header": "Name", "sortable": true, "tooltip": "(outbox.RecipientsByMail.name) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type2769, "filter": { "type": "string" }, "header": "Recipient Type", "sortable": false, "tooltip": "(outbox.RecipientsByMail.type) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id2770, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.RecipientsByMail.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "mail", "editable": true, "editor": mail2774, "filter": { "type": "string" }, "header": "Outgoing Mail", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientsByMail.mail) ", "width": Lino.chars2width(21) } ];
    Lino.outbox.RecipientsByMail.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.RecipientsByMail.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientsByMail", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientsByMail.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.RecipientsByMail.GridPanel(p);
});

// js_render_GridPanel_class outbox.MyOutbox
Lino.outbox.MyOutbox.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/MyOutbox",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/MyOutbox','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "My Outbox",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "name": "sent" }, { "name": "recipients" }, { "name": "subject" }, { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "body" }, { "name": "user" }, 'userHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MyOutbox.detail;
    this.ls_insert_handler = Lino.outbox.MyOutbox.insert;
    var ww = this.containing_window;
    var sent6850 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var recipients_htmlbox6851 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Recipients", "value": "<br/>" });
    var subject6852 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id6853 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type6854 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MyOutbox/owner_type" }) }) });
    var owner_id6855 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MyOutbox/owner_id" }) }) });
    var date6856 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var owner_disp6857 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    var workflow_buttons_disp6858 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6859 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6860 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body6861 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var user6862 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MyOutbox/user" }) }) });
    this.before_row_edit = function(record) {
      recipients_htmlbox6851.refresh();
      owner_id6855.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6854.on('change',Lino.chooser_handler(owner_id6855,'owner_type'));
      Lino.outbox.MyOutbox.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.MyOutbox.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "recipients", "editable": false, "header": "Recipients", "sortable": false, "tooltip": "(outbox.MyOutbox.recipients) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "subject", "editable": true, "editor": subject6852, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(outbox.MyOutbox.subject) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id6853, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.MyOutbox.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "owner_type", "editable": true, "editor": owner_type6854, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.MyOutbox.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_id", "editable": true, "editor": owner_id6855, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "date", "editable": true, "editor": date6856, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "hidden": true, "sortable": true, "tooltip": "(outbox.MyOutbox.date) \n        The official date to be printed on the document.\n        ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "body", "editable": true, "editor": body6861, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(outbox.MyOutbox.body) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user6862, "filter": { "type": "string" }, "header": "Sender", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.MyOutbox.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) } ];
    Lino.outbox.MyOutbox.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MyOutbox.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MyOutbox.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/outbox/MyOutbox",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MyOutbox.detail;
    this.ls_insert_handler = Lino.outbox.MyOutbox.insert;
    Lino.outbox.MyOutbox.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MyOutbox.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.MyOutbox.insertPanel(p);
});
Lino.outbox.MyOutbox.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MyOutbox.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/MyOutbox",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MyOutbox.detail;
    this.ls_insert_handler = Lino.outbox.MyOutbox.insert;
    Lino.outbox.MyOutbox.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MyOutbox.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.MyOutbox.detailPanel(p);
});
Lino.outbox.MyOutbox.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.MyOutbox.GridPanel(p);
});
Lino.outbox.MyOutbox.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MyOutbox.send_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MyOutbox", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.MailsByUser
Lino.outbox.MailsByUser.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/MailsByUser",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByUser','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "Outbox",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "name": "sent" }, { "name": "subject" }, { "name": "recipients" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByUser.detail;
    this.ls_insert_handler = Lino.outbox.MailsByUser.insert;
    var ww = this.containing_window;
    var sent6864 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject6865 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var recipients_htmlbox6866 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Recipients", "value": "<br/>" });
    this.before_row_edit = function(record) {
      recipients_htmlbox6866.refresh();
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.MailsByUser.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": true, "editor": subject6865, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(outbox.MailsByUser.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "recipients", "editable": false, "header": "Recipients", "sortable": false, "tooltip": "(outbox.MailsByUser.recipients) ", "width": Lino.chars2width(31) } ];
    Lino.outbox.MailsByUser.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByUser.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByUser.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/outbox/MailsByUser",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByUser.detail;
    this.ls_insert_handler = Lino.outbox.MailsByUser.insert;
    Lino.outbox.MailsByUser.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByUser.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.MailsByUser.insertPanel(p);
});
Lino.outbox.MailsByUser.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByUser.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/MailsByUser",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByUser.detail;
    this.ls_insert_handler = Lino.outbox.MailsByUser.insert;
    Lino.outbox.MailsByUser.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByUser.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.MailsByUser.detailPanel(p);
});
Lino.outbox.MailsByUser.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.MailsByUser.GridPanel(p);
});
Lino.outbox.MailsByUser.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByUser.send_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByUser", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.SentByPartner
Lino.outbox.SentByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/SentByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/SentByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "Outbox",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "sent" }, { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.SentByPartner.detail;
    this.ls_insert_handler = Lino.outbox.SentByPartner.insert;
    var ww = this.containing_window;
    var sent6868 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var subject6869 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user6870 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/SentByPartner/user" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.SentByPartner.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "subject", "editable": true, "editor": subject6869, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(outbox.SentByPartner.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user6870, "filter": { "type": "string" }, "header": "Sender", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.SentByPartner.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) } ];
    Lino.outbox.SentByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.SentByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.SentByPartner.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/outbox/SentByPartner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.SentByPartner.detail;
    this.ls_insert_handler = Lino.outbox.SentByPartner.insert;
    Lino.outbox.SentByPartner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.SentByPartner.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.SentByPartner.insertPanel(p);
});
Lino.outbox.SentByPartner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.SentByPartner.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/SentByPartner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.SentByPartner.detail;
    this.ls_insert_handler = Lino.outbox.SentByPartner.insert;
    Lino.outbox.SentByPartner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.SentByPartner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.SentByPartner.detailPanel(p);
});
Lino.outbox.SentByPartner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.SentByPartner.GridPanel(p);
});
Lino.outbox.SentByPartner.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.SentByPartner.send_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/SentByPartner", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class outbox.AttachmentsByMail
Lino.outbox.AttachmentsByMail.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/AttachmentsByMail",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/AttachmentsByMail','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Attachments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 12,
  ls_store_fields : [ { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "owner" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "mail" }, 'mailHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  content_type : 74,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var id6872 = new Ext.form.NumberField({ "selectOnFocus": true });
    var owner_type6873 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByMail/owner_type" }) }) });
    var owner_id6874 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByMail/owner_id" }) }) });
    var owner_disp6875 = new Ext.form.DisplayField({ "disabled": true });
    var workflow_buttons_disp6876 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6877 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6878 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mail6879 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Outgoing Mail...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/AttachmentsByMail/mail" }) }) });
    this.before_row_edit = function(record) {
      owner_id6874.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type6873.on('change',Lino.chooser_handler(owner_id6874,'owner_type'));
      Lino.outbox.AttachmentsByMail.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "id", "editable": true, "editor": id6872, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(outbox.AttachmentsByMail.id) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "owner_type", "editable": true, "editor": owner_type6873, "filter": { "type": "string" }, "header": "Controlled by (type)", "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.AttachmentsByMail.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "owner_id", "editable": true, "editor": owner_id6874, "filter": { "type": "string" }, "header": "Controlled by (object)", "sortable": false, "tooltip": "(outbox.AttachmentsByMail.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 3, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(outbox.AttachmentsByMail.owner) ", "width": Lino.chars2width(11) }, { "colIndex": 4, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 6, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "mail", "editable": true, "editor": mail6879, "filter": { "type": "string" }, "header": "Outgoing Mail", "hidden": true, "sortable": false, "tooltip": "(outbox.AttachmentsByMail.mail) ", "width": Lino.chars2width(21) } ];
    Lino.outbox.AttachmentsByMail.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.AttachmentsByMail.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/AttachmentsByMail", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.AttachmentsByMail.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.AttachmentsByMail.GridPanel(p);
});

// js_render_GridPanel_class excerpts.ExcerptsByType
Lino.excerpts.ExcerptsByType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/ExcerptsByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Excerpts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 27,
  ls_store_fields : [ { "name": "build_time" }, { "name": "owner" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByType.detail;
    var ww = this.containing_window;
    var build_time3864 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var owner_disp3865 = new Ext.form.DisplayField({ "disabled": true });
    var user3866 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/user" }) }) });
    var id3867 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_method3868 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company3869 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/company" }) }) });
    var contact_person3870 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/contact_person" }) }) });
    var contact_role3871 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/contact_role" }) }) });
    var owner_type3872 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/owner_type" }) }) });
    var owner_id3873 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/owner_id" }) }) });
    var language3874 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var body_template_content3875 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox3876 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Preview", "value": "<br/>" });
    var workflow_buttons_disp3877 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3878 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3879 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var excerpt_type3880 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Excerpt Type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByType/excerpt_type" }) }) });
    this.before_row_edit = function(record) {
      contact_person3870.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id3873.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox3876.refresh();
      excerpt_type3880.setContextValue('owner', record ? record.data['owner'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3869.on('change',Lino.chooser_handler(contact_person3870,'company'));
      owner_type3872.on('change',Lino.chooser_handler(owner_id3873,'owner_type'));
      owner_disp3865.on('change',Lino.chooser_handler(excerpt_type3880,'owner'));
      Lino.excerpts.ExcerptsByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "build_time", "editable": false, "header": "build time", "sortable": true, "tooltip": "(excerpts.ExcerptsByType.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "owner", "editable": false, "header": "Controlled by", "sortable": false, "tooltip": "(excerpts.ExcerptsByType.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user3866, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3867, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.ExcerptsByType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "build_method", "editable": true, "editor": build_method3868, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company3869, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_person", "editable": true, "editor": contact_person3870, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "contact_role", "editable": true, "editor": contact_role3871, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type3872, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByType.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id3873, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language3874, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "body_template_content", "editable": false, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "preview", "editable": false, "header": "Preview", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type3880, "filter": { "type": "string" }, "header": "Excerpt Type", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByType.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) } ];
    Lino.excerpts.ExcerptsByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.ExcerptsByType.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/ExcerptsByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByType.detail;
    Lino.excerpts.ExcerptsByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByType.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.ExcerptsByType.detailPanel(p);
});
Lino.excerpts.ExcerptsByType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.ExcerptsByType.GridPanel(p);
});
Lino.excerpts.ExcerptsByType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByType.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class users.AuthoritiesGiven
Lino.users.AuthoritiesGiven.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/AuthoritiesGiven",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesGiven','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Authorities given",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "authorized" }, 'authorizedHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 3,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var authorized3665 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/AuthoritiesGiven/authorized" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      authorized3665.setContextValue('mk',bp['mk']);
      authorized3665.setContextValue('mt',bp['mt']);
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "authorized", "editable": true, "editor": authorized3665, "filter": { "type": "string" }, "header": "User", "renderer": Lino.fk_renderer('authorizedHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(users.AuthoritiesGiven.authorized) The user who gets authority to act in your name.", "width": Lino.chars2width(21) } ];
    Lino.users.AuthoritiesGiven.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AuthoritiesGiven.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesGiven", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesGiven.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Authorities.ParamsPanel({});
  return new Lino.users.AuthoritiesGiven.GridPanel(p);
});

// js_render_GridPanel_class users.AuthoritiesTaken
Lino.users.AuthoritiesTaken.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/users/AuthoritiesTaken",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/users/AuthoritiesTaken','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Authorities taken",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 2,
  ls_grid_configs : [  ],
  content_type : 3,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var user6881 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/users/AuthoritiesTaken/user" }) }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "user", "editable": true, "editor": user6881, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(users.AuthoritiesTaken.user) The user who gives the right of representation. author of this\nauthority", "width": Lino.chars2width(21) } ];
    Lino.users.AuthoritiesTaken.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.users.AuthoritiesTaken.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/users/AuthoritiesTaken", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.users.AuthoritiesTaken.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.users.Authorities.ParamsPanel({});
  return new Lino.users.AuthoritiesTaken.GridPanel(p);
});

// js_render_GridPanel_class courses.LinesByTopic
Lino.courses.LinesByTopic.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/LinesByTopic",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByTopic','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Activity lines",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 41,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "topic" }, 'topicHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "guest_role" }, 'guest_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "excerpt_title" }, { "name": "excerpt_title_de" }, { "name": "excerpt_title_fr" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "fee" }, 'feeHidden', { "name": "options_cat" }, 'options_catHidden', { "name": "fees_cat" }, 'fees_catHidden', { "name": "body_template" }, { "name": "course_type" }, 'course_typeHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 15,
  ls_grid_configs : [  ],
  content_type : 57,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByTopic.detail;
    this.ls_insert_handler = Lino.courses.LinesByTopic.insert;
    var ww = this.containing_window;
    var ref3549 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name3550 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3551 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3552 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var topic3553 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Topic...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/topic" }) }) });
    var course_area3554 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var event_type3555 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/event_type" }) }) });
    var guest_role3556 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/guest_role" }) }) });
    var every_unit3557 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3558 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var id3559 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var company3560 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/company" }) }) });
    var contact_person3561 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/contact_person" }) }) });
    var contact_role3562 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/contact_role" }) }) });
    var excerpt_title3563 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_de3564 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_fr3565 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description3566 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3567 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3568 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee3569 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/fee" }) }) });
    var options_cat3570 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/options_cat" }) }) });
    var fees_cat3571 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/fees_cat" }) }) });
    var body_template3572 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/body_template" }) }) });
    var course_type3573 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Activity type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByTopic/course_type" }) }) });
    var workflow_buttons_disp3574 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3575 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3576 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      contact_person3561.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      fee3569.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3560.on('change',Lino.chooser_handler(contact_person3561,'company'));
      fees_cat3571.on('change',Lino.chooser_handler(fee3569,'fees_cat'));
      Lino.courses.LinesByTopic.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref3549, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.LinesByTopic.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3550, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.LinesByTopic.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3551, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(courses.LinesByTopic.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3552, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(courses.LinesByTopic.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "topic", "editable": true, "editor": topic3553, "filter": { "type": "string" }, "header": "Topic", "sortable": false, "tooltip": "(courses.LinesByTopic.topic) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course_area", "editable": true, "editor": course_area3554, "filter": { "type": "string" }, "header": "Layout", "sortable": false, "tooltip": "(courses.LinesByTopic.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.", "width": Lino.chars2width(14) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type3555, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(courses.LinesByTopic.event_type) The type of calendar events to be generated. If this is empty, no calendar events will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "guest_role", "editable": true, "editor": guest_role3556, "filter": { "type": "string" }, "header": "Manage presences as", "renderer": Lino.fk_renderer('guest_roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.guest_role) The default guest role for particpants of events for courses in this series. Leave empty if you don't want any presence management.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "every_unit", "editable": true, "editor": every_unit3557, "filter": { "type": "string" }, "header": "Recurrency", "sortable": false, "tooltip": "(courses.LinesByTopic.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 9, "dataIndex": "every", "editable": true, "editor": every3558, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "sortable": true, "tooltip": "(courses.LinesByTopic.every) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id3559, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.id) ", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "company", "editable": true, "editor": company3560, "filter": { "type": "string" }, "header": "Company", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_person", "editable": true, "editor": contact_person3561, "filter": { "type": "string" }, "header": "represented by", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "contact_role", "editable": true, "editor": contact_role3562, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "excerpt_title", "editable": true, "editor": excerpt_title3563, "filter": { "type": "string" }, "header": "Excerpt title", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.excerpt_title) The title to be used when printing an excerpt.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "excerpt_title_de", "editable": true, "editor": excerpt_title_de3564, "filter": { "type": "string" }, "header": "Excerpt title (de)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.excerpt_title_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "excerpt_title_fr", "editable": true, "editor": excerpt_title_fr3565, "filter": { "type": "string" }, "header": "Excerpt title (fr)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByTopic.excerpt_title_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description3566, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "description_de", "editable": true, "editor": description_de3567, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "description_fr", "editable": true, "editor": description_fr3568, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee3569, "filter": { "type": "string" }, "header": "Participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "options_cat", "editable": true, "editor": options_cat3570, "filter": { "type": "string" }, "header": "Options category", "hidden": true, "renderer": Lino.fk_renderer('options_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.options_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "fees_cat", "editable": true, "editor": fees_cat3571, "filter": { "type": "string" }, "header": "Fees category", "hidden": true, "renderer": Lino.fk_renderer('fees_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.fees_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "body_template", "editable": true, "editor": body_template3572, "filter": { "type": "string" }, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "course_type", "editable": true, "editor": course_type3573, "filter": { "type": "string" }, "header": "Activity type", "hidden": true, "renderer": Lino.fk_renderer('course_typeHidden','Lino.courses.CourseTypes.detail'), "sortable": false, "tooltip": "(courses.LinesByTopic.course_type) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByTopic.description_column) ", "width": Lino.chars2width(31) } ];
    Lino.courses.LinesByTopic.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByTopic.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByTopic.insertPanel = Ext.extend(Lino.courses.Lines.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/LinesByTopic",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByTopic.detail;
    this.ls_insert_handler = Lino.courses.LinesByTopic.insert;
    Lino.courses.LinesByTopic.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByTopic.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(16), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.LinesByTopic.insertPanel(p);
});
Lino.courses.LinesByTopic.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByTopic.detailPanel = Ext.extend(Lino.courses.Lines.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/courses/LinesByTopic",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByTopic.detail;
    this.ls_insert_handler = Lino.courses.LinesByTopic.insert;
    Lino.courses.LinesByTopic.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByTopic.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByTopic.detailPanel(p);
});
Lino.courses.LinesByTopic.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByTopic.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByTopic.GridPanel(p);
});
Lino.courses.LinesByTopic.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByTopic", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesByTeacher
Lino.courses.CoursesByTeacher.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesByTeacher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTeacher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "line" }, 'lineHidden', { "name": "room" }, 'roomHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "teacher" }, 'teacherHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.CoursesByTeacher.insert;
    var ww = this.containing_window;
    var start_date3399 = new Lino.DateField({ "selectOnFocus": true });
    var start_time3400 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time3401 = new Lino.TimeField({ "selectOnFocus": true });
    var line3402 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/line" }) }) });
    var room3403 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/room" }) }) });
    var id3404 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref3405 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var end_date3406 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user3407 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/user" }) }) });
    var every_unit3408 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3409 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday3410 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday3411 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday3412 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday3413 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday3414 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday3415 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday3416 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events3417 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date3418 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot3419 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/slot" }) }) });
    var description3420 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3421 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3422 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark3423 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state3424 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places3425 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name3426 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until3427 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee3428 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/fee" }) }) });
    var payment_term3429 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/payment_term" }) }) });
    var paper_type3430 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/paper_type" }) }) });
    var workflow_buttons_disp3431 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3432 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3433 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp3434 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments3435 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp3436 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested3437 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed3438 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox3439 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying3440 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places3441 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp3442 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp3443 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp3444 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration3445 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var teacher3446 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTeacher/teacher" }) }) });
    this.before_row_edit = function(record) {
      fee3428.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox3439.refresh();
    };
    this.onRender = function(ct, position) {
      line3402.on('change',Lino.chooser_handler(fee3428,'line'));
      Lino.courses.CoursesByTeacher.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date3399, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.CoursesByTeacher.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "start_time", "editable": true, "editor": start_time3400, "header": "Start time", "sortable": true, "tooltip": "(courses.CoursesByTeacher.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "end_time", "editable": true, "editor": end_time3401, "header": "End Time", "sortable": true, "tooltip": "(courses.CoursesByTeacher.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "line", "editable": true, "editor": line3402, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room3403, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.CoursesByTeacher.room) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id3404, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref3405, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "end_date", "editable": true, "editor": end_date3406, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "user", "editable": true, "editor": user3407, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "every_unit", "editable": true, "editor": every_unit3408, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 10, "dataIndex": "every", "editable": true, "editor": every3409, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.every) ", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 12, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 13, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 14, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 18, "dataIndex": "max_events", "editable": true, "editor": max_events3417, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 19, "dataIndex": "max_date", "editable": true, "editor": max_date3418, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 20, "dataIndex": "slot", "editable": true, "editor": slot3419, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "description", "editable": true, "editor": description3420, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "description_de", "editable": true, "editor": description_de3421, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 23, "dataIndex": "description_fr", "editable": true, "editor": description_fr3422, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 24, "dataIndex": "remark", "editable": true, "editor": remark3423, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "state", "editable": true, "editor": state3424, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 26, "dataIndex": "max_places", "editable": true, "editor": max_places3425, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 27, "dataIndex": "name", "editable": true, "editor": name3426, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until3427, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTeacher.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 29, "dataIndex": "fee", "editable": true, "editor": fee3428, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 30, "dataIndex": "payment_term", "editable": true, "editor": payment_term3429, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 31, "dataIndex": "paper_type", "editable": true, "editor": paper_type3430, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 33, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 34, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 36, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 37, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 38, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 39, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 40, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 41, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 42, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 43, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTeacher.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 47, "dataIndex": "teacher", "editable": true, "editor": teacher3446, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesByTeacher.teacher) ", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesByTeacher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTeacher.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByTeacher.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/CoursesByTeacher",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.CoursesByTeacher.insert;
    Lino.courses.CoursesByTeacher.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTeacher.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CoursesByTeacher.insertPanel(p);
});
Lino.courses.CoursesByTeacher.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByTeacher.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesByTeacher",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTeacher.detail;
    this.ls_insert_handler = Lino.courses.CoursesByTeacher.insert;
    Lino.courses.CoursesByTeacher.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTeacher.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesByTeacher.detailPanel(p);
});
Lino.courses.CoursesByTeacher.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.CoursesByTeacher.GridPanel(p);
});
Lino.courses.CoursesByTeacher.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTeacher.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTeacher", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesBySlot
Lino.courses.CoursesBySlot.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesBySlot",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesBySlot','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": null, "menu": [ { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)", "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "room" }, 'roomHidden', { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "ref" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "overview" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "what_text" }, { "name": "duration" }, { "name": "slot" }, 'slotHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesBySlot.detail;
    this.ls_insert_handler = Lino.courses.CoursesBySlot.insert;
    var ww = this.containing_window;
    var start_date2875 = new Lino.DateField({ "selectOnFocus": true });
    var enrolments_until2876 = new Lino.DateField({ "selectOnFocus": true });
    var line2877 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/line" }) }) });
    var teacher2878 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/teacher" }) }) });
    var room2879 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/room" }) }) });
    var workflow_buttons_disp2880 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id2881 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref2882 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_time2883 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date2884 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time2885 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user2886 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/user" }) }) });
    var every_unit2887 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every2888 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday2889 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday2890 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday2891 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday2892 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday2893 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday2894 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday2895 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events2896 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date2897 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var description2898 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de2899 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr2900 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark2901 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state2902 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places2903 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name2904 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var fee2905 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/fee" }) }) });
    var payment_term2906 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/payment_term" }) }) });
    var paper_type2907 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/paper_type" }) }) });
    var overview_disp2908 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2909 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp2910 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments2911 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp2912 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested2913 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed2914 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox2915 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying2916 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places2917 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var weekdays_text_disp2918 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var times_text_disp2919 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var what_text_disp2920 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration2921 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var slot2922 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesBySlot/slot" }) }) });
    this.before_row_edit = function(record) {
      fee2905.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox2915.refresh();
    };
    this.onRender = function(ct, position) {
      line2877.on('change',Lino.chooser_handler(fee2905,'line'));
      Lino.courses.CoursesBySlot.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date2875, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.CoursesBySlot.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until2876, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "sortable": true, "tooltip": "(courses.CoursesBySlot.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "line", "editable": true, "editor": line2877, "filter": { "type": "string" }, "header": "Activity line", "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "teacher", "editable": true, "editor": teacher2878, "filter": { "type": "string" }, "header": "Instructor", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "room", "editable": true, "editor": room2879, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.CoursesBySlot.room) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.CoursesBySlot.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id2881, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "ref", "editable": true, "editor": ref2882, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time2883, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date2884, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time2885, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user2886, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit2887, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every2888, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.every) ", "width": Lino.chars2width(6) }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events2896, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date2897, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "description", "editable": true, "editor": description2898, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description) ", "width": Lino.chars2width(61) }, { "colIndex": 24, "dataIndex": "description_de", "editable": true, "editor": description_de2899, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_fr", "editable": true, "editor": description_fr2900, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "remark", "editable": true, "editor": remark2901, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "state", "editable": true, "editor": state2902, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 28, "dataIndex": "max_places", "editable": true, "editor": max_places2903, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 29, "dataIndex": "name", "editable": true, "editor": name2904, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesBySlot.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "fee", "editable": true, "editor": fee2905, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesBySlot.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 31, "dataIndex": "payment_term", "editable": true, "editor": payment_term2906, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 32, "dataIndex": "paper_type", "editable": true, "editor": paper_type2907, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 34, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 35, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 36, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 37, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 38, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 39, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 40, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 41, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 42, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 43, "dataIndex": "weekdays_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "times_text", "editable": false, "header": "Times", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 47, "dataIndex": "slot", "editable": true, "editor": slot2922, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesBySlot.slot) ", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesBySlot.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesBySlot.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesBySlot.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/CoursesBySlot",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesBySlot.detail;
    this.ls_insert_handler = Lino.courses.CoursesBySlot.insert;
    Lino.courses.CoursesBySlot.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesBySlot.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CoursesBySlot.insertPanel(p);
});
Lino.courses.CoursesBySlot.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesBySlot.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": null, "menu": [ { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)", "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesBySlot",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesBySlot.detail;
    this.ls_insert_handler = Lino.courses.CoursesBySlot.insert;
    Lino.courses.CoursesBySlot.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesBySlot.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesBySlot.detailPanel(p);
});
Lino.courses.CoursesBySlot.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.CoursesBySlot.GridPanel(p);
});
Lino.courses.CoursesBySlot.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesBySlot.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesBySlot", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByOption
Lino.courses.EnrolmentsByOption.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByOption",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByOption','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments using this option",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "name": "course" }, 'courseHidden', { "name": "pupil" }, 'pupilHidden', { "name": "remark" }, { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "confirmation_details" }, { "name": "amount" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "option" }, 'optionHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByOption.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByOption.insert;
    var ww = this.containing_window;
    var course1256 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/course" }) }) });
    var pupil1257 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/pupil" }) }) });
    var remark1258 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var request_date1259 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var id1260 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date1261 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date1262 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user1263 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/user" }) }) });
    var printed_by1264 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area1265 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state1266 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var places1267 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 1 });
    var confirmation_details1268 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var amount1269 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var fee1270 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/fee" }) }) });
    var free_events1271 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox1272 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp1273 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp1274 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp1275 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1276 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1277 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp1278 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var option1279 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByOption/option" }) }) });
    this.before_row_edit = function(record) {
      course1256.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1256.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil1257.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee1270.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox1272.refresh();
      option1279.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      course_area1265.on('change',Lino.chooser_handler(course1256,'course_area'));
      request_date1259.on('change',Lino.chooser_handler(course1256,'request_date'));
      course1256.on('change',Lino.chooser_handler(pupil1257,'course'));
      course1256.on('change',Lino.chooser_handler(fee1270,'course'));
      course1256.on('change',Lino.chooser_handler(option1279,'course'));
      Lino.courses.EnrolmentsByOption.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "course", "editable": true, "editor": course1256, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.course) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil1257, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "remark", "editable": true, "editor": remark1258, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.EnrolmentsByOption.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "request_date", "editable": true, "editor": request_date1259, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.EnrolmentsByOption.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id1260, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "start_date", "editable": true, "editor": start_date1261, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 6, "dataIndex": "end_date", "editable": true, "editor": end_date1262, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "user", "editable": true, "editor": user1263, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 10, "dataIndex": "state", "editable": true, "editor": state1266, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 11, "dataIndex": "places", "editable": true, "editor": places1267, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.places) The number of participants in this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 12, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details1268, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 13, "dataIndex": "amount", "editable": true, "editor": amount1269, "filter": { "type": "numeric" }, "header": "Amount", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 14, "dataIndex": "fee", "editable": true, "editor": fee1270, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 15, "dataIndex": "free_events", "editable": true, "editor": free_events1271, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByOption.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 16, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByOption.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "option", "editable": true, "editor": option1279, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByOption.option) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByOption.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByOption.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByOption.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsByOption",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByOption.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByOption.insert;
    Lino.courses.EnrolmentsByOption.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByOption.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByOption.insertPanel(p);
});
Lino.courses.EnrolmentsByOption.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByOption.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByOption",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByOption.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByOption.insert;
    Lino.courses.EnrolmentsByOption.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByOption.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByOption.detailPanel(p);
});
Lino.courses.EnrolmentsByOption.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByOption.GridPanel(p);
});
Lino.courses.EnrolmentsByOption.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByOption.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByOption", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByPupil
Lino.courses.EnrolmentsByPupil.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByPupil",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByPupil','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "course" }, 'courseHidden', { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "option" }, 'optionHidden', { "name": "confirmation_details" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "pupil" }, 'pupilHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByPupil.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByPupil.insert;
    var ww = this.containing_window;
    var request_date1847 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var course1848 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/course" }) }) });
    var start_date1849 = new Lino.DateField({ "selectOnFocus": true });
    var end_date1850 = new Lino.DateField({ "selectOnFocus": true });
    var places1851 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark1852 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var amount1853 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp1854 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id1855 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user1856 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/user" }) }) });
    var printed_by1857 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area1858 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state1859 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var option1860 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/option" }) }) });
    var confirmation_details1861 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee1862 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/fee" }) }) });
    var free_events1863 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox1864 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp1865 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp1866 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1867 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1868 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp1869 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var pupil1870 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByPupil/pupil" }) }) });
    this.before_row_edit = function(record) {
      course1848.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course1848.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      option1860.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee1862.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      pupil_info_htmlbox1864.refresh();
      pupil1870.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      course_area1858.on('change',Lino.chooser_handler(course1848,'course_area'));
      request_date1847.on('change',Lino.chooser_handler(course1848,'request_date'));
      course1848.on('change',Lino.chooser_handler(option1860,'course'));
      course1848.on('change',Lino.chooser_handler(fee1862,'course'));
      course1848.on('change',Lino.chooser_handler(pupil1870,'course'));
      Lino.courses.EnrolmentsByPupil.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date1847, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "course", "editable": true, "editor": course1848, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.course) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date1849, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date1850, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "places", "editable": true, "editor": places1851, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.places) The number of participants in this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark1852, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 6, "dataIndex": "amount", "editable": true, "editor": amount1853, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id1855, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "user", "editable": true, "editor": user1856, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 12, "dataIndex": "state", "editable": true, "editor": state1859, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 13, "dataIndex": "option", "editable": true, "editor": option1860, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.option) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details1861, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.confirmation_details) ", "width": Lino.chars2width(61) }, { "colIndex": 15, "dataIndex": "fee", "editable": true, "editor": fee1862, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 16, "dataIndex": "free_events", "editable": true, "editor": free_events1863, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByPupil.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "pupil", "editable": true, "editor": pupil1870, "filter": { "type": "string" }, "header": "Participant", "hidden": true, "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByPupil.pupil) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByPupil.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByPupil.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByPupil.insertPanel = Ext.extend(Lino.courses.EnrolmentsByPupil.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsByPupil",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByPupil.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByPupil.insert;
    Lino.courses.EnrolmentsByPupil.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByPupil.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByPupil.insertPanel(p);
});
Lino.courses.EnrolmentsByPupil.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByPupil.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByPupil",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByPupil.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByPupil.insert;
    Lino.courses.EnrolmentsByPupil.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByPupil.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByPupil.detailPanel(p);
});
Lino.courses.EnrolmentsByPupil.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByPupil.GridPanel(p);
});
Lino.courses.EnrolmentsByPupil.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByPupil.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByPupil", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByCourse
Lino.courses.EnrolmentsByCourse.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByCourse",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByCourse','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil" }, 'pupilHidden', { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "fee" }, 'feeHidden', { "name": "free_events", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "option" }, 'optionHidden', { "name": "confirmation_details" }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "course" }, 'courseHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByCourse.insert;
    var ww = this.containing_window;
    var request_date6883 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil6884 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/pupil" }) }) });
    var start_date6885 = new Lino.DateField({ "selectOnFocus": true });
    var end_date6886 = new Lino.DateField({ "selectOnFocus": true });
    var places6887 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6888 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var fee6889 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/fee" }) }) });
    var free_events6890 = new Ext.form.NumberField({ "selectOnFocus": true });
    var amount6891 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6892 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6893 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user6894 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/user" }) }) });
    var printed_by6895 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6896 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6897 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var option6898 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/option" }) }) });
    var confirmation_details6899 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6900 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp6901 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6902 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6903 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6904 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6905 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course6906 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByCourse/course" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil6884.setContextValue('mk',bp['mk']);
      pupil6884.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      fee6889.setContextValue('mk',bp['mk']);
      fee6889.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option6898.setContextValue('mk',bp['mk']);
      option6898.setContextValue('mt',bp['mt']);
      pupil_info_htmlbox6900.refresh();
      course6906.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6906.setContextValue('request_date', record ? record.data['request_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      course6906.on('change',Lino.chooser_handler(pupil6884,'course'));
      course6906.on('change',Lino.chooser_handler(fee6889,'course'));
      course6906.on('change',Lino.chooser_handler(option6898,'course'));
      course_area6896.on('change',Lino.chooser_handler(course6906,'course_area'));
      request_date6883.on('change',Lino.chooser_handler(course6906,'request_date'));
      Lino.courses.EnrolmentsByCourse.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6883, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil6884, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "start_date", "editable": true, "editor": start_date6885, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "end_date", "editable": true, "editor": end_date6886, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 4, "dataIndex": "places", "editable": true, "editor": places6887, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.places) The number of participants in this enrolment.", "width": Lino.chars2width(9) }, { "colIndex": 5, "dataIndex": "remark", "editable": true, "editor": remark6888, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "fee", "editable": true, "editor": fee6889, "filter": { "type": "string" }, "header": "Tariff", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 7, "dataIndex": "free_events", "editable": true, "editor": free_events6890, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 8, "dataIndex": "amount", "editable": true, "editor": amount6891, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 9, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id6893, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByCourse.id) ", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6894, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6897, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "option", "editable": true, "editor": option6898, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.option) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6899, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.confirmation_details) ", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "course", "editable": true, "editor": course6906, "filter": { "type": "string" }, "header": "Activity", "hidden": true, "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByCourse.course) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByCourse.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByCourse.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByCourse.insertPanel = Ext.extend(Lino.courses.EnrolmentsByCourse.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsByCourse",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByCourse.insert;
    Lino.courses.EnrolmentsByCourse.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByCourse.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByCourse.insertPanel(p);
});
Lino.courses.EnrolmentsByCourse.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByCourse.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByCourse",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByCourse.insert;
    Lino.courses.EnrolmentsByCourse.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByCourse.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByCourse.detailPanel(p);
});
Lino.courses.EnrolmentsByCourse.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByCourse.GridPanel(p);
});
Lino.courses.EnrolmentsByCourse.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByCourse.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByCourse", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByFee
Lino.courses.EnrolmentsByFee.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByFee",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByFee','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments using this fee",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "name": "course" }, 'courseHidden', { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil_info" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "free_events", "type": "int", "useNull": true }, { "name": "amount" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "pupil" }, 'pupilHidden', { "name": "state" }, 'stateHidden', { "name": "option" }, 'optionHidden', { "name": "confirmation_details" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "fee" }, 'feeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByFee.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByFee.insert;
    var ww = this.containing_window;
    var course6908 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/course" }) }) });
    var request_date6909 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil_info_htmlbox6910 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var start_date6911 = new Lino.DateField({ "selectOnFocus": true });
    var end_date6912 = new Lino.DateField({ "selectOnFocus": true });
    var places6913 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6914 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var free_events6915 = new Ext.form.NumberField({ "selectOnFocus": true });
    var amount6916 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var id6917 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user6918 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/user" }) }) });
    var printed_by6919 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6920 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var pupil6921 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/pupil" }) }) });
    var state6922 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var option6923 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/option" }) }) });
    var confirmation_details6924 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_info_disp6925 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6926 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6927 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6928 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6929 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6930 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var fee6931 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByFee/fee" }) }) });
    this.before_row_edit = function(record) {
      course6908.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6908.setContextValue('request_date', record ? record.data['request_date'] : undefined);
      pupil_info_htmlbox6910.refresh();
      pupil6921.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      option6923.setContextValue('course', record ? record.data['courseHidden'] : undefined);
      fee6931.setContextValue('course', record ? record.data['courseHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      course_area6920.on('change',Lino.chooser_handler(course6908,'course_area'));
      request_date6909.on('change',Lino.chooser_handler(course6908,'request_date'));
      course6908.on('change',Lino.chooser_handler(pupil6921,'course'));
      course6908.on('change',Lino.chooser_handler(option6923,'course'));
      course6908.on('change',Lino.chooser_handler(fee6931,'course'));
      Lino.courses.EnrolmentsByFee.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "course", "editable": true, "editor": course6908, "filter": { "type": "string" }, "header": "Activity", "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.course) ", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "request_date", "editable": true, "editor": request_date6909, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "sortable": false, "tooltip": "(courses.EnrolmentsByFee.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "start_date", "editable": true, "editor": start_date6911, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "end_date", "editable": true, "editor": end_date6912, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 5, "dataIndex": "places", "editable": true, "editor": places6913, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.places) The number of participants in this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "remark", "editable": true, "editor": remark6914, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.remark) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "free_events", "editable": true, "editor": free_events6915, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 8, "dataIndex": "amount", "editable": true, "editor": amount6916, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(courses.EnrolmentsByFee.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 9, "dataIndex": "id", "editable": true, "editor": id6917, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByFee.id) ", "width": Lino.chars2width(6) }, { "colIndex": 10, "dataIndex": "user", "editable": true, "editor": user6918, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 13, "dataIndex": "pupil", "editable": true, "editor": pupil6921, "filter": { "type": "string" }, "header": "Participant", "hidden": true, "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.pupil) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6922, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "option", "editable": true, "editor": option6923, "filter": { "type": "string" }, "header": "Option", "hidden": true, "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.option) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6924, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.confirmation_details) ", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByFee.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "fee", "editable": true, "editor": fee6931, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByFee.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByFee.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByFee.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByFee.insertPanel = Ext.extend(Lino.courses.EnrolmentsByCourse.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsByFee",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByFee.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByFee.insert;
    Lino.courses.EnrolmentsByFee.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByFee.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByFee.insertPanel(p);
});
Lino.courses.EnrolmentsByFee.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByFee.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByFee",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByFee.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByFee.insert;
    Lino.courses.EnrolmentsByFee.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByFee.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByFee.detailPanel(p);
});
Lino.courses.EnrolmentsByFee.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByFee.GridPanel(p);
});
Lino.courses.EnrolmentsByFee.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByFee.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByFee", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.TeachersByType
Lino.courses.TeachersByType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/TeachersByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/TeachersByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Instructors",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 64,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "teacher_type" }, 'teacher_typeHidden', { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "eid_info" }, { "name": "image" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeachersByType.detail;
    this.ls_insert_handler = Lino.courses.TeachersByType.insert;
    var ww = this.containing_window;
    var name_column_disp3263 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp3264 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var teacher_type3265 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/teacher_type" }) }) });
    var id3266 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email3267 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language3268 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url3269 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone3270 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm3271 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax3272 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country3273 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/country" }) }) });
    var city3274 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/city" }) }) });
    var zip_code3275 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region3276 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/region" }) }) });
    var addr13277 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix3278 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street3279 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no3280 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box3281 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr23282 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name3283 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks3284 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term3285 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/payment_term" }) }) });
    var vat_regime3286 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient3287 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/invoice_recipient" }) }) });
    var paper_type3288 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/paper_type" }) }) });
    var title3289 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name3290 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name3291 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name3292 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender3293 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date3294 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id3295 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country3296 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/birth_country" }) }) });
    var birth_place3297 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality3298 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/TeachersByType/nationality" }) }) });
    var card_number3299 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from3300 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until3301 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type3302 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer3303 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition3304 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var workflow_buttons_disp3305 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3306 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3307 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp3308 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp3309 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance3310 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var eid_info_disp3311 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var image_htmlbox3312 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    this.before_row_edit = function(record) {
      city3274.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city3274.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region3276.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox3312.refresh();
    };
    this.onRender = function(ct, position) {
      country3273.on('change',Lino.chooser_handler(city3274,'country'));
      region3276.on('change',Lino.chooser_handler(city3274,'region'));
      country3273.on('change',Lino.chooser_handler(region3276,'country'));
      Lino.courses.TeachersByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.TeachersByType.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(courses.TeachersByType.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "teacher_type", "editable": true, "editor": teacher_type3265, "filter": { "type": "string" }, "header": "Instructor Type", "renderer": Lino.fk_renderer('teacher_typeHidden','Lino.courses.TeacherTypes.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.teacher_type) Pointer to TeacherType.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id3266, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "email", "editable": true, "editor": email3267, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "language", "editable": true, "editor": language3268, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "url", "editable": true, "editor": url3269, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.url) ", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "phone", "editable": true, "editor": phone3270, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 8, "dataIndex": "gsm", "editable": true, "editor": gsm3271, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 9, "dataIndex": "fax", "editable": true, "editor": fax3272, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "country", "editable": true, "editor": country3273, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.country) ", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "city", "editable": true, "editor": city3274, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "zip_code", "editable": true, "editor": zip_code3275, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 13, "dataIndex": "region", "editable": true, "editor": region3276, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.region) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "addr1", "editable": true, "editor": addr13277, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix3278, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "street", "editable": true, "editor": street3279, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "street_no", "editable": true, "editor": street_no3280, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "street_box", "editable": true, "editor": street_box3281, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 19, "dataIndex": "addr2", "editable": true, "editor": addr23282, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "name", "editable": true, "editor": name3283, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "remarks", "editable": true, "editor": remarks3284, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 22, "dataIndex": "payment_term", "editable": true, "editor": payment_term3285, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime3286, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 24, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient3287, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "paper_type", "editable": true, "editor": paper_type3288, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "title", "editable": true, "editor": title3289, "filter": { "type": "string" }, "header": "Title", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.title) An optional name prefix like \"Dr.\" or \"PhD\", used to specify a\nprofessional position or academic qualification.", "width": Lino.chars2width(22) }, { "colIndex": 27, "dataIndex": "first_name", "editable": true, "editor": first_name3290, "filter": { "type": "string" }, "header": "First name", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 28, "dataIndex": "middle_name", "editable": true, "editor": middle_name3291, "filter": { "type": "string" }, "header": "Middle name", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 29, "dataIndex": "last_name", "editable": true, "editor": last_name3292, "filter": { "type": "string" }, "header": "Last name", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 30, "dataIndex": "gender", "editable": true, "editor": gender3293, "filter": { "type": "string" }, "header": "Gender", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 31, "dataIndex": "birth_date", "editable": true, "editor": birth_date3294, "filter": { "type": "string" }, "header": "Birth date", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 32, "dataIndex": "national_id", "editable": true, "editor": national_id3295, "filter": { "type": "string" }, "header": "National ID", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 33, "dataIndex": "birth_country", "editable": true, "editor": birth_country3296, "filter": { "type": "string" }, "header": "Birth country", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "birth_place", "editable": true, "editor": birth_place3297, "filter": { "type": "string" }, "header": "Birth place", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "nationality", "editable": true, "editor": nationality3298, "filter": { "type": "string" }, "header": "Nationality", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.TeachersByType.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 36, "dataIndex": "card_number", "editable": true, "editor": card_number3299, "filter": { "type": "string" }, "header": "eID card number", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 37, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from3300, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID card valid from", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 38, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until3301, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "until", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 39, "dataIndex": "card_type", "editable": true, "editor": card_type3302, "filter": { "type": "string" }, "header": "eID card type", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.card_type) ", "width": Lino.chars2width(25) }, { "colIndex": 40, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer3303, "filter": { "type": "string" }, "header": "eID card issuer", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.card_issuer) The administration who issued this ID card.", "width": Lino.chars2width(22) }, { "colIndex": 41, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition3304, "filter": { "type": "string" }, "header": "noble condition", "hidden": true, "sortable": true, "tooltip": "(courses.TeachersByType.noble_condition) The eventual noble condition of this person.", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 43, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 44, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "age", "editable": false, "header": "Age", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.age) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 48, "dataIndex": "eid_info", "editable": false, "header": "eID card", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.eid_info) ", "width": Lino.chars2width(31) }, { "colIndex": 49, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.TeachersByType.image) ", "width": Lino.chars2width(31) } ];
    Lino.courses.TeachersByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeachersByType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeachersByType.insertPanel = Ext.extend(Lino.contacts.Persons.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/TeachersByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeachersByType.detail;
    this.ls_insert_handler = Lino.courses.TeachersByType.insert;
    Lino.courses.TeachersByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeachersByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.TeachersByType.insertPanel(p);
});
Lino.courses.TeachersByType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.TeachersByType.detailPanel = Ext.extend(Lino.courses.Teachers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/TeachersByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.TeachersByType.detail;
    this.ls_insert_handler = Lino.courses.TeachersByType.insert;
    Lino.courses.TeachersByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.TeachersByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.TeachersByType.detailPanel(p);
});
Lino.courses.TeachersByType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.contacts.Partners.ParamsPanel({});
  return new Lino.courses.TeachersByType.GridPanel(p);
});
Lino.courses.TeachersByType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.read_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.TeachersByType.find_by_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/TeachersByType", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.PupilsByType
Lino.courses.PupilsByType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/PupilsByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "print_labels", "menu_item_text": "Labels", "overflowText": "Labels", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','print_labels','GET',Lino.get_current_grid_config), "text": "Labels", "tooltip": "Generate mailing labels for these recipients" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/PupilsByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Merge", "overflowText": "Merge", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Merge this object into another object of same class." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : true,
  title : "Participants",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 72,
  ls_store_fields : [ { "name": "name_column" }, { "name": "address_column" }, { "name": "pupil_type" }, 'pupil_typeHidden', { "name": "section" }, 'sectionHidden', { "name": "is_lfv", "type": "boolean" }, { "name": "is_ckk", "type": "boolean" }, { "name": "is_raviva", "type": "boolean" }, { "dateFormat": "d.m.Y", "name": "member_until", "type": "date" }, { "name": "id", "type": "int" }, { "name": "email" }, { "name": "language" }, 'languageHidden', { "name": "url" }, { "name": "phone" }, { "name": "gsm" }, { "name": "fax" }, { "name": "country" }, 'countryHidden', { "name": "city" }, 'cityHidden', { "name": "zip_code" }, { "name": "region" }, 'regionHidden', { "name": "addr1" }, { "name": "street_prefix" }, { "name": "street" }, { "name": "street_no" }, { "name": "street_box" }, { "name": "addr2" }, { "name": "name" }, { "name": "remarks" }, { "name": "payment_term" }, 'payment_termHidden', { "name": "vat_regime" }, 'vat_regimeHidden', { "name": "invoice_recipient" }, 'invoice_recipientHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "title" }, { "name": "first_name" }, { "name": "middle_name" }, { "name": "last_name" }, { "name": "gender" }, 'genderHidden', { "name": "birth_date" }, { "name": "national_id" }, { "name": "birth_country" }, 'birth_countryHidden', { "name": "birth_place" }, { "name": "nationality" }, 'nationalityHidden', { "name": "card_number" }, { "dateFormat": "d.m.Y", "name": "card_valid_from", "type": "date" }, { "dateFormat": "d.m.Y", "name": "card_valid_until", "type": "date" }, { "name": "card_type" }, 'card_typeHidden', { "name": "card_issuer" }, { "name": "noble_condition" }, { "name": "legacy_id" }, { "name": "is_member", "type": "boolean" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "age" }, { "name": "mti_navigator" }, { "name": "debit_balance" }, { "name": "eid_info" }, { "name": "image" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 10,
  ls_grid_configs : [  ],
  content_type : 10,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilsByType.detail;
    this.ls_insert_handler = Lino.courses.PupilsByType.insert;
    var ww = this.containing_window;
    var name_column_disp1716 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var address_column_disp1717 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var pupil_type1718 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Participant Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/pupil_type" }) }) });
    var section1719 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.courses.Sections) });
    var is_lfv1720 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_ckk1721 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var is_raviva1722 = new Ext.form.Checkbox({ "checked": false, "selectOnFocus": true });
    var member_until1723 = new Lino.DateField({ "selectOnFocus": true });
    var id1724 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var email1725 = new Ext.form.TextField({ "hidden": true, "maxLength": 254, "selectOnFocus": true });
    var language1726 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var url1727 = new Lino.URLField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var phone1728 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gsm1729 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var fax1730 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var country1731 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/country" }) }) });
    var city1732 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "forceSelection": false, "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/city" }) }) });
    var zip_code1733 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var region1734 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Place...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/region" }) }) });
    var addr11735 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_prefix1736 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street1737 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var street_no1738 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var street_box1739 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "hidden": true, "maxLength": 10, "selectOnFocus": true });
    var addr21740 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var name1741 = new Ext.form.TextField({ "allowBlank": false, "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var remarks1742 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var payment_term1743 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/payment_term" }) }) });
    var vat_regime1744 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatRegimes) });
    var invoice_recipient1745 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/invoice_recipient" }) }) });
    var paper_type1746 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/paper_type" }) }) });
    var title1747 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var first_name1748 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var middle_name1749 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var last_name1750 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var gender1751 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.system.Genders) });
    var birth_date1752 = new Lino.IncompleteDateField({ "hidden": true, "selectOnFocus": true });
    var national_id1753 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var birth_country1754 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/birth_country" }) }) });
    var birth_place1755 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var nationality1756 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Country...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/PupilsByType/nationality" }) }) });
    var card_number1757 = new Ext.form.TextField({ "hidden": true, "maxLength": 20, "selectOnFocus": true });
    var card_valid_from1758 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_valid_until1759 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var card_type1760 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.beid.BeIdCardTypes) });
    var card_issuer1761 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var noble_condition1762 = new Ext.form.TextField({ "hidden": true, "maxLength": 50, "selectOnFocus": true });
    var legacy_id1763 = new Ext.form.TextField({ "hidden": true, "maxLength": 12, "selectOnFocus": true });
    var is_member1764 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp1765 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1766 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1767 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var age_disp1768 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var mti_navigator_disp1769 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var debit_balance1770 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true, "hidden": true });
    var eid_info_disp1771 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var image_htmlbox1772 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "image", "value": "<br/>" });
    this.before_row_edit = function(record) {
      city1732.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      city1732.setContextValue('region', record ? record.data['regionHidden'] : undefined);
      region1734.setContextValue('country', record ? record.data['countryHidden'] : undefined);
      image_htmlbox1772.refresh();
    };
    this.onRender = function(ct, position) {
      country1731.on('change',Lino.chooser_handler(city1732,'country'));
      region1734.on('change',Lino.chooser_handler(city1732,'region'));
      country1731.on('change',Lino.chooser_handler(region1734,'country'));
      Lino.courses.PupilsByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name_column", "editable": false, "header": "Name", "sortable": false, "tooltip": "(courses.PupilsByType.name_column) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "address_column", "editable": false, "header": "Address", "sortable": false, "tooltip": "(courses.PupilsByType.address_column) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "pupil_type", "editable": true, "editor": pupil_type1718, "filter": { "type": "string" }, "header": "Participant Type", "renderer": Lino.fk_renderer('pupil_typeHidden','Lino.courses.PupilTypes.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.pupil_type) Pointer to PupilType.", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "section", "editable": true, "editor": section1719, "filter": { "type": "string" }, "header": "Section", "sortable": false, "tooltip": "(courses.PupilsByType.section) ", "width": Lino.chars2width(14) }, { "colIndex": 4, "dataIndex": "is_lfv", "editable": true, "filter": { "type": "boolean" }, "header": "LFV", "sortable": false, "tooltip": "(courses.PupilsByType.is_lfv) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 5, "dataIndex": "is_ckk", "editable": true, "filter": { "type": "boolean" }, "header": "CKK", "sortable": false, "tooltip": "(courses.PupilsByType.is_ckk) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 6, "dataIndex": "is_raviva", "editable": true, "filter": { "type": "boolean" }, "header": "Raviva", "sortable": false, "tooltip": "(courses.PupilsByType.is_raviva) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 7, "dataIndex": "member_until", "editable": true, "editor": member_until1723, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Mitglied bis", "sortable": true, "tooltip": "(courses.PupilsByType.member_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id1724, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "email", "editable": true, "editor": email1725, "filter": { "type": "string" }, "header": "e-mail address", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.email) The primary email address.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language1726, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.language) The language to use when communicating with this partner.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "url", "editable": true, "editor": url1727, "filter": { "type": "string" }, "header": "URL", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.url) ", "width": Lino.chars2width(22) }, { "colIndex": 12, "dataIndex": "phone", "editable": true, "editor": phone1728, "filter": { "type": "string" }, "header": "Phone", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.phone) The primary phone number.  Note that Lino does not ignore\nformatting characters in phone numbers when searching.  For\nexample, if you enter \"087/12.34.56\" as a phone number, then a\nsearch for phone number containing \"1234\" will not find it.", "width": Lino.chars2width(22) }, { "colIndex": 13, "dataIndex": "gsm", "editable": true, "editor": gsm1729, "filter": { "type": "string" }, "header": "GSM", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.gsm) The primary mobile phone number.", "width": Lino.chars2width(22) }, { "colIndex": 14, "dataIndex": "fax", "editable": true, "editor": fax1730, "filter": { "type": "string" }, "header": "Fax", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.fax) ", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "country", "editable": true, "editor": country1731, "filter": { "type": "string" }, "header": "Country", "hidden": true, "renderer": Lino.fk_renderer('countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.country) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "city", "editable": true, "editor": city1732, "filter": { "type": "string" }, "header": "City", "hidden": true, "renderer": Lino.fk_renderer('cityHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.city) A pointer to Place.", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "zip_code", "editable": true, "editor": zip_code1733, "filter": { "type": "string" }, "header": "Zip code", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.zip_code) ", "width": Lino.chars2width(12) }, { "colIndex": 18, "dataIndex": "region", "editable": true, "editor": region1734, "filter": { "type": "string" }, "header": "County", "hidden": true, "renderer": Lino.fk_renderer('regionHidden','Lino.countries.Places.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.region) ", "width": Lino.chars2width(21) }, { "colIndex": 19, "dataIndex": "addr1", "editable": true, "editor": addr11735, "filter": { "type": "string" }, "header": "Address line before street", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.addr1) Address line before street", "width": Lino.chars2width(22) }, { "colIndex": 20, "dataIndex": "street_prefix", "editable": true, "editor": street_prefix1736, "filter": { "type": "string" }, "header": "Street prefix", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street_prefix) Text to print before name of street, but to ignore for sorting.", "width": Lino.chars2width(22) }, { "colIndex": 21, "dataIndex": "street", "editable": true, "editor": street1737, "filter": { "type": "string" }, "header": "Street", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street) Name of street, without house number.", "width": Lino.chars2width(22) }, { "colIndex": 22, "dataIndex": "street_no", "editable": true, "editor": street_no1738, "filter": { "type": "string" }, "header": "No.", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street_no) House number.", "width": Lino.chars2width(12) }, { "colIndex": 23, "dataIndex": "street_box", "editable": true, "editor": street_box1739, "filter": { "type": "string" }, "header": "Box", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.street_box) Text to print after street nuber on the same line.", "width": Lino.chars2width(12) }, { "colIndex": 24, "dataIndex": "addr2", "editable": true, "editor": addr21740, "filter": { "type": "string" }, "header": "Address line after street", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.addr2) Address line to print below street line.", "width": Lino.chars2width(22) }, { "colIndex": 25, "dataIndex": "name", "editable": true, "editor": name1741, "filter": { "type": "string" }, "header": "Name", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.name) The full name of this partner. Used for alphabetic sorting.\nSubclasses may hide this field and fill it automatically,\ne.g. saving a Person will automatically set her\nname field to \"last_name, first_name\".", "width": Lino.chars2width(22) }, { "colIndex": 26, "dataIndex": "remarks", "editable": true, "editor": remarks1742, "filter": { "type": "string" }, "header": "Remarks", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.remarks) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "payment_term", "editable": true, "editor": payment_term1743, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.payment_term) The default payment term for sales invoices to this customer.", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "vat_regime", "editable": true, "editor": vat_regime1744, "filter": { "type": "string" }, "header": "VAT regime", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.vat_regime) The default VAT regime for         sales and purchases of this partner.", "width": Lino.chars2width(28) }, { "colIndex": 29, "dataIndex": "invoice_recipient", "editable": true, "editor": invoice_recipient1745, "filter": { "type": "string" }, "header": "Invoicing address", "hidden": true, "renderer": Lino.fk_renderer('invoice_recipientHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.invoice_recipient) Redirect to another partner all invoices which should go to this partner.", "width": Lino.chars2width(21) }, { "colIndex": 30, "dataIndex": "paper_type", "editable": true, "editor": paper_type1746, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.paper_type) ", "width": Lino.chars2width(21) }, { "colIndex": 31, "dataIndex": "title", "editable": true, "editor": title1747, "filter": { "type": "string" }, "header": "Title", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.title) An optional name prefix like \"Dr.\" or \"PhD\", used to specify a\nprofessional position or academic qualification.", "width": Lino.chars2width(22) }, { "colIndex": 32, "dataIndex": "first_name", "editable": true, "editor": first_name1748, "filter": { "type": "string" }, "header": "First name", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.first_name) The first name, also known as given name.", "width": Lino.chars2width(22) }, { "colIndex": 33, "dataIndex": "middle_name", "editable": true, "editor": middle_name1749, "filter": { "type": "string" }, "header": "Middle name", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.middle_name) A space-separated list of all middle names.", "width": Lino.chars2width(22) }, { "colIndex": 34, "dataIndex": "last_name", "editable": true, "editor": last_name1750, "filter": { "type": "string" }, "header": "Last name", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.last_name) The last name, also known as family name.", "width": Lino.chars2width(22) }, { "colIndex": 35, "dataIndex": "gender", "editable": true, "editor": gender1751, "filter": { "type": "string" }, "header": "Gender", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.gender) The sex of this person (male or female).", "width": Lino.chars2width(10) }, { "colIndex": 36, "dataIndex": "birth_date", "editable": true, "editor": birth_date1752, "filter": { "type": "string" }, "header": "Birth date", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.birth_date) Uncomplete dates are allowed, e.g. \n\"00.00.1980\" means \"some day in 1980\", \n\"00.07.1980\" means \"in July 1980\"\nor \"23.07.0000\" means \"on a 23th of July\".", "width": Lino.chars2width(13) }, { "colIndex": 37, "dataIndex": "national_id", "editable": true, "editor": national_id1753, "filter": { "type": "string" }, "header": "National ID", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.national_id) The SSIN. It is a nullable char field declared unique. It\nis not validated directly because that would cause problems\nwith legacy data where SSINs need manual control. See also\nBeIdCardHolderChecker.", "width": Lino.chars2width(22) }, { "colIndex": 38, "dataIndex": "birth_country", "editable": true, "editor": birth_country1754, "filter": { "type": "string" }, "header": "Birth country", "hidden": true, "renderer": Lino.fk_renderer('birth_countryHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.birth_country) ", "width": Lino.chars2width(21) }, { "colIndex": 39, "dataIndex": "birth_place", "editable": true, "editor": birth_place1755, "filter": { "type": "string" }, "header": "Birth place", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.birth_place) ", "width": Lino.chars2width(22) }, { "colIndex": 40, "dataIndex": "nationality", "editable": true, "editor": nationality1756, "filter": { "type": "string" }, "header": "Nationality", "hidden": true, "renderer": Lino.fk_renderer('nationalityHidden','Lino.countries.Countries.detail'), "sortable": false, "tooltip": "(courses.PupilsByType.nationality) The nationality. This is a pointer to\ncountries.Country which should\ncontain also entries for refugee statuses.", "width": Lino.chars2width(21) }, { "colIndex": 41, "dataIndex": "card_number", "editable": true, "editor": card_number1757, "filter": { "type": "string" }, "header": "eID card number", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_number) ", "width": Lino.chars2width(22) }, { "colIndex": 42, "dataIndex": "card_valid_from", "editable": true, "editor": card_valid_from1758, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "ID card valid from", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_valid_from) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 43, "dataIndex": "card_valid_until", "editable": true, "editor": card_valid_until1759, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "until", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_valid_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 44, "dataIndex": "card_type", "editable": true, "editor": card_type1760, "filter": { "type": "string" }, "header": "eID card type", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.card_type) ", "width": Lino.chars2width(25) }, { "colIndex": 45, "dataIndex": "card_issuer", "editable": true, "editor": card_issuer1761, "filter": { "type": "string" }, "header": "eID card issuer", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.card_issuer) The administration who issued this ID card.", "width": Lino.chars2width(22) }, { "colIndex": 46, "dataIndex": "noble_condition", "editable": true, "editor": noble_condition1762, "filter": { "type": "string" }, "header": "noble condition", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.noble_condition) The eventual noble condition of this person.", "width": Lino.chars2width(22) }, { "colIndex": 47, "dataIndex": "legacy_id", "editable": true, "editor": legacy_id1763, "filter": { "type": "string" }, "header": "Legacy ID", "hidden": true, "sortable": true, "tooltip": "(courses.PupilsByType.legacy_id) ", "width": Lino.chars2width(14) }, { "colIndex": 48, "dataIndex": "is_member", "editable": true, "filter": { "type": "boolean" }, "header": "Member", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.is_member) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 49, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 50, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 51, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 52, "dataIndex": "age", "editable": false, "header": "Age", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.age) ", "width": Lino.chars2width(31) }, { "colIndex": 53, "dataIndex": "mti_navigator", "editable": false, "header": "See as ", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.mti_navigator) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 54, "dataIndex": "debit_balance", "editable": false, "header": "Debit balance", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.debit_balance) ", "width": Lino.chars2width(13) }, { "colIndex": 55, "dataIndex": "eid_info", "editable": false, "header": "eID card", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.eid_info) ", "width": Lino.chars2width(31) }, { "colIndex": 56, "dataIndex": "image", "editable": false, "header": "image", "hidden": true, "sortable": false, "tooltip": "(courses.PupilsByType.image) ", "width": Lino.chars2width(31) } ];
    Lino.courses.PupilsByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilsByType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.print_labels = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "print_labels", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilsByType.insertPanel = Ext.extend(Lino.courses.Pupils.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/PupilsByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilsByType.detail;
    this.ls_insert_handler = Lino.courses.PupilsByType.insert;
    Lino.courses.PupilsByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilsByType.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.PupilsByType.insertPanel(p);
});
Lino.courses.PupilsByType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.PupilsByType.detailPanel = Ext.extend(Lino.courses.Pupils.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-arrow_join", "itemId": "merge_row", "menu_item_text": "Merge", "overflowText": "Merge", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Pupils.merge_row), "tooltip": "Merge this object into another object of same class." }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "create_excerpt1", "menu_item_text": "Payment reminder", "overflowText": "Payment reminder", "panel_btn_handler": Lino.row_action_handler('create_excerpt1','GET',null), "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Start an invoicing plan for this partner." }, { "auto_save": true, "iconCls": "x-tbar-book_link", "itemId": "due", "menu_item_text": "Debts", "overflowText": "Debts", "panel_btn_handler": Lino.row_action_handler('due','GET',null), "tooltip": "Debts" }, { "auto_save": true, "itemId": "show_invoice_partners", "menu_item_text": "Invoice senders", "overflowText": "Invoice senders", "panel_btn_handler": Lino.row_action_handler('show_invoice_partners','GET',null), "text": "Invoice senders" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/courses/PupilsByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.PupilsByType.detail;
    this.ls_insert_handler = Lino.courses.PupilsByType.insert;
    Lino.courses.PupilsByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.PupilsByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.PupilsByType.detailPanel(p);
});
Lino.courses.PupilsByType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.create_excerpt1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "create_excerpt1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.due = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "due", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.show_invoice_partners = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "show_invoice_partners", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Pupils.ParamsPanel({});
  return new Lino.courses.PupilsByType.GridPanel(p);
});
Lino.courses.PupilsByType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "ins_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "ins_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "del_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.read_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "POST", pk, "read_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_company = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "ins_company", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_teacher = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "del_teacher", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_partner = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "del_partner", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "ins_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "del_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.del_pupil = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "del_pupil", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.ins_person = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "GET", pk, "ins_person", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.PupilsByType.find_by_beid = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/PupilsByType", "POST", pk, "find_by_beid", params, Lino.beid_read_card_processor);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesByTopic
Lino.courses.CoursesByTopic.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesByTopic",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByTopic','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "overview" }, { "name": "weekdays_text" }, { "name": "times_text" }, { "name": "max_places", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "requested", "type": "int", "useNull": true }, { "name": "trying", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "name": "room" }, 'roomHidden', { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "line" }, 'lineHidden', { "name": "teacher" }, 'teacherHidden', { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "presences_box" }, { "name": "what_text" }, { "name": "duration" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTopic.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    var ww = this.containing_window;
    var overview_disp3579 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var weekdays_text_disp3580 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var times_text_disp3581 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var max_places3582 = new Ext.form.NumberField({ "selectOnFocus": true });
    var confirmed3583 = new Ext.form.NumberField({ "disabled": true });
    var free_places3584 = new Ext.form.NumberField({ "disabled": true });
    var requested3585 = new Ext.form.NumberField({ "disabled": true });
    var trying3586 = new Ext.form.NumberField({ "disabled": true });
    var id3587 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref3588 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date3589 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time3590 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date3591 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time3592 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user3593 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/user" }) }) });
    var every_unit3594 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3595 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday3596 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday3597 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday3598 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday3599 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday3600 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday3601 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday3602 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events3603 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var room3604 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/room" }) }) });
    var max_date3605 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var line3606 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/line" }) }) });
    var teacher3607 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/teacher" }) }) });
    var slot3608 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/slot" }) }) });
    var description3609 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3610 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3611 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark3612 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state3613 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var name3614 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until3615 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee3616 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/fee" }) }) });
    var payment_term3617 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/payment_term" }) }) });
    var paper_type3618 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByTopic/paper_type" }) }) });
    var workflow_buttons_disp3619 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3620 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp3621 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments3622 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp3623 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var presences_box_htmlbox3624 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var what_text_disp3625 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration3626 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    this.before_row_edit = function(record) {
      fee3616.setContextValue('line', record ? record.data['lineHidden'] : undefined);
      presences_box_htmlbox3624.refresh();
    };
    this.onRender = function(ct, position) {
      line3606.on('change',Lino.chooser_handler(fee3616,'line'));
      Lino.courses.CoursesByTopic.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(courses.CoursesByTopic.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "weekdays_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(courses.CoursesByTopic.weekdays_text) ", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "times_text", "editable": false, "header": "Times", "sortable": false, "tooltip": "(courses.CoursesByTopic.times_text) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "max_places", "editable": true, "editor": max_places3582, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "sortable": true, "tooltip": "(courses.CoursesByTopic.max_places) Maximum number of participants", "width": Lino.chars2width(9) }, { "align": "right", "colIndex": 4, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "sortable": false, "tooltip": "(courses.CoursesByTopic.confirmed) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 5, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "sortable": false, "tooltip": "(courses.CoursesByTopic.free_places) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 6, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "sortable": false, "tooltip": "(courses.CoursesByTopic.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 7, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "sortable": false, "tooltip": "(courses.CoursesByTopic.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id3587, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "ref", "editable": true, "editor": ref3588, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 10, "dataIndex": "start_date", "editable": true, "editor": start_date3589, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "start_time", "editable": true, "editor": start_time3590, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 12, "dataIndex": "end_date", "editable": true, "editor": end_date3591, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 13, "dataIndex": "end_time", "editable": true, "editor": end_time3592, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 14, "dataIndex": "user", "editable": true, "editor": user3593, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "every_unit", "editable": true, "editor": every_unit3594, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 16, "dataIndex": "every", "editable": true, "editor": every3595, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.every) ", "width": Lino.chars2width(6) }, { "colIndex": 17, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 21, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 23, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 24, "dataIndex": "max_events", "editable": true, "editor": max_events3603, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 25, "dataIndex": "room", "editable": true, "editor": room3604, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.room) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "max_date", "editable": true, "editor": max_date3605, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 27, "dataIndex": "line", "editable": true, "editor": line3606, "filter": { "type": "string" }, "header": "Activity line", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.line) Pointer to the course series.", "width": Lino.chars2width(21) }, { "colIndex": 28, "dataIndex": "teacher", "editable": true, "editor": teacher3607, "filter": { "type": "string" }, "header": "Instructor", "hidden": true, "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.teacher) ", "width": Lino.chars2width(21) }, { "colIndex": 29, "dataIndex": "slot", "editable": true, "editor": slot3608, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 30, "dataIndex": "description", "editable": true, "editor": description3609, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description) ", "width": Lino.chars2width(61) }, { "colIndex": 31, "dataIndex": "description_de", "editable": true, "editor": description_de3610, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 32, "dataIndex": "description_fr", "editable": true, "editor": description_fr3611, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 33, "dataIndex": "remark", "editable": true, "editor": remark3612, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 34, "dataIndex": "state", "editable": true, "editor": state3613, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "colIndex": 35, "dataIndex": "name", "editable": true, "editor": name3614, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 36, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until3615, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByTopic.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 37, "dataIndex": "fee", "editable": true, "editor": fee3616, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesByTopic.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 38, "dataIndex": "payment_term", "editable": true, "editor": payment_term3617, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 39, "dataIndex": "paper_type", "editable": true, "editor": paper_type3618, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 40, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 41, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 42, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 44, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.print_actions) ", "width": Lino.chars2width(31) }, { "colIndex": 45, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.presences_box) ", "width": Lino.chars2width(31) }, { "colIndex": 46, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 47, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByTopic.duration) ", "width": Lino.chars2width(8) } ];
    Lino.courses.CoursesByTopic.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTopic.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByTopic.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesByTopic",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByTopic.detail;
    this.ls_insert_handler = Lino.courses.Activities.insert;
    Lino.courses.CoursesByTopic.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByTopic.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesByTopic.detailPanel(p);
});
Lino.courses.CoursesByTopic.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.CoursesByTopic.ParamsPanel({});
  return new Lino.courses.CoursesByTopic.GridPanel(p);
});
Lino.courses.CoursesByTopic.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByTopic.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByTopic", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.CoursesByLine
Lino.courses.CoursesByLine.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/CoursesByLine",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CoursesByLine','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Activities",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 59,
  ls_store_fields : [ { "name": "overview" }, { "name": "weekdays_text" }, { "name": "room" }, 'roomHidden', { "name": "times_text" }, { "name": "teacher" }, 'teacherHidden', { "name": "id", "type": "int" }, { "name": "ref" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "user" }, 'userHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "monday", "type": "boolean" }, { "name": "tuesday", "type": "boolean" }, { "name": "wednesday", "type": "boolean" }, { "name": "thursday", "type": "boolean" }, { "name": "friday", "type": "boolean" }, { "name": "saturday", "type": "boolean" }, { "name": "sunday", "type": "boolean" }, { "name": "max_events", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "max_date", "type": "date" }, { "name": "slot" }, 'slotHidden', { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "remark" }, { "name": "state" }, 'stateHidden', { "name": "max_places", "type": "int", "useNull": true }, { "name": "name" }, { "dateFormat": "d.m.Y", "name": "enrolments_until", "type": "date" }, { "name": "fee" }, 'feeHidden', { "name": "payment_term" }, 'payment_termHidden', { "name": "paper_type" }, 'paper_typeHidden', { "name": "workflow_buttons" }, { "name": "description_column" }, { "name": "events_text" }, { "name": "enrolments" }, { "name": "print_actions" }, { "name": "requested", "type": "int", "useNull": true }, { "name": "confirmed", "type": "int", "useNull": true }, { "name": "presences_box" }, { "name": "trying", "type": "int", "useNull": true }, { "name": "free_places", "type": "int", "useNull": true }, { "name": "what_text" }, { "name": "duration" }, { "name": "line" }, 'lineHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 52,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByLine.detail;
    this.ls_insert_handler = Lino.courses.CoursesByLine.insert;
    var ww = this.containing_window;
    var overview_disp3093 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var weekdays_text_disp3094 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var room3095 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/room" }) }) });
    var times_text_disp3096 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var teacher3097 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Instructor...", "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/teacher" }) }) });
    var id3098 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var ref3099 = new Ext.form.TextField({ "hidden": true, "maxLength": 40, "preferred_with": 6, "selectOnFocus": true });
    var start_date3100 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time3101 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date3102 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time3103 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var user3104 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/user" }) }) });
    var every_unit3105 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3106 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var monday3107 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var tuesday3108 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var wednesday3109 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var thursday3110 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var friday3111 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var saturday3112 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var sunday3113 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var max_events3114 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var max_date3115 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var slot3116 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Timetable Slot...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/slot" }) }) });
    var description3117 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3118 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3119 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var remark3120 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var state3121 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.CourseStates });
    var max_places3122 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var name3123 = new Ext.form.TextField({ "hidden": true, "maxLength": 100, "selectOnFocus": true });
    var enrolments_until3124 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var fee3125 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/fee" }) }) });
    var payment_term3126 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Payment Term...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/payment_term" }) }) });
    var paper_type3127 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Paper type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/paper_type" }) }) });
    var workflow_buttons_disp3128 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3129 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var events_text_disp3130 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var enrolments3131 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var print_actions_disp3132 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var requested3133 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var confirmed3134 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var presences_box_htmlbox3135 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "presences_box", "title": "Presences", "value": "<br/>" });
    var trying3136 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var free_places3137 = new Ext.form.NumberField({ "disabled": true, "hidden": true });
    var what_text_disp3138 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration3139 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var line3140 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity line...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/CoursesByLine/line" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      fee3125.setContextValue('mk',bp['mk']);
      fee3125.setContextValue('mt',bp['mt']);
      presences_box_htmlbox3135.refresh();
    };
    this.onRender = function(ct, position) {
      line3140.on('change',Lino.chooser_handler(fee3125,'line'));
      Lino.courses.CoursesByLine.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "overview", "editable": false, "header": "Description", "sortable": false, "tooltip": "(courses.CoursesByLine.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "weekdays_text", "editable": false, "header": "When", "sortable": false, "tooltip": "(courses.CoursesByLine.weekdays_text) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "room", "editable": true, "editor": room3095, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.CoursesByLine.room) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "times_text", "editable": false, "header": "Times", "sortable": false, "tooltip": "(courses.CoursesByLine.times_text) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "teacher", "editable": true, "editor": teacher3097, "filter": { "type": "string" }, "header": "Instructor", "renderer": Lino.fk_renderer('teacherHidden','Lino.courses.Teachers.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.teacher) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id3098, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "ref", "editable": true, "editor": ref3099, "filter": { "type": "string" }, "header": "Reference", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.ref) An identifying public course number to be used by both\nexternal and internal partners for easily referring to a given\ncourse.", "width": Lino.chars2width(22) }, { "colIndex": 7, "dataIndex": "start_date", "editable": true, "editor": start_date3100, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "start_time", "editable": true, "editor": start_time3101, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 9, "dataIndex": "end_date", "editable": true, "editor": end_date3102, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_time", "editable": true, "editor": end_time3103, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.end_time) ", "width": Lino.chars2width(9) }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user3104, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "every_unit", "editable": true, "editor": every_unit3105, "filter": { "type": "string" }, "header": "Recurrency", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 13, "dataIndex": "every", "editable": true, "editor": every3106, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.every) ", "width": Lino.chars2width(6) }, { "colIndex": 14, "dataIndex": "monday", "editable": true, "filter": { "type": "boolean" }, "header": "Monday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.monday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 15, "dataIndex": "tuesday", "editable": true, "filter": { "type": "boolean" }, "header": "Tuesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.tuesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 16, "dataIndex": "wednesday", "editable": true, "filter": { "type": "boolean" }, "header": "Wednesday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.wednesday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 17, "dataIndex": "thursday", "editable": true, "filter": { "type": "boolean" }, "header": "Thursday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.thursday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 18, "dataIndex": "friday", "editable": true, "filter": { "type": "boolean" }, "header": "Friday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.friday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 19, "dataIndex": "saturday", "editable": true, "filter": { "type": "boolean" }, "header": "Saturday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.saturday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 20, "dataIndex": "sunday", "editable": true, "filter": { "type": "boolean" }, "header": "Sunday", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.sunday) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "align": "right", "colIndex": 21, "dataIndex": "max_events", "editable": true, "editor": max_events3114, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.max_events) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "max_date", "editable": true, "editor": max_date3115, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Generate events until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.max_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 23, "dataIndex": "slot", "editable": true, "editor": slot3116, "filter": { "type": "string" }, "header": "Timetable Slot", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.slot) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "description", "editable": true, "editor": description3117, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description) ", "width": Lino.chars2width(61) }, { "colIndex": 25, "dataIndex": "description_de", "editable": true, "editor": description_de3118, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 26, "dataIndex": "description_fr", "editable": true, "editor": description_fr3119, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 27, "dataIndex": "remark", "editable": true, "editor": remark3120, "filter": { "type": "string" }, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.remark) ", "width": Lino.chars2width(61) }, { "colIndex": 28, "dataIndex": "state", "editable": true, "editor": state3121, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.state) The ChoiceList of the state field must have at least two items\nnamed \"draft\" and \"registered\".\nThere may be additional states.\nEvery state must have an extra attribute \"editable\".", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 29, "dataIndex": "max_places", "editable": true, "editor": max_places3122, "filter": { "type": "numeric" }, "format": "0", "header": "Available places", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.max_places) Maximum number of participants", "width": Lino.chars2width(6) }, { "colIndex": 30, "dataIndex": "name", "editable": true, "editor": name3123, "filter": { "type": "string" }, "header": "Designation", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.name) A short designation for this course. An extension of the\nref.", "width": Lino.chars2width(22) }, { "colIndex": 31, "dataIndex": "enrolments_until", "editable": true, "editor": enrolments_until3124, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Enrolments until", "hidden": true, "sortable": true, "tooltip": "(courses.CoursesByLine.enrolments_until) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 32, "dataIndex": "fee", "editable": true, "editor": fee3125, "filter": { "type": "string" }, "header": "Default participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.fee) The default participation fee to apply for new enrolments.", "width": Lino.chars2width(21) }, { "colIndex": 33, "dataIndex": "payment_term", "editable": true, "editor": payment_term3126, "filter": { "type": "string" }, "header": "Payment Term", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.payment_term) The payment term to use when writing an invoice. If this is\nempty, Lino will use the partner's default payment term.", "width": Lino.chars2width(21) }, { "colIndex": 34, "dataIndex": "paper_type", "editable": true, "editor": paper_type3127, "filter": { "type": "string" }, "header": "Paper type", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.paper_type) The paper_type to use when writing an invoice. If this is\nempty, Lino will use the site's default paper type.", "width": Lino.chars2width(21) }, { "colIndex": 35, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 36, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 37, "dataIndex": "events_text", "editable": false, "header": "Events", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.events_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 38, "dataIndex": "enrolments", "editable": false, "format": "0", "header": "Enrolments", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.enrolments) ", "width": Lino.chars2width(6) }, { "colIndex": 39, "dataIndex": "print_actions", "editable": false, "header": "Print", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.print_actions) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 40, "dataIndex": "requested", "editable": false, "format": "0", "header": "Requested", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.requested) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 41, "dataIndex": "confirmed", "editable": false, "format": "0", "header": "Confirmed", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.confirmed) ", "width": Lino.chars2width(6) }, { "colIndex": 42, "dataIndex": "presences_box", "editable": false, "header": "Presences", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.presences_box) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 43, "dataIndex": "trying", "editable": false, "format": "0", "header": "Trying", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.trying) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 44, "dataIndex": "free_places", "editable": false, "format": "0", "header": "Free places", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.free_places) ", "width": Lino.chars2width(6) }, { "colIndex": 45, "dataIndex": "what_text", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.what_text) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 46, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.CoursesByLine.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 47, "dataIndex": "line", "editable": true, "editor": line3140, "filter": { "type": "string" }, "header": "Activity line", "hidden": true, "renderer": Lino.fk_renderer('lineHidden','Lino.courses.Lines.detail'), "sortable": false, "tooltip": "(courses.CoursesByLine.line) Pointer to the course series.", "width": Lino.chars2width(21) } ];
    Lino.courses.CoursesByLine.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByLine.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByLine.insertPanel = Ext.extend(Lino.courses.Activities.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/CoursesByLine",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByLine.detail;
    this.ls_insert_handler = Lino.courses.CoursesByLine.insert;
    Lino.courses.CoursesByLine.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByLine.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.CoursesByLine.insertPanel(p);
});
Lino.courses.CoursesByLine.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.CoursesByLine.detailPanel = Ext.extend(Lino.courses.Activities.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt3", "menu_item_text": "Overview", "overflowText": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": "Overview", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet_html", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet (HTML)", "overflowText": "Presence sheet (HTML)", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet_html), "text": "Presence sheet (HTML)" }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Presence sheet", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt11", "menu_item_text": "Payment list", "overflowText": "Payment list", "panel_btn_handler": Lino.row_action_handler('create_excerpt11','GET',null), "text": "Payment list", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "print_presence_sheet", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Print using a hard-coded template and without cache.") }, "menu_item_text": "Presence sheet", "overflowText": "Presence sheet", "panel_btn_handler": Lino.param_action_handler(Lino.courses.Activities.print_presence_sheet), "text": "Presence sheet" } ], "menu_item_text": "Overview", "panel_btn_handler": Lino.row_action_handler('create_excerpt3','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-basket", "itemId": "start_invoicing", "menu_item_text": "Create invoices", "overflowText": "Create invoices", "panel_btn_handler": Lino.row_action_handler('start_invoicing','POST',null), "tooltip": "Base for StartInvoicingForJournal,\nStartInvoicingForPartner." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "auto_save": true, "itemId": "do_update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('do_update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/CoursesByLine",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.CoursesByLine.detail;
    this.ls_insert_handler = Lino.courses.CoursesByLine.insert;
    Lino.courses.CoursesByLine.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CoursesByLine.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CoursesByLine.detailPanel(p);
});
Lino.courses.CoursesByLine.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.create_excerpt3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "create_excerpt3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.create_excerpt11 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "create_excerpt11", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.start_invoicing = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "POST", pk, "start_invoicing", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Activities.ParamsPanel({});
  return new Lino.courses.CoursesByLine.GridPanel(p);
});
Lino.courses.CoursesByLine.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.do_update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "do_update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CoursesByLine.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CoursesByLine", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.LinesByType
Lino.courses.LinesByType.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/LinesByType",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/LinesByType','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Activity lines",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 41,
  ls_store_fields : [ { "name": "ref" }, { "name": "name" }, { "name": "name_de" }, { "name": "name_fr" }, { "name": "topic" }, 'topicHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "event_type" }, 'event_typeHidden', { "name": "guest_role" }, 'guest_roleHidden', { "name": "every_unit" }, 'every_unitHidden', { "name": "every", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "excerpt_title" }, { "name": "excerpt_title_de" }, { "name": "excerpt_title_fr" }, { "name": "description" }, { "name": "description_de" }, { "name": "description_fr" }, { "name": "fee" }, 'feeHidden', { "name": "options_cat" }, 'options_catHidden', { "name": "fees_cat" }, 'fees_catHidden', { "name": "body_template" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "course_type" }, 'course_typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 15,
  ls_grid_configs : [  ],
  content_type : 57,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByType.detail;
    this.ls_insert_handler = Lino.courses.LinesByType.insert;
    var ww = this.containing_window;
    var ref3015 = new Ext.form.TextField({ "maxLength": 40, "selectOnFocus": true });
    var name3016 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 200, "selectOnFocus": true });
    var name_de3017 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var name_fr3018 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var topic3019 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Topic...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/topic" }) }) });
    var course_area3020 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.courses.CourseAreas });
    var event_type3021 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/event_type" }) }) });
    var guest_role3022 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Guest Role...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/guest_role" }) }) });
    var every_unit3023 = new Lino.ChoicesFieldElement({ "forceSelection": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.Recurrencies) });
    var every3024 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var id3025 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var company3026 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/company" }) }) });
    var contact_person3027 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/contact_person" }) }) });
    var contact_role3028 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/contact_role" }) }) });
    var excerpt_title3029 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_de3030 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var excerpt_title_fr3031 = new Ext.form.TextField({ "hidden": true, "maxLength": 200, "selectOnFocus": true });
    var description3032 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_de3033 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var description_fr3034 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var fee3035 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/fee" }) }) });
    var options_cat3036 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/options_cat" }) }) });
    var fees_cat3037 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff Category...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/fees_cat" }) }) });
    var body_template3038 = new Lino.SimpleRemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/body_template" }) }) });
    var workflow_buttons_disp3039 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp3040 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp3041 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course_type3042 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Activity type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/LinesByType/course_type" }) }) });
    this.before_row_edit = function(record) {
      contact_person3027.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      fee3035.setContextValue('fees_cat', record ? record.data['fees_catHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company3026.on('change',Lino.chooser_handler(contact_person3027,'company'));
      fees_cat3037.on('change',Lino.chooser_handler(fee3035,'fees_cat'));
      Lino.courses.LinesByType.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": true, "editor": ref3015, "filter": { "type": "string" }, "header": "Reference", "sortable": true, "tooltip": "(courses.LinesByType.ref) The reference. This must be either empty or unique.", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": true, "editor": name3016, "filter": { "type": "string" }, "header": "Designation", "sortable": true, "tooltip": "(courses.LinesByType.name) The designation of this activity line as seen by the user\ne.g. when selecting the line.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "name_de", "editable": true, "editor": name_de3017, "filter": { "type": "string" }, "header": "Designation (de)", "sortable": true, "tooltip": "(courses.LinesByType.name_de) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "name_fr", "editable": true, "editor": name_fr3018, "filter": { "type": "string" }, "header": "Designation (fr)", "sortable": true, "tooltip": "(courses.LinesByType.name_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "topic", "editable": true, "editor": topic3019, "filter": { "type": "string" }, "header": "Topic", "sortable": false, "tooltip": "(courses.LinesByType.topic) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "course_area", "editable": true, "editor": course_area3020, "filter": { "type": "string" }, "header": "Layout", "sortable": false, "tooltip": "(courses.LinesByType.course_area) Pointer to CourseAreas.  This is used only when an\napplication defines several variants of\nEnrolmentsByPupil.", "width": Lino.chars2width(14) }, { "colIndex": 6, "dataIndex": "event_type", "editable": true, "editor": event_type3021, "filter": { "type": "string" }, "header": "Calendar entry type", "sortable": false, "tooltip": "(courses.LinesByType.event_type) The type of calendar events to be generated. If this is empty, no calendar events will be generated.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "guest_role", "editable": true, "editor": guest_role3022, "filter": { "type": "string" }, "header": "Manage presences as", "renderer": Lino.fk_renderer('guest_roleHidden','Lino.cal.GuestRoles.detail'), "sortable": false, "tooltip": "(courses.LinesByType.guest_role) The default guest role for particpants of events for courses in this series. Leave empty if you don't want any presence management.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "every_unit", "editable": true, "editor": every_unit3023, "filter": { "type": "string" }, "header": "Recurrency", "sortable": false, "tooltip": "(courses.LinesByType.every_unit) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 9, "dataIndex": "every", "editable": true, "editor": every3024, "filter": { "type": "numeric" }, "format": "0", "header": "Repeat every", "sortable": true, "tooltip": "(courses.LinesByType.every) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 10, "dataIndex": "id", "editable": true, "editor": id3025, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.id) ", "width": Lino.chars2width(6) }, { "colIndex": 11, "dataIndex": "company", "editable": true, "editor": company3026, "filter": { "type": "string" }, "header": "Company", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(courses.LinesByType.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "contact_person", "editable": true, "editor": contact_person3027, "filter": { "type": "string" }, "header": "represented by", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(courses.LinesByType.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "contact_role", "editable": true, "editor": contact_role3028, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "excerpt_title", "editable": true, "editor": excerpt_title3029, "filter": { "type": "string" }, "header": "Excerpt title", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.excerpt_title) The title to be used when printing an excerpt.", "width": Lino.chars2width(22) }, { "colIndex": 15, "dataIndex": "excerpt_title_de", "editable": true, "editor": excerpt_title_de3030, "filter": { "type": "string" }, "header": "Excerpt title (de)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.excerpt_title_de) ", "width": Lino.chars2width(22) }, { "colIndex": 16, "dataIndex": "excerpt_title_fr", "editable": true, "editor": excerpt_title_fr3031, "filter": { "type": "string" }, "header": "Excerpt title (fr)", "hidden": true, "sortable": true, "tooltip": "(courses.LinesByType.excerpt_title_fr) ", "width": Lino.chars2width(22) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description3032, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description) ", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "description_de", "editable": true, "editor": description_de3033, "filter": { "type": "string" }, "header": "Description (de)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description_de) ", "width": Lino.chars2width(61) }, { "colIndex": 19, "dataIndex": "description_fr", "editable": true, "editor": description_fr3034, "filter": { "type": "string" }, "header": "Description (fr)", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description_fr) ", "width": Lino.chars2width(61) }, { "colIndex": 20, "dataIndex": "fee", "editable": true, "editor": fee3035, "filter": { "type": "string" }, "header": "Participation fee", "hidden": true, "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.LinesByType.fee) ", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "options_cat", "editable": true, "editor": options_cat3036, "filter": { "type": "string" }, "header": "Options category", "hidden": true, "renderer": Lino.fk_renderer('options_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByType.options_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 22, "dataIndex": "fees_cat", "editable": true, "editor": fees_cat3037, "filter": { "type": "string" }, "header": "Fees category", "hidden": true, "renderer": Lino.fk_renderer('fees_catHidden','Lino.products.ProductCats.detail'), "sortable": false, "tooltip": "(courses.LinesByType.fees_cat) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "body_template", "editable": true, "editor": body_template3038, "filter": { "type": "string" }, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.body_template) The body template to use when printing a course of this series. Leave empty to use the site's default.", "width": Lino.chars2width(11) }, { "colIndex": 24, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 25, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.LinesByType.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "course_type", "editable": true, "editor": course_type3042, "filter": { "type": "string" }, "header": "Activity type", "hidden": true, "renderer": Lino.fk_renderer('course_typeHidden','Lino.courses.CourseTypes.detail'), "sortable": false, "tooltip": "(courses.LinesByType.course_type) ", "width": Lino.chars2width(21) } ];
    Lino.courses.LinesByType.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByType.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByType.insertPanel = Ext.extend(Lino.courses.Lines.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/LinesByType",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByType.detail;
    this.ls_insert_handler = Lino.courses.LinesByType.insert;
    Lino.courses.LinesByType.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByType.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(16), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.LinesByType.insertPanel(p);
});
Lino.courses.LinesByType.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.LinesByType.detailPanel = Ext.extend(Lino.courses.Lines.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/courses/LinesByType",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.LinesByType.detail;
    this.ls_insert_handler = Lino.courses.LinesByType.insert;
    Lino.courses.LinesByType.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.LinesByType.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByType.detailPanel(p);
});
Lino.courses.LinesByType.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.LinesByType.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.LinesByType.GridPanel(p);
});
Lino.courses.LinesByType.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/LinesByType", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsAndPaymentsByCourse
Lino.courses.EnrolmentsAndPaymentsByCourse.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsAndPaymentsByCourse",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsAndPaymentsByCourse','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "pupil_info" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "invoicing_info" }, { "name": "payment_info" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.insert;
    var ww = this.containing_window;
    var pupil_info_htmlbox6933 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var start_date6934 = new Lino.DateField({ "selectOnFocus": true });
    var invoicing_info_disp6935 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payment_info_disp6936 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
      pupil_info_htmlbox6933.refresh();
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "sortable": false, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "start_date", "editable": true, "editor": start_date6934, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "sortable": false, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "sortable": false, "tooltip": "(courses.EnrolmentsAndPaymentsByCourse.payment_info) ", "width": Lino.chars2width(31) } ];
    Lino.courses.EnrolmentsAndPaymentsByCourse.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsAndPaymentsByCourse.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsAndPaymentsByCourse.insertPanel = Ext.extend(Lino.courses.Enrolments.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsAndPaymentsByCourse",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.insert;
    Lino.courses.EnrolmentsAndPaymentsByCourse.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsAndPaymentsByCourse.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsAndPaymentsByCourse.insertPanel(p);
});
Lino.courses.EnrolmentsAndPaymentsByCourse.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsAndPaymentsByCourse.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsAndPaymentsByCourse",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsAndPaymentsByCourse.insert;
    Lino.courses.EnrolmentsAndPaymentsByCourse.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsAndPaymentsByCourse.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsAndPaymentsByCourse.detailPanel(p);
});
Lino.courses.EnrolmentsAndPaymentsByCourse.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsAndPaymentsByCourse.GridPanel(p);
});
Lino.courses.EnrolmentsAndPaymentsByCourse.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsAndPaymentsByCourse.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsAndPaymentsByCourse", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByHike
Lino.courses.EnrolmentsByHike.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByHike",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByHike','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil" }, 'pupilHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "fee" }, 'feeHidden', { "name": "option" }, 'optionHidden', { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "confirmation_details" }, { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "course" }, 'courseHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByHike.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByHike.insert;
    var ww = this.containing_window;
    var request_date6938 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil6939 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/pupil" }) }) });
    var places6940 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6941 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var fee6942 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/fee" }) }) });
    var option6943 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/option" }) }) });
    var amount6944 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6945 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6946 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date6947 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date6948 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user6949 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/user" }) }) });
    var printed_by6950 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6951 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6952 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var confirmation_details6953 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var free_events6954 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6955 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp6956 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6957 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6958 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6959 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6960 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course6961 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByHike/course" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil6939.setContextValue('mk',bp['mk']);
      pupil6939.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      fee6942.setContextValue('mk',bp['mk']);
      fee6942.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option6943.setContextValue('mk',bp['mk']);
      option6943.setContextValue('mt',bp['mt']);
      pupil_info_htmlbox6955.refresh();
      course6961.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6961.setContextValue('request_date', record ? record.data['request_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      course6961.on('change',Lino.chooser_handler(pupil6939,'course'));
      course6961.on('change',Lino.chooser_handler(fee6942,'course'));
      course6961.on('change',Lino.chooser_handler(option6943,'course'));
      course_area6951.on('change',Lino.chooser_handler(course6961,'course_area'));
      request_date6938.on('change',Lino.chooser_handler(course6961,'request_date'));
      Lino.courses.EnrolmentsByHike.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6938, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil6939, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.pupil) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "places", "editable": true, "editor": places6940, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.places) The number of participants in this enrolment.", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark6941, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "fee", "editable": true, "editor": fee6942, "filter": { "type": "string" }, "header": "Tariff", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "option", "editable": true, "editor": option6943, "filter": { "type": "string" }, "header": "Option", "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.option) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "amount", "editable": true, "editor": amount6944, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(courses.EnrolmentsByHike.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.EnrolmentsByHike.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id6946, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "start_date", "editable": true, "editor": start_date6947, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date6948, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6949, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6952, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6953, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 16, "dataIndex": "free_events", "editable": true, "editor": free_events6954, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByHike.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByHike.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "course", "editable": true, "editor": course6961, "filter": { "type": "string" }, "header": "Activity", "hidden": true, "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByHike.course) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByHike.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByHike.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByHike.insertPanel = Ext.extend(Lino.courses.EnrolmentsByHike.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsByHike",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByHike.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByHike.insert;
    Lino.courses.EnrolmentsByHike.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByHike.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByHike.insertPanel(p);
});
Lino.courses.EnrolmentsByHike.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByHike.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByHike",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByHike.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByHike.insert;
    Lino.courses.EnrolmentsByHike.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByHike.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByHike.detailPanel(p);
});
Lino.courses.EnrolmentsByHike.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByHike.GridPanel(p);
});
Lino.courses.EnrolmentsByHike.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByHike.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByHike", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EnrolmentsByJourney
Lino.courses.EnrolmentsByJourney.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EnrolmentsByJourney",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EnrolmentsByJourney','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  cell_edit : true,
  title : "Enrolments",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 33,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "request_date", "type": "date" }, { "name": "pupil" }, 'pupilHidden', { "name": "places", "type": "int", "useNull": true }, { "name": "remark" }, { "name": "fee" }, 'feeHidden', { "name": "option" }, 'optionHidden', { "name": "amount" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "user" }, 'userHidden', { "name": "printed_by" }, 'printed_byHidden', { "name": "course_area" }, 'course_areaHidden', { "name": "state" }, 'stateHidden', { "name": "confirmation_details" }, { "name": "free_events", "type": "int", "useNull": true }, { "name": "pupil_info" }, { "name": "payment_info" }, { "name": "invoicing_info" }, { "name": "overview" }, { "name": "description_column" }, { "name": "printed" }, { "name": "course" }, 'courseHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 53,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByJourney.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByJourney.insert;
    var ww = this.containing_window;
    var request_date6963 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var pupil6964 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Participant...", "forceSelection": false, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/pupil" }) }) });
    var places6965 = new Ext.form.NumberField({ "allowBlank": false, "selectOnFocus": true, "value": 1 });
    var remark6966 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var fee6967 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/fee" }) }) });
    var option6968 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/option" }) }) });
    var amount6969 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "selectOnFocus": true });
    var workflow_buttons_disp6970 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id6971 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var start_date6972 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_date6973 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var user6974 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/user" }) }) });
    var printed_by6975 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Excerpt...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var course_area6976 = new Lino.ChoicesFieldElement({ "disabled": true, "forceSelection": true, "hidden": true, "store": [['','<br>']].concat(Lino.courses.CourseAreas) });
    var state6977 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.courses.EnrolmentStates });
    var confirmation_details6978 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var free_events6979 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var pupil_info_htmlbox6980 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "pupil_info", "title": "Participant", "value": "<br/>" });
    var payment_info_disp6981 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoicing_info_disp6982 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6983 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp6984 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var printed_disp6985 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var course6986 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Activity...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EnrolmentsByJourney/course" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      pupil6964.setContextValue('mk',bp['mk']);
      pupil6964.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      fee6967.setContextValue('mk',bp['mk']);
      fee6967.setContextValue('mt',bp['mt']);
      var bp = this.get_base_params();
      option6968.setContextValue('mk',bp['mk']);
      option6968.setContextValue('mt',bp['mt']);
      pupil_info_htmlbox6980.refresh();
      course6986.setContextValue('course_area', record ? record.data['course_areaHidden'] : undefined);
      course6986.setContextValue('request_date', record ? record.data['request_date'] : undefined);
    };
    this.onRender = function(ct, position) {
      course6986.on('change',Lino.chooser_handler(pupil6964,'course'));
      course6986.on('change',Lino.chooser_handler(fee6967,'course'));
      course6986.on('change',Lino.chooser_handler(option6968,'course'));
      course_area6976.on('change',Lino.chooser_handler(course6986,'course_area'));
      request_date6963.on('change',Lino.chooser_handler(course6986,'request_date'));
      Lino.courses.EnrolmentsByJourney.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "request_date", "editable": true, "editor": request_date6963, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date of request", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.request_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "pupil", "editable": true, "editor": pupil6964, "filter": { "type": "string" }, "header": "Participant", "renderer": Lino.fk_renderer('pupilHidden','Lino.courses.Pupils.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.pupil) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 2, "dataIndex": "places", "editable": true, "editor": places6965, "filter": { "type": "numeric" }, "format": "0", "header": "Places used", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.places) The number of participants in this enrolment.", "width": Lino.chars2width(9) }, { "colIndex": 3, "dataIndex": "remark", "editable": true, "editor": remark6966, "filter": { "type": "string" }, "header": "Remark", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.remark) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "fee", "editable": true, "editor": fee6967, "filter": { "type": "string" }, "header": "Tariff", "renderer": Lino.fk_renderer('feeHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.fee) The participation fee to apply for this enrolment.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "option", "editable": true, "editor": option6968, "filter": { "type": "string" }, "header": "Option", "renderer": Lino.fk_renderer('optionHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.option) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "amount", "editable": true, "editor": amount6969, "filter": { "type": "numeric" }, "header": "Amount", "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.amount) The total amount to pay for this enrolment. This is\nplaces * fee.", "width": Lino.chars2width(13) }, { "colIndex": 7, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 8, "dataIndex": "id", "editable": true, "editor": id6971, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.id) ", "width": Lino.chars2width(6) }, { "colIndex": 9, "dataIndex": "start_date", "editable": true, "editor": start_date6972, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date6973, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End date", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "user", "editable": true, "editor": user6974, "filter": { "type": "string" }, "header": "Author", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "printed_by", "editable": false, "filter": { "type": "string" }, "header": "Printed", "hidden": true, "renderer": Lino.fk_renderer('printed_byHidden','Lino.excerpts.Excerpts.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.printed_by) ForeignKey to the Excerpt which certifies this instance.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "course_area", "editable": false, "filter": { "type": "string" }, "header": "Layout", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.course_area) ", "width": Lino.chars2width(14) }, { "colIndex": 14, "dataIndex": "state", "editable": true, "editor": state6977, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.state) One of lino_xl.lib.courses.choicelists.EnrolmentStates.", "width": Lino.chars2width(13) }, { "colIndex": 15, "dataIndex": "confirmation_details", "editable": true, "editor": confirmation_details6978, "filter": { "type": "string" }, "header": "Confirmation details", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.confirmation_details) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 16, "dataIndex": "free_events", "editable": true, "editor": free_events6979, "filter": { "type": "numeric" }, "format": "0", "header": "Free events", "hidden": true, "sortable": true, "tooltip": "(courses.EnrolmentsByJourney.free_events) Number of events to add for first invoicing for this enrolment.", "width": Lino.chars2width(6) }, { "colIndex": 17, "dataIndex": "pupil_info", "editable": false, "header": "Participant", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.pupil_info) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "payment_info", "editable": false, "header": "Payment info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.payment_info) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "invoicing_info", "editable": false, "header": "Invoicing info", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.invoicing_info) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 22, "dataIndex": "printed", "editable": false, "header": "Printed", "hidden": true, "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.printed) ", "width": Lino.chars2width(31) }, { "colIndex": 23, "dataIndex": "course", "editable": true, "editor": course6986, "filter": { "type": "string" }, "header": "Activity", "hidden": true, "renderer": Lino.fk_renderer('courseHidden','Lino.courses.Activities.detail'), "sortable": false, "tooltip": "(courses.EnrolmentsByJourney.course) ", "width": Lino.chars2width(21) } ];
    Lino.courses.EnrolmentsByJourney.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByJourney.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByJourney.insertPanel = Ext.extend(Lino.courses.EnrolmentsByHike.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EnrolmentsByJourney",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByJourney.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByJourney.insert;
    Lino.courses.EnrolmentsByJourney.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByJourney.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EnrolmentsByJourney.insertPanel(p);
});
Lino.courses.EnrolmentsByJourney.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EnrolmentsByJourney.detailPanel = Ext.extend(Lino.courses.Enrolments.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "iconCls": "x-tbar-printer", "menu": [ { "auto_save": true, "itemId": "create_excerpt9", "menu_item_text": "Confirmation", "overflowText": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": "Confirmation", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "do_print", "menu_item_text": "Enrolment", "overflowText": "Enrolment", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "text": "Enrolment", "tooltip": "Create an excerpt in order to print this data record." }, { "auto_save": true, "itemId": "create_excerpt10", "menu_item_text": "Certificate", "overflowText": "Certificate", "panel_btn_handler": Lino.row_action_handler('create_excerpt10','GET',null), "text": "Certificate", "tooltip": "Create an excerpt in order to print this data record." } ], "menu_item_text": "Confirmation", "panel_btn_handler": Lino.row_action_handler('create_excerpt9','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "clear_printed", "menu_item_text": "Clear print cache", "overflowText": "Clear print cache", "panel_btn_handler": Lino.row_action_handler('clear_printed','GET',null), "tooltip": "Mark this object as not printed. A subsequent call to print will generate a new cache file." } ],
  ls_url: "/courses/EnrolmentsByJourney",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EnrolmentsByJourney.detail;
    this.ls_insert_handler = Lino.courses.EnrolmentsByJourney.insert;
    Lino.courses.EnrolmentsByJourney.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EnrolmentsByJourney.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EnrolmentsByJourney.detailPanel(p);
});
Lino.courses.EnrolmentsByJourney.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.create_excerpt9 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "create_excerpt9", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.create_excerpt10 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "create_excerpt10", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.clear_printed = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "clear_printed", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.courses.Enrolments.ParamsPanel({});
  return new Lino.courses.EnrolmentsByJourney.GridPanel(p);
});
Lino.courses.EnrolmentsByJourney.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EnrolmentsByJourney.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EnrolmentsByJourney", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class uploads.UploadsByController
Lino.uploads.UploadsByController.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/uploads/UploadsByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/UploadsByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Uploads",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 20,
  ls_store_fields : [ { "name": "file" }, { "name": "type" }, 'typeHidden', { "name": "description" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "mimetype" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "upload_area" }, 'upload_areaHidden', { "name": "description_link" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 6,
  ls_grid_configs : [  ],
  content_type : 71,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByController.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByController.insert;
    var ww = this.containing_window;
    var file6988 = Lino.file_field_handler(this,{ "maxLength": 100, "selectOnFocus": true });
    var type6989 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Upload Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/type" }) }) });
    var description6990 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user6991 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/user" }) }) });
    var id6992 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var mimetype6993 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": 255 });
    var owner_type6994 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/owner_type" }) }) });
    var owner_id6995 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/uploads/UploadsByController/owner_id" }) }) });
    var upload_area6996 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.uploads.UploadAreas });
    var description_link_disp6997 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var workflow_buttons_disp6998 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp6999 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp7000 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp7001 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      type6989.setContextValue('upload_area', record ? record.data['upload_areaHidden'] : undefined);
      owner_id6995.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      upload_area6996.on('change',Lino.chooser_handler(type6989,'upload_area'));
      owner_type6994.on('change',Lino.chooser_handler(owner_id6995,'owner_type'));
      Lino.uploads.UploadsByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "file", "editable": true, "editor": file6988, "filter": { "type": "string" }, "header": "File", "sortable": true, "tooltip": "(uploads.UploadsByController.file) Pointer to the uploaded file. See\nlino.mixins.uploadable.Uploadable.file", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "type", "editable": true, "editor": type6989, "filter": { "type": "string" }, "header": "Upload Type", "sortable": false, "tooltip": "(uploads.UploadsByController.type) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "description", "editable": true, "editor": description6990, "filter": { "type": "string" }, "header": "Description", "sortable": true, "tooltip": "(uploads.UploadsByController.description) A short description entered manually by the user.", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "user", "editable": true, "editor": user6991, "filter": { "type": "string" }, "header": "Uploaded by", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(uploads.UploadsByController.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 4, "dataIndex": "id", "editable": true, "editor": id6992, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByController.id) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "mimetype", "editable": false, "filter": { "type": "string" }, "header": "MIME type", "hidden": true, "sortable": true, "tooltip": "(uploads.UploadsByController.mimetype) The Media type\nof the file.  See also this thread\nabout length of MIME type field.", "width": Lino.chars2width(22) }, { "colIndex": 6, "dataIndex": "owner_type", "editable": true, "editor": owner_type6994, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(uploads.UploadsByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "owner_id", "editable": true, "editor": owner_id6995, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "upload_area", "editable": true, "editor": upload_area6996, "filter": { "type": "string" }, "header": "Upload Area", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.upload_area) ", "width": Lino.chars2width(11) }, { "colIndex": 9, "dataIndex": "description_link", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.description_link) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(uploads.UploadsByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.uploads.UploadsByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByController.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByController.insertPanel = Ext.extend(Lino.uploads.UploadsByController.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/uploads/UploadsByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByController.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByController.insert;
    Lino.uploads.UploadsByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByController.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.uploads.UploadsByController.insertPanel(p);
});
Lino.uploads.UploadsByController.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.uploads.UploadsByController.detailPanel = Ext.extend(Lino.uploads.Uploads.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/uploads/UploadsByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.uploads.UploadsByController.detail;
    this.ls_insert_handler = Lino.uploads.UploadsByController.insert;
    Lino.uploads.UploadsByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.UploadsByController.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.UploadsByController.detailPanel(p);
});
Lino.uploads.UploadsByController.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.UploadsByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.uploads.Uploads.ParamsPanel({});
  return new Lino.uploads.UploadsByController.GridPanel(p);
});
Lino.uploads.UploadsByController.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/UploadsByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class changes.ChangesByObject
Lino.changes.ChangesByObject.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/changes/ChangesByObject",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByObject','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" } ],
  cell_edit : true,
  title : "Changes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 21,
  ls_store_fields : [ { "name": "time" }, { "name": "user" }, 'userHidden', { "name": "type" }, 'typeHidden', { "name": "changed_fields" }, { "name": "master" }, { "name": "master_type" }, 'master_typeHidden', { "name": "master_id" }, 'master_idHidden', { "name": "id", "type": "int" }, { "name": "object_type" }, 'object_typeHidden', { "name": "object_id" }, 'object_idHidden', { "name": "diff" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "object" }, { "name": "disabled_actions" } ],
  pk_index : 11,
  ls_grid_configs : [  ],
  content_type : 77,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByObject.detail;
    var ww = this.containing_window;
    var time7003 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var user7004 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/user" }) }) });
    var type7005 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var changed_fields7006 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var master_disp7007 = new Ext.form.DisplayField({ "disabled": true });
    var master_type7008 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/master_type" }) }) });
    var master_id7009 = new Lino.RemoteComboFieldElement({ "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/master_id" }) }) });
    var id7010 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var object_type7011 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/object_type" }) }) });
    var object_id7012 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByObject/object_id" }) }) });
    var diff7013 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp7014 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp7015 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp7016 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var object_disp7017 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      master_type7008.on('change',Lino.chooser_handler(master_id7009,'master_type'));
      object_type7011.on('change',Lino.chooser_handler(object_id7012,'object_type'));
      Lino.changes.ChangesByObject.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "time", "editable": true, "editor": time7003, "header": "time", "sortable": true, "tooltip": "(changes.ChangesByObject.time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user7004, "filter": { "type": "string" }, "header": "User", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(changes.ChangesByObject.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type7005, "filter": { "type": "string" }, "header": "Change Type", "sortable": false, "tooltip": "(changes.ChangesByObject.type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "changed_fields", "editable": true, "editor": changed_fields7006, "filter": { "type": "string" }, "header": "Fields", "sortable": true, "tooltip": "(changes.ChangesByObject.changed_fields) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "master", "editable": false, "header": "Master", "sortable": false, "tooltip": "(changes.ChangesByObject.master) The database object which acts as \"master\".", "width": Lino.chars2width(11) }, { "colIndex": 5, "dataIndex": "master_type", "editable": true, "editor": master_type7008, "filter": { "type": "string" }, "header": "Master type", "renderer": Lino.fk_renderer('master_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByObject.master_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "master_id", "editable": true, "editor": master_id7009, "filter": { "type": "string" }, "header": "master id", "sortable": false, "tooltip": "(changes.ChangesByObject.master_id) ", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id7010, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(changes.ChangesByObject.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "object_type", "editable": true, "editor": object_type7011, "filter": { "type": "string" }, "header": "Object type", "hidden": true, "renderer": Lino.fk_renderer('object_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByObject.object_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "object_id", "editable": true, "editor": object_id7012, "filter": { "type": "string" }, "header": "object id", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.object_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "diff", "editable": true, "editor": diff7013, "filter": { "type": "string" }, "header": "Changes", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.diff) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "object", "editable": false, "header": "Object", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByObject.object) The database object which has been modified.", "width": Lino.chars2width(11) } ];
    Lino.changes.ChangesByObject.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByObject.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByObject", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByObject", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByObject", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByObject", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByObject", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByObject.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByObject", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.changes.ChangesByObject.detailPanel = Ext.extend(Lino.changes.Changes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/changes/ChangesByObject",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByObject.detail;
    Lino.changes.ChangesByObject.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByObject.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.ChangesByObject.detailPanel(p);
});
Lino.changes.ChangesByObject.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.changes.Changes.ParamsPanel({});
  return new Lino.changes.ChangesByObject.GridPanel(p);
});

// js_render_GridPanel_class invoicing.InvoicingsByInvoiceable
Lino.invoicing.InvoicingsByInvoiceable.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/invoicing/InvoicingsByInvoiceable",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/invoicing/InvoicingsByInvoiceable','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "itemId": "move_up", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row upwards.") }, "menu_item_text": "\u25b2", "overflowText": "\u25b2", "panel_btn_handler": Lino.row_action_handler('move_up','GET',null), "text": " <font size=\"4\">\u25b2</font>" }, { "auto_save": true, "itemId": "move_down", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Move this row one row downwards.") }, "menu_item_text": "\u25bc", "overflowText": "\u25bc", "panel_btn_handler": Lino.row_action_handler('move_down','GET',null), "text": " <font size=\"4\">\u25bc</font>" } ],
  cell_edit : true,
  title : "Invoicings",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 29,
  ls_store_fields : [ { "name": "voucher" }, 'voucherHidden', { "name": "title" }, { "name": "qty" }, { "dateFormat": "d.m.Y", "name": "voucher__voucher_date", "type": "date" }, { "name": "voucher__state" }, 'voucher__stateHidden', { "name": "product__number_of_events", "type": "int", "useNull": true }, { "name": "id", "type": "int" }, { "name": "seqno", "type": "int", "useNull": true }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "vat_class" }, 'vat_classHidden', { "name": "unit_price" }, { "name": "product" }, 'productHidden', { "name": "description" }, { "name": "discount" }, { "name": "invoiceable_type" }, 'invoiceable_typeHidden', { "name": "invoiceable_id" }, 'invoiceable_idHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "move_buttons" }, { "name": "invoiceable" }, { "name": "disabled_actions" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 44,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var voucher1143 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Product invoice...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/voucher" }) }) });
    var title1144 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var qty1145 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "maxLength": 6, "selectOnFocus": true });
    var voucher__voucher_date1146 = new Lino.DateField({ "disabled": true, "sortable": false });
    var voucher__state1147 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(10), "disabled": true, "maxLength": 10, "sortable": false });
    var product__number_of_events1148 = new Ext.form.NumberField({ "disabled": true, "sortable": false });
    var id1149 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var seqno1150 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var total_incl1151 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_base1152 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var total_vat1153 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var vat_class1154 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.vat.VatClasses) });
    var unit_price1155 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var product1156 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Tariff...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/product" }) }) });
    var description1157 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var discount1158 = new Ext.form.NumberField({ "allowBlank": true, "decimalPrecision": 2, "decimalSeparator": ",", "hidden": true, "selectOnFocus": true });
    var invoiceable_type1159 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/invoiceable_type" }) }) });
    var invoiceable_id1160 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/invoicing/InvoicingsByInvoiceable/invoiceable_id" }) }) });
    var workflow_buttons_disp1161 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1162 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1163 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var move_buttons_disp1164 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var invoiceable_disp1165 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      invoiceable_type1159.on('change',Lino.chooser_handler(invoiceable_id1160,'invoiceable_type'));
      Lino.invoicing.InvoicingsByInvoiceable.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher", "editable": true, "editor": voucher1143, "filter": { "type": "string" }, "header": "Product invoice", "renderer": Lino.fk_renderer('voucherHidden','Lino.sales.Invoices.detail'), "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.voucher) Pointer to the voucher which contains this item.  Non\nnullable.  The voucher must be a subclass of\nledger.Voucher.\nThe related_name must be 'items'.", "width": Lino.chars2width(21) }, { "colIndex": 1, "dataIndex": "title", "editable": true, "editor": title1144, "filter": { "type": "string" }, "header": "Heading", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.title) The title of this voucher.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 2, "dataIndex": "qty", "editable": true, "editor": qty1145, "filter": { "type": "string" }, "format": "", "header": "Quantity", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.qty) ", "width": Lino.chars2width(8) }, { "colIndex": 3, "dataIndex": "voucher__voucher_date", "editable": false, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Voucher date", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.voucher__voucher_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 4, "dataIndex": "voucher__state", "editable": false, "filter": { "type": "string" }, "header": "State", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.voucher__state) ", "width": Lino.chars2width(12) }, { "align": "right", "colIndex": 5, "dataIndex": "product__number_of_events", "editable": false, "filter": { "type": "numeric" }, "format": "0", "header": "Number of events", "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.product__number_of_events) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id1149, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 7, "dataIndex": "seqno", "editable": true, "editor": seqno1150, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.seqno) The sequence number of this item with its parent.", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 8, "dataIndex": "total_incl", "editable": true, "editor": total_incl1151, "filter": { "type": "numeric" }, "header": "Total incl. VAT", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 9, "dataIndex": "total_base", "editable": true, "editor": total_base1152, "filter": { "type": "numeric" }, "header": "Total excl. VAT", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 10, "dataIndex": "total_vat", "editable": true, "editor": total_vat1153, "filter": { "type": "numeric" }, "header": "VAT", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) }, { "colIndex": 11, "dataIndex": "vat_class", "editable": true, "editor": vat_class1154, "filter": { "type": "string" }, "header": "VAT Class", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.vat_class) The VAT class to be applied for this item. A pointer to\nVatClasses.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 12, "dataIndex": "unit_price", "editable": true, "editor": unit_price1155, "filter": { "type": "numeric" }, "header": "Unit price", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.unit_price) ", "width": Lino.chars2width(13) }, { "colIndex": 13, "dataIndex": "product", "editable": true, "editor": product1156, "filter": { "type": "string" }, "header": "Tariff", "hidden": true, "renderer": Lino.fk_renderer('productHidden','Lino.products.Products.detail'), "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.product) ", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "description", "editable": true, "editor": description1157, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.description) A multi-line rich text to be printed in the resulting printable\ndocument.", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 15, "dataIndex": "discount", "editable": true, "editor": discount1158, "filter": { "type": "numeric" }, "header": "Discount", "hidden": true, "sortable": true, "tooltip": "(invoicing.InvoicingsByInvoiceable.discount) ", "width": Lino.chars2width(8) }, { "colIndex": 16, "dataIndex": "invoiceable_type", "editable": true, "editor": invoiceable_type1159, "filter": { "type": "string" }, "header": "Invoiced object (type)", "hidden": true, "renderer": Lino.fk_renderer('invoiceable_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.invoiceable_type) ", "width": Lino.chars2width(21) }, { "colIndex": 17, "dataIndex": "invoiceable_id", "editable": true, "editor": invoiceable_id1160, "filter": { "type": "string" }, "header": "Invoiced object (object)", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.invoiceable_id) ", "width": Lino.chars2width(11) }, { "colIndex": 18, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 20, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 21, "dataIndex": "move_buttons", "editable": false, "header": "Move", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.move_buttons) ", "width": Lino.chars2width(6) }, { "colIndex": 22, "dataIndex": "invoiceable", "editable": false, "header": "Invoiced object", "hidden": true, "sortable": false, "tooltip": "(invoicing.InvoicingsByInvoiceable.invoiceable) ", "width": Lino.chars2width(11) } ];
    Lino.invoicing.InvoicingsByInvoiceable.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.invoicing.InvoicingsByInvoiceable.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.invoicing.InvoicingsByInvoiceable.GridPanel(p);
});
Lino.invoicing.InvoicingsByInvoiceable.move_up = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "move_up", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.invoicing.InvoicingsByInvoiceable.move_down = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/invoicing/InvoicingsByInvoiceable", "GET", pk, "move_down", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class notes.NotesByOwner
Lino.notes.NotesByOwner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/notes/NotesByOwner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/NotesByOwner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Notes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 31,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "time" }, { "name": "event_type" }, 'event_typeHidden', { "name": "type" }, 'typeHidden', { "name": "subject" }, { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "body" }, { "name": "language" }, 'languageHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 9,
  ls_grid_configs : [  ],
  content_type : 67,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByOwner.detail;
    this.ls_insert_handler = Lino.notes.NotesByOwner.insert;
    var ww = this.containing_window;
    var date884 = new Lino.DateField({ "allowBlank": false, "selectOnFocus": true });
    var time885 = new Lino.TimeField({ "selectOnFocus": true });
    var event_type886 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Event Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/event_type" }) }) });
    var type887 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Note Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/type" }) }) });
    var subject888 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var user889 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/user" }) }) });
    var id890 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_time891 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method892 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company893 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/company" }) }) });
    var contact_person894 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/contact_person" }) }) });
    var contact_role895 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/contact_role" }) }) });
    var owner_type896 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/owner_type" }) }) });
    var owner_id897 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/notes/NotesByOwner/owner_id" }) }) });
    var body898 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var language899 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var workflow_buttons_disp900 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp901 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp902 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp903 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      contact_person894.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id897.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      company893.on('change',Lino.chooser_handler(contact_person894,'company'));
      owner_type896.on('change',Lino.chooser_handler(owner_id897,'owner_type'));
      Lino.notes.NotesByOwner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "date", "editable": true, "editor": date884, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "sortable": true, "tooltip": "(notes.NotesByOwner.date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "time", "editable": true, "editor": time885, "header": "Time", "sortable": true, "tooltip": "(notes.NotesByOwner.time) ", "width": Lino.chars2width(9) }, { "colIndex": 2, "dataIndex": "event_type", "editable": true, "editor": event_type886, "filter": { "type": "string" }, "header": "Event Type (Form)", "sortable": false, "tooltip": "(notes.NotesByOwner.event_type) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "type", "editable": true, "editor": type887, "filter": { "type": "string" }, "header": "Note Type (Content)", "sortable": false, "tooltip": "(notes.NotesByOwner.type) ", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "subject", "editable": true, "editor": subject888, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(notes.NotesByOwner.subject) ", "width": Lino.chars2width(22) }, { "colIndex": 5, "dataIndex": "user", "editable": true, "editor": user889, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 6, "dataIndex": "id", "editable": true, "editor": id890, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByOwner.id) ", "width": Lino.chars2width(6) }, { "colIndex": 7, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(notes.NotesByOwner.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 8, "dataIndex": "build_method", "editable": true, "editor": build_method892, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 9, "dataIndex": "company", "editable": true, "editor": company893, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.company) Pointer to lino_xl.lib.contacts.models.Company.", "width": Lino.chars2width(21) }, { "colIndex": 10, "dataIndex": "contact_person", "editable": true, "editor": contact_person894, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.contact_person) Pointer to lino_xl.lib.contacts.models.Person.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "contact_role", "editable": true, "editor": contact_role895, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 12, "dataIndex": "owner_type", "editable": true, "editor": owner_type896, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(notes.NotesByOwner.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "owner_id", "editable": true, "editor": owner_id897, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 14, "dataIndex": "body", "editable": true, "editor": body898, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.body) ", "width": Lino.chars2width(61) }, { "colIndex": 15, "dataIndex": "language", "editable": true, "editor": language899, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.language) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 17, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 18, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 19, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(notes.NotesByOwner.owner) ", "width": Lino.chars2width(11) } ];
    Lino.notes.NotesByOwner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByOwner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByOwner.insertPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/notes/NotesByOwner",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByOwner.detail;
    this.ls_insert_handler = Lino.notes.NotesByOwner.insert;
    Lino.notes.NotesByOwner.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByOwner.insert = new Lino.WindowAction({  }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.notes.NotesByOwner.insertPanel(p);
});
Lino.notes.NotesByOwner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.notes.NotesByOwner.detailPanel = Ext.extend(Lino.notes.Notes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/notes/NotesByOwner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.notes.NotesByOwner.detail;
    this.ls_insert_handler = Lino.notes.NotesByOwner.insert;
    Lino.notes.NotesByOwner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.NotesByOwner.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.NotesByOwner.detailPanel(p);
});
Lino.notes.NotesByOwner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.notes.Notes.ParamsPanel({});
  return new Lino.notes.NotesByOwner.GridPanel(p);
});
Lino.notes.NotesByOwner.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.NotesByOwner.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/NotesByOwner", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class cal.TasksByController
Lino.cal.TasksByController.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/TasksByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/TasksByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Tasks",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 18,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByController.detail;
    this.ls_insert_handler = Lino.cal.TasksByController.insert;
    var ww = this.containing_window;
    var start_date7019 = new Lino.DateField({ "selectOnFocus": true });
    var summary7020 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp7021 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id7022 = new Ext.form.NumberField({ "selectOnFocus": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date7019, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(cal.TasksByController.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary7020, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.TasksByController.summary) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.TasksByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id7022, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(cal.TasksByController.id) ", "width": Lino.chars2width(6) } ];
    Lino.cal.TasksByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByController.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByController.insertPanel = Ext.extend(Lino.cal.Tasks.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/TasksByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByController.detail;
    this.ls_insert_handler = Lino.cal.TasksByController.insert;
    Lino.cal.TasksByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByController.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(50) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.TasksByController.insertPanel(p);
});
Lino.cal.TasksByController.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.TasksByController.detailPanel = Ext.extend(Lino.cal.Tasks.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  ls_url: "/cal/TasksByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.TasksByController.detail;
    this.ls_insert_handler = Lino.cal.TasksByController.insert;
    Lino.cal.TasksByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TasksByController.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.TasksByController.detailPanel(p);
});
Lino.cal.TasksByController.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Tasks.ParamsPanel({});
  return new Lino.cal.TasksByController.GridPanel(p);
});
Lino.cal.TasksByController.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf1 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "wf1", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TasksByController.wf4 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TasksByController", "GET", pk, "wf4", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class gfks.HelpTextsByModel
Lino.gfks.HelpTextsByModel.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/gfks/HelpTextsByModel",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/HelpTextsByModel','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" } ],
  cell_edit : true,
  title : "Help Texts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "field" }, { "name": "verbose_name" }, { "name": "help_text" }, { "name": "id", "type": "int" }, { "name": "content_type" }, 'content_typeHidden', { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 16,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var field2132 = new Lino.SimpleRemoteComboFieldElement({ "allowBlank": false, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTextsByModel/field" }) }) });
    var verbose_name2133 = new Ext.form.TextField({ "disabled": true, "maxLength": 200 });
    var help_text2134 = new Ext.form.TextArea({ "growMax": 2000, "selectOnFocus": true });
    var id2135 = new Ext.form.NumberField({ "selectOnFocus": true });
    var content_type2136 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a content type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/gfks/HelpTextsByModel/content_type" }) }) });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      field2132.setContextValue('mk',bp['mk']);
      field2132.setContextValue('mt',bp['mt']);
    };
    this.onRender = function(ct, position) {
      content_type2136.on('change',Lino.chooser_handler(field2132,'content_type'));
      Lino.gfks.HelpTextsByModel.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "field", "editable": true, "editor": field2132, "filter": { "type": "string" }, "header": "Field", "sortable": false, "tooltip": "(gfks.HelpTextsByModel.field) ", "width": Lino.chars2width(11) }, { "colIndex": 1, "dataIndex": "verbose_name", "editable": false, "header": "Verbose name", "sortable": false, "tooltip": "(gfks.HelpTextsByModel.verbose_name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "help_text", "editable": true, "editor": help_text2134, "filter": { "type": "string" }, "header": "HelpText", "sortable": false, "tooltip": "(gfks.HelpTextsByModel.help_text) ", "width": Lino.chars2width(61) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id2135, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "sortable": true, "tooltip": "(gfks.HelpTextsByModel.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "content_type", "editable": true, "editor": content_type2136, "filter": { "type": "string" }, "header": "Model", "renderer": Lino.fk_renderer('content_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(gfks.HelpTextsByModel.content_type) ", "width": Lino.chars2width(21) } ];
    Lino.gfks.HelpTextsByModel.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.HelpTextsByModel.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/HelpTextsByModel", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.HelpTextsByModel.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.HelpTextsByModel.GridPanel(p);
});

// js_render_GridPanel_class outbox.MailsByController
Lino.outbox.MailsByController.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/outbox/MailsByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/MailsByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  cell_edit : true,
  title : "Outgoing Mails",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 17,
  ls_store_fields : [ { "name": "sent" }, { "name": "recipients" }, { "name": "subject" }, { "name": "id", "type": "int" }, { "name": "user" }, 'userHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "dateFormat": "d.m.Y", "name": "date", "type": "date" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "body" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 72,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByController.detail;
    this.ls_insert_handler = Lino.outbox.MailsByController.insert;
    var ww = this.containing_window;
    var sent7024 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var recipients_htmlbox7025 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "recipients", "title": "Recipients", "value": "<br/>" });
    var subject7026 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id7027 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var user7028 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MailsByController/user" }) }) });
    var owner_type7029 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MailsByController/owner_type" }) }) });
    var owner_id7030 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/outbox/MailsByController/owner_id" }) }) });
    var date7031 = new Lino.DateField({ "allowBlank": false, "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp7032 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp7033 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp7034 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var body7035 = new Ext.form.HtmlEditor({ "hidden": true, "selectOnFocus": true });
    var owner_disp7036 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      recipients_htmlbox7025.refresh();
      owner_id7030.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type7029.on('change',Lino.chooser_handler(owner_id7030,'owner_type'));
      Lino.outbox.MailsByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "sent", "editable": false, "header": "sent", "sortable": true, "tooltip": "(outbox.MailsByController.sent) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "recipients", "editable": false, "header": "Recipients", "sortable": false, "tooltip": "(outbox.MailsByController.recipients) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "subject", "editable": true, "editor": subject7026, "filter": { "type": "string" }, "header": "Subject", "sortable": true, "tooltip": "(outbox.MailsByController.subject) ", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id7027, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(outbox.MailsByController.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "user", "editable": true, "editor": user7028, "filter": { "type": "string" }, "header": "Sender", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(outbox.MailsByController.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_type", "editable": true, "editor": owner_type7029, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(outbox.MailsByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "owner_id", "editable": true, "editor": owner_id7030, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 7, "dataIndex": "date", "editable": true, "editor": date7031, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Date", "hidden": true, "sortable": true, "tooltip": "(outbox.MailsByController.date) \n        The official date to be printed on the document.\n        ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 8, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 10, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 11, "dataIndex": "body", "editable": true, "editor": body7035, "filter": { "type": "string" }, "header": "Body", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.body) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(outbox.MailsByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.outbox.MailsByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByController.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByController.insertPanel = Ext.extend(Lino.outbox.Mails.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/outbox/MailsByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByController.detail;
    this.ls_insert_handler = Lino.outbox.MailsByController.insert;
    Lino.outbox.MailsByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByController.insert = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.outbox.MailsByController.insertPanel(p);
});
Lino.outbox.MailsByController.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.outbox.MailsByController.detailPanel = Ext.extend(Lino.outbox.Mails.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." }, { "auto_save": true, "iconCls": "x-tbar-email_go", "itemId": "send_mail", "menu_item_text": "Send email", "overflowText": "Send email", "panel_btn_handler": Lino.row_action_handler('send_mail','GET',null), "tooltip": "Sends an outbox.Mail as an email." } ],
  ls_url: "/outbox/MailsByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.outbox.MailsByController.detail;
    this.ls_insert_handler = Lino.outbox.MailsByController.insert;
    Lino.outbox.MailsByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.MailsByController.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.MailsByController.detailPanel(p);
});
Lino.outbox.MailsByController.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.outbox.Mails.ParamsPanel({});
  return new Lino.outbox.MailsByController.GridPanel(p);
});
Lino.outbox.MailsByController.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.MailsByController.send_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/MailsByController", "GET", pk, "send_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.ProblemsByOwner
Lino.plausibility.ProblemsByOwner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/plausibility/ProblemsByOwner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/ProblemsByOwner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  cell_edit : false,
  title : "Plausibility problems",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 14,
  ls_store_fields : [ { "name": "message" }, { "name": "checker" }, 'checkerHidden', { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "owner" }, { "name": "disabled_actions" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 17,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByOwner.detail;
    var ww = this.containing_window;
    var message1449 = new Ext.form.TextField({ "allowBlank": false, "maxLength": 250, "selectOnFocus": true });
    var checker1450 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.plausibility.Checkers });
    var user1451 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByOwner/user" }) }) });
    var id1452 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var owner_type1453 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByOwner/owner_type" }) }) });
    var owner_id1454 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/plausibility/ProblemsByOwner/owner_id" }) }) });
    var workflow_buttons_disp1455 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp1456 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp1457 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp1458 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      owner_type1453.on('change',Lino.chooser_handler(owner_id1454,'owner_type'));
      Lino.plausibility.ProblemsByOwner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "message", "editable": true, "editor": message1449, "filter": { "type": "string" }, "header": "Message", "sortable": true, "tooltip": "(plausibility.ProblemsByOwner.message) The message text. This is a concatenation of all messages that\nwere yeld by the checker.", "width": Lino.chars2width(51) }, { "colIndex": 1, "dataIndex": "checker", "editable": true, "editor": checker1450, "filter": { "type": "string" }, "header": "Plausibility checker", "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.checker) The Checker which reported\nthis problem.", "width": Lino.chars2width(11) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user1451, "filter": { "type": "string" }, "header": "Responsible", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.user) The user reponsible\nfor fixing this problem.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id1452, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(plausibility.ProblemsByOwner.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "owner_type", "editable": true, "editor": owner_type1453, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "owner_id", "editable": true, "editor": owner_id1454, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 6, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 7, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 8, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 9, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(plausibility.ProblemsByOwner.owner) ", "width": Lino.chars2width(11) } ];
    Lino.plausibility.ProblemsByOwner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByOwner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.ProblemsByOwner.detailPanel = Ext.extend(Lino.plausibility.Problems.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "update_problem", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": "Check plausibility", "tooltip": "Check plausibility" }, { "auto_save": true, "itemId": "fix_problem", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problem','GET',null), "text": "Fix plausibility problems", "tooltip": "Fix plausibility problems" } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('update_problem','GET',null), "text": null, "xtype": "splitbutton" } ],
  ls_url: "/plausibility/ProblemsByOwner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.ProblemsByOwner.detail;
    Lino.plausibility.ProblemsByOwner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.ProblemsByOwner.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(70) }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.ProblemsByOwner.detailPanel(p);
});
Lino.plausibility.ProblemsByOwner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.plausibility.Problems.ParamsPanel({});
  return new Lino.plausibility.ProblemsByOwner.GridPanel(p);
});
Lino.plausibility.ProblemsByOwner.update_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "update_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.ProblemsByOwner.fix_problem = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/ProblemsByOwner", "GET", pk, "fix_problem", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class changes.ChangesByMaster
Lino.changes.ChangesByMaster.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/changes/ChangesByMaster",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/ChangesByMaster','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" } ],
  cell_edit : true,
  title : "Changes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 21,
  ls_store_fields : [ { "name": "time" }, { "name": "user" }, 'userHidden', { "name": "type" }, 'typeHidden', { "name": "changed_fields" }, { "name": "object" }, { "name": "id", "type": "int" }, { "name": "object_type" }, 'object_typeHidden', { "name": "object_id" }, 'object_idHidden', { "name": "master_type" }, 'master_typeHidden', { "name": "master_id" }, 'master_idHidden', { "name": "diff" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "master" }, { "name": "disabled_actions" } ],
  pk_index : 7,
  ls_grid_configs : [  ],
  content_type : 77,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByMaster.detail;
    var ww = this.containing_window;
    var time2379 = new Ext.form.DisplayField({ "allowBlank": false, "selectOnFocus": true, "value": "<br>" });
    var user2380 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/user" }) }) });
    var type2381 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "selectOnFocus": true, "store": Lino.changes.ChangeTypes });
    var changed_fields2382 = new Ext.form.TextField({ "maxLength": 250, "selectOnFocus": true });
    var object_disp2383 = new Ext.form.DisplayField({ "disabled": true });
    var id2384 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var object_type2385 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/object_type" }) }) });
    var object_id2386 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/object_id" }) }) });
    var master_type2387 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/master_type" }) }) });
    var master_id2388 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/changes/ChangesByMaster/master_id" }) }) });
    var diff2389 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var workflow_buttons_disp2390 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp2391 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp2392 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var master_disp2393 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
    };
    this.onRender = function(ct, position) {
      object_type2385.on('change',Lino.chooser_handler(object_id2386,'object_type'));
      master_type2387.on('change',Lino.chooser_handler(master_id2388,'master_type'));
      Lino.changes.ChangesByMaster.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "time", "editable": true, "editor": time2379, "header": "time", "sortable": true, "tooltip": "(changes.ChangesByMaster.time) ", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "user", "editable": true, "editor": user2380, "filter": { "type": "string" }, "header": "User", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(changes.ChangesByMaster.user) ", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "type", "editable": true, "editor": type2381, "filter": { "type": "string" }, "header": "Change Type", "sortable": false, "tooltip": "(changes.ChangesByMaster.type) ", "width": Lino.chars2width(16) }, { "colIndex": 3, "dataIndex": "changed_fields", "editable": true, "editor": changed_fields2382, "filter": { "type": "string" }, "header": "Fields", "sortable": true, "tooltip": "(changes.ChangesByMaster.changed_fields) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "object", "editable": false, "header": "Object", "sortable": false, "tooltip": "(changes.ChangesByMaster.object) The database object which has been modified.", "width": Lino.chars2width(11) }, { "align": "right", "colIndex": 5, "dataIndex": "id", "editable": true, "editor": id2384, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(changes.ChangesByMaster.id) ", "width": Lino.chars2width(6) }, { "colIndex": 6, "dataIndex": "object_type", "editable": true, "editor": object_type2385, "filter": { "type": "string" }, "header": "Object type", "hidden": true, "renderer": Lino.fk_renderer('object_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByMaster.object_type) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "object_id", "editable": true, "editor": object_id2386, "filter": { "type": "string" }, "header": "object id", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.object_id) ", "width": Lino.chars2width(11) }, { "colIndex": 8, "dataIndex": "master_type", "editable": true, "editor": master_type2387, "filter": { "type": "string" }, "header": "Master type", "hidden": true, "renderer": Lino.fk_renderer('master_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(changes.ChangesByMaster.master_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "master_id", "editable": true, "editor": master_id2388, "filter": { "type": "string" }, "header": "master id", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.master_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "diff", "editable": true, "editor": diff2389, "filter": { "type": "string" }, "header": "Changes", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.diff) ", "width": Lino.chars2width(61) }, { "colIndex": 11, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 12, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "master", "editable": false, "header": "Master", "hidden": true, "sortable": false, "tooltip": "(changes.ChangesByMaster.master) The database object which acts as \"master\".", "width": Lino.chars2width(11) } ];
    Lino.changes.ChangesByMaster.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByMaster.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByMaster", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByMaster", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByMaster", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByMaster", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByMaster", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangesByMaster.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangesByMaster", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.changes.ChangesByMaster.detailPanel = Ext.extend(Lino.changes.Changes.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/changes/ChangesByMaster",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.changes.ChangesByMaster.detail;
    Lino.changes.ChangesByMaster.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangesByMaster.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.ChangesByMaster.detailPanel(p);
});
Lino.changes.ChangesByMaster.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.changes.Changes.ParamsPanel({});
  return new Lino.changes.ChangesByMaster.GridPanel(p);
});

// js_render_GridPanel_class cal.EntriesByController
Lino.cal.EntriesByController.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/cal/EntriesByController",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntriesByController','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Calendar entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "name": "when_html" }, { "name": "summary" }, { "name": "workflow_buttons" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "start_time" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "end_time" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "room" }, 'roomHidden', { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByController.detail;
    this.ls_insert_handler = Lino.cal.EntriesByController.insert;
    var ww = this.containing_window;
    var when_html_disp7038 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var summary7039 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var workflow_buttons_disp7040 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var id7041 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified7042 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created7043 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var start_date7044 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var start_time7045 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var end_date7046 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var end_time7047 = new Lino.TimeField({ "hidden": true, "selectOnFocus": true });
    var build_time7048 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method7049 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user7050 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/user" }) }) });
    var assigned_to7051 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/assigned_to" }) }) });
    var owner_type7052 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/owner_type" }) }) });
    var owner_id7053 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/owner_id" }) }) });
    var description7054 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class7055 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence7056 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var auto_type7057 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var event_type7058 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/event_type" }) }) });
    var transparent7059 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var room7060 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/room" }) }) });
    var priority7061 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/cal/EntriesByController/priority" }) }) });
    var state7062 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar7063 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var reminder_disp7064 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp7065 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day7066 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp7067 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp7068 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp7069 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp7070 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration7071 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var owner_disp7072 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      owner_id7053.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type7052.on('change',Lino.chooser_handler(owner_id7053,'owner_type'));
      Lino.cal.EntriesByController.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "when_html", "editable": false, "header": "When", "sortable": false, "tooltip": "(cal.EntriesByController.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "summary", "editable": true, "editor": summary7039, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(cal.EntriesByController.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(cal.EntriesByController.workflow_buttons) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id7041, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 5, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 6, "dataIndex": "start_date", "editable": true, "editor": start_date7044, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 7, "dataIndex": "start_time", "editable": true, "editor": start_time7045, "header": "Start time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 8, "dataIndex": "end_date", "editable": true, "editor": end_date7046, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 9, "dataIndex": "end_time", "editable": true, "editor": end_time7047, "header": "End Time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 10, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 11, "dataIndex": "build_method", "editable": true, "editor": build_method7049, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 12, "dataIndex": "user", "editable": true, "editor": user7050, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 13, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to7051, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "owner_type", "editable": true, "editor": owner_type7052, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(cal.EntriesByController.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_id", "editable": true, "editor": owner_id7053, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 16, "dataIndex": "description", "editable": true, "editor": description7054, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 17, "dataIndex": "access_class", "editable": true, "editor": access_class7055, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 18, "dataIndex": "sequence", "editable": true, "editor": sequence7056, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.sequence) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 19, "dataIndex": "auto_type", "editable": true, "editor": auto_type7057, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "hidden": true, "sortable": true, "tooltip": "(cal.EntriesByController.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type7058, "filter": { "type": "string" }, "header": "Calendar entry type", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "room", "editable": true, "editor": room7060, "filter": { "type": "string" }, "header": "Room", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.room) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "priority", "editable": true, "editor": priority7061, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 24, "dataIndex": "state", "editable": true, "editor": state7062, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 25, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 26, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 33, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 34, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(cal.EntriesByController.owner) ", "width": Lino.chars2width(11) } ];
    Lino.cal.EntriesByController.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByController.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByController.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/cal/EntriesByController",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByController.detail;
    this.ls_insert_handler = Lino.cal.EntriesByController.insert;
    Lino.cal.EntriesByController.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByController.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.cal.EntriesByController.insertPanel(p);
});
Lino.cal.EntriesByController.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.cal.EntriesByController.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/cal/EntriesByController",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.cal.EntriesByController.detail;
    this.ls_insert_handler = Lino.cal.EntriesByController.insert;
    Lino.cal.EntriesByController.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntriesByController.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntriesByController.detailPanel(p);
});
Lino.cal.EntriesByController.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.cal.EntriesByController.GridPanel(p);
});
Lino.cal.EntriesByController.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntriesByController.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntriesByController", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class courses.EntriesByCourse
Lino.courses.EntriesByCourse.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/courses/EntriesByCourse",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/EntriesByCourse','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  cell_edit : true,
  title : "Calendar entries",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 47,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "start_date", "type": "date" }, { "name": "auto_type", "type": "int", "useNull": true }, { "name": "workflow_buttons" }, { "name": "start_time" }, { "name": "end_time" }, { "name": "room" }, 'roomHidden', { "name": "summary" }, { "name": "id", "type": "int" }, { "name": "modified" }, { "name": "created" }, { "dateFormat": "d.m.Y", "name": "end_date", "type": "date" }, { "name": "build_time" }, { "name": "build_method" }, 'build_methodHidden', { "name": "user" }, 'userHidden', { "name": "assigned_to" }, 'assigned_toHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "description" }, { "name": "access_class" }, 'access_classHidden', { "name": "sequence", "type": "int", "useNull": true }, { "name": "event_type" }, 'event_typeHidden', { "name": "transparent", "type": "boolean" }, { "name": "priority" }, 'priorityHidden', { "name": "state" }, 'stateHidden', { "name": "calendar" }, 'calendarHidden', { "name": "when_html" }, { "name": "reminder" }, { "name": "when_text" }, { "name": "all_day", "type": "boolean" }, { "name": "url" }, { "name": "overview" }, { "name": "description_column" }, { "name": "created_natural" }, { "name": "duration" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 8,
  ls_grid_configs : [  ],
  content_type : 23,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByCourse.detail;
    this.ls_insert_handler = Lino.courses.EntriesByCourse.insert;
    var ww = this.containing_window;
    var start_date7083 = new Lino.DateField({ "selectOnFocus": true });
    var auto_type7084 = new Ext.form.NumberField({ "selectOnFocus": true });
    var workflow_buttons_disp7085 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var start_time7086 = new Lino.TimeField({ "selectOnFocus": true });
    var end_time7087 = new Lino.TimeField({ "selectOnFocus": true });
    var room7088 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Room...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/room" }) }) });
    var summary7089 = new Ext.form.TextField({ "maxLength": 200, "selectOnFocus": true });
    var id7090 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var modified7091 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var created7092 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var end_date7093 = new Lino.DateField({ "hidden": true, "selectOnFocus": true });
    var build_time7094 = new Ext.form.DisplayField({ "disabled": true, "hidden": true, "value": "<br>" });
    var build_method7095 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var user7096 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/user" }) }) });
    var assigned_to7097 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "hidden": true, "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/assigned_to" }) }) });
    var owner_type7098 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/owner_type" }) }) });
    var owner_id7099 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/owner_id" }) }) });
    var description7100 = new Ext.form.TextArea({ "growMax": 2000, "hidden": true, "selectOnFocus": true });
    var access_class7101 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.cal.AccessClasses) });
    var sequence7102 = new Ext.form.NumberField({ "allowBlank": false, "hidden": true, "selectOnFocus": true, "value": 0 });
    var event_type7103 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Calendar entry type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/event_type" }) }) });
    var transparent7104 = new Ext.form.Checkbox({ "checked": false, "hidden": true, "selectOnFocus": true });
    var priority7105 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Priority...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/courses/EntriesByCourse/priority" }) }) });
    var state7106 = new Lino.ChoicesFieldElement({ "allowBlank": false, "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": Lino.cal.EntryStates });
    var calendar7107 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Calendar...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var when_html_disp7108 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var reminder_disp7109 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var when_text_disp7110 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var all_day7111 = new Ext.form.Checkbox({ "hidden": true, "selectOnFocus": true });
    var url_disp7112 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp7113 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp7114 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var created_natural_disp7115 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var duration7116 = new Ext.form.TextField({ "boxMinWidth": Lino.chars2width(6), "disabled": true, "hidden": true, "maxLength": 6 });
    var owner_disp7117 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      owner_id7099.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
    };
    this.onRender = function(ct, position) {
      owner_type7098.on('change',Lino.chooser_handler(owner_id7099,'owner_type'));
      Lino.courses.EntriesByCourse.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "start_date", "editable": true, "editor": start_date7083, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "Start date", "sortable": true, "tooltip": "(courses.EntriesByCourse.start_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "auto_type", "editable": true, "editor": auto_type7084, "filter": { "type": "numeric" }, "format": "0", "header": "No.", "sortable": true, "tooltip": "(courses.EntriesByCourse.auto_type) Contains the sequence number if this is an automatically\ngenerated component. Otherwise this field is empty.", "width": Lino.chars2width(6) }, { "colIndex": 2, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "sortable": false, "tooltip": "(courses.EntriesByCourse.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "start_time", "editable": true, "editor": start_time7086, "header": "Start time", "sortable": true, "tooltip": "(courses.EntriesByCourse.start_time) ", "width": Lino.chars2width(9) }, { "colIndex": 4, "dataIndex": "end_time", "editable": true, "editor": end_time7087, "header": "End Time", "sortable": true, "tooltip": "(courses.EntriesByCourse.end_time) These four fields define the duration of this entry.\nOnly start_date is mandatory.", "width": Lino.chars2width(9) }, { "colIndex": 5, "dataIndex": "room", "editable": true, "editor": room7088, "filter": { "type": "string" }, "header": "Room", "sortable": false, "tooltip": "(courses.EntriesByCourse.room) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "summary", "editable": true, "editor": summary7089, "filter": { "type": "string" }, "header": "Short description", "sortable": true, "tooltip": "(courses.EntriesByCourse.summary) A one-line descriptive text.", "width": Lino.chars2width(22) }, { "align": "right", "colIndex": 7, "dataIndex": "id", "editable": true, "editor": id7090, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.id) ", "width": Lino.chars2width(6) }, { "colIndex": 8, "dataIndex": "modified", "editable": false, "header": "Modified", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.modified) ", "width": Lino.chars2width(17) }, { "colIndex": 9, "dataIndex": "created", "editable": false, "header": "Created", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.created) The timestame when this object was created.", "width": Lino.chars2width(17) }, { "colIndex": 10, "dataIndex": "end_date", "editable": true, "editor": end_date7093, "filter": { "dateFormat": "d.m.Y", "type": "date" }, "format": "d.m.Y", "header": "End Date", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.end_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 11, "dataIndex": "build_time", "editable": false, "header": "build time", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 12, "dataIndex": "build_method", "editable": true, "editor": build_method7095, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 13, "dataIndex": "user", "editable": true, "editor": user7096, "filter": { "type": "string" }, "header": "Responsible user", "hidden": true, "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.user) The responsible user.", "width": Lino.chars2width(21) }, { "colIndex": 14, "dataIndex": "assigned_to", "editable": true, "editor": assigned_to7097, "filter": { "type": "string" }, "header": "Assigned to", "hidden": true, "renderer": Lino.fk_renderer('assigned_toHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.assigned_to) Another user who is expected to take responsibility for this\nentry.", "width": Lino.chars2width(21) }, { "colIndex": 15, "dataIndex": "owner_type", "editable": true, "editor": owner_type7098, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(courses.EntriesByCourse.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 16, "dataIndex": "owner_id", "editable": true, "editor": owner_id7099, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 17, "dataIndex": "description", "editable": true, "editor": description7100, "filter": { "type": "string" }, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.description) A longer descriptive text.", "width": Lino.chars2width(61) }, { "colIndex": 18, "dataIndex": "access_class", "editable": true, "editor": access_class7101, "filter": { "type": "string" }, "header": "Access Class", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.access_class) Whether this is private, public or between.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 19, "dataIndex": "sequence", "editable": true, "editor": sequence7102, "filter": { "type": "numeric" }, "format": "0", "header": "Revision", "hidden": true, "sortable": true, "tooltip": "(courses.EntriesByCourse.sequence) ", "width": Lino.chars2width(6) }, { "colIndex": 20, "dataIndex": "event_type", "editable": true, "editor": event_type7103, "filter": { "type": "string" }, "header": "Calendar entry type", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.event_type) The type of this entry. Every calendar entry should have this\nfield pointing to a given EventType, which holds\nextended configurable information about this entry.", "width": Lino.chars2width(21) }, { "colIndex": 21, "dataIndex": "transparent", "editable": true, "filter": { "type": "boolean" }, "header": "Transparent", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.transparent) Indicates that this entry shouldn't prevent other entries at\nthe same time.", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 22, "dataIndex": "priority", "editable": true, "editor": priority7105, "filter": { "type": "string" }, "header": "Priority", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.priority) ", "width": Lino.chars2width(21) }, { "colIndex": 23, "dataIndex": "state", "editable": true, "editor": state7106, "filter": { "type": "string" }, "header": "State", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.state) The state of this entry. The state can change according to\nrules defined by the workflow, that's why we sometimes refer\nto it as the life cycle.", "width": Lino.chars2width(14) }, { "colIndex": 24, "dataIndex": "calendar", "editable": false, "header": "Calendar", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.calendar) ", "width": Lino.chars2width(21) }, { "colIndex": 25, "dataIndex": "when_html", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.when_html) ", "width": Lino.chars2width(31) }, { "colIndex": 26, "dataIndex": "reminder", "editable": false, "header": "Reminder", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.reminder) ", "width": Lino.chars2width(31) }, { "colIndex": 27, "dataIndex": "when_text", "editable": false, "header": "When", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.when_text) ", "width": Lino.chars2width(31) }, { "colIndex": 28, "dataIndex": "all_day", "editable": true, "header": "all day", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.all_day) ", "width": Lino.chars2width(11), "xtype": "checkcolumn" }, { "colIndex": 29, "dataIndex": "url", "editable": false, "header": "Link URL", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.url) ", "width": Lino.chars2width(31) }, { "colIndex": 30, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 31, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 32, "dataIndex": "created_natural", "editable": false, "header": "Created", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.created_natural) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 33, "dataIndex": "duration", "editable": false, "format": "", "header": "Duration", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.duration) ", "width": Lino.chars2width(8) }, { "colIndex": 34, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(courses.EntriesByCourse.owner) ", "width": Lino.chars2width(11) } ];
    Lino.courses.EntriesByCourse.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByCourse.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EntriesByCourse.insertPanel = Ext.extend(Lino.cal.Events.InsertFormPanel,{
  empty_title: "New",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_insert",
  ls_bbar_actions: [ { "auto_save": false, "itemId": "submit_insert", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create the record and open a detail window on it") }, "menu_item_text": "Create", "overflowText": "Create", "panel_btn_handler": function(panel){panel.save()}, "text": "Create" } ],
  ls_url: "/courses/EntriesByCourse",
  action_name: "insert",
  default_record_id: -99999,
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByCourse.detail;
    this.ls_insert_handler = Lino.courses.EntriesByCourse.insert;
    Lino.courses.EntriesByCourse.insertPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByCourse.insert = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.courses.EntriesByCourse.insertPanel(p);
});
Lino.courses.EntriesByCourse.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.courses.EntriesByCourse.detailPanel = Ext.extend(Lino.cal.Events.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "iconCls": "x-tbar-add", "itemId": "insert", "keycode": 44, "menu_item_text": "New", "overflowText": "New", "panel_btn_handler": Lino.show_insert, "tooltip": "Insert a new record" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "auto_save": true, "iconCls": "x-tbar-calendar", "itemId": "show_today", "menu_item_text": "Today", "overflowText": "Today", "panel_btn_handler": Lino.row_action_handler('show_today','GET',null), "tooltip": "Show all calendar events of the same day." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "itemId": "update_guests", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Populate or update the list of participants for this entry\naccording to the suggestions.") }, "menu_item_text": "Update Guests", "overflowText": "Update Guests", "panel_btn_handler": Lino.row_action_handler('update_guests','GET',null), "text": "\u00a0\u2637\u00a0" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "itemId": "update_events", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Create or update the automatic events controlled by this generator.") }, "menu_item_text": "Update Events", "overflowText": "Update Events", "panel_btn_handler": Lino.row_action_handler('update_events','GET',null), "text": "\u00a0\u26a1\u00a0" } ],
  ls_url: "/courses/EntriesByCourse",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.EntriesByCourse.detail;
    this.ls_insert_handler = Lino.courses.EntriesByCourse.insert;
    Lino.courses.EntriesByCourse.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.EntriesByCourse.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.EntriesByCourse.detailPanel(p);
});
Lino.courses.EntriesByCourse.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.show_conflicting = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "show_conflicting", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.show_today = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "show_today", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.cal.Events.ParamsPanel({});
  return new Lino.courses.EntriesByCourse.GridPanel(p);
});
Lino.courses.EntriesByCourse.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.update_guests = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "update_guests", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.move_next = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "move_next", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.assign_to_me = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "assign_to_me", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.take = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "take", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.update_events = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "update_events", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.reset_event = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "reset_event", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.wf2 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "wf2", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.EntriesByCourse.wf3 = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/EntriesByCourse", "GET", pk, "wf3", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class excerpts.ExcerptsByOwner
Lino.excerpts.ExcerptsByOwner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true, "getRowClass": Lino.getRowClass },
  ls_url : "/excerpts/ExcerptsByOwner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/ExcerptsByOwner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  cell_edit : true,
  title : "Existing excerpts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disabled_actions_index : 27,
  ls_store_fields : [ { "name": "build_time" }, { "name": "excerpt_type" }, 'excerpt_typeHidden', { "name": "user" }, 'userHidden', { "name": "id", "type": "int" }, { "name": "build_method" }, 'build_methodHidden', { "name": "company" }, 'companyHidden', { "name": "contact_person" }, 'contact_personHidden', { "name": "contact_role" }, 'contact_roleHidden', { "name": "owner_type" }, 'owner_typeHidden', { "name": "owner_id" }, 'owner_idHidden', { "name": "language" }, 'languageHidden', { "name": "body_template_content" }, { "name": "preview" }, { "name": "workflow_buttons" }, { "name": "overview" }, { "name": "description_column" }, { "name": "owner" }, { "name": "disabled_fields" }, { "name": "disabled_actions" }, { "name": "disable_editing" } ],
  pk_index : 5,
  ls_grid_configs : [  ],
  content_type : 76,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByOwner.detail;
    var ww = this.containing_window;
    var build_time7119 = new Ext.form.DisplayField({ "disabled": true, "value": "<br>" });
    var excerpt_type7120 = new Lino.RemoteComboFieldElement({ "allowBlank": false, "emptyText": "Select a Excerpt Type...", "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/excerpt_type" }) }) });
    var user7121 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a User...", "pageSize": 20, "preferred_width": 15, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/user" }) }) });
    var id7122 = new Ext.form.NumberField({ "hidden": true, "selectOnFocus": true });
    var build_method7123 = new Lino.ChoicesFieldElement({ "forceSelection": true, "hidden": true, "selectOnFocus": true, "store": [['','<br>']].concat(Lino.printing.BuildMethods) });
    var company7124 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Organization...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/company" }) }) });
    var contact_person7125 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Person...", "hidden": true, "pageSize": 20, "preferred_width": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/contact_person" }) }) });
    var contact_role7126 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a Function...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/contact_role" }) }) });
    var owner_type7127 = new Lino.RemoteComboFieldElement({ "emptyText": "Select a content type...", "hidden": true, "pageSize": 20, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/owner_type" }) }) });
    var owner_id7128 = new Lino.RemoteComboFieldElement({ "hidden": true, "selectOnFocus": true, "store": new Lino.ComplexRemoteComboStore({ "proxy": new Ext.data.HttpProxy({ "method": "GET", "url": "/choices/excerpts/ExcerptsByOwner/owner_id" }) }) });
    var language7129 = new Lino.ChoicesFieldElement({ "hidden": true, "selectOnFocus": true, "store": [ [ "en", "English" ], [ "de", "German" ], [ "fr", "French" ] ] });
    var body_template_content7130 = new Ext.form.TextArea({ "disabled": true, "growMax": 2000, "hidden": true });
    var preview_htmlbox7131 = new Lino.HtmlBoxPanel({ "always_enabled": true, "bodyStyle": "overflow-x:hidden;", "containing_panel": this, "hidden": true, "items": new Ext.BoxComponent({autoScroll:true}), "layout": "fit", "name": "preview", "title": "Preview", "value": "<br/>" });
    var workflow_buttons_disp7132 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var overview_disp7133 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var description_column_disp7134 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var owner_disp7135 = new Ext.form.DisplayField({ "disabled": true, "hidden": true });
    this.before_row_edit = function(record) {
      var bp = this.get_base_params();
      excerpt_type7120.setContextValue('mk',bp['mk']);
      excerpt_type7120.setContextValue('mt',bp['mt']);
      contact_person7125.setContextValue('company', record ? record.data['companyHidden'] : undefined);
      owner_id7128.setContextValue('owner_type', record ? record.data['owner_typeHidden'] : undefined);
      preview_htmlbox7131.refresh();
    };
    this.onRender = function(ct, position) {
      owner_disp7135.on('change',Lino.chooser_handler(excerpt_type7120,'owner'));
      company7124.on('change',Lino.chooser_handler(contact_person7125,'company'));
      owner_type7127.on('change',Lino.chooser_handler(owner_id7128,'owner_type'));
      Lino.excerpts.ExcerptsByOwner.GridPanel.superclass.onRender.call(this, ct, position);
    }
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "build_time", "editable": false, "header": "build time", "sortable": true, "tooltip": "(excerpts.ExcerptsByOwner.build_time) Timestamp of the built target file. Contains None\nif no build hasn't been called yet.", "width": Lino.chars2width(17) }, { "colIndex": 1, "dataIndex": "excerpt_type", "editable": true, "editor": excerpt_type7120, "filter": { "type": "string" }, "header": "Excerpt Type", "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.excerpt_type) The type of this excerpt (ForeignKey to ExcerptType).", "width": Lino.chars2width(21) }, { "colIndex": 2, "dataIndex": "user", "editable": true, "editor": user7121, "filter": { "type": "string" }, "header": "Author", "renderer": Lino.fk_renderer('userHidden','Lino.users.Users.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.user) The author of this object.\nA pointer to lino.modlib.users.models.User.", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "id", "editable": true, "editor": id7122, "filter": { "type": "numeric" }, "format": "0", "header": "ID", "hidden": true, "sortable": true, "tooltip": "(excerpts.ExcerptsByOwner.id) ", "width": Lino.chars2width(6) }, { "colIndex": 4, "dataIndex": "build_method", "editable": true, "editor": build_method7123, "filter": { "type": "string" }, "header": "Build method", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.build_method) ", "width": Lino.chars2width(24) }, { "colIndex": 5, "dataIndex": "company", "editable": true, "editor": company7124, "filter": { "type": "string" }, "header": "Recipient (Organization)", "hidden": true, "renderer": Lino.fk_renderer('companyHidden','Lino.contacts.Companies.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.company) The optional company of the recipient of this\nexcerpt.  See ContactRelated.company.", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "contact_person", "editable": true, "editor": contact_person7125, "filter": { "type": "string" }, "header": "Recipient (Person)", "hidden": true, "renderer": Lino.fk_renderer('contact_personHidden','Lino.contacts.Persons.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.contact_person) The optional contact person of the recipient of this\nexcerpt.  See ContactRelated.contact_person.", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "contact_role", "editable": true, "editor": contact_role7126, "filter": { "type": "string" }, "header": "represented as", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.contact_role) The optional Role\nof the contact_person within company.", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "owner_type", "editable": true, "editor": owner_type7127, "filter": { "type": "string" }, "header": "Controlled by (type)", "hidden": true, "renderer": Lino.fk_renderer('owner_typeHidden','Lino.gfks.ContentTypes.detail'), "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.owner_type) ", "width": Lino.chars2width(21) }, { "colIndex": 9, "dataIndex": "owner_id", "editable": true, "editor": owner_id7128, "filter": { "type": "string" }, "header": "Controlled by (object)", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.owner_id) ", "width": Lino.chars2width(11) }, { "colIndex": 10, "dataIndex": "language", "editable": true, "editor": language7129, "filter": { "type": "string" }, "header": "Language", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.language) The language used for printing this excerpt.", "width": Lino.chars2width(21) }, { "colIndex": 11, "dataIndex": "body_template_content", "editable": false, "header": "Body template", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.body_template_content) ", "width": Lino.chars2width(61) }, { "colIndex": 12, "dataIndex": "preview", "editable": false, "header": "Preview", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.preview) ", "width": Lino.chars2width(31) }, { "colIndex": 13, "dataIndex": "workflow_buttons", "editable": false, "header": "Actions", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.workflow_buttons) ", "width": Lino.chars2width(31) }, { "colIndex": 14, "dataIndex": "overview", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.overview) ", "width": Lino.chars2width(31) }, { "colIndex": 15, "dataIndex": "description_column", "editable": false, "header": "Description", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.description_column) ", "width": Lino.chars2width(31) }, { "colIndex": 16, "dataIndex": "owner", "editable": false, "header": "Controlled by", "hidden": true, "sortable": false, "tooltip": "(excerpts.ExcerptsByOwner.owner) The object being printed by this excerpt.\nSee Controllable.owner.", "width": Lino.chars2width(11) } ];
    Lino.excerpts.ExcerptsByOwner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByOwner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.submit_detail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "submit_detail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.grid_put = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "grid_put", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.grid_post = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "grid_post", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.submit_insert = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "submit_insert", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.duplicate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "duplicate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.excerpts.ExcerptsByOwner.detailPanel = Ext.extend(Lino.excerpts.Excerpts.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": false, "iconCls": "x-tbar-disk", "itemId": "submit_detail", "menu_item_text": "Save", "overflowText": "Save", "panel_btn_handler": function(panel){panel.save()}, "tooltip": "Save changes in this form" }, { "auto_save": true, "itemId": "duplicate", "listeners": { "render": Lino.quicktip_renderer('a2btn',"Duplicate this row.") }, "menu_item_text": "\u2687", "overflowText": "\u2687", "panel_btn_handler": Lino.row_action_handler('duplicate','GET',null), "text": " <font size=\"4\">\u2687</font>" }, { "auto_save": false, "iconCls": "x-tbar-delete", "itemId": "delete_selected", "keycode": 46, "menu_item_text": "Delete", "overflowText": "Delete", "panel_btn_handler": Lino.row_action_handler('delete_selected','GET',null), "tooltip": "Delete this record" }, { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','POST',null), "tooltip": "A print action which uses a cache for the generated printable\ndocument and builds is only when it doesn't yet exist." }, { "auto_save": true, "iconCls": "x-tbar-printer_delete", "itemId": "do_clear_cache", "menu_item_text": "Clear cache", "overflowText": "Clear cache", "panel_btn_handler": Lino.row_action_handler('do_clear_cache','GET',null), "tooltip": "Defines the Clear cache button on a Printable record." }, { "iconCls": "x-tbar-bell", "menu": [ { "auto_save": true, "itemId": "check_plausibility", "menu_item_text": "Check plausibility", "overflowText": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": "Check plausibility", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." }, { "auto_save": true, "itemId": "fix_problems", "menu_item_text": "Fix plausibility problems", "overflowText": "Fix plausibility problems", "panel_btn_handler": Lino.row_action_handler('fix_problems','GET',null), "text": "Fix plausibility problems", "tooltip": "Updates the table of plausibility problems for a given database\nobject, also removing those messages which no longer exist. This\naction does not change anything else in the database." } ], "menu_item_text": "Check plausibility", "panel_btn_handler": Lino.row_action_handler('check_plausibility','GET',null), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-script_add", "itemId": "create_postings", "menu_item_text": "Create posting", "overflowText": "Create posting", "panel_btn_handler": Lino.row_action_handler('create_postings','GET',null), "tooltip": "Create classical mail postings from this" }, { "auto_save": true, "iconCls": "x-tbar-email_add", "itemId": "create_mail", "menu_item_text": "Create email", "overflowText": "Create email", "panel_btn_handler": Lino.row_action_handler('create_mail','GET',null), "tooltip": "Create an email from this" } ],
  ls_url: "/excerpts/ExcerptsByOwner",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.excerpts.ExcerptsByOwner.detail;
    Lino.excerpts.ExcerptsByOwner.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.ExcerptsByOwner.detail = new Lino.WindowAction({ "autoHeight": true, "draggable": true, "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(80) }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.ExcerptsByOwner.detailPanel(p);
});
Lino.excerpts.ExcerptsByOwner.delete_selected = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "delete_selected", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "POST", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.do_clear_cache = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "do_clear_cache", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.excerpts.Excerpts.ParamsPanel({});
  return new Lino.excerpts.ExcerptsByOwner.GridPanel(p);
});
Lino.excerpts.ExcerptsByOwner.validate = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "validate", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.check_plausibility = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "check_plausibility", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.fix_problems = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "fix_problems", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.create_postings = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "create_postings", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.ExcerptsByOwner.create_mail = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/ExcerptsByOwner", "GET", pk, "create_mail", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class about.Models
Lino.about.Models.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/Models",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/Models','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/Models','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/about/Models','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/Models','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/Models','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" } ],
  cell_edit : true,
  title : "Models",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "app" }, { "name": "name" }, { "name": "fields" }, { "name": "tables" }, { "name": "rows" }, { "name": "detail_action" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    this.ls_detail_handler = Lino.about.Models.detail;
    var ww = this.containing_window;
    var app_disp7137 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var name_disp7138 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var fields_disp7139 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var tables_disp7140 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var rows7141 = new Ext.form.NumberField({ "disabled": true });
    var detail_action_disp7142 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "app", "editable": false, "header": "app_label", "sortable": false, "tooltip": "(about.Models.app) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(about.Models.name) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "fields", "editable": false, "header": "Fields", "sortable": false, "tooltip": "(about.Models.fields) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "tables", "editable": false, "header": "Tables", "sortable": false, "tooltip": "(about.Models.tables) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 4, "dataIndex": "rows", "editable": false, "format": "0", "header": "Rows", "sortable": false, "tooltip": "(about.Models.rows) ", "width": Lino.chars2width(6) }, { "colIndex": 5, "dataIndex": "detail_action", "editable": false, "header": "Detail Action", "sortable": false, "tooltip": "(about.Models.detail_action) ", "width": Lino.chars2width(31) } ];
    Lino.about.Models.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.Models.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Models", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Models.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Models", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Models.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Models", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Models.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Models", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.about.Models.detailPanel = Ext.extend(Lino.about.Models.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/about/Models",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.about.Models.detail;
    Lino.about.Models.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.about.Models.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.Models.detailPanel(p);
});
Lino.about.Models.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.Models.GridPanel(p);
});

// js_render_GridPanel_class about.FieldsByModel
Lino.about.FieldsByModel.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/FieldsByModel",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/FieldsByModel','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Fields",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 3,
  ls_store_fields : [ { "name": "name" }, { "name": "verbose_name" }, { "name": "help_text_column" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var name_disp2746 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var verbose_name_disp2747 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var help_text_column_disp2748 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(about.FieldsByModel.name) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "verbose_name", "editable": false, "header": "verbose name", "sortable": false, "tooltip": "(about.FieldsByModel.verbose_name) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "help_text_column", "editable": false, "header": "help text", "sortable": false, "tooltip": "(about.FieldsByModel.help_text_column) ", "width": Lino.chars2width(31) } ];
    Lino.about.FieldsByModel.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.FieldsByModel.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/FieldsByModel", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/FieldsByModel", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/FieldsByModel", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/FieldsByModel", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.FieldsByModel.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.FieldsByModel.GridPanel(p);
});

// js_render_GridPanel_class about.Inspector
Lino.about.Inspector.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/Inspector",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/Inspector','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Inspector",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 3,
  ls_store_fields : [ { "name": "i_name" }, { "name": "i_type" }, { "name": "i_value" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var i_name_disp7144 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var i_type_disp7145 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var i_value_disp7146 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "i_name", "editable": false, "header": "Name", "sortable": false, "tooltip": "(about.Inspector.i_name) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "i_type", "editable": false, "header": "Type", "sortable": false, "tooltip": "(about.Inspector.i_type) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "i_value", "editable": false, "header": "Value", "sortable": false, "tooltip": "(about.Inspector.i_value) ", "width": Lino.chars2width(31) } ];
    Lino.about.Inspector.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.Inspector.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Inspector", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Inspector", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Inspector", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/Inspector", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.Inspector.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.about.Inspector.ParamsPanel({});
  return new Lino.about.Inspector.GridPanel(p);
});

// js_render_GridPanel_class about.SourceFiles
Lino.about.SourceFiles.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/about/SourceFiles",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/about/SourceFiles','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Source files",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 3,
  ls_store_fields : [ { "name": "module_name" }, { "name": "code_lines", "type": "int", "useNull": true }, { "name": "doc_lines", "type": "int", "useNull": true }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var module_name7148 = new Ext.form.TextField({ "disabled": true, "maxLength": null });
    var code_lines7149 = new Ext.form.NumberField({ "disabled": true });
    var doc_lines7150 = new Ext.form.NumberField({ "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "module_name", "editable": false, "header": "module name", "sortable": false, "tooltip": "(about.SourceFiles.module_name) ", "width": Lino.chars2width(5) }, { "align": "right", "colIndex": 1, "dataIndex": "code_lines", "editable": false, "format": "0", "header": "Code", "sortable": false, "tooltip": "(about.SourceFiles.code_lines) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 2, "dataIndex": "doc_lines", "editable": false, "format": "0", "header": "doc", "sortable": false, "tooltip": "(about.SourceFiles.doc_lines) ", "width": Lino.chars2width(6) } ];
    Lino.about.SourceFiles.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.about.SourceFiles.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/SourceFiles", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/SourceFiles", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/SourceFiles", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/about/SourceFiles", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.about.SourceFiles.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.about.SourceFiles.GridPanel(p);
});

// js_render_GridPanel_class gfks.BrokenGFKs
Lino.gfks.BrokenGFKs.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/gfks/BrokenGFKs",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKs','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Broken GFKs",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "database_model" }, { "name": "database_object" }, { "name": "message" }, { "name": "todo" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var database_model_disp7152 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var database_object_disp7153 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var message_disp7154 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var todo_disp7155 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "database_model", "editable": false, "header": "Database model", "sortable": false, "tooltip": "(gfks.BrokenGFKs.database_model) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "database_object", "editable": false, "header": "Database object", "sortable": false, "tooltip": "(gfks.BrokenGFKs.database_object) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "message", "editable": false, "header": "Message", "sortable": false, "tooltip": "(gfks.BrokenGFKs.message) ", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "todo", "editable": false, "header": "Action", "sortable": false, "tooltip": "(gfks.BrokenGFKs.todo) ", "width": Lino.chars2width(31) } ];
    Lino.gfks.BrokenGFKs.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.BrokenGFKs.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKs", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKs", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKs", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKs", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKs.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.BrokenGFKs.GridPanel(p);
});

// js_render_GridPanel_class gfks.BrokenGFKsByModel
Lino.gfks.BrokenGFKsByModel.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/gfks/BrokenGFKsByModel",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/gfks/BrokenGFKsByModel','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Broken GFKs",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 4,
  ls_store_fields : [ { "name": "database_object" }, { "name": "message" }, { "name": "todo" }, { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 3,
  ls_grid_configs : [  ],
  content_type : 1,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var database_object_disp2139 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var message_disp2140 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var todo_disp2141 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "database_object", "editable": false, "header": "Database object", "sortable": false, "tooltip": "(gfks.BrokenGFKsByModel.database_object) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "message", "editable": false, "header": "Message", "sortable": false, "tooltip": "(gfks.BrokenGFKsByModel.message) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "todo", "editable": false, "header": "Action", "sortable": false, "tooltip": "(gfks.BrokenGFKsByModel.todo) ", "width": Lino.chars2width(31) } ];
    Lino.gfks.BrokenGFKsByModel.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.gfks.BrokenGFKsByModel.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKsByModel", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKsByModel", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKsByModel", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/gfks/BrokenGFKsByModel", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.gfks.BrokenGFKsByModel.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.gfks.BrokenGFKsByModel.GridPanel(p);
});

// js_render_GridPanel_class ledger.ExpectedMovements
Lino.ledger.ExpectedMovements.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/ExpectedMovements",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/ExpectedMovements','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  page_length : 20,
  cell_edit : true,
  title : "Debts",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "balance" }, { "name": "debts" }, { "name": "payments" }, { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var due_date7157 = new Lino.DateField({ "disabled": true });
    var balance7158 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var debts_disp7159 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7160 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(ledger.ExpectedMovements.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(16), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(ledger.ExpectedMovements.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(ledger.ExpectedMovements.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(ledger.ExpectedMovements.payments) List of payments in this match group", "width": Lino.chars2width(31) } ];
    Lino.ledger.ExpectedMovements.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.ExpectedMovements.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/ExpectedMovements", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/ExpectedMovements", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/ExpectedMovements", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/ExpectedMovements", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.ExpectedMovements.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.ledger.ExpectedMovements.GridPanel(p);
});

// js_render_GridPanel_class ledger.DebtsByAccount
Lino.ledger.DebtsByAccount.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/DebtsByAccount",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByAccount','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  page_length : 20,
  cell_edit : true,
  title : "Debts",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "balance" }, { "name": "debts" }, { "name": "payments" }, { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var due_date7162 = new Lino.DateField({ "disabled": true });
    var balance7163 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var debts_disp7164 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7165 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(ledger.DebtsByAccount.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(16), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(ledger.DebtsByAccount.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(ledger.DebtsByAccount.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(ledger.DebtsByAccount.payments) List of payments in this match group", "width": Lino.chars2width(31) } ];
    Lino.ledger.DebtsByAccount.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.DebtsByAccount.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByAccount", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByAccount", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByAccount", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByAccount", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByAccount.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.ledger.DebtsByAccount.GridPanel(p);
});

// js_render_GridPanel_class ledger.DebtsByPartner
Lino.ledger.DebtsByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/DebtsByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/DebtsByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  page_length : 20,
  cell_edit : true,
  title : "Debts",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "balance" }, { "name": "debts" }, { "name": "payments" }, { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 4,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var due_date7167 = new Lino.DateField({ "disabled": true });
    var balance7168 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var debts_disp7169 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7170 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(ledger.DebtsByPartner.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(16), "xtype": "datecolumn" }, { "align": "right", "colIndex": 1, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(ledger.DebtsByPartner.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 2, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(ledger.DebtsByPartner.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 3, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(ledger.DebtsByPartner.payments) List of payments in this match group", "width": Lino.chars2width(31) } ];
    Lino.ledger.DebtsByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.DebtsByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/DebtsByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.DebtsByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.ledger.DebtsByPartner.GridPanel(p);
});

// js_render_GridPanel_class ledger.GeneralAccountsBalance
Lino.ledger.GeneralAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/GeneralAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/GeneralAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "General Accounts Balances",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "ref" }, { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var ref_disp7172 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp7173 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d7174 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c7175 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_d7176 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c7177 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_d7178 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c7179 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": false, "header": "Ref", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.ref) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "old_d", "editable": false, "header": "Debit\nbefore", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.old_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "old_c", "editable": false, "header": "Credit\nbefore", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.old_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.during_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.during_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "new_d", "editable": false, "header": "Debit\nafter", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.new_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 7, "dataIndex": "new_c", "editable": false, "header": "Credit\nafter", "sortable": false, "tooltip": "(ledger.GeneralAccountsBalance.new_c) ", "width": Lino.chars2width(13) } ];
    Lino.ledger.GeneralAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.GeneralAccountsBalance.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/GeneralAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/GeneralAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/GeneralAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/GeneralAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.GeneralAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.GeneralAccountsBalance.GridPanel(p);
});

// js_render_GridPanel_class ledger.PartnerAccountsBalance
Lino.ledger.PartnerAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/PartnerAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PartnerAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "PartnerAccountsBalance",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "ref" }, { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var ref_disp7181 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp7182 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d7183 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c7184 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_d7185 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c7186 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_d7187 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c7188 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": false, "header": "Ref", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.ref) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "old_d", "editable": false, "header": "Debit\nbefore", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.old_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "old_c", "editable": false, "header": "Credit\nbefore", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.old_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.during_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.during_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "new_d", "editable": false, "header": "Debit\nafter", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.new_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 7, "dataIndex": "new_c", "editable": false, "header": "Credit\nafter", "sortable": false, "tooltip": "(ledger.PartnerAccountsBalance.new_c) ", "width": Lino.chars2width(13) } ];
    Lino.ledger.PartnerAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PartnerAccountsBalance.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PartnerAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PartnerAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.PartnerAccountsBalance.GridPanel(p);
});

// js_render_GridPanel_class ledger.CustomerAccountsBalance
Lino.ledger.CustomerAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/CustomerAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/CustomerAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Customer Accounts Balances",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "ref" }, { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var ref_disp7190 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp7191 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d7192 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c7193 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_d7194 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c7195 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_d7196 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c7197 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": false, "header": "Ref", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.ref) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "old_d", "editable": false, "header": "Debit\nbefore", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.old_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "old_c", "editable": false, "header": "Credit\nbefore", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.old_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.during_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.during_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "new_d", "editable": false, "header": "Debit\nafter", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.new_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 7, "dataIndex": "new_c", "editable": false, "header": "Credit\nafter", "sortable": false, "tooltip": "(ledger.CustomerAccountsBalance.new_c) ", "width": Lino.chars2width(13) } ];
    Lino.ledger.CustomerAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.CustomerAccountsBalance.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/CustomerAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/CustomerAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/CustomerAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/CustomerAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.CustomerAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.CustomerAccountsBalance.GridPanel(p);
});

// js_render_GridPanel_class ledger.SupplierAccountsBalance
Lino.ledger.SupplierAccountsBalance.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/SupplierAccountsBalance",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/SupplierAccountsBalance','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Supplier Accounts Balances",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 8,
  ls_store_fields : [ { "name": "ref" }, { "name": "description" }, { "name": "old_d" }, { "name": "old_c" }, { "name": "during_d" }, { "name": "during_c" }, { "name": "new_d" }, { "name": "new_c" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var ref_disp7199 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var description_disp7200 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var old_d7201 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var old_c7202 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_d7203 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var during_c7204 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_d7205 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var new_c7206 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "ref", "editable": false, "header": "Ref", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.ref) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "description", "editable": false, "header": "Description", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.description) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "old_d", "editable": false, "header": "Debit\nbefore", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.old_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "old_c", "editable": false, "header": "Credit\nbefore", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.old_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "during_d", "editable": false, "header": "Debit", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.during_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 5, "dataIndex": "during_c", "editable": false, "header": "Credit", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.during_c) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 6, "dataIndex": "new_d", "editable": false, "header": "Debit\nafter", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.new_d) ", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 7, "dataIndex": "new_c", "editable": false, "header": "Credit\nafter", "sortable": false, "tooltip": "(ledger.SupplierAccountsBalance.new_c) ", "width": Lino.chars2width(13) } ];
    Lino.ledger.SupplierAccountsBalance.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.SupplierAccountsBalance.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/SupplierAccountsBalance", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/SupplierAccountsBalance", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/SupplierAccountsBalance", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/SupplierAccountsBalance", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.SupplierAccountsBalance.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.SupplierAccountsBalance.GridPanel(p);
});

// js_render_GridPanel_class ledger.Debtors
Lino.ledger.Debtors.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/Debtors",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Debtors','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Debtors",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "age", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "partner_id", "type": "int", "useNull": true }, { "name": "balance" }, { "name": "vouchers" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var age7208 = new Ext.form.NumberField({ "disabled": true });
    var due_date7209 = new Lino.DateField({ "disabled": true });
    var partner7210 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner_id7211 = new Ext.form.NumberField({ "disabled": true });
    var balance7212 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var vouchers_disp7213 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "age", "editable": false, "format": "0", "header": "Age", "sortable": false, "tooltip": "(ledger.Debtors.age) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(ledger.Debtors.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": false, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.Debtors.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "partner_id", "editable": false, "format": "0", "header": "ID", "sortable": false, "tooltip": "(ledger.Debtors.partner_id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 4, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(ledger.Debtors.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "vouchers", "editable": false, "header": "Vouchers", "sortable": false, "tooltip": "(ledger.Debtors.vouchers) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Debtors.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Debtors.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Debtors", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Debtors", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Debtors", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Debtors", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Debtors.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Debtors.ParamsPanel({});
  return new Lino.ledger.Debtors.GridPanel(p);
});

// js_render_GridPanel_class ledger.Creditors
Lino.ledger.Creditors.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/ledger/Creditors",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/Creditors','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Creditors",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "age", "type": "int", "useNull": true }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "partner" }, 'partnerHidden', { "name": "partner_id", "type": "int", "useNull": true }, { "name": "balance" }, { "name": "vouchers" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var age7215 = new Ext.form.NumberField({ "disabled": true });
    var due_date7216 = new Lino.DateField({ "disabled": true });
    var partner7217 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner_id7218 = new Ext.form.NumberField({ "disabled": true });
    var balance7219 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var vouchers_disp7220 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "align": "right", "colIndex": 0, "dataIndex": "age", "editable": false, "format": "0", "header": "Age", "sortable": false, "tooltip": "(ledger.Creditors.age) ", "width": Lino.chars2width(6) }, { "colIndex": 1, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(ledger.Creditors.due_date) ", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 2, "dataIndex": "partner", "editable": false, "header": "Partner", "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(ledger.Creditors.partner) ", "width": Lino.chars2width(21) }, { "align": "right", "colIndex": 3, "dataIndex": "partner_id", "editable": false, "format": "0", "header": "ID", "sortable": false, "tooltip": "(ledger.Creditors.partner_id) ", "width": Lino.chars2width(6) }, { "align": "right", "colIndex": 4, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(ledger.Creditors.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 5, "dataIndex": "vouchers", "editable": false, "header": "Vouchers", "sortable": false, "tooltip": "(ledger.Creditors.vouchers) ", "width": Lino.chars2width(31) } ];
    Lino.ledger.Creditors.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Creditors.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Creditors", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Creditors", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Creditors", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Creditors", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.Creditors.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Creditors.ParamsPanel({});
  return new Lino.ledger.Creditors.GridPanel(p);
});

// js_render_GridPanel_class vat.VouchersByPartner
Lino.vat.VouchersByPartner.GridPanel = Ext.extend(Lino.GridPanel,{
  ls_url : "/vat/VouchersByPartner",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/vat/VouchersByPartner','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "VAT vouchers",
  page_length : 20,
  params_panel_hidden : true,
  gc_name : 0,
  disable_editing : true,
  disabled_actions_index : 5,
  ls_store_fields : [ { "dateFormat": "d.m.Y", "name": "voucher_date", "type": "date" }, { "name": "voucher" }, { "name": "total_incl" }, { "name": "total_base" }, { "name": "total_vat" }, { "name": "disabled_actions" } ],
  stripeRows : true,
  ls_grid_configs : [  ],
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  initComponent : function() {
    var ww = this.containing_window;
    var voucher_date7222 = new Lino.DateField({ "disabled": true });
    var voucher_disp7223 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var total_incl7224 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var total_base7225 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var total_vat7226 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "voucher_date", "editable": false, "format": "d.m.Y", "header": "Voucher date", "sortable": false, "tooltip": "(vat.VouchersByPartner.voucher_date) The date on the voucher, i.e. when this voucher has been\nissued by its emitter.", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 1, "dataIndex": "voucher", "editable": false, "header": "Voucher", "sortable": false, "tooltip": "(vat.VouchersByPartner.voucher) ", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 2, "dataIndex": "total_incl", "editable": false, "header": "Total incl. VAT", "sortable": false, "tooltip": "(vat.VouchersByPartner.total_incl) A lino.core.fields.PriceField which stores the total\namount VAT included.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 3, "dataIndex": "total_base", "editable": false, "header": "Total excl. VAT", "sortable": false, "tooltip": "(vat.VouchersByPartner.total_base) A lino.core.fields.PriceField which stores the total\namount VAT excluded.", "width": Lino.chars2width(13) }, { "align": "right", "colIndex": 4, "dataIndex": "total_vat", "editable": false, "header": "VAT", "sortable": false, "tooltip": "(vat.VouchersByPartner.total_vat) A lino.core.fields.PriceField which stores the amount\nof VAT.", "width": Lino.chars2width(13) } ];
    Lino.vat.VouchersByPartner.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.vat.VouchersByPartner.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/VouchersByPartner", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/VouchersByPartner", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/VouchersByPartner", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/vat/VouchersByPartner", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.vat.VouchersByPartner.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.vat.VouchersByPartner.GridPanel(p);
});

// js_render_GridPanel_class finan.SuggestionsByVoucher
Lino.finan.SuggestionsByVoucher.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByVoucher",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucher','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7228 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7229 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7230 = new Lino.DateField({ "disabled": true });
    var debts_disp7231 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7232 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7233 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7234 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7235 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7236 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByVoucher.partner) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByVoucher.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByVoucher.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucher", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucher", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucher", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucher", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucher.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByVoucher.GridPanel(p);
});
Lino.finan.SuggestionsByVoucher.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucher", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByJournalEntry
Lino.finan.SuggestionsByJournalEntry.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByJournalEntry",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByJournalEntry','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7238 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7239 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7240 = new Lino.DateField({ "disabled": true });
    var debts_disp7241 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7242 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7243 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7244 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7245 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7246 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByJournalEntry.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByJournalEntry.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByJournalEntry.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByJournalEntry", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByJournalEntry", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByJournalEntry", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByJournalEntry", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByJournalEntry.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByJournalEntry.GridPanel(p);
});
Lino.finan.SuggestionsByJournalEntry.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByJournalEntry", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByPaymentOrder
Lino.finan.SuggestionsByPaymentOrder.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByPaymentOrder",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrder','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7248 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7249 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7250 = new Lino.DateField({ "disabled": true });
    var debts_disp7251 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7252 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7253 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7254 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7255 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7256 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrder.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByPaymentOrder.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByPaymentOrder.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrder", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrder", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrder", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrder", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrder.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByPaymentOrder.GridPanel(p);
});
Lino.finan.SuggestionsByPaymentOrder.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrder", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByBankStatement
Lino.finan.SuggestionsByBankStatement.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByBankStatement",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatement','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7258 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7259 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7260 = new Lino.DateField({ "disabled": true });
    var debts_disp7261 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7262 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7263 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7264 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7265 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7266 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatement.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByBankStatement.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByBankStatement.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatement", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatement", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatement", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatement", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatement.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByBankStatement.GridPanel(p);
});
Lino.finan.SuggestionsByBankStatement.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatement", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByVoucherItem
Lino.finan.SuggestionsByVoucherItem.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByVoucherItem",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByVoucherItem','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7268 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7269 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7270 = new Lino.DateField({ "disabled": true });
    var debts_disp7271 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7272 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7273 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7274 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7275 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7276 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.partner) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByVoucherItem.bank_account) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByVoucherItem.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByVoucherItem.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucherItem", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucherItem", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucherItem", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucherItem", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByVoucherItem.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByVoucherItem.GridPanel(p);
});
Lino.finan.SuggestionsByVoucherItem.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByVoucherItem", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByBankStatementItem
Lino.finan.SuggestionsByBankStatementItem.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByBankStatementItem",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByBankStatementItem','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7278 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7279 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7280 = new Lino.DateField({ "disabled": true });
    var debts_disp7281 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7282 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7283 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7284 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7285 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7286 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByBankStatementItem.partner) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByBankStatementItem.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByBankStatementItem.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatementItem", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatementItem", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatementItem", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatementItem", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByBankStatementItem.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByBankStatementItem.GridPanel(p);
});
Lino.finan.SuggestionsByBankStatementItem.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByBankStatementItem", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class finan.SuggestionsByPaymentOrderItem
Lino.finan.SuggestionsByPaymentOrderItem.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "cellTpl": new Ext.Template(
'<td class="x-grid3-col x-grid3-cell x-grid3-td-{id} {css}" style="{style}" tabIndex="0" {cellAttr}>',
'<div class="x-grid3-cell-inner x-grid3-col-{id}" unselectable="on" style="height:44px" {attr}>{value}</div>',
'</td>'), "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/finan/SuggestionsByPaymentOrderItem",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-lightning", "itemId": "do_fill", "menu_item_text": "Fill", "overflowText": "Fill", "panel_btn_handler": Lino.list_action_handler('/finan/SuggestionsByPaymentOrderItem','do_fill','POST',null), "tooltip": "Fill selected suggestions from a SuggestionsByVoucher table into a\nfinancial voucher." } ],
  page_length : 20,
  cell_edit : false,
  title : "Suggestions",
  row_height : 4,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 13,
  ls_store_fields : [ { "name": "info" }, { "name": "match" }, { "dateFormat": "d.m.Y", "name": "due_date", "type": "date" }, { "name": "debts" }, { "name": "payments" }, { "name": "balance" }, { "name": "account" }, 'accountHidden', { "name": "bank_account" }, 'bank_accountHidden', { "name": "partner" }, 'partnerHidden', { "name": "id", "type": "int" }, { "name": "disabled_actions" } ],
  pk_index : 12,
  ls_grid_configs : [  ],
  content_type : 40,
  ls_id_property : "id",
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var info_disp7288 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var match_disp7289 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var due_date7290 = new Lino.DateField({ "disabled": true });
    var debts_disp7291 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var payments_disp7292 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "value": "<br/>" });
    var balance7293 = new Ext.form.NumberField({ "decimalPrecision": 2, "decimalSeparator": ",", "disabled": true });
    var account7294 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var bank_account7295 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Bank account...", "hidden": true, "pageSize": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    var partner7296 = new Lino.RemoteComboFieldElement({ "disabled": true, "emptyText": "Select a Partner...", "hidden": true, "pageSize": 20, "preferred_width": 20, "store": new Lino.ComplexRemoteComboStore({  }) });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "info", "editable": false, "header": "Info", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.info) ", "width": Lino.chars2width(31) }, { "colIndex": 1, "dataIndex": "match", "editable": false, "header": "Match", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.match) ", "width": Lino.chars2width(31) }, { "colIndex": 2, "dataIndex": "due_date", "editable": false, "format": "d.m.Y", "header": "Due date", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.due_date) Due date of the eldest debt in this match group", "width": Lino.chars2width(14), "xtype": "datecolumn" }, { "colIndex": 3, "dataIndex": "debts", "editable": false, "header": "Debts", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.debts) List of invoices in this match group", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "payments", "editable": false, "header": "Payments", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.payments) List of payments in this match group", "width": Lino.chars2width(31) }, { "align": "right", "colIndex": 5, "dataIndex": "balance", "editable": false, "header": "Balance", "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.balance) ", "width": Lino.chars2width(13) }, { "colIndex": 6, "dataIndex": "account", "editable": false, "header": "Account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.account) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "bank_account", "editable": false, "header": "Bank account", "hidden": true, "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.bank_account) ", "width": Lino.chars2width(21) }, { "colIndex": 8, "dataIndex": "partner", "editable": false, "header": "Partner", "hidden": true, "renderer": Lino.fk_renderer('partnerHidden','Lino.contacts.Partners.detail'), "sortable": false, "tooltip": "(finan.SuggestionsByPaymentOrderItem.partner) ", "width": Lino.chars2width(21) } ];
    Lino.finan.SuggestionsByPaymentOrderItem.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.finan.SuggestionsByPaymentOrderItem.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrderItem", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.finan.SuggestionsByPaymentOrderItem.grid = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": "90%" }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ExpectedMovements.ParamsPanel({});
  return new Lino.finan.SuggestionsByPaymentOrderItem.GridPanel(p);
});
Lino.finan.SuggestionsByPaymentOrderItem.do_fill = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/finan/SuggestionsByPaymentOrderItem", "POST", pk, "do_fill", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.about.About.showPanel = Ext.extend(Lino.about.About.DetailFormPanel,{
  empty_title: "About",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/about/About",
  initComponent : function() {
    this.ls_detail_handler = Lino.about.About.show;
    Lino.about.About.showPanel.superclass.initComponent.call(this);
  }
});

Lino.about.About.show = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.about.About.showPanel(p);
});

Lino.about.About.showPanel = Ext.extend(Lino.about.About.DetailFormPanel,{
  empty_title: "About",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/about/About",
  initComponent : function() {
    this.ls_detail_handler = Lino.about.About.show;
    Lino.about.About.showPanel.superclass.initComponent.call(this);
  }
});

Lino.about.About.show = new Lino.WindowAction({ "draggable": true, "height": Lino.rows2height(20), "maximizable": true, "maximized": false, "modal": true, "width": Lino.chars2width(60) }, function(){
  var p = { "hide_top_toolbar": true, "is_main_window": true };
  return new Lino.about.About.showPanel(p);
});

Lino.ledger.Situation.showPanel = Ext.extend(Lino.ledger.Situation.DetailFormPanel,{
  empty_title: "Situation",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/ledger/Situation",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Situation.show;
    Lino.ledger.Situation.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Situation.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Situation.ParamsPanel({});
  return new Lino.ledger.Situation.showPanel(p);
});

Lino.ledger.Situation.showPanel = Ext.extend(Lino.ledger.Situation.DetailFormPanel,{
  empty_title: "Situation",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/ledger/Situation",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.Situation.show;
    Lino.ledger.Situation.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.Situation.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.Situation.ParamsPanel({});
  return new Lino.ledger.Situation.showPanel(p);
});
Lino.ledger.Situation.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/Situation", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.ledger.ActivityReport.showPanel = Ext.extend(Lino.ledger.ActivityReport.DetailFormPanel,{
  empty_title: "Activity Report",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/ledger/ActivityReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.ActivityReport.show;
    Lino.ledger.ActivityReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.ActivityReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ActivityReport.ParamsPanel({});
  return new Lino.ledger.ActivityReport.showPanel(p);
});

Lino.ledger.ActivityReport.showPanel = Ext.extend(Lino.ledger.ActivityReport.DetailFormPanel,{
  empty_title: "Activity Report",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/ledger/ActivityReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.ledger.ActivityReport.show;
    Lino.ledger.ActivityReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.ActivityReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  p.params_panel = new Lino.ledger.ActivityReport.ParamsPanel({});
  return new Lino.ledger.ActivityReport.showPanel(p);
});
Lino.ledger.ActivityReport.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/ActivityReport", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.extensible.CalendarPanel.grid = new Lino.WindowAction({  }, function(){
  return Lino.CalendarApp().get_main_panel();
});

Lino.courses.StatusReport.showPanel = Ext.extend(Lino.courses.StatusReport.DetailFormPanel,{
  empty_title: "Status Report",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/courses/StatusReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.StatusReport.show;
    Lino.courses.StatusReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.StatusReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.StatusReport.showPanel(p);
});

Lino.courses.StatusReport.showPanel = Ext.extend(Lino.courses.StatusReport.DetailFormPanel,{
  empty_title: "Status Report",
  hide_navigator: true,
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [ { "auto_save": true, "iconCls": "x-tbar-printer", "itemId": "do_print", "menu_item_text": "Print", "overflowText": "Print", "panel_btn_handler": Lino.row_action_handler('do_print','GET',null), "tooltip": "Print using a hard-coded template and without cache." } ],
  ls_url: "/courses/StatusReport",
  initComponent : function() {
    this.ls_detail_handler = Lino.courses.StatusReport.show;
    Lino.courses.StatusReport.showPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.StatusReport.show = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.StatusReport.showPanel(p);
});
Lino.courses.StatusReport.do_print = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/StatusReport", "GET", pk, "do_print", params, null);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

// js_render_GridPanel_class plausibility.Checkers
Lino.plausibility.Checkers.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/plausibility/Checkers",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/plausibility/Checkers','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" }, { "auto_save": true, "iconCls": "x-tbar-application_form", "itemId": "detail", "menu_item_text": "Detail", "overflowText": "Detail", "panel_btn_handler": Lino.show_detail, "tooltip": "Open a detail window on this record" } ],
  cell_edit : true,
  title : "Plausibility checkers",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 3,
  ls_store_fields : [ { "name": "value" }, { "name": "text" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Checkers.detail;
    var ww = this.containing_window;
    var value7298 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7299 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(plausibility.Checkers.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(plausibility.Checkers.text) ", "width": Lino.chars2width(22) } ];
    Lino.plausibility.Checkers.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Checkers.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Checkers", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Checkers.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Checkers", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Checkers.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Checkers", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.plausibility.Checkers.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/plausibility/Checkers", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};

Lino.plausibility.Checkers.detailPanel = Ext.extend(Lino.plausibility.Checkers.DetailFormPanel,{
  empty_title: "Detail",
  params_panel_hidden: true,
  save_action_name: "submit_detail",
  ls_bbar_actions: [  ],
  ls_url: "/plausibility/Checkers",
  action_name: "detail",
  initComponent : function() {
    this.ls_detail_handler = Lino.plausibility.Checkers.detail;
    Lino.plausibility.Checkers.detailPanel.superclass.initComponent.call(this);
  }
});

Lino.plausibility.Checkers.detail = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.Checkers.detailPanel(p);
});
Lino.plausibility.Checkers.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.plausibility.Checkers.GridPanel(p);
});

// js_render_GridPanel_class notes.SpecialTypes
Lino.notes.SpecialTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/notes/SpecialTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notes/SpecialTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Special note types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7301 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7302 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7303 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7304 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7305 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(notes.SpecialTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(notes.SpecialTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(notes.SpecialTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(notes.SpecialTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(notes.SpecialTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.notes.SpecialTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notes.SpecialTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/SpecialTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/SpecialTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/SpecialTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notes/SpecialTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notes.SpecialTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notes.SpecialTypes.GridPanel(p);
});

// js_render_GridPanel_class notify.MailModes
Lino.notify.MailModes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/notify/MailModes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/MailModes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Email notification modes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7307 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7308 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7309 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7310 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7311 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(notify.MailModes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(notify.MailModes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(notify.MailModes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(notify.MailModes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(notify.MailModes.type) ", "width": Lino.chars2width(31) } ];
    Lino.notify.MailModes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.MailModes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MailModes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MailModes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MailModes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MailModes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MailModes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notify.MailModes.GridPanel(p);
});

// js_render_GridPanel_class beid.CivilStates
Lino.beid.CivilStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/beid/CivilStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/beid/CivilStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Civil states",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7319 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7320 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7321 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7322 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7323 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(beid.CivilStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(beid.CivilStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(beid.CivilStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(beid.CivilStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(beid.CivilStates.type) ", "width": Lino.chars2width(31) } ];
    Lino.beid.CivilStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.beid.CivilStates.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/CivilStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/CivilStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/CivilStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/CivilStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.CivilStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.beid.CivilStates.GridPanel(p);
});

// js_render_GridPanel_class changes.ChangeTypes
Lino.changes.ChangeTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/changes/ChangeTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/changes/ChangeTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Change Types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7331 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7332 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7333 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7334 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7335 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(changes.ChangeTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(changes.ChangeTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(changes.ChangeTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(changes.ChangeTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(changes.ChangeTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.changes.ChangeTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.changes.ChangeTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangeTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangeTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangeTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/changes/ChangeTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.changes.ChangeTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.changes.ChangeTypes.GridPanel(p);
});

// js_render_GridPanel_class cal.DurationUnits
Lino.cal.DurationUnits.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/DurationUnits",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/DurationUnits','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "DurationUnits",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7337 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7338 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7339 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7340 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7341 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.DurationUnits.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.DurationUnits.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.DurationUnits.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(cal.DurationUnits.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(cal.DurationUnits.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.DurationUnits.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.DurationUnits.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/DurationUnits", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/DurationUnits", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/DurationUnits", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/DurationUnits", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.DurationUnits.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.DurationUnits.GridPanel(p);
});

// js_render_GridPanel_class courses.Sections
Lino.courses.Sections.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/courses/Sections",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/Sections','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Sections",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7343 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7344 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7345 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7346 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7347 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(courses.Sections.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(courses.Sections.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(courses.Sections.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.Sections.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(courses.Sections.type) ", "width": Lino.chars2width(31) } ];
    Lino.courses.Sections.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.Sections.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Sections", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Sections", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Sections", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/Sections", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.Sections.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.Sections.GridPanel(p);
});

// js_render_GridPanel_class cal.TaskStates
Lino.cal.TaskStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/TaskStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/TaskStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Task states",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7349 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7350 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7351 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7352 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7353 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text7354 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.TaskStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.TaskStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.TaskStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(cal.TaskStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.cal.TaskStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.TaskStates.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TaskStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TaskStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TaskStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/TaskStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.TaskStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.TaskStates.GridPanel(p);
});

// js_render_GridPanel_class cal.Weekdays
Lino.cal.Weekdays.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/Weekdays",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Weekdays','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Weekdays",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7362 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7363 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7364 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7365 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7366 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.Weekdays.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.Weekdays.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.Weekdays.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(cal.Weekdays.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(cal.Weekdays.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Weekdays.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Weekdays.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Weekdays", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Weekdays", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Weekdays", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Weekdays", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Weekdays.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Weekdays.GridPanel(p);
});

// js_render_GridPanel_class beid.BeIdCardTypes
Lino.beid.BeIdCardTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/beid/BeIdCardTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/beid/BeIdCardTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "eID card types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7381 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7382 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7383 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7384 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7385 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(beid.BeIdCardTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(beid.BeIdCardTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(beid.BeIdCardTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(beid.BeIdCardTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(beid.BeIdCardTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.beid.BeIdCardTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.beid.BeIdCardTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/BeIdCardTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/BeIdCardTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/BeIdCardTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/BeIdCardTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.BeIdCardTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.beid.BeIdCardTypes.GridPanel(p);
});

// js_render_GridPanel_class excerpts.Shortcuts
Lino.excerpts.Shortcuts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/excerpts/Shortcuts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/excerpts/Shortcuts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Excerpt shortcuts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7387 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7388 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7389 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7390 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7391 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(excerpts.Shortcuts.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(excerpts.Shortcuts.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(excerpts.Shortcuts.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(excerpts.Shortcuts.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(excerpts.Shortcuts.type) ", "width": Lino.chars2width(31) } ];
    Lino.excerpts.Shortcuts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.excerpts.Shortcuts.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Shortcuts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Shortcuts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Shortcuts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/excerpts/Shortcuts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.excerpts.Shortcuts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.excerpts.Shortcuts.GridPanel(p);
});

// js_render_GridPanel_class system.PeriodEvents
Lino.system.PeriodEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/system/PeriodEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/PeriodEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Observed events",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7393 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7394 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7395 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7396 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7397 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(system.PeriodEvents.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(system.PeriodEvents.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(system.PeriodEvents.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(system.PeriodEvents.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(system.PeriodEvents.type) ", "width": Lino.chars2width(31) } ];
    Lino.system.PeriodEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.PeriodEvents.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/PeriodEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/PeriodEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/PeriodEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/PeriodEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.PeriodEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.system.PeriodEvents.GridPanel(p);
});

// js_render_GridPanel_class notify.MessageTypes
Lino.notify.MessageTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/notify/MessageTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/notify/MessageTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Message Types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7399 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7400 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7401 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7402 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7403 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(notify.MessageTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(notify.MessageTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(notify.MessageTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(notify.MessageTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(notify.MessageTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.notify.MessageTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.notify.MessageTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MessageTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MessageTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MessageTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/notify/MessageTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.notify.MessageTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.notify.MessageTypes.GridPanel(p);
});

// js_render_GridPanel_class beid.ResidenceTypes
Lino.beid.ResidenceTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/beid/ResidenceTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/beid/ResidenceTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Residence types",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7405 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7406 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7407 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7408 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7409 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(beid.ResidenceTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(beid.ResidenceTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(beid.ResidenceTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(beid.ResidenceTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(beid.ResidenceTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.beid.ResidenceTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.beid.ResidenceTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/ResidenceTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/ResidenceTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/ResidenceTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/beid/ResidenceTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.beid.ResidenceTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.beid.ResidenceTypes.GridPanel(p);
});

// js_render_GridPanel_class accounts.AccountTypes
Lino.accounts.AccountTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/accounts/AccountTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/accounts/AccountTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "AccountTypes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "dc", "type": "boolean" }, { "name": "sheet" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7411 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7412 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7413 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var dc_disp7414 = new Ext.form.DisplayField({ "disabled": true });
    var sheet7415 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(accounts.AccountTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(accounts.AccountTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(accounts.AccountTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "dc", "editable": false, "header": "D/C", "sortable": false, "tooltip": "(accounts.AccountTypes.dc) Debit (checked) or Credit (not checked)", "width": Lino.chars2width(21) }, { "colIndex": 4, "dataIndex": "sheet", "editable": false, "header": "Sheet", "sortable": false, "tooltip": "(accounts.AccountTypes.sheet) ", "width": Lino.chars2width(22) } ];
    Lino.accounts.AccountTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.accounts.AccountTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/accounts/AccountTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.accounts.AccountTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.accounts.AccountTypes.GridPanel(p);
});

// js_render_GridPanel_class cal.Recurrencies
Lino.cal.Recurrencies.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/Recurrencies",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/Recurrencies','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Recurrencies",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7417 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7418 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7419 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7420 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7421 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.Recurrencies.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.Recurrencies.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.Recurrencies.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(cal.Recurrencies.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(cal.Recurrencies.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.Recurrencies.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.Recurrencies.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Recurrencies", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Recurrencies", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Recurrencies", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/Recurrencies", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.Recurrencies.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.Recurrencies.GridPanel(p);
});

// js_render_GridPanel_class system.Genders
Lino.system.Genders.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/system/Genders",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/Genders','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/Genders','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/system/Genders','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/Genders','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/Genders','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Genders",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7423 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7424 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7425 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7426 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7427 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(system.Genders.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(system.Genders.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(system.Genders.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(system.Genders.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(system.Genders.type) ", "width": Lino.chars2width(31) } ];
    Lino.system.Genders.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.Genders.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/Genders", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/Genders", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/Genders", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/Genders", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.Genders.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.system.Genders.GridPanel(p);
});

// js_render_GridPanel_class uploads.Shortcuts
Lino.uploads.Shortcuts.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/uploads/Shortcuts",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/uploads/Shortcuts','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Upload shortcuts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7429 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7430 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7431 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7432 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7433 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(uploads.Shortcuts.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(uploads.Shortcuts.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(uploads.Shortcuts.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(uploads.Shortcuts.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(uploads.Shortcuts.type) ", "width": Lino.chars2width(31) } ];
    Lino.uploads.Shortcuts.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.uploads.Shortcuts.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Shortcuts", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Shortcuts", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Shortcuts", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/uploads/Shortcuts", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.uploads.Shortcuts.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.uploads.Shortcuts.GridPanel(p);
});

// js_render_GridPanel_class ledger.VoucherStates
Lino.ledger.VoucherStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/VoucherStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/VoucherStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "States",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7444 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7445 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7446 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7447 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7448 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text7449 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(ledger.VoucherStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.VoucherStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(ledger.VoucherStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(ledger.VoucherStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.ledger.VoucherStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.VoucherStates.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/VoucherStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/VoucherStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/VoucherStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/VoucherStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.VoucherStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.VoucherStates.GridPanel(p);
});

// js_render_GridPanel_class ledger.PeriodStates
Lino.ledger.PeriodStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/ledger/PeriodStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/ledger/PeriodStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "States",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7451 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7452 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7453 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7454 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7455 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text7456 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(ledger.PeriodStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(ledger.PeriodStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(ledger.PeriodStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.type) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(ledger.PeriodStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.ledger.PeriodStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.ledger.PeriodStates.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PeriodStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PeriodStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PeriodStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/ledger/PeriodStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.ledger.PeriodStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.ledger.PeriodStates.GridPanel(p);
});

// js_render_GridPanel_class cal.EventEvents
Lino.cal.EventEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/EventEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EventEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Observed events",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7458 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7459 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7460 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7461 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7462 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.EventEvents.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.EventEvents.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.EventEvents.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(cal.EventEvents.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(cal.EventEvents.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.EventEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EventEvents.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EventEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EventEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EventEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EventEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EventEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EventEvents.GridPanel(p);
});

// js_render_GridPanel_class cal.GuestStates
Lino.cal.GuestStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/GuestStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/GuestStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Guest states",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "afterwards", "type": "boolean" }, { "name": "text" }, { "name": "button_text" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7464 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7465 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var afterwards_disp7466 = new Ext.form.DisplayField({ "disabled": true });
    var text7467 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var button_text7468 = new Ext.form.TextField({ "disabled": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.GuestStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.GuestStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "afterwards", "editable": false, "header": "Afterwards", "sortable": false, "tooltip": "(cal.GuestStates.afterwards) ", "width": Lino.chars2width(21) }, { "colIndex": 3, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.GuestStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 4, "dataIndex": "button_text", "editable": false, "header": "Symbol", "sortable": false, "tooltip": "(cal.GuestStates.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.cal.GuestStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.GuestStates.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/GuestStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.GuestStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.GuestStates.GridPanel(p);
});

// js_render_GridPanel_class products.DeliveryUnit
Lino.products.DeliveryUnit.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/products/DeliveryUnit",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/products/DeliveryUnit','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Delivery units",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 7,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "button_text" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7470 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7471 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7472 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7473 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7474 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var button_text7475 = new Ext.form.TextField({ "disabled": true, "hidden": true, "maxLength": null });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(products.DeliveryUnit.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(products.DeliveryUnit.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(products.DeliveryUnit.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.type) ", "width": Lino.chars2width(31) }, { "colIndex": 5, "dataIndex": "button_text", "editable": false, "header": "Symbol", "hidden": true, "sortable": false, "tooltip": "(products.DeliveryUnit.button_text) ", "width": Lino.chars2width(5) } ];
    Lino.products.DeliveryUnit.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.products.DeliveryUnit.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/DeliveryUnit", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/DeliveryUnit", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/DeliveryUnit", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/products/DeliveryUnit", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.products.DeliveryUnit.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.products.DeliveryUnit.GridPanel(p);
});

// js_render_GridPanel_class printing.BuildMethods
Lino.printing.BuildMethods.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/printing/BuildMethods",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/printing/BuildMethods','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "BuildMethods",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7489 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7490 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7491 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7492 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7493 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(printing.BuildMethods.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(printing.BuildMethods.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(printing.BuildMethods.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(printing.BuildMethods.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(printing.BuildMethods.type) ", "width": Lino.chars2width(31) } ];
    Lino.printing.BuildMethods.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.printing.BuildMethods.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/printing/BuildMethods", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/printing/BuildMethods", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/printing/BuildMethods", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/printing/BuildMethods", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.printing.BuildMethods.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.printing.BuildMethods.GridPanel(p);
});

// js_render_GridPanel_class cal.EntryStates
Lino.cal.EntryStates.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/EntryStates",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/EntryStates','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Event states",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 9,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "button_text" }, { "name": "edit_guests", "type": "boolean" }, { "name": "fixed", "type": "boolean" }, { "name": "transparent", "type": "boolean" }, { "name": "noauto", "type": "boolean" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7495 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7496 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7497 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var button_text7498 = new Ext.form.TextField({ "disabled": true, "maxLength": null });
    var edit_guests_disp7499 = new Ext.form.DisplayField({ "disabled": true });
    var fixed_disp7500 = new Ext.form.DisplayField({ "disabled": true });
    var transparent_disp7501 = new Ext.form.DisplayField({ "disabled": true });
    var noauto_disp7502 = new Ext.form.DisplayField({ "disabled": true });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.EntryStates.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.EntryStates.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.EntryStates.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "button_text", "editable": false, "header": "Symbol", "sortable": false, "tooltip": "(cal.EntryStates.button_text) ", "width": Lino.chars2width(5) }, { "colIndex": 4, "dataIndex": "edit_guests", "editable": false, "header": "Edit participants", "sortable": false, "tooltip": "(cal.EntryStates.edit_guests) ", "width": Lino.chars2width(21) }, { "colIndex": 5, "dataIndex": "fixed", "editable": false, "header": "Stable", "sortable": false, "tooltip": "(cal.EntryStates.fixed) ", "width": Lino.chars2width(21) }, { "colIndex": 6, "dataIndex": "transparent", "editable": false, "header": "Transparent", "sortable": false, "tooltip": "(cal.EntryStates.transparent) ", "width": Lino.chars2width(21) }, { "colIndex": 7, "dataIndex": "noauto", "editable": false, "header": "No auto", "sortable": false, "tooltip": "(cal.EntryStates.noauto) ", "width": Lino.chars2width(21) } ];
    Lino.cal.EntryStates.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.EntryStates.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntryStates", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntryStates", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntryStates", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/EntryStates", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.EntryStates.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.EntryStates.GridPanel(p);
});

// js_render_GridPanel_class outbox.RecipientTypes
Lino.outbox.RecipientTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/outbox/RecipientTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/outbox/RecipientTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "RecipientTypes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7510 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7511 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7512 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7513 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7514 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(outbox.RecipientTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(outbox.RecipientTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(outbox.RecipientTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(outbox.RecipientTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.outbox.RecipientTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.outbox.RecipientTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/outbox/RecipientTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.outbox.RecipientTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.outbox.RecipientTypes.GridPanel(p);
});

// js_render_GridPanel_class cal.AccessClasses
Lino.cal.AccessClasses.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/cal/AccessClasses",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/cal/AccessClasses','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "AccessClasses",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7516 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7517 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7518 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7519 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7520 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(cal.AccessClasses.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(cal.AccessClasses.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(cal.AccessClasses.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(cal.AccessClasses.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(cal.AccessClasses.type) ", "width": Lino.chars2width(31) } ];
    Lino.cal.AccessClasses.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.cal.AccessClasses.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AccessClasses", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AccessClasses", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AccessClasses", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/cal/AccessClasses", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.cal.AccessClasses.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.cal.AccessClasses.GridPanel(p);
});

// js_render_GridPanel_class system.YesNo
Lino.system.YesNo.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/system/YesNo",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/system/YesNo','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Yes or no",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7522 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7523 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7524 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7525 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7526 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(system.YesNo.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(system.YesNo.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(system.YesNo.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(system.YesNo.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(system.YesNo.type) ", "width": Lino.chars2width(31) } ];
    Lino.system.YesNo.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.system.YesNo.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/YesNo", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/YesNo", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/YesNo", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/system/YesNo", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.system.YesNo.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.system.YesNo.GridPanel(p);
});

// js_render_GridPanel_class courses.CourseAreas
Lino.courses.CourseAreas.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/courses/CourseAreas",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/courses/CourseAreas','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Course layouts",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7528 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7529 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7530 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7531 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7532 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(courses.CourseAreas.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(courses.CourseAreas.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(courses.CourseAreas.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(courses.CourseAreas.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(courses.CourseAreas.type) ", "width": Lino.chars2width(31) } ];
    Lino.courses.CourseAreas.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.courses.CourseAreas.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseAreas", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseAreas", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseAreas", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/courses/CourseAreas", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.courses.CourseAreas.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.courses.CourseAreas.GridPanel(p);
});

// js_render_GridPanel_class contacts.PartnerEvents
Lino.contacts.PartnerEvents.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/contacts/PartnerEvents",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/contacts/PartnerEvents','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "Observed events",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7539 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7540 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7541 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7542 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7543 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(contacts.PartnerEvents.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(contacts.PartnerEvents.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(contacts.PartnerEvents.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnerEvents.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(contacts.PartnerEvents.type) ", "width": Lino.chars2width(31) } ];
    Lino.contacts.PartnerEvents.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.contacts.PartnerEvents.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnerEvents", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnerEvents", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnerEvents", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/contacts/PartnerEvents", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.contacts.PartnerEvents.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.contacts.PartnerEvents.GridPanel(p);
});

// js_render_GridPanel_class countries.PlaceTypes
Lino.countries.PlaceTypes.GridPanel = Ext.extend(Lino.GridPanel,{
  viewConfig : { "emptyText": "No data to display.", "forceFit": true },
  ls_url : "/countries/PlaceTypes",
  ls_bbar_actions : [ { "auto_save": true, "iconCls": "x-tbar-html", "itemId": "show_as_html", "menu_item_text": "HTML", "overflowText": "HTML", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','show_as_html','GET',Lino.get_current_grid_config), "tooltip": "Show this table in Bootstrap3 interface" }, { "iconCls": "x-tbar-page_white_acrobat", "menu": [ { "auto_save": true, "itemId": "as_pdf", "menu_item_text": "Table (landscape)", "overflowText": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": "Table (landscape)", "tooltip": "Show this table as a pdf document" }, { "auto_save": true, "itemId": "as_pdf_p", "menu_item_text": "Table (portrait)", "overflowText": "Table (portrait)", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','as_pdf_p','GET',Lino.get_current_grid_config), "text": "Table (portrait)", "tooltip": "Show this table as a pdf document" } ], "menu_item_text": "Table (landscape)", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','as_pdf','GET',Lino.get_current_grid_config), "text": null, "xtype": "splitbutton" }, { "auto_save": true, "iconCls": "x-tbar-page_excel", "itemId": "export_excel", "menu_item_text": "Export to .xls", "overflowText": "Export to .xls", "panel_btn_handler": Lino.list_action_handler('/countries/PlaceTypes','export_excel','GET',Lino.get_current_grid_config), "tooltip": "Export this table as an .xls document" } ],
  cell_edit : true,
  title : "PlaceTypes",
  page_length : 20,
  params_panel_hidden : true,
  stripeRows : true,
  disable_editing : true,
  disabled_actions_index : 6,
  ls_store_fields : [ { "name": "value" }, { "name": "name" }, { "name": "text" }, { "name": "remark" }, { "name": "type" }, { "name": "None" }, { "name": "disabled_actions" } ],
  pk_index : 0,
  ls_grid_configs : [  ],
  ls_id_property : null,
  gc_name : 0,
  initComponent : function() {
    var ww = this.containing_window;
    var value7553 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var name7554 = new Ext.form.TextField({ "disabled": true, "maxLength": 20 });
    var text7555 = new Ext.form.TextField({ "disabled": true, "maxLength": 50 });
    var remark_disp7556 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    var type_disp7557 = new Ext.form.DisplayField({ "always_enabled": true, "disabled": true, "hidden": true, "value": "<br/>" });
    this.before_row_edit = function(record) {
    };
    this.ls_columns = [ { "colIndex": 0, "dataIndex": "value", "editable": false, "header": "value", "sortable": false, "tooltip": "(countries.PlaceTypes.value) ", "width": Lino.chars2width(22) }, { "colIndex": 1, "dataIndex": "name", "editable": false, "header": "name", "sortable": false, "tooltip": "(countries.PlaceTypes.name) ", "width": Lino.chars2width(22) }, { "colIndex": 2, "dataIndex": "text", "editable": false, "header": "text", "sortable": false, "tooltip": "(countries.PlaceTypes.text) ", "width": Lino.chars2width(22) }, { "colIndex": 3, "dataIndex": "remark", "editable": false, "header": "Remark", "hidden": true, "sortable": false, "tooltip": "(countries.PlaceTypes.remark) ", "width": Lino.chars2width(31) }, { "colIndex": 4, "dataIndex": "type", "editable": false, "header": "Type", "hidden": true, "sortable": false, "tooltip": "(countries.PlaceTypes.type) ", "width": Lino.chars2width(31) } ];
    Lino.countries.PlaceTypes.GridPanel.superclass.initComponent.call(this);
  }
});

Lino.countries.PlaceTypes.show_as_html = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlaceTypes", "GET", pk, "show_as_html", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.as_pdf = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlaceTypes", "GET", pk, "as_pdf", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.as_pdf_p = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlaceTypes", "GET", pk, "as_pdf_p", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.export_excel = function(rp, pk, params) { 
  var h = function() { 
    Lino.run_row_action(rp, "/countries/PlaceTypes", "GET", pk, "export_excel", params, Lino.get_current_grid_config);
  };
  var panel = Ext.getCmp(rp);
  if(panel) panel.do_when_clean(true, h); else h();
};
Lino.countries.PlaceTypes.grid = new Lino.WindowAction({  }, function(){
  var p = { "is_main_window": true };
  return new Lino.countries.PlaceTypes.GridPanel(p);
});
